#Include-Once

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Login
Func login($compte, $connexion, $pleinEcran = 0, $tray = "")
	If Not FileExists($connexion) Then
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_login_msg_moduleinconnu"), 30, 3)
	ElseIf StringRegExp($connexion,"au3$") And @Compiled Then
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_login_msg_moduleinutilisable"), 30, 3)
	Else
		Local $ligne = cond(StringRegExp($connexion,"au3$"),'"'&@AutoItExe&'" ',"") & '"'&$connexion&'"' & " -connect"
		$ligne = $ligne & " " & _StringToHex(convertCompteToLigne($compte))
		$ligne = $ligne & cond($pleinEcran <> "1" And $pleinEcran <> "2", "", " -d "&$pleinEcran) & " -f"
		Local $dossier = StringLeft($connexion,StringInStr($connexion,"\",0,-1)-1)
		RunWait($ligne,$dossier)
	EndIf
EndFunc
#EndRegion

#Region Multi-Co
Func multico($multi, $liste, $connexion, $pleinEcran = 0, $tray = "")
	If Not FileExists($connexion) Then
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_multico_msg_moduleinconnu"), 30, 3)
	ElseIf StringRegExp($connexion,"au3$") And @Compiled Then
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_multico_msg_moduleinutilisable"), 30, 3)
	ElseIf Not isMulti($multi) Then
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_multico_msg_multinonconforme1"), 30, 3)
	ElseIf getMultiListingSize($multi) = 0 Then
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_multico_msg_multinonconforme2"), 30, 3)
	Else
		Local $ligne = cond(StringRegExp($connexion,"au3$"),'"'&@AutoItExe&'" ',"") & '"'&$connexion&'"' & " -connect"
		For $i = 1 To getMultiListingSize($multi)
			Local $index = getCompteIndexInMultiListingAt($multi,$i)
			Local $compte = getCompteInListFromIndex($liste,$index)
			If isCompte($compte) Then $ligne = $ligne & " " & _StringToHex(convertCompteToLigne($compte))
		Next
		$ligne = $ligne & cond($pleinEcran <> "1" And $pleinEcran <> "2", "", " -d "&$pleinEcran) & " -f"
		Local $dossier = StringLeft($connexion,StringInStr($connexion,"\",0,-1)-1)
		RunWait($ligne,$dossier)
	EndIf
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Capture
Func snapshot($format="BMP", $crop="INTERNAL", $mode="GLOBAL", $parent="", $tray="")
	If $crop = "MANUAL" Then
		snapshotManual($format, $parent, $tray)
	Else
		snapshotAuto($format, $crop, $mode, $tray)
	EndIf
EndFunc
Func snapshotAuto($format="BMP", $crop="INTERNAL", $mode="GLOBAL", $tray="")
	; TODO : Traitement du mode "UNIQUE"
	Local $winList = WinList("[CLASS:"&$nAiO_fenetres_CLASS&"]"), $soustotal=0, $handle=0, $resultat=0
	If $crop = "DESKTOP" Then
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_encours"),20,2)
		Sleep(1500)
		TrayAdvancedDisplayMessage($tray)
		$resultat = snapshotUnitaire("",$handle,$format,$crop)
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_effectue"),20,cond($resultat,1,3))
	ElseIf $winList[0][0] > 0 Then
		If $mode = "UNIQUE" Then
			$handle=$winList[1][1]
			TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_encours"),20,2)
			Sleep(1000)
			TrayAdvancedDisplayMessage($tray)
			If WinActivate($handle) <> 0 Then
				Local $windowTitle = WinGetTitle($handle)
				$resultat = snapshotUnitaire($windowTitle,$handle,$format,$crop)
			EndIf
			TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_effectue"),20,cond($resultat=1,1,3))
		Else
			For $i = 1 To $winList[0][0]
				$handle=$winList[$i][1]
				TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_encours_pluriel")&" : " &$i&"/"&$winList[0][0],20,2)
				Sleep(1000)
				TrayAdvancedDisplayMessage($tray)
				If WinActivate($handle) <> 0 Then
					Local $windowTitle = WinGetTitle($handle)
					$soustotal = $soustotal + snapshotUnitaire($windowTitle,$handle,$format,$crop)
				EndIf
			Next
			TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_effectue_pluriel")&" : " &$soustotal&"/"&$winList[0][0],20,cond($soustotal=$winList[0][0],1,3))
		EndIf
	Else
		TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_msg_aucunefenetre"),20,2)
	EndIf
EndFunc
Func snapshotUnitaire($windowTitle="",$handle=0,$format="BMP",$crop="INTERNAL")
	Local $index, $found=False, $snapshotFullTitle=""
	For $index=0 To 999
		$snapshotFullTitle = $nAiO_repertoire_captures&cond($crop="DESKTOP","Capture",$windowTitle&"\"&$windowTitle)&"_"&StringFormat("%03s",$index)
		If Not FileExists($snapshotFullTitle&".*") Then
			$found = True
			Local $snapshotFullDir   = StringLeft($snapshotFullTitle,StringInStr($snapshotFullTitle,"\",2,-1)-1)
			If Not FileExists($snapshotFullDir&"\") Then
				DirCreate($snapshotFullDir)
			EndIf
			ExitLoop
		EndIf
	Next
	If Not $found Then Return 0
	Local $cadre = getDesktopTotalResolution()
	If $crop = "WINDOW" Then
		$cadre = WinGetPos($handle)
	ElseIf $crop = "INTERNAL" Or $crop = "CAROTTE" Then
		$cadre = getWindowClientCoords($handle)
		Local $cadreX = $cadre[2], $cadreY = $cadre[3]
		If $cadreX*$cadreY = 0 Then Return 0
		If $cadreY/$cadreX > 0.8 Then
			$cadre[1] = $cadre[1]+($cadreY-$cadre[3])/2
			$cadre[3] = $cadreX*0.8
		ElseIf $cadreY/$cadreX < 0.8 Then
			$cadre[0] = $cadre[0]+($cadreX-$cadre[2])/2
			$cadre[2] = $cadreY/0.8
		EndIf
		If $crop = "CAROTTE" Then $cadre[3] = Ceiling($cadre[3]*0.84)
	EndIf
	If @error Then Return 0
	_ScreenCapture_Capture($snapshotFullTitle&"."&cond($format="JPG","jpg","bmp"), $cadre[0],$cadre[1],$cadre[0]+$cadre[2],$cadre[1]+$cadre[3], False)
	If $format = "PNG" Then Return snapshotConvertBmpToPng($snapshotFullTitle)
	Return 1
EndFunc
Func snapshotConvertBmpToPng($fichier)
	If Not FileExists($fichier&".bmp") Then Return 0
	FileCopy($fichier&".bmp",@TempDir)
	Local $fichierTemp = @TempDir&"\"&StringTrimLeft($fichier,StringInStr($fichier,"\",0,-1))
	If Not FileExists($fichierTemp&".bmp") Then Return 0
	_GDIPlus_Startup()
	Local $params, _
		$image = _GDIPlus_ImageLoadFromFile($fichierTemp&".bmp"), _
		$CLSID = _GDIPlus_EncodersGetCLSID("PNG")
	_GDIPlus_ImageSaveToFileEx($image, $fichier&".png", $CLSID, DllStructGetPtr($params))
	_GDIPlus_ShutDown()
	FileDelete($fichier&".bmp")
	Return cond(@error,0,1)
EndFunc
Func getDesktopTotalResolution()
	Local $resultat[4] = [0,0,0,0], $i = 0
	While 1
		Local $struct = DllStructCreate("dword cb;char DeviceName[32];char DeviceString[128];dword StateFlags;char DeviceID[128];char DeviceKey[128]")
		DllStructSetData($struct, "cb", DllStructGetSize($struct))
		Local $retour = DllCall("user32.dll", "int", "EnumDisplayDevices", "ptr", 0, "dword", $i, "ptr", DllStructGetPtr($struct), "dword", 0)
		If Not $retour[0] Then
			ExitLoop
		ElseIf Not BitAND(DllStructGetData($struct, "StateFlags"), 0x00000008) Then
			Local $dev = DllStructCreate("char dmDeviceName[32];ushort dmSpecVersion;ushort dmDriverVersion;short dmSize;" & _
				"ushort dmDriverExtra;dword dmFields;long x;long y;dword dmDisplayOrientation;dword dmDisplayFixedOutput;" & _
				"short dmColor;short dmDuplex;short dmYResolution;short dmTTOption;short dmCollate;" & _
				"byte dmFormName[32];ushort LogPixels;dword dmBitsPerPel;int dmPelsWidth;dword dmPelsHeight;" & _
				"dword dmDisplayFlags;dword dmDisplayFrequency")
			DllStructSetData($dev, "dmSize", DllStructGetSize($dev))
			$retour = DllCall("user32.dll", "int", "EnumDisplaySettings", "str", DllStructGetData($struct, "DeviceName"), "dword", -1, "ptr", DllStructGetPtr($dev))
			Local _
				$x0 = DllStructGetData($dev, "x"), _
				$y0 = DllStructGetData($dev, "y")
			Local _
				$x1 = $x0 + DllStructGetData($dev, "dmPelsWidth"), _
				$y1 = $y0 + DllStructGetData($dev, "dmPelsHeight")
			If $resultat[0] > $x0 Then $resultat[0] = $x0
			If $resultat[1] > $y0 Then $resultat[1] = $y0
			If $resultat[2] < $x1 Then $resultat[2] = $x1
			If $resultat[3] < $y1 Then $resultat[3] = $y1
		EndIf
		$i += 1
	WEnd
	$resultat[2] = $resultat[2]-$resultat[0]
	$resultat[3] = $resultat[3]-$resultat[1]
	Return $resultat
EndFunc
Func snapshotManual($format = "BMP", $GUI_Parent = "", $tray = "")
	; Choix du nom du fichier
	Local $index, $found=False, $snapshotFullTitle=""
	For $index=0 To 999
		$snapshotFullTitle = $nAiO_repertoire_captures&"Capture"&"_"&StringFormat("%03s",$index)
		If Not FileExists($snapshotFullTitle&".*") Then
			$found = True
			Local $snapshotFullDir   = StringLeft($snapshotFullTitle,StringInStr($snapshotFullTitle,"\",2,-1)-1)
			If Not FileExists($snapshotFullDir&"\") Then
				DirCreate($snapshotFullDir)
			EndIf
			ExitLoop
		EndIf
	Next
	If Not $found Then Return 0
	; Choix de la fentre de snapshot
	Local $GUIs[6] = [5], $Images[6] = [5, "Snapshot\CornerUL.png", "Snapshot\CornerUR.png", "Snapshot\CornerDL.png", "Snapshot\CornerDR.png", "Snapshot\Center.png"]
	_GDIPlus_Startup()
	For $i = 1 To $GUIs[0]
		If $GUI_Parent <> "" Then
			$GUIs[$i] = GUICreate($Images[$i], 25, 25, -1, -1, $WS_POPUP, $WS_EX_LAYERED + $WS_EX_TOPMOST, $GUI_Parent)
		Else
			$GUIs[$i] = GUICreate($Images[$i], 25, 25, -1, -1, $WS_POPUP, $WS_EX_LAYERED + $WS_EX_TOPMOST)
		EndIf
		$Images[$i] = _GDIPlus_ImageLoadFromFile($nAiO_repertoire_images & "\" & $Images[$i])
		SetBitmap($GUIs[$i], $Images[$i], 80)
		GUISetState()
	Next
	; Interception des messages
	interceptAllMsg()
	; Prparation tray
	TrayAdvancedDisplayMessage($tray, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_snapshot_manuel_info"),30)
	Local $fleches[4] = ["{LEFT}", "{RIGHT}", "{UP}", "{DOWN}"]
	For $i = 0 To 3
		HotKeySet("+"&$fleches[$i], "snapshotZoom")
		HotKeySet($fleches[$i], "snapshotZoom")
		HotKeySet("^"&$fleches[$i], "snapshotZoom")
	Next
	Local $ready = False, $ok = False, $trans_previous = 0, $posStr_previous=""
	Do
		Local $msg = GUIGetMsg(), $pos = MouseGetPos()
		Local $posStr = $pos[0]&";"&$pos[1]&";"&$snapshotCadre[0]&";"&$snapshotCadre[1]
		Local $trans = Abs(@MSEC/2 - 250)
		If Not $ready And $trans_previous <> $trans Then
			$trans_previous = $trans
			For $i = 1 To $GUIs[0]
				If $trans > 20 Then SetBitmap($GUIs[$i], $Images[$i], $trans)
			Next
		EndIf
		If $ready Then
			If $msg = $GUI_EVENT_PRIMARYUP Or $msg = $GUI_EVENT_SECONDARYDOWN Then
				$ready = False
				For $i = 1 To $GUIs[0]
					SetBitmap($GUIs[$i], $Images[$i], 80)
				Next
				If $msg = $GUI_EVENT_PRIMARYUP Then $ok = True
			EndIf
		ElseIf $msg = $GUI_EVENT_PRIMARYDOWN Then
			$ready = True
		ElseIf $posStr <> $posStr_previous Then
			$posStr = $posStr_previous
			WinMove($GUIs[1], "", $pos[0] - $snapshotCadre[0],          $pos[1] - $snapshotCadre[1])
			WinMove($GUIs[2], "", $pos[0] + $snapshotCadre[0] - 25 + 1, $pos[1] - $snapshotCadre[1])
			WinMove($GUIs[3], "", $pos[0] - $snapshotCadre[0],          $pos[1] + $snapshotCadre[1] - 25 + 1)
			WinMove($GUIs[4], "", $pos[0] + $snapshotCadre[0] - 25 + 1, $pos[1] + $snapshotCadre[1] - 25 + 1)
			WinMove($GUIs[5], "", $pos[0] - 12,                         $pos[1] - 12)
			_MouseTrap($snapshotCadre[0], $snapshotCadre[1], @DesktopWidth-$snapshotCadre[0]+1, @DesktopHeight-$snapshotCadre[1]+1)
		EndIf
	Until $msg = $GUI_EVENT_CLOSE Or $ok
	TrayAdvancedDisplayMessage($tray)
	For $i = 0 To 3
		HotKeySet("+"&$fleches[$i])
		HotKeySet($fleches[$i])
		HotKeySet("^"&$fleches[$i])
	Next
	For $i = 1 To $Images[0]
		_GDIPlus_ImageDispose($Images[$i])
		GUIDelete($GUIs[$i])
	Next
	_GDIPlus_Shutdown()
	If Not $ok Then Return 0
	Local $cadre[4] = [ _
		$pos[0] - $snapshotCadre[0], _
		$pos[1] - $snapshotCadre[1], _
		$pos[0] + $snapshotCadre[0], _
		$pos[1] + $snapshotCadre[1]  _
	]
	; Capture d'cran
	_ScreenCapture_Capture($snapshotFullTitle&"."&cond($format="JPG","jpg","bmp"), $cadre[0],$cadre[1],$cadre[2],$cadre[3], False)
	; Enregistrement
	If $format = "PNG" Then Return snapshotConvertBmpToPng($snapshotFullTitle)
	Return 1
EndFunc
Func snapshotZoom()
	Local $key = @HotKeyPressed, $step = 5
	If StringLeft($key,1) = "+" Then
		$step = 1
	ElseIf StringLeft($key,1) = "^" Then
		$step = 50
	ElseIf StringLeft($key,1) = "{" Then
		$key = " "&$key
	EndIf
	$key = StringTrimLeft($key,1)
	Local _
		$x = cond($key="{RIGHT}", $step, cond($key="{LEFT}", -$step, 0)), _
		$y = cond($key="{UP}",    $step, cond($key="{DOWN}", -$step, 0))
	Local $new[2] = [$snapshotCadre[0]+$x, $snapshotCadre[1]+$y]
	Local $mouse = MouseGetPos()
	If $new[0] < 0 Then $new[0] = 0
	If $new[1] < 0 Then $new[1] = 0
	If $new[0] > @DesktopWidth/2  Then $new[0] = @DesktopWidth/2
	If $new[1] > @DesktopHeight/2 Then $new[1] = @DesktopHeight/2
	$snapshotCadre = $new
EndFunc
Func SetBitmap($GUI, $image, $trans)
	Local $hScrDC, $hMemDC, $hBitmap, $hOld, $pSize, $tSize, $pSource, $tSource, $pBlend, $tBlend
	$hScrDC = _WinAPI_GetDC(0)
	$hMemDC = _WinAPI_CreateCompatibleDC($hScrDC)
	$hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($image)
	$hOld = _WinAPI_SelectObject($hMemDC, $hBitmap)
	$tSize = DllStructCreate($tagSIZE)
	$pSize = DllStructGetPtr($tSize)
	DllStructSetData($tSize, "X", _GDIPlus_ImageGetWidth($image))
	DllStructSetData($tSize, "Y", _GDIPlus_ImageGetHeight($image))
	$tSource = DllStructCreate($tagPOINT)
	$pSource = DllStructGetPtr($tSource)
	$tBlend = DllStructCreate($tagBLENDFUNCTION)
	$pBlend = DllStructGetPtr($tBlend)
	DllStructSetData($tBlend, "Alpha", $trans)
	DllStructSetData($tBlend, "Format", 1)
	_WinAPI_UpdateLayeredWindow($GUI, $hScrDC, 0, $pSize, $hMemDC, $pSource, 0, $pBlend, $ULW_ALPHA)
	_WinAPI_ReleaseDC(0, $hScrDC)
	_WinAPI_SelectObject($hMemDC, $hOld)
	_WinAPI_DeleteObject($hBitmap)
	_WinAPI_DeleteDC($hMemDC)
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Modules
Func moduleExecuter($module)
	Local $commande = cond(isModuleCompiled($module), '"'&getModuleChemin($module)&'"', '"'&@AutoItExe&'" "'&getModuleChemin($module)&'"')
	If @Compiled And Not isModuleCompiled($module) Then
		SetError(2)
	Else
		Local $resultat = Run($commande, $nAiO_repertoire_modules)
		If @error Then SetError(1)
	EndIf
EndFunc
#EndRegion

#Region Lien
Func lienExecuter($lien)
	Local $path = getLienChemin($lien)
	Local $folder = StringLeft($path,StringInStr($path,"\",0,-1)-1)
	If isLienTypeDossier($lien) Then
		ShellExecute("explorer.exe",'"'&$path&'"')
	ElseIf isLienTypeFichier($lien) Then
		ShellExecute($path, "", $folder)
	ElseIf isLienTypeProgramme($lien) Then
		Run($path, $folder)
	ElseIf Not FileExists($path) Then
		Return 1
	Else
		Return 2
	EndIf
	Return 0
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Action
Func launchAction($action, $ressources)
	If isActionDefined($action) Then
		Switch Int(getActionType($action))
		Case 1 ; Application
			Local $application = getActionParameter($action)
			If FileExists($application) Then
				Local $retour = MsgBox(0,$nAiO_title&" v"&$nAiO_version, _
				'Le nAiO tente de lancer une application.' & @CRLF & _
				'Cliquez sur "OK" pour continuer :' & @CRLF & _
				$application)
				If $retour = 1 Then Run($application)
			EndIf
		Case 2 ; Page internet
			Local $nom = @TempDir&"\~htm.htm", $page = getActionParameter($action)
			If Not StringInStr($page,"://") Then $page = "http://"&$page
			Local $file = FileOpen($nom,10)
			FileWrite($file, _
				'Le nAiO tente de vous connecter  une page web.<br>' & _
				'Cliquez sur le lien pour continuer : <a href="'&$page&'">'&$page&'</a>')
			FileClose($file)
			ShellExecute($nom)
		Case 3 ; Module externe
			If IsArray($ressources) And $ressources[0]>=3 Then
				Local $nom = getActionParameter($action), $modules = $ressources[3]
				Local $module = getModuleInListFromNom($modules,$nom)
				If isModule($module) And isModuleEtatActif($module) Then
					moduleExecuter($module)
				EndIf
			EndIf
		Case 4 ; Fonction interne
			MsgBox(0,getInternationalisationText($nAiO_languageResources,"MAction_type4_label"),getInternationalisationText($nAiO_languageResources,"EP_action_nonimplemente_label"))
		Case 5 ; Login rapide
			If IsArray($ressources) And $ressources[0]>=4 Then
				Local $index = getActionParameter($action), $comptes = $ressources[1], $parametres = $ressources[4]
				Local $compte = getCompteInListFromIndex($comptes,$index)
				If isCompte($compte) Then
					login($compte, ""&getParametreValeurInListFromClef($parametres, "Connexion"), ""&getParametreValeurInListFromClef($parametres, "Fullscreen"))
				EndIf
			EndIf
		Case 6 ; Multi-login
			If IsArray($ressources) And $ressources[0]>=4 Then
				Local $index = getActionParameter($action), $comptes = $ressources[1], $multis = $ressources[2], $parametres = $ressources[4]
				Local $multi = getMultiInListFromIndex($multis,$index)
				If isMulti($multi) Then
					multico($multi,$comptes, ""&getParametreValeurInListFromClef($parametres, "Connexion"), ""&getParametreValeurInListFromClef($parametres, "FullscreenMulti"))
				EndIf
			EndIf
		Case Else
			MsgBox(0,getInternationalisationText($nAiO_languageResources,"MAction_typeinconnu_label"),getInternationalisationText($nAiO_languageResources,"MAction_typeinconnu_label"))
		EndSwitch
	EndIf
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Audio
Func playSound($fichier)
	If FileExists($fichier) Then SoundPlay($fichier)
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Configuration - Positionnement
Func positionner()
	_GDIPlus_Startup()
	Local $image_handle = _GDIPlus_ImageLoadFromFile($nAiO_repertoire_images & "\" & "Screenshot.png")
	Local $image_dimension[2] = [ _GDIPlus_ImageGetWidth($image_handle) , _GDIPlus_ImageGetHeight($image_handle) ]
	Local $GUI = GUICreate("Position", $image_dimension[0], $image_dimension[1], -1, -1, $WS_POPUP, $WS_EX_LAYERED + $WS_EX_TOPMOST)
	SetBitmap($GUI, $image_handle, 80)
	GUISetState()
	Local $ready = False, $ok = False, $trans_previous = -1, $pos_previous[2] = [-1,-1]
	Do
		Local $msg = GUIGetMsg(), $pos = MouseGetPos()
		Local $trans = Abs(@MSEC/2 - 250)
		If Not $ready And $trans_previous <> $trans Then
			$trans_previous = $trans
			If $trans > 20 Then SetBitmap($GUI, $image_handle, $trans)
		EndIf
		If $ready Then
			If $msg = $GUI_EVENT_PRIMARYUP Or $msg = $GUI_EVENT_SECONDARYDOWN Then
				$ready = False
				SetBitmap($GUI, $image_handle, 80)
				If $msg = $GUI_EVENT_PRIMARYUP Then $ok = True
			EndIf
		ElseIf $msg = $GUI_EVENT_PRIMARYDOWN Then
			$ready = True
		ElseIf $pos_previous[0] <> $pos[0] Or $pos_previous[1] <> $pos[1] Then
			$pos_previous = $pos
			WinMove($GUI, "", $pos[0] - $image_dimension[0] / 2, $pos[1] - $image_dimension[1] / 2)
		EndIf
	Until $msg = $GUI_EVENT_CLOSE Or $ok
	_GDIPlus_ImageDispose($image_handle)
	GUIDelete($GUI)
	_GDIPlus_Shutdown()
	If Not $ok Then Return ""
	$pos[0] = $pos[0] - $image_dimension[0] / 2
	$pos[1] = $pos[1] - $image_dimension[1] / 2
	Return $pos
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Compilation
Func compilationExecuter($type, $aut2exe, $source="", $destination="", $icone="", $compression=0)
	If Not @Compiled Then
		$ligne = '"'&$aut2exe&'"'& _
			cond(FileExists($source),' /in "'&$source&'"', ' /in "'&@ScriptFullPath&'"') & _
			cond(String($destination),' /out "'&$destination&'"','') & _
			cond(FileExists($icone),' /icon "'&$icone&'"','') & _
			cond($compression <> 0, ' /comp '&$compression,'') & _
			cond(@AutoItX64=1," /x64","")
		If FileExists($nAiO_repertoire_include&"Lancement Compilation.exe") Then
			Return RunWait('"'&$nAiO_repertoire_include&'Lancement Compilation.exe" '&$type&' '&_StringToHex($ligne))
		ElseIf FileExists($nAiO_repertoire_include&"Lancement Compilation.au3") Then
			Return RunWait(@AutoItExe&' "'&$nAiO_repertoire_include&'Lancement Compilation.au3" '&$type&' '&_StringToHex($ligne))
		EndIf
		Return 1
	Else
		Return 0
	EndIf
EndFunc
#EndRegion
