Global $displayAlertesNotification = 0
Global $displayAlertesNotification_frequence = 100
Global $displayAlertesNotification_audio = True
Global $displayAlertesNotification_activateAudio = ""
Global $displayAlertesNotification_titre = ""
Global $displayAlertesNotification_texte = ""
Global $displayAlertesNotification_position[2] = [0,0]

#Region Gestion des alertes
; ### startAlertesNotification()>void :
; Dmarre la gestion des alertes
Func startAlertesNotification()
	AdlibRegister("displayAlertesNotification", $displayAlertesNotification_frequence)
EndFunc
; ### updateAlertesNotification()>void :
; Met  jour le message des alertes
Func updateAlertesNotification($liste, ByRef $liste_en_cours, ByRef $lastTime)
	Local $now = @YEAR&@MON&@MDAY&@HOUR&@MIN&@SEC
	deleteListeAlertes($liste_en_cours)
	For $i = 1 To getListeAlertesLength($liste)
		Local $alerte = getAlerteInListAt($liste,$i)
		Local $listeOccurrences = occursAlerteEntreDates($alerte,$lastTime,$now)
		If $listeOccurrences[0] > 10 Then
			If $listeOccurrences[0] = 11 Then
				$listeOccurrences[6] = getInternationalisationText($nAiO_languageResources, "GA_update_occurencesregroupees")
			Else
				$listeOccurrences[6] = getInternationalisationText($nAiO_languageResources, "GA_update_occurencesregroupees_pluriel", $listeOccurrences[0]-10)
			EndIf
			For $j = $listeOccurrences[0]-5 To 7 Step -1
				$listeOccurrences[0] = $listeOccurrences[0]-1
				For $k = $j To UBound($listeOccurrences)-2
					$listeOccurrences[$k] = $listeOccurrences[$k+1]
				Next
				ReDim $listeOccurrences[UBound($listeOccurrences)-1]
			Next
		EndIf
		setAlerteOccurrences($alerte,$listeOccurrences)
		If $listeOccurrences[0] > 0 Then
			addToListeAlertes($liste_en_cours, $alerte)
		EndIf
	Next
EndFunc
; ### displayAlertesNotification()>void :
; Met  jour le message des alertes
Func displayAlertesNotification()
	If Mod($displayAlertesNotification_frequence*$displayAlertesNotification, 10000) = 0 Then
		Dim $last_time_Alertes_en_cours
		updateAlertesNotification($nAiO_alertes_to_check, $nAiO_alertes_to_display, $last_time_Alertes_en_cours)
	EndIf
	Local $total = getListeAlertesLength($nAiO_alertes_to_display), $titre, $texte, $position = MouseGetpos()
	If $total > 0 Then
		Local $soustotal = Mod(Floor($displayAlertesNotification_frequence*$displayAlertesNotification/5000),$total)+1
		Local $alerte = getAlerteInListAt($nAiO_alertes_to_display,$soustotal)
		Local $liste = getAlerteOccurrences($alerte)
		Local $liste2 = $liste
		$msg = getAlerteDescript($alerte) & @CRLF
		For $i = 1 To $liste[0]
			Local $valeur = StringSplit($liste[$i],"/ :")
			If $valeur[0]=6 Then
				$msg = $msg & @CRLF & " - " & $valeur[3]&"/"&$valeur[2]&"/"&$valeur[1]&" "&$valeur[4]&":"&$valeur[5]&":"&$valeur[6]
			Else
				$msg = $msg & @CRLF & $liste[$i]
			EndIf
		Next
		If $total = 1 Then
			$titre = getInternationalisationText($nAiO_languageResources, "GA_display_title")&" : "&getAlerteTitle($alerte)
		Else
			$titre = getInternationalisationText($nAiO_languageResources, "GA_display_title_pluriel", $soustotal, $total)&" : "&getAlerteTitle($alerte)
		EndIf
		$texte = StringStripWS($msg,3)
		If $titre <> $displayAlertesNotification_titre Or $texte <> $displayAlertesNotification_texte Or $position[0] <> $displayAlertesNotification_position[0] Or $position[1] <> $displayAlertesNotification_position[1] Then
			$displayAlertesNotification_titre = $titre
			$displayAlertesNotification_texte = $texte
			$displayAlertesNotification_position = $position
			ToolTip($texte, _
				$position[0]+20,$position[1]+20, _
				$titre)
			Local $couleur = 0xC02020
			If IsDeclared("Label_HHMM") Then
				GUICtrlSetColor($Label_HHMM, $couleur)
			EndIf
			Dim $GUI_CLOCK
			If IsArray($GUI_CLOCK) And UBound($GUI_CLOCK) = 5 Then
				GUICtrlSetColor($GUI_CLOCK[0], $couleur)
				GUICtrlSetColor($GUI_CLOCK[1], $couleur)
				GUICtrlSetColor($GUI_CLOCK[2], $couleur)
				GUICtrlSetColor($GUI_CLOCK[3], $couleur)
				GUICtrlSetColor($GUI_CLOCK[4], $couleur)
			ElseIf Not IsArray($GUI_CLOCK) And GUICtrlGetHandle($GUI_CLOCK) <> 0 Then
				GUICtrlSetColor($GUI_CLOCK, $couleur)
			EndIf
		EndIf
		If Mod(@SEC,5) = 0 Then
			If $displayAlertesNotification_audio Then
				If $displayAlertesNotification_activateAudio = "Y" Then playSound($nAiO_repertoire_audio&"Alerte.mp3")
				$displayAlertesNotification_audio = False
			EndIf
		Else
			$displayAlertesNotification_audio = True
		EndIf
	Else
		ToolTip("")
	EndIf
	$displayAlertesNotification += 1
EndFunc
; ### stopAlertesNotification()>void :
; Arrete la gestion des alertes
Func stopAlertesNotification()
	AdlibUnRegister("displayAlertesNotification")
EndFunc
#EndRegion