#Include-Once

Global $Label_HHMM

Func guiInterface()

	#Region Rcupration des donnes
	Local $listeProfils    = $nAiO_listeProfils, $listeAlertes    = newListeAlertes()
	Local $listeComptes    = newListeComptes(),  $listeMultis     = newListeMultis()
	Local $listeModules    = newListeModules(),  $listeLiens      = newListeLiens()
	Local $listeActions    = newListeActions(),  $listeParametres = newListeParametres()
	Local $listeLangues    = getAvailableLanguages()
	convertFichierToListeComptes(    getProfilFichier("comptes"), $listeComptes, $nAiO_profil_password)
	convertFichierToListeMultis(     getProfilFichier("multis"),  $listeMultis  )
	convertFichierToListeAlertes(    getProfilFichier("alertes"), $listeAlertes )
	convertFichierToListeModules(    getProfilFichier("modules"), $listeModules )
	convertFichierToListeLiens(      getProfilFichier("liens"),   $listeLiens   )
	convertFichierToListeActions(    getProfilFichier("config"),  $listeActions )
	convertFichierToListeParametres( getProfilFichier("config"),  $listeParametres )
	Local $CustomMultiCo = newMulti()
	setMultiAlias($CustomMultiCo, getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3"))
	deleteListeAlertes($nAiO_alertes_to_display)
	$nAiO_alertes_to_check = $listeAlertes
	$displayAlertesNotification_activateAudio = cond(getParametreValeurInListFromClef($listeParametres, "Audio")="Y", "Y", "N")
	$customMultiCo_activateMenu = cond(getParametreValeurInListFromClef($listeParametres, "CustomMulti")="Y", "Y", "N")
	Local _
		$nAiO_colorsForGUI     = getParametreValeurInListFromClef($listeParametres, "ColorGUI"),  _
		$nAiO_colorsForTRAY    = getParametreValeurInListFromClef($listeParametres, "ColorTRAY"), _
		$nAiO_visibleInTaskbar = getParametreValeurInListFromClef($listeParametres, "Taskbar") = "N"
	#EndRegion

	#Region Chargement de l'interface graphique
	Local $position = StringSplit(getParametreValeurInListFromClef($listeParametres, "PositionXY"),";")
	If @error Or Not IsArray($position) Or $position[0] < 2 Then $position = StringSplit("10;10",";")
	Local $GUI_position[6] = [ Number($position[1]), Number($position[2]), 146, 98, 122, "Background.jpg" ], $msgGUI=0, $msgTray=0, $horaire=0
	Local                                                                           _
		$GUI = GUICreate($nAiO_title&" v"&$nAiO_version,                            _
			$GUI_position[2], $GUI_position[3],                                     _
			$GUI_position[0], $GUI_position[1],                                     _
			BitOR($WS_POPUP,$WS_BORDER), cond($nAiO_visibleInTaskbar,0x00000080,-1) _ ; $DS_MODALFRAME = 0x00000080
		),                                                                          _
		$TRAY = TrayAdvancedCreate($nAiO_title&" v"&$nAiO_version, $nAiO_repertoire_images&"ZaDS-nAiO.ico")
	WinSetOnTop($GUI, "", cond(0<StringInStr("YS",getParametreValeurInListFromClef($listeParametres, "AOT")),1,0))
	GUISetIcon($nAiO_repertoire_images&"ZaDS-nAiO.ico", -1, $GUI)
	GUISetBkColor(0xC9C9C9, $GUI)
	Local $background = GUICtrlCreatePic($nAiO_repertoire_images&$GUI_position[5], 1,1, $GUI_position[2]-2,$GUI_position[3]-2)
	GUICtrlSetState($background, $GUI_DISABLE)
	GUICtrlSetResizing($background, 802) ; $GUI_DOCKALL = 802
	TrayAdvancedActivateContextMenu($TRAY)
	Local $trayMenu = TrayAdvancedCreateContextMenu($TRAY)
	#EndRegion

	#Region Choix des langues
	Local $LanguesTrayHandles[1] = [TrayAdvancedCreateMenu(getInternationalisationText($nAiO_languageResources, "IP_langues_menu"), $trayMenu)]
	language_updateTrayMenu($listeLangues, $LanguesTrayHandles)
	TrayAdvancedCreateMenu("", $trayMenu)
	#EndRegion

	#Region Items gnraux de l'interface
	Local $Bouton_Apropos, $Bouton_Profiler, $Bouton_Deplacer, $Bouton_Quitter

	; Bouton "A propos"
	$Bouton_Apropos = GUICtrlCreateButton("s", 1, 1, 24, 24, Default)
	GUICtrlSetFont($Bouton_Apropos, 9, 400, 1, "Webdings")
	GUICtrlSetResizing($Bouton_Apropos, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Apropos, getInternationalisationText($nAiO_languageResources, "IP_general_apropos_tip"))

	; Bouton "Profil"
	$Bouton_Profiler = GUICtrlCreateButton("4", 25, 1, 24, 24, Default)
	GUICtrlSetFont($Bouton_Profiler, 15, 400, 0, "Wingdings")
	GUICtrlSetResizing($Bouton_Profiler, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Profiler, getInternationalisationText($nAiO_languageResources, "IP_general_profiler_tip"))

	; Bouton "Deplacer"
	$Bouton_Deplacer = GUICtrlCreateButton("q", 97, 1, 24, 24, Default)
	GUICtrlSetFont($Bouton_Deplacer, 9, 400, 1, "Webdings")
	GUICtrlSetResizing($Bouton_Deplacer, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Deplacer, getInternationalisationText($nAiO_languageResources, "IP_general_deplacer_tip"))

	; Bouton "Quitter"
	$Bouton_Quitter = GUICtrlCreateButton("", 121, 1, 24, 24, Default)
	GUICtrlSetFont($Bouton_Quitter, 15, 400, 0, "Wingdings")
	GUICtrlSetResizing($Bouton_Quitter, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Quitter, getInternationalisationText($nAiO_languageResources, "IP_general_quitter_tip"))

	; Menu du choix du profil
	Local $ProfilerHandles[1] = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())]
	profiler_updateContextMenu($listeProfils, $ProfilerHandles)
	#EndRegion

	#Region Bouton Login
	Local $Bouton_Loginer = GUICtrlCreateButton("", 1, 25, 48, 48, $BS_BITMAP)
	GUICtrlSetImage($Bouton_Loginer, $nAiO_repertoire_images&"Interface\Cadenas.bmp")
	GUICtrlSetResizing($Bouton_Loginer, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Loginer, getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_tip"))
	; Sousmenus
	Local _
		$LoginerGUIHandles[1]  = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())],                                                                         _
		$LoginerTrayHandles[1] = [TrayAdvancedCreateMenu(getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), $trayMenu)], _
		$MultiCoGUIHandles[1]  = [GUICtrlCreateContextMenu($Bouton_Loginer)],                                                                              _
		$MultiCoTrayHandles[1] = [TrayAdvancedCreateMenu(getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), $trayMenu)]
	Local $Bouton_Loginer_Title = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), $LoginerGUIHandles[0])
	GUICtrlAdvancedSetState($Bouton_Loginer_Title, $GUI_DEFBUTTON)
	GUICtrlAdvancedMenuItemSetIcon($Bouton_Loginer_Title, $nAiO_repertoire_images&"Interface\Cadenas.bmp")
	GUICtrlCreateAdvancedMenuItem("", $LoginerGUIHandles[0])
	loginer_updateContextMenuAndTrayMenu($listeComptes, $LoginerGUIHandles, $LoginerTrayHandles)
	Local $Bouton_MultiCo_Title = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), $MultiCoGUIHandles[0])
	GUICtrlAdvancedSetState($Bouton_MultiCo_Title, $GUI_DEFBUTTON)
	GUICtrlAdvancedMenuItemSetIcon($Bouton_MultiCo_Title, $nAiO_repertoire_images&"Interface\Cadenas.bmp")
	GUICtrlCreateAdvancedMenuItem("", $MultiCoGUIHandles[0])
	Local $CustomMultiCo_Handles[1] = [0], $Bouton_CustomMultiCo_Title, $Bouton_CustomMultiCo_Separator, $CustomMultiCo_Handles_separator = "NOT_FOUND"
	multiCo_updateContextMenuAndTrayMenu($listeMultis, $listeComptes, $MultiCoGUIHandles, $MultiCoTrayHandles, $customMultiCo_activateMenu, $Bouton_CustomMultiCo_Title, $Bouton_CustomMultiCo_Separator)
	Local $CustomMultiCo_HandlesMenu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $CustomMultiCo_HandlesMenu_Launch = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3_launch"), $CustomMultiCo_HandlesMenu)
	GUICtrlAdvancedSetState($CustomMultiCo_HandlesMenu_Launch, BitOR($GUI_DEFBUTTON,$GUI_DISABLE))
	GUICtrlCreateAdvancedMenuItem("", $CustomMultiCo_HandlesMenu)
	#EndRegion

	#Region Bouton Snapshot
	Local $Bouton_Snapshot = GUICtrlCreateButton("", 49, 1, 48, 48, $BS_BITMAP)
	GUICtrlSetImage($Bouton_Snapshot, $nAiO_repertoire_images&"Interface\PersonnageAucun.bmp")
	GUICtrlSetResizing($Bouton_Snapshot, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Snapshot, getInternationalisationText($nAiO_languageResources, "IP_principal_snapshot_tip"))
	; Sousmenus
	Local $Bouton_Snapshot_Contexte = GUICtrlCreateContextMenu($Bouton_Snapshot)
	Local $Bouton_Snapshot_Title    = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_snapshot_title"), $Bouton_Snapshot_Contexte)
	GUICtrlAdvancedMenuItemSetIcon($Bouton_Snapshot_Title, $nAiO_repertoire_images&"Interface\PersonnageAucun.bmp")
	GUICtrlAdvancedSetState($Bouton_Snapshot_Title, $GUI_DEFBUTTON)
	GUICtrlCreateAdvancedMenuItem("", $Bouton_Snapshot_Contexte)
	; Sousmenu "Format" : {BMP,JPG,PNG}
	Local $Bouton_Snapshot_Format_Menu  = GUICtrlCreateAdvancedMenu(getInternationalisationText($nAiO_languageResources, "IP_principal_snapshot_format_title"), $Bouton_Snapshot_Contexte)
	Local $Bouton_Snapshot_Format_Items = newList( _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_format_value0"), $Bouton_Snapshot_Format_Menu), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_format_value1"), $Bouton_Snapshot_Format_Menu), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_format_value2"), $Bouton_Snapshot_Format_Menu)  _
	)
	; Sousmenu "Crop" : {Internal,Window,Desktop,Carotte,Manual}
	Local $Bouton_Snapshot_Crop_Menu    = GUICtrlCreateAdvancedMenu(getInternationalisationText($nAiO_languageResources, "IP_principal_snapshot_crop_title"), $Bouton_Snapshot_Contexte)
	Local $Bouton_Snapshot_Crop_Items   = newList( _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_crop_value0"), $Bouton_Snapshot_Crop_Menu), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_crop_value1"), $Bouton_Snapshot_Crop_Menu), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_crop_value2"), $Bouton_Snapshot_Crop_Menu), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_crop_value3"), $Bouton_Snapshot_Crop_Menu), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_crop_value4"), $Bouton_Snapshot_Crop_Menu)  _
	)
	; Sousmenu "Mode" : {Global,Unique}
	Local $Bouton_Snapshot_Mode_Menu  = GUICtrlCreateAdvancedMenu(getInternationalisationText($nAiO_languageResources, "IP_principal_snapshot_mode_title"), $Bouton_Snapshot_Contexte)
	Local $Bouton_Snapshot_Mode_Items = newList( _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_mode_value0"), $Bouton_Snapshot_Mode_Menu), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_mode_value1"), $Bouton_Snapshot_Mode_Menu)  _
	)
	GUICtrlCreateAdvancedMenuItem("", $Bouton_Snapshot_Contexte)
	Local $Bouton_Snapshot_Folder = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_snapshot_folder_title"), $Bouton_Snapshot_Contexte)
	snapshots_updateContextMenuAndCheck($listeParametres, $Bouton_Snapshot_Format_Menu,$Bouton_Snapshot_Format_Items, $Bouton_Snapshot_Crop_Menu,$Bouton_Snapshot_Crop_Items, $Bouton_Snapshot_Mode_Menu,$Bouton_Snapshot_Mode_Items)
	#EndRegion

	#Region Bouton Modules
	Local $Bouton_Modules = GUICtrlCreateButton("", 49, 49, 48, 48, $BS_BITMAP)
	GUICtrlSetImage($Bouton_Modules, $nAiO_repertoire_images&"Interface\Livre.bmp")
	GUICtrlSetResizing($Bouton_Modules, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Modules, getInternationalisationText($nAiO_languageResources, "IP_principal_modules_tip"))
	; Sousmenus
	Local _
		$ModulesGUIHandles[1]  = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())], _
		$ModulesTrayHandles[1] = [TrayAdvancedCreateMenu(getInternationalisationText($nAiO_languageResources, "IP_principal_modules_title"), $trayMenu)], _
		$LiensGUIHandles[1]  = [GUICtrlCreateContextMenu($Bouton_Modules)],      _
		$LiensTrayHandles[1] = [TrayAdvancedCreateMenu(getInternationalisationText($nAiO_languageResources, "IP_principal_liens_title"), $trayMenu)]
	Local $Bouton_Modules_Title = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_modules_title"), $ModulesGUIHandles[0])
	GUICtrlAdvancedMenuItemSetIcon($Bouton_Modules_Title, $nAiO_repertoire_images&"Interface\Livre.bmp")
	GUICtrlAdvancedSetState($Bouton_Modules_Title, $GUI_DEFBUTTON)
	GUICtrlCreateAdvancedMenuItem("", $ModulesGUIHandles[0])
	Local $Bouton_Liens_Title = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_liens_title"), $LiensGUIHandles[0])
	GUICtrlAdvancedMenuItemSetIcon($Bouton_Liens_Title, $nAiO_repertoire_images&"Interface\Livre.bmp")
	GUICtrlAdvancedSetState($Bouton_Liens_Title, $GUI_DEFBUTTON)
	GUICtrlCreateAdvancedMenuItem("", $LiensGUIHandles[0])
	modules_updateContextMenuAndTrayMenu($listeModules, $listeLiens, $ModulesGUIHandles, $ModulesTrayHandles, $LiensGUIHandles, $LiensTrayHandles)
	#EndRegion

	#Region Bouton Config
	Local $Bouton_Config = GUICtrlCreateButton("", 97, 25, 48, 48, $BS_BITMAP)
	GUICtrlSetImage($Bouton_Config, $nAiO_repertoire_images&"Interface\Engrenage.bmp")
	GUICtrlSetResizing($Bouton_Config, 802) ; $GUI_DOCKALL = 802
	GUICtrlSetTip($Bouton_Config, getInternationalisationText($nAiO_languageResources, "IP_principal_config_tip"))
	#EndRegion

	#Region Boutons Custom
	Local $Bouton_Custom1 = GUICtrlCreateButton("", 1, 73, 24, 24, Default)
	GUICtrlSetResizing($Bouton_Custom1, 802) ; $GUI_DOCKALL = 802
	Local $Bouton_Custom2 = GUICtrlCreateButton("", 25, 73, 24, 24, Default)
	GUICtrlSetResizing($Bouton_Custom2, 802) ; $GUI_DOCKALL = 802
	actions_updateCustomButtons($listeActions, $Bouton_Custom1, $Bouton_Custom2)
	#EndRegion

	#Region Horloge
	Local $Label_HHMM = GUICtrlCreateLabel("", 97, 77, 48, 20)
	GUICtrlSetFont($Label_HHMM, 11, 800, 1)
	GUICtrlSetStyle($Label_HHMM, 0x0101)
	GUICtrlSetBkColor($Label_HHMM,$GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetColor($Label_HHMM, 0x000000)
	GUICtrlSetResizing($Label_HHMM, 802) ; $GUI_DOCKALL = 802
	Local $space_HHMM = ""
	#EndRegion

	#Region Organizer
	Local $Organizer_windowList_vide = getDofusWinList(True), $Organizer_windowList = getDofusWinList(True)
	Local $Bouton_Organizer_1 = GUICtrlCreateButton("-",    1, 97, 48, 24)
	GUICtrlSetBkColor($Bouton_Organizer_1, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetResizing($Bouton_Organizer_1, 802) ; $GUI_DOCKALL = 802
	Local $Bouton_Organizer_2 = GUICtrlCreateButton("-",   49, 97, 48, 24)
	GUICtrlSetBkColor($Bouton_Organizer_2, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetResizing($Bouton_Organizer_2, 802) ; $GUI_DOCKALL = 802
	Local $Bouton_Organizer_3 = GUICtrlCreateButton("324", 97, 97, 48, 24)
	GUICtrlSetFont($Bouton_Organizer_3, 11, 400, 1, "Webdings")
	GUICtrlSetBkColor($Bouton_Organizer_3, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetResizing($Bouton_Organizer_3, 802) ; $GUI_DOCKALL = 802
	; Sousmenus
	Local $OrganizerGUIHandles[1] = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())]
	Local $Bouton_Organizer_Title = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_extension_organizer_title"), $OrganizerGUIHandles[0])
	GUICtrlAdvancedSetState($Bouton_Organizer_Title, $GUI_DEFBUTTON)
	GUICtrlCreateAdvancedMenuItem("", $OrganizerGUIHandles[0])
	Local $Bouton_Organizer_Apply = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_extension_organizer_apply"), $OrganizerGUIHandles[0])
	Local $Bouton_Organizer_Separator = GUICtrlCreateAdvancedMenuItem("", $OrganizerGUIHandles[0])
	organizer_updateButtons($Organizer_windowList, $Bouton_Organizer_Apply, $OrganizerGUIHandles)
	#EndRegion

	#Region Finalisation du menu Tray
	TrayAdvancedCreateItem("", $trayMenu)
	Local $Tray_Config  = TrayAdvancedCreateItem(getInternationalisationText($nAiO_languageResources, "IP_tray_config"), $trayMenu)
	Local $Tray_Quitter = TrayAdvancedCreateItem(getInternationalisationText($nAiO_languageResources, "IP_tray_quitter"), $trayMenu)
	TrayAdvancedItemSetIcon($Tray_Quitter, "shell32.dll", -28)
	#EndRegion

	#Region Variables d'tat de l'interface
	Global $nAiO_countdown = 0, $nAiO_etat_move = False, $nAiO_etat_timeout = True, $nAiO_etat_dock = (getParametreValeurInListFromClef($listeParametres, "AOT")="S")
	Local $nAiO_TimeOut = Number(""&getParametreValeurInListFromClef($listeParametres, "TimeOut"))*60*1000, $nAiO_etat_extended_previous = False
	timerStamp()
	#EndRegion

	#Region Raccourcis clavier
	Global _
		$hotkey_Apropos, $hotkey_Loginer, $hotkey_Snapshot, _
		$hotkey_Config,  $hotkey_Custom1, $hotkey_Custom2
	reset_guiHotkeys()
	start_guiHotkeys()
	#EndRegion

	GUICtrlAdvancedSetColors($nAiO_colorsForGUI)
	TrayAdvancedSetColors($nAiO_colorsForTRAY)
	switchInterface($GUI, $TRAY, True, True)
	startAlertesNotification()
	interceptAllMsg()
	_SetFlashTimeOut(250)

	While True
		; Traitement des messages
		Local $msgGUI = GUIGetMsg(), $msgTray = TrayGetMsg(), $hotkey = True
		#Region Traitement des raccourcis clavier
		Select
		Case $hotkey_Apropos
			$msgGUI = $Bouton_Apropos
		Case $hotkey_Loginer
			$msgGUI = $Bouton_Loginer
		Case $hotkey_Snapshot
			$msgGUI = $Bouton_Snapshot
		Case $hotkey_Config
			$msgGUI = $Bouton_Config
		Case $hotkey_Custom1
			$msgGUI = $Bouton_Custom1
		Case $hotkey_Custom2
			$msgGUI = $Bouton_Custom2
		Case Else
			$hotkey = False
		EndSelect
		If $hotkey Then reset_guiHotkeys()
		#EndRegion
		#Region Traitement des messages GUI pour les commandes gnrales (A propos, Profils, Dplacer et Quitter)
		Switch $msgGUI
		Case $Bouton_Apropos
			Local $texte = getAboutMessage($nAiO_title_long)
			MsgBox(0,$nAiO_title&" v"&$nAiO_version, $texte,60)
			interceptAllGUIMsg()
			timerStamp()
		Case $Bouton_Profiler
			sousmenu($GUI, $Bouton_Profiler, $ProfilerHandles[0])
			timerStamp()
		Case $Bouton_Deplacer
			$nAiO_etat_move = Not $nAiO_etat_move
			interceptAllGUIMsg()
			timerStamp()
		Case $Bouton_Quitter, $GUI_EVENT_CLOSE
			$nAiO_etat_stop = True
		Case Else
			; Gestion du timeout
			If $nAiO_TimeOut > 0 And TimerDiff($nAiO_countdown) > $nAiO_TimeOut Then
				$nAiO_etat_stop = True
			EndIf
			; Mise en place de l'extension infrieure
			If $nAiO_etat_extended_previous <> $nAiO_etat_extended Then
				GUISetState(@SW_DISABLE, $GUI)
				$nAiO_etat_extended_previous = $nAiO_etat_extended
				Local $speed = 5, $sleep = 30
				If $nAiO_etat_extended Then
					$Organizer_windowList = getDofusWinList()
					organizer_updateButtons($Organizer_windowList, $Bouton_Organizer_Apply, $OrganizerGUIHandles)
					For $i = $GUI_position[3] To $GUI_position[4]+2 Step $speed
						WinMove($GUI, "", Default, Default, Default, $i)
						Sleep($sleep)
					Next
					WinMove($GUI, "", Default, Default, Default, $GUI_position[4]+2)
				Else
					For $i = $GUI_position[4] To $GUI_position[3]+2 Step -$speed
						WinMove($GUI, "", Default, Default, Default, $i)
						Sleep($sleep)
					Next
					WinMove($GUI, "", Default, Default, Default, $GUI_position[3]+2)
					$Organizer_windowList = $Organizer_windowList_vide
					organizer_updateButtons($Organizer_windowList, $Bouton_Organizer_Apply, $OrganizerGUIHandles)
				EndIf
				GUISetState(@SW_ENABLE, $GUI)
			EndIf
			; Gestion de profils
			For $i = 1 To getListeProfilsLength($listeProfils)
				If $msgGUI = $ProfilerHandles[$i] And IsInt($ProfilerHandles[$i]) Then
					Local $profil = getProfilInListAt($listeProfils,$i), $ok = True, $clef = $nAiO_profil_password
					If isProfilProtected($profil) Then
						$ok = False
						Local $essai = 0
						While $essai < 3 And Not $ok
							$essai = $essai + 1
							$clef = InputBox( _
								getInternationalisationText($nAiO_languageResources, "ICB_trt_profil_title1",getProfilNom($profil),$essai), _
								getInternationalisationText($nAiO_languageResources, "ICB_trt_profil_texte1"), _
								"", "*M20", _
								200,120,Default,Default, 30 _
							)
							If @error Then $essai = 3
							$ok = checkProfilPassword($clef, $profil)
						WEnd
					Else
						$clef = ""
					EndIf
					If $ok Then
						$nAiO_profil_password = $clef
						; Sauvegarde du choix de profil
						setProfilActuel($profil)
						; Mise  jour des SdD  partir des nouveaux fichiers
						convertFichierToListeComptes(    getProfilFichier("comptes"), $listeComptes,   $nAiO_profil_password )
						convertFichierToListeMultis(     getProfilFichier("multis"),  $listeMultis  )
						convertFichierToListeAlertes(    getProfilFichier("alertes"), $listeAlertes )
						convertFichierToListeModules(    getProfilFichier("modules"), $listeModules )
						convertFichierToListeLiens(      getProfilFichier("liens"),   $listeLiens   )
						convertFichierToListeActions(    getProfilFichier("config"),  $listeActions )
						convertFichierToListeParametres( getProfilFichier("config"),  $listeParametres )
						$CustomMultiCo = newMulti()
						setMultiAlias($CustomMultiCo, getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3"))
						deleteListeAlertes($nAiO_alertes_to_display)
						$nAiO_alertes_to_check = $listeAlertes
						$displayAlertesNotification_activateAudio = cond(getParametreValeurInListFromClef($listeParametres, "Audio")="Y", "Y", "N")
						$customMultiCo_activateMenu = cond(getParametreValeurInListFromClef($listeParametres, "CustomMulti")="Y", "Y", "N")
						; Mise  jour des items de la GUI  partir des SdD
						profiler_updateContextMenu($listeProfils, $ProfilerHandles)
						loginer_updateContextMenuAndTrayMenu($listeComptes, $LoginerGUIHandles, $LoginerTrayHandles)
						multiCo_updateContextMenuAndTrayMenu($listeMultis,  $listeComptes, $MultiCoGUIHandles, $MultiCoTrayHandles, $customMultiCo_activateMenu, $Bouton_CustomMultiCo_Title, $Bouton_CustomMultiCo_Separator)
						modules_updateContextMenuAndTrayMenu($listeModules, $listeLiens, $ModulesGUIHandles, $ModulesTrayHandles, $LiensGUIHandles, $LiensTrayHandles)
						actions_updateCustomButtons($listeActions, $Bouton_Custom1, $Bouton_Custom2)
						WinSetOnTop($GUI, "", cond(0<StringInStr("YS",getParametreValeurInListFromClef($listeParametres, "AOT")),1,0))
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "IP_trt_profil_ok", getProfilNom($profil)), 30,1)
					Else
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "IP_trt_profil_ko", getProfilNom($profil)), 30,3)
					EndIf
					interceptAllGUIMsg()
					timerStamp()
				EndIf
			Next
			; Dplacement
			If $nAiO_etat_move Then
				Local $mouse = MouseGetPos(), $control = getControlCoords($GUI,$Bouton_Deplacer,True), $window = WinGetPos($GUI)
				WinMove($GUI, "", $mouse[0]-$control[0]-$control[2]/2, $mouse[1]-$control[1]-$control[3]/2)
			ElseIf $nAiO_etat_dock Then
				If WinActive("[CLASS:ApolloRuntimeContentWindow]") Then
					Local $pos = WinGetPos("[CLASS:ApolloRuntimeContentWindow]")
					If @error = 0 Then
						WinMove($GUI, "", cond(""&getParametreValeurInListFromClef($listeParametres, "Position")="L",$pos[0]+$GUI_position[0],$pos[0]+$pos[2]-$GUI_position[2]-$GUI_position[0]), $pos[1]+($pos[3]-$GUI_position[3])/2, Default,Default)
					EndIf
				EndIf
			EndIf
			; Fermeture
			If $nAiO_etat_stop Then ExitLoop
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour les fonctions principales (Login, Snapshot, Modules et Config)
		Switch $msgGUI
		Case $Bouton_Loginer, $Bouton_MultiCo_Title
			sousmenu($GUI, $Bouton_Loginer, $LoginerGUIHandles[0])
			timerStamp()
		Case $Bouton_Loginer_Title
			sousmenu($GUI, $Bouton_Loginer, $MultiCoGUIHandles[0])
			timerStamp()
		Case $Bouton_Modules, $Bouton_Liens_Title
			sousmenu($GUI, $Bouton_Modules, $ModulesGUIHandles[0])
			timerStamp()
		Case $Bouton_Modules_Title
			sousmenu($GUI, $Bouton_Modules, $LiensGUIHandles[0])
			timerStamp()
		Case $Bouton_Snapshot
			switchInterface($GUI, $TRAY, False, False)
			snapshot(""&getParametreValeurInListFromClef($listeParametres, "SnapshotFormat"), ""&getParametreValeurInListFromClef($listeParametres, "SnapshotCrop"), ""&getParametreValeurInListFromClef($listeParametres, "SnapshotMode"), $GUI, $TRAY)
			timerStamp()
			switchInterface($GUI, $TRAY, True, True)
		Case $Bouton_Snapshot_Title
			sousmenu($GUI, $Bouton_Snapshot, $Bouton_Snapshot_Contexte)
			timerStamp()
        Case $Bouton_Snapshot_Folder
			; Afficher le dossier
			ShellExecute("explorer.exe",'"'&$nAiO_repertoire_captures&'"')
		Case $Bouton_Config, $Tray_Config
			switchInterface($GUI, $TRAY, False, False)
			Local $resultat = guiConfiguration($TRAY)
			Local $error = @error, $extended = @extended
			If $error <> 0 Then
				; Afficher l'erreur
			Else
				Local $redemarrer = False
				If $resultat = True Then
					Local $retour = MsgBox(512+48+4, $nAiO_title&" v"&$nAiO_version, _
						getInternationalisationText($nAiO_languageResources, "IP_trt_config_restart_message"), _
						30, $GUI _
					)
					$redemarrer = ($retour=6)
				EndIf
				If $redemarrer Then
					; Redmarrage du nAiO
					redemarrer()
				Else
					setLastUsedProfil()
					convertStructureToListeProfils($nAiO_listeProfils)
					; Mise  jour des SdD  partir des nouveaux fichiers
					convertFichierToListeComptes(    getProfilFichier("comptes"), $listeComptes,   $nAiO_profil_password )
					convertFichierToListeMultis(     getProfilFichier("multis"),  $listeMultis  )
					convertFichierToListeAlertes(    getProfilFichier("alertes"), $listeAlertes )
					convertFichierToListeModules(    getProfilFichier("modules"), $listeModules )
					convertFichierToListeLiens(      getProfilFichier("liens"),   $listeLiens   )
					convertFichierToListeActions(    getProfilFichier("config"),  $listeActions )
					convertFichierToListeParametres( getProfilFichier("config"),  $listeParametres )
					$CustomMultiCo = newMulti()
					setMultiAlias($CustomMultiCo, getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3"))
					deleteListeAlertes($nAiO_alertes_to_display)
					$nAiO_alertes_to_check = $listeAlertes
					$displayAlertesNotification_activateAudio = cond(getParametreValeurInListFromClef($listeParametres, "Audio")="Y", "Y", "N")
					$customMultiCo_activateMenu = cond(getParametreValeurInListFromClef($listeParametres, "CustomMulti")="Y", "Y", "N")
					$nAiO_colorsForGUI  = getParametreValeurInListFromClef($listeParametres, "ColorGUI")
					$nAiO_colorsForTRAY = getParametreValeurInListFromClef($listeParametres, "ColorTRAY")
					; Mise  jour des items de la GUI  partir des SdD
					profiler_updateContextMenu($listeProfils, $ProfilerHandles)
					loginer_updateContextMenuAndTrayMenu($listeComptes, $LoginerGUIHandles, $LoginerTrayHandles)
					multiCo_updateContextMenuAndTrayMenu($listeMultis,  $listeComptes, $MultiCoGUIHandles, $MultiCoTrayHandles, $customMultiCo_activateMenu, $Bouton_CustomMultiCo_Title, $Bouton_CustomMultiCo_Separator)
					modules_updateContextMenuAndTrayMenu($listeModules, $listeLiens, $ModulesGUIHandles, $ModulesTrayHandles, $LiensGUIHandles, $LiensTrayHandles)
					actions_updateCustomButtons($listeActions, $Bouton_Custom1, $Bouton_Custom2)
					GUICtrlAdvancedSetColors($nAiO_colorsForGUI)
					TrayAdvancedSetColors($nAiO_colorsForTRAY)
					Local $position = StringSplit(getParametreValeurInListFromClef($listeParametres, "PositionXY"),";")
					If $position[0] = 2 Then WinMove($GUI, "", Number($position[1]), Number($position[2]))
					WinSetOnTop($GUI, "", cond(0<StringInStr("YS",getParametreValeurInListFromClef($listeParametres, "AOT")),1,0))
				EndIf
			EndIf
			interceptAllGUIMsg()
			timerStamp()
			switchInterface($GUI, $TRAY, True, True)
		Case $CustomMultiCo_HandlesMenu_Launch
			multico($CustomMultiCo,$listeComptes, ""&getParametreValeurInListFromClef($listeParametres, "Connexion"), ""&getParametreValeurInListFromClef($listeParametres, "FullscreenMulti"))
			Switch @error
			Case 1
				TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2")&" ("&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3")&")", _
					getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error1", getMultiAlias($CustomMultiCo)), _
					30,3 _
				)
			Case 2
				TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2")&" ("&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3")&")", _
					getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error2", getMultiAlias($CustomMultiCo)), _
					30,2 _
				)
			Case 3
				TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2")&" ("&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3")&")", _
					getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error3", getMultiAlias($CustomMultiCo)), _
					30,1 _
				)
			EndSwitch
			interceptAllGUIMsg()
			timerStamp()
		Case Else
			If $customMultiCo_activateMenu = "Y" And $msgGUI = $Bouton_CustomMultiCo_Title And IsInt($Bouton_CustomMultiCo_Title) Then
				For $i = $CustomMultiCo_Handles[0] To 1 Step -1
					GUICtrlAdvancedDelete($CustomMultiCo_Handles[$i])
				Next
				GUICtrlAdvancedDelete($CustomMultiCo_Handles_separator)
				ReDim $CustomMultiCo_Handles[getListeComptesLength($listeComptes)+1]
				$CustomMultiCo_Handles[0] = getListeComptesLength($listeComptes)
				$CustomMultiCo_ComptesSize = getMultiListingSize($CustomMultiCo)
				For $j = 1 To $CustomMultiCo_ComptesSize
					Local $index = getCompteIndexInMultiListingAt($CustomMultiCo,$j)
					For $i = 1 To $CustomMultiCo_Handles[0]
						Local $compte = getCompteInListAt($listeComptes,$i)
						If $index = getCompteIndex($compte) Then
							$texte = toStringCompte($compte)
							$CustomMultiCo_Handles[$i] = GUICtrlCreateAdvancedMenuItem($texte, $CustomMultiCo_HandlesMenu)
							GUICtrlAdvancedSetState($CustomMultiCo_Handles[$i], $GUI_CHECKED)
						EndIf
					Next
				Next
				If $CustomMultiCo_ComptesSize = 0 Then
					$CustomMultiCo_Handles_separator = "NOT_FOUND"
				Else
					$CustomMultiCo_Handles_separator = GUICtrlCreateAdvancedMenuItem("", $CustomMultiCo_HandlesMenu)
				EndIf
				For $i = 1 To $CustomMultiCo_Handles[0]
					Local $compte = getCompteInListAt($listeComptes,$i)
					$texte = toStringCompte($compte)
					If Not isCompteInMultiListing($CustomMultiCo, $compte) Then
						$CustomMultiCo_Handles[$i] = GUICtrlCreateAdvancedMenuItem($texte, $CustomMultiCo_HandlesMenu)
					EndIf
				Next
				GUICtrlAdvancedSetState($CustomMultiCo_HandlesMenu_Launch, BitOR($GUI_DEFBUTTON,cond($CustomMultiCo_ComptesSize=0, $GUI_DISABLE, $GUI_ENABLE)))
				sousmenu($GUI, $Bouton_Loginer, $CustomMultiCo_HandlesMenu)
				timerStamp()
			EndIf
			; Comptes
			For $i = 1 To getListeComptesLength($listeComptes)
				If $msgGUI = $LoginerGUIHandles[$i] And IsInt($LoginerGUIHandles[$i]) Then
					Local $compte = getCompteInListAt($listeComptes,$i)
					If isCompte($compte) Then
						login($compte, ""&getParametreValeurInListFromClef($listeParametres, "Connexion"), ""&getParametreValeurInListFromClef($listeParametres, "Fullscreen"), $TRAY)
						Switch @error
						Case 1
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error1", getCompteAlias($compte)), _
								30,3 _
							)
						Case 2
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error2", getCompteAlias($compte)), _
								30,2 _
							)
						Case 3
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error3", getCompteAlias($compte)), _
								30,1 _
							)
						Case 4
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error4", getCompteAlias($compte)), _
								30,3 _
							)
						EndSwitch
					EndIf
					interceptAllGUIMsg()
					timerStamp()
				EndIf
			Next
			; Multis
			For $i = 1 To getListeMultisLength($listeMultis)
				If $msgGUI = $MultiCoGUIHandles[$i] And IsInt($MultiCoGUIHandles[$i]) Then
					Local $multi = getMultiInListAt($listeMultis,$i)
					If isMulti($multi) Then
						multico($multi,$listeComptes, ""&getParametreValeurInListFromClef($listeParametres, "Connexion"), ""&getParametreValeurInListFromClef($listeParametres, "FullscreenMulti"), $TRAY)
						Switch @error
						Case 1
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error1", getMultiAlias($multi)), _
								30,3 _
							)
						Case 2
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error2", getMultiAlias($multi)), _
								30,2 _
							)
						Case 3
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error3", getMultiAlias($multi)), _
								30,1 _
							)
						EndSwitch
					EndIf
					interceptAllGUIMsg()
					timerStamp()
				EndIf
			Next
			; Modules
			For $i = 1 To getListeModulesLength($listeModules)
				If $msgGUI = $ModulesGUIHandles[$i] And IsInt($ModulesGUIHandles[$i]) Then
					switchInterface($GUI, $TRAY, False, False)
					Local $module = getModuleInListAt($listeModules,$i)
					moduleExecuter($module)
					interceptAllGUIMsg()
					timerStamp()
					switchInterface($GUI, $TRAY, True, True)
				EndIf
			Next
			; Liens
			For $i = 1 To getListeLiensLength($listeLiens)
				If $msgGUI = $LiensGUIHandles[$i] And IsInt($LiensGUIHandles[$i]) Then
					Local $lien = getLienInListAt($listeLiens,$i)
					Local $retour = lienExecuter($lien)
					If $retour = 1 Then
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_lien_msg_chemininconnu"), 30, 3)
					ElseIf $retour = 2 Then
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version, getInternationalisationText($nAiO_languageResources, "EP_lien_msg_liennonconforme"), 30, 3)
					EndIf
					interceptAllGUIMsg()
					timerStamp()
				EndIf
			Next
			; CustomMulti
			For $i = 1 To $CustomMultiCo_Handles[0]
				If $msgGUI = $CustomMultiCo_Handles[$i] And IsInt($CustomMultiCo_Handles[$i]) Then
					Local $compte = getCompteInListAt($listeComptes,$i)
					If isCompteInMultiListing($CustomMultiCo, $compte) Then
						GUICtrlAdvancedSetState($CustomMultiCo_Handles[$i], $GUI_UNCHECKED)
						delCompteFromMultiListing($CustomMultiCo, $compte)
					Else
						GUICtrlAdvancedSetState($CustomMultiCo_Handles[$i], $GUI_CHECKED)
						addCompteToMultiListing($CustomMultiCo, $compte)
					EndIf
					; Mise  jour menu
					For $i = $CustomMultiCo_Handles[0] To 1 Step -1
						GUICtrlAdvancedDelete($CustomMultiCo_Handles[$i])
					Next
					GUICtrlAdvancedDelete($CustomMultiCo_Handles_separator)
					ReDim $CustomMultiCo_Handles[getListeComptesLength($listeComptes)+1]
					$CustomMultiCo_Handles[0] = getListeComptesLength($listeComptes)
					$CustomMultiCo_ComptesSize = getMultiListingSize($CustomMultiCo)
					For $j = 1 To $CustomMultiCo_ComptesSize
						Local $index = getCompteIndexInMultiListingAt($CustomMultiCo,$j)
						For $i = 1 To $CustomMultiCo_Handles[0]
							Local $compte = getCompteInListAt($listeComptes,$i)
							If $index = getCompteIndex($compte) Then
								$texte = toStringCompte($compte)
								$CustomMultiCo_Handles[$i] = GUICtrlCreateAdvancedMenuItem($texte, $CustomMultiCo_HandlesMenu)
								GUICtrlAdvancedSetState($CustomMultiCo_Handles[$i], $GUI_CHECKED)
							EndIf
						Next
					Next
					If $CustomMultiCo_ComptesSize = 0 Then
						$CustomMultiCo_Handles_separator = "NOT_FOUND"
					Else
						$CustomMultiCo_Handles_separator = GUICtrlCreateAdvancedMenuItem("", $CustomMultiCo_HandlesMenu)
					EndIf
					For $i = 1 To $CustomMultiCo_Handles[0]
						Local $compte = getCompteInListAt($listeComptes,$i)
						$texte = toStringCompte($compte)
						If Not isCompteInMultiListing($CustomMultiCo, $compte) Then
							$CustomMultiCo_Handles[$i] = GUICtrlCreateAdvancedMenuItem($texte, $CustomMultiCo_HandlesMenu)
						EndIf
					Next
					GUICtrlAdvancedSetState($CustomMultiCo_HandlesMenu_Launch, BitOR($GUI_DEFBUTTON,cond($CustomMultiCo_ComptesSize=0, $GUI_DISABLE, $GUI_ENABLE)))
					sousmenu($GUI, $Bouton_Loginer, $CustomMultiCo_HandlesMenu)
					timerStamp()
					ExitLoop
				EndIf
			Next
			; Captures
			For $i = 1 To $Bouton_Snapshot_Format_Items[0]
				If $msgGUI = $Bouton_Snapshot_Format_Items[$i] And IsInt($Bouton_Snapshot_Format_Items[$i]) Then
					setParametreValeurInListFromClef($listeParametres, "SnapshotFormat", _
						cond($msgGUI = $Bouton_Snapshot_Format_Items[1], "BMP",               _
						cond($msgGUI = $Bouton_Snapshot_Format_Items[2], "JPG",               _
						cond($msgGUI = $Bouton_Snapshot_Format_Items[3], "PNG",               _
						""))) _
					)
					snapshots_updateContextMenuAndCheck($listeParametres, $Bouton_Snapshot_Format_Menu,$Bouton_Snapshot_Format_Items, $Bouton_Snapshot_Crop_Menu,$Bouton_Snapshot_Crop_Items, $Bouton_Snapshot_Mode_Menu,$Bouton_Snapshot_Mode_Items)
					timerStamp()
					sousmenu($GUI, $Bouton_Snapshot, $Bouton_Snapshot_Contexte)
				EndIf
			Next
			For $i = 1 To $Bouton_Snapshot_Crop_Items[0]
				If $msgGUI = $Bouton_Snapshot_Crop_Items[$i] And IsInt($Bouton_Snapshot_Crop_Items[$i]) Then
					setParametreValeurInListFromClef($listeParametres, "SnapshotCrop", _
						cond($msgGUI = $Bouton_Snapshot_Crop_Items[1],  "INTERNAL",     _
						cond($msgGUI = $Bouton_Snapshot_Crop_Items[2],    "WINDOW",       _
						cond($msgGUI = $Bouton_Snapshot_Crop_Items[3],   "DESKTOP",      _
						cond($msgGUI = $Bouton_Snapshot_Crop_Items[4],   "CAROTTE",      _
						cond($msgGUI = $Bouton_Snapshot_Crop_Items[5],    "MANUAL",       _
						""))))) _
					)
					snapshots_updateContextMenuAndCheck($listeParametres, $Bouton_Snapshot_Format_Menu,$Bouton_Snapshot_Format_Items, $Bouton_Snapshot_Crop_Menu,$Bouton_Snapshot_Crop_Items, $Bouton_Snapshot_Mode_Menu,$Bouton_Snapshot_Mode_Items)
					timerStamp()
					sousmenu($GUI, $Bouton_Snapshot, $Bouton_Snapshot_Contexte)
				EndIf
			Next
			For $i = 1 To $Bouton_Snapshot_Mode_Items[0]
				If $msgGUI = $Bouton_Snapshot_Mode_Items[$i] And IsInt($Bouton_Snapshot_Mode_Items[$i]) Then
					setParametreValeurInListFromClef($listeParametres, "SnapshotMode", _
						cond($msgGUI = $Bouton_Snapshot_Mode_Items[1], "GLOBAL",          _
						cond($msgGUI = $Bouton_Snapshot_Mode_Items[2], "UNIQUE",          _
						"")) _
					)
					snapshots_updateContextMenuAndCheck($listeParametres, $Bouton_Snapshot_Format_Menu,$Bouton_Snapshot_Format_Items, $Bouton_Snapshot_Crop_Menu,$Bouton_Snapshot_Crop_Items, $Bouton_Snapshot_Mode_Menu,$Bouton_Snapshot_Mode_Items)
					timerStamp()
					sousmenu($GUI, $Bouton_Snapshot, $Bouton_Snapshot_Contexte)
				EndIf
			Next
			; Mise  jour de l'image du bouton de snapshot
			If Not IsDeclared("nAiO_nbFenetres") Then Local $nAiO_nbFenetres = -1
			$nAiO_fenetres = WinList("[CLASS:"&$nAiO_fenetres_CLASS&"]")
			If $nAiO_nbFenetres <> $nAiO_fenetres[0][0] Then
				$nAiO_nbFenetres = $nAiO_fenetres[0][0]
				Local $nombre = $nAiO_fenetres[0][0]
				For $i = 1 To $nAiO_nbFenetres
					$nombre = $nombre - cond(StringInStr($nAiO_fenetres[$i][0], "Audio Subsystem"),1,0)
				Next
				GUICtrlSetImage($Bouton_Snapshot, $nAiO_repertoire_images&cond($nombre=0,"Interface\PersonnageAucun.bmp",cond($nombre=1,"Interface\PersonnageUnique.bmp","Interface\PersonnageMultiple.bmp")))
				GUICtrlAdvancedMenuItemSetIcon($Bouton_Snapshot_Title, $nAiO_repertoire_images&cond($nombre=0,"Interface\PersonnageAucun.bmp",cond($nombre=1,"Interface\PersonnageUnique.bmp","Interface\PersonnageMultiple.bmp")))
				; Mise  jour de l'Organizer
				$Organizer_windowList = getDofusWinList()
				organizer_updateButtons($Organizer_windowList, $Bouton_Organizer_Apply, $OrganizerGUIHandles)
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour les fonctions customises
		Switch $msgGUI
		Case $Bouton_Custom1
			switchInterface($GUI, $TRAY, False, False)
			Local $ressources[5] = [4, $listeComptes, $listeMultis, $listeModules, $listeParametres]
			launchAction($listeActions[1],$ressources)
			interceptAllGUIMsg()
			timerStamp()
			switchInterface($GUI, $TRAY, True, True)
		Case $Bouton_Custom2
			switchInterface($GUI, $TRAY, False, False)
			Local $ressources[5] = [4, $listeComptes, $listeMultis, $listeModules, $listeParametres]
			launchAction($listeActions[2],$ressources)
			interceptAllGUIMsg()
			timerStamp()
			switchInterface($GUI, $TRAY, True, True)
		Case Else
			; Sous-menu clic droit
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour les fonctions d'alertes programmes
		Switch $msgGUI
		Case $Label_HHMM
			Local $now = _NowCalc()
			If getListeAlertesLength($nAiO_alertes_to_display) = 0 Then
				Local $nextAlertes = getNextAlertesInListAt($listeAlertes, $now)
				Local $diffFromNow = @extended
				If getListeAlertesLength($nextAlertes) > 0 Then
					; Affiche
					Local _
						$trigger = _DateAdd("s", $diffFromNow, $now), _
						$errorTriggerDate   = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_date_format_error"), _
						$formatTriggerDate  = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_date_format"), _
						$errorTriggerDelay  = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_delay_format_error"), _
						$formatTriggerDelay = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_delay_format")
					Local _
						$triggerAsDate  = getAlerteTriggerAsDate($trigger,$errorTriggerDate,$formatTriggerDate), _
						$triggerAsDelay = getAlerteTriggerAsDelay($diffFromNow,$errorTriggerDelay)
					If getListeAlertesLength($nextAlertes) > 1 Then
						Local $texte = ""
						For $i = 1 To getListeAlertesLength($nextAlertes)
							Local $alerte = getAlerteInListAt($nextAlertes,$i)
							$texte = $texte & cond($i>1,", ","") & "'" & getAlerteTitle($alerte) & "'"
						Next
						$texte = StringReplace($texte, ", ", " et ",-1)
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_title"), _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_submessage", $triggerAsDate, $triggerAsDelay) & @CRLF & @CRLF & _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_message_pluriel", $texte), _
							30,1 _
						)
					Else
						Local $alerte = getAlerteInListAt($nextAlertes,1)
						Local $texte = "'" & getAlerteTitle($alerte) & "'"
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_title"), _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_submessage", $triggerAsDate, $triggerAsDelay) & @CRLF & @CRLF & _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_message", $texte), _
							30,1 _
						)
					EndIf
				Else
					; Aucun
					TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_title"), _
						getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_message_aucun"), _
						30,2 _
					)
				EndIf
			Else
				Local $GUI_CLOCK
				If IsDeclared("GUI_CLOCK") And IsArray($GUI_CLOCK) And UBound($GUI_CLOCK) = 5 Then
					GUICtrlSetColor($GUI_CLOCK[0], 0x000000)
					GUICtrlSetColor($GUI_CLOCK[1], 0x000000)
					GUICtrlSetColor($GUI_CLOCK[2], 0x000000)
					GUICtrlSetColor($GUI_CLOCK[3], 0x000000)
					GUICtrlSetColor($GUI_CLOCK[4], 0x000000)
				ElseIf IsDeclared("GUI_CLOCK") Then
					GUICtrlSetColor($GUI_CLOCK, 0x000000)
				EndIf
				If IsDeclared("Label_HHMM") Then GUICtrlSetColor($Label_HHMM, 0x000000)
				$last_time_Alertes_en_cours = @YEAR&@MON&@MDAY&@HOUR&@MIN&@SEC
				If @SEC > 0 Then deleteListeAlertes($nAiO_alertes_to_display)
			EndIf
			timerStamp()
		Case Else
			; Affichage de l'horaire
			If $horaire <> Round(2*@SEC+@MSEC/500) Then ; Actualise toutes les demi-secondes
				$horaire = Round(2*@SEC+@MSEC/500)
				If isHoveringCtrl($GUI,$Label_HHMM) Then
					GUICtrlSetData($Label_HHMM, cond(Mod($horaire,2)=0, " "&$space_HHMM&@SEC&$space_HHMM&" ", "-"&$space_HHMM&@SEC&$space_HHMM&"-"))
				Else
					GUICtrlSetData($Label_HHMM, @HOUR&$space_HHMM&cond(Mod($horaire,2)=0, " ", ":")&$space_HHMM&@MIN)
				EndIf
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour les fonctions de rorganisation des fentres
		Switch $msgGUI
		Case $Bouton_Organizer_3, $Bouton_Organizer_Title
			sousmenu($GUI, $Bouton_Organizer_3, $OrganizerGUIHandles[0])
			timerStamp()
		Case $Bouton_Organizer_Apply
			For $i = 1 To $Organizer_windowList[0][0]
				If $Organizer_windowList[$i][2] > 0 Then WinSetState($Organizer_windowList[$i][0], "", @SW_HIDE)
			Next
			For $i = 1 To $Organizer_windowList[0][0]
				For $j = 1 To $Organizer_windowList[0][0]
					If $Organizer_windowList[$j][2] = $i Then WinSetState($Organizer_windowList[$j][0], "", @SW_SHOW)
				Next
			Next
			timerStamp()
		Case Else
			; Clic et survol des boutons correspondants aux fentres
			Local $found = False, $reclic = False
			For $i = 1 To UBound($OrganizerGUIHandles)-1
				If $msgGUI = $OrganizerGUIHandles[$i] And IsInt($OrganizerGUIHandles[$i]) Then
					Local $order = $Organizer_windowList[$i][2]
					If $order = 0 Then
						For $j = 1 To $Organizer_windowList[0][0]
							If $order < $Organizer_windowList[$j][2] Then $order = $Organizer_windowList[$j][2]
						Next
						$Organizer_windowList[$i][2] = $order+1
					Else
						$Organizer_windowList[$i][2] = 0
						For $j = 1 To $Organizer_windowList[0][0]
							If $order < $Organizer_windowList[$j][2] Then $Organizer_windowList[$j][2] = $Organizer_windowList[$j][2]-1
						Next
					EndIf
					$reclic = True
				EndIf
			Next
			If $reclic Then
				organizer_updateButtons($Organizer_windowList, $Bouton_Organizer_Apply, $OrganizerGUIHandles)
				sousmenu($GUI, $Bouton_Organizer_3, $OrganizerGUIHandles[0])
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages Tray pour les fonctions primordiales (A propos, Login, Modules, Config et Quitter)
		$msgTray = $msgGUI
		Switch $msgTray
		Case $Tray_Quitter
			$nAiO_etat_stop = True
		Case Else
			; Comptes
			For $i = 1 To getListeComptesLength($listeComptes)
				If $msgTray = $LoginerTrayHandles[$i] And IsInt($LoginerTrayHandles[$i]) Then
					Local $compte = getCompteInListAt($listeComptes,$i)
					If isCompte($compte) Then
						login($compte, ""&getParametreValeurInListFromClef($listeParametres, "Connexion"), ""&getParametreValeurInListFromClef($listeParametres, "Fullscreen"), $TRAY)
						Switch @error
						Case 1
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error1", getCompteAlias($compte)), _
								30,3 _
							)
						Case 2
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error2", getCompteAlias($compte)), _
								30,2 _
							)
						Case 3
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error3", getCompteAlias($compte)), _
								30,1 _
							)
						Case 4
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title1"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_compte_error4", getCompteAlias($compte)), _
								30,3 _
							)
						EndSwitch
					EndIf
					interceptAllTrayMsg()
					timerStamp()
				EndIf
			Next
			; Multis
			For $i = 1 To getListeMultisLength($listeMultis)
				If $msgTray = $MultiCoTrayHandles[$i] And IsInt($MultiCoTrayHandles[$i]) Then
					Local $multi = getMultiInListAt($listeMultis,$i)
					If isMulti($multi) Then
						multico($multi,$listeComptes, ""&getParametreValeurInListFromClef($listeParametres, "Connexion"), ""&getParametreValeurInListFromClef($listeParametres, "FullscreenMulti"), $TRAY)
						Switch @error
						Case 1
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error1", getMultiAlias($multi)), _
								30,3 _
							)
						Case 2
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error2", getMultiAlias($multi)), _
								30,2 _
							)
						Case 3
							TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title2"), _
								getInternationalisationText($nAiO_languageResources, "IP_trt_connexion_multi_error3", getMultiAlias($multi)), _
								30,1 _
							)
						EndSwitch
					EndIf
					interceptAllTrayMsg()
					timerStamp()
				EndIf
			Next
			; Modules
			For $i = 1 To getListeModulesLength($listeModules)
				If $msgTray = $ModulesTrayHandles[$i] And IsInt($ModulesTrayHandles[$i]) Then
					switchInterface($GUI, $TRAY, False, False)
					Local $module = getModuleInListAt($listeModules,$i)
					moduleExecuter($module)
					interceptAllTrayMsg()
					timerStamp()
					switchInterface($GUI, $TRAY, True, True)
				EndIf
			Next
			; Liens
			For $i = 1 To getListeLiensLength($listeLiens)
				If $msgTray = $LiensTrayHandles[$i] And IsInt($LiensTrayHandles[$i]) Then
					Local $lien = getLienInListAt($listeLiens,$i)
					lienExecuter($lien)
					interceptAllGUIMsg()
					timerStamp()
				EndIf
			Next
			; Langues
			For $i = 1 To $listeLangues[0]
				If $msgGUI = $LanguesTrayHandles[$i] And IsInt($LanguesTrayHandles[$i]) Then
					Local $langue = $listeLangues[$i]
					setLanguageInConfig($langue)
					$nAiO_etat_restart = True
					$nAiO_etat_stop    = True
				EndIf
			Next
		EndSwitch
		#EndRegion
	WEnd
	stopAlertesNotification()

	stop_guiHotkeys()
	GUIDelete($GUI)
	TrayAdvancedDelete($TRAY)
EndFunc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Fonction de mise en sommeil de l'interface (xcution concurrentielle)
Func switchInterface($GUI, $TRAY, $flag_GUI, $flag_TRAY)
	GUICtrlSetData($Label_HHMM,"--:--")
	If $flag_GUI Then
		GUISetState(@SW_SHOW, $GUI)
	Else
		GUISetState(@SW_HIDE, $GUI)
	EndIf
	If $flag_TRAY Then
		TrayAdvancedActivateContextMenu($TRAY)
	Else
		TrayAdvancedDesactivateContextMenu($TRAY)
	EndIf
EndFunc
#EndRegion

#Region Fonctions annexes pour le traitement des messages de l'interface
; Langues
Func language_updateTrayMenu($listeLangues, ByRef $listeTray)
	; Efface les menus de 'Langues'
	Local _
		$texte = getInternationalisationText($nAiO_languageResources, "IP_langues_aucun_label"), _
		$itemTray = 0, $menuTray = $listeTray[0]
	For $i = 1 To UBound($listeTray)-1
		If IsInt($listeTray[$i]) Then TrayAdvancedDeleteItem($listeTray[$i])
	Next
	$listeTray = newArray()
	If $listeLangues[0] = 0 Then
		$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
		TrayAdvancedItemSetState($itemTray, $GUI_DISABLE)
		addToArray($listeTray, $itemTray)
	Else
		; Pour chaque langue, cre un menu de 'Langues'
		For $i = 1 To $listeLangues[0]
			Local $texte = getInternationalisationText($nAiO_languageResources, "IP_langues_choix_"&$listeLangues[$i])
			$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
			If $listeLangues[$i] = getDefaultLanguage() Then TrayAdvancedItemSetState($itemTray, $GUI_DISABLE)
			addToArray($listeTray, $itemTray)
		Next
	EndIf
	$listeTray[0] = $menuTray
EndFunc
; Comptes
Func loginer_updateContextMenuAndTrayMenu($listeComptes, ByRef $listeGUI, ByRef $listeTray)
	; Efface les menus de 'Connexion' et de la barre de tray
	Local _
		$texte = getInternationalisationText($nAiO_languageResources, "IP_comptes_aucun_label"), _
		$itemGUI = 0, $menuGUI = $listeGUI[0], $itemTray = 0, $menuTray = $listeTray[0]
	For $i = 1 To UBound($listeGUI)-1
		If IsInt($listeGUI[$i])  Then GUICtrlAdvancedDelete($listeGUI[$i])
		If IsInt($listeTray[$i]) Then TrayAdvancedDeleteItem($listeTray[$i])
	Next
	$listeGUI = newArray()
	$listeTray = newArray()
	If getListeComptesLength($listeComptes) = 0 Then
		$itemGUI = GUICtrlCreateAdvancedMenuItem($texte, $menuGUI)
		$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
		GUICtrlAdvancedSetState($itemGUI, $GUI_DISABLE)
		TrayAdvancedItemSetState($itemTray, $GUI_DISABLE)
		addToArray($listeGUI, $itemGUI)
		addToArray($listeTray, $itemTray)
	Else
		; Pour chaque compte, cre un menu de 'Connexion' et de la barre de tray
		For $i = 1 To getListeComptesLength($listeComptes)
			Local $compte = getCompteInListAt($listeComptes,$i)
			$texte = toStringCompte($compte)
			$itemGUI = GUICtrlCreateAdvancedMenuItem($texte, $menuGUI)
			$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
			If FileExists(getCompteAvatar($compte)) Then GUICtrlAdvancedMenuItemSetIcon($itemGUI,getCompteAvatar($compte))
			If isCompteLockedByKey($compte) Then GUICtrlAdvancedMenuItemSetSelIcon($itemGUI,$nAiO_repertoire_images&"Interface\Etoile.ico")
			addToArray($listeGUI, $itemGUI)
			addToArray($listeTray, $itemTray)
		Next
	EndIf
	$listeGUI[0]  = $menuGUI
	$listeTray[0] = $menuTray
EndFunc
; Multi
Func multiCo_updateContextMenuAndTrayMenu($listeMultis, $listeComptes, ByRef $listeGUI, ByRef $listeTray, $CustomMode, ByRef $CustomTitle, ByRef $CustomSeparator)
	; Efface les menus de 'Multi-Co' et de la barre de tray
	Local _
		$texte = getInternationalisationText($nAiO_languageResources, "IP_multis_aucun_label"), _
		$itemGUI = 0, $menuGUI = $listeGUI[0], $itemTray = 0, $menuTray = $listeTray[0]
	For $i = 1 To UBound($listeGUI)-1
		If IsInt($listeGUI[$i])  Then GUICtrlAdvancedDelete($listeGUI[$i])
		If IsInt($listeTray[$i]) Then TrayAdvancedDeleteItem($listeTray[$i])
	Next
	GUICtrlAdvancedDelete($CustomTitle)
	GUICtrlAdvancedDelete($CustomSeparator)
	If $CustomMode = "Y" Then
		$CustomTitle = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_principal_loginer_title3")&" >", $menuGUI)
		If getListeComptesLength($listeComptes) = 0 Then GUICtrlAdvancedSetState($CustomTitle, $GUI_DISABLE)
		$CustomSeparator = GUICtrlCreateAdvancedMenuItem("", $menuGUI)
	Else
		$CustomTitle = "NOT_FOUND"
		$CustomSeparator = "NOT_FOUND"
	EndIf
	$listeGUI = newArray()
	$listeTray = newArray()
	If getListeMultisLength($listeMultis) = 0 Then
		$itemGUI  = GUICtrlCreateAdvancedMenuItem($texte, $menuGUI)
		$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
		GUICtrlAdvancedSetState($itemGUI, $GUI_DISABLE)
		TrayAdvancedItemSetState($itemTray, $GUI_DISABLE)
		addToArray($listeGUI, $itemGUI)
		addToArray($listeTray, $itemTray)
	Else
		; Pour chaque multi, cre un menu de 'Multi-Co' et de la barre de tray
		For $i = 1 To getListeMultisLength($listeMultis)
			Local $multi = getMultiInListAt($listeMultis,$i)
			$texte = toStringMulti($multi)
			$itemGUI = GUICtrlCreateAdvancedMenuItem($texte, $menuGUI)
			$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
			If getMultiListingSize($multi) = 0 Then
				GUICtrlAdvancedSetState($itemGUI,   $GUI_DISABLE)
				TrayAdvancedItemSetState($itemTray, $GUI_DISABLE)
			EndIf
			addToArray($listeGUI, $itemGUI)
			addToArray($listeTray, $itemTray)
		Next
	EndIf
	$listeGUI[0]  = $menuGUI
	$listeTray[0] = $menuTray
EndFunc
; Captures
Func snapshots_updateContextMenuAndCheck(ByRef $listeParametres, $formatMenu,$formatItems, $cropMenu,$cropItems, $modeMenu,$modeItems)
	; Initialisation des menus "Format", "Crop" et "Mode"
	Local $liste, $index = 0 _
		, $disable_Format = False, $value_Format = getParametreValeurInListFromClef($listeParametres, "SnapshotFormat") _
		, $disable_Crop   = False, $value_Crop   = getParametreValeurInListFromClef($listeParametres, "SnapshotCrop")   _
		, $disable_Mode   = False, $value_Mode   = getParametreValeurInListFromClef($listeParametres, "SnapshotMode")
	; Traitement des items du menu "Format"
	For $i=1 To $formatItems[0]
		GUICtrlAdvancedSetState($formatItems[$i], $GUI_UNCHECKED)
	Next
	$liste = newList("BMP","JPG","PNG")
	$index = getIndexInList($liste, $value_Format)
	If $index = 0 Then
		$index = 1
		setParametreValeurInListFromClef($listeParametres, "SnapshotFormat", $liste[$index])
	EndIf
	GUICtrlAdvancedSetState($formatItems[$index], $GUI_CHECKED)
	; Traitement des items du menu "Crop"
	For $i=1 To $cropItems[0]
		GUICtrlAdvancedSetState($cropItems[$i], $GUI_UNCHECKED)
	Next
	$liste = newList("INTERNAL","WINDOW","DESKTOP","CAROTTE","MANUAL")
	$index = getIndexInList($liste, $value_Crop)
	If $index = 0 Then
		$index = 3
		setParametreValeurInListFromClef($listeParametres, "SnapshotCrop", $liste[$index])
	EndIf
	If $index = 3 Or $index = 5 Then $disable_Mode = True
	GUICtrlAdvancedSetState($cropItems[$index], $GUI_CHECKED)
	; Traitement des items du menu "Mode"
	For $i=1 To $modeItems[0]
		GUICtrlAdvancedSetState($modeItems[$i], $GUI_UNCHECKED)
	Next
	$liste = newList("GLOBAL","UNIQUE")
	$index = getIndexInList($liste, $value_Mode)
	If $index = 0 Then
		$index = 1
		setParametreValeurInListFromClef($listeParametres, "SnapshotMode", $liste[$index])
	EndIf
	GUICtrlAdvancedSetState($modeItems[$index], $GUI_CHECKED)
	; Traitement des menus "Format", "Crop" et "Mode"
	GUICtrlAdvancedSetState($formatMenu, cond($disable_Format, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlAdvancedSetState($cropMenu,   cond($disable_Crop,   $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlAdvancedSetState($modeMenu,   cond($disable_Mode,   $GUI_DISABLE, $GUI_ENABLE))
EndFunc
; Modules
Func modules_updateContextMenuAndTrayMenu($listeModules, $listeLiens, ByRef $listeModulesGUI, ByRef $listeModulesTray, ByRef $listeLiensGUI, ByRef $listeLiensTray)
	; Efface les menus de 'Modules' et de la barre de tray
	Local $n = 0, _
		$texteModuleVide = getInternationalisationText($nAiO_languageResources, "IP_modules_aucun_label"), _
		$texteLienVide = getInternationalisationText($nAiO_languageResources, "IP_liens_aucun_label"), _
		$itemGUI = 0, $menuGUI = $listeModulesGUI[0], $itemTray = 0, $menuTray = $listeModulesTray[0]
	For $i = 1 To UBound($listeModulesGUI)-1
		If IsInt($listeModulesGUI[$i])  Then GUICtrlAdvancedDelete($listeModulesGUI[$i])
		If IsInt($listeModulesTray[$i]) Then TrayAdvancedDeleteItem($listeModulesTray[$i])
	Next
	For $i = 1 To UBound($listeLiensGUI)-1
		If IsInt($listeLiensGUI[$i])  Then GUICtrlAdvancedDelete($listeLiensGUI[$i])
		If IsInt($listeLiensTray[$i]) Then TrayAdvancedDeleteItem($listeLiensTray[$i])
	Next
	; Pour chaque module ACTIF, cre un menu de 'Modules' et de la barre de tray
	$n = 0
	$listeModulesGUI = newArray()
	$listeModulesTray = newArray()
	For $i = 1 To getListeModulesLength($listeModules)
		Local $module = getModuleInListAt($listeModules,$i)
		Local $texte = toStringModule($module)
		If Not isModuleEtatActif($module) Then
			$itemGUI = "NOT_FOUND"
			$itemTray = "NOT_FOUND"
		Else
			$itemGUI  = GUICtrlCreateAdvancedMenuItem($texte, $menuGUI)
			$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
			$n = $n + 1
		EndIf
		addToArray($listeModulesGUI, $itemGUI)
		addToArray($listeModulesTray, $itemTray)
	Next
	; $n = nombre de modules ACTIFS, si zro, afficher un message "Aucun module actif"
	If $n = 0 Then
		$itemGUI  = GUICtrlCreateAdvancedMenuItem($texteModuleVide, $menuGUI)
		$itemTray = TrayAdvancedCreateItem($texteModuleVide, $menuTray)
		GUICtrlAdvancedSetState($itemGUI, $GUI_DISABLE)
		TrayAdvancedItemSetState($itemTray, $GUI_DISABLE)
		$listeModulesGUI[1]  = $itemGUI
		$listeModulesTray[1] = $itemTray
	EndIf
	$listeModulesGUI[0]  = $menuGUI
	$listeModulesTray[0] = $menuTray
	; Pour chaque lien, cre un menu de 'Liens' et de la barre de tray
	$menuGUI = $listeLiensGUI[0]
	$menuTray = $listeLiensTray[0]
	$n = 0
	$listeLiensGUI = newArray()
	$listeLiensTray = newArray()
	For $i = 1 To getListeLiensLength($listeLiens)
		Local $lien = getLienInListAt($listeLiens,$i)
		Local $texte = toStringLien($lien)
		$itemGUI  = GUICtrlCreateAdvancedMenuItem($texte, $menuGUI)
		$itemTray = TrayAdvancedCreateItem($texte, $menuTray)
		$n = $n + 1
		addToArray($listeLiensGUI, $itemGUI)
		addToArray($listeLiensTray, $itemTray)
	Next
	; $n = nombre de liens trouvs, si zro, afficher un message "Aucun lien actif"
	If $n = 0 Then
		$itemGUI  = GUICtrlCreateAdvancedMenuItem($texteLienVide, $menuGUI)
		$itemTray = TrayAdvancedCreateItem($texteLienVide, $menuTray)
		GUICtrlAdvancedSetState($itemGUI, $GUI_DISABLE)
		TrayAdvancedItemSetState($itemTray, $GUI_DISABLE)
		addToArray($listeLiensGUI, $itemGUI)
		addToArray($listeLiensTray, $itemTray)
	EndIf
	$listeLiensGUI[0] = $menuGUI
	$listeLiensTray[0] = $menuTray
EndFunc
; Profiles
Func profiler_updateContextMenu($listeProfils, ByRef $listeGUI)
	; Efface les menus de 'Profil'
	Local _
		$texte = getInternationalisationText($nAiO_languageResources, "IP_profils_aucun_label"), _
		$itemGUI = 0, $menuGUI = $listeGUI[0]
	For $i = 1 To UBound($listeGUI)-1
		If IsInt($listeGUI[$i]) Then GUICtrlAdvancedDelete($listeGUI[$i])
	Next
	$listeGUI = newArray()
	If getListeProfilsLength($listeProfils) = 0 Then
		$itemGUI = GUICtrlCreateAdvancedMenuItem($texte, $menuGUI)
		GUICtrlAdvancedSetState($itemGUI, $GUI_DISABLE)
		addToArray($listeGUI, $itemGUI)
	Else
		; Pour chaque profil, cre un menu de 'Profil'
		For $i = 1 To getListeProfilsLength($listeProfils)
			Local $profil = getProfilInListAt($listeProfils,$i)
			$itemGUI  = GUICtrlCreateAdvancedMenuItem(getProfilNom($profil), $menuGUI)
			If isProfilProtected($profil) Then
				GUICtrlAdvancedMenuItemSetSelIcon($itemGUI,$nAiO_repertoire_images&"Interface\Etoile.ico")
			EndIf
			If getProfilNom($profil) = getProfilNom(getProfilActuel()) Then GUICtrlAdvancedSetState($itemGUI, $GUI_DEFBUTTON)
			addToArray($listeGUI, $itemGUI)
		Next
	EndIf
	$listeGUI[0] = $menuGUI
EndFunc
; Actions
Func actions_updateCustomButtons($listeActions, $Bouton_Custom1, $Bouton_Custom2)
	actions_updateCustomButton(getActionInListAt($listeActions,1),$Bouton_Custom1)
	actions_updateCustomButton(getActionInListAt($listeActions,2),$Bouton_Custom2)
EndFunc
Func actions_updateCustomButton($action, $Bouton_Custom)
	If isActionDefined($action) Then
		GUICtrlSetState($Bouton_Custom, $GUI_ENABLE)
		GUICtrlSetState($Bouton_Custom, $GUI_SHOW)
		; Update d'items
		GUICtrlSetData($Bouton_Custom, getActionLabel($action))
		GUICtrlSetFont($Bouton_Custom, getActionSize($action), cond(isActionBold($action),800,400), 1, getActionFont($action))
		; Tooltips des items
		GUICtrlSetTip($Bouton_Custom, getActionDescription($action), getActionTitle($action))
	Else
		GUICtrlSetState($Bouton_Custom, $GUI_DISABLE)
		GUICtrlSetState($Bouton_Custom, $GUI_HIDE)
	EndIf
EndFunc
; Organizer
Func organizer_updateButtons($listeFenetres, $lanceur, ByRef $listeGUI)
	; Efface les menus de 'Connexion' et de la barre de tray
	Local $texte = getInternationalisationText($nAiO_languageResources, "IP_organizer_aucun_label")
	For $i = 1 To UBound($listeGUI)-1
		If IsInt($listeGUI[$i])  Then GUICtrlAdvancedDelete($listeGUI[$i])
	Next
	ReDim $listeGUI[2]
	GUICtrlAdvancedSetState($lanceur, $GUI_DISABLE)
	If $listeFenetres[0][0] = 0 Then
		$listeGUI[1]  = GUICtrlCreateAdvancedMenuItem($texte, $listeGUI[0])
		GUICtrlAdvancedSetState($listeGUI[1], $GUI_DISABLE)
	Else
		; Pour chaque compte, cre un menu de 'Connexion' et de la barre de tray
		ReDim $listeGUI[$listeFenetres[0][0]+1]
		For $i = 1 To $listeFenetres[0][0]
			For $j = 1 To $listeFenetres[0][0]
				If $listeFenetres[$j][2] = $i Then
					$texte = $listeFenetres[$j][0]
					$listeGUI[$j] = GUICtrlCreateAdvancedMenuItem($texte, $listeGUI[0])
					GUICtrlAdvancedSetState($listeGUI[$j], $GUI_CHECKED)
					GUICtrlAdvancedSetState($lanceur, $GUI_ENABLE)
				EndIf
			Next
		Next
		For $i = 1 To $listeFenetres[0][0]
			If $listeFenetres[$i][2] = 0 Then
				$texte = $listeFenetres[$i][0]
				$listeGUI[$i] = GUICtrlCreateAdvancedMenuItem($texte, $listeGUI[0])
				GUICtrlAdvancedSetState($listeGUI[$i], $GUI_UNCHECKED)
			EndIf
		Next
	EndIf
EndFunc
#EndRegion

#Region Fonctions annexes pour le traitement gnral de l'interface
Func timerStamp()
	$nAiO_countdown = TimerInit()
EndFunc
Func start_guiHotkeys()
	HotKeySet("#{F2}","etendre")
	HotKeySet("#{F4}","quitter")
	HotKeySet("#{F5}","redemarrer")
	HotKeySet("#h", "hotkey_Apropos")
	HotKeySet("#", "hotkey_Loginer")
	HotKeySet("#s", "hotkey_Snapshot")
	HotKeySet("#c", "hotkey_Config")
	HotKeySet("#1", "hotkey_Custom1")
	HotKeySet("#2", "hotkey_Custom2")
EndFunc
Func reset_guiHotkeys()
	$hotkey_Apropos  = False
	$hotkey_Loginer  = False
	$hotkey_Snapshot = False
	$hotkey_Config   = False
	$hotkey_Custom1  = False
	$hotkey_Custom2  = False
EndFunc
Func stop_guiHotkeys()
	HotKeySet("#{F2}")
	HotKeySet("#{F4}")
	HotKeySet("#{F5}")
	HotKeySet("#h")
	HotKeySet("#")
	HotKeySet("#s")
	HotKeySet("#c")
	HotKeySet("#1")
	HotKeySet("#2")
EndFunc
Func etendre()
	$nAiO_etat_extended = Not $nAiO_etat_extended
EndFunc
Func quitter()
	If $nAiO_etat_stop Then exit_naio()
	$nAiO_etat_stop = True
EndFunc
Func redemarrer()
	If $nAiO_etat_restart Then restart_naio()
	$nAiO_etat_restart = True
	$nAiO_etat_stop = True
EndFunc
#EndRegion

#Region Fonctions annexes pour le traitement des Hotkeys
Func hotkey_Apropos()
	$hotkey_Apropos = True
EndFunc
Func hotkey_Loginer()
	$hotkey_Loginer = True
EndFunc
Func hotkey_Snapshot()
	$hotkey_Snapshot = True
EndFunc
Func hotkey_Config()
	$hotkey_Config = True
EndFunc
Func hotkey_Custom1()
	$hotkey_Custom1 = True
EndFunc
Func hotkey_Custom2()
	$hotkey_Custom2 = True
EndFunc
#EndRegion