Func getInternationalisationFile()
	Local $titre = "LANGUAGE", $vide = newArray(2), $registre = getDefaultLanguage()
	Local $fichier = $nAiO_repertoire_language&$registre&".ini"
	If FileExists($fichier) Then
		Local $resultat = IniReadSection($fichier, $titre)
		If Not @error Then
			orderInternationalisationResources($resultat)
			Return $resultat
		EndIf
	EndIf
	SetError(1,0,$vide)
	Return $vide
EndFunc

Func getDefaultLanguage()
	Local $resultat = IniRead($nAiO_repertoire_data&"Config.ini", "ZaDS-nAiO", "Language", "FR")
	If @error Or Not FileExists($nAiO_repertoire_language&$resultat&".ini") Then $resultat = "FR"
	Return $resultat
EndFunc

Func getAvailableLanguages()
	Local $resultat = newArray(), $recherche = FileFindFirstFile($nAiO_repertoire_language&"*.ini")
	If $recherche = -1 Then Return $resultat
	While 1
		Local $fichier = FileFindNextFile($recherche)
		If @error Then ExitLoop
		Local $regexp = StringRegExp($fichier,"^(.*?)\.ini$",1)
		If @error = 0 And IsArray($regexp) And UBound($regexp) = 1 Then addToArray($resultat, StringUpper($regexp[0]))
	WEnd
	FileClose($recherche)
	Return $resultat
EndFunc

Func setLanguageInConfig($langue)
	IniWrite($nAiO_repertoire_data&"Config.ini", "ZaDS-nAiO", "Language", $langue)
EndFunc

Func getInternationalisationText($resources, $clef, $val0="", $val1="", $val2="", $val3="")
	Local $start = 1, $end = $resources[0][0], $i = 0, $compare = 0
	While $start<=$end
		$i = Floor(($start+$end)/2)
		$compare = StringCompare($clef, $resources[$i][0])
		If $compare = 0 Then
			Local $texte = StringReplace($resources[$i][1],"\n",@CRLF,0,2)
			If StringRegExp($texte,"\{[0123]\}") Then
				$texte = StringReplace($texte,"{0}",$val0,0,2)
				$texte = StringReplace($texte,"{1}",$val1,0,2)
				$texte = StringReplace($texte,"{2}",$val2,0,2)
				$texte = StringReplace($texte,"{3}",$val3,0,2)
			EndIf
			Return $texte
		ElseIf $compare < 0 Then ; $clef < $resources[$i][0] => Partie gauche
			$end = $i-1
		ElseIf $compare > 0 Then ; $resources[$i][0] < $clef => Partie droite
			$start = $i+1
		EndIf
	WEnd
	Return " "
EndFunc

Func orderInternationalisationResources(ByRef $resources)
	Local $size = UBound($resources)
	If $size > 1 Then internationalisationQuickSort($resources)
EndFunc

Func internationalisationQuickSort(ByRef $array, $start="", $end="")
	; Initialisation
	If Not (IsInt($start) And IsInt($end)) Then
		$start = 1
		$end = UBound($array)-1
	EndIf
	If $end > $start Then
		Local $start2=$start, $end2=$end, $middle = Int(($start2+$end2)/2), $pivot = $array[$middle][0]
		Do
			While (StringCompare($array[$start2][0], $pivot) < 0)
				$start2 += 1
			WEnd
			While (StringCompare($array[$end2][0], $pivot) > 0)
				$end2 -= 1
			WEnd
			If $start2 <= $end2 Then
				For $i = 0 To UBound($array, 2) - 1
					Local $temp = $array[$start2][$i]
					$array[$start2][$i] = $array[$end2][$i]
					$array[$end2][$i] = $temp
				Next
				$start2 += 1
				$end2 -= 1
			EndIf
		Until $start2 > $end2
		; Appel rcursif
		internationalisationQuickSort($array, $start, $end2)
		internationalisationQuickSort($array, $start2, $end)
	EndIf
EndFunc

;~ Func getInternationalisationText($resources, $clef, $val0="", $val1="", $val2="", $val3="")
;~ 	For $i = 1 To $resources[0][0]
;~ 		If $resources[$i][0] = $clef Then
;~ 			Local $texte = StringReplace($resources[$i][1],"\n",@CRLF,0,2)
;~ 			If StringRegExp($texte,"\{[0123]\}") Then
;~ 				$texte = StringReplace($texte,"{0}",$val0,0,2)
;~ 				$texte = StringReplace($texte,"{1}",$val1,0,2)
;~ 				$texte = StringReplace($texte,"{2}",$val2,0,2)
;~ 				$texte = StringReplace($texte,"{3}",$val3,0,2)
;~ 			EndIf
;~ 			Return $texte
;~ 		EndIf
;~ 	Next
;~ 	Return " "
;~ EndFunc