#Include-Once

#Region #Include <Array.au3>
;~ #Include <Array.au3>
#EndRegion

#Region #Include <ButtonConstants.au3>
Global Const $BS_BITMAP = 0x0080
#EndRegion

#Region #Include <Constants.au3>
;~ #Include <Constants.au3>
#EndRegion

#Region #Include <Crypt.au3>
;~ #Include <Crypt.au3>
#EndRegion

#Region #Include <Date.au3>
Func _DateAdd($sType, $iValToAdd, $sDate)
	Local $asTimePart[4], $asDatePart[4], $iJulianDate
	$sType = StringLeft($sType, 1)
	If StringInStr("D,M,Y,w,h,n,s", $sType) = 0 Or $sType = "" Then
		Return SetError(1,0,0)
	EndIf
	If Not StringIsInt($iValToAdd) Then
		Return SetError(2,0,0)
	EndIf
	If Not _DateIsValid($sDate) Then
		Return SetError(3,0,0)
	EndIf
	_DateTimeSplit($sDate, $asDatePart, $asTimePart)
	If $sType = "d" Or $sType = "w" Then
		If $sType = "w" Then $iValToAdd = $iValToAdd * 7
		$iJulianDate = _DateToDayValue($asDatePart[1], $asDatePart[2], $asDatePart[3]) + $iValToAdd
		_DayValueToDate($iJulianDate, $asDatePart[1], $asDatePart[2], $asDatePart[3])
	EndIf
	If $sType = "m" Then
		$asDatePart[2] = $asDatePart[2] + $iValToAdd
		While $asDatePart[2] > 12
			$asDatePart[2] = $asDatePart[2] - 12
			$asDatePart[1] = $asDatePart[1] + 1
		WEnd
		While $asDatePart[2] < 1
			$asDatePart[2] = $asDatePart[2] + 12
			$asDatePart[1] = $asDatePart[1] - 1
		WEnd
	EndIf
	If $sType = "y" Then
		$asDatePart[1] = $asDatePart[1] + $iValToAdd
	EndIf
	If $sType = "h" Or $sType = "n" Or $sType = "s" Then
		Local $iTimeVal = _TimeToTicks($asTimePart[1], $asTimePart[2], $asTimePart[3]) / 1000
		If $sType = "h" Then $iTimeVal = $iTimeVal + $iValToAdd * 3600
		If $sType = "n" Then $iTimeVal = $iTimeVal + $iValToAdd * 60
		If $sType = "s" Then $iTimeVal = $iTimeVal + $iValToAdd
		Local $Day2Add = Int($iTimeVal / (24 * 60 * 60))
		$iTimeVal = $iTimeVal - $Day2Add * 24 * 60 * 60
		If $iTimeVal < 0 Then
			$Day2Add = $Day2Add - 1
			$iTimeVal = $iTimeVal + 24 * 60 * 60
		EndIf
		$iJulianDate = _DateToDayValue($asDatePart[1], $asDatePart[2], $asDatePart[3]) + $Day2Add
		_DayValueToDate($iJulianDate, $asDatePart[1], $asDatePart[2], $asDatePart[3])
		_TicksToTime($iTimeVal * 1000, $asTimePart[1], $asTimePart[2], $asTimePart[3])
	EndIf
	Local $iNumDays = _DaysInMonth($asDatePart[1])
	If $iNumDays[$asDatePart[2]] < $asDatePart[3] Then $asDatePart[3] = $iNumDays[$asDatePart[2]]
	$sDate = $asDatePart[1] & '/' & StringRight("0" & $asDatePart[2], 2) & '/' & StringRight("0" & $asDatePart[3], 2)
	If $asTimePart[0] > 0 Then
		If $asTimePart[0] > 2 Then
			$sDate = $sDate & " " & StringRight("0" & $asTimePart[1], 2) & ':' & StringRight("0" & $asTimePart[2], 2) & ':' & StringRight("0" & $asTimePart[3], 2)
		Else
			$sDate = $sDate & " " & StringRight("0" & $asTimePart[1], 2) & ':' & StringRight("0" & $asTimePart[2], 2)
		EndIf
	EndIf
	Return ($sDate)
EndFunc
Func _DateDiff($sType, $sStartDate, $sEndDate)
	$sType = StringLeft($sType, 1)
	If StringInStr("d,m,y,w,h,n,s", $sType) = 0 Or $sType = "" Then
		Return SetError(1,0,0)
	EndIf
	If Not _DateIsValid($sStartDate) Then
		Return SetError(2,0,0)
	EndIf
	If Not _DateIsValid($sEndDate) Then
		Return SetError(3,0,0)
	EndIf
	Local $asStartDatePart[4], $asStartTimePart[4], $asEndDatePart[4], $asEndTimePart[4]
	_DateTimeSplit($sStartDate, $asStartDatePart, $asStartTimePart)
	_DateTimeSplit($sEndDate, $asEndDatePart, $asEndTimePart)
	Local $aDaysDiff = _DateToDayValue($asEndDatePart[1], $asEndDatePart[2], $asEndDatePart[3]) - _DateToDayValue($asStartDatePart[1], $asStartDatePart[2], $asStartDatePart[3])
	Local $iTimeDiff, $iYearDiff, $iStartTimeInSecs, $iEndTimeInSecs
	If $asStartTimePart[0] > 1 And $asEndTimePart[0] > 1 Then
		$iStartTimeInSecs = $asStartTimePart[1] * 3600 + $asStartTimePart[2] * 60 + $asStartTimePart[3]
		$iEndTimeInSecs = $asEndTimePart[1] * 3600 + $asEndTimePart[2] * 60 + $asEndTimePart[3]
		$iTimeDiff = $iEndTimeInSecs - $iStartTimeInSecs
		If $iTimeDiff < 0 Then
			$aDaysDiff = $aDaysDiff - 1
			$iTimeDiff = $iTimeDiff + 24 * 60 * 60
		EndIf
	Else
		$iTimeDiff = 0
	EndIf
	Select
		Case $sType = "d"
			Return ($aDaysDiff)
		Case $sType = "m"
			$iYearDiff = $asEndDatePart[1] - $asStartDatePart[1]
			Local $iMonthDiff = $asEndDatePart[2] - $asStartDatePart[2] + $iYearDiff * 12
			If $asEndDatePart[3] < $asStartDatePart[3] Then $iMonthDiff = $iMonthDiff - 1
			$iStartTimeInSecs = $asStartTimePart[1] * 3600 + $asStartTimePart[2] * 60 + $asStartTimePart[3]
			$iEndTimeInSecs = $asEndTimePart[1] * 3600 + $asEndTimePart[2] * 60 + $asEndTimePart[3]
			$iTimeDiff = $iEndTimeInSecs - $iStartTimeInSecs
			If $asEndDatePart[3] = $asStartDatePart[3] And $iTimeDiff < 0 Then $iMonthDiff = $iMonthDiff - 1
			Return ($iMonthDiff)
		Case $sType = "y"
			$iYearDiff = $asEndDatePart[1] - $asStartDatePart[1]
			If $asEndDatePart[2] < $asStartDatePart[2] Then $iYearDiff = $iYearDiff - 1
			If $asEndDatePart[2] = $asStartDatePart[2] And $asEndDatePart[3] < $asStartDatePart[3] Then $iYearDiff = $iYearDiff - 1
			$iStartTimeInSecs = $asStartTimePart[1] * 3600 + $asStartTimePart[2] * 60 + $asStartTimePart[3]
			$iEndTimeInSecs = $asEndTimePart[1] * 3600 + $asEndTimePart[2] * 60 + $asEndTimePart[3]
			$iTimeDiff = $iEndTimeInSecs - $iStartTimeInSecs
			If $asEndDatePart[2] = $asStartDatePart[2] And $asEndDatePart[3] = $asStartDatePart[3] And $iTimeDiff < 0 Then $iYearDiff = $iYearDiff - 1
			Return ($iYearDiff)
		Case $sType = "w"
			Return (Int($aDaysDiff / 7))
		Case $sType = "h"
			Return ($aDaysDiff * 24 + Int($iTimeDiff / 3600))
		Case $sType = "n"
			Return ($aDaysDiff * 24 * 60 + Int($iTimeDiff / 60))
		Case $sType = "s"
			Return ($aDaysDiff * 24 * 60 * 60 + $iTimeDiff)
	EndSelect
EndFunc
Func _DateIsValid($sDate)
	Local $asDatePart[4], $asTimePart[4]
	Local $sDateTime = StringSplit($sDate, " T")
	If $sDateTime[0] > 0 Then $asDatePart = StringSplit($sDateTime[1], "/-.")
	If UBound($asDatePart) <> 4 Then Return (0)
	If $asDatePart[0] <> 3 Then Return (0)
	If Not StringIsInt($asDatePart[1]) Then Return (0)
	If Not StringIsInt($asDatePart[2]) Then Return (0)
	If Not StringIsInt($asDatePart[3]) Then Return (0)
	$asDatePart[1] = Number($asDatePart[1])
	$asDatePart[2] = Number($asDatePart[2])
	$asDatePart[3] = Number($asDatePart[3])
	Local $iNumDays = _DaysInMonth($asDatePart[1])
	If $asDatePart[1] < 1000 Or $asDatePart[1] > 2999 Then Return (0)
	If $asDatePart[2] < 1 Or $asDatePart[2] > 12 Then Return (0)
	If $asDatePart[3] < 1 Or $asDatePart[3] > $iNumDays[$asDatePart[2]] Then Return (0)
	If $sDateTime[0] > 1 Then
		$asTimePart = StringSplit($sDateTime[2], ":")
		If UBound($asTimePart) < 4 Then ReDim $asTimePart[4]
	Else
		Dim $asTimePart[4]
	EndIf
	If $asTimePart[0] < 1 Then Return (1)
	If $asTimePart[0] < 2 Then Return (0)
	If $asTimePart[0] = 2 Then $asTimePart[3] = "00"
	If Not StringIsInt($asTimePart[1]) Then Return (0)
	If Not StringIsInt($asTimePart[2]) Then Return (0)
	If Not StringIsInt($asTimePart[3]) Then Return (0)
	$asTimePart[1] = Number($asTimePart[1])
	$asTimePart[2] = Number($asTimePart[2])
	$asTimePart[3] = Number($asTimePart[3])
	If $asTimePart[1] < 0 Or $asTimePart[1] > 23 Then Return (0)
	If $asTimePart[2] < 0 Or $asTimePart[2] > 59 Then Return (0)
	If $asTimePart[3] < 0 Or $asTimePart[3] > 59 Then Return (0)
	Return 1
EndFunc
Func _DateTimeSplit($sDate, ByRef $asDatePart, ByRef $iTimePart)
	Local $sDateTime = StringSplit($sDate, " T")
	If $sDateTime[0] > 0 Then $asDatePart = StringSplit($sDateTime[1], "/-.")
	If $sDateTime[0] > 1 Then
		$iTimePart = StringSplit($sDateTime[2], ":")
		If UBound($iTimePart) < 4 Then ReDim $iTimePart[4]
	Else
		Dim $iTimePart[4]
	EndIf
	If UBound($asDatePart) < 4 Then ReDim $asDatePart[4]
	For $x = 1 To 3
		If StringIsInt($asDatePart[$x]) Then
			$asDatePart[$x] = Number($asDatePart[$x])
		Else
			$asDatePart[$x] = -1
		EndIf
		If StringIsInt($iTimePart[$x]) Then
			$iTimePart[$x] = Number($iTimePart[$x])
		Else
			$iTimePart[$x] = 0
		EndIf
	Next
	Return 1
EndFunc
Func _DateToDayValue($iYear, $iMonth, $iDay)
	If Not _DateIsValid(StringFormat("%04d/%02d/%02d", $iYear, $iMonth, $iDay)) Then Return SetError(1,0,"")
	If $iMonth < 3 Then
		$iMonth = $iMonth + 12
		$iYear = $iYear - 1
	EndIf
	Local $i_aFactor = Int($iYear / 100)
	Local $i_bFactor = Int($i_aFactor / 4)
	Local $i_cFactor = 2 - $i_aFactor + $i_bFactor
	Local $i_eFactor = Int(1461 * ($iYear + 4716) / 4)
	Local $i_fFactor = Int(153 * ($iMonth + 1) / 5)
	Local $iJulianDate = $i_cFactor + $iDay + $i_eFactor + $i_fFactor - 1524.5
	Return ($iJulianDate)
EndFunc
Func _DayValueToDate($iJulianDate, ByRef $iYear, ByRef $iMonth, ByRef $iDay)
	If $iJulianDate < 0 Or Not IsNumber($iJulianDate) Then
		Return SetError(1,0,0)
	EndIf
	Local $i_zFactor = Int($iJulianDate + 0.5)
	Local $i_wFactor = Int(($i_zFactor - 1867216.25) / 36524.25)
	Local $i_xFactor = Int($i_wFactor / 4)
	Local $i_aFactor = $i_zFactor + 1 + $i_wFactor - $i_xFactor
	Local $i_bFactor = $i_aFactor + 1524
	Local $i_cFactor = Int(($i_bFactor - 122.1) / 365.25)
	Local $i_dFactor = Int(365.25 * $i_cFactor)
	Local $i_eFactor = Int(($i_bFactor - $i_dFactor) / 30.6001)
	Local $i_fFactor = Int(30.6001 * $i_eFactor)
	$iDay = $i_bFactor - $i_dFactor - $i_fFactor
	If $i_eFactor - 1 < 13 Then
		$iMonth = $i_eFactor - 1
	Else
		$iMonth = $i_eFactor - 13
	EndIf
	If $iMonth < 3 Then
		$iYear = $i_cFactor - 4715
	Else
		$iYear = $i_cFactor - 4716
	EndIf
	$iYear = StringFormat("%04d", $iYear)
	$iMonth = StringFormat("%02d", $iMonth)
	$iDay = StringFormat("%02d", $iDay)
	Return $iYear & "/" & $iMonth & "/" & $iDay
EndFunc
Func _TimeToTicks($iHours = @HOUR, $iMins = @MIN, $iSecs = @SEC)
	If StringIsInt($iHours) And StringIsInt($iMins) And StringIsInt($iSecs) Then
		Local $iTicks = 1000 * ((3600 * $iHours) + (60 * $iMins) + $iSecs)
		Return $iTicks
	Else
		Return SetError(1,0,0)
	EndIf
EndFunc
Func _TicksToTime($iTicks, ByRef $iHours, ByRef $iMins, ByRef $iSecs)
	If Number($iTicks) > 0 Then
		$iTicks = Int($iTicks / 1000)
		$iHours = Int($iTicks / 3600)
		$iTicks = Mod($iTicks, 3600)
		$iMins = Int($iTicks / 60)
		$iSecs = Mod($iTicks, 60)
		Return 1
	ElseIf Number($iTicks) = 0 Then
		$iHours = 0
		$iTicks = 0
		$iMins = 0
		$iSecs = 0
		Return 1
	Else
		Return SetError(1,0,0)
	EndIf
EndFunc
Func _DaysInMonth($iYear)
	Local $aiDays[13] = [ 0, 31,28,31,30,31,30,31,31,30,31,30,31]
	If _DateIsLeapYear($iYear) Then $aiDays[2] = 29
	Return $aiDays
EndFunc
Func _DateIsLeapYear($iYear)
	If Not StringIsInt($iYear) Then	Return SetError(1,0,0)
	If Mod($iYear, 4) = 0 And Mod($iYear, 100) <> 0 Then Return 1
	If Mod($iYear, 400) = 0 Then Return 1
	Return 0
EndFunc
Func _NowCalc()
	Return @YEAR&"/"&@MON&"/"&@MDAY&" "&@HOUR&":"&@MIN&":"&@SEC
EndFunc
Func _DateToDayOfWeek($iYear, $iMonth, $iDay)
	If Not _DateIsValid($iYear & "/" & $iMonth & "/" & $iDay) Then
		Return SetError(1,0,"")
	EndIf
	Local $i_aFactor = Int((14 - $iMonth) / 12)
	Local $i_yFactor = $iYear - $i_aFactor
	Local $i_mFactor = $iMonth + (12 * $i_aFactor) - 2
	Local $i_dFactor = Mod($iDay + $i_yFactor + Int($i_yFactor / 4) - Int($i_yFactor / 100) + Int($i_yFactor / 400) + Int((31 * $i_mFactor) / 12), 7)
	Return ($i_dFactor + 1)
EndFunc
Func _DateToDayOfWeekISO($iYear, $iMonth, $iDay)
	Local $idow = _DateToDayOfWeek($iYear, $iMonth, $iDay)
	If @error Then
		Return SetError(1,0,"")
	EndIf
	If $idow >= 2 Then Return $idow - 1
	Return 7
EndFunc
#EndRegion

#Region #Include <File.au3>
Func _FileListToArray($sPath, $sFilter = "*", $iFlag = 0)
	Local $hSearch, $sFile, $sFileList, $sDelim = "|"
	$sPath = StringRegExpReplace($sPath, "[\\/]+\z", "") & "\"
	If Not FileExists($sPath) Then Return SetError(1, 1, "")
	If StringRegExp($sFilter, "[\\/:><\|]|(?s)\A\s*\z") Then Return SetError(2, 2, "")
	If Not ($iFlag = 0 Or $iFlag = 1 Or $iFlag = 2) Then Return SetError(3, 3, "")
	$hSearch = FileFindFirstFile($sPath & $sFilter)
	If @error Then Return SetError(4, 4, "")
	While 1
		$sFile = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		If ($iFlag + @extended = 2) Then ContinueLoop
		$sFileList &= $sDelim & $sFile
	WEnd
	FileClose($hSearch)
	If Not $sFileList Then Return SetError(4, 4, "")
	Return StringSplit(StringTrimLeft($sFileList, 1), "|")
EndFunc
#EndRegion

#Region #Include <GDIPlus.au3>
;~ #Include <GDIPlus.au3>
#EndRegion


#Region #Include <GuiComboBoxEx.au3>
;~ #Include <GuiComboBoxEx.au3>
#EndRegion

#Region #Include <GuiConstants.au3>
;~ #Include <GuiConstants.au3>
#EndRegion

#Region #Include <GUIConstantsEx.au3>
Global Const $GUI_EVENT_CLOSE = -3
Global Const $GUI_EVENT_PRIMARYDOWN = -7
Global Const $GUI_EVENT_PRIMARYUP = -8
Global Const $GUI_EVENT_SECONDARYDOWN = -9
Global Const $GUI_WS_EX_PARENTDRAG = 0x00100000
Global Const $GUI_DROPACCEPTED = 8
Global Const $GUI_CHECKED = 1
Global Const $GUI_INDETERMINATE = 2
Global Const $GUI_UNCHECKED = 4
Global Const $GUI_SHOW = 16
Global Const $GUI_HIDE = 32
Global Const $GUI_ENABLE = 64
Global Const $GUI_DISABLE = 128
Global Const $GUI_FOCUS = 256
Global Const $GUI_DEFBUTTON = 512
Global Const $GUI_ONTOP = 2048
Global Const $GUI_BKCOLOR_TRANSPARENT = -2
Global Const $GUI_BKCOLOR_LV_ALTERNATE = 0xFE000000
#EndRegion

#Region #Include <GUIDateTimePicker.au3>
;~ #Include <GUIDateTimePicker.au3>
#EndRegion

#Region #Include <GuiEdit.au3>
;~ #Include <GuiEdit.au3>
#EndRegion

#Region #Include <GUIListView.au3>
Func _GUICtrlListView_GetItemSelected($hWnd, $iIndex)
	Return _GUICtrlListView_GetItemState($hWnd, $iIndex, 0x0002) <> 0
EndFunc
Func _GUICtrlListView_GetItemState($hWnd, $iIndex, $iMask)
	If IsHWnd($hWnd) Then
		Return _SendMessage($hWnd, (0x1000 + 44), $iIndex, $iMask)
	Else
		Return GUICtrlSendMsg($hWnd, (0x1000 + 44), $iIndex, $iMask)
	EndIf
EndFunc
Func _GUICtrlListView_SetItemSelected($hWnd, $iIndex, $fSelected = True, $fFocused = False)
	Local $tstruct = DllStructCreate("uint Mask;int Item;int SubItem;uint State;uint StateMask;ptr Text;int TextMax;int Image;lparam Param;int Indent;int GroupID;uint Columns;ptr pColumns")
	Local $pItem = DllStructGetPtr($tstruct)
	Local $iRet, $iSelected = 0, $iFocused = 0, $iSize, $tMemMap, $pMemory
	If ($fSelected = True) Then $iSelected = 0x0002
	If ($fFocused = True And $iIndex <> -1) Then $iFocused = 0x0001
	DllStructSetData($tstruct, "Mask", 0x00000008)
	DllStructSetData($tstruct, "Item", $iIndex)
	DllStructSetData($tstruct, "State", BitOR($iSelected, $iFocused))
	DllStructSetData($tstruct, "StateMask", BitOR(0x0002, $iFocused))
	$iSize = DllStructGetSize($tstruct)
	If IsHWnd($hWnd) Then
		$pMemory = _MemInit($hWnd, $iSize, $tMemMap)
		_MemWrite($tMemMap, $pItem, $pMemory, $iSize)
		$iRet = _SendMessage($hWnd, (0x1000 + 43), $iIndex, $pMemory)
		_MemFree($tMemMap)
	Else
		$iRet = GUICtrlSendMsg($hWnd, (0x1000 + 43), $iIndex, $pItem)
	EndIf
	Return $iRet <> 0
EndFunc
Func _GUICtrlListView_SetColumnWidth($hWnd, $iCol, $iWidth)
	If IsHWnd($hWnd) Then
		Return _SendMessage($hWnd, (0x1000 + 30), $iCol, $iWidth)
	Else
		Return GUICtrlSendMsg($hWnd, (0x1000 + 30), $iCol, $iWidth)
	EndIf
EndFunc
#EndRegion

#Region #Include <GUIMenu.au3>
;~ #Include <GUIMenu.au3>
#EndRegion

#Region #Include <GuiToolBar.au3>
Global $gh_TBLastWnd
Func _GUICtrlToolbar_ButtonCount($hWnd)
	Return _SendMessage($hWnd, 0x400+24)
EndFunc
Func _GUICtrlToolbar_IndexToCommand($hWnd, $iIndex)
	Local $tButton = DllStructCreate("int Bitmap;int Command;byte State;byte Style;align;dword_ptr Param;int_ptr String")
	Local $pButton = DllStructGetPtr($tButton)
	If _WinAPI_InProcess($hWnd, $gh_TBLastWnd) Then
		_SendMessage($hWnd, 0x400+23, $iIndex, $pButton, 0, "wparam", "ptr")
	Else
		Local $iButton = DllStructGetSize($tButton)
		Local $tMemMap
		Local $pMemory = _MemInit($hWnd, $iButton, $tMemMap)
		_MemWrite($tMemMap, $pButton, $pMemory, $iButton)
		_SendMessage($hWnd, 0x400+23, $iIndex, $pMemory, 0, "wparam", "ptr")
		_MemRead($tMemMap, $pMemory, $pButton, $iButton)
		_MemFree($tMemMap)
	EndIf
	Return DllStructGetData($tButton, "Command")
EndFunc
Func _GUICtrlToolbar_GetButtonState($hWnd, $iCommandID)
	Return _SendMessage($hWnd, 0x400+18, $iCommandID)
EndFunc
Func _GUICtrlToolbar_GetButtonText($hWnd, $iCommandID)
	Local $fUnicode = _GUICtrlToolbar_GetUnicodeFormat($hWnd)
	Local $iBuffer
	If $fUnicode Then
		$iBuffer = _SendMessage($hWnd, 0x400+75, $iCommandID)
	Else
		$iBuffer = _SendMessage($hWnd, 0x400+45, $iCommandID)
	EndIf
	If $iBuffer = 0 Then Return SetError(True, 0, "")
	If $iBuffer = 1 Then Return SetError(False, 0, "")
	If $iBuffer <= -1 Then Return SetError(False, -1, "")
	$iBuffer += 1
	Local $tBuffer
	If $fUnicode Then
		$tBuffer = DllStructCreate("wchar Text[" & $iBuffer & "]")
		$iBuffer *= 2
	Else
		$tBuffer = DllStructCreate("char Text[" & $iBuffer & "]")
	EndIf
	Local $pBuffer = DllStructGetPtr($tBuffer)
	Local $iRet
	If _WinAPI_InProcess($hWnd, $gh_TBLastWnd) Then
		$iRet = _SendMessage($hWnd, 0x400+75, $iCommandID, $pBuffer, 0, "wparam", "ptr")
	Else
		Local $tMemMap
		Local $pMemory = _MemInit($hWnd, $iBuffer, $tMemMap)
		If $fUnicode Then
			$iRet = _SendMessage($hWnd, 0x400+75, $iCommandID, $pMemory, 0, "wparam", "ptr")
		Else
			$iRet = _SendMessage($hWnd, 0x400+45, $iCommandID, $pMemory, 0, "wparam", "ptr")
		EndIf
		_MemRead($tMemMap, $pMemory, $pBuffer, $iBuffer)
		_MemFree($tMemMap)
	EndIf
	Return SetError($iRet > 0, 0, DllStructGetData($tBuffer, "Text"))
EndFunc
Func _GUICtrlToolbar_GetUnicodeFormat($hWnd)
	Return _SendMessage($hWnd, 0x2006) <> 0
EndFunc   ;==>_GUICtrlToolbar_GetUnicodeFormat
#EndRegion

#Region #Include <IE.au3>
;~ #Include <IE.au3>
#EndRegion

#Region #Include <ListboxConstants>
;~ #Include <ListboxConstants>
#EndRegion

#Region #Include <ListviewConstants.au3>
;~ #Include <ListviewConstants.au3>
#EndRegion

#Region #Include <Math.au3>
Func _Min($a, $b)
	If $a < $b Then Return $a
	Return $b
EndFunc
Func _Max($a, $b)
	If $a > $b Then Return $a
	Return $b
EndFunc
#EndRegion

#Region #Include <Memory.au3>
Func _MemRead(ByRef $tMemMap, $pSrce, $pDest, $iSize)
	Local $aResult = DllCall("kernel32.dll", "bool", "ReadProcessMemory", "handle", DllStructGetData($tMemMap, "hProc"), _
		"ptr", $pSrce, "ptr", $pDest, "ulong_ptr", $iSize, "ulong_ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc
Func _MemWrite(ByRef $tMemMap, $pSrce, $pDest = 0, $iSize = 0, $sSrce = "ptr")
	If $pDest = 0 Then $pDest = DllStructGetData($tMemMap, "Mem")
	If $iSize = 0 Then $iSize = DllStructGetData($tMemMap, "Size")
	Local $aResult = DllCall("kernel32.dll", "bool", "WriteProcessMemory", "handle", DllStructGetData($tMemMap, "hProc"), _
			"ptr", $pDest, $sSrce, $pSrce, "ulong_ptr", $iSize, "ulong_ptr*", 0)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc
Func _MemInit($hWnd, $iSize, ByRef $tMemMap)
	Local $aResult = DllCall("User32.dll", "dword", "GetWindowThreadProcessId", "hwnd", $hWnd, "dword*", 0)
	If @error Then Return SetError(@error, @extended, 0)
	Local $iProcessID = $aResult[2]
	If $iProcessID = 0 Then Return SetError(1, 0, 0)
	Local $hProcess = __Mem_OpenProcess(0x00000038, False, $iProcessID, True)
	Local $pMemory = _MemVirtualAllocEx($hProcess, 0, $iSize, 0x00003000, 0x00000004)
	If $pMemory = 0 Then Return SetError(2, 0, 0)
	$tMemMap = DllStructCreate("handle hProc;ulong_ptr Size;ptr Mem")
	DllStructSetData($tMemMap, "hProc", $hProcess)
	DllStructSetData($tMemMap, "Size", $iSize)
	DllStructSetData($tMemMap, "Mem", $pMemory)
	Return $pMemory
EndFunc
Func _MemFree(ByRef $tMemMap)
	Local $pMemory = DllStructGetData($tMemMap, "Mem")
	Local $hProcess = DllStructGetData($tMemMap, "hProc")
	Local $bResult = _MemVirtualFreeEx($hProcess, $pMemory, 0, 0x00008000)
	DllCall("kernel32.dll", "bool", "CloseHandle", "handle", $hProcess)
	If @error Then Return SetError(@error, @extended, False)
	Return $bResult
EndFunc
Func __Mem_OpenProcess($iAccess, $fInherit, $iProcessID, $fDebugPriv=False)
	Local $aResult = DllCall("kernel32.dll", "handle", "OpenProcess", "dword", $iAccess, "bool", $fInherit, "dword", $iProcessID)
	If @error Then Return SetError(@error, @extended, 0)
	If $aResult[0] Then Return $aResult[0]
	If Not $fDebugPriv Then Return 0
	Local $hToken = _Security__OpenThreadTokenEx(0x00000028)
	If @error Then Return SetError(@error, @extended, 0)
	_Security__SetPrivilege($hToken, "SeDebugPrivilege", True)
	Local $iError = @error
	Local $iLastError = @extended
	Local $iRet = 0
	If Not @error Then
		$aResult = DllCall("kernel32.dll", "handle", "OpenProcess", "dword", $iAccess, "bool", $fInherit, "dword", $iProcessID)
		$iError = @error
		$iLastError = @extended
		If $aResult[0] Then $iRet = $aResult[0]
		_Security__SetPrivilege($hToken, "SeDebugPrivilege", False)
		If @error Then
			$iError = @error
			$iLastError = @extended
		EndIf
	EndIf
	DllCall("kernel32.dll", "bool", "CloseHandle", "handle", $hToken)
	Return SetError($iError,  $iLastError, $iRet)
EndFunc
Func _MemVirtualAllocEx($hProcess, $pAddress, $iSize, $iAllocation, $iProtect)
	Local $aResult = DllCall("kernel32.dll", "ptr", "VirtualAllocEx", "handle", $hProcess, "ptr", $pAddress, "ulong_ptr", $iSize, "dword", $iAllocation, "dword", $iProtect)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc
Func _MemVirtualFreeEx($hProcess, $pAddress, $iSize, $iFreeType)
	Local $aResult = DllCall("kernel32.dll", "bool", "VirtualFreeEx", "handle", $hProcess, "ptr", $pAddress, "ulong_ptr", $iSize, "dword", $iFreeType)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc
#EndRegion

#Region #Include <Misc.au3>
Func _MouseTrap($l=0, $t=0, $r=0, $b=0)
	If @NumParams == 0 Then
		Local $resultat = DllCall("user32.dll", "bool", "ClipCursor", "ptr", 0)
		If @error Or Not $resultat[0] Then Return SetError(1, _WinAPI_GetLastError(), False)
	Else
		If @NumParams == 2 Then
			$r = $l + 1
			$b = $t + 1
		EndIf
		Local $c = DllStructCreate("long l;long t;long r;long b")
		DllStructSetData($c, "l", $l)
		DllStructSetData($c, "t", $t)
		DllStructSetData($c, "r", $r)
		DllStructSetData($c, "b", $b)
		Local $resultat = DllCall("user32.dll", "bool", "ClipCursor", "ptr", DllStructGetPtr($c))
		If @error Or Not $resultat[0] Then Return SetError(2, _WinAPI_GetLastError(), False)
	EndIf
	Return True
EndFunc
Func _Singleton($nom)
	Local $resultat = DllCall("kernel32.dll", "handle", "CreateMutexW", "ptr", 0, "bool", 1, "wstr", $nom)
	If @error Then Return SetError(@error, @extended, 0)
	Local $error = DllCall("kernel32.dll", "dword", "GetLastError")
	If @error Then Return SetError(@error, @extended, 0)
	If $error[0] = 183 Then Return SetError($error[0], $error[0], 0)
	Return $resultat[0]
EndFunc
Func _IsPressed($key, $dll = 'user32.dll')
	Local $resultat = DllCall($dll, "short", "GetAsyncKeyState", "int", '0x' & $key)
	If @error Then Return SetError(@error, @extended, False)
	Return BitAND($resultat[0], 0x8000) <> 0
EndFunc
#EndRegion

#Region #Include <ScreenCapture.au3>
#Include <ScreenCapture.au3>
#EndRegion

#Region #Include <SendMessage.au3>
;~ Func _SendMessage($hWnd, $iMsg, $wParam = 0, $lParam = 0, $iReturn = 0, $wParamType = "wparam", $lParamType = "lparam", $sReturnType = "lresult")
;~ 	Local $aResult = DllCall("user32.dll", $sReturnType, "SendMessageW", "hwnd", $hWnd, "uint", $iMsg, $wParamType, $wParam, $lParamType, $lParam)
;~ 	If @error Then Return SetError(@error, @extended, "")
;~ 	If $iReturn >= 0 And $iReturn <= 4 Then Return $aResult[$iReturn]
;~ 	Return $aResult
;~ EndFunc
#EndRegion
#Region #Include <Sound.au3>
;~ #Include <Sound.au3>
#EndRegion

#Region #Include <StaticConstants.au3>
;~ #Include <StaticConstants.au3>
#EndRegion

#Region #Include <String.au3>
Func _HexToString($strHex)
	If StringLeft($strHex, 2) = "0x" Then Return BinaryToString($strHex)
	Return BinaryToString("0x" & $strHex)
EndFunc
Func _StringToHex($strChar)
	Return Hex(StringToBinary($strChar))
EndFunc
Func _StringBetween($s_String, $s_Start, $s_End, $v_Case = -1)
	Local $s_case = ""
	If $v_Case = Default Or $v_Case = -1 Then $s_case = "(?i)"
	Local $s_pattern_escape = "(\.|\||\*|\?|\+|\(|\)|\{|\}|\[|\]|\^|\$|\\)"
	$s_Start = StringRegExpReplace($s_Start, $s_pattern_escape, "\\$1")
	$s_End = StringRegExpReplace($s_End, $s_pattern_escape, "\\$1")
	If $s_Start = "" Then $s_Start = "\A"
	If $s_End = "" Then $s_End = "\z"
	Local $a_ret = StringRegExp($s_String, "(?s)" & $s_case & $s_Start & "(.*?)" & $s_End, 3)
	If @error Then Return SetError(1, 0, 0)
	Return $a_ret
EndFunc
#EndRegion

#Region #Include <TabConstants.au3>
;~ #Include <TabConstants.au3>
#EndRegion

#Region #Include <WinAPI.au3>
;~ #Include <WinAPI.au3>
#EndRegion

#Region #Include <WindowsConstants.au3>
Global Const $WS_BORDER = 0x00800000
Global Const $WS_POPUP = 0x80000000
Global Const $WS_EX_ACCEPTFILES = 0x00000010
Global Const $WS_EX_LAYERED = 0x00080000
Global Const $WS_EX_TOPMOST = 0x00000008
Global Const $DS_MODALFRAME = 0x00000080
Global Const $WM_MOUSEMOVE = 0x0200
Global Const $WM_LBUTTONDOWN = 0x0201
Global Const $WM_LBUTTONUP = 0x0202
Global Const $WM_LBUTTONDBLCLK = 0x0203
Global Const $WM_RBUTTONDOWN = 0x0204
Global Const $WM_RBUTTONUP = 0x0205
#EndRegion
