#Include-Once

#Include "ModernMenu\ModernMenuRaw.au3"

Global Const $colors_matrix[5][8] = [ [ 4 ] _ ; BkColor, IconBkColor, IconBkGrdColor, SelectBkColor, SelectRectColor, SelectTextColor, TextColor
	, [ "",  0xFFFFFF, 0xD1D8DB, 0xD1D8DB, 0xD2BDB6, 0x854240, 0x000000, 0x000000 ] _ ; Par dfaut
	, [ "1", 0xAADDFF, 0x5566BB, 0x5566BB, 0x70A0C0, 0x854240, 0x000000, 0x000000 ] _
	, [ "2", 0xE0FFE0, 0x66BB66, 0x66BB66, 0xBBCC88, 0x222277, 0x770000, 0x000000 ] _
	, [ "3", 0xFFE0E0, 0xBB8877, 0xBB8877, 0x662222, 0x4477AA, 0x66FFFF, 0x000000 ] _
]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Func GUICtrlCreateAdvancedMenuItem($texte, $menu)
	Return _GUICtrlCreateODMenuItem($texte, $menu)
EndFunc

Func GUICtrlCreateAdvancedMenu($texte, $menu)
	Return _GUICtrlCreateODMenu($texte, $menu)
EndFunc

Func GUICtrlAdvancedMenuItemSetText($menu, $texte)
	Return _GUICtrlODMenuItemSetText($menu, $texte)
EndFunc

Func GUICtrlAdvancedMenuItemGetText($menu)
	Return _GetMenuText($menu)
EndFunc

Func GUICtrlAdvancedMenuItemSetIcon($menu, $icone = "", $id = 0)
	Return _GUICtrlODMenuItemSetIcon($menu, $icone, $id)
EndFunc

Func GUICtrlAdvancedMenuItemSetSelIcon($menu, $icone = "", $id = 0)
	Return _GUICtrlODMenuItemSetSelIcon($menu, $icone, $id)
EndFunc

Func GUICtrlAdvancedDelete($id)
	Return _GUICtrlODMenuItemDelete($id)
EndFunc

Func GUICtrlAdvancedSetState($id, $state)
	Return GUICtrlSetState($id, $state)
EndFunc

Func GUICtrlAdvancedSetColors($colorId="")
	Local $i, $found = False
	For $i = 1 To $colors_matrix[0][0]
		If Not $found And $colorId = $colors_matrix[$i][0] Then
			_SetMenuBkColor($colors_matrix[$i][1])
			_SetMenuIconBkColor($colors_matrix[$i][2])
			_SetMenuIconBkGrdColor($colors_matrix[$i][3])
			_SetMenuSelectBkColor($colors_matrix[$i][4])
			_SetMenuSelectRectColor($colors_matrix[$i][5])
			_SetMenuSelectTextColor($colors_matrix[$i][6])
			_SetMenuTextColor($colors_matrix[$i][7])
			$found = True
		EndIf
	Next
	If Not $found And $colorId <> "" Then GUICtrlAdvancedSetColors()
EndFunc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Func TrayAdvancedCreate($text, $icon)
	Local $resultat = _TrayIconCreate($text, $icon)
	_TrayIconSetState($resultat)
	Return $resultat
EndFunc

Func TrayAdvancedDelete($id)
	Return _TrayIconDelete($id)
EndFunc

Func TrayAdvancedActivateContextMenu($tray)
	_TrayIconSetClick($tray, 16)
EndFunc

Func TrayAdvancedDesactivateContextMenu($tray)
	_TrayIconSetClick($tray, 0)
EndFunc

Func TrayAdvancedCreateContextMenu($tray)
	Local $resultat = _TrayCreateContextMenu($tray)
	Return $resultat
EndFunc

Func TrayAdvancedCreateMenu($texte, $menu)
	Local $resultat = _TrayCreateMenu($texte, $menu)
	TrayAdvancedItemSetIcon($resultat)
	Return $resultat
EndFunc

Func TrayAdvancedCreateItem($texte, $menu)
	Local $resultat = _TrayCreateItem($texte, $menu)
	TrayAdvancedItemSetIcon($resultat)
	Return $resultat
EndFunc

Func TrayAdvancedDeleteItem($id)
	Return _TrayDeleteItem($id)
EndFunc

Func TrayAdvancedItemSetState($id, $state)
	Return GUICtrlSetState($id, $state)
EndFunc

Func TrayAdvancedItemSetIcon($id, $icon = "", $iconId = 0)
	Return _TrayItemSetIcon($id, $icon, $iconId)
EndFunc

Func TrayAdvancedDisplayMessage($tray, $title = "", $message = "", $time = 10, $icone = 0)
	_TrayTip($tray, $title, $message, $time, $icone)
EndFunc

Func TrayAdvancedSetColors($colorId="")
	Local $i, $found = False
	For $i = 1 To $colors_matrix[0][0]
		If Not $found And $colorId = $colors_matrix[$i][0] Then
			_SetTrayBkColor($colors_matrix[$i][1])
			_SetTrayIconBkColor($colors_matrix[$i][2])
			_SetTrayIconBkGrdColor($colors_matrix[$i][3])
			_SetTraySelectBkColor($colors_matrix[$i][4])
			_SetTraySelectRectColor($colors_matrix[$i][5])
			_SetTraySelectTextColor($colors_matrix[$i][6])
			_SetTrayTextColor($colors_matrix[$i][7])
			$found = True
		EndIf
	Next
	If Not $found And $colorId <> "" Then TrayAdvancedSetColors()
EndFunc
