#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=..\Images\ZaDS-nAiO.ico
#AutoIt3Wrapper_outfile=AIO-Log.exe
#AutoIt3Wrapper_Res_Fileversion=1.1.0.1
#AutoIt3Wrapper_Res_Field=Nom (short)|Update
#AutoIt3Wrapper_Res_Field=Nom (long)|Update
#AutoIt3Wrapper_Res_Field=Version (short)|1.1.0.1
#AutoIt3Wrapper_Res_Field=Version (long)|1.1.0.1
#AutoIt3Wrapper_Res_Field=Description|Module de connexion
#AutoIt3Wrapper_Res_Field=Type|Connexion
#AutoIt3Wrapper_Res_Field=Auteur|Za [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Entte du module
Global Const _
	$MODULE_NOM = "AIO-Log", $MODULE_AUTEUR = "Za", $MODULE_VERSION = "1.1.0.1", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1), $CONNECT_MODE = ($cmdLine[0] >= 1 And $cmdLine[1] = "-connect")

#Region Librairies AutoIt
;~ #Include <GUIConstants.au3>	;Ncessaire pour les $GUI_EVENT
Global Const $GUI_EVENT_CLOSE  =   -3
Global Const $GUI_CHECKED      =    1
Global Const $GUI_UNCHECKED    =    4
Global Const $GUI_DROPACCEPTED =    8
Global Const $GUI_DISABLE      =  128
Global Const $GUI_FOCUS        =  256
Global Const $GUI_NOFOCUS      = 8192
;~ #Include <String.au3>	;Pour l'encryptage + conversion HexToString
Func _HexToString($strHex)
	If StringLeft($strHex, 2) = "0x" Then Return BinaryToString($strHex)
	Return BinaryToString("0x" & $strHex)
EndFunc
Func _StringEncrypt($i_Encrypt, $s_EncryptText, $s_EncryptPassword, $i_EncryptLevel = 1)
	If $i_Encrypt <> 0 And $i_Encrypt <> 1 Then
		SetError(1, 0, '')
	ElseIf $s_EncryptText = '' Or $s_EncryptPassword = '' Then
		SetError(1, 0, '')
	Else
		If Number($i_EncryptLevel) <= 0 Or Int($i_EncryptLevel) <> $i_EncryptLevel Then $i_EncryptLevel = 1
		Local $v_EncryptModified
		Local $i_EncryptCountH
		Local $i_EncryptCountG
		Local $v_EncryptSwap
		Local $av_EncryptBox[256][2]
		Local $i_EncryptCountA
		Local $i_EncryptCountB
		Local $i_EncryptCountC
		Local $i_EncryptCountD
		Local $i_EncryptCountE
		Local $v_EncryptCipher
		Local $v_EncryptCipherBy
		If $i_Encrypt = 1 Then
			For $i_EncryptCountF = 0 To $i_EncryptLevel Step 1
				$i_EncryptCountG = ''
				$i_EncryptCountH = ''
				$v_EncryptModified = ''
				For $i_EncryptCountG = 1 To StringLen($s_EncryptText)
					If $i_EncryptCountH = StringLen($s_EncryptPassword) Then
						$i_EncryptCountH = 1
					Else
						$i_EncryptCountH += 1
					EndIf
					$v_EncryptModified = $v_EncryptModified & Chr(BitXOR(Asc(StringMid($s_EncryptText, $i_EncryptCountG, 1)), Asc(StringMid($s_EncryptPassword, $i_EncryptCountH, 1)), 255))
				Next
				$s_EncryptText = $v_EncryptModified
				$i_EncryptCountA = ''
				$i_EncryptCountB = 0
				$i_EncryptCountC = ''
				$i_EncryptCountD = ''
				$i_EncryptCountE = ''
				$v_EncryptCipherBy = ''
				$v_EncryptCipher = ''
				$v_EncryptSwap = ''
				$av_EncryptBox = ''
				Local $av_EncryptBox[256][2]
				For $i_EncryptCountA = 0 To 255
					$av_EncryptBox[$i_EncryptCountA][1] = Asc(StringMid($s_EncryptPassword, Mod($i_EncryptCountA, StringLen($s_EncryptPassword)) + 1, 1))
					$av_EncryptBox[$i_EncryptCountA][0] = $i_EncryptCountA
				Next
				For $i_EncryptCountA = 0 To 255
					$i_EncryptCountB = Mod(($i_EncryptCountB + $av_EncryptBox[$i_EncryptCountA][0] + $av_EncryptBox[$i_EncryptCountA][1]), 256)
					$v_EncryptSwap = $av_EncryptBox[$i_EncryptCountA][0]
					$av_EncryptBox[$i_EncryptCountA][0] = $av_EncryptBox[$i_EncryptCountB][0]
					$av_EncryptBox[$i_EncryptCountB][0] = $v_EncryptSwap
				Next
				For $i_EncryptCountA = 1 To StringLen($s_EncryptText)
					$i_EncryptCountC = Mod(($i_EncryptCountC + 1), 256)
					$i_EncryptCountD = Mod(($i_EncryptCountD + $av_EncryptBox[$i_EncryptCountC][0]), 256)
					$i_EncryptCountE = $av_EncryptBox[Mod(($av_EncryptBox[$i_EncryptCountC][0] + $av_EncryptBox[$i_EncryptCountD][0]), 256)][0]
					$v_EncryptCipherBy = BitXOR(Asc(StringMid($s_EncryptText, $i_EncryptCountA, 1)), $i_EncryptCountE)
					$v_EncryptCipher &= Hex($v_EncryptCipherBy, 2)
				Next
				$s_EncryptText = $v_EncryptCipher
			Next
		Else
			For $i_EncryptCountF = 0 To $i_EncryptLevel Step 1
				$i_EncryptCountB = 0
				$i_EncryptCountC = ''
				$i_EncryptCountD = ''
				$i_EncryptCountE = ''
				$v_EncryptCipherBy = ''
				$v_EncryptCipher = ''
				$v_EncryptSwap = ''
				$av_EncryptBox = ''
				Local $av_EncryptBox[256][2]
				For $i_EncryptCountA = 0 To 255
					$av_EncryptBox[$i_EncryptCountA][1] = Asc(StringMid($s_EncryptPassword, Mod($i_EncryptCountA, StringLen($s_EncryptPassword)) + 1, 1))
					$av_EncryptBox[$i_EncryptCountA][0] = $i_EncryptCountA
				Next
				For $i_EncryptCountA = 0 To 255
					$i_EncryptCountB = Mod(($i_EncryptCountB + $av_EncryptBox[$i_EncryptCountA][0] + $av_EncryptBox[$i_EncryptCountA][1]), 256)
					$v_EncryptSwap = $av_EncryptBox[$i_EncryptCountA][0]
					$av_EncryptBox[$i_EncryptCountA][0] = $av_EncryptBox[$i_EncryptCountB][0]
					$av_EncryptBox[$i_EncryptCountB][0] = $v_EncryptSwap
				Next
				For $i_EncryptCountA = 1 To StringLen($s_EncryptText) Step 2
					$i_EncryptCountC = Mod(($i_EncryptCountC + 1), 256)
					$i_EncryptCountD = Mod(($i_EncryptCountD + $av_EncryptBox[$i_EncryptCountC][0]), 256)
					$i_EncryptCountE = $av_EncryptBox[Mod(($av_EncryptBox[$i_EncryptCountC][0] + $av_EncryptBox[$i_EncryptCountD][0]), 256)][0]
					$v_EncryptCipherBy = BitXOR(Dec(StringMid($s_EncryptText, $i_EncryptCountA, 2)), $i_EncryptCountE)
					$v_EncryptCipher = $v_EncryptCipher & Chr($v_EncryptCipherBy)
				Next
				$s_EncryptText = $v_EncryptCipher
				$i_EncryptCountG = ''
				$i_EncryptCountH = ''
				$v_EncryptModified = ''
				For $i_EncryptCountG = 1 To StringLen($s_EncryptText)
					If $i_EncryptCountH = StringLen($s_EncryptPassword) Then
						$i_EncryptCountH = 1
					Else
						$i_EncryptCountH += 1
					EndIf
					$v_EncryptModified &= Chr(BitXOR(Asc(StringMid($s_EncryptText, $i_EncryptCountG, 1)), Asc(StringMid($s_EncryptPassword, $i_EncryptCountH, 1)), 255))
				Next
				$s_EncryptText = $v_EncryptModified
			Next
		EndIf
		Return $s_EncryptText
	EndIf
EndFunc
#Include <Crypt.au3>	;Pour l'AES
#EndRegion

#Region =========================================Avant de commencer=========================================
;Ce script s'apelle le AIO-Log, il permet  l'utilisateur de se logguer de manire assiste
;au jeu ou  l'application choisie.
;Il ne contient aucun identifiant, et a t pens dans le sens de la scurit.
;Si une dfaillance tait dcouverte, veuillez la signaler au plus vite  l'adresse
; gweltaz27@hotmail.com , il s'agit de la bote ml de Za. ; ( la mienne ^^ )
;
;Les fonctions ragissent ainsi :
;Return	0	; signifie "rien  signaler" ( il s'agit bien de la valeur zro )
;Return	Valeur	; ( Valeur <> 0 ) signifie un retour quelconque ( paramtre normal ou/et erreur )
;
;Description :
;Quand le script est appel, la configuration est charge. Si des paramtres ont t ajouts en appel
;(lors des raccourcis, par exemple), ils sont pris en compte si possible.
;L'interface graphique permet de passer d'une fonction  l'autre en cliquant sur les boutons visibles,
;elle n'est donc pas ncessaire.
;Ceci est une version encore en dveloppement, certaines fonctionnalits peuvent planter.
;Un remaniement des appels/arguments/renvois est en cours, dans le but de simplifier la comprhension
;des instructions du script pour tout le monde.
#EndRegion =========================================Avant de commencer=========================================
#Region ======================================Et maintenant, la gamme.======================================
HotKeySet("{F4}", "exuit") ;fermeture du script sur un "F4", ds que possible
HotKeySet("{F5}", "exuit") ;fermeture du script sur un "F5", ds que possible
HotKeySet("{BACKSPACE}", "pause") ;C'est ici pour PAUSE.
AutoItSetOption("TrayAutoPause", 0)
AutoItSetOption("GUIOnEventMode", 1)
Global $iniNC = "Non Communiqu", $iniLang=$iniNC, $p
Global $AIOLog[15], $Skin[9], $FenBase[24], $FenMod[10], $FenSkin[14], $FenProg[36] ;Inutiliss : $FenBase[8]
Dim $aLog[1], $Radio[1], $Avatar[1], $coListe[2]
Local $temp
$AIOLog[0] = ChargeIni($MODULE_DIR & "\" & $MODULE_Nom & ".ini")
$FenBase[0] = Default
$Skin[8] = 2 ;NbLignes
TrayTip(@ScriptName, "Initialisation du script." & @CRLF & @CRLF & "Bienvenue sur l'AIO-Log !" & @CRLF & Message(), 2)
Initialisation() ;Chargement de tous les paramtres
TrayTip("", "", 0)

While 1 ;Tant que 1 vaut 1 (temps infini)
	Sleep(100) ;ne rien faire pendant 100 millisecondes (0,1 seconde)
	If $AIOLog[13] <> 0 Then Initialisation($AIOLog[13]) ;sauf si $AIOLog[13] est demand, excuter Initialisation ()
	If $AIOLog[9] = 1 Then FNouveau() ;ou si $AIOLog[9] vaut 1, excuter FNouveau ()
	If $AIOLog[3] = 1 Then Lance() ;ou bien si $AIOLog[3] vaut 1, excuter Lance ()
WEnd ;Boucler Tant que
Exit ;C'est la fin. (N'est thoriquement jamais appele  cause de la boucle While plus haut et des portes de sorties des fonctions, c.f "exuit ()", mais a fait super styl ! '_')
#EndRegion ======================================Et maintenant, la gamme.======================================
#Region =================================Fonctions totalement cres par Za=================================
Func Initialisation($Cmd = $CmdLine) ;C'est le dpart
	Local $Ub = UBound($Cmd), $temp = 1 ;Mise en place de la configuration (via fichier.ini, qui est cr si inexistant)
	$AIOLog[7] = Default
	$AIOLog[4] = 4
	IniWrite($AIOLog[0], "Configuration", "Version", $MODULE_VERSION)
	IniWrite($AIOLog[0], "Configuration", "By", "Za")
	$AIOLog[6] = IniRead($AIOLog[0], "Configuration", "Connexion plein cran", 0)
	$AIOLog[5] = IniRead($AIOLog[0], "Configuration", "AutoSauvegarde Fentre", 0)
	$AIOLog[1] = IniRead($AIOLog[0], "Configuration", "Dernier fichier de Skin utilis", "")
	ChargeSkin($AIOLog[1])
	$AIOLog[2] = IniRead($AIOLog[0], "Configuration", "Fermeture aprs connexion", $GUI_UNCHECKED)
	While $temp < $Ub ;Paramtres passs en raccourcis
		Switch $Cmd[$temp]
		Case "-c"
			$temp += 1
			If $temp < $Ub And ($Cmd[$temp] = "-c" Or $Cmd[$temp] = "-d" Or $Cmd[$temp] = "-f" Or $Cmd[$temp] = "-p") Then
				$temp -= 1 ;Si le paramtre est mal tap, ne pas le prendre en compte
			Else
				$AIOLog[7] = _HexToString($Cmd[$temp])
			EndIf
		Case "-d" ;Taille de fentre Dofus
			$temp += 1
			If $temp < $Ub And ($Cmd[$temp] = "-c" Or $Cmd[$temp] = "-d" Or $Cmd[$temp] = "-f" Or $Cmd[$temp] = "-p") Then
				$temp -= 1
			Else
				$AIOLog[6] = $Cmd[$temp]
			EndIf
		Case "-f" ;Sans fentre
			$AIOLog[14] = 1
		Case "-p" ;Excutable Dofus
			$temp += 1
			If $temp < $Ub And ($Cmd[$temp] = "-c" Or $Cmd[$temp] = "-d" Or $Cmd[$temp] = "-f" Or $Cmd[$temp] = "-p") Then
				$temp -= 1
			Else
				$AIOLog[11] = _HexToString($Cmd[$temp])
				If FileExists($Cmd[$temp]) Then $AIOLog[11] = $Cmd[$temp]
			EndIf
		Case "-connect"
		Case Else
			If String(getNDC(_HexToString($Cmd[$temp]))) <> "" Then ;Ajout du compte  la liste
				If $aLog[UBound($aLog) - 1] <> "" Then ReDim $aLog[UBound($aLog) + 1]
				$aLog[UBound($aLog) - 1] = _HexToString($Cmd[$temp])
				If $coListe[UBound($coListe) - 1] <> "" Then ReDim $coListe[UBound($coListe) + 1]
				$coListe[UBound($coListe) - 1] = UBound($coListe) - 2
				$AIOLog[10] = 42
				$AIOLog[4] = 1
				$AIOLog[3] = 1
				$AIOLog[2] = $GUI_CHECKED ;Juste pour le petit ct pratique.
			Else
				Switch $temp ;Compatibilit avec les anciens raccourcis
				Case 1
					$AIOLog[10] = ChargeLog($Cmd[1]) ;Chargement des paramtres des raccourcis et du fichier de Log
				Case 2
					$coListe = StringSplit($Cmd[2], ",") ;Chargement de la liste de connexion
					For $i = 0 To UBound($coListe) - 1
						$coListe[$i] -= 1
					Next
					$coListe[0] = $coListe[1]
					$AIOLog[4] = 1
					$AIOLog[3] = 1
					$AIOLog[2] = $GUI_CHECKED ;Juste pour le petit ct pratique.
				Case 3
					$AIOLog[14] = $Cmd[3]
					$AIOLog[3] = 1
				Case 4
					If $cmd[4] <> "Default" Then $AIOLog[7] = $cmd[4]
				EndSwitch
			EndIf
		EndSwitch
		$temp += 1
	WEnd
	While $AIOLog[10] = ""
		$AIOLog[10] = ChargeLog(IniRead($AIOLog[0], "Configuration", "Dernier fichier de Logs utilis", $iniNC))
	WEnd
	If $AIOLog[14] = 0 Then Fenetre() ;L'interface graphique n'est qu'une option, dsactivable si dsir en raccourcis
	$AIOLog[13] = 0 ;Sortie. Devrait faire un return $AIOLog.
EndFunc   ;==>Initialisation
Func Recharge()
	Local $temp = $AIOLog[10]
	Dim $Init[2]
	$temp = FileOpenDialog(@ScriptName & " - Slectionnez un fichier pour charger vos logs", @ScriptDir, " (*.txt;*.doc)|Tous (*.*)", 8, $temp)
	If $temp <> $AIOLog[10] And $temp <> "" Then
		If Not FileExists($temp) Then FileWrite($temp, @CRLF)
		$AIOLog[10] = ""
		$Init[0] = @ScriptFullPath
		$Init[1] = $temp
		$AIOLog[13] = $Init
	Else
		$AIOLog[13] = 0
	EndIf
EndFunc   ;==>Recharge
Func Sauvegarde()
	Local $temp = $AIOLog[10]
	$temp = FileOpenDialog(@ScriptName & " - Slectionnez un fichier pour sauver vos logs", @ScriptDir, " (*.txt;*.doc)|Tous (*.*)", 8, $temp)
	If $temp <> "" Then _FileWriteFromArray2($temp, $aLog, 1)
EndFunc   ;==>Sauvegarde
Func ChargeIni($fIni = "")
	Local $temp
	If Not FileExists($fIni) Then
		$temp = @ScriptDir & "\AIO-Log.ini"
		If FileExists($temp) Then
			If MsgBox(4, "Configuration", "Pour continuer d'utiliser l'AIO-Log, la configuration doit tre dplace. Dsirez-vous la dplacer maintenant ?") = 6 Then
				FileCopy($temp, $fIni, 8)
			Else
				$fIni = $temp
			EndIf
		ElseIf FileExists(@ScriptDir & "\DofusLog.ini") Then
			If MsgBox (4, "", IniRead($iniLang, "Initialisation", "Export", "Pour continuer d'utiliser l'AIO-Log, vous devez migrer votre DofusLog.ini." & @CRLF & "Dsirez-vous exporter votre DofusLog.ini maintenant ?")) = 6 Then
				FileCopy(@ScriptDir & "\DofusLog.ini", $fIni)
			Else
				$fIni = @ScriptDir & "\DofusLog.ini"
			EndIf
		Else
			DirCreate(StringLeft($fIni, StringInStr($fIni, "\", 0, -1) - 1)) ;Cration du rpertoire ncessaire.
		EndIf
	EndIf
	Return $fIni
EndFunc
Func ChargeLog($log = "") ;chang
	Local $f = "", $temp, $i, $j
	$f = LogChemin($log)
	If FileRead($f, 1) = "" Then ;Cration
		$AIOLog[9] = 1
		Dim $aLog[1]
	ElseIf StringInStr(FileReadLine($f, 2), "{TAB}") Then ;Traitement 
		$aLog = _FileReadToArray2($f)
		$i = 0
		While $i < UBound($aLog) - 1
			If StringInStr($aLog[$i], "#avatar#") > 0 Then
				$aLog[$i] = $i & "" & StringReplace($aLog[$i], "#avatar#", "") & "" & StringReplace($aLog[$i + 1], "{TAB}", "")
			Else
				$aLog[$i] = $i & "" & $aLog[$i] & "" & "" & StringReplace($aLog[$i + 1], "{TAB}", "")
			EndIf
			For $j = $i + 1 To UBound($aLog) - 2
				$aLog[$j] = $aLog[$j+1]
			Next
			ReDim $aLog[UBound($aLog) - 1]
			$i += 1
		WEnd
		If MsgBox(4, @ScriptName, "Attention, vous utilisez un ancien fichier de Logs." & @CRLF & "Il a besoin tre adapt pour cette version du script." & @CRLF & @CRLF & "Dsirez-vous le mettre  jour ?" & @CRLF & @CRLF & "Cliquer sur 'Non' pour mettre  jour dans un nouveau fichier.") = 7 Then
			$f = LogChemin()
			_FileWriteFromArray2($f, $aLog)
		Else
			_FileWriteFromArray2($f, $aLog)
		EndIf
	Else ;Chargement
		$aLog = _FileReadToArray2($f)
	EndIf
	$temp = IniRead($AIOLog[0], "Configuration", "Dernier fichier de Logs utilis", "")
	If $temp <> $f Then
		TrayTip(@ScriptName, "Enregistrement de la place du Log", 1, 16)
		If MsgBox(4, "Enregistrement", "Changement dans le chemin d'accs au Log dtect." & @CRLF & @CRLF & "Dsirez vous que le script s'en souvienne ?") = 6 Then
			IniWrite($AIOLog[0], "Configuration", "Dernier fichier de Logs utilis", $f)
		Else
			If $temp = "" Then IniWrite($AIOLog[0], "Configuration", "Dernier fichier de Logs utilis", $iniNC)
		EndIf
		TrayTip("", "", 0)
	EndIf
	Dim $Radio[UBound($aLog)]
	Dim $Avatar[UBound($aLog)]
	Return $f
EndFunc   ;==>ChargeLog
Func LogChemin($log = "")
	Local $f = ""
	If Not FileExists($log) Then
		While $f = ""
			TrayTip(@ScriptName, "Veuillez slectionner un fichier texte.", 0)
			$f = FileOpenDialog(@ScriptName & " - Slectionnez un fichier pour vos logs", @ScriptDir, " (*.txt;*.doc)|Tous (*.*)", 8, "Log.txt")
			TrayTip("", "", 0)
			If $f = "" Then
				If $AIOLog[10] = "" Then
					If MsgBox(4 + 256, "#001:Carapuce.", "Aucun fichier de Log slectionn. Dsirez-vous fermer le script ?") <> 7 Then Exit
				Else
					$f = $AIOLog[10]
				EndIf
			EndIf
		WEnd
	Else
		$f = $log
	EndIf
	Return $f
EndFunc
Func PosFenetre($Fen = "", $sauve = 0)
	Local $temp
	AutoItSetOption("WinTitleMatchMode", 3)
	Dim $posFen[4]
	If Not WinExists($Fen) Then
		$temp = IniRead($AIOLog[0], "Fentre Principale", "Position Horizontale", "")
		If $temp = "" Or $temp > @DesktopWidth Or $temp < -1 Then
			IniWrite($AIOLog[0], "Fentre Principale", "Position Horizontale", -1)
			$temp = -1
		EndIf
		$posFen[0] = $temp
		$temp = IniRead($AIOLog[0], "Fentre Principale", "Position Verticale", "")
		If $temp = "" Or $temp > @DesktopHeight Or $temp < -1 Then
			IniWrite($AIOLog[0], "Fentre Principale", "Position Verticale", -1)
			$temp = -1
		EndIf
		$posFen[1] = $temp
	Else
		$posFen = WinGetPos($Fen)
		If $sauve = 1 Then
			IniWrite($AIOLog[0], "Fentre Principale", "Position Horizontale", $posFen[0])
			IniWrite($AIOLog[0], "Fentre Principale", "Position Verticale", $posFen[1])
		EndIf
	EndIf
	AutoItSetOption("WinTitleMatchMode", 1)
	Return $posFen
EndFunc   ;==>PosFenetre
Func Fenetre($GUI = "FenBase")
	Local $compteBis = 0, $temp, $array, $Fen, $Label2, $i, $s, $gauche = 0, $droite = 0, $haut = 0, $bas = 0
	Switch $GUI
		Case "FenBase"
			$Fen = Patience()
			$array = TestFenetre()
			$FenBase[17] = $array[3] - 4 ;hauteur - dbordement
			$FenBase[18] = $Skin[8] * $FenBase[17] + $Skin[7] ;2 (lignes) * hauteur + sparation
			$FenBase[20] = $array[2] + $array[2] / 2 ;3/2 de message
			$FenBase[19] = UBound($aLog)
			If $FenBase[19] < 4 Then $FenBase[19] = 4
			$titre = @ScriptName & " Commandante" ;Fentre "Gnrale".. aha. :x
			$posFenetre = PosFenetre($titre)
			$FenBase[8] = $FenBase[0] ;Utile sous Multico..

			$i = 0
			$temp = $array[1] - 1 + 4 * $FenBase[17] - $skin[7]
			While $temp < @DesktopHeight - $FenBase[18] And $i < $FenBase[19]
				$temp += $FenBase[18]
				$i += 1
			WEnd
			$FenBase[0] = GUICreate($titre, $gauche + $FenBase[20] - 1 + $droite, $haut + $temp + $bas, $posFenetre[0], $posFenetre[1], 0x70000) ;Taille correcte !!
			GUISetOnEvent($GUI_EVENT_CLOSE, "quit", $FenBase[0])
			If $DEBUG_MODE Then GUISetState()
			AppliqueSkin($FenBase[0], $titre) ;Skins utilisateurs accepts, youhou !

			$FenBase[13] = GUICtrlCreateMenu("&Fichier", -1, 0)
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Nouveau", $FenBase[13], 0), "Recharge")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("Ch&arger", $FenBase[13], 1), "Recharge")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Sauvegarder", $FenBase[13], 2), "Sauvegarde")
			GUICtrlCreateMenuItem("", $FenBase[13], 3)
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("Quitt&er", $FenBase[13], 4), "quit")

			$FenBase[9] = GUICtrlCreateMenu("&Options", -1, 1)
			$FenBase[10] = GUICtrlCreateMenu("&Configuration", $FenBase[9], 0)
			$FenBase[11] = GUICtrlCreateMenuItem("F&entre Dofus	 (Normale)", $FenBase[10], 0)
			GUICtrlSetOnEvent($FenBase[11], "PleinEcran")
			If $AIOLog[6] = 1 Then GUICtrlSetData($FenBase[11], "F&entre Dofus	 (Agrandie)")
			If $AIOLog[6] = 2 Then GUICtrlSetData($FenBase[11], "F&entre Dofus	 (Plein cran)")
			$FenBase[23] = GUICtrlCreateMenuItem("&Autosave Fentre	(non)", $FenBase[10], 1)
			GUICtrlSetOnEvent($FenBase[23], "AutoSave")
			If $AIOLog[5] = 1 Then GUICtrlSetData($FenBase[23], "> &Autosave Fentre	(oui)")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Changer l'excutable	-->", $FenBase[10], 2), "PrgNom")
			$FenBase[12] = GUICtrlCreateMenu("Compt&e", $FenBase[9], 1)
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Lancer !", $FenBase[12], 0), "FuncLance")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Nouveau", $FenBase[12], 1), "FNouveau")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Modifier", $FenBase[12], 2), "FModifier")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Supprimer", $FenBase[12], 3), "FSupprimer")
			$FenBase[14] = GUICtrlCreateMenu("&Raccourcis", $FenBase[9], 2)
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Crer", $FenBase[14], 0), "RModif")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("Ch&arger", $FenBase[14], 1), "RCharge")
			$FenBase[15] = GUICtrlCreateMenu("&Skins", $FenBase[9], 3)
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Nouveau", $FenBase[15], 0), "SkinNouveau")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Sauver", $FenBase[15], 1), "SkinSauve")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Modifier", $FenBase[15], 2), "SkinMod")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("&Charger", $FenBase[15], 3), "Skinner")
			$FenBase[16] = GUICtrlCreateMenu("&Info", -1, 3)
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("AIO-Log By &Za", $FenBase[16], 1), "Za")
			GUICtrlSetOnEvent(GUICtrlCreateMenuItem("Version : " & $MODULE_VERSION, $FenBase[16], 2), "Info")

			GUICtrlSetResizing(GUICtrlCreateLabel("Choisissez un compte  connecter :", $gauche + 1, $haut + 0, -1, $FenBase[17]), 2 + 32 + 768)

			GUIStartGroup($FenBase[0]) ;-utile pour la boucle de focus
			$FenBase[4] = GUICtrlCreateButton("&Nouveau", $gauche + 0, $haut + $FenBase[19] * $FenBase[18] + 2 * $FenBase[17], ($FenBase[20] - 3) / 3, $FenBase[18] - $Skin[7])
			GUICtrlSetResizing($FenBase[4], 8 + 64 + 768)
			GUICtrlSetOnEvent($FenBase[4], "FNouveau")
			$FenBase[5] = GUICtrlCreateButton(" Supprimer", $gauche + $FenBase[20] / 3 - 1, $haut + $FenBase[19] * $FenBase[18] + 2 * $FenBase[17], ($FenBase[20] - 3) / 3, $FenBase[18] - $Skin[7])
			GUICtrlSetResizing($FenBase[5], 8 + 64 + 768)
			GUICtrlSetOnEvent($FenBase[5], "FSupprimer")
			$FenBase[3] = GUICtrlCreateButton("&Modifier", $gauche + $FenBase[20] - $FenBase[20] / 3 - 2, $haut + $FenBase[19] * $FenBase[18] + 2 * $FenBase[17], ($FenBase[20] - 3) / 3, $FenBase[18] - $Skin[7])
			GUICtrlSetResizing($FenBase[3], 8 + 64 + 768)
			GUICtrlSetOnEvent($FenBase[3], "FModifier")
			$FenBase[22] = GUICtrlCreateCheckbox("Clef", $gauche + $FenBase[20] - 3 - 2 * ($FenBase[20] - 6) / 6, $haut + $FenBase[18] * ($FenBase[19] / 2 + 1) + 2.1 * $FenBase[17] - $Skin[7], -1, $FenBase[17])
			GUICtrlSetResizing($FenBase[22], 8 + 768)
			GUICtrlSetOnEvent($FenBase[22], "ClefUnique")
			If $AIOLog[7] <> Default Then
				GUICtrlSetState($FenBase[22], $GUI_CHECKED)
				GUICtrlSetFont($FenBase[22], -1, 800)
			EndIf
			$FenBase[21] = GUICtrlCreateButton("&Lancer !", $gauche + $FenBase[20] - 4 - 2 * ($FenBase[20] - 6) / 6, $haut + $FenBase[18] * $FenBase[19] / 2 + 2.1 * $FenBase[17], ($FenBase[20] - 3) / 3, $FenBase[18] - $Skin[7])
			GUICtrlSetResizing($FenBase[21], 8 + 768)
			GUICtrlSetOnEvent($FenBase[21], "FuncLance")
			If $AIOLog[4] = 1 Then GUICtrlSetOnEvent(GUICtrlCreateButton("Tous", $gauche + $FenBase[20] - $FenBase[20] / 6, $haut + $FenBase[18] * $FenBase[19] / 2 + 1.1 * $FenBase[17], -1, $FenBase[17]), "FCheckAll")
			$FenBase[2] = GUICtrlCreateCheckbox("Multi", $gauche + $FenBase[20] - 3 - 2 * ($FenBase[20] - 6) / 6, $haut + $FenBase[18] * $FenBase[19] / 2 + 1.1 * $FenBase[17], -1, $FenBase[17])
			GUICtrlSetResizing($FenBase[2], 8 + 768)
			GUICtrlSetState($FenBase[2], $AIOLog[4])
			GUICtrlSetOnEvent($FenBase[2], "FMultico")
			$FenBase[6] = GUICtrlCreateButton("Monte", $gauche + $FenBase[20] - 4 - ($FenBase[20] - 6) / 6, $haut + 2 * ($FenBase[17] + $Skin[7]), $FenBase[20] / 6, $FenBase[18] - $Skin[7])
			GUICtrlSetResizing($FenBase[6], 8 + 768)
			GUICtrlSetOnEvent($FenBase[6], "MHaut")
			$FenBase[7] = GUICtrlCreateButton("Baisse", $gauche + $FenBase[20] - 4 - 2 * ($FenBase[20] - 6) / 6, $haut + 2 * ($FenBase[17] + $Skin[7]), $FenBase[20] / 6, $FenBase[18] - $Skin[7])
			GUICtrlSetResizing($FenBase[7], 8 + 768)
			GUICtrlSetOnEvent($FenBase[7], "MBas")
			$FenBase[1] = GUICtrlCreateCheckbox("Fermer le script aprs ces comptes", $gauche + 1, $haut + $FenBase[17], -1, $FenBase[17])
			GUICtrlSetResizing($FenBase[1], 2 + 32 + 768)
			GUICtrlSetState($FenBase[1], $AIOLog[2])
			GUICtrlSetOnEvent($FenBase[1], "Fini")
			If $AIOLog[4] = 4 Then GUICtrlSetData($FenBase[1], "Fermer le script aprs ce compte")
			For $i = 0 To UBound($aLog) - 1
				If getID($aLog[$i]) <> "" Then
					If $AIOLog[4] = 1 Then
						$Radio[$i] = GUICtrlCreateCheckbox(getSurnom($aLog[$i]) & " . ", $gauche + $Skin[8] * $FenBase[17] + 1, $haut + $i * $FenBase[18] + 2 * $FenBase[17], 2 * ($FenBase[20] - 6) / 3 - $Skin[8] * $FenBase[17] + 1, $FenBase[18] - $Skin[7], 0x2000)
					Else
						$Radio[$i] = GUICtrlCreateRadio(getSurnom($aLog[$i]) & " . ", $gauche + $Skin[8] * $FenBase[17] + 1, $haut + $i * $FenBase[18] + 2 * $FenBase[17], 2 * ($FenBase[20] - 6) / 3 - $Skin[8] * $FenBase[17] + 1, $FenBase[18] - $Skin[7], 0x2000)
					EndIf
					GUICtrlSetOnEvent($Radio[$i], "FControl")
					GUICtrlSetData($Radio[$i], getSurnom($aLog[$i]))
					GUICtrlSetResizing($Radio[$i], 2 + 32 + 768)
					$s = getAvatar($aLog[$i])
					If FileExists($s) Then
						$Avatar[$i] = GUICtrlCreatePic(getAvatar($aLog[$i]), $gauche + 1, $haut + $i * $FenBase[18] + 2 * $FenBase[17], $Skin[8] * $FenBase[17], $Skin[8] * $FenBase[17])
						GUICtrlSetResizing($Avatar[$i], 2 + 32 + 768)
						GUICtrlSetState($Avatar[$i], $GUI_DISABLE)
					EndIf
					If $DEBUG_MODE Then MsgBox(80,"",getSurnom($aLog[$i]))
				EndIf
			Next
			$temp = 0
			If $AIOLog[4] = 1 Then
				While $temp < UBound($coListe) - 1
					$temp += 1
					If $coListe[$temp] < UBound($Radio) Then
						GUICtrlSetState($Radio[$coListe[$temp]], $GUI_CHECKED + $GUI_FOCUS)
						GUICtrlSetFont($Radio[$coListe[$temp]], -1, 1000)
					EndIf
				WEnd
			EndIf
			GUICtrlSetState($Radio[$coListe[$temp]], $GUI_CHECKED + $GUI_FOCUS)
			GUICtrlSetFont($Radio[$coListe[$temp]], -1, 1000)
			GUIDelete($Fen)
			If $FenBase[8] <> Default Then GUIDelete($FenBase[8])
		Case "FenMod"
			$array = TestFenetre("Mot de pass associ ( crypt et cach ) :")
			$titre = "Ajouter/modifier un compte"
			$FenMod[0] = GUICreate($titre, $array[2], $FenBase[17] * 12 - 1, -1, -1, -1, 0x00100010, $FenBase[0])
			GUISetOnEvent($GUI_EVENT_CLOSE, "ModAnnule")
			If $DEBUG_MODE Then GUISetState()
			AppliqueSkin($FenMod[0], $titre)
			GUISetIcon(getAvatar($aLog[$AIOLog[8]]), -1, $FenMod[0])
;~ 			$temp = WinGetPos(@ScriptName & " Commandante")
;~ 			WinMove(@ScriptName & " Commandante", "", $temp[0], $temp[1], $temp[2] + $array[2], $temp[3], 1)

			GUICtrlCreateLabel("Veuillez entrer" & @CRLF & " un surnom public :", 1, 0, -1, 2 * $FenBase[17])
			$FenMod[1] = GUICtrlCreateInput(getSurnom($aLog[$AIOLog[8]]), 0, $FenBase[17] * 2, $array[2] - ($array[2] / 4 + 10), $FenBase[17])
			GUICtrlSetState($FenMod[1], $GUI_FOCUS)
			GUICtrlCreateLabel("Clef de cryptage :" & @CRLF & "(cache)", $array[2] * 4 / 7 , 0, -1, 2 * $FenBase[17])
			$FenMod[3] = GUICtrlCreateInput("", $array[2] - $array[2] / 4, $FenBase[17] * 2, $array[2] / 4, $FenBase[17], 0x20)
			GUICtrlSetState($FenMod[2], $GUI_DROPACCEPTED)
			GUICtrlCreateLabel("Nom de compte Dofus (crypt) :", 0, $FenBase[17] * 3, -1, $FenBase[17])
			$FenMod[4] = GUICtrlCreateInput("", 0, $FenBase[17] * 4, $array[2], $FenBase[17]) ;ndc
			GUICtrlCreateLabel("Mot de pass associ (crypt et cach) :", 0, $FenBase[17] * 5, -1, $FenBase[17])
			$FenMod[5] = GUICtrlCreateInput("", 0, $FenBase[17] * 6, $array[2], $FenBase[17], 0x20) ;mdp
			GUICtrlSetOnEvent(GUICtrlCreateButton("Choisir un avatar", 0, $FenBase[17] * 7, $array[2], 1 * $FenBase[18], 0x20), "ModAvatar")
			$FenMod[2] = GUICtrlCreateInput(getAvatar($aLog[$AIOLog[8]]), 0, $FenBase[17] * 8, $array[2], $FenBase[17]) ;avatar
			$FenMod[6] = GUICtrlCreateButton("Choisir un excutable", 0, $FenBase[17] * 9, $array[2], 1 * $FenBase[18], 0x20)
			GUICtrlSetOnEvent($FenMod[6], "ModExec")
			$FenMod[7] = GUICtrlCreateInput(getExecutable($aLog[$AIOLog[8]]), 0, $FenBase[17] * 10, $array[2], $FenBase[17])
			$FenMod[8] = GUICtrlCreateButton("Valider", 0, $FenBase[17] * 11, $array[2] / 2, $FenBase[18])
			GUICtrlSetOnEvent($FenMod[8], "ModModifier")
			$FenMod[9] = GUICtrlCreateButton("Annuler", $array[2] / 2, $FenBase[17] * 11, $array[2] / 2, $FenBase[18])
			GUICtrlSetOnEvent($FenMod[9], "ModAnnule")
		Case "FenSkin"
			$array = TestFenetre("Noir : 0, Blanc : 0xFFFFFF ")
			$titre = "Modifier un Skin"
			$FenSkin[0] = GUICreate($titre, $array[2], 24 * $FenBase[17] + $FenBase[18], -1, -1, -1, 0x00100010, $FenBase[0])
			GUISetOnEvent($GUI_EVENT_CLOSE, "SkinAnnule")
			If $DEBUG_MODE Then GUISetState()
			AppliqueSkin($FenSkin[0], $titre)

			GUICtrlCreateLabel("Image de fond : ", 0, 0, -1, $FenBase[17]) ;vierge par def
			$FenSkin[1] = GUICtrlCreateInput($Skin[0], 0, $FenBase[17], $array[2], 1.5 * $FenBase[17])
			GUICtrlSetState($FenSkin[1], $GUI_DROPACCEPTED)
			GUICtrlCreateLabel("Couleurs ( en hexadcimal )", 0, 2.5 * $FenBase[17], -1, $FenBase[17]) ;-1 par def
			GUICtrlCreateLabel("du fond :", 0, 3.75 * $FenBase[17], -1, $FenBase[17])
			$FenSkin[2] = GUICtrlCreateInput($Skin[1], $array[2] / 2, 3.5 * $FenBase[17], $array[2] / 2, 1.5 * $FenBase[17])
			GUICtrlCreateLabel("des objets :", 0, 5.25 * $FenBase[17], -1, $FenBase[17]) ;-1 par def
			$FenSkin[4] = GUICtrlCreateInput($Skin[3], $array[2] / 2, 5 * $FenBase[17], $array[2] / 2, 1.5 * $FenBase[17])
			GUICtrlCreateLabel("de la police :", 0, 6.75 * $FenBase[17], -1, $FenBase[17]) ;-1 par def
			$FenSkin[3] = GUICtrlCreateInput($Skin[2], $array[2] / 2, 6.5 * $FenBase[17], $array[2] / 2, 1.5 * $FenBase[17])
			GUICtrlCreateEdit("Noir : 0, Blanc : 0xFFFFFF" & @CRLF & "0xRougeVertBleu" & @CRLF, 0, 8 * $FenBase[17], $array[2], 2.5 * $FenBase[17], 0x805)
			GUICtrlCreateLabel("Police de caractre : ", 0, 10.5 * $FenBase[17], -1, $FenBase[17]) ;-1 par def
			$FenSkin[6] = GUICtrlCreateInput($Skin[6], 0, 11.5 * $FenBase[17], $array[2], 1.5 * $FenBase[17])
			GUICtrlSetState($FenSkin[6], $GUI_DROPACCEPTED)
			GUICtrlCreateLabel("Taille de la police : ", 0, 13 * $FenBase[17], -1, $FenBase[17]) ;-1 par def, ou 8.5 ?
			$FenSkin[5] = GUICtrlCreateInput($Skin[4], 0, 14 * $FenBase[17], $array[2], 1.5 * $FenBase[17])
			GUICtrlCreateLabel("Attributs : ", 0, 15.5 * $FenBase[17], -1, $FenBase[17]) ;ensuite des checkboxes
			$FenSkin[7] = GUICtrlCreateCheckbox("Italique", 0, 16.5 * $FenBase[17], -1, $FenBase[17]) ;2
			If BitAND($Skin[5], 2) Then GUICtrlSetState($FenSkin[7], $GUI_CHECKED)
			$FenSkin[8] = GUICtrlCreateCheckbox("Soulign", 0, 17.5 * $FenBase[17], -1, $FenBase[17]) ;4
			If BitAND($Skin[5], 4) Then GUICtrlSetState($FenSkin[8], $GUI_CHECKED)
			$FenSkin[9] = GUICtrlCreateCheckbox("Barr", 0, 18.5 * $FenBase[17], -1, $FenBase[17]) ;8
			If BitAND($Skin[5], 8) Then GUICtrlSetState($FenSkin[9], $GUI_CHECKED)
			GUICtrlCreateLabel("Sparation entre 2 lignes : ", 0, 20 * $FenBase[17], -1, $FenBase[17])
			$FenSkin[11] = GUICtrlCreateInput($Skin[7], 0, 21 * $FenBase[17], $array[2] / 4, 1.5 * $FenBase[17])
			GUICtrlCreateLabel("pixel ( s )", $array[2] / 4 + 1, 21.25 * $FenBase[17], -1, $FenBase[17])
			GUICtrlCreateLabel("Hauteur :", 0, 22.75 * $FenBase[17], -1, $FenBase[17])
			$FenSkin[12] = GUICtrlCreateInput($Skin[8], $array[2] * 2 / 4, 22.5 * $FenBase[17], $array[2] / 4, 1.5 * $FenBase[17])
			$FenSkin[13] = GUICtrlCreateButton("Valider", 1, 24 * $FenBase[17], $array[2] / 2, $FenBase[18])
			GUICtrlSetOnEvent($FenSkin[13], "SkinModifier")
			GUICtrlSetState($FenSkin[13], $GUI_FOCUS)
			GUICtrlSetOnEvent(GUICtrlCreateButton("Annuler", $array[2] / 2 + 1, 24 * $FenBase[17], $array[2] / 2, $FenBase[18]), "SkinAnnule")
		Case "FenProg"
			Return MsgBox(80, "Stop-Bug", "Fentre momentanment dsactive pour cause de bug.") ;Fentre dsactive pour cause de bug
			$array = TestFenetre("Voici la liste des aliases : ")
			$titre = "Changer d'excutables"
			$temp = IniReadSection($AIOLog[0], "Excutables")
			Dim $FenProg[UBound($temp, 1) + 3]
			$FenProg[0] = GUICreate($titre, $array[2], (UBound($temp) + 1) * $FenBase[18] + $FenBase[17], -1, -1, -1, 0x00100010, $FenBase[0])
			GUISetOnEvent($GUI_EVENT_CLOSE, "ProgAnnule")
			If $DEBUG_MODE Then GUISetState()
			AppliqueSkin($FenProg[0], $titre)

			GUICtrlCreateLabel("Voici la liste des aliases :", 0, 0, -1, $FenBase[17])
			$i = 0
			While $i < UBound($temp, 1) - 1
				$i += 1
				$FenProg[$i] = GUICtrlCreateButton($temp[$i][0], 0, $FenBase[18] * ($i-1) + $FenBase[17], -1, $FenBase[18])
				GUICtrlSetOnEvent($FenProg[$i], "NouvExec")
			WEnd
			$FenProg[$i] = GUICtrlCreateButton("Ajouter >", 0, $FenBase[18] * $i + $FenBase[17], -1, $FenBase[18])
			GUICtrlSetOnEvent($FenProg[$i], "NouvExec")
			$FenProg[$i+1] = GUICtrlCreateButton("< Retirer", $array[2] / 2, $FenBase[18] * $i + $FenBase[17], -1, $FenBase[18])
			GUICtrlSetOnEvent($FenProg[$i + 1], "DelExec")
	EndSwitch
	GUISetState()
EndFunc   ;==>Fenetre
Func ClefUnique()
	If $AIOLog[7] = Default Then
		Local $Input = InputBox("Clef Gnrique", "Veuillez entrer la clef gnrique" & @CRLF & " utiliser par dfaut pour les surnoms :", "", "")
		If @error = 1 Then
			GUICtrlSetState($FenBase[22], $GUI_UNCHECKED)
			GUICtrlSetState($FenBase[22], $GUI_FOCUS)
			Return 1
		EndIf
		$AIOLog[7] = $Input
		GUICtrlSetFont($FenBase[22], -1, 800)
		GUICtrlSetState($FenBase[22], $GUI_CHECKED)
	Else
		GUICtrlSetFont($FenBase[22], -1, 400)
		$AIOLog[7] = Default
	EndIf
	GUICtrlSetState($FenBase[22], $GUI_FOCUS)
EndFunc   ;==>ClefUnique
Func PleinEcran()
	Local $temp
	$AIOLog[6] += 1
	If $AIOLog[6] = 1 Then
		$temp = "(Agrandie)"
	ElseIf $AIOLog[6] = 2 Then
		$temp = "(Plein cran)"
	Else
		$AIOLog[6] = 0
		$temp = "(Normale)"
	EndIf
	GUICtrlSetData($FenBase[11], "F&entre Dofus	 " & $temp)
	If $AIOLog[6] <> IniRead($AIOLog[0], "Configuration", "Connexion plein cran", -1) Then
		If MsgBox(4, "AutoSave de Fentre", "Modification du lancement de la fentre Dofus " & $temp & " dtect." & @CRLF & @CRLF & "Dsirez-vous que le script s'en souvienne ?") = 6 Then
			IniWrite($AIOLog[0], "Configuration", "Connexion plein cran", $AIOLog[6])
		EndIf
	EndIf
EndFunc   ;==>PleinEcran
Func AutoSave()
	$AIOLog[5] = 1 - $AIOLog[5]
	If $AIOLog[5] = 1 Then
		GUICtrlSetData($FenBase[23], "> &Autosave Fentre	 ( oui )")
	Else
		GUICtrlSetData($FenBase[23], "&Autosave Fentre	 ( non )")
	EndIf
	If $AIOLog[5] <> IniRead($AIOLog[0], "Configuration", "AutoSauvegarde Fentre", "") Then
		If MsgBox(4, "AutoSave de Fentre", "Changement de la configuration de sauvegarde de Fentre." & @CRLF & @CRLF & "Dsirez-vous que le script s'en souvienne ?") = 6 Then
			IniWrite($AIOLog[0], "Configuration", "AutoSauvegarde Fentre", $AIOLog[5])
		EndIf
	EndIf
EndFunc   ;==>AutoSave
Func PrgNom()
	Fenetre("FenProg")
EndFunc
Func DelExec()
	Local $temp = InputBox(@ScriptName, "Veuillez entrer le nom de l'alias  supprimer", "")
	IniDelete($AIOLog[0], "Excutables", $temp)
	GUIDelete($FenProg[0])
	Fenetre("FenProg")
EndFunc
Func NouvExec()
	Local $temp = FileOpenDialog("Slectionnez l'excutable dsir", "C:\Program Files\Dofus 2.0\App\UpLauncher.exe", "Excutables (*.exe;*.html)|Tous (*.*)"), $a = Default
	If $temp <> "" Then
		Do
			$a = InputBox(@ScriptName, "Entrez l'alias pour " & $temp & " :", "Dofus 2.0")
			If $a = "" Then
				If MsgBox(4, "???", "Aucun nom slectionn, dsirez-vous fermer cette fentre ?") <> 7 Then Return
			ElseIf IniRead($AIOLog[0], "Excutables", $a, "") <> "" Then
				If MsgBox(4, "???", "L'excutable " & $a & " est dj enregistr, dsirez-vous le remplacer ?") <> 6 Then $a = ""
			EndIf
		Until $a <> ""
		IniWrite($AIOLog[0], "Excutables", $a, $temp)
		GUIDelete($FenProg[0])
		Fenetre("FenProg")
	EndIf
EndFunc
Func ProgAnnule()
	GUIDelete($FenProg[0])
EndFunc
Func TestFenetre($Label = "Choisissez un compte  connecter :")
	Local $a, $b, $c
	$c = GUICreate("Testinou", -1, -1, -1, -1, 0x70000)
;~ 	If $DEBUG_MODE Then GUISetState()
	GUICtrlCreateMenu("&Fichier", -1, 0)
	AutoItSetOption("CaretCoordMode", 0)
	$b = WinGetCaretPos()
	AutoItSetOption("CaretCoordMode", 1)
	GUISetFont($Skin[4], 400, $Skin[5], $Skin[6], $c)
	$a = ControlGetPos("Testinou", "", GUICtrlCreateLabel($Label, 0, 0))
	$a[0] = $b[0]
	$a[1] = $b[1]
	GUISetState()
;~ 	If $DEBUG_MODE Then MsgBox(80,"","Fentre de test")
	GUIDelete($c)
	Return $a
EndFunc   ;==>TestFenetre
Func FSupprimer() ;chang
	Local $err = 1, $temp = 0
	If UBound($Radio) < 1 Then Return 0
	If $AIOLog[4] = 1 Then
		While $temp < UBound($coListe) - 1
			$temp += 1
			If Not Delete($coListe[$temp]) Then
				ReDim $coListe[UBound($coListe) - 1]
				$err = 0
			EndIf
		WEnd
	Else
		$err = Delete($coListe[0])
	EndIf
	If $temp > UBound($coListe) - 1 Then $temp = UBound($coListe) - 1
	If $coListe[$temp] > UBound($coListe) Then $coListe[$temp] = UBound($coListe)
	If $err = 0 Then Fenetre()
EndFunc   ;==>FSupprimer
Func Delete($r = 0) ;chang
	If MsgBox(4, @ScriptName & " - Suppression", "Souhaitez-vous vraiment dtruire " & getSurnom($aLog[$r]) & " ?") <> 6 Then Return 1
	TrayTip(@ScriptName, "Effacement en cours...", 10, 16)
	For $temp = $r To UBound($Radio) - 1 ; rcrire
		MBas()
	Next
	ReDim $aLog[UBound($aLog) - 1]
	ReDim $Radio[UBound($Radio) - 1]
	If $coListe[0] > UBound($aLog) - 1 Then $coListe[0] = UBound($aLog) - 1
	If UBound($aLog) > 0 Then
		_FileWriteFromArray2($AIOLog[10], $aLog)
	Else
		FileDelete($AIOLog[10])
		FileWrite($AIOLog[10], @CRLF)
		$AIOLog[9] = 1
	EndIf
	TrayTip("", "", 0)
EndFunc   ;==>Delete
Func FModifier()
	$AIOLog[8] = $coListe[0]
	If $AIOLog[4] = 1 And $coListe[UBound($coListe) - 1] <> "" Then $AIOLog[8] = $coListe[UBound($coListe) - 1] ;Bof, formulation  revoir.
	Fenetre("FenMod")
EndFunc   ;==>FModifier
Func FNouveau() ; vrifier
	$AIOLog[9] = 0
	If $aLog[UBound($aLog) - 1] <> "" Then
		ReDim $aLog[UBound($aLog) + 1]
		ReDim $Radio[UBound($aLog)]
		ReDim $Avatar[UBound($aLog)]
	EndIf
	$AIOLog[8] = UBound($aLog) - 1
	Fenetre("FenMod")
EndFunc   ;==>FNouveau
Func ModAnnule()
	GUIDelete($FenMod[0])
	If $aLog[UBound($aLog) - 1] = "" And UBound($aLog) > 1 Then
		ReDim $aLog[UBound($aLog) - 1]
		ReDim $Radio[UBound($Radio) - 1]
	EndIf
EndFunc   ;==>ModAnnule
Func ModModifier() ;Refait.
	Local $s = $aLog[$AIOLog[8]], $a, $Surnom, $b, $c
	If MsgBox(4, @ScriptName & " - Modification", "Dsirez-vous vraiment enregistrer dans " & $AIOLog[10] & " ?") <> 6 Then Return 1
	TrayTip(@ScriptName, "criture en cours...", 0, 16)
	$a = getID($s)
	If $a = "" Then $a = setID()
	$a &= "" & GUICtrlRead($FenMod[1]) & "" & GUICtrlRead($FenMod[2])
	$a &= ""
	$b = GUICtrlRead($FenMod[4])
	If $b <> "" Then
		$c = GUICtrlRead($FenMod[3])
		If $c = "" Then
			$a &= $b
		Else
			$a &= _StringEncrypt(1, $b, $c)
			$c = ""
		EndIf
		GUICtrlSetData($FenMod[4], "")
		$b = ""
	Else
		$a &= getNDC($s)
	EndIf
	$a &= ""
	$b = GUICtrlRead($FenMod[5])
	If $b <> "" Then
		$c = GUICtrlRead($FenMod[3])
		If $c = "" Then
			$a &= $b
		Else
			$a &= _StringEncrypt(1, $b, $c)
			$c = ""
		EndIf
		GUICtrlSetData($FenMod[5], "")
		$b = ""
	Else
		$a &= getMDP($s)
	EndIf
	$a &= "" & GUICtrlRead($FenMod[7])
	$aLog[$AIOLog[8]] = $a
	_FileWriteFromArray2($AIOLog[10], $aLog)
	TrayTip("", "", 0)
	GUICtrlSetData($FenMod[3], "")
	GUICtrlSetData($FenMod[4], "")
	GUICtrlSetData($FenMod[5], "")
	GUIDelete($FenMod[0])
	Fenetre()
EndFunc   ;==>ModModifier
Func ModExec()
	Local $temp = IniReadSection($AIOLog[0], "Excutables"), $a = "Choisissez un alias pour aller avec le Surnom.", $i = 1
	If UBound($temp) > 1 Then
		$a &= @CRLF & "Les alias actuellement disponibles sont : "
		While $i < UBound($temp) - 1
			$a &= $temp[$i][0] & ", "
			$i += 1
		WEnd
		$a &= $temp[$i][0] & "."
	EndIf
	$a = InputBox(@ScriptName, $a, "Dofus 2.0")
	IF IniRead($AIOLog[0], "Excutables", $a, 0) = 0 Then
		If MsgBox(4, @ScriptName, "L'alias " & '"' & $a & '"' & " n'existe pas pour le moment." & @CRLF & "Le crer ?") = 6 Then NouvExec()
	EndIf
	GUICtrlSetData($FenMod[7], $a)
EndFunc
Func ModAvatar()
	Local $temp = FileOpenDialog(@ScriptName, @ScriptDir, "Images (*.bmp;*.jpg;*.gif)|Tous (*.*)")
	If $temp <> "" Then GUICtrlSetData($FenMod[2], $temp)
EndFunc
Func FControl()
	If $AIOLog[4] = 1 Then
		FCheckBox()
	Else
		FRadio(@GUI_CtrlId)
	EndIf
EndFunc   ;==>FControl
Func FRadio($mess = 0)
	If $mess = $Radio[$coListe[0]] Then
		$AIOLog[3] = 1
	Else
		If GUICtrlRead($Radio[$coListe[0]]) = $GUI_UNCHECKED Then
			GUICtrlSetFont($Radio[$coListe[0]], -1, 500)
			GUICtrlSetState($Radio[$coListe[0]], $GUI_NOFOCUS)
		EndIf
		$coListe[0] = 0
		While $mess <> $Radio[$coListe[0]]
			$coListe[0] += 1
		WEnd
		GUICtrlSetState($Radio[$coListe[0]], $GUI_FOCUS + $GUI_CHECKED)
		GUICtrlSetFont($Radio[$coListe[0]], -1, 1000)
	EndIf
EndFunc   ;==>FRadio
Func FCheckAll()
	Local $i, $j = $GUI_CHECKED
	For $i = 0 To UBound($Radio) - 1
		If GUICtrlRead($Radio[$i]) = $GUI_UNCHECKED Then $j += 1
	Next
	If $j = $GUI_CHECKED Then $j = $GUI_UNCHECKED
	For $i = 0 To UBound($Radio) - 1
		GUIctrlSetState($Radio[$i], $j)
	Next
	FCheckBox()
EndFunc
Func FCheckBox()
	Local $i
	ReDim $coListe[1]
	For $i = 0 To UBound($Radio) - 1
		If GUICtrlRead($Radio[$i]) = $GUI_CHECKED Then
			ReDim $coListe[UBound($coListe) + 1]
			$coListe[UBound($coListe) - 1] = $i
			GUICtrlSetFont($Radio[$i], -1, 1000)
		Else
			GUICtrlSetFont($Radio[$i], -1, 500)
		EndIf
	Next
EndFunc   ;==>FCheckBox
Func FMultico()
	$AIOLog[4] = GUICtrlRead($FenBase[2])
;~ 	If UBound($Radio) < 2 Then Return 0
	If UBound($coListe) < 2 Then ReDim $coListe[2]
	If String($coListe[1]) = "" And $AIOLog[4] = 1 Then $coListe[1] = $coListe[0]
	Fenetre()
EndFunc   ;==>FMultico
Func MHaut() ;chang
	Local $n = 0, $i = 1
	If $AIOLog[4] = 1 Then
		$n = 1
		While $n < UBound($coListe)
;~ 			If $coListe[$n] = $coListe[0] And $coListe[0] > 0 Then $coListe[0] -= 1
			If GUICtrlRead($Radio[$coListe[$n]]) = $GUI_CHECKED And $coListe[$n] > 0 And $coListe[$n] < UBound($aLog) Then
				MBouge($coListe[$n], $coListe[$n] - 1)
				FCheckBox()
			EndIf
			$n += 1
		WEnd
	ElseIf $coListe[0] > 0 Then
		While $i < UBound($coListe)
			If $coListe[$i] <> "" And $coListe[$i] = $coListe[0] And $coListe[0] > 0 Then $coListe[$i] -= 1
			$i += 1
		WEnd
		MBouge($coListe[$n], $coListe[$n] - 1)
		FRadio($Radio[$coListe[$n] - 1])
	EndIf
EndFunc   ;==>MHaut
Func MBas() ;chang
	Local $n = 0, $i = 1
	If $AIOLog[4] = 1 Then
		$n = UBound($coListe) - 1
		While $n > 0
;~ 			If $coListe[$n] = $coListe[0] And $coListe[0] < UBound($aLog) - 1 Then $coListe[0] += 1
			If GUICtrlRead($Radio[$coListe[$n]]) = $GUI_CHECKED And $coListe[$n] < UBound($aLog) - 1 Then
				MBouge($coListe[$n], $coListe[$n] + 1)
				FCheckBox()
			EndIf
			$n -= 1
		WEnd
	ElseIf $coListe[0] < UBound($aLog) - 1 Then
		While $i < UBound($coListe)
			If $coListe[$i] <> "" And $coListe[$i] = $coListe[0] And $coListe[0] < UBound($aLog) - 1 Then $coListe[$i] += 1
			$i += 1
		WEnd
		MBouge($coListe[$n], $coListe[$n] + 1)
		FRadio($Radio[$coListe[$n] + 1])
	EndIf
EndFunc   ;==>MBas
Func MBouge($depart, $arrivee) ;chang
	Local $titre = @ScriptName & " Commandante", $temp
	$temp = $Avatar[$depart]
	$Avatar[$depart] = $Avatar[$arrivee]
	$Avatar[$arrivee] = $temp
	$temp = GUICtrlRead($Radio[$depart])
	GUICtrlSetState($Radio[$depart], GUICtrlRead($Radio[$arrivee]))
	GUICtrlSetState($Radio[$arrivee], $temp)
	GUICtrlSetData($Radio[$depart], getSurnom($aLog[$arrivee]))
	GUICtrlSetData($Radio[$arrivee], getSurnom($aLog[$depart]))
	$temp = ControlGetPos($titre, "", $Radio[$depart])
	GUICtrlSetPos($Avatar[$depart], 1, $temp[1])
	$temp = ControlGetPos($titre, "", $Radio[$arrivee])
	GUICtrlSetPos($Avatar[$arrivee], 1, $temp[1])
	$temp = $aLog[$depart]
	$aLog[$depart] = $aLog[$arrivee]
	$aLog[$arrivee] = $temp
EndFunc   ;==>MBouge
Func RModif() ; refaire
	Local $i = $coListe[0], $a, $n = FileOpenDialog(@ScriptName & " - Choissez le nom et rpertoire du raccourcis :", @ScriptDir, "Raccourcis (*.lnk)", 8, @ScriptName & ".lnk")
	If $n = '' Then Return 1
	TrayTip(@ScriptName, "Cration du Raccourcis en cours", 0)
	If StringRight($n, 4) <> ".lnk" Then $n &= ".lnk"
	If $AIOLog[4] = 1 Then
		$i = $coListe[1]+1
		For $a = 2 To UBound($coListe) - 1
			$i &= "," & $coListe[$a]+1
		Next
	EndIf
	If MsgBox(256+4, "Clef par dfaut", "Dsirez-vous avoir une clef par dfaut associe au raccourcis ?" & @CRLF & "Attention, la scurit de vos identifiants en sera amoindrie.") = 6 Then
		$a = InputBox("Clef par dfaut", "Veuillez entrer la clef par dfaut  associer aux surnoms choisis :", "", "*")
		If $a = "" Then $i &= ' ""'
	Else
		$i &= " Default"
	EndIf
	If MsgBox(256+4, "Graphismes", "Dsirez-vous avoir une connexion silencieuse ? (sans fentre)") = 6 Then $i &= " 1"
	FileCreateShortcut(@ScriptFullPath, $n, "", ' "' & $AIOLog[10] & '" ' & $i, "Raccourcis AIO-Log, permet de connecter un/plusieurs comptes rapidement au jeu Dofus dit par la socit Ankama-Games.")
	TrayTip("", "", 0)
EndFunc   ;==>RModif
Func RCharge() ; voir
	Local $i, $temp, $temp2, $Init, $n = FileGetShortcut(FileOpenDialog(@ScriptName & " - Slectionnez votre raccourcis :", @ScriptDir, "Raccourcis (*.lnk)", 8, @ScriptName & ".lnk"))
	If $n = "" Then Return 1
	$AIOLog[10] = ""
	$Init = StringSplit($n[2], " ")
	While $i < UBound($Init)
		If StringInStr($Init[$i], '"', 2) <> 0 Then
			$Init[$i] = StringTrimLeft($Init[$i], 1)
			$temp = $i
			While $temp < UBound($Init) - 1
				$temp += 1
				$Init[$i] &= " " & $Init[$temp]
				For $temp2 = $temp To UBound($Init) - 2
					$Init[$temp2] = $Init[$temp2 + 1]
				Next
				ReDim $Init[UBound($Init) - 1]
				If StringInStr($Init[$i], '"', 2, 1, 2) <> 0 Then ExitLoop 1
			WEnd
			$Init[$i] = StringTrimRight($Init[$i], 1)
		ElseIf StringInStr($Init[$i], "'", 2) <> 0 Then
			$Init[$i] = StringTrimLeft($Init[$i], 1)
			$temp = $i
			While $temp < UBound($Init) - 1
				$temp += 1
				$Init[$i] &= " " & $Init[$temp]
				For $temp2 = $temp To UBound($Init) - 2
					$Init[$temp2] = $Init[$temp2 + 1]
				Next
				ReDim $Init[UBound($Init) - 1]
				If StringInStr($Init[$temp], "'", 2, 1, 2) <> 0 Then ExitLoop 1
			WEnd
			$Init[$i] = StringTrimRight($Init[$i], 1)
		EndIf
		$i += 1
	WEnd
	$AIOLog[13] = $Init
EndFunc   ;==>RCharge
Func FuncLance()
	$AIOLog[3] = 1
EndFunc   ;==>FuncLance
Func Lance()
	Local $err = 0
	If $AIOLog[4] = 1 Then
		For $n = 1 To UBound($coListe) - 1
			If $coListe[$n] < UBound($Radio) Then $err = FLancer($coListe[$n], $AIOLog[6], $AIOLog[7], $AIOLog[11])
		Next
	Else
		$err = FLancer($coListe[0], $AIOLog[6], $AIOLog[7], $AIOLog[11])
	EndIf
	If $AIOLog[2] = $GUI_CHECKED And $err = 0 Or $AIOLog[14] <> 0 Then Exit
	$AIOLog[3] = $err
EndFunc   ;==>Lance
Func FLancer($compteBis, $PleinEcran = 1, $Clef = Default, $Executable = Default) ;chang, mais  voir
	Local $NDCMDP, $titre, $Surnom, $temp
	$Surnom = getSurnom($aLog[$compteBis]) ;Gestion du surnom
	If StringInStr($Surnom, "&", 0, -1, 2) > 0 Then $Surnom = StringLeft($Surnom, StringInStr($Surnom, "&") - 1) & StringTrimLeft($Surnom, StringInStr($Surnom, "&"))
	;Gestion de la clef
	If $Clef = Default Then $Clef = InputBox(@ScriptName & " - Code du compte " & $Surnom, "Veuillez entrer la clef de " & $Surnom & " :", "", "")
	If @error = 1 Then
		Return -2
	EndIf
	If $Executable = Default Then
		$Executable = getExecutable($aLog[$compteBis])
		If $Executable = "" Then
			If Not FileExists(IniRead($AIOLog[0], "Configuration", "Excuter", "")) Then
				If Not FileExists(IniRead($AIOLog[0], "Configuration", "Chemin", "") & "\" & IniRead($AIOLog[0], "Configuration", "Excuter", "")) Then
					MsgBox(80, @ScriptName, "Aucun excutable disponible pour " & $Surnom & "..." & @CRLF & "Pensez  slectionner les excutables avec les surnoms !")
					Return -1
				Else
					$Executable = IniRead($AIOLog[0], "Configuration", "Chemin", "") & "\" & IniRead($AIOLog[0], "Configuration", "Excuter", "")
				EndIf
			Else
				$Executable = IniRead($AIOLog[0], "Configuration", "Excuter", "")
			EndIf
		EndIf
	EndIf
	$temp = MsgBox(3, @ScriptName, "Lancer l'excutable de " & $Surnom & " ?" & @CRLF & Message() & @CRLF & @CRLF & "Cliquez sur Non pour ne pas charger l'excutable, et cliquez sur Annuler pour annuler." & @CRLF & $Executable, 4)
	If $temp = 2 Then Return - 3
	If $temp <> 7 Then
		If FileExists($Executable) Then
			TrayTip(@ScriptName, "Lancement de la fentre pour" & @CRLF & $Surnom & ".", 0)
			ShellExecute($Executable, "", StringLeft($Executable, StringLeft($Executable, StringInStr($Executable, "\", 0, -1))))
		EndIf
	EndIf
	TrayTip(@ScriptName, "En attente pour " & $Surnom & "." & @CRLF & "Cliquez dans la fentre, et appuyez sur [BackSpace] (souvent au-dessus de la touche Entre) pour taper les identifiants !", 0)
	pause()
	AutoItSetOption("SendKeyDelay", 20)
	AutoItSetOption("SendKeyDownDelay", 10)
	$NDCMDP = getNDC($aLog[$compteBis])
	If $NDCMDP <> "" Then
		Send("{HOME}+{END}") ;Si un pseudo est dj crit, l'effacer
		If $Clef = "" Then
			If StringLeft($NDCMDP, 2) = "0x" Then
				$Clef = ""
			Else
				Send($NDCMDP, 1)
			EndIf
		EndIf
		If $Clef <> "" Then
			If StringLeft($NDCMDP, 2) = "0x" Then
				Send(StringTrimLeft(String(BinaryToString(_Crypt_DecryptData($NDCMDP, $Clef, $CALG_AES_256))), 1), 1)
			Else
				Send(_StringEncrypt(0, $NDCMDP, $Clef), 1)
			EndIf
		EndIf
		Sleep(10 * StringLen($NDCMDP))
	EndIf
	Send("{TAB}")
	Sleep(10)
	$NDCMDP = getMDP($aLog[$compteBis])
	If $NDCMDP <> "" Then
		Send("{HOME}+{END}") ;Si un pass est dj crit, l'effacer
		If $Clef = "" Then
			If StringLeft($NDCMDP, 2) = "0x" Then
				$Clef = ""
			Else
				Send($NDCMDP, 1)
			EndIf
		EndIf
		If $Clef <> "" Then
			If StringLeft($NDCMDP, 2) = "0x" Then
				Send(StringTrimLeft(String(BinaryToString(_Crypt_DecryptData($NDCMDP, $Clef, $CALG_AES_256))), 1), 1)
			Else
				Send(_StringEncrypt(0, $NDCMDP, $Clef), 1)
			EndIf
		EndIf
		Sleep(10 * StringLen($NDCMDP))
	EndIf
	Send("{TAB}")
	Send("{ENTER}")
	If $PleinEcran = 2 Then Send("!{h}^{f}") ;Mode "plein cran" implment ! !{h} correspond  la version "1.x" de Dofus, pour le menu "Affic[h]age > Plein []cran"
	If $PleinEcran = 1 Then WinSetState ("", "", @SW_MAXIMIZE) ;Mode "Agrandie" implment ! :)
	$Clef = 0
	Return 0
EndFunc   ;==>FLancer
Func Message($temp = Default)
	Local $s
	If $temp = Default Then $temp = Random(0, 20, 1)
	Switch $temp
		Case 0
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, " (\__/)" & @CRLF & " ( ' . ' )" & @CRLF & "('')__('')")
		Case 1
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Vous pouvez aussi aller jouer dehors" & @CRLF & "avec les papillons, les fleurs et les oiseaux.")
		Case 2
			$s = IniRead($AIOLog[0], "Messages", $temp, "")
		Case 3
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "La Vie est comme cette bote de dialogue :" & @CRLF & "C'est quand elle se ferme qu'on arrive  l'essentiel.")
		Case 4
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Aucune astuce aujourd'hui, le Matre dort.")
		Case 5
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Go pexe, Noob !")
		Case 6
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, " [_ Votre message perso ici _]" & @CRLF & "3 Kamas l'annonce, pas cher !")
		Case 7
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Ding !" & @CRLF & "Il est actuellement " & @HOUR & "h" & @MIN & ".")
			If @MIN = 00 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", 700, "Blonk !" & @CRLF & "Il est actuellement " & @HOUR & "h pile.")
		Case 8
			If @HOUR > 21 Or @HOUR < 7 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", 821, "~ Laissez-moi dormir, c'est pas une heure pour se connecter !")
			If @HOUR > 6 And @HOUR < 11 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", 806, "~ Bonjour... *baille*")
			If @HOUR > 10 And @HOUR < 15 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", 810, "~ Bonap'. Vous en voulez aussi ?")
			If @HOUR > 14 And @HOUR < 19 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", 814, "~ Salut, a farte ?")
			If @HOUR > 18 And @HOUR < 22 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", 818, "~ 'Soir.")
		Case 9
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Secouez fort, sinon le Poulpe, il reste en bas.")
		Case 10
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Banane ! *_*")
		Case 11
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Alors, la pche ?")
		Case 12
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Il parat que les pinards sont utiles. Il parat.")
		Case 13
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "MWOUAHAHAHAHAHAHAHAHA")
		Case 14
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Ha, vous aussi ?")
		Case 15
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Ou pas.")
		Case 16
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Vous saviez que?")
		Case 17
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Oui, mais non. Enfin.. si, ok !")
		Case 18
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Encore ?")
		Case 19
			$s = @CRLF & IniRead($AIOLog[0], "Messages", $temp, "Vous connaissez la diffrence entre" & @CRLF & "un niripsa et un sacrieur ?")
		Case Else
			$s = @CRLF & IniRead($AIOLog[0], "Messages", "", "Rien  signaler, revenez plus tard.")
			If @YDAY = 1 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", -1, "Bonnanne " & @YEAR & " !")
			If @MON = 3 And @MDAY = 28 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", -2, "Tous ensemble :" & @CRLF & "Joyeux " & @YEAR - 1986 & "me Za'nniversaire !")
			If @MON = 4 And @MDAY = 1 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", -3, "Votre License pour le AIO-Log a expir." & @CRLF & "Maintenant, c'est 3 Kamas / utilisation.")
			If (@MON = 4 And @MDAY = 4) Or (@MON = 5 And (@MDAY = 1 Or @MDAY = 9 Or @MDAY = 12)) Or (@MON = 7 And @MDAY = 14) Or (@MON = 8 And @MDAY = 15) Or (@MON = 11 And @MDAY = 11) Then $s = @CRLF & IniRead($AIOLog[0], "Messages", -4, "'Suis pas l, je fais grve ! (_)/")
			If @MON = 11 And @MDAY = 1 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", -5, "Halloween ? 'connais pas." & @CRLF & "Bonne anne Celte, par contre !")
			If @MON = 12 And @MDAY = 25 Then $s = @CRLF & IniRead($AIOLog[0], "Messages", -6, "Noyeux Jol !")
		EndSwitch
		Return StringReplace(StringReplace(StringReplace(StringReplace($s, '" & @CRLF & "', @CRLF), '" & @MIN & "', @MIN), '" & @HOUR & "', @HOUR), '" & @YEAR & "', @YEAR)
EndFunc   ;==>Message
Func Fini()
	$AIOLog[2] = GUICtrlRead($FenBase[1])
	IniWrite($AIOLog[0], "Configuration", "Fermeture aprs connexion", $AIOLog[2])
EndFunc   ;==>Fini
Func Patience($action = "Chargement de la fentre")
	Local $Fen
	$Fen = GUICreate(@ScriptName, 300, 60)
	GUICtrlSetFont(GUICtrlCreateLabel($action & " en cours," & @CRLF & @CRLF & "Veuillez patienter.", 0, 0, 350), 8.5, 800, 2, "Comic sans MS")
	GUISetState()
	Return $Fen
EndFunc   ;==>Patience
Func quit()
	If @GUI_WinHandle = $FenBase[0] Then
		TrayTip(@ScriptName, "Fermeture du AIO-Log en cours", 0)
		PosFenetre(@ScriptName & " Commandant")
	EndIf
	GUIDelete(@GUI_WinHandle)
	If @GUI_WinHandle = $FenBase[0] Then exuit()
EndFunc   ;==>quit
Func exuit()
	Exit
EndFunc   ;==>exuit
Func Skinner() ;Module utilisateur pour changer le skin
	Local $temp = FileOpenDialog(@ScriptName & " - Slectionnez un fichier de Skin", @ScriptDir, "Paramtres de conf. (*.ini)", 1, "Skin.ini", $FenBase[0])
	If $temp = "" Then Return 1
	If $temp = $AIOLog[0] Then
		MsgBox(80, "#054:Psychokwak", "Aha, bien tent, le skin AIOLog.ini !!" & @CRLF & "..." & @CRLF & "Mais a ne marche pas.")
		Return 1
	EndIf
	If $temp <> $AIOLog[1] Then
		$AIOLog[1] = $temp
		If IniRead($AIOLog[0], "Configuration", "Dernier fichier de Skin utilis", "") <> $AIOLog[1] Then
			If MsgBox(4, "Enregistrement", "Changement de skin pour le AIO-Log dtect." & @CRLF & @CRLF & "Dsirez vous que le script s'en souvienne ?") = 6 Then IniWrite($AIOLog[0], "Configuration", "Dernier fichier de Skin utilis", $AIOLog[1])
		EndIf
	EndIf
	ChargeSkin($AIOLog[1])
	Fenetre()
EndFunc   ;==>Skinner
Func SkinMod()
	Fenetre("FenSkin")
EndFunc   ;==>SkinMod
Func SkinModifier()
	$Skin[0] = GUICtrlRead($FenSkin[1]) ;image de fond
	$Skin[1] = GUICtrlRead($FenSkin[2]) ;couleur du fond
	$Skin[2] = GUICtrlRead($FenSkin[3]) ;couleur de police
	$Skin[3] = GUICtrlRead($FenSkin[4]) ;couleur des objets
	$Skin[6] = GUICtrlRead($FenSkin[6]) ;police
	$Skin[4] = GUICtrlRead($FenSkin[5]) ;taille de police
	$Skin[5] = 0 ;attributs de police par dfaut
	If GUICtrlRead($FenSkin[7]) = $GUI_CHECKED Then $Skin[5] += 2 ;italique
	If GUICtrlRead($FenSkin[8]) = $GUI_CHECKED Then $Skin[5] += 4 ;soulign
	If GUICtrlRead($FenSkin[9]) = $GUI_CHECKED Then $Skin[5] += 8 ;barr
	$Skin[7] = Abs(GUICtrlRead($FenSkin[11])) ;sparation
	$Skin[8] = Abs(GUICtrlRead($FenSkin[12])) ;hauteur
	Fenetre()
EndFunc   ;==>SkinModifier
Func SkinAnnule()
	GUIDelete($FenSkin[0])
EndFunc   ;==>SkinAnnule
Func SkinNouveau()
	ChargeSkin()
	Fenetre()
EndFunc   ;==>SkinNouveau
Func SkinSauve()
	Local $temp, $Fen
	Do
		$temp = FileOpenDialog(@ScriptName & " - Slectionnez un fichier de Skin", @ScriptDir, "Paramtres de conf. (*.ini)", 8, "Skin.ini", $FenBase[0])
		If $temp = "" Or $temp = $AIOLog[0] Then
			If $temp = $AIOLog[0] Then MsgBox(80, "#054:Psychokwak", "Aha, bien tent, le skin AIOLog.ini !!" & @CRLF & "..." & @CRLF & "Mais a ne marche pas.")
			Return 1
		EndIf
		If FileExists($temp) Then
			If MsgBox(4, "Remplacement", "Dsirez vous vraiment remplacer ce fichier :" & @CRLF & $temp & " ?") <> 6 Then $temp = ""
		EndIf
	Until $temp <> ""
	If $temp <> IniRead($AIOLog[0], "Configuration", "Dernier fichier de Skin utilis", "") Then
		If MsgBox(4, "Enregistrement", "Changement du fichier de Skin dtect." & @CRLF & @CRLF & "Dsirez vous que le script s'en souvienne ?") = 6 Then IniWrite($AIOLog[0], "Configuration", "Dernier fichier de Skin utilis", $temp)
	EndIf
	$AIOLog[1] = $temp
	$Fen = Patience("criture du Skin")
	IniWrite($AIOLog[1], "Fentre", "Image de Fond",  $Skin[0])
	IniWrite($AIOLog[1], "Fentre", "Background color", $Skin[1])
	IniWrite($AIOLog[1], "Fentre", "Control Police color", $Skin[2])
	IniWrite($AIOLog[1], "Fentre", "Control color", $Skin[3])
	IniWrite($AIOLog[1], "Police gnrale", "taille", $Skin[4])
	IniWrite($AIOLog[1], "Police gnrale", "attribut", $Skin[5])
	IniWrite($AIOLog[1], "Police gnrale", "Font", $Skin[6])
	IniWrite($AIOLog[1], "Fentre", "Sparation", $Skin[7])
	IniWrite($AIOLog[1], "Fentre", "Hauteur", $Skin[8])
	GUIDelete($Fen)
EndFunc   ;==>SkinSauve
Func ChargeSkin($temp = "")
	Dim $Skin[9] = [IniRead($temp, "Fentre", "Image de Fond", ""), IniRead($temp, "Fentre", "Background color", -1), IniRead($temp, "Fentre", "Control Police color", -1), IniRead($temp, "Fentre", "Control color", -1), IniRead($temp, "Police gnrale", "taille", -1), IniRead($temp, "Police gnrale", "attribut", 0), IniRead($temp, "Police gnrale", "Font", ""), Abs(IniRead($temp, "Fentre", "Sparation", 1)), Abs(IniRead($temp, "Fentre", "Hauteur", 1))]
EndFunc   ;==>ChargeSkin
Func AppliqueSkin($Fen, $titre = @ScriptName)
	Local $array
	If FileExists($Skin[0]) Then ;Taille minimale avant dformation : carr de 26x26 pixels.
		$temp = GUICtrlCreatePic($Skin[0], 0, 0, 0, 0)
		GUICtrlSetState($temp, $GUI_DISABLE)
		$array = ControlGetPos($titre, "", $temp)
		If @DesktopWidth / $array[2] * @DesktopHeight / $array[3] > 2000 Then
			While @DesktopWidth / $array[2] * @DesktopHeight / $array[3] > 1000
				$array[2] *= 2
				$array[3] *= 2
			WEnd
		EndIf
		GUICtrlSetPos($temp, 0, 0, $array[2], $array[3])
		For $a = 0 To @DesktopWidth Step $array[2]
			For $b = 0 To @DesktopHeight Step $array[3]
				$temp = GUICtrlCreatePic($Skin[0], $a, $b, $array[2], $array[3])
				GUICtrlSetResizing($temp, 2 + 32 + 768)
				GUICtrlSetState($temp, $GUI_DISABLE)
			Next
		Next
	EndIf
	GUISetBkColor($Skin[1], $Fen)
	GUICtrlSetDefColor($Skin[2], $Fen)
	GUICtrlSetDefBkColor($Skin[3], $Fen)
	GUISetFont($Skin[4], 400, $Skin[5], $Skin[6], $Fen)
EndFunc   ;==>AppliqueSkin
Func Za()
	ToolTip(Message() & @CRLF & " ")
	Sleep(1500)
	ToolTip("")
EndFunc   ;==>Za
Func Info()
	ToolTip("60142 caractres et 1309 lignes de code source," & @CRLF & "pour cette version " & $MODULE_VERSION & " !")
	Sleep(2000)
	ToolTip("")
EndFunc   ;==>Info
Func _Send($sSend, $nParam = 0)
	Local $aRand, $aString, $cActual, $cLast, $i, $j, $r, $t
	If $nParam = 2 Then ;mode brouill
		$aString = StringSplit($sSend, "", 2) ;on permet d'utiliser $aString[0]
		Dim $aRand[StringLen($sSend)]
		For $i = 0 To StringLen($sSend) -1
			$aRand[$i] = $i
		Next
		;1, 2, 3, 4, etc
		For $i = 0	To	StringLen($sSend) - 1
			$r = Random(0, StringLen($sSend) - 1, 1)
			$t = $aRand[$i]
			$aRand[$i] = $aRand[$r]
			$aRand[$r] = $t
		Next
		;5, 8, 3, 2, etc
		$sMod = ''
		$cLast = $aRand[0]
		For $i = 0 To StringLen($sSend) - 1
			$cActual = $aRand[$i]
			If $cActual > $cLast Then
				For $j = 1 To $i
					If $aRand[$j - 1] < $cActual and $aRand[$j - 1] > $cLast Then Send ("{RIGHT}")
				Next
			Else;$cActual <= $cLast
				For $j = 1 To $i
					If $aRand[$j - 1] > $cActual and $aRand[$j - 1] <= $cLast Then Send("{LEFT}")
				Next
			EndIf
			$cLast = $cActual
			Send($aString[$cActual], 0)
		Next
	Else
		Send($sSend, $nParam)
	EndIf
EndFunc
Func pause()
	$p=1-$p
	while $p
		sleep(100)
	WEnd
EndFunc
#EndRegion =================================Fonctions totalement cres par Za=================================
#Region ====================================Fonctions AutoIt 3 modifies====================================
Func _FileReadToArray2($sFile)
	Local $aArray, $sStringFile = ""
	If not FileExists($sFile) Then Return -1
	$sStringFile = FileRead($sFile)
	If @error Then Return -2 ;FileRead error
	If StringInStr($sStringFile, @CRLF) Then
		$aArray = StringSplit($sStringFile, @CRLF, 3)
	Else
		$aArray = StringSplit($sStringFile, @CRLF, 2)
	EndIf
	Return $aArray
EndFunc ;==>_FileReadToArray2
Func _FileWriteFromArray2($sFile, $aArray, $iBase = 0, $iUbound = -1)
	Local $i, $sFile2Write = ""
	If $iBase > UBound($aArray) - 1 Then Return -1 ;This is an error, isn't it ?
	If Not FileExists($sFile) Then FileWrite($sFile, "")
	If Not FileExists($sFile) Then Return -2
	If $iUbound >= UBound($aArray) Then $iUbound = UBound($aArray) - 1
	If $iUbound < 0 Then $iUbound = UBound($aArray) + $iUbound ;Right-based count
	For $i = $iBase To $iUbound - 1
		$sFile2Write &= $aArray[$i] & @CRLF
	Next
	FileDelete($sFile)
	FileWrite($sFile, $sFile2Write & $aArray[$iUbound])
	Return 0
EndFunc   ;==>_FileWriteFromArray2
#EndRegion
#Region ============================================Modlisation============================================
Func getID($sCompte)
	Local $aCompte = StringSplit($sCompte, "", 2)
	Return $aCompte[0]
EndFunc
Func getSurnom($sCompte)
	Local $aCompte = StringSplit($sCompte, "", 2)
	If UBound($aCompte) < 2 Then Return ""
	Return $aCompte[1]
EndFunc
Func getAvatar($sCompte)
	Local $aCompte = StringSplit($sCompte, "", 2)
	If UBound($aCompte) < 3 Then Return ""
	Return $aCompte[2]
EndFunc
Func getNDC($sCompte)
	Local $aCompte = StringSplit($sCompte, "", 2)
	If UBound($aCompte) < 4 Then Return ""
	Return $aCompte[3]
EndFunc
Func getMDP($sCompte)
	Local $aCompte = StringSplit($sCompte, "", 2)
	If UBound($aCompte) < 5 Then Return ""
	Return $aCompte[4]
EndFunc
Func getExecutable($sCompte)
	Local $aCompte = StringSplit($sCompte, "", 2)
	If UBound($aCompte) < 6 Then Return ""
	If IniRead($AIOLog[0], "Excutables", $aCompte[5], "") <> "" Then $aCompte[5] = IniRead($AIOLog[0], "Excutables", $aCompte[5], "")
	Return $aCompte[5]
EndFunc
Func setID()
	Local $i = 0, $j = 1
	While $i < UBound($aLog)
		If getID($aLog[$i]) = $j Then
			$j += 1
			$i = 0
		EndIf
		$i += 1
	WEnd
	Return $j
EndFunc
