#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=.\Concasseur\Concasseur.ico
#AutoIt3Wrapper_outfile=Concasseur.exe
#AutoIt3Wrapper_Res_FileVersion=1.1.0.1
#AutoIt3Wrapper_Res_Field=Nom (short)|Concasseur
#AutoIt3Wrapper_Res_Field=Nom (long)|Le Concasseur de Poche
#AutoIt3Wrapper_Res_Field=Version (short)|1.1.0.1
#AutoIt3Wrapper_Res_Field=Version (long)|1.1.0.1
#AutoIt3Wrapper_Res_Field=Description|Module de simulation de concassage
#AutoIt3Wrapper_Res_Field=Type|Module
#AutoIt3Wrapper_Res_Field=Auteur|Orphi [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Options AutoIt
AutoItSetOption("MustDeclareVars", 1)

; Entte du module
Global Const _
	$MODULE_NOM = "Le Concasseur de Poche", $MODULE_AUTEUR = "Orphi", $MODULE_VERSION = "1.1.0.1", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1), $CONNECT_MODE = ($cmdLine[0] >= 1 And $cmdLine[1] = "-connect")

#cs *********** ToDo list ***********
Rentabilit
Informations gnrales
Gestion des objets
Utilisation de l'encyclopdie "Assistez-Toi!"
#ce *********************************

#cs **** Historique des versions ****
10/04/2012 1.0.0.0 Version initiale
#ce *********************************

; Compilation
#Include ".\Concasseur\Compilation.au3"

#Region Librairies AutoIt
#Include <WindowsConstants.au3>
#Include <GUIScrollBars.au3>
#Include <ScrollBarConstants.au3>

#Include <Array.au3>
#Include <EditConstants.au3>
#Include <GUIConstantsEx.au3>
#Include <StaticConstants.au3>
#EndRegion Librairies AutoIt

#Region Dclaration des Constantes
Local Const $Chemin_icone = cond(@Compiled,@ScriptName,$MODULE_DIR&'\'&'Concasseur.ico')

Local Const $Nombre_bonus = 45
;Colonnes : Nom du bonus, Poids, Nom de la rune de base, Valeur de la rune de base, Existence de runes Pa, Existence de runes Ra
Local $Liste_bonus[$Nombre_bonus][6] = [ _
	[           'Initiative',  0.1, 'Ini'          , 10, 1, 1], _ ;  0
	[                 'Pods', 0.25, 'Pod'          , 10, 1, 1], _ ;  1
	[             'Vitalit', 0.25, 'Vi'           ,  3, 1, 1], _ ;  2
	[                'Force',    1, 'Fo'           ,  1, 1, 1], _ ;  3
	[         'Intelligence',    1, 'Ine'          ,  1, 1, 1], _ ;  4
	[               'Chance',    1, 'Cha'          ,  1, 1, 1], _ ;  5
	[              'Agilit',    1, 'Age'          ,  1, 1, 1], _ ;  6
	[            'Puissance',    2, 'Do Per'       ,  1, 1, 1], _ ;  7
	['% Dommages aux Piges',    2, 'Pi Per'       ,  1, 1, 1], _ ;  8
	[    'Rsistance Neutre',    2, 'R Neutre'    ,  1, 0, 0], _ ;  9
	[     'Rsistance Terre',    2, 'R Terre'     ,  1, 0, 0], _ ; 10
	[       'Rsistance Feu',    2, 'R Feu'       ,  1, 0, 0], _ ; 11
	[       'Rsistance Eau',    2, 'R Eau'       ,  1, 0, 0], _ ; 12
	[       'Rsistance Air',    2, 'R Air'       ,  1, 0, 0], _ ; 13
	[   'Rsistance Pousse',    2, 'R Pou'       ,  1, 1, 0], _ ; 14
	[ 'Rsistance Critiques',    2, 'R Cri'       ,  1, 1, 0], _ ; 15
	[              'Sagesse',    3, 'Sa'           ,  1, 1, 1], _ ; 16
	[          'Prospection',    3, 'Prospe'       ,  1, 1, 0], _ ; 17
	[                'Tacle',    4, 'Tac'          ,  1, 1, 0], _ ; 18
	[                'Fuite',    4, 'Fui'          ,  1, 1, 0], _ ; 19
	[       'Arme de Chasse',    5, 'Chasse'       ,  1, 0, 0], _ ; 20
	[      'Dommages Neutre',    5, 'Do Neutre'    ,  1, 1, 0], _ ; 21
	[       'Dommages Terre',    5, 'Do Terre'     ,  1, 1, 0], _ ; 22
	[         'Dommages Feu',    5, 'Do Feu'       ,  1, 1, 0], _ ; 23
	[         'Dommages Eau',    5, 'Do Eau'       ,  1, 1, 0], _ ; 24
	[         'Dommages Air',    5, 'Do Air'       ,  1, 1, 0], _ ; 25
	[     'Dommages Pousse',    5, 'Do Pou'       ,  1, 1, 0], _ ; 26
	[  '% Rsistance Neutre',    6, 'R Per Neutre',  1, 0, 0], _ ; 27
	[   '% Rsistance Terre',    6, 'R Per Terre' ,  1, 0, 0], _ ; 28
	[     '% Rsistance Feu',    6, 'R Per Feu'   ,  1, 0, 0], _ ; 29
	[     '% Rsistance Eau',    6, 'R Per Eau'   ,  1, 0, 0], _ ; 30
	[     '% Rsistance Air',    6, 'R Per Air'   ,  1, 0, 0], _ ; 31
	[           'Retrait PA',    7, 'Ret Pa'       ,  1, 1, 0], _ ; 32
	[           'Retrait PM',    7, 'Ret Pme'      ,  1, 1, 0], _ ; 33
	[           'Esquive PA',    7, 'R Pa'        ,  1, 1, 0], _ ; 34
	[           'Esquive PM',    7, 'R Pme'       ,  1, 1, 0], _ ; 35
	[      'Dommages Piges',   15, 'Pi'           ,  1, 1, 0], _ ; 36
	[             'Dommages',   20, 'Do'           ,  1, 0, 0], _ ; 37
	[                'Soins',   20, 'So'           ,  1, 0, 0], _ ; 38
	[          'Invocations',   30, 'Invo'         ,  1, 0, 0], _ ; 39
	[      'Coups Critiques',   30, 'Cri'          ,  1, 0, 0], _ ; 40
	[   'Renvoi de Dommages',   30, 'Do Ren'       ,  1, 0, 0], _ ; 41
	[                   'PO',   51, 'Po'           ,  1, 0, 0], _ ; 42
	[                   'PM',   90, 'Ga Pme'       ,  1, 0, 0], _ ; 43
	[                   'PA',  100, 'Ga Pa'        ,  1, 0, 0]  _ ; 44
]

Local Const $Prefixe_rune[3] = ['', 'Pa ', 'Ra ']
Local Const $Alea_min = 0.9, $Alea_max = 1.1

Local $Intervalles_confiance[61][17] = [ _
	[-100  , 0     , 0.1   , 0.2   , 0.3   , 0.4   , 0.5   , 0.6   , 0.7   , 0.8   , 0.9   , 0.95  , 0.98  , 0.99  , 0.995 , 0.999 , 0.9999], _
	[-2    , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     , 1     ], _
	[-1.99 , 0.9121, 0.9294, 0.9467, 0.9641, 0.9814, 0.9987, 1.0161, 1.0334, 1.0508, 1.0681, 1.0768, 1.082 , 1.0837, 1.0846, 1.0853, 1.0854], _
	[-1.98 , 0.8748, 0.8993, 0.9239, 0.9484, 0.9729, 0.9975, 1.022 , 1.0466, 1.0711, 1.0957, 1.1079, 1.1153, 1.1178, 1.119 , 1.12  , 1.1202], _
	[-1.95 , 0.799 , 0.838 , 0.8769, 0.9158, 0.9547, 0.9937, 1.0326, 1.0715, 1.1104, 1.1494, 1.1688, 1.1805, 1.1844, 1.1864, 1.1879, 1.1883], _
	[-1.9  , 0.7105, 0.7658, 0.8211, 0.8765, 0.9318, 0.9872, 1.0425, 1.0978, 1.1532, 1.2085, 1.2362, 1.2528, 1.2583, 1.2611, 1.2633, 1.2638], _
	[-1.85 , 0.6397, 0.7079, 0.776 , 0.8442, 0.9123, 0.9805, 1.0486, 1.1168, 1.1849, 1.253 , 1.2871, 1.3076, 1.3144, 1.3178, 1.3205, 1.3211], _
	[-1.775, 0.5492, 0.6334, 0.7175, 0.8017, 0.8859, 0.97  , 1.0542, 1.1384, 1.2225, 1.3067, 1.3488, 1.374 , 1.3825, 1.3867, 1.39  , 1.3908], _
	[-1.7  , 0.4688, 0.5668, 0.6649, 0.763 , 0.861 , 0.9591, 1.0572, 1.1552, 1.2533, 1.3513, 1.4004, 1.4298, 1.4396, 1.4445, 1.4484, 1.4493], _
	[-1.6  , 0.3702, 0.4849, 0.5995, 0.7142, 0.8289, 0.9436, 1.0583, 1.173 , 1.2877, 1.4024, 1.4597, 1.4941, 1.5056, 1.5113, 1.5159, 1.5169], _
	[-1.5  , 0.2768, 0.4068, 0.5368, 0.6668, 0.7969, 0.9269, 1.0569, 1.1869, 1.3169, 1.447 , 1.512 , 1.551 , 1.564 , 1.5705, 1.5757, 1.5769], _
	[-1.4  , 0.1855, 0.3302, 0.4748, 0.6194, 0.7641, 0.9087, 1.0533, 1.1979, 1.3426, 1.4872, 1.5595, 1.6029, 1.6173, 1.6246, 1.6304, 1.6317], _
	[-1.3  , 0.0941, 0.253 , 0.4119, 0.5708, 0.7297, 0.8886, 1.0475, 1.2064, 1.3653, 1.5242, 1.6037, 1.6513, 1.6672, 1.6752, 1.6815, 1.6829], _
	[-1.2  , 0     , 0.1732, 0.3464, 0.5196, 0.6928, 0.866 , 1.0392, 1.2124, 1.3856, 1.5588, 1.6454, 1.6974, 1.7147, 1.7234, 1.7303, 1.7319], _
	[-1.19 , 0     , 0.1749, 0.3498, 0.5247, 0.6996, 0.8745, 1.0494, 1.2243, 1.3992, 1.5741, 1.6615, 1.714 , 1.7453, 1.7683, 1.8048, 1.8375], _
	[-1.18 , 0     , 0.174 , 0.3481, 0.5221, 0.6961, 0.8701, 1.0442, 1.2182, 1.3922, 1.5662, 1.6532, 1.7295, 1.7678, 1.797 , 1.8452, 1.8901], _
	[-1.15 , 0     , 0.1731, 0.3462, 0.5192, 0.6923, 0.8654, 1.0385, 1.2115, 1.3846, 1.5577, 1.6706, 1.7677, 1.8201, 1.8618, 1.9341, 2.005 ], _
	[-1.12 , 0     , 0.1698, 0.3397, 0.5095, 0.6794, 0.8492, 1.0193, 1.1905, 1.3664, 1.5616, 1.6867, 1.7994, 1.8624, 1.9135, 2.0043, 2.096 ], _
	[-1.09 , 0     , 0.1685, 0.337 , 0.5055, 0.674 , 0.8426, 1.0118, 1.1831, 1.3618, 1.566 , 1.7016, 1.8275, 1.8995, 1.9588, 2.0658, 2.1759], _
	[-1.05 , 0     , 0.1667, 0.3334, 0.5001, 0.6668, 0.8339, 1.0022, 1.1741, 1.3567, 1.5718, 1.7198, 1.8612, 1.9438, 2.0128, 2.1394, 2.2722], _
	[-1    , 0     , 0.1644, 0.3288, 0.4932, 0.6579, 0.8232, 0.9907, 1.1639, 1.3513, 1.5788, 1.7405, 1.899 , 1.9936, 2.0736, 2.2227, 2.382 ], _
	[-0.95 , 0     , 0.1621, 0.3243, 0.4865, 0.6491, 0.8129, 0.9799, 1.1545, 1.3465, 1.5854, 1.7593, 1.9334, 2.0389, 2.1291, 2.2992, 2.4838], _
	[-0.9  , 0     , 0.1599, 0.3197, 0.4798, 0.6404, 0.8029, 0.9697, 1.1458, 1.3422, 1.5914, 1.7765, 1.9651, 2.0808, 2.1806, 2.3707, 2.5798], _
	[-0.825, 0     , 0.1565, 0.3131, 0.47  , 0.628 , 0.7888, 0.9554, 1.1337, 1.3362, 1.5996, 1.8001, 2.0086, 2.1386, 2.2519, 2.4707, 2.7154], _
	[-0.75 , 0     , 0.1532, 0.3066, 0.4605, 0.6161, 0.7754, 0.9421, 1.1225, 1.3306, 1.6068, 1.8214, 2.0483, 2.1917, 2.3177, 2.564 , 2.8434], _
	[-0.675, 0     , 0.15  , 0.3003, 0.4514, 0.6048, 0.7629, 0.9296, 1.112 , 1.3253, 1.6131, 1.8407, 2.0848, 2.2408, 2.3791, 2.6517, 2.9651], _
	[-0.6  , 0     , 0.1469, 0.2942, 0.4427, 0.5941, 0.751 , 0.9178, 1.1021, 1.3201, 1.6187, 1.8583, 2.1187, 2.2867, 2.4366, 2.735 , 3.0818], _
	[-0.5  , 0     , 0.1429, 0.2864, 0.4317, 0.5806, 0.7361, 0.9031, 1.0897, 1.3133, 1.6251, 1.8797, 2.1604, 2.3436, 2.5085, 2.84  , 3.2306], _
	[-0.4  , 0     , 0.1391, 0.2791, 0.4213, 0.5679, 0.7222, 0.8893, 1.0779, 1.3067, 1.6306, 1.8989, 2.1987, 2.3964, 2.5755, 2.9391, 3.3728], _
	[-0.3  , 0     , 0.1355, 0.2721, 0.4115, 0.556 , 0.7092, 0.8763, 1.0668, 1.3003, 1.6351, 1.9163, 2.2341, 2.4456, 2.6384, 3.0332, 3.5093], _
	[-0.2  , 0     , 0.1321, 0.2655, 0.4023, 0.5449, 0.697 , 0.8641, 1.0562, 1.2939, 1.639 , 1.9322, 2.267 , 2.4916, 2.6977, 3.1228, 3.6408], _
	[-0.1  , 0     , 0.1288, 0.2593, 0.3936, 0.5343, 0.6854, 0.8526, 1.0461, 1.2877, 1.6422, 1.9467, 2.2976, 2.535 , 2.7538, 3.2084, 3.7677], _
	[ 0    , 0     , 0.1257, 0.2533, 0.3853, 0.5244, 0.6745, 0.8416, 1.0364, 1.2816, 1.6449, 1.96  , 2.3263, 2.5758, 2.807 , 3.2905, 3.8906], _
	[ 0.01 , 0     , 0.1255, 0.253 , 0.3849, 0.5238, 0.6738, 0.8408, 1.0356, 1.2808, 1.6446, 1.9606, 2.3287, 2.5797, 2.8127, 3.3012, 3.9099], _
	[ 0.02 , 0     , 0.1254, 0.2527, 0.3844, 0.5232, 0.6731, 0.84  , 1.0348, 1.2801, 1.6444, 1.9613, 2.331 , 2.5836, 2.8184, 3.3118, 3.9296], _
	[ 0.05 , 0     , 0.1249, 0.2518, 0.3831, 0.5215, 0.671 , 0.8377, 1.0324, 1.278 , 1.6438, 1.9633, 2.3377, 2.5949, 2.835 , 3.3435, 3.9886], _
	[ 0.1  , 0     , 0.1242, 0.2504, 0.381 , 0.5187, 0.6677, 0.8339, 1.0284, 1.2745, 1.6427, 1.9663, 2.3485, 2.613 , 2.8618, 3.3949, 4.0846], _
	[ 0.2  , 0     , 0.1228, 0.2477, 0.377 , 0.5135, 0.6614, 0.8269, 1.0211, 1.2679, 1.6404, 1.9716, 2.3683, 2.6469, 2.9123, 3.4932, 4.2729], _
	[ 0.3  , 0     , 0.1216, 0.2453, 0.3734, 0.5088, 0.6557, 0.8204, 1.0142, 1.2617, 1.638 , 1.976 , 2.3861, 2.6779, 2.9589, 3.586 , 4.4558], _
	[ 0.4  , 0     , 0.1205, 0.243 , 0.37  , 0.5045, 0.6504, 0.8144, 1.0079, 1.2559, 1.6356, 1.9798, 2.4021, 2.7062, 3.002 , 3.6734, 4.6337], _
	[ 0.5  , 0     , 0.1194, 0.241 , 0.367 , 0.5005, 0.6456, 0.8088, 1.002 , 1.2504, 1.6331, 1.983 , 2.4166, 2.7321, 3.042 , 3.7556, 4.8029], _
	[ 0.6  , 0     , 0.1185, 0.2391, 0.3642, 0.4968, 0.6411, 0.8037, 0.9964, 1.2453, 1.6307, 1.9857, 2.4298, 2.756 , 3.079 , 3.8334, 4.9652], _
	[ 0.7  , 0     , 0.1176, 0.2373, 0.3615, 0.4933, 0.6369, 0.7989, 0.9913, 1.2404, 1.6282, 1.988 , 2.4418, 2.778 , 3.1134, 3.9065, 5.1234], _
	[ 0.8  , 0     , 0.1168, 0.2357, 0.3591, 0.4901, 0.633 , 0.7944, 0.9865, 1.2358, 1.6258, 1.9899, 2.4528, 2.7984, 3.1455, 3.9755, 5.2733], _
	[ 0.9  , 0     , 0.116 , 0.2341, 0.3568, 0.4871, 0.6293, 0.7902, 0.9819, 1.2314, 1.6234, 1.9915, 2.4628, 2.8172, 3.1753, 4.0408, 5.4167], _
	[ 1    , 0     , 0.1153, 0.2327, 0.3547, 0.4844, 0.6259, 0.7863, 0.9777, 1.2273, 1.6211, 1.9929, 2.472 , 2.8347, 3.2033, 4.1026, 5.5561], _
	[ 1.2  , 0     , 0.114 , 0.2301, 0.3509, 0.4793, 0.6197, 0.7791, 0.9699, 1.2197, 1.6167, 1.995 , 2.4883, 2.8661, 3.2539, 4.2165, 5.815 ], _
	[ 1.4  , 0     , 0.1129, 0.2279, 0.3475, 0.4748, 0.6143, 0.7727, 0.9629, 1.2129, 1.6124, 1.9965, 2.5022, 2.8934, 3.2987, 4.3186, 6.0518], _
	[ 1.6  , 0     , 0.1118, 0.2258, 0.3445, 0.4709, 0.6094, 0.767 , 0.9566, 1.2066, 1.6085, 1.9975, 2.5142, 2.9175, 3.3383, 4.4109, 6.2745], _
	[ 1.8  , 0     , 0.1109, 0.224 , 0.3418, 0.4673, 0.605 , 0.7619, 0.951 , 1.201 , 1.6047, 1.9981, 2.5246, 2.9387, 3.3737, 4.4946, 6.477 ], _
	[ 2    , 0     , 0.1101, 0.2224, 0.3394, 0.4641, 0.601 , 0.7573, 0.9459, 1.1958, 1.6012, 1.9985, 2.5337, 2.9576, 3.4054, 4.5707, 6.664 ], _
	[ 2.3  , 0     , 0.109 , 0.2203, 0.3361, 0.4598, 0.5958, 0.7511, 0.939 , 1.1889, 1.5963, 1.9986, 2.5454, 2.9823, 3.4473, 4.6723, 6.9158], _
	[ 2.6  , 0     , 0.1081, 0.2184, 0.3333, 0.4561, 0.5912, 0.7457, 0.933 , 1.1827, 1.5919, 1.9984, 2.5552, 3.0033, 3.4834, 4.762 , 7.1478], _
	[ 3    , 0     , 0.107 , 0.2162, 0.3301, 0.4518, 0.5859, 0.7395, 0.926 , 1.1756, 1.5866, 1.9979, 2.566 , 3.0271, 3.5247, 4.8652, 7.4118], _
	[ 3.5  , 0     , 0.1059, 0.214 , 0.3268, 0.4474, 0.5803, 0.733 , 0.9187, 1.1679, 1.5808, 1.9969, 2.5767, 3.0514, 3.5674, 4.9745, 7.708 ], _
	[ 4    , 0     , 0.105 , 0.2121, 0.3239, 0.4436, 0.5757, 0.7275, 0.9125, 1.1615, 1.5757, 1.9958, 2.5852, 3.0712, 3.6025, 5.0663, 7.9485], _
	[ 4.5  , 0     , 0.1042, 0.2105, 0.3216, 0.4405, 0.5718, 0.7228, 0.9072, 1.1559, 1.5713, 1.9946, 2.5921, 3.0876, 3.632 , 5.144 , 8.166 ], _
	[ 5    , 0     , 0.1035, 0.2092, 0.3195, 0.4378, 0.5684, 0.7188, 0.9027, 1.1511, 1.5674, 1.9934, 2.5977, 3.1014, 3.6571, 5.2114, 8.3498], _
	[ 6    , 0     , 0.1024, 0.207 , 0.3162, 0.4333, 0.5629, 0.7123, 0.8953, 1.1432, 1.5608, 1.9912, 2.6065, 3.1233, 3.6974, 5.3204, 8.6614], _
	[ 7    , 0     , 0.1015, 0.2052, 0.3136, 0.4299, 0.5586, 0.7072, 0.8894, 1.137 , 1.5556, 1.9891, 2.6128, 3.1398, 3.7283, 5.4062, 8.9033], _
	[ 25   , 0     , 0.0946, 0.1914, 0.2929, 0.4021, 0.5238, 0.6654, 0.8412, 1.0841, 1.5074, 1.9632, 2.6495, 3.2556, 3.958 , 6.0883, 10.987]  _
]
#EndRegion Dclaration des Constantes


#Region Dclaration et initialisation des Variables
Local $Gui, $Msg, $i
Local $Label_nom, $Input_nom, $Label_type, $Combo_type, $Label_niveau, $Input_niveau, $Label_titre_bonus, $Label_titre_jets, $Label_aide, $Context_menu
Local $Sous_menu_ajouter_bonus_1, $Sous_menu_ajouter_bonus_2, $Sous_menu_ajouter_bonus_3, $Sous_menu_supprimer_bonus, $Sous_menu_charger_objet
Local $Reinitialiser_objet
Local $Bonus_ajoute[$Nombre_bonus], $Num_bonus2
Local $Decalage1 = 90, $Hauteur_ligne_bonus = 25, $Decalage2 = 90, $Hauteur_ligne_runes = 16, $Hauteur_interligne_runes = 4
Local $Nombre_bonus_actifs_max = 15, $Nombre_bonus_actifs = 0, $Num_bonus_actif
Local $ID_bonus_actifs[$Nombre_bonus_actifs_max], $Bonus_supprime[$Nombre_bonus_actifs_max]
Local $Label_bonus[$Nombre_bonus_actifs_max], $Input_bonus_min[$Nombre_bonus_actifs_max], $Label_a[$Nombre_bonus_actifs_max], $Input_bonus_max[$Nombre_bonus_actifs_max]
Local $Input_nombre_objets, $Nombre_objets, $Input_intervalle_confiance, $Intervalle_confiance
Local $Label_titre_runes, $Label_titre_jets_runes
Local $Label_titre_stats, $Label_titre_moy_stats, $Label_titre_interval_stats
Local $Button_briser_1, $Button_briser_tout, $Button_infos, $Button_rentabilite
Local $Decalage_ligne, $Niveau_objet, $Jet_min, $Jet_max, $Runes_min_moy_max[6][3]
Local $Label_runes_nom[$Nombre_bonus_actifs_max][3], $Label_runes_min[$Nombre_bonus_actifs_max][3], $Label_runes_moy[$Nombre_bonus_actifs_max][3], $Label_runes_max[$Nombre_bonus_actifs_max][3]
Local $Label_stats_nom[$Nombre_bonus_actifs_max][3], $Label_stats_int[$Nombre_bonus_actifs_max][3], $Label_stats_moy[$Nombre_bonus_actifs_max][3]
Local $Pop_Progress, $Progress_bar1, $Progress_bar2, $Progress
;Initialisation des tableaux
For $i = 0 To UBound($ID_bonus_actifs)-1
	$ID_bonus_actifs[$i] = -1
Next
For $i = 0 To UBound($Bonus_supprime)-1
	$Bonus_supprime[$i] = -1
Next
#EndRegion Dclaration et initialisation des Variables


#Region Gnration et affichage de l'interface graphique principale
$Gui = GUICreate("Le Concasseur de Poche", 735, 535)
GUISetIcon($Chemin_icone)

;Groupes
GUICtrlCreateGroup(" Objet ", 5, 50, 235, 415)
GUICtrlCreateGroup("Fragments magiques extraits par objet", 245, 50, 200, 480)
GUICtrlCreateGroup("Statistiques de brisages", 450, 50, 280, 480)
GUICtrlCreateGroup("", -99, -99, 1, 1)  ;close group

;Titres du groupe 'Objet'
$Label_nom = GUICtrlCreateLabel('Nom de l''objet', 15, 10, 100)
$Input_nom = GUICtrlCreateInput('', 15, 27, 215, 20)
$Label_type = GUICtrlCreateLabel('Type', 255, 10)
$Combo_type = GUICtrlCreateCombo("Amulette", 300, 5, 130)
GUICtrlSetData($Combo_type, "Anneau|Arc|Baguette|Bton|Bottes|Cape|Ceinture|Chapeau|Dagues|Epe|Hache|Marteau|Pelle|Sac  dos|Autre")
$Label_niveau = GUICtrlCreateLabel('Niveau', 255, 30)
$Input_niveau = GUICtrlCreateInput(200, 300, 27, 30, 20, $ES_NUMBER + $ES_RIGHT)
$Label_titre_bonus = GUICtrlCreateLabel('Bonus', 15, 70)
$Label_titre_jets = GUICtrlCreateLabel('Jets', 148, 70)
$Label_aide = GUICtrlCreateButton ('?', 215, 67, Default, 15)
GUICtrlSetTip($Label_aide, 'Clic droit n''importe o pour afficher le menu contextuel')
GUICtrlSetFont($Label_nom, Default , 800)
GUICtrlSetFont($Label_type, Default , 800)
GUICtrlSetFont($Label_niveau, Default , 800)
GUICtrlSetFont($Label_titre_bonus, Default , 800)
GUICtrlSetFont($Label_titre_jets, Default , 800)

;Titres du groupe 'Fragments'
$Label_titre_runes = GUICtrlCreateLabel('Runes', 255, 70)
$Label_titre_jets_runes = GUICtrlCreateLabel('Moy    Min  Max', 337, 70, 95)
GUICtrlSetFont($Label_titre_runes, Default , 800)
GUICtrlSetFont($Label_titre_jets_runes, Default , 800)

;Titres du groupe 'Statistiques'
GUICtrlCreateLabel('Le brisage de', 450, 10)
$Input_nombre_objets = GUICtrlCreateInput(100, 516, 7, 38, 20, $ES_NUMBER + $ES_RIGHT)
GUICtrlCreateLabel('objets permettra d''obtenir un nombre', 558, 10)
GUICtrlCreateLabel('de runes inclus dans cet intervalle, dans', 450, 30)
$Input_intervalle_confiance = GUICtrlCreateInput(95, 640, 27, 35, 20, $ES_RIGHT)
GUICtrlCreateLabel('% des cas.', 675, 30)
$Label_titre_stats = GUICtrlCreateLabel('Runes', 460, 70)
$Label_titre_interval_stats = GUICtrlCreateLabel('Intervalle', 545, 70, 100)
$Label_titre_moy_stats = GUICtrlCreateLabel('Moyenne', 660, 70, 60)
GUICtrlSetFont($Label_titre_stats, Default , 800)
GUICtrlSetFont($Label_titre_moy_stats, Default , 800)
GUICtrlSetFont($Label_titre_interval_stats, Default , 800)

;Boutons
$Button_briser_1    = GUICtrlCreateButton('Briser un objet', 5, 468 , 100 , 30)
$Button_briser_tout = GUICtrlCreateButton('Briser une pile d''objets', 107, 468 , 133 , 30)
$Button_infos       = GUICtrlCreateButton('Informations gnrales', 5, 500 , 133 , 30)
GUICtrlSetState(-1, $GUI_DISABLE)
$Button_rentabilite = GUICtrlCreateButton('Rentabilit', 140, 500 , 100 , 30)
GUICtrlSetState(-1, $GUI_DISABLE)

;Menu Contextuel
$Context_menu = GUICtrlCreateContextMenu()
$Sous_menu_ajouter_bonus_1 = GUICtrlCreateMenu('Ajouter un bonus (1)', $Context_menu)
$Sous_menu_ajouter_bonus_2 = GUICtrlCreateMenu('Ajouter un bonus (2)', $Context_menu)
$Sous_menu_ajouter_bonus_3 = GUICtrlCreateMenu('Ajouter un bonus (3)', $Context_menu)
$Sous_menu_supprimer_bonus = GUICtrlCreateMenu('Supprimer un bonus', $Context_menu)
For $Num_bonus =  0 To 15
	$Bonus_ajoute[$Num_bonus] = GUICtrlCreateMenuItem($Liste_bonus[$Num_bonus][0], $Sous_menu_ajouter_bonus_1)
Next
For $Num_bonus = 16 To 31
	$Bonus_ajoute[$Num_bonus] = GUICtrlCreateMenuItem($Liste_bonus[$Num_bonus][0], $Sous_menu_ajouter_bonus_2)
Next
For $Num_bonus = 32 To $Nombre_bonus - 1
	$Bonus_ajoute[$Num_bonus] = GUICtrlCreateMenuItem($Liste_bonus[$Num_bonus][0], $Sous_menu_ajouter_bonus_3)
Next
GUICtrlCreateMenuItem('', $Context_menu)
$Reinitialiser_objet = GUICtrlCreateMenuItem('Rinitialiser l''objet', $Context_menu)
GUICtrlCreateMenuItem('Sauvegarder l''objet', $Context_menu)
GUICtrlSetState(-1, $GUI_DISABLE)
$Sous_menu_charger_objet = GUICtrlCreateMenu('Charger un objet', $Context_menu)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateMenuItem(' partir de l''encyclopdie', $Sous_menu_charger_objet)
GUICtrlCreateMenuItem(' partir de la bibliothque personnelle', $Sous_menu_charger_objet)

;Affichage de la fentre
GUISetState(@SW_SHOW)
#EndRegion Gnration et affichage de l'interface graphique principale

;Boucle principale
While 1
	Sleep(5) ;pour allger la charge CPU

	;Acquisition du message envoy par l'interface (ID du bouton sur lequel on a appuy)
    $Msg = GUIGetMsg()

	;Fermeture de la fentre
    If $Msg = $GUI_EVENT_CLOSE Then
		Exit
	EndIf

	;Affichage du'une popup par un clic gauche sur le bouton "?"
	If $Msg = $Label_aide Then
		MsgBox(64, '', 'Clic droit n''importe o pour afficher le menu contextuel')
	EndIf

	;Ajout d'un bonus
	For $Num_bonus = 0 To $Nombre_bonus - 1
		If $Msg = $Bonus_ajoute[$Num_bonus] Then
			If $ID_bonus_actifs[$Nombre_bonus_actifs_max - 1] >= 0 Then
				MsgBox(64, 'Conseil du jour', 'Cet objet comporte trop de bonus.' & @CRLF & 'a serait dommage de le briser !')
				ExitLoop
			EndIf
			For $Num_bonus_actif = 0 To $Nombre_bonus_actifs_max - 1
				If $ID_bonus_actifs[$Num_bonus_actif] >= 0 Then ContinueLoop

				$Nombre_bonus_actifs += 1
				$ID_bonus_actifs[$Num_bonus_actif] = $Num_bonus
				$Label_bonus    [$Num_bonus_actif] = GUICtrlCreateLabel($Liste_bonus[$Num_bonus][0], 15, $Decalage1 + $Num_bonus_actif * $Hauteur_ligne_bonus)
				$Input_bonus_min[$Num_bonus_actif] = GUICtrlCreateInput(1, 145, $Decalage1 - 3 + $Num_bonus_actif * $Hauteur_ligne_bonus, 30, 20, $ES_NUMBER + $ES_RIGHT)
				$Label_a        [$Num_bonus_actif] = GUICtrlCreateLabel('', 185, $Decalage1 + $Num_bonus_actif * $Hauteur_ligne_bonus)
				$Input_bonus_max[$Num_bonus_actif] = GUICtrlCreateInput('', 200, $Decalage1 - 3 + $Num_bonus_actif * $Hauteur_ligne_bonus, 30, 20, $ES_NUMBER + $ES_RIGHT)
				$Bonus_supprime [$Num_bonus_actif] = GUICtrlCreateMenuItem($Liste_bonus[$Num_bonus][0], $Sous_menu_supprimer_bonus)
				GUICtrlSetState($Bonus_ajoute[$Num_bonus], $GUI_DISABLE)

				ExitLoop 2
			Next
		EndIf
	Next

	;Suppression d'un bonus
	For $Num_bonus_actif = 0 To $Nombre_bonus_actifs_max - 1
		If $ID_bonus_actifs[$Num_bonus_actif] >= 0 And $Msg = $Bonus_supprime[$Num_bonus_actif] Then
			$Nombre_bonus_actifs -= 1
			GUICtrlDelete($Label_bonus    [$Num_bonus_actif])
			GUICtrlDelete($Input_bonus_min[$Num_bonus_actif])
			GUICtrlDelete($Label_a        [$Num_bonus_actif])
			GUICtrlDelete($Input_bonus_max[$Num_bonus_actif])
			GUICtrlDelete($Bonus_supprime [$Num_bonus_actif])
			GUICtrlSetState($Bonus_ajoute[$ID_bonus_actifs[$Num_bonus_actif]], $GUI_ENABLE)

			For $Num_bonus = $Num_bonus_actif To $Nombre_bonus_actifs_max - 1
				If $ID_bonus_actifs[$Num_bonus] >= 0 Then
					GUICtrlSetPos($Label_bonus    [$Num_bonus],  15, $Decalage1 + ( $Num_bonus - 1 ) * $Hauteur_ligne_bonus)
					GUICtrlSetPos($Input_bonus_min[$Num_bonus], 145, $Decalage1 + ( $Num_bonus - 1 ) * $Hauteur_ligne_bonus - 3)
					GUICtrlSetPos($Label_a        [$Num_bonus], 185, $Decalage1 + ( $Num_bonus - 1 ) * $Hauteur_ligne_bonus)
					GUICtrlSetPos($Input_bonus_max[$Num_bonus], 200, $Decalage1 + ( $Num_bonus - 1 ) * $Hauteur_ligne_bonus - 3)
					If $Num_bonus < $Nombre_bonus_actifs_max - 1 Then
						$ID_bonus_actifs[$Num_bonus] = $ID_bonus_actifs[$Num_bonus + 1]
						$Bonus_supprime [$Num_bonus] = $Bonus_supprime [$Num_bonus + 1]
						$Label_bonus    [$Num_bonus] = $Label_bonus    [$Num_bonus + 1]
						$Input_bonus_min[$Num_bonus] = $Input_bonus_min[$Num_bonus + 1]
						$Label_a        [$Num_bonus] = $Label_a        [$Num_bonus + 1]
						$Input_bonus_max[$Num_bonus] = $Input_bonus_max[$Num_bonus + 1]
					Else
						$ID_bonus_actifs[$Num_bonus] = -1
						$Bonus_supprime [$Num_bonus] = -1
						$Label_bonus    [$Num_bonus] = -1
						$Input_bonus_min[$Num_bonus] = -1
						$Label_a        [$Num_bonus] = -1
						$Input_bonus_max[$Num_bonus] = -1
					EndIf
				Else
					ExitLoop
				EndIf
			Next

			ExitLoop
		EndIf
	Next

	;Brisage d'un objet ou d'une pile d'objets
    If $Msg = $Button_briser_1 Or $Msg = $Button_briser_tout Then
		$Nombre_objets = cond($Msg = $Button_briser_tout, GUICtrlRead($Input_nombre_objets), 0)
		$Intervalle_confiance = Round(GUICtrlRead($Input_intervalle_confiance), 3)
		$Intervalle_confiance /= 100

		$Pop_Progress = GUICreate("Calcul en cours...", 220, 40)
		$Progress_bar1 = GUICtrlCreateProgress(0, 0, 220, 20)
		$Progress_bar2 = GUICtrlCreateProgress(0, 20, 220, 20)
		$Progress = 0
		GUISetState(@SW_SHOW)
		GUISwitch($Gui)

		$Decalage_ligne = - $Hauteur_ligne_runes - $Hauteur_interligne_runes
		For $Num_bonus_actif = 0 To $Nombre_bonus_actifs_max - 1
			For $i = 0 To 2
				If $Label_runes_nom[$Num_bonus_actif][$i] <> '' Then
					GUICtrlDelete($Label_runes_nom[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_runes_min[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_runes_moy[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_runes_max[$Num_bonus_actif][$i])
					$Label_runes_nom[$Num_bonus_actif][$i] = ''
					$Label_runes_min[$Num_bonus_actif][$i] = ''
					$Label_runes_moy[$Num_bonus_actif][$i] = ''
					$Label_runes_max[$Num_bonus_actif][$i] = ''
				EndIf
				If $Label_stats_nom[$Num_bonus_actif][$i] <> '' Then
					GUICtrlDelete($Label_stats_nom[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_stats_int[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_stats_moy[$Num_bonus_actif][$i])
					$Label_stats_nom[$Num_bonus_actif][$i] = ''
					$Label_stats_int[$Num_bonus_actif][$i] = ''
					$Label_stats_moy[$Num_bonus_actif][$i] = ''
				EndIf
			Next
		Next

		For $Num_bonus_actif = 0 To $Nombre_bonus_actifs_max - 1
			GUISwitch($Pop_Progress)
			If $Nombre_bonus_actifs > 0 Then
				$Progress = ( $Num_bonus_actif + 1 ) / $Nombre_bonus_actifs * 100
			EndIf
			GUICtrlSetData($Progress_bar1, $Progress)
			GUISwitch($Gui)

			$Num_bonus = $ID_bonus_actifs[$Num_bonus_actif]
			If $Num_bonus >= 0 Then
				$Niveau_objet = GUICtrlRead($Input_niveau)
				$Jet_min = GUICtrlRead($Input_bonus_min[$Num_bonus_actif])
				$Jet_max = Max( $Jet_min, Number( GUICtrlRead($Input_bonus_max[$Num_bonus_actif]) ) )

				$Runes_min_moy_max = Runes_min_moy_max($Liste_bonus, $Alea_min, $Alea_max, $Niveau_objet, $Num_bonus, $Jet_min, $Jet_max, $Nombre_objets, $Intervalle_confiance, $Intervalles_confiance)

				$Decalage_ligne += $Hauteur_interligne_runes
				For $i = 0 To 2
					If  ( $i = 1 And ( Not $Liste_bonus[$Num_bonus][4] Or ( $Runes_min_moy_max[0][1] = 0 And $Runes_min_moy_max[2][1] = 0 ) ) ) Or _
						( $i = 2 And ( Not $Liste_bonus[$Num_bonus][5] Or ( $Runes_min_moy_max[0][2] = 0 And $Runes_min_moy_max[2][2] = 0 ) ) ) Then ContinueLoop

					$Decalage_ligne += $Hauteur_ligne_runes
					$Label_runes_nom[$Num_bonus_actif][$i] = GUICtrlCreateLabel($Prefixe_rune[$i] & $Liste_bonus[$Num_bonus][2], 255, $Decalage2 + $Decalage_ligne)
					$Label_runes_min[$Num_bonus_actif][$i] = GUICtrlCreateLabel($Runes_min_moy_max[1][$i], 330, $Decalage2 + $Decalage_ligne, 30, Default, $SS_RIGHT)
					$Label_runes_moy[$Num_bonus_actif][$i] = GUICtrlCreateLabel($Runes_min_moy_max[0][$i], 375, $Decalage2 + $Decalage_ligne, 20, Default, $SS_RIGHT)
					$Label_runes_max[$Num_bonus_actif][$i] = GUICtrlCreateLabel($Runes_min_moy_max[2][$i], 405, $Decalage2 + $Decalage_ligne, 20, Default, $SS_RIGHT)

					If $Msg = $Button_briser_tout Then
						$Label_stats_nom[$Num_bonus_actif][$i] = GUICtrlCreateLabel($Prefixe_rune[$i] & $Liste_bonus[$Num_bonus][2], 460, $Decalage2 + $Decalage_ligne)
						$Label_stats_int[$Num_bonus_actif][$i] = GUICtrlCreateLabel('[ ' & $Runes_min_moy_max[3][$i] & ' ; ' & $Runes_min_moy_max[5][$i] & ' ]', 545, $Decalage2 + $Decalage_ligne)
						$Label_stats_moy[$Num_bonus_actif][$i] = GUICtrlCreateLabel($Runes_min_moy_max[4][$i], 660, $Decalage2 + $Decalage_ligne, 50, Default, $SS_RIGHT)
					EndIf
				Next
			EndIf
		Next
		GUIDelete($Pop_Progress)
	EndIf

	;Rinitialisation de l'objet
	If $Msg = $Reinitialiser_objet Then
		GUICtrlSetData($Input_nom, "")
		GUICtrlSetData($Input_niveau, 200)

		For $Num_bonus_actif = 0 To $Nombre_bonus_actifs_max - 1
			If $ID_bonus_actifs[$Num_bonus_actif] >= 0 Then
				GUICtrlDelete($Label_bonus    [$Num_bonus_actif])
				GUICtrlDelete($Input_bonus_min[$Num_bonus_actif])
				GUICtrlDelete($Label_a        [$Num_bonus_actif])
				GUICtrlDelete($Input_bonus_max[$Num_bonus_actif])
				GUICtrlDelete($Bonus_supprime [$Num_bonus_actif])
				GUICtrlSetState($Bonus_ajoute[$ID_bonus_actifs[$Num_bonus_actif]], $GUI_ENABLE)
				$ID_bonus_actifs[$Num_bonus_actif] = -1
				$Bonus_supprime [$Num_bonus_actif] = -1
				$Label_bonus    [$Num_bonus_actif] = -1
				$Input_bonus_min[$Num_bonus_actif] = -1
				$Label_a        [$Num_bonus_actif] = -1
				$Input_bonus_max[$Num_bonus_actif] = -1
			EndIf
		Next

		For $Num_bonus_actif = 0 To $Nombre_bonus_actifs_max - 1
			For $i = 0 To 2
				If $Label_runes_nom[$Num_bonus_actif][$i] <> '' Then
					GUICtrlDelete($Label_runes_nom[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_runes_min[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_runes_moy[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_runes_max[$Num_bonus_actif][$i])
					$Label_runes_nom[$Num_bonus_actif][$i] = ''
					$Label_runes_min[$Num_bonus_actif][$i] = ''
					$Label_runes_moy[$Num_bonus_actif][$i] = ''
					$Label_runes_max[$Num_bonus_actif][$i] = ''
				EndIf
				If $Label_stats_nom[$Num_bonus_actif][$i] <> '' Then
					GUICtrlDelete($Label_stats_nom[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_stats_int[$Num_bonus_actif][$i])
					GUICtrlDelete($Label_stats_moy[$Num_bonus_actif][$i])
					$Label_stats_nom[$Num_bonus_actif][$i] = ''
					$Label_stats_int[$Num_bonus_actif][$i] = ''
					$Label_stats_moy[$Num_bonus_actif][$i] = ''
				EndIf
			Next
		Next

	EndIf


WEnd ;fin de la boucle principale


;**********************************************************************************************************************
;***************************************** Fonctions Mathmatiques Gnrales ******************************************
;**********************************************************************************************************************

;****************************************** Fonction conditionnelle rapide ********************************************
Func cond($cond, $true, $false)
	If $cond Then Return $true
	Return $false
EndFunc ;**************************************************************************************************************

;********************************* Fonction pour calculer le minimum de deux nombres **********************************
Func Min($Nombre1, $Nombre2)
	Return cond($Nombre1 < $Nombre2, $Nombre1, $Nombre2)
EndFunc ;**************************************************************************************************************

;********************************* Fonction pour calculer le maximum de deux nombres **********************************
Func Max($Nombre1, $Nombre2)
	Return cond($Nombre1 < $Nombre2, $Nombre2, $Nombre1)
EndFunc ;**************************************************************************************************************

;************************** Fonction pour afficher les nombres avec un sparateur milliers ****************************
Func Separe_000($Nombre, $Separateur)
	If Not IsNumber($Nombre) Then Return ""
	If Floor($Nombre) < 1000 Then Return ""&$Nombre
	Return Separe_000(Floor($Nombre/1000), $Separateur) & $Separateur & StringFormat("%03d", Mod($Nombre, 1000))
EndFunc ;**************************************************************************************************************


;**********************************************************************************************************************
;*********************************************** Fonctions Spcifiques ************************************************
;**********************************************************************************************************************

;************************* Fonction calculant le taux d'extraction de puissance d'un bonus ****************************
Func Taux_d_extraction($Niveau_objet, $Poids_bonus, $Jet_bonus)
	Local Const $Taux_max = 2/3
	Local $Taux_de_base, $Taux_d_extraction

	;Gestion des erreurs sur les paramtres
	If $Niveau_objet < 1 Or $Poids_bonus <= 0 Or $Jet_bonus < 1 Then Return 0

	;Calcul du taux d'extraction
	If $Jet_bonus > Ceiling($Poids_bonus) Then Return $Taux_max

	$Taux_de_base = 3 * $Niveau_objet * $Niveau_objet / 200 / $Poids_bonus ^(5/4)

	$Taux_d_extraction = Min( $Taux_max, $Taux_de_base + ( $Jet_bonus - 1 ) / $Poids_bonus * ( $Taux_max - $Taux_de_base ) )

	Return $Taux_d_extraction
EndFunc ;**************************************************************************************************************

;*************** Fonction calculant le nombre de runes extraites  partir de la puissance d'un bonus ******************
Func Puissance_to_runes(ByRef $Liste_bonus, $Num_bonus, $Puissance_extraite, $Inf_Sup)
	Local Const $Tr[11] = [0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 2]
	Local Const $Seuils_Pa[3]  = [5, 16, 50], $Seuils_Ra[3]  = [20, 62, 200]
	Local Const $Valeurs_Pa[3] = [3, 10, 30], $Valeurs_Ra[3] = [10, 30, 100]
	Local $Seuil_Pa  = $Seuils_Pa [$Tr[$Liste_bonus[$Num_bonus][3]]], $Seuil_Ra  = $Seuils_Ra [$Tr[$Liste_bonus[$Num_bonus][3]]]
	Local $Valeur_Pa = $Valeurs_Pa[$Tr[$Liste_bonus[$Num_bonus][3]]], $Valeur_Ra = $Valeurs_Ra[$Tr[$Liste_bonus[$Num_bonus][3]]]
	Local $Runes[3] = [$Puissance_extraite, 0, 0]

	;Calcul pour les bonus n'ayant ni runes Pa, ni runes Ra
	If Not $Liste_bonus[$Num_bonus][4] And Not $Liste_bonus[$Num_bonus][5] Then Return $Runes

	;Calcul pour les bonus ayant des runes Pa, mais pas de runes Ra
	If Not $Liste_bonus[$Num_bonus][5] Then
		$Runes[1] = Floor( $Runes[0] / $Seuil_Pa )
		If Not Mod( $Runes[0] , $Seuil_Pa ) And $Inf_Sup = 'Inf' Then $Runes[1] -= 1 ;Si la puissance est divisible par $Seuil_Pa Et qu'on veut la valeur infrieure

		$Runes[0] -= $Valeur_Pa * $Runes[1]

		Return $Runes
	EndIf

	;Calcul pour les bonus ayant tous les types de runes
	$Runes[2] = Floor( $Runes[0] / $Seuil_Ra )
	If Not Mod( $Runes[0] , $Seuil_Ra ) And $Inf_Sup = 'Inf' Then $Runes[2] -= 1 ;Si la puissance est divisible par $Seuil_Ra Et qu'on veut la valeur infrieure

	$Runes[0] -= $Valeur_Ra * $Runes[2]

	$Runes[1] = Floor( $Runes[0] / $Seuil_Pa )
	If Not Mod( $Runes[0] , $Seuil_Pa ) And $Inf_Sup = 'Inf' Then $Runes[1] -= 1 ;Si la puissance restante est divisible par $Seuil_Pa Et qu'on veut la valeur infrieure

	$Runes[0] -= $Valeur_Pa * $Runes[1]
	$Runes[0] /= $Liste_bonus[$Num_bonus][3]

	Return $Runes
EndFunc ;**************************************************************************************************************

;*********** Fonction calculant la frquence d'occurence d'une puissance aprs application de l'alatoire *************
Func Frequence_apres_aleatoire($Alea_min, $Alea_max, $Jet_bonus, $Taux_d_extraction, $Puissance_extraite, $Inf_Sup)
	Local Const $Infini = 10000
	Local Const $Alea_moy = ( $Alea_min + $Alea_max ) / 2, $Alea_diff = $Alea_max - $Alea_min
	Local Const $Jet_min = $Jet_bonus * $Taux_d_extraction * $Alea_min
	Local Const $Jet_max = $Jet_bonus * $Taux_d_extraction * $Alea_max

	;Calcul de la frquence dans les diffrents cas possibles
	Switch $Inf_Sup
		Case 'Inf'
			Switch $Jet_min
				Case 0 To $Puissance_extraite - 1
					Switch $Jet_max
						Case $Puissance_extraite - 1 To $Puissance_extraite
							;Cas 3g
							Return ( 1 - 2 * $Puissance_extraite + $Puissance_extraite ^ 2 ) / 2 / $Alea_diff / $Taux_d_extraction / $Jet_bonus - _
								$Alea_max * ( $Puissance_extraite - 1 ) / $Alea_diff + $Alea_max ^ 2 * $Taux_d_extraction * $Jet_bonus / 2 / $Alea_diff

						Case $Puissance_extraite     To $Infini
							;Cas 1g
							Return 1 / 2 / $Alea_diff / $Taux_d_extraction / $Jet_bonus
					EndSwitch

				Case $Puissance_extraite - 1 To $Puissance_extraite
					Switch $Jet_max
						Case $Puissance_extraite - 1 To $Puissance_extraite
							;Cas 4g
							Return 1 - $Puissance_extraite + $Alea_moy * $Taux_d_extraction * $Jet_bonus

						Case $Puissance_extraite     To $Infini
							;Cas 2g
							Return $Puissance_extraite * ( 2 - $Puissance_extraite ) / 2 / $Alea_diff / $Taux_d_extraction / $Jet_bonus + _
								$Alea_min * ( $Puissance_extraite - 1 ) / $Alea_diff - $Alea_min ^ 2 * $Taux_d_extraction * $Jet_bonus / 2 / $Alea_diff
					EndSwitch
			EndSwitch

		Case 'Sup'
			Switch $Jet_min
				Case 0 To $Puissance_extraite
					Switch $Jet_max
						Case $Puissance_extraite     To $Puissance_extraite + 1
							;Cas 2d
							Return - $Puissance_extraite * ( 2 + $Puissance_extraite ) / 2 / $Alea_diff / $Taux_d_extraction / $Jet_bonus + _
								$Alea_max * ( $Puissance_extraite + 1 ) / $Alea_diff - $Alea_max ^ 2 * $Taux_d_extraction * $Jet_bonus / 2 / $Alea_diff

						Case $Puissance_extraite + 1 To $Infini
							;Cas 1d
							Return 1 / 2 / $Alea_diff / $Taux_d_extraction / $Jet_bonus
					EndSwitch

				Case $Puissance_extraite To $Puissance_extraite + 1
					Switch $Jet_max
						Case $Puissance_extraite     To $Puissance_extraite + 1
							;Cas 4d
							Return 1 + $Puissance_extraite - $Alea_moy * $Taux_d_extraction * $Jet_bonus

						Case $Puissance_extraite + 1 To $Infini
							;Cas 3d
							Return ( 1 + 2 * $Puissance_extraite + $Puissance_extraite ^ 2 ) / 2 / $Alea_diff / $Taux_d_extraction / $Jet_bonus - _
								$Alea_min * ( $Puissance_extraite + 1 ) / $Alea_diff + $Alea_min ^ 2 * $Taux_d_extraction * $Jet_bonus / 2 / $Alea_diff
					EndSwitch
			EndSwitch
	EndSwitch

	Return 0
EndFunc ;**************************************************************************************************************

;******************** Fonction calculant le nombre de runes extraites selon les jets d'un bonus ***********************
Func Runes_min_moy_max(ByRef $Liste_bonus, $Alea_min, $Alea_max, $Niveau_objet, $Num_bonus, $Jet_min, $Jet_max, $Nombre_objets, $Intervalle_confiance, ByRef $IC)
	Local $Jet_bonus, $Taux_d_extraction, $Puissance_min, $Puissance_max, $Puissance_extraite, $Minimum = 0
	Local $Array_Inf_Sup[2] = ['Inf', 'Sup'], $Inf_Sup, $Frequence, $Progress = 0, $i, $z, $k
	Local $Moyenne, $Ecart_type, $Ecart_symetrique, $Ecart_asymetrique, $Variance[3] = [0,0,0]
	Local $Asymetrie[3] = [0,0,0], $Skewness, $Aplatissement[3] = [0,0,0], $Kurtosis
	Local $Z_normal, $Z_modif, $Intervalle_min, $Intervalle_max
	Local $Runes[3], $Runes_min_moy_max[6][3] = [[0,0,0],[0,0,0],[0,0,0],[10000,10000,10000],[0,0,0],[0,0,0]]

	For $Jet_bonus = $Jet_min To $Jet_max
		$Taux_d_extraction = Taux_d_extraction($Niveau_objet, $Liste_bonus[$Num_bonus][1], $Jet_bonus)
		If $Taux_d_extraction = 0 Then ContinueLoop
		$Puissance_min = Floor  ( $Jet_bonus * $Taux_d_extraction * $Alea_min )
		$Puissance_max = Ceiling( $Jet_bonus * $Taux_d_extraction * $Alea_max )

		For $Puissance_extraite = $Puissance_min To $Puissance_max
			For $Inf_Sup In $Array_Inf_Sup
				$Frequence  = Frequence_apres_aleatoire($Alea_min, $Alea_max, $Jet_bonus, $Taux_d_extraction, $Puissance_extraite, $Inf_Sup)
				If $Frequence > 0 Then
					$Runes = Puissance_to_runes($Liste_bonus, $Num_bonus, $Puissance_extraite, $Inf_Sup)
					For $i = 0 To 2
						$Runes_min_moy_max[0][$i] = cond($Minimum = 0, Floor($Runes[$i]), $Runes_min_moy_max[0][$i])
						$Runes_min_moy_max[1][$i] += $Frequence * $Runes[$i]
						$Runes_min_moy_max[2][$i] = Ceiling($Runes[$i])
						If $Nombre_objets > 0 Then
							$Runes_min_moy_max[3][$i] = cond($Runes[$i] < $Runes_min_moy_max[3][$i], Floor($Runes[$i]),   $Runes_min_moy_max[3][$i])
							$Runes_min_moy_max[5][$i] = cond($Runes[$i] > $Runes_min_moy_max[5][$i], Ceiling($Runes[$i]), $Runes_min_moy_max[5][$i])
							$Variance[$i]      += $Frequence * $Runes[$i] * $Runes[$i]
							$Asymetrie[$i]     += $Frequence * $Runes[$i] * $Runes[$i] * $Runes[$i]
							$Aplatissement[$i] += $Frequence * $Runes[$i] * $Runes[$i] * $Runes[$i] * $Runes[$i]
						EndIf
					Next
					$Minimum = 1
				EndIf
			Next
		Next

		GUISwitch($Pop_Progress)
		$Progress = ( $Jet_bonus - $Jet_min + 1 ) / ( $Jet_max - $Jet_min + 1 ) * 100
		GUICtrlSetData($Progress_bar2, $Progress)
		If GUIGetMsg() = $GUI_EVENT_CLOSE Then ExitLoop 2
		GUISwitch($Gui)
	Next

	For $i = 0 To 2
		$Runes_min_moy_max[1][$i] /= ( $Jet_max - $Jet_min + 1 )
		If $Nombre_objets > 0 Then
			$Moyenne = $Runes_min_moy_max[1][$i]
			$Runes_min_moy_max[4][$i] = $Moyenne * $Nombre_objets
			$Runes_min_moy_max[3][$i] = Floor($Runes_min_moy_max[3][$i] * $Nombre_objets)
			$Runes_min_moy_max[5][$i] = Ceiling($Runes_min_moy_max[5][$i] * $Nombre_objets)

			If IsNumber($Intervalle_confiance) And $Intervalle_confiance < 1 And $Intervalle_confiance > 0 Then
				$Variance[$i]      /= ( $Jet_max - $Jet_min + 1 )
				$Asymetrie[$i]     /= ( $Jet_max - $Jet_min + 1 )
				$Aplatissement[$i] /= ( $Jet_max - $Jet_min + 1 )
				$Aplatissement[$i] += ( - 4 * $Moyenne * $Asymetrie[$i] + 6 * $Moyenne * $Moyenne * $Variance[$i] - 3 * $Moyenne * $Moyenne * $Moyenne * $Moyenne )
				$Asymetrie[$i]     += ( - 3 * $Moyenne * $Variance[$i]  + 2 * $Moyenne * $Moyenne * $Moyenne )
				$Variance[$i]      += ( -     $Moyenne * $Moyenne )
				$Ecart_type         = Sqrt( Max($Variance[$i], 0) )
				If $Ecart_type > 1e-5 Then
					$Asymetrie[$i]     /= ( $Ecart_type * $Ecart_type * $Ecart_type )
					$Skewness           = $Asymetrie[$i]
					$Aplatissement[$i] /= ( $Ecart_type * $Ecart_type * $Ecart_type * $Ecart_type )
					$Aplatissement[$i] -= 3
					$Kurtosis           = $Aplatissement[$i] / $Nombre_objets
				Else
					$Skewness           = 0
					$Kurtosis           = 0
				EndIf

				;Interpolation de $Z_normal
				For $z = 2 To 16
					If $Intervalle_confiance <= $IC[0][$z] Then ExitLoop
				Next
				$z = Min($z, 16)
				For $k = 2 To 60
					If $Kurtosis <= $IC[$k][0] Then ExitLoop
				Next
				$k = Min($k, 60)

				$Z_normal = (  $IC[$k][$z]     * ($Intervalle_confiance - $IC[0][$z-1]) * ($Kurtosis - $IC[$k-1][0])   _
				             + $IC[$k][$z-1]   * ($IC[0][$z]  -  $Intervalle_confiance) * ($Kurtosis - $IC[$k-1][0])   _
				             + $IC[$k-1][$z]   * ($Intervalle_confiance - $IC[0][$z-1]) * ($IC[$k][0]  -  $Kurtosis)   _
				             + $IC[$k-1][$z-1] * ($IC[0][$z]  -  $Intervalle_confiance) * ($IC[$k][0]  -  $Kurtosis) ) _
						     / ($IC[0][$z] - $IC[0][$z-1]) / ($IC[$k][0] - $IC[$k-1][0])
				$Z_modif = (1 + 2 * $Z_normal * $Z_normal) / 6

				;Dtermination de l'intervalle de confiance
				$Moyenne = $Moyenne * $Nombre_objets
				$Ecart_symetrique  = $Z_normal * $Ecart_type * Sqrt($Nombre_objets)
				$Ecart_symetrique *= Sqrt(1 + $Z_modif * $Z_modif * $Skewness * $Skewness / $Nombre_objets)
				$Ecart_asymetrique = $Z_modif * $Ecart_type * $Skewness

				$Intervalle_min = $Moyenne - $Ecart_symetrique + $Ecart_asymetrique
				$Intervalle_max = $Moyenne + $Ecart_symetrique + $Ecart_asymetrique

				$Runes_min_moy_max[3][$i] = Floor(Max($Intervalle_min, $Runes_min_moy_max[3][$i]))
				$Runes_min_moy_max[5][$i] = Ceiling(Min($Intervalle_max, $Runes_min_moy_max[5][$i]))
			EndIf

			$Runes_min_moy_max[3][$i] = Separe_000( $Runes_min_moy_max[3][$i], ' ' )
			$Runes_min_moy_max[5][$i] = Separe_000( $Runes_min_moy_max[5][$i], ' ' )
			Switch $Runes_min_moy_max[4][$i]
				Case 0 To 0.000001
					$Runes_min_moy_max[4][$i] = 0
				Case 0.000001 To 9.999999
					$Runes_min_moy_max[4][$i] = Round( $Runes_min_moy_max[4][$i], 2 )
				Case 10 To 999.999999
					$Runes_min_moy_max[4][$i] = Round( $Runes_min_moy_max[4][$i], 1 )
				Case Else
					$Runes_min_moy_max[4][$i] = Separe_000( Round( $Runes_min_moy_max[4][$i], 0 ), ' ')
			EndSwitch
		EndIf

		Switch $Runes_min_moy_max[1][$i]
			Case 0 To 0.000001
				$Runes_min_moy_max[1][$i] = 0
			Case 0.000001 To 0.999999
				$Runes_min_moy_max[1][$i] = String( Round( $Runes_min_moy_max[1][$i], 3 ) * 100 ) & '%'
			Case 1 To 9.999
				$Runes_min_moy_max[1][$i] = Round( $Runes_min_moy_max[1][$i], 2 )
			Case Else
				$Runes_min_moy_max[1][$i] = Round( Number($Runes_min_moy_max[1][$i]), 1 )
		EndSwitch
	Next

	Return $Runes_min_moy_max
EndFunc ;**************************************************************************************************************