#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Connexion\Connexion.ico
#AutoIt3Wrapper_outfile=Connexion.exe
#AutoIt3Wrapper_Res_Fileversion=1.4.0.0
#AutoIt3Wrapper_Res_Field=Nom (short)|Connexion
#AutoIt3Wrapper_Res_Field=Nom (long)|Connexion
#AutoIt3Wrapper_Res_Field=Version (short)|1.4
#AutoIt3Wrapper_Res_Field=Version (long)|1.4.0.0
#AutoIt3Wrapper_Res_Field=Description|Module de connexion calibrable
#AutoIt3Wrapper_Res_Field=Type|Connexion
#AutoIt3Wrapper_Res_Field=Auteur|ZDS [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Entte du module
Global Const _
	$MODULE_NOM = "Connexion", $MODULE_AUTEUR = "ZDS", $MODULE_VERSION = "1.4", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1), $CONNECT_MODE = ($cmdLine[0] >= 1 And $cmdLine[1] = "-connect")

#Region Librairies AutoIt
;~ #Include <WinAPI.au3>
Func _WinAPI_GetAncestor($hWnd, $iFlags = 1)
	Local $aResult = DllCall("user32.dll", "hwnd", "GetAncestor", "hwnd", $hWnd, "uint", $iFlags)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc
;~ #Include <GUIConstantsEx.au3>
Global Const $GUI_SHOW = 16
Global Const $GUI_HIDE = 32
Global Const $GUI_ENABLE = 64
Global Const $GUI_DISABLE = 128
;~ #Include <String.au3>
Func _HexToString($strHex)
	If StringLeft($strHex, 2) = "0x" Then Return BinaryToString($strHex)
	Return BinaryToString("0x" & $strHex)
EndFunc
#EndRegion

#Region Librairies nAiO
#Include ".\Connexion\Compilation.au3"
#Include "..\Include\Modelisation\Compte.au3"
#Include "..\Include\Controle Souris.au3"
Func si($cond, $true, $false)
	If $cond Then Return $true
	Return $false
EndFunc
Func min($a, $b)
	Return si($a<$b,$a,$b)
EndFunc
Func max($a, $b)
	Return si($a>$b,$a,$b)
EndFunc
Func min_max($a, $b, $c)
	Return min(max($a,$b),$c)
EndFunc
#EndRegion

; Initialisation
Global Const $fichierCfg = $MODULE_DIR&"\"&$MODULE_NOM&".ini"

; Liste des fentres
Global $FENETRES_EN_COURS = newArray(), $FENETRES = newArray(), $TRAYTIP_TIMER = TimerInit(), $TRAYTIP_TIMER_START = TimerInit()
Global $stopLogin = False
OnAutoItExitRegister("exitScript")

; Gestion des parametres d'excution
Local $clef = $DEFAULT_Key, $fullscreen = 0, $i = 2, $listeComptes = newListeComptes(), $profil = ""
While $i <= $cmdLine[0]
	$cmd = $cmdLine[$i]
	Switch StringLower($cmd)
	Case "-f"
		; Spcifique aux modules avec IG
	Case "-d"
		$fullscreen = Number($cmdLine[min($i+1,$cmdLine[0])])
		If $fullscreen <> 1 And $fullscreen <> 2 Then $fullscreen = 0
		$i = $i + 1
	Case "-c","-key"
		$clef = _HexToString($cmdLine[min($i+1,$cmdLine[0])])
		$i = $i + 1
	Case "-profil"
		$profil = _HexToString($cmdLine[min($i+1,$cmdLine[0])])
		$i = $i + 1
	Case Else
		addToListeComptes($listeComptes, convertLigneToCompte(_HexToString($cmdLine[$i])))
	EndSwitch
	$i = $i + 1
WEnd

; Rcapitulatif
If $CONNECT_MODE Then
	configTrayTip( _
		si($profil="", "", "Profil utilis : " & $profil & @CRLF) & _
		"Nombre de comptes : " & getListeComptesLength($listeComptes) & @CRLF & _
		"Plein cran : " & $fullscreen _
		, 1 _
	)
EndIf

#Region Prparation des paramtres
Global Const $DofusMod_Ratio[2] = [900,720]
Global Const $CalibrageKeyIds[7][2] = [ [ 6 , "" ] _
	, [ "{INSERT}",      "Insert"       ] _
	, [ "{BACKSPACE}",   "Backspace"    ] _
	, [ "{TAB}",         "Tabulation"   ] _
	, [ "{NUMPADENTER}", "Entre (Num)" ] _
	, [ "{DELETE}",      "Supprime"     ] _
	, [ "",             "Touche ''"   ] _
]
Global Const $StringSendModes[7][2] = [ [ 6 , "" ] _
	, [ "1",  "Niveau 1"  ] _
	, [ "1X", "Niveau 1*" ] _
	, [ "2",  "Niveau 2"  ] _
	, [ "2X", "Niveau 2*" ] _
	, [ "3",  "Niveau 3"  ] _
	, [ "3X", "Niveau 3*" ] _
]
Global _
	$isTotallyConfigured    = isTotallyConfigured($fichierCfg),                                                                                                 _
	$StringSendMode         = Number(IniRead($fichierCfg, $MODULE_NOM,      "StringSendMode",         "1")),                                                    _
	$ConnexionPath          = IniRead($fichierCfg, $MODULE_NOM,             "ConnexionPath",          getDefaultConnexionPath()&"\UpLauncher.exe"),             _
	$SendKeyDelay           = IniRead($fichierCfg, $MODULE_NOM,             "SendKeyDelay",           "20"),                                                    _
	$SendKeyDownDelay       = IniRead($fichierCfg, $MODULE_NOM,             "SendKeyDownDelay",       "10"),                                                    _
	$SendKeySpeed           = IniRead($fichierCfg, $MODULE_NOM,             "SendKeySpeed",           "200"),                                                   _
	$MouseSpeed             = IniRead($fichierCfg, $MODULE_NOM,             "MouseSpeed",             "5"),                                                     _
	$CalibrageKeyId         = Number(IniRead($fichierCfg, $MODULE_NOM,      "CalibrageKeyId",         "1")),                                                    _
	$UpLauncher_WinMatch    = IniRead($fichierCfg, $MODULE_NOM,             "UpLauncher_WinMatch",    "[REGEXPTITLE:Updater Dofus; CLASS:wxWindowClassNR]"),    _
	$UpLauncher_WinSize     = unserialize(IniRead($fichierCfg, $MODULE_NOM, "UpLauncher_WinSize",     "")),                                                     _
	$UpLauncher_ButtonMatch = IniRead($fichierCfg, $MODULE_NOM,             "UpLauncher_ButtonMatch", "[CLASS:wxWindowClassNR; INSTANCE:19]"),                  _
	$DofusMod_WinMatch      = IniRead($fichierCfg, $MODULE_NOM,             "DofusMod_WinMatch",      "[REGEXPTITLE:Dofus; CLASS:ApolloRuntimeContentWindow]"), _
	$DofusMod_WinSize       = unserialize(IniRead($fichierCfg, $MODULE_NOM, "DofusMod_WinSize",       "0,0,0,0")),                                              _
	$DofusMod_WinFrame      = unserialize(IniRead($fichierCfg, $MODULE_NOM, "DofusMod_WinFrame",      "358,120,900,720")),                                      _
	$DofusMod_LoginPosition = unserialize(IniRead($fichierCfg, $MODULE_NOM, "DofusMod_LoginPosition", "547,345,15921906")),                                     _
	$DofusMod_PassPosition  = unserialize(IniRead($fichierCfg, $MODULE_NOM, "DofusMod_PassPosition",  "547,405,15921906")),                                     _
	$DofusMod_PlayPosition  = unserialize(IniRead($fichierCfg, $MODULE_NOM, "DofusMod_PlayPosition",  "547,543,0")),                                            _
	$TimeoutValues          = unserialize(IniRead($fichierCfg, $MODULE_NOM, "TimeoutValues",          "30,90,15,30,90,15"))
; Vrification des paramtres
If Not IsInt($StringSendMode) Or $StringSendMode < 1 Or $StringSendMode > $StringSendModes[0][0] Then
	ConsoleWrite("StringSendMode"&@CRLF)
	$StringSendMode = 1
	$isTotallyConfigured = False
EndIf
If Not IsInt($CalibrageKeyId) Or $CalibrageKeyId < 1 Or $CalibrageKeyId > $CalibrageKeyIds[0][0] Then
	ConsoleWrite("CalibrageKeyId"&@CRLF)
	$CalibrageKeyId = 1
	$isTotallyConfigured = False
EndIf
#EndRegion

Local $sortie = 0
If $CONNECT_MODE Then
	Local $reponse = 7 ; NO = 7
	If Not $isTotallyConfigured Then
		Local $reponse = MsgBox(3+32, $MODULE_NOM, _
			"La configuration du module de connexion n'est pas complte."       & @CRLF & _
			"Cela se produit si vous utilisez ce module pour la premire fois," & @CRLF & _
			"ou si il a dernirement subi une mise  jour notable."     & @CRLF & @CRLF & _
			"Souhaitez vous paramtrer ce module?"                      & @CRLF & @CRLF & _
			"Oui : Interface de configuration du module" & @CRLF & "Non : Connexion automatique (paramtres de base)" & @CRLF & "Annuler : Retourner au nAiO", _
			20 _
		)
	EndIf
	If $reponse = 7 And getListeComptesLength($listeComptes) > 0 Then
		$sortie = connexion($listeComptes, $clef, $fullscreen)
	ElseIf $reponse = 6 Then
		$sortie = configuration($isTotallyConfigured)
	EndIf
Else
	$sortie = configuration($isTotallyConfigured)
EndIf
Exit $sortie

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Paramtrage de la procdure de connexion

Func configuration($isTotallyConfigured)
	; Interface
	Local $GUI_size[2] = [320,270], $GUI_modification = False
	Local $GUI = GUICreate($MODULE_NOM, _
		$GUI_size[0], $GUI_size[1], Default, Default, 0x80800000 _
	) ; $WS_POPUP = 0x80000000 , $WS_BORDER = 0x00800000
	GUISetIcon($MODULE_DIR&"\"&$MODULE_NOM&".ico")
	TraySetIcon($MODULE_DIR&"\"&$MODULE_NOM&".ico")
	; Boutons principaux
	Local $GUI_TITRE = GUICtrlCreateLabel( _
		WinGetTitle($GUI), _
		10, 10, $GUI_size[0]-50, 25, _
		Default, 0x00100000 _
	) ; $GUI_WS_EX_PARENTDRAG = 0x00100000
	GUICtrlSetBkColor($GUI_TITRE, -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
	GUICtrlSetFont($GUI_TITRE, 15, 800)
	Local $Bouton_Quitter    = GUICtrlCreateButton("X", $GUI_size[0]-35, 10, 25, 25)
	GUICtrlSetFont($Bouton_Quitter, Default, 800)
	GUICtrlSetTip($Bouton_Quitter, "Quitter le module")
	; Valeurs  configurer
	$tabContainer = GUICtrlCreateTab(10, 40, $GUI_size[0]-20, $GUI_size[1]-40-10)
	GUICtrlCreateTabItem("Gnral")
	Global _
		$StringSendMode_label   = GUICtrlCreateLabel("Touches scurises :",       20,                      45+25*1+3, ($GUI_size[0]-40)/2,    20), _
		$StringSendMode_value   = GUICtrlCreateButton("",                          20+($GUI_size[0]-40)/2,    45+25*1, ($GUI_size[0]-40)/2,    20), _
		$ConnexionPath_label    = GUICtrlCreateLabel("Systme de connexion :",     20,                      45+25*2+3, ($GUI_size[0]-40)/2,    20), _
		$ConnexionPath_value    = GUICtrlCreateInput("",                           20+($GUI_size[0]-40)/2,    45+25*2, ($GUI_size[0]-40)/2-25, 20), _
		$ConnexionPath_choice   = GUICtrlCreateButton("...",                       20+($GUI_size[0]-40)-25+5, 45+25*2, 20,                     20), _
		$SendKeyDelay_label     = GUICtrlCreateLabel("Dure entre les frappes :",  20,                      45+25*3+3, ($GUI_size[0]-40)/2,    20), _
		$SendKeyDelay_value     = GUICtrlCreateInput("",                           20+($GUI_size[0]-40)/2,    45+25*3, ($GUI_size[0]-40)/2,    20), _
		$SendKeyDownDelay_label = GUICtrlCreateLabel("Dure d'appui de touche :",  20,                      45+25*4+3, ($GUI_size[0]-40)/2,    20), _
		$SendKeyDownDelay_value = GUICtrlCreateInput("",                           20+($GUI_size[0]-40)/2,    45+25*4, ($GUI_size[0]-40)/2,    20), _
		$MouseSpeed_label       = GUICtrlCreateLabel("Vitesse de la souris :",     20,                      45+25*5+3, ($GUI_size[0]-40)/2,    20), _
		$MouseSpeed_value       = GUICtrlCreateInput("",                           20+($GUI_size[0]-40)/2,    45+25*5, ($GUI_size[0]-40)/2,    20), _
		$CalibrageKeyId_label   = GUICtrlCreateLabel("Touche de calibrage :",      20,                      45+25*6+3, ($GUI_size[0]-40)/2,    20), _
		$CalibrageKeyId_value   = GUICtrlCreateButton("",                          20+($GUI_size[0]-40)/2,    45+25*6, ($GUI_size[0]-40)/2,    20), _
		$General_separator      = GUICtrlCreateLabel("", 20, 45+25*7+2, $GUI_size[0]-40, 1),                                                        _
		$Calibrage_label        = GUICtrlCreateLabel("Calibrage du module :",      20,                   45+25*7+3+10, ($GUI_size[0]-40)/2,    20), _
		$Calibrage_value        = GUICtrlCreateButton("Lancer le calibrage",       20+($GUI_size[0]-40)/2, 45+25*7+10, ($GUI_size[0]-40)/2,    20)
	; Mise  jour des donnes
	GUICtrlSetData($StringSendMode_value,   $StringSendModes[$StringSendMode][1])
	GUICtrlSetData($ConnexionPath_value,    $ConnexionPath)
	GUICtrlSetColor($ConnexionPath_value,   0x009900)
	GUICtrlSetData($SendKeyDelay_value,     $SendKeyDelay)
	GUICtrlSetData($MouseSpeed_value,       $MouseSpeed)
	GUICtrlSetData($CalibrageKeyId_value,   $CalibrageKeyIds[$CalibrageKeyId][1])
	GUICtrlSetData($SendKeyDownDelay_value, $SendKeyDownDelay)
	GUICtrlSetBkColor($General_separator,   0x000000)
	GUICtrlCreateTabItem("Timeouts")
	Global _
		$timeout1_label         = GUICtrlCreateLabel("Activation UpLauncher :",    20,                      45+25*1+3, ($GUI_size[0]-50)/2,    20), _
		$timeout1_value         = GUICtrlCreateInput("",                           20+($GUI_size[0]-50)/2,    45+25*1, ($GUI_size[0]-50)/2,    20), _
		$timeout2_label         = GUICtrlCreateLabel("Bouton 'Jouer' actif :",     20,                      45+25*2+3, ($GUI_size[0]-50)/2,    20), _
		$timeout2_value         = GUICtrlCreateInput("",                           20+($GUI_size[0]-50)/2,    45+25*2, ($GUI_size[0]-50)/2,    20), _
		$timeout3_label         = GUICtrlCreateLabel("Clic Bouton 'Jouer' :",      20,                      45+25*3+3, ($GUI_size[0]-50)/2,    20), _
		$timeout3_value         = GUICtrlCreateInput("",                           20+($GUI_size[0]-50)/2,    45+25*3, ($GUI_size[0]-50)/2,    20), _
		$timeout4_label         = GUICtrlCreateLabel("Attente fentre :",          20,                      45+25*4+3, ($GUI_size[0]-50)/2,    20), _
		$timeout4_value         = GUICtrlCreateInput("",                           20+($GUI_size[0]-50)/2,    45+25*4, ($GUI_size[0]-50)/2,    20), _
		$timeout5_label         = GUICtrlCreateLabel("Affichage des champs :",     20,                      45+25*5+3, ($GUI_size[0]-50)/2,    20), _
		$timeout5_value         = GUICtrlCreateInput("",                           20+($GUI_size[0]-50)/2,    45+25*5, ($GUI_size[0]-50)/2,    20), _
		$timeout6_label         = GUICtrlCreateLabel("Remplissage des champs :",   20,                      45+25*6+3, ($GUI_size[0]-50)/2,    20), _
		$timeout6_value         = GUICtrlCreateInput("",                           20+($GUI_size[0]-50)/2,    45+25*6, ($GUI_size[0]-50)/2,    20), _
		$Timeouts_separator     = GUICtrlCreateLabel("", 20, 45+25*7+2, $GUI_size[0]-40, 1),                                                        _
		$SendKeySpeed_label     = GUICtrlCreateLabel("Ractivit gnrale :",      20,                   45+25*7+3+10, ($GUI_size[0]-50)/2,    20), _
		$SendKeySpeed_value     = GUICtrlCreateInput("",                           20+($GUI_size[0]-50)/2, 45+25*7+10, ($GUI_size[0]-50)/2,    20)
	GUICtrlSetData($timeout1_value,        $TimeoutValues[1])
	GUICtrlSetData($timeout2_value,        $TimeoutValues[2])
	GUICtrlSetData($timeout3_value,        $TimeoutValues[3])
	GUICtrlSetData($timeout4_value,        $TimeoutValues[4])
	GUICtrlSetData($timeout5_value,        $TimeoutValues[5])
	GUICtrlSetData($timeout6_value,        $TimeoutValues[6])
	GUICtrlSetBkColor($Timeouts_separator, 0x000000)
	GUICtrlSetData($SendKeySpeed_value,    $SendKeySpeed)
	GUICtrlCreateTabItem("")
	; Traitement
	GUISetState(@SW_SHOW, $GUI)
	Local $previous_values = "", $modificationAvantSauvegarde = Not $isTotallyConfigured, $ConnexionPath_state = True
	While True
		$msg = GUIGetMsg()
		Switch $msg
		Case -3, $Bouton_Quitter ; $GUI_EVENT_CLOSE = -3
			If $modificationAvantSauvegarde Then
				Local $retour = MsgBox(3+32, WinGetTitle($GUI)&" - "&"Sortie", _
					"Les modifications ne sont pas enregistres." & @CRLF & "Souhaitez vous les sauvegarder avant de quitter?" & @CRLF & _
					@CRLF & _
					"Oui : Sauvegarder et quitter" & @CRLF & "Non : Quitter sans sauvegarder" & @CRLF & "Annuler : Ne pas quitter", _
					20, $GUI _
				)
				If $retour = 6 Or $retour = 7 Then
					If $retour = 6 Then
						; Prparer
						For $i = 1 To 6
							$TimeoutValues[$i] = Number(GUICtrlRead(Eval("timeout"&$i&"_value")))
						Next
						; Sauvegarder
						FileClose(FileOpen($fichierCfg,10))
						IniWrite($fichierCfg, "",          "Version",                $MODULE_VERSION)
						IniWrite($fichierCfg, $MODULE_NOM, "StringSendMode",         $StringSendMode)
						IniWrite($fichierCfg, $MODULE_NOM, "ConnexionPath",          GUICtrlRead($ConnexionPath_value))
						IniWrite($fichierCfg, $MODULE_NOM, "SendKeyDelay",           Number(GUICtrlRead($SendKeyDelay_value)))
						IniWrite($fichierCfg, $MODULE_NOM, "SendKeyDownDelay",       Number(GUICtrlRead($SendKeyDownDelay_value)))
						IniWrite($fichierCfg, $MODULE_NOM, "MouseSpeed",             Number(GUICtrlRead($MouseSpeed_value)))
						IniWrite($fichierCfg, $MODULE_NOM, "SendKeySpeed",           Number(GUICtrlRead($SendKeySpeed_value)))
						IniWrite($fichierCfg, $MODULE_NOM, "CalibrageKeyId",         $CalibrageKeyId)
						IniWrite($fichierCfg, $MODULE_NOM, "UpLauncher_WinMatch",    $UpLauncher_WinMatch)
						IniWrite($fichierCfg, $MODULE_NOM, "UpLauncher_WinSize",     serialize($UpLauncher_WinSize))
						IniWrite($fichierCfg, $MODULE_NOM, "UpLauncher_ButtonMatch", $UpLauncher_ButtonMatch)
						IniWrite($fichierCfg, $MODULE_NOM, "DofusMod_WinMatch",      $DofusMod_WinMatch)
						IniWrite($fichierCfg, $MODULE_NOM, "DofusMod_WinSize",       serialize($DofusMod_WinSize))
						IniWrite($fichierCfg, $MODULE_NOM, "DofusMod_WinFrame",      serialize($DofusMod_WinFrame))
						IniWrite($fichierCfg, $MODULE_NOM, "DofusMod_LoginPosition", serialize($DofusMod_LoginPosition))
						IniWrite($fichierCfg, $MODULE_NOM, "DofusMod_PassPosition",  serialize($DofusMod_PassPosition))
						IniWrite($fichierCfg, $MODULE_NOM, "DofusMod_PlayPosition",  serialize($DofusMod_PlayPosition))
						IniWrite($fichierCfg, $MODULE_NOM, "TimeoutValues",          serialize($TimeoutValues))
					EndIf
					$modificationAvantSauvegarde = False
				EndIf
			EndIf
			If $modificationAvantSauvegarde = False Then ExitLoop
		Case $StringSendMode_value
			$StringSendMode = $StringSendMode + 1
			If $StringSendMode > $StringSendModes[0][0] Then $StringSendMode = 1
			GUICtrlSetData($StringSendMode_value, $StringSendModes[$StringSendMode][1])
		Case $CalibrageKeyId_value
			$CalibrageKeyId = $CalibrageKeyId + 1
			If $CalibrageKeyId > $CalibrageKeyIds[0][0] Then $CalibrageKeyId = 1
			GUICtrlSetData($CalibrageKeyId_value, $CalibrageKeyIds[$CalibrageKeyId][1])
		Case $ConnexionPath_choice
			GUICtrlSetState($ConnexionPath_choice, $GUI_DISABLE)
			; "Smaphore" pour exclure les bidouillages pendant l'affichage de la seconde fentre
			GUISetState(@SW_DISABLE, $GUI)
			Local $chemin = getDefaultConnexionPath(StringLeft(GUICtrlRead($ConnexionPath_value),StringInStr(GUICtrlRead($ConnexionPath_value),"\",0,-1)-1))
			Local $result = FileOpenDialog("Choisir le lanceur du client de jeu", $chemin, "Excutable (*.exe)|Autres (*.*)", 1, "", $GUI)
			If @error = 0 Then
				GUICtrlSetData($ConnexionPath_value, $result)
				$modificationAvantSauvegarde = True
			EndIf
			GUISetState(@SW_ENABLE, $GUI)
			; "Smaphore" relach
			GUICtrlSetState($ConnexionPath_choice, $GUI_ENABLE)
		Case $Calibrage_value
			GUISetState(@SW_HIDE, $GUI)
			Local $result = connexion_calibrage($CalibrageKeyIds[$CalibrageKeyId][0], $GUI, GUICtrlRead($ConnexionPath_value))
			GUISetState(@SW_SHOW, $GUI)
			If $result Then $modificationAvantSauvegarde = True
		Case Else
			; Mise  jour automatique du champ chemin
			Local _
				$value = GUICtrlRead($ConnexionPath_value), _
				$state = StringRegExp(StringLower($value),"\.exe$") And FileExists($value)
			If $ConnexionPath_state <> $state Then
				$ConnexionPath_state = $state
				GUICtrlSetColor($ConnexionPath_value, si($state, 0x009900, 0xBB0000))
			EndIf
			; Modifications avant sauvegarde
			If Not $modificationAvantSauvegarde Then
				Local $values = GUICtrlRead($StringSendMode_value)&","&GUICtrlRead($ConnexionPath_value)&","&GUICtrlRead($SendKeyDelay_value)&","&GUICtrlRead($SendKeyDownDelay_value)&","&GUICtrlRead($MouseSpeed_value)&","&$CalibrageKeyId&","& _
					GUICtrlRead($timeout1_value)&","&GUICtrlRead($timeout2_value)&","&GUICtrlRead($timeout3_value)&","&GUICtrlRead($timeout4_value)&","&GUICtrlRead($timeout5_value)&","&GUICtrlRead($timeout6_value)&","&GUICtrlRead($SendKeySpeed_value)
				If $previous_values = "" Then
					$previous_values = $values
				ElseIf $previous_values <> $values Then
					$previous_values = $values
					$modificationAvantSauvegarde = True
				EndIf
			EndIf
		EndSwitch
	WEnd
	Return 0
EndFunc
#EndRegion

#Region Procdure de connexion

Func connexion($listeComptes, $clef, $fullscreen)

	; Options
	Opt("SendKeyDelay",     Number($SendKeyDelay))
	Opt("SendKeyDownDelay", Number($SendKeyDownDelay))

	; Raccourci clavier
	HotKeySet("{F4}","stopLogin")

	; Rduction de toutes les fentres de jeu
	connexionTrayTip("Rduction de toutes les fentres de jeu")
	Local $winList = WinList($DofusMod_WinMatch)
	For $i = 1 To $winList[0][0]
		addAndHideWindowToList($FENETRES_EN_COURS, $winList[$i][1])
	Next

	; Lancement du programme UpLauncher
	connexionTrayTip("Lancement du programme UpLauncher")
	connexion_launchUpLauncher()
	If @error <> 0 Then Return @error

	; Ouverture des fentres Dofus
	connexionTrayTip("Ouverture des fentres Dofus")
	Local $list_dofusclient = WinList($DofusMod_WinMatch)
	Local $newlist_dofusclient = newArray(2)

	; Pour chaque compte
	For $i = 1 To getListeComptesLength($listeComptes)

		; Activation de la fentre UpLauncher
		connexionTrayTip("Activation de la fentre UpLauncher pour le compte n"&$i)
		Local $window_uplauncher = connexion_activateUpLauncher($UpLauncher_WinMatch, $i)
		If @error <> 0 Then Return @error

		; Attente reprage du bouton 'Jouer'
		connexionTrayTip("Attente reprage du bouton 'Jouer' pour le compte n"&$i)
		connexion_waitBoutonJouer($window_uplauncher, $i)
		If @error <> 0 Then Return @error

		; Clic sur le bouton 'Jouer'
		connexionTrayTip("Clic sur le bouton 'Jouer' pour le compte n"&$i)
		connexion_clicButtonJouer($window_uplauncher, $i)
		If @error <> 0 Then Return @error

		; Attente nouvelle fentre
		connexionTrayTip("Attente nouvelle fentre pour le compte n"&$i)
		Local $window_dofusclient = connexion_waitNewWindow($i, $list_dofusclient, $newlist_dofusclient)
		If @error <> 0 Then Return @error

		; Attente activation de la fentre
		connexionTrayTip("Attente activation de la fentre pour le compte n"&$i)
		connexion_waitActivatedWindow($window_dofusclient, $i)
		If @error <> 0 Then Return @error

		; Ajout dans la liste des fentres en cours de traitement
		connexionTrayTip("Ajout dans la liste des fentres en cours de traitement pour le compte n"&$i)
		addAndHideWindowToList($FENETRES, $window_dofusclient)

	Next

	; Traitrement des fentres avant connexion
	connexionTrayTip("Traitrement des fentres avant connexion")
	If $FENETRES[0] <> getListeComptesLength($listeComptes) Then
		connexionTrayTip("Traitrement des fentres avant connexion"&@CRLF&"Arrt involontaire : nombre de fentres non conforme",3)
		Return 1
	EndIf

	; Traitement de chaque compte
	connexionTrayTip("Traitrement de chaque compte")

	For $i = 1 To getListeComptesLength($listeComptes)

		Local $fenetre = $FENETRES[$i]

		; Traitement du compte n$i
		connexionTrayTip("Traitrement du compte n"&$i)
		Local $compte = getCompteInListAt($listeComptes,$i)

		; Demande de la clef du compte n$i
		connexionTrayTip("Demande de la clef du compte n"&$i)
		Local $infos = connexion_askKeyForCompte($compte, $i)
		If @error Then Return @error

		; Activation de la fentre pour le compte n$i
		WinSetState($fenetre,"",@SW_SHOW)

		; Attente affichage des champs pour le compte n$i
		connexionTrayTip("Attente affichage des champs pour le compte n"&$i)
		connexion_waitFields($fenetre, $i)
		If @error Then Return @error

		; Remplissage du champ Login pour le compte n$i
		connexionTrayTip("Remplissage du champ Login pour le compte n"&$i)
		connexion_fillLoginField($fenetre, $i, $infos[1])
		If @error Then Return @error

		; Remplissage du champ Pass pour le compte n$i
		connexionTrayTip("Remplissage du champ Pass pour le compte n"&$i)
		connexion_fillPassField($fenetre, $i, $infos[2])
		If @error Then Return @error

		; Clic sur le bouton de connexion pour le compte n$i
		connexionTrayTip("Clic sur le bouton de connexion pour le compte n"&$i)
		connexion_clicConnectButton($fenetre, $i, $fullscreen)
		If @error Then Return @error

		; Dsactivation de la fentre pour le compte n$i
		WinSetState($fenetre,"",@SW_HIDE)

	Next
	Return 0
EndFunc

#EndRegion

#Region Fonctions supplmentaires de la procdure de connexion

; Etape 1 : Lancement du programme UpLauncher
Func connexion_launchUpLauncher()
	If Not WinExists($UpLauncher_WinMatch) Then
		If FileExists($ConnexionPath) Then
			Run($ConnexionPath, StringLeft($ConnexionPath,StringInStr($ConnexionPath,"\",0,1)-1))
		Else
			connexionTrayTip("Lancement du programme UpLauncher"&@CRLF&"Arrt volontaire",2)
			SetError(1)
		EndIf
	EndIf
EndFunc

; Etape 2 : Activation de la fentre UpLauncher pour le compte n$i
Func connexion_activateUpLauncher($discriminant, $index)
	Local $timer = TimerInit(), $timeout = $TimeoutValues[1], $found = False
	Do
		Local $window = WinGetHandle($discriminant)
		If @error = 0 Then
			WinActivate($window)
			$found = (WinActive($window) = $window)
		EndIf
	Until $found Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Activation de la fentre UpLauncher pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $found Or TimerDiff($timer) > $timeout*1000 Then
		connexionTrayTip("Activation de la fentre UpLauncher pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	Else
		Return $window
	EndIf
EndFunc

; Etape 3 : Attente reprage du bouton 'Jouer' pour le compte n$i
Func connexion_waitBoutonJouer($window, $index)
	Local $timer = TimerInit(), $timeout = $TimeoutValues[2], $found = False
	Do
		Local $visible = (ControlCommand("[HANDLE:"&$window&"]","",$UpLauncher_ButtonMatch,"IsVisible","") = 1)
		Local $enabled = (ControlCommand("[HANDLE:"&$window&"]","",$UpLauncher_ButtonMatch,"IsEnabled","") = 1)
		$found = $visible And $enabled
	Until $found Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Attente reprage du bouton 'Jouer' pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $found Or TimerDiff($timer) > $timeout*1000 Then
		connexionTrayTip("Attente reprage du bouton 'Jouer' pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	EndIf
EndFunc

; Etape 4 : Clic sur le bouton 'Jouer' pour le compte n$i
Func connexion_clicButtonJouer($window, $index)
	Local $try = Ceiling($TimeoutValues[3]/3), $ok = False
	Do
		$try = $try - 1
		ControlClick("[HANDLE:"&$window&"]","",$UpLauncher_ButtonMatch)
		Local $timer = TimerInit(), $timeout = 3
		Do
			$ok = Not WinActive($window)
		Until $ok Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	Until $ok Or $try < 0 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Clic sur le bouton 'Jouer' pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $ok Then
		connexionTrayTip("Clic sur le bouton 'Jouer' pour le compte n"&$index&@CRLF&"Arrt involontaire : bouton non ractif",3)
		SetError(1)
	EndIf
EndFunc

; Etape 5 : Attente nouvelle fentre pour le compte n$i
Func connexion_waitNewWindow($index, $winlist, ByRef $newwinlist)
	Local $timer = TimerInit(), $timeout = $TimeoutValues[4]
	Do
		Local $window[2] = ["",0]
		Local $actuallist = WinList($DofusMod_WinMatch)
		For $i = 1 To $actuallist[0][0]
			Local $myWindow[2] = [$actuallist[$i][0],$actuallist[$i][1]]
			If $window[1] = 0 Then
				Local $found = False
				If Not $found Then
					For $j = 1 To $winlist[0][0]
						$found = $found Or ($myWindow[1] = $winlist[$j][1])
					Next
				EndIf
				If Not $found Then
					For $j = 1 To $newwinlist[0][0]
						$found = $found Or ($myWindow[1] = $newwinlist[$j][1])
					Next
				EndIf
				If Not $found Then $window = $myWindow
			EndIf
		Next
	Until $window[1] <> 0 Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Attente nouvelle fentre pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf $window[1] = 0 Then
		connexionTrayTip("Attente nouvelle fentre pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	Else
		addToArray($newwinlist,$window[0],$window[1])
		Return $window[1]
	EndIf
EndFunc

; Etape 6 : Attente activation de la fentre pour le compte n$i
Func connexion_waitActivatedWindow($window, $index)
	Local $timer = TimerInit(), $timeout = $TimeoutValues[4], $found = False
	Do
		WinActivate($window)
		$found = (WinActive($window) <> 0)
	Until $found Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Attente activation de la fentre pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $found Or TimerDiff($timer) > $timeout*1000 Then
		connexionTrayTip("Attente activation de la fentre pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	EndIf
EndFunc

; Etape 7 : Demande de la clef du compte n$i
Func connexion_askKeyForCompte($compte, $index)
	Local $alias = getCompteAlias($compte), $error = 0, $clef = $DEFAULT_Key
	If isCompteLockedByKey($compte) Then
		$clef = InputBox( _
			"Compte '"&$alias&"'", _
			"Veuillez entrer la clef du compte :", "", "*M8", _
			200,120,Default,Default, 30 _
		)
		$error = @error
	EndIf
	If $stopLogin Then
		connexionTrayTip("Demande de la clef du compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf $error = 2 Then
		connexionTrayTip("Demande de la clef du compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint (30s max)",3)
		SetError(1)
	ElseIf $error Then
		connexionTrayTip("Demande de la clef du compte n"&$index&@CRLF&"Arrt involontaire : erreur pass type "&$error,3)
		SetError(1)
	ElseIf Not checkCompteWithKey($compte,$clef) Then
		connexionTrayTip("Demande de la clef du compte n"&$index&@CRLF&"Arrt involontaire : clef incorrecte",3)
		SetError(4)
	Else
		Local $infos[3] = [$alias, getCompteLogin($compte,$clef), getComptePass($compte,$clef)]
		Return $infos
	EndIf
EndFunc

; Etape 8 : Attente affichage des champs pour le compte n$i
Func connexion_waitFields($window, $index)
	Local $timer = TimerInit(), $timeout = $TimeoutValues[5], $found = False
	Do
		Local $frame = getWindowClientCoords($window)
		If IsArray($frame) And UBound($frame) > 3 And $frame[2]*$frame[3] > 0 Then
			Local $login_position = zoomPosition($DofusMod_LoginPosition, $DofusMod_WinFrame, $frame, $DofusMod_Ratio)
			Local $pass_position  = zoomPosition($DofusMod_PassPosition,  $DofusMod_WinFrame, $frame, $DofusMod_Ratio)
			Local $pixel[2] = [ _
				RelativePixelGetColorHwnd($login_position[1], $login_position[2], $window), _
				RelativePixelGetColorHwnd($pass_position[1],  $pass_position[2],  $window)  _
			]
			connexionTrayTip("Attente affichage des champs pour le compte n" & $index _
				& @CRLF & "["&$login_position[3] & "] : (" & $login_position[1] & "," & $login_position[2] & ")=" & $pixel[0] _
				& @CRLF & "["&$pass_position[3]  & "] : (" & $pass_position[1]  & "," & $pass_position[2]  & ")=" & $pixel[1] _
			)
			$found = ($pixel[0] = $login_position[3] And $pixel[1] = $pass_position[3])
		EndIf
	Until $found Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Attente affichage des champs pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $found Or TimerDiff($timer) > $timeout*1000 Then
		connexionTrayTip("Attente affichage des champs pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	EndIf
EndFunc

; Etape 9 : Remplissage du champ Login pour le compte n$i
Func connexion_fillLoginField($window, $index, $value)
	Local $sleep = Number($SendKeySpeed), $timer = TimerInit(), $timeout = $TimeoutValues[6], $found = False, $frame = getWindowClientCoords($window)
	Local $login_position = zoomPosition($DofusMod_LoginPosition, $DofusMod_WinFrame, $frame, $DofusMod_Ratio)
	Do
		RelativeMouseClick("left", $login_position[1], $login_position[2])
		Sleep($sleep)
		; Envoi indirect, champ pouvant tre non vide
		Send("^a")
		Sleep($sleep)
		SendMessage($StringSendMode,$window,$value)
		Sleep($sleep)
		$found = (WinActive($window) = $window)
	Until $found Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Remplissage du champ Login pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $found Then
		connexionTrayTip("Remplissage du champ Login pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	EndIf
EndFunc

; Etape 10 : Remplissage du champ Pass pour le compte n$i
Func connexion_fillPassField($window, $index, $value)
	Local $sleep = Number($SendKeySpeed), $timer = TimerInit(), $timeout = $TimeoutValues[6], $found = False, $frame = getWindowClientCoords($window)
	Local $pass_position = zoomPosition($DofusMod_PassPosition, $DofusMod_WinFrame, $frame, $DofusMod_Ratio)
	Do
		RelativeMouseClick("left", $pass_position[1], $pass_position[2])
		Sleep($sleep)
		; Envoi direct, champ vide par dfaut
		SendMessage($StringSendMode,$window,$value)
		Sleep($sleep)
		$found = (WinActive($window) = $window)
	Until $found Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Remplissage du champ Pass pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $found Then
		connexionTrayTip("Remplissage du champ Pass pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	EndIf
EndFunc

; Etape 11 : Clic sur le bouton de connexion pour le compte n$i
Func connexion_clicConnectButton($window, $index, $mode)
	Local $sleep = 200, $timer = TimerInit(), $timeout = $TimeoutValues[6], $found = False, $frame = getWindowClientCoords($window)
	Local $play_position = zoomPosition($DofusMod_PlayPosition, $DofusMod_WinFrame, $frame, $DofusMod_Ratio)
	Do
		RelativeMouseClick("left", $play_position[1], $play_position[2])
		Sleep($sleep)
		$found = (WinActive($window) = $window)
	Until $found Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	If $stopLogin Then
		connexionTrayTip("Clic sur le bouton de connexion pour le compte n"&$index&@CRLF&"Arrt volontaire",2)
		SetError(2)
	ElseIf Not $found Or TimerDiff($timer) > $timeout*1000 Then
		connexionTrayTip("Clic sur le bouton de connexion pour le compte n"&$index&@CRLF&"Arrt involontaire : timeout atteint ("&$timeout&"s max)",3)
		SetError(1)
	Else
		If $mode = 2 Then
			RelativeMouseClick("left",0,0,1,0)
			Send("^f")
		ElseIf $mode = 1 Then
			WinSetState($window,"",@SW_MAXIMIZE)
		EndIf
	EndIf
EndFunc

#EndRegion

#Region Fonctions supplmentaires de la procdure de calibrage

; Etape annexe 1 : Demande de calibrage
Func connexion_calibrage($key, $window, $path)
	Local $erreur = 0, $donnees = newArray()
	If $erreur = 0 Then
		Local $step1 = connexion_calibrageUpLauncher($key, $window, $path)
		If @error Then $erreur = 1
	EndIf
	If $erreur = 0 Then
		Local $step2 = connexion_calibrageDofusMod($key, $window)
		If @error Then $erreur = 1
	EndIf
	If $erreur = 0 Then
		; Etape annexe 1.1
		$UpLauncher_WinMatch    = $step1[1]
		$UpLauncher_WinSize     = unserialize($step1[2])
		$UpLauncher_ButtonMatch = $step1[3]
		; Etape annexe 1.2
		$DofusMod_WinMatch      = $step2[1]
		$DofusMod_WinSize       = unserialize($step2[2])
		$DofusMod_WinFrame      = unserialize($step2[3])
		$DofusMod_LoginPosition = unserialize($step2[4])
		$DofusMod_PassPosition  = unserialize($step2[5])
		$DofusMod_PlayPosition  = unserialize($step2[6])
		configTrayTip("La procdure de calibrage a t correctement effectue.",1)
	EndIf
	Return ($erreur = 0)
EndFunc

; Etape annexe 1.1 : Calibrage UpLauncher
Func connexion_calibrageUpLauncher($key, $window,$path)
	If FileExists($path) Then
		Run($path, StringLeft($path,StringInStr($path,"\",0,1)-1))
		Local $erreur = 0, $donnees = newArray()
;~ 		Local $retour = MsgBox(1+64+262144, WinGetTitle($window)&" - "&"Calibrage n1/5", _
;~ 			"La fentre de l'UpLauncher du client de jeu Dofus est en cours de lancement." & @CRLF & "Une fois la fentre affiche, cliquez sur 'OK' pour effectuer le calibrage." & @CRLF & _
;~ 			@CRLF & _
;~ 			"OK : Effectuer le calibrage" & @CRLF & "Annuler : Quitter sans calibrage", _
;~ 			60, $window _
;~ 		)
		If $erreur = 0 Then
			Local $position = calibrage($key, "Calibrage n1/5 : Visez le bouton 'Jouer' de l'UpLauncher, et appuyez sur ["&$CalibrageKeyIds[$CalibrageKeyId][1]&"] pour calibrer la dtection de celui-ci.")
			If @error = 0 Then
				configTrayTip("Calibrage n1/5 : Traitement des informations en cours, veuillez ne plus toucher la souris ou le clavier.")
				Sleep(200)
				Local $infos = MouseGetInfos()
				If Not @error And UBound($infos) = 8 And $infos[3] > 0 Then
					addToArray($donnees, "[REGEXPTITLE:"&WinGetTitle($infos[1])&"; CLASS:"&$infos[2]&"]") ; $UpLauncher_WinMatch
					Local $winSize = WinGetPos($infos[1])
					addToArray($donnees, serialize($winSize,True)) ; $UpLauncher_WinSize
					addToArray($donnees, "[CLASS:"&$infos[2]&"; INSTANCE:"&$infos[3]&"]") ; $UpLauncher_ButtonMatch
					configTrayTip("Calibrage n1/5 : Traitement des informations effectu. Le bouton 'Jouer' de l'UpLauncher est correctement calibr.",1)
					Sleep(1000)
					ControlClick($infos[1],"","[CLASS:"&$infos[2]&"; INSTANCE:"&$infos[3]&"]")
				Else
					configTrayTip("Calibrage n1/5 : Erreur de traitement",3)
					$erreur = 1
				EndIf
			Else
				configTrayTip("Calibrage n1/5 : Annulation",2)
				$erreur = 1
			EndIf
		EndIf
	Else
		configTrayTip("Calibrage n1/5 : UpLauncher introuvable",3)
		$erreur = 1
	EndIf
	Return SetError($erreur,0,$donnees)
EndFunc

; Etape annexe 1.2 : Calibrage DofusMod
Func connexion_calibrageDofusMod($key, $window)
	Local $erreur = 0, $donnees = newArray(), $DofusMod_Handle = 0
;~ 	Local $retour = MsgBox(1+64+262144, WinGetTitle($window)&" - "&"Calibrage n2/5", _
;~ 		"La fentre de connexion du client de jeu Dofus est en cours de lancement." & @CRLF & "Une fois la fentre affiche, cliquez sur 'OK' pour effectuer le calibrage." & @CRLF & _
;~ 		@CRLF & _
;~ 		"OK : Effectuer le calibrage" & @CRLF & "Annuler : Quitter sans calibrage", _
;~ 		60, $window _
;~ 	)
	If $erreur = 0 Then
		Local $position = calibrage($key, "Calibrage n2/5 : Visez le champ 'Compte Ankama' du client de jeu, et appuyez sur ["&$CalibrageKeyIds[$CalibrageKeyId][1]&"] pour calibrer la dtection de celui-ci.")
		If @error = 0 Then
			configTrayTip("Calibrage n2/5 : Traitement des informations en cours, veuillez ne plus toucher la souris ou le clavier.")
			Sleep(200)
			Local $infos = MouseGetInfos()
			If Not @error And UBound($infos) = 8 And ($DofusMod_Handle = 0 Or $DofusMod_Handle = $infos[1]) Then
				If $DofusMod_Handle = 0 Then $DofusMod_Handle = $infos[1]
				addToArray($donnees, "[REGEXPTITLE:"&WinGetTitle($DofusMod_Handle)&"; CLASS:"&$infos[2]&"]") ; $DofusMod_WinMatch
				Local $winSize = WinGetPos($DofusMod_Handle)
				addToArray($donnees, serialize($winSize,True)) ; $DofusMod_WinSize
				Local $winFrame = getWindowClientCoords($DofusMod_Handle)
				addToArray($donnees, serialize($winFrame,True)) ; $DofusMod_WinFrame
				Local $coords = newArray()
				addToArray($coords, $infos[5])
				addToArray($coords, $infos[6])
				addToArray($coords, $infos[7])
				addToArray($donnees, serialize($coords)) ; $DofusMod_LoginPosition
				$DofusMod_LoginPosition = $coords
				configTrayTip("Calibrage n2/5 : Traitement des informations effectu. Le champ 'Compte Ankama' est correctement calibr.",1)
				Sleep(1000)
			Else
				configTrayTip("Calibrage n2/5 : Erreur de traitement",3)
				$erreur = 1
			EndIf
		Else
			configTrayTip("Calibrage n2/5 : Annulation",2)
			$erreur = 1
		EndIf
	EndIf
	If $erreur = 0 Then
		Local $position = calibrage($key, "Calibrage n3/5 : Visez le champ 'Mot de passe' du client de jeu, et appuyez sur ["&$CalibrageKeyIds[$CalibrageKeyId][1]&"] pour calibrer la dtection de celui-ci.")
		If @error = 0 Then
			configTrayTip("Calibrage n3/5 : Traitement des informations en cours, veuillez ne plus toucher la souris ou le clavier.")
			Sleep(200)
			Local $infos = MouseGetInfos()
			If Not @error And UBound($infos) = 8 And ($DofusMod_Handle = 0 Or $DofusMod_Handle = $infos[1]) Then
				If $DofusMod_Handle = 0 Then $DofusMod_Handle = $infos[1]
				Local $coords = newArray()
				addToArray($coords, $infos[5])
				addToArray($coords, $infos[6])
				addToArray($coords, $infos[7])
				addToArray($donnees, serialize($coords)) ; $DofusMod_PassPosition
				$DofusMod_PassPosition = $coords
				configTrayTip("Calibrage n3/5 : Traitement des informations effectu. Le champ 'Mot de passe' est correctement calibr.",1)
				Sleep(1000)
			Else
				configTrayTip("Calibrage n3/5 : Erreur de traitement",3)
				$erreur = 1
			EndIf
		Else
			configTrayTip("Calibrage n3/5 : Annulation",2)
			$erreur = 1
		EndIf
	EndIf
	If $erreur = 0 Then
		Local $position = calibrage($key, "Calibrage n4/5 : Visez le bouton 'Jouer' du client de jeu, et appuyez sur ["&$CalibrageKeyIds[$CalibrageKeyId][1]&"] pour calibrer la dtection de celui-ci.")
		If @error = 0 Then
			configTrayTip("Calibrage n4/5 : Traitement des informations en cours, veuillez ne plus toucher la souris ou le clavier.")
			Sleep(200)
			Local $infos = MouseGetInfos($position[0],$position[1])
			If Not @error And UBound($infos) = 8 And ($DofusMod_Handle = 0 Or $DofusMod_Handle = $infos[1]) Then
				If $DofusMod_Handle = 0 Then $DofusMod_Handle = $infos[1]
				Local $coords = newArray()
				addToArray($coords, $infos[5])
				addToArray($coords, $infos[6])
				addToArray($coords, $infos[7])
				addToArray($donnees, serialize($coords)) ; $DofusMod_PlayPosition
				$DofusMod_PlayPosition = $coords
				configTrayTip("Calibrage n4/5 : Traitement des informations effectu. Le bouton 'Jouer' du client de jeu est correctement calibr.",1)
				Sleep(1000)
			Else
				configTrayTip("Calibrage n4/5 : Erreur de traitement",3)
				$erreur = 1
			EndIf
		Else
			configTrayTip("Calibrage n4/5 : Annulation",2)
			$erreur = 1
		EndIf
	EndIf
	If $DofusMod_Handle = 0 Then
		configTrayTip("Calibrage n4/5 : Erreur de traitement",3)
		$erreur = 1
	EndIf
	If $erreur = 0 Then
		configTrayTip("Calibrage n5/5 : Veuillez patienter afin de dterminer les types d'envois de touches compatibles avec votre systme.")
		WinActivate($DofusMod_Handle)
		RelativeMouseClick("left", $DofusMod_LoginPosition[1], $DofusMod_LoginPosition[2])
		Sleep(1000)
		For $i = 1 To $StringSendModes[0][0]
			configTrayTip("Calibrage n5/5 ("&$StringSendModes[$i][1]&") : Veuillez patienter afin de dterminer les types d'envois de touches compatibles avec votre systme.")
			Send("^a")
			Sleep(1000)
			SendMessage($i,$DofusMod_Handle,"Niveau_"&$StringSendModes[$i][0]&"_maximum")
			Sleep(1000)
		Next
	EndIf
	Return SetError($erreur,0,$donnees)
EndFunc

#EndRegion

; Fonction de rcupration d'un chemin de client par dfaut
Func getDefaultConnexionPath($path = "")
	If $path <> "" And FileExists($path) Then
		Return $path
	ElseIf FileExists(@ProgramFilesDir&"\Dofus 2\app") Then
		Return @ProgramFilesDir&"\Dofus 2\app"
	ElseIf FileExists("C:\Program Files\Dofus 2\app") Then
		Return "C:\Program Files\Dofus 2\app"
	ElseIf FileExists("C:\Program Files (x86)\Dofus 2\app") Then
		Return "C:\Program Files (x86)\Dofus 2\app"
	ElseIf FileExists(@ProgramFilesDir&"\Dofus2\app") Then
		Return @ProgramFilesDir&"\Dofus2\app"
	ElseIf FileExists("C:\Program Files\Dofus2\app") Then
		Return "C:\Program Files\Dofus2\app"
	ElseIf FileExists("C:\Program Files (x86)\Dofus2\app") Then
		Return "C:\Program Files (x86)\Dofus2\app"
	EndIf
	Return $MODULE_DIR
EndFunc

; Fonction HotKey:F4
Func stopLogin()
	If Not IsDeclared("stopLogin") Then
		Global $stopLogin = True
	ElseIf $stopLogin Then
		configTrayTip("HotKey:F4"&@CRLF&"Arrt volontaire forc",2)
		Exit 2
	Else
		$stopLogin = True
	EndIf
EndFunc

; Fonction de rcupration de la taille interieure d'une fentre
Func getWindowClientCoords($handle="",$text="")
	Local $hwnd = si(IsInt($handle),$handle,WinGetHandle($handle, $text))
	If $hwnd = "" Then Return SetError(1)
	Local $tpoint = DllStructCreate("int X;int Y")
	DllStructSetData($tpoint, "X", 0)
	DllStructSetData($tpoint, "Y", 0)
	Local $pPoint = DllStructGetPtr($tPoint)
	DllCall("user32.dll", "bool", "ClientToScreen", "hwnd", $hWnd, "ptr", $pPoint)
	Local $clientsize = WinGetClientSize($handle, $text)
	Local $resultat[4] = [DllStructGetData($tpoint, "X"),DllStructGetData($tpoint, "Y"),$clientsize[0],$clientsize[1]]
	Return $resultat
EndFunc

; Fonction d'affichage de tooltip (configuration)
Func configTrayTip($texte="",$icone=0)
	$TRAYTIP_TIMER = si($texte<>"",TimerInit(),$TRAYTIP_TIMER_START)
	TrayTip(si($texte<>"",$MODULE_NOM,""), $texte, 30, si($texte<>"",$icone,0))
	Sleep(100)
EndFunc

; Fonction d'affichage de tooltip (calibrage)
Func calibrageTrayTip($texte="",$icone=0)
	$TRAYTIP_TIMER = si($texte<>"",TimerInit(),$TRAYTIP_TIMER_START)
	TrayTip(si($texte<>"",$MODULE_NOM&" [F4:Annuler le calibrage]",""), $texte, 30, si($texte<>"",$icone,0))
	Sleep(100)
EndFunc

; Fonction d'affichage de tooltip (connexion)
Func connexionTrayTip($texte="",$icone=0)
	$TRAYTIP_TIMER = si($texte<>"",TimerInit(),$TRAYTIP_TIMER_START)
	TrayTip(si($texte<>"",$MODULE_NOM&" [F4:Annuler la procdure]",""), $texte, 30, si($texte<>"",$icone,0))
	If $DEBUG_MODE Then FileWriteLine("debug.txt", "["&@HOUR&":"&@MIN&":"&@SEC&"] "&$MODULE_NOM&" : "&StringRegExpReplace($texte,"\n","#"))
	Sleep(100)
EndFunc

; Fonction de vrification du fichier de config
Func isTotallyConfigured($fichier)
	Local $version = IniRead($fichierCfg, "", "Version", "")
	Return $version = $MODULE_VERSION
EndFunc

; Fonction de calibrage
Func calibrage($key, $message)
	Global $calibrage_ok = False, $calibrage_ko = False
	HotKeySet($key, "calibrage_ok")
	HotKeySet("{F4}", "calibrage_ko")
	calibrageTrayTip($message)
	Local $timer = TimerInit(), $timeout = 5
	Do
		Local $pos = MouseGetPos()
		If TimerDiff($timer) > $timeout*1000 Then
			$timer = TimerInit()
			calibrageTrayTip($message)
		EndIf
	Until $calibrage_ok Or $calibrage_ko
	HotKeySet($key)
	HotKeySet("{F4}")
	If $calibrage_ko Or Not IsArray($pos) Or UBound($pos) <> 2 Then Return SetError(1)
	Return $pos
EndFunc

Func calibrage_ok()
	If Not IsDeclared("calibrage_ok") Then Global $calibrage_ok
	$calibrage_ok = True
EndFunc

Func calibrage_ko()
	If Not IsDeclared("calibrage_ko") Then Global $calibrage_ko
	$calibrage_ko = True
EndFunc

; Fonction de rcupration d'une fenetre en fonction d'un PID de processus
Func getWindowFromProcessId($pid, $loop=False)
	Local $timer = TimerInit(), $timeout = 2
	Do
		Local $liste = WinList()
		For $i = 1 To $liste[0][0]
			If WinGetProcess($liste[$i][1]) = $pid Then Return $liste[$i][1]
		Next
	Until Not $loop Or TimerDiff($timer) > $timeout*1000 Or $stopLogin
	SetError(1,0,"")
EndFunc

; Fonction d'initialisation d'une liste ou d'un tableau
Func newArray($cols=0)
	If $cols = 0 Then
		Local $empty[1] = [0]
		return $empty
	EndIf
	Local $empty[1][$cols] = [[0]]
	For $i = 1 To $cols-1
		$empty[0][$i] = ""
	Next
	Return $empty
EndFunc

; Fonction d'ajout  une liste ou  un tableau
Func addToArray(ByRef $array, $value0="", $value1="", $value2="", $value3="", $value4="", $value5="", $value6="", $value7="", $value8="", $value9="", $value10="", $value11="", $value12="", $value13="", $value14="", $value15="", $value16="", $value17="", $value18="", $value19="", $value20="", $value21="", $value22="", $value23="", $value24="", $value25="", $value26="", $value27="", $value28="", $value29="", $value30="", $value31="")
	Local $dim = UBound($array,0)
	If $dim = 1 Then
		ReDim $array[$array[0]+2]
		$array[$array[0]+1] = $value0
		$array[0] = $array[0]+1
	ElseIf $dim = 2 Then
		Local $cols = UBound($array,2)
		$array[0][0] = $array[0][0]+1
		Redim $array[$array[0][0]+1][$cols]
		For $i = 0 To $cols-1
			$array[$array[0][0]][$i] = Eval("value"&$i)
		Next
	EndIf
EndFunc

; Fonction d'ajout d'une fentre  une liste, et dsactivation de la fentre
Func addAndHideWindowToList(ByRef $list, $window)
	addToArray($list, $window)
	WinSetState($window,"",@SW_HIDE)
EndFunc

; Fonction d'arret du script
Func exitScript()
	ReactivateWindows()
	If IsDeclared("TRAYTIP_TIMER") Then
		Local $timeout = 3
		Do
			Sleep(100)
		Until TimerDiff($TRAYTIP_TIMER) > $timeout*1000
	EndIf
EndFunc

; Fonction de ractivation des fentes
Func ReactivateWindows()
	For $i = 1 To $FENETRES_EN_COURS[0]
		WinSetState($FENETRES_EN_COURS[$i],"",@SW_SHOW)
	Next
	For $i = 1 To $FENETRES[0]
		WinSetState($FENETRES[$i],"",@SW_SHOW)
	Next
EndFunc

; Fonction pour convertir une liste en chaine de caractres
Func serialize($array,$zeroBased=False)
	Local $string = ""
	If $zeroBased Then
		For $i = 0 To UBound($array)-1
			$string = $string & si($i>0,",","") & $array[$i]
		Next
	Else
		For $i = 1 To $array[0]
			$string = $string & si($i>1,",","") & $array[$i]
		Next
	EndIf
	Return $string
EndFunc

; Fonction pour convertir une chaine de caractres en liste
Func unserialize($string)
	Local $array = newArray()
	If $string = "" Then Return $array()
	Local $stringSplit = StringSplit($string, ",")
	If @error = 0 Then
		For $i = 1 To $stringSplit[0]
			addToArray($array, Number($stringSplit[$i]))
		Next
	EndIf
	Return $array
EndFunc

; Fonction de rcupration d'informations sur l'lment survol par la souris / aux coordonnes prcises
Func MouseGetInfos($x=0,$y=0)
	Local $opt
	If @NumParams <> 2 Then
		$opt = Opt("MouseCoordMode", 1)
		$x = MouseGetPos(0)
		$y = MouseGetPos(1)
		Opt("MouseCoordMode", $opt)
	EndIf
	Local $control = 0, $window = 0, $classe = "", $n = 1, $position[2] = [$x, $y]
	$control = DllCall("user32.dll", "int", "WindowFromPoint", "long", $x, "long", $y)
    If @error Or $control = 0 Then Return SetError(1)
	$control = HWnd($control[0])
	$window = _WinAPI_GetAncestor($control, 2)
    If @error Or $window = 0 Then Return SetError(2)
	Local $client = getWindowClientCoords($window)
	If @error Or UBound($client) <> 4 Then Return SetError(3)
	If $x <> min_max($x, $client[0], $client[0]+$client[2]) Or $y <> min_max($y,$client[1],$client[1]+$client[3]) Then Return SetError(4)
    Local $struct = DllStructCreate("char[260]")
    DllCall("User32.dll", "int", "GetClassName", "hwnd", $control, "ptr", DllStructGetPtr($struct), "int", 260)
	If @error Then Return SetError(5)
    $classe = DllStructGetData($struct,1)
    Local $classes = StringSplit(StringTrimRight(WinGetClassList($window), 1), @LF), $found = False
    For $i = 1 To $classes[0]
        If $classes[$i] = $classe Then
			If ControlGetHandle($window, "", $classe & $n) = $control Then
				$found = True
				ExitLoop
			EndIf
			$n += 1
		EndIf
    Next
	If Not $found Then $n = 0
	$opt = Opt("PixelCoordMode", 1)
	Local $color = PixelGetColor($x,$y,$window)
	Opt("PixelCoordMode", $opt)
	Local $result[8] = [$control, $window, $classe, $n, si($n=0,"",$classe&$n), $x - $client[0], $y - $client[1], $color]
	Return $result
EndFunc

; Fonction de calcul de position en fonction d'un changement de zoom
Func zoomPosition($position, $frame, $new_frame, $ratio)
	; Calcul de proportions par rapport aux coordonnes d'origine
	Local $proportion[2] = [$position[1]/$frame[3]-0.5, $position[2]/$frame[4]-0.5]
	If $frame[3]*$ratio[1] > $ratio[0]*$frame[4] Then ; plus large, bandes noires  gauche et droite
		$proportion[0] = $ratio[1] * ($position[1]-$frame[3]/2) / ($frame[4]*$ratio[0])
	ElseIf $frame[3]*$ratio[1] < $ratio[0]*$frame[4] Then ; plus haut, bandes noires en haut et en bas
		$proportion[1] = $ratio[0] * ($position[2]-$frame[4]/2) / ($frame[3]*$ratio[1])
	EndIf
	; Calcul de position par rapport aux proportions calcules
	Local $new_position[4] = [3, $new_frame[2] * (1+2*$proportion[0]), $new_frame[3] * (1+2*$proportion[1]), $position[3]]
	If $new_frame[2]*$ratio[1] > $ratio[0]*$new_frame[3] Then ; plus large, bandes noires  gauche et droite
		$new_position[1] = $new_frame[2] + 2*$proportion[0]*$new_frame[3]*$ratio[0]/$ratio[1]
	ElseIf $new_frame[2]*$ratio[1] < $ratio[0]*$new_frame[3] Then ; plus haut, bandes noires en haut et en bas
		$new_position[2] = $new_frame[3] + 2*$proportion[1]*$new_frame[2]*$ratio[1]/$ratio[0]
	EndIf
	$new_position[1] = Round($new_position[1]/2,2)
	$new_position[2] = Round($new_position[2]/2,2)
	; Retour du rsultat
	Return $new_position
EndFunc

; Fonction paramtre d'envoi de touches
Func SendMessage($type,$window,$value)
	Local $handle = WinActivate($window)
	Switch $type
	Case 1
		Local $values = StringSplit($value,"")
		For $i = 1 To $values[0]
			Send($values[$i],1)
		Next
	Case 2
		Send($value,1)
	Case 3
		Local $values = StringSplit($value,"")
		For $i = 1 To $values[0]
			SecuredSend($values[$i])
		Next
	Case 4
		SecuredSend($value)
	Case 5
		Local $values = StringSplit($value,"")
		For $i = 1 To $values[0]
			ControlSend($handle,"","",$values[$i],1)
		Next
	Case 6
		ControlSend($handle,"","",$value,1)
	EndSwitch
EndFunc

; Fonction d'envoi scuris de touches (similaire  la commande "Send")
Func SecuredSend($string)
	; Initialisation
    Local $type = ""
    For $i = 1 To StringLen($string)
        $type = $type _
			& 'dword type;ushort wVk;ushort wScan;dword dwFlags;dword time;ulong_ptr dwExtraInfo;dword pad;dword pad;' _ ; Premire structure pour l'appui
			& 'dword type;ushort wVk;ushort wScan;dword dwFlags;dword time;ulong_ptr dwExtraInfo;dword pad;dword pad;'   ; Seconde structure pour le relachement
    Next
    Local $struct = DllStructCreate($type)
	; Structure
    For $i = 0 To StringLen($string)-1
        Local $char = AscW(StringMid($string, $i+1, 1)), $iPushed = 16*$i, $iReleased = 16*$i+8
		; Appui
        DllStructSetData($struct, $iPushed+1,   1)   ; $INPUT_KEYBOARD = 1
        DllStructSetData($struct, $iPushed+3,   $char)
        DllStructSetData($struct, $iPushed+4,   4)   ; $KEYEVENTF_UNICODE = 4
		; Relachement
        DllStructSetData($struct, $iReleased+1, 1)   ; $INPUT_KEYBOARD = 1
        DllStructSetData($struct, $iReleased+3, $char)
        DllStructSetData($struct, $iReleased+4, 4+2) ; $KEYEVENTF_UNICODE = 4 ; $KEYEVENTF_KEYUP = 2
    Next
	; Envoi des informations [ MSDN : http://msdn.microsoft.com/en-us/library/windows/desktop/ms646310(v=vs.85).aspx ]
    Local $result = DllCall('user32.dll', 'uint', 'SendInput', 'uint', 2*StringLen($string), 'ptr', DllStructGetPtr($struct), 'int', 28) ; char struct size = 28
    Return Not (@error Or Not $result[0])
EndFunc