#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=.\Recette\Recette.ico
#AutoIt3Wrapper_outfile=Recette.exe
#AutoIt3Wrapper_Res_FileVersion=0.0.0.0
#AutoIt3Wrapper_Res_Field=Nom (short)|Recette
#AutoIt3Wrapper_Res_Field=Nom (long)|Recette
#AutoIt3Wrapper_Res_Field=Version (short)|alpha
#AutoIt3Wrapper_Res_Field=Version (long)|0.0.0.0
#AutoIt3Wrapper_Res_Field=Description|Module de dcomposition de recettes
#AutoIt3Wrapper_Res_Field=Type|Module
#AutoIt3Wrapper_Res_Field=Auteur|ZDS [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Entte du module
Global Const _
	$MODULE_NOM = "Recette", $MODULE_AUTEUR = "ZDS", $MODULE_VERSION = "Alpha", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1)

; Compilation
#Include ".\Recette\Compilation.au3"

#Region Librairies AutoIt
#include <Array.au3>
#include <Date.au3>
#include <File.au3>
#include <string.au3>
#include <ButtonConstants.au3>
#include <GuiConstants.au3>
#include <GuiEdit.au3>
#include <Math.au3>
#include <StaticConstants.au3>
#include <String.au3>
#include <WindowsConstants.au3>
#include <GuiConstantsEx.au3>
#include <GuiMenu.au3>
#include <GuiListView.au3>
#include <ListViewConstants.au3>
#include <TreeViewConstants.au3>
#EndRegion

#Region Fonctions nAiO
Func si($cond, $true, $false)
	If $cond Then Return $true
	Return $false
EndFunc
Func min($a, $b)
	Return si($a<$b,$a,$b)
EndFunc
Func max($a, $b)
	Return si($a>$b,$a,$b)
EndFunc
Func min_max($a, $b, $c)
	Return min(max($a,$b),$c)
EndFunc
Func state($control,$state)
	Return BitAND(GUICtrlGetState($control),$state) = $state
EndFunc
Func getControlCoords($handle="", $control="")
	Local $pos = ControlGetPos($handle, "", $control)
	If @error Then Return SetError(1)
	Local $winpos = WinGetPos($handle)
	If @error Then Return SetError(1)
	Local $resultat[4] = [$winpos[0]+$pos[0],$winpos[1]+$pos[1], $pos[2],$pos[3]]
	Return $resultat
EndFunc
#EndRegion

; Initialisation (Constantes)
Global Const $MAX_ITEM = 999999

; Initialisation (Variables)
Global $fichierXml = $MODULE_DIR&"\"&$MODULE_NOM&".xml", $fichierCfg = $MODULE_DIR&"\"&$MODULE_NOM&".ini"
Global $donneesXml = xml_getRacine($fichierXml), $panneaux[1][10] = [[0]], $stop = False, $msgNotify = ""

#Region Triggers
Global $_touche_enter, $_touche_delete
; Gnral : Dmarrage
Func startTrigger($trigger)
	Switch StringLower($trigger)
	Case "enter"
		$_touche_enter = False
		HotKeySet("{ENTER}", "_touche_enter")
	Case "delete"
		$_touche_delete = False
		HotKeySet("{DELETE}", "_touche_delete")
	EndSwitch
EndFunc
; Gnral : Arrt
Func stopTrigger($trigger)
	Switch StringLower($trigger)
	Case "enter"
		HotKeySet("{ENTER}")
	Case "delete"
		HotKeySet("{DELETE}")
	EndSwitch
EndFunc
; Gnral : Redmarrage
Func restartTrigger($trigger)
	stopTrigger($trigger)
	startTrigger($trigger)
EndFunc
; Gnral : Etat
Func isTrigger($trigger)
	Local $value = False
	Switch StringLower($trigger)
	Case "enter"
		$value = $_touche_enter
	Case "delete"
		$value = $_touche_delete
	EndSwitch
	Return $value
EndFunc
; Touche ENTER
Func _touche_enter()
	$_touche_enter = True
EndFunc
; Touche DELETE
Func _touche_delete()
	$_touche_delete = True
EndFunc
#EndRegion

recette()
ConsoleWrite(@CRLF)
Exit

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Procdure principale du module
Func recette()
	; Initialisation
	Local $position[2] = [200,200]
	; Fentre globale
	Local $GUI = GUICreate($MODULE_NOM&" v"&$MODULE_VERSION, $position[0], $position[1], Default, Default, $WS_POPUPWINDOW)
	; Icone de la fentre
	GUISetIcon($MODULE_DIR&"\"&$MODULE_NOM&".ico", Default, $GUI)
	; Titre du programme
	Local $label_titre = GUICtrlCreateLabel($MODULE_NOM, 10, 5, $position[0]-75, 25, Default, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont($label_titre, 14, 800)
	GUICtrlSetResizing($label_titre, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
	; Bouton Aide
	Local $bouton_aide = GUICtrlCreateButton("?", $position[0]-60, 5, 25, 25)
	GUICtrlSetTip($bouton_aide, "Aide")
	GUICtrlSetResizing($bouton_aide, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
	; Bouton Quitter
	Local $bouton_quitter = GUICtrlCreateButton("X", $position[0]-30, 5, 25, 25)
	GUICtrlSetTip($bouton_quitter, "Quitter")
	GUICtrlSetResizing($bouton_quitter, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
	; Dmarquation
	Local $label_separateur = GUICtrlCreateLabel("", 5, 35, $position[0]-10, 1)
	GUICtrlSetBkColor($label_separateur, 0x000000)
	GUICtrlSetResizing($label_separateur, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
	; Menu d'ajout de mtiers
	Local $metiers = xml_getMetiers($donneesXml), $context_metiers = GUICtrlCreateContextMenu(GUICtrlCreateDummy()), $item_metiers[max($metiers[0],1)+1] = [$metiers[0]]
	If $metiers[0] = 0 Then
		$item_metiers[1] = GUICtrlCreateMenuItem("Aucun mtier disponible", $context_metiers)
		GUICtrlSetState($item_metiers[1], $GUI_DISABLE)
	Else
		For $i = 1 To $metiers[0]
			$item_metiers[$i] = GUICtrlCreateMenuItem(xml_getNom($metiers[$i]), $context_metiers)
		Next
	EndIf
	; Panneaux de l'interface
	gui_restaurerPanneaux($GUI, $metiers)
	; Finalisation
	GUIRegisterMsg(0x004E, "clicNotify")
	GuiSetState(@SW_SHOW, $GUI)
	startTrigger("delete")
	; Boucle de traitement
	While $stop = False
		#Region Gestion des vnements de l'interface graphique
		Local $msg = GuiGetMsg()
		If $msg = $bouton_quitter Or $msg = -3 Then ; $GUI_EVENT_CLOSE = -3
			$stop = True
		ElseIf $msg = $bouton_aide Then
			stopTrigger("delete")
			GuiSetState(@SW_HIDE, $GUI)
			Local $donneesAide[7] = [ 6 _
				, "I - Gnral" _
					& @CRLF & "Glissez/dposez le titre pour dplacer la fentre"               _
					& @CRLF & "Cliquez sur le bouton '?' pour afficher cette bote de dialogue" _
					& @CRLF & "Cliquez sur le bouton 'X' pour quitter le module"                _
				, "II - Mtiers" _
					& @CRLF & "Cliquez sur le bouton '...' pour slectionner un mtier" _
						& "#" & "Cela ajoute un panneau  la fentre"                   _
					& @CRLF & "Cliquez sur le bouton 'Mtier' pour effacer un mtier"   _
						& "#" & "Ainsi que les mtiers qui le suivent dans la liste"    _
				, "III - Ingrdients" _
					& @CRLF & "Cliquez droit dans un panneau pour choisir un ingrdient"     _
						& "#" & "Une fois choisi, cela affiche une boite de dialogue"        _
					& @CRLF & "Tapez la quantit d'ingrdients puis tapez [Entre]"          _
						& "#" & "Tapez [Echap] pour annuler l'ajout de l'ingrdient"         _
					& @CRLF & "Double-cliquez sur un ingrdient pour modifier sa quantit"   _
						& "#" & "Tapez [Echap] pour annuler la modification de l'ingrdient" _
					& @CRLF & "Control-cliquez pour slectionner plusieurs ingrdients"      _
					& @CRLF & "Tapez [Suppr] pour effacer les ingrdients slectionns"      _
				, "IV - Recettes" _
					& @CRLF & "Glissez/dposez des ingrdients pour faire une dcomposition ou un craft"   _
						& "#" & "Vers le panneau de gauche pour dcomposer chaque ingrdient slectionn"  _
						& "#" & "Vers le panneau de droite pour crafter avec les ingrdients slectionns" _
				, "V - Import/Export" _
					& @CRLF & "Fonctionnalit en cours de dveloppement" _
				, "VI - [ A COMPLETER ]" _
					& @CRLF & "Manuel d'utilisation en cours de rdaction" _
			]
			afficheAide($donneesAide)
			GUISetState(@SW_SHOW, $GUI)
			startTrigger("delete")
			$stop = False
		ElseIf $msg = -13 Then ; $GUI_EVENT_DROPPED = -13
			Local $listviewDrag = @GUI_DragId, $listviewDrop = @GUI_DropId
			For $i = 0 To $panneaux[0][0]
				If IsInt($panneaux[$i][1]) And $listviewDrag = $panneaux[$i][1] Then
					If $i>0 And IsInt($panneaux[$i-1][1]) And $listviewDrop = $panneaux[$i-1][1] Then ; Dcomposition
						Local $metier = $panneaux[$i][0]
						For $j = _GUICtrlListView_GetItemCount($listviewDrag)-1 To 0 Step -1
							If _GUICtrlListView_GetItemSelected($listviewDrag, $j) Then
								Local $texte = _GUICtrlListView_GetItemTextString($listviewDrag, $j)
								Local $liste = getDecomposition($metier, $texte)
								For $k = 1 To $liste[0]
									ajouterListview($listviewDrop, $liste[$k])
								Next
								If $liste[0] > 0 Then _GUICtrlListView_DeleteItem($listviewDrag, $j)
							EndIf
						Next
					ElseIf $i<$panneaux[0][0] And IsInt($panneaux[$i+1][1]) And $listviewDrop = $panneaux[$i+1][1] Then ; Confection
						Local $metier = $panneaux[$i+1][0]
						Local $items[1] = [0]
						For $j = _GUICtrlListView_GetItemCount($listviewDrag)-1 To 0 Step -1
							If _GUICtrlListView_GetItemSelected($listviewDrag, $j) Then
								$items[0] = $items[0]+1
								ReDim $items[$items[0]+1]
								$items[$items[0]] = _GUICtrlListView_GetItemTextString($listviewDrag, $j)
							EndIf
						Next
						; Confections
						Local $listeFull = getConfectionFull($metier,  $items), $listePart = getConfectionPart($metier, $items, $listeFull)
						; Cration du sousmenu des crafts possibles
						Local $dummy = GUICtrlCreateDummy(), $context = GUICtrlCreateContextMenu($dummy)
						Local $titreFull = GUICtrlCreateMenu(si($listeFull[0]>0,$listeFull[0],"Aucune")&" recette"&si($listeFull[0]>1,"s","")&" complte"&si($listeFull[0]>1,"s",""), $context)
						Local $menuitemsFull[$listeFull[0]+1] = [$listeFull[0]]
						For $j = 1 To $listeFull[0]
							$menuitemsFull[$j] = GUICtrlCreateMenuItem($listeFull[$j], $titreFull)
						Next
						GUICtrlSetState($titreFull, si($listeFull[0]>0,$GUI_ENABLE,$GUI_DISABLE))
						Local $titrePart = GUICtrlCreateMenu(si($listePart[0]>0,$listePart[0],"Aucune")&" recette"&si($listePart[0]>1,"s","")&" partielle"&si($listePart[0]>1,"s",""), $context)
						Local $menuitemsPart[$listePart[0]+1] = [$listePart[0]]
						For $j = 1 To $listePart[0]
							$menuitemsPart[$j] = GUICtrlCreateMenuItem($listePart[$j], $titrePart)
						Next
						GUICtrlSetState($titrePart, si($listePart[0]>0,$GUI_ENABLE,$GUI_DISABLE))
						; Affichage des sousmenus
						interceptMsg()
						stopTrigger("delete")
						sousmenu($GUI, $listviewDrop, $context)
						Local $timer = TimerInit()
						Do
							Local $sousmenu_msg = GUIGetMsg()
						Until $sousmenu_msg >= 0 Or TimerDiff($timer) > 1000
						startTrigger("delete")
						; Crafts complets
						For $j = 1 To $menuitemsFull[0]
							If $sousmenu_msg = $menuitemsFull[$j] Then
								ajouterListview($listviewDrop, $listeFull[$j])
								Local $liste = getDecomposition($metier, $listeFull[$j])
								For $k = 1 To $liste[0]
									soustraireListview($listviewDrag, $liste[$k])
								Next
							EndIf
						Next
						; Crafts partiels
						For $j = 1 To $menuitemsPart[0]
							If $sousmenu_msg = $menuitemsPart[$j] Then
								ajouterListview($listviewDrop, $listePart[$j])
								Local $liste = getDecomposition($metier, $listePart[$j])
								For $k = 1 To $liste[0]
									soustraireListview($listviewDrag, $liste[$k])
								Next
							EndIf
						Next
						; Effacement du sousmenu des crafts possibles
						For $j = 1 To $menuitemsFull[0]
							GUICtrlDelete($menuitemsFull[$j])
						Next
						For $j = 1 To $menuitemsPart[0]
							GUICtrlDelete($menuitemsPart[$j])
						Next
						GUICtrlDelete($titreFull)
						GUICtrlDelete($titrePart)
						GUICtrlDelete($context)
						GUICtrlDelete($dummy)
					EndIf
					ExitLoop
				EndIf
			Next
		Else
			; Clic sur les boutons de mtiers
			For $i = 0 To $panneaux[0][0]
				If IsInt($panneaux[$i][2]) And $msg = $panneaux[$i][2] Then
					stopTrigger("delete")
					For $j = 1 To $panneaux[0][0]-$i
						gui_effacerPanneau($GUI)
					Next
					sousmenu($GUI, $panneaux[$i][2], $context_metiers)
					startTrigger("delete")
					ExitLoop
				EndIf
			Next
			; Clic sur un menuitem des mtiers
			For $i = 1 To $item_metiers[0]
				If IsInt($item_metiers[$i]) And $msg = $item_metiers[$i] Then
					gui_ajouterPanneau($GUI, $metiers[$i])
					ExitLoop
				EndIf
			Next
			; Clic sur un menuitem des matriaux
			For $i = 0 To $panneaux[0][0]-1
				Local $liste = $panneaux[$i][6]
				For $j = 1 To $liste[0][0]
					If IsInt($liste[$j][0]) And $msg = $liste[$j][0] Then
						Local $listview = $panneaux[$i][1]
						Local $found = -1, $valeur = $liste[$j][1]
						For $k = 0 To _GUICtrlListView_GetItemCount($listview)-1
							If StringRight(_GUICtrlListView_GetItemTextString($listview,$k), StringLen($valeur)) = $valeur Then $found = $k
						Next
						Local $nombre = 0
						If $found <> -1 Then
							$nombre = Number(_GUICtrlListView_GetItemTextString($listview,$found))
							$nombre = afficheInput($valeur, $nombre, $listview, $GUI)
							If $nombre > 0 Then _GUICtrlListView_SetItemText($listview, $found, $nombre&" x "&$valeur)
						Else
							$nombre = afficheInput($valeur, $nombre, $listview, $GUI)
							If $nombre > 0 Then GUICtrlCreateListViewItem($nombre&" x "&$valeur, $listview)
						EndIf
						_GUICtrlListView_SetColumnWidth($listview, 0, $LVSCW_AUTOSIZE)
						ExitLoop 2
					EndIf
				Next
			Next
			; Clic sur un menuitem des crafts
			For $i = 1 To $panneaux[0][0]
				Local $liste = $panneaux[$i][9]
				For $j = 1 To $liste[0][0]
					If IsInt($liste[$j][0]) And $msg = $liste[$j][0] Then
						Local $listview = $panneaux[$i][1]
						Local $found = -1, $valeur = $liste[$j][1]
						For $k = 0 To _GUICtrlListView_GetItemCount($listview)-1
							If StringRight(_GUICtrlListView_GetItemTextString($listview,$k), StringLen($valeur)) = $valeur Then $found = $k
						Next
						Local $nombre = 0
						If $found <> -1 Then
							$nombre = Number(_GUICtrlListView_GetItemTextString($listview,$found))
							$nombre = afficheInput($valeur, $nombre, $listview, $GUI)
							If $nombre > 0 Then _GUICtrlListView_SetItemText($listview, $found, $nombre&" x "&$valeur)
						Else
							$nombre = afficheInput($valeur, $nombre, $listview, $GUI)
							If $nombre > 0 Then GUICtrlCreateListViewItem($nombre&" x "&$valeur, $listview)
						EndIf
						_GUICtrlListView_SetColumnWidth($listview, 0, $LVSCW_AUTOSIZE)
						ExitLoop 2
					EndIf
				Next
			Next
		EndIf
		; Capture d'un Delete
		If isTrigger("delete") Then
			stopTrigger("delete")
			Local $ok = False
			If WinActive($GUI) Then
				Local $found = -1, $focus = ControlGetHandle($GUI,"",ControlGetFocus($GUI))
				For $i = 0 To $panneaux[0][0]
					If GUICtrlGetHandle($panneaux[$i][1]) = $focus Then $found = $i
				Next
				If $found > -1 Then
					$msgNotify = "DELETE_LV"&";"&$found
					$ok = True
				EndIf
			EndIf
			If Not $ok Then Send("{DELETE}")
			startTrigger("delete")
		EndIf
		; Traitement des messages diffrs
		If $msgNotify <> "" Then
			Local $values = StringSplit($msgNotify,";")
			If $values[0] > 1 Then
				Switch $values[1]
				Case "DBLCLICK_LV"
					If $values[0] = 3 Then
						Local $i = Number($values[2]), $j = Number($values[3]), $listview = $panneaux[$i][1]
						Local $param = listview_stringToParam(_GUICtrlListView_GetItemTextString($listview,$j))
						$nombre = afficheInput($param[1], $param[0], $listview, $GUI)
						If $nombre > 0 Then
							_GUICtrlListView_SetItemText($listview, $j, $nombre&" x "&$param[1])
							_GUICtrlListView_SetColumnWidth($listview, 0, $LVSCW_AUTOSIZE)
						EndIf
					EndIf
				Case "DELETE_LV"
					If $values[0] = 2 Then
						Local $i = Number($values[2]),$listview = $panneaux[$i][1]
						For $j = _GUICtrlListView_GetItemCount($listview)-1 To 0 Step -1
							If _GUICtrlListView_GetItemSelected($listview, $j) Then
								_GUICtrlListView_DeleteItem($listview, $j)
							EndIf
						Next
						_GUICtrlListView_SetColumnWidth($listview, 0, $LVSCW_AUTOSIZE)
					EndIf
				EndSwitch
			EndIf
			$msgNotify = ""
		EndIf
		#EndRegion
	WEnd
	stopTrigger("delete")
	gui_sauvegarderPanneaux($GUI)
	GUIDelete($GUI)
EndFunc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Fentre d'aide
Func afficheAide($donnees)
	Local $aide = GUICreate($MODULE_NOM&" v"&$MODULE_VERSION, 500, 400, Default, Default, $WS_POPUPWINDOW)
	; Icone de la fentre
	GUISetIcon($MODULE_DIR&"\"&$MODULE_NOM&".ico", Default, $aide)
	Local $aide_titre = GUICtrlCreateLabel($MODULE_NOM&" : Aide", 10, 5, 500-45, 25, Default, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont($aide_titre, 14, 800)
	Local $aide_quitter = GUICtrlCreateButton("X", 500-30, 5, 25, 25)
	GUICtrlSetTip($aide_quitter, "Fermer")
	Local $aide_separateur = GUICtrlCreateLabel("", 5, 35, 500-10, 1)
	GUICtrlSetBkColor($aide_separateur, 0x000000)
	Local $aide_tree = GUICtrlCreateTreeView(5, 40, 500-10, 400-45, BitOR($TVS_HASBUTTONS, $TVS_LINESATROOT, $TVS_DISABLEDRAGDROP, $TVS_SHOWSELALWAYS, $WS_TABSTOP))
	For $i = 1 To $donnees[0]
		Local $values = StringSplit($donnees[$i], @CRLF, 1)
		If Not @error And $values[0] > 1 Then
			Local $menu = GUICtrlCreateTreeViewItem($values[1], $aide_tree)
			For $j = 2 To $values[0]
				Local $subvalues = StringSplit($values[$j], "#", 1)
				Local $item = GUICtrlCreateTreeViewItem($subvalues[1], $menu)
				If $subvalues[0] > 1 Then
					For $k = 2 To $subvalues[0]
						Local $child = GUICtrlCreateTreeViewItem("-> "&$subvalues[$k], $menu)
					Next
					GUICtrlSetState($item, $GUI_EXPAND)
				EndIf
			Next
			GUICtrlSetState($menu, $GUI_DEFBUTTON)
		EndIf
	Next
	; Finalisation
	GuiSetState(@SW_SHOW, $aide)
	; Boucle de traitement
	While $stop = False
		Local $msg = GuiGetMsg()
		If $msg = $aide_quitter Or $msg = -3 Then ; $GUI_EVENT_CLOSE = -3
			$stop = True
		EndIf
	WEnd
	GUISetState(@SW_HIDE, $aide)
	GUIDelete($aide)
EndFunc
; Fonction d'affichage d'un item d'une listview
Func listview_paramToString($nombre, $valeur)
	Local $resultat = $nombre&" x "&$valeur
	Return $resultat
EndFunc
; Fonction d'affichage d'un item d'une listview
Func listview_stringToParam($texte)
	Local $resultat[2]
	$resultat[0] = StringLeft($texte, StringInStr($texte," x ")-1)
	$resultat[1] = StringTrimLeft($texte, StringLen($resultat[0]&" x "))
	Return $resultat
EndFunc
; Fonction de dcomposition d'un item
Func getDecomposition($metier, $item)
	Local $resultat[1] = [0], $element = listview_stringToParam($item), $crafts = xml_getCrafts($metier)
	For $i = 1 To $crafts[0]
		If xml_getNom($crafts[$i]) = $element[1] Then
			Local $ingredients = xml_getIngredients($crafts[$i])
			For $j = 1 To $ingredients[0]
				$resultat[0] = $resultat[0]+1
				ReDim $resultat[$resultat[0]+1]
				$resultat[$resultat[0]] = ($element[0]*xml_getNbre($ingredients[$j]))&" x "&xml_getNom($ingredients[$j])
			Next
		EndIf
	Next
	Return $resultat
EndFunc
; Fonction de dcomposition d'un item (recette complte)
Func getConfectionFull($metier, $items)
	Local $crafts = xml_getCrafts($metier), $completes[1] = [0]
	For $i = 1 To $crafts[0]
		Local $ingredients = xml_getIngredients($crafts[$i]), $resultat = $MAX_ITEM+1
		If $ingredients[0] > 0 And $ingredients[0] <= $items[0] Then
			For $j = 1 To $ingredients[0]
				If $resultat > 0 Then
					Local $ingredient = xml_getNom($ingredients[$j]), $nombre = xml_getNbre($ingredients[$j]), $found = 0
					For $k = 1 To $items[0]
						Local $item = listview_stringToParam($items[$k])
						If $ingredient = $item[1] And $item[0]*$nombre > 0 Then
							$found = $k
							ExitLoop
						EndIf
					Next
					If $found > 0 Then
						Local $item = listview_stringToParam($items[$found])
						$resultat = min($resultat, Floor($item[0]/$nombre))
					Else
						$resultat = 0
					EndIf
				EndIf
			Next
			If $resultat > 0 Then
				Local $texte = $resultat&" x "&xml_getNom($crafts[$i])
				$completes[0] = $completes[0]+1
				ReDim $completes[$completes[0]+1]
				$completes[$completes[0]] = $texte
			EndIf
		EndIf
	Next
	Return $completes
EndFunc
; Fonction de dcomposition d'un item (recette partielle)
Func getConfectionPart($metier, $items, $exclusions = "")
	Local $crafts = xml_getCrafts($metier), $partielles[1] = [0], $completes[1] = [0]
	If IsArray($exclusions) And UBound($exclusions) = $exclusions[0]+1 Then $completes = $exclusions
	For $i = 1 To $crafts[0]
		Local $ingredients = xml_getIngredients($crafts[$i]), $resultat = 0
		If $ingredients[0] > 0 Then
			For $j = 1 To $ingredients[0]
				Local $ingredient = xml_getNom($ingredients[$j]), $nombre = xml_getNbre($ingredients[$j]), $found = 0
				For $k = 1 To $items[0]
					Local $item = listview_stringToParam($items[$k])
					If $ingredient = $item[1] And $item[0]*$nombre > 0 Then
						$found = $k
						ExitLoop
					EndIf
				Next
				If $found > 0 Then
					Local $item = listview_stringToParam($items[$found])
					$resultat = max($resultat, Floor($item[0]/$nombre))
				EndIf
			Next
			If $resultat > 0 Then
				Local $texte = $resultat&" x "&xml_getNom($crafts[$i]), $doublon = False
				For $j = 1 To $completes[0]
					If $completes[$j] = $texte Then
						$doublon = True
					EndIf
				Next
				If Not $doublon Then
					$partielles[0] = $partielles[0]+1
					ReDim $partielles[$partielles[0]+1]
					$partielles[$partielles[0]] = $texte
				EndIf
			EndIf
		EndIf
	Next
	Return $partielles
EndFunc
; Fonction d'ajout dans une listview
Func ajouterListview($control, $item)
	Local $param = listview_stringToParam($item)
	For $i = 0 To _GUICtrlListView_GetItemCount($control)-1
		Local $param2 = listview_stringToParam(_GUICtrlListView_GetItemTextString($control, $i))
		If $param[1] = $param2[1] Then
			_GUICtrlListView_SetItemText($control, $i, ($param2[0]+$param[0])&" x "&$param[1])
			_GUICtrlListView_SetColumnWidth($control, 0, $LVSCW_AUTOSIZE)
			Return
		EndIf
	Next
	GUICtrlCreateListViewItem($item, $control)
	_GUICtrlListView_SetColumnWidth($control, 0, $LVSCW_AUTOSIZE)
EndFunc
; Fonction de soustraction dans une listview
Func soustraireListview($control, $item)
	Local $param = listview_stringToParam($item)
	For $i = 0 To _GUICtrlListView_GetItemCount($control)-1
		Local $param2 = listview_stringToParam(_GUICtrlListView_GetItemTextString($control, $i))
		If $param[1] = $param2[1] Then
			If $param2[0] > $param[0] Then
				_GUICtrlListView_SetItemText($control, $i, ($param2[0]-$param[0])&" x "&$param[1])
			Else
				_GUICtrlListView_DeleteItem($control, $i)
			EndIf
			ExitLoop
		EndIf
	Next
	_GUICtrlListView_SetColumnWidth($control, 0, $LVSCW_AUTOSIZE)
EndFunc
; Fonction de modification dans une listview
Func modifierListview($control, $item)
	Local $param = listview_stringToParam($item)
	For $i = 0 To _GUICtrlListView_GetItemCount($control)-1
		Local $param2 = listview_stringToParam(_GUICtrlListView_GetItemTextString($control)-1)
		If $param[1] = $param2[1] Then
			_GUICtrlListView_SetItemText($control, $i, $item)
			_GUICtrlListView_SetColumnWidth($control, 0, $LVSCW_AUTOSIZE)
			ExitLoop
		EndIf
	Next
EndFunc
; Fonction de retrait dans une listview
Func retirerListview($control, $item)
	Local $param = listview_stringToParam($item)
	For $i = 0 To _GUICtrlListView_GetItemCount($control)-1
		Local $param2 = listview_stringToParam(_GUICtrlListView_GetItemTextString($control)-1)
		If $param[1] = $param2[1] Then
			_GUICtrlListView_DeleteItem($control, $i)
			_GUICtrlListView_SetColumnWidth($control, 0, $LVSCW_AUTOSIZE)
			ExitLoop
		EndIf
	Next
EndFunc
; Traitement des clics sur les listviews
Func clicNotify($hWnd, $iMsg, $iwParam, $ilParam)
	Local $structure1 = DllStructCreate("struct;hwnd hWndFrom;uint_ptr IDFrom;int Code;endstruct", $ilParam)
	Local $listview   = DllStructGetData($structure1, "hWndFrom")
	Local $iIDFrom    = DllStructGetData($structure1, "IDFrom")
	Local $code       = DllStructGetData($structure1, "Code")
	If $code = $NM_DBLCLK Then
		For $i = 0 To $panneaux[0][0]
			Local $control = si(IsHWnd($panneaux[$i][1]), $panneaux[$i][1], GUICtrlGetHandle($panneaux[$i][1]))
			If HWnd($listview) = $control Then
				Local $structure2 = DllStructCreate( _
					"struct;hwnd hWndFrom;uint_ptr IDFrom;int Code;endstruct;int Index;int SubItem;uint NewState;" &  _
					"uint OldState;uint Changed;struct;long X;long Y;endstruct;lparam lParam;uint KeyFlags", $ilParam _
				)
				Local $index = DllStructGetData($structure2, "Index")
				If $index > -1 and $index < _GUICtrlListView_GetItemCount($control) Then $msgNotify = "DBLCLICK_LV"&";"&$i&";"&$index
				ExitLoop
			EndIf
		Next
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc
; Fentre de frappe
Func afficheInput($matiere, $quantite, $control, $parent)
	GUISetState(@SW_LOCK, $parent)
	Local $ajout = Number($quantite)=0, $frame = getControlCoords($parent, $control), $dim[2] = [60,24], $resultat = 0
	$child = GUICreate("", $dim[0],$dim[1], $frame[0]+$frame[2]/2-$dim[0]/2,$frame[1]+$frame[3]/3-$dim[1]/2, $WS_POPUPWINDOW)
	$child_input = GUICtrlCreateInput(""&si($ajout,1,$quantite), 2,2, $dim[0]-4,$dim[1]-4, $ES_NUMBER)
	Local $titre = si($ajout, "Element  ajouter","Elment  modifier")
	Local $texte = si($ajout, "Quantit pour l'lment suivant :"&@CRLF&""""&"???","Nouvelle quantit pour l'lment suivant :"&@CRLF&""""&$quantite)&" x "&$matiere&""""
	ToolTip($texte&@CRLF&@CRLF&"[Entre]:Valider , [Echap]:Annuler", $frame[0]+$frame[2]/2-$dim[0]/2, $frame[1]+$frame[3]/3+$dim[1]/2 + 5, $titre)
	GUICtrlSetLimit($child_input, StringLen($MAX_ITEM))
	GUISetState(@SW_SHOW, $child)
	startTrigger("enter")
	Local $timer = TimerInit(), $timeout = 30
	While Not $stop And Not isTrigger("enter") And TimerDiff($timer) < $timeout*1000 And WinActive($child) = $child
		Local $msg = GUIGetMsg()
		If $msg = $GUI_EVENT_CLOSE Then ExitLoop
	WEnd
	If isTrigger("enter") Then $resultat = Number(GUICtrlRead($child_input))
	stopTrigger("enter")
	ToolTip("")
	GUIDelete($child)
	While GUIGetMsg() <> 0
		Sleep(50)
	WEnd
	GUISetState(@SW_UNLOCK, $parent)
	WinActivate($parent)
	Return $resultat
EndFunc
; Restauration des panneaux
Func gui_restaurerPanneaux($GUI, $jobs)
	gui_ajouterPanneau($GUI)
	Local $n = Number(IniRead($fichierCfg, "Metiers", "Nb", "0"))
	For $i = 1 To $n
		Local $found = 0, $job = IniRead($fichierCfg, "Metiers", StringRight("000"&($i),3), "")
		For $j = 1 To $jobs[0]
			If xml_getNom($jobs[$j]) = $job Then $found = $j
		Next
		If $j > 0 Then
			gui_ajouterPanneau($GUI, $jobs[$found])
		EndIf
	Next
	For $i = 0 To $panneaux[0][0]
		Local $listview = $panneaux[$i][1]
		For $j = 0 To Number(IniRead($fichierCfg, "Metier"&"_"&StringRight("000"&($i),3), "Nb", "0"))-1
			Local $texte = IniRead($fichierCfg, "Metier"&"_"&StringRight("000"&($i),3), StringRight("000"&($j+1),3), "")
			If $texte <> "" Then ajouterListview($listview, $texte)
		Next
	Next
EndFunc
; Sauvegarde des panneaux
Func gui_sauvegarderPanneaux($GUI)
	Local $flux = FileOpen($fichierCfg, 10)
	If Not @error Then
		FileClose($flux)
		; Metiers
		IniWrite($fichierCfg, "Metiers", "Nb", $panneaux[0][0])
		For $i = 1 To $panneaux[0][0]
			IniWrite($fichierCfg, "Metiers", StringRight("000"&($i),3), xml_getNom($panneaux[$i][0]))
		Next
		; Items
		For $i = 0 To $panneaux[0][0]
			Local $listview = $panneaux[$i][1]
			IniWrite($fichierCfg, "Metier"&"_"&StringRight("000"&($i),3), "Nb", _GUICtrlListView_GetItemCount($listview))
			For $j = 0 To _GUICtrlListView_GetItemCount($listview)-1
				Local $texte = _GUICtrlListView_GetItemTextString($listview, $j)
				IniWrite($fichierCfg, "Metier"&"_"&StringRight("000"&($i),3), StringRight("000"&($j+1),3), $texte)
			Next
		Next
	EndIf
EndFunc
; Ajout d'un panneau
Func gui_ajouterPanneau($GUI, $metier = "")
	; Initialisation
	Local $index = $panneaux[0][0]+1, $vide[1][2] = [[0]], $position = WinGetPos($GUI)
	If $metier = "" Then
		; Ajout des lments graphiques
		$panneaux[0][0] = 0
		$panneaux[0][1] = GUICtrlCreateListView("Liste n0", 210*0+5, 65, 200, 250, BitOR($LVS_SHOWSELALWAYS,$LVS_REPORT,$LVS_NOCOLUMNHEADER,$WS_HSCROLL,$WS_VSCROLL))
		$panneaux[0][2] = GUICtrlCreateButton("...", 210*0+180, 40, 25, 20)
		$panneaux[0][3] = GUICtrlCreateContextMenu($panneaux[0][1])
		$panneaux[0][4] = "NOT_DECLARED"
		$panneaux[0][5] = $vide
		$panneaux[0][6] = $vide
		$panneaux[0][7] = "NOT_DECLARED"
		$panneaux[0][8] = $vide
		$panneaux[0][9] = $vide
		; Mise  jour des tats des lments graphiques
		_GUICtrlListView_SetColumnWidth($panneaux[0][1], 0, $LVSCW_AUTOSIZE)
		GUICtrlSetState($panneaux[0][1], $GUI_DROPACCEPTED)
		; Positionnement des lments graphiques
		GUICtrlSetResizing($panneaux[0][1], $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
		GUICtrlSetResizing($panneaux[0][2], $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
		; Redimensionnement de la fentre
		Local $control = ControlGetPos($GUI, "", $panneaux[0][1])
		WinMove($GUI, "", Default, Default, 210, $control[1]+$control[3]+5)
	Else
		; Ajout d'un emplacement
		ReDim $panneaux[UBound($panneaux,1)+1][UBound($panneaux,2)]
		$panneaux[0][0] = $index
		; Ajout des lments graphiques
		$panneaux[$index][0] = $metier
		$panneaux[$index][1] = GUICtrlCreateListView("Liste n"&$index, 210*$index+5, 65, 200, 250, BitOR($LVS_SHOWSELALWAYS,$LVS_REPORT,$LVS_NOCOLUMNHEADER,$WS_HSCROLL,$WS_VSCROLL))
		$panneaux[$index][2] = GUICtrlCreateButton("...", 210*$index+180, 40, 25, 20)
		$panneaux[$index][3] = GUICtrlCreateContextMenu($panneaux[$index][1])
		$panneaux[$index][4] = "NOT_DECLARED"
		$panneaux[$index][5] = $vide
		$panneaux[$index][6] = $vide
		$panneaux[$index][7] = GUICtrlCreateMenu(xml_getNom($metier), $panneaux[$index][3])
		$panneaux[$index][8] = $vide
		$panneaux[$index][9] = $vide
		Local $slots[9] = [8], $slots_menus[$slots[0]+1][2] = [[$slots[0]]]
		For $i = 1 To $slots[0]
			$slots_menus[$i][1] = $i&" "&"ingrdient"&si($i>1,"s","")
			$slots_menus[$i][0] = GUICtrlCreateMenu($slots_menus[$i][1], $panneaux[$index][7])
			GUICtrlSetState($slots_menus[$i][0], $GUI_DISABLE)
		Next
		$panneaux[$index][8] = $slots_menus
		Local $crafts = xml_getCrafts($metier), $crafts_items[$crafts[0]+1][2] = [[$crafts[0]]]
		For $i = 1 To $crafts[0]
			$crafts_items[$i][1] = xml_getNom($crafts[$i])
			$crafts_items[$i][0] = GUICtrlCreateMenuItem($crafts_items[$i][1],$slots_menus[xml_getSlot($crafts[$i])][0])
			GUICtrlSetState($slots_menus[xml_getSlot($crafts[$i])][0], $GUI_ENABLE)
		Next
		$panneaux[$index][9] = $crafts_items
		; Mise  jour des tats des lments graphiques
		_GUICtrlListView_SetColumnWidth($panneaux[$index][1], 0, $LVSCW_AUTOSIZE)
		GUICtrlSetState($panneaux[$index][1], $GUI_DROPACCEPTED)
		; Modification des lments graphiques du panneau prcdent
		GUICtrlSetPos($panneaux[$index-1][2], 210*($index-1)+135, 40, 150, 20)
		GUICtrlSetData($panneaux[$index-1][2], xml_getNom($metier))
		$panneaux[$index-1][4] = GUICtrlCreateMenu(xml_getNom($metier), $panneaux[$index-1][3])
		Local $categories = xml_getCategories($metier), $categories_menus[$categories[0]+1][2] = [[$categories[0]]]
		For $i = 1 To $categories[0]
			$categories_menus[$i][1] = xml_getNom($categories[$i])
			$categories_menus[$i][0] = GUICtrlCreateMenu($categories_menus[$i][1],$panneaux[$index-1][4])
		Next
		$panneaux[$index-1][5] = $categories_menus
		Local $materiaux_items[1][2] = [[0]]
		For $i = 1 To $categories[0]
			Local $materiaux = xml_getMateriaux($categories[$i])
			$materiaux_items[0][0] = $materiaux_items[0][0]+$materiaux[0]
			ReDim $materiaux_items[$materiaux_items[0][0]+1][2]
			For $j = 1 To $materiaux[0]
				$materiaux_items[$materiaux_items[0][0]-$materiaux[0]+$j][1] = xml_getNom($materiaux[$j])
				$materiaux_items[$materiaux_items[0][0]-$materiaux[0]+$j][0] = GUICtrlCreateMenuItem($materiaux_items[$materiaux_items[0][0]-$materiaux[0]+$j][1], $categories_menus[$i][0])
			Next
		Next
		$panneaux[$index-1][6] = $materiaux_items
		; Positionnement des lments graphiques
		GUICtrlSetResizing($panneaux[$index][1], $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
		GUICtrlSetResizing($panneaux[$index][2], $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
		; Redimensionnement de la fentre
		WinMove($GUI, "", max(0,$position[0]-105), Default, 210*($index+1), Default)
	EndIf
EndFunc

; Retrait d'un panneau
Func gui_effacerPanneau($GUI)
	; Initialisation
	Local $index = $panneaux[0][0], $vide[1][2] = [[0]], $position = WinGetPos($GUI)
	If $index > 0 Then
		; Redimensionnement de la fentre
		WinMove($GUI, "", $position[0]+105, Default, 210*($index), Default)
		; Modification des lments graphiques du panneau prcdent
		Local $liste = $panneaux[$index-1][6]
		For $i = 1 To $liste[0][0]
			If IsInt($liste[$i][0]) Then GUICtrlDelete($liste[$i][0])
		Next
		Local $liste = $panneaux[$index-1][5]
		For $i = 1 To $liste[0][0]
			If IsInt($liste[$i][0]) Then GUICtrlDelete($liste[$i][0])
		Next
		If IsInt($panneaux[$index-1][4]) Then GUICtrlDelete($panneaux[$index-1][4])
		$panneaux[$index-1][6] = $vide
		$panneaux[$index-1][5] = $vide
		$panneaux[$index-1][4] = "NOT_DECLARED"
		GUICtrlSetPos($panneaux[$index-1][2], 210*($index-1)+180, 40, 25, 20)
		GUICtrlSetData($panneaux[$index-1][2], "...")
		; Effacement des lments graphiques
		Local $liste = $panneaux[$index][9]
		For $i = 1 To $liste[0][0]
			If IsInt($liste[$i][0]) Then GUICtrlDelete($liste[$i][0])
		Next
		Local $liste = $panneaux[$index][8]
		For $i = 1 To $liste[0][0]
			If IsInt($liste[$i][0]) Then GUICtrlDelete($liste[$i][0])
		Next
		If IsInt($panneaux[$index][7]) Then GUICtrlDelete($panneaux[$index][7])
		Local $liste = $panneaux[$index][6]
		For $i = 1 To $liste[0][0]
			If IsInt($liste[$i][0]) Then GUICtrlDelete($liste[$i][0])
		Next
		Local $liste = $panneaux[$index][5]
		For $i = 1 To $liste[0][0]
			If IsInt($liste[$i][0]) Then GUICtrlDelete($liste[$i][0])
		Next
		If IsInt($panneaux[$index][4]) Then GUICtrlDelete($panneaux[$index][4])
		If IsInt($panneaux[$index][3]) Then GUICtrlDelete($panneaux[$index][3])
		If IsInt($panneaux[$index][2]) Then GUICtrlDelete($panneaux[$index][2])
		If IsInt($panneaux[$index][1]) Then GUICtrlDelete($panneaux[$index][1])
		; Effacement d'un emplacement
		ReDim $panneaux[UBound($panneaux,1)-1][UBound($panneaux,2)]
		$panneaux[0][0] = $panneaux[0][0]-1
	EndIf
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region
; Rcupration de l'attribut 'nom' pour un lment
Func xml_getNom($element)
	Return $element.GetAttribute("nom")
EndFunc
; Rcupration de l'attribut 'nbre' pour un ingrdient
Func xml_getNbre($element)
	Return $element.GetAttribute("nbre")
EndFunc
; Rcupration du slot pour un craft
Func xml_getSlot($craft)
	Local $n = 0, $ingredients = $craft.SelectNodes("ingredient")
	For $ingredient In $ingredients
		$n = $n+1
	Next
	Return $n
EndFunc
; Rcupration de la structure XML pour un fichier
Func xml_getRacine($file)
	Local $racine = ObjCreate("Microsoft.XMLDOM")
	If IsObj($racine) And FileExists($file) Then
		$racine.Async = "false"
		$racine.Load($file)
	EndIf
	Return $racine
EndFunc
; Rcupration de la liste des mtiers pour une structure XML
Func xml_getMetiers($racine)
	Local $liste[1] = [0], $metiers = $racine.SelectNodes("/donnees/metier")
	For $metier In $metiers
		$liste[0] = $liste[0]+1
		ReDim $liste[$liste[0]+1]
		$liste[$liste[0]] = $metier
	Next
	Return $liste
EndFunc
; Rcupration de la liste des crafts pour un mtier
Func xml_getCrafts($metier)
	Local $liste[1] = [0], $crafts = $metier.SelectNodes("crafts/craft")
	For $craft In $crafts
		$liste[0] = $liste[0]+1
		ReDim $liste[$liste[0]+1]
		$liste[$liste[0]] = $craft
	Next
	Return $liste
EndFunc
; Rcupration de la liste des ingredients pour un craft
Func xml_getIngredients($craft)
	Local $liste[1] = [0], $ingredients = $craft.SelectNodes("ingredient")
	For $ingredient In $ingredients
		$liste[0] = $liste[0]+1
		ReDim $liste[$liste[0]+1]
		$liste[$liste[0]] = $ingredient
	Next
	Return $liste
EndFunc
; Rcupration de la liste des catgories de matriaux pour un mtier
Func xml_getCategories($metier)
	Local $liste[1] = [0], $categories = $metier.SelectNodes("materiaux/categorie")
	For $categorie In $categories
		$liste[0] = $liste[0]+1
		ReDim $liste[$liste[0]+1]
		$liste[$liste[0]] = $categorie
	Next
	Return $liste
EndFunc
; Rcupration de la liste des materiaux pour une catgorie
Func xml_getMateriaux($categorie)
	Local $liste[1] = [0], $ingredients = $categorie.SelectNodes("ingredient")
	For $ingredient In $ingredients
		$liste[0] = $liste[0]+1
		ReDim $liste[$liste[0]+1]
		$liste[$liste[0]] = $ingredient
	Next
	Return $liste
EndFunc
; Interception des messages
Func interceptMsg()
	While GUIGetMsg() <> 0
		; Rien
	WEnd
EndFunc
; Dclenchement de l'affichage d'un sousmenu
Func sousmenu($GUI, $target, $context)
	Local $menu = GUICtrlGetHandle($context), $position = ControlGetPos($GUI, "", $target), $coords = DllStructCreate("int;int")
	DllStructSetData($coords, 1, $position[0]+10)
	DllStructSetData($coords, 2, $position[1]+10)
	DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $GUI, "ptr", DllStructGetPtr($coords))
	DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $menu, "int", 0, "int", DllStructGetData($coords, 1), "int", DllStructGetData($coords, 2), "hwnd", $GUI, "ptr", 0)
EndFunc
#EndRegion

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region BROUILLON
;~ 		ElseIf $msg = $bouton12 Then														; Bouton fenetre 1 -> fenetre 2
;~ 			_GUICtrlListBox_BeginUpdate($fenetre1)
;~ 			_GUICtrlListBox_BeginUpdate($fenetre2)
;~ 			$arrayCursor = GUIGetCursorInfo($GUI)
;~ 			If $arrayCursor[3] = 1 Then
;~ 				For $i = _GUICtrlListBox_GetCount($fenetre2)-1 To 0 Step -1
;~ 					_GUICtrlListBox_DeleteString($fenetre2, $i)
;~ 				Next
;~ 			EndIf
;~ 			_GUICtrlListBox_EndUpdate($fenetre2)
;~ 			For $i = 0 To _GUICtrlListBox_GetCount($fenetre1)-1
;~ 				If _GUICtrlListBox_GetSel($fenetre1,$i) Then
;~ 					$valeur = _GUICtrlListBox_GetText($fenetre1, $i)
;~ 					$str = StringSplit($valeur, " x ", 1)
;~ 					If $str[0] = 2 Then
;~ 						$n = Number($str[1])
;~ 						$objet = $str[2]
;~ 						$recette = getRecette($metiers_actifs[0], $objet)
;~ 						If $recette[0][0] <> "" Then
;~ 							_GUICtrlListBox_SetSel($fenetre1, $i, 1)
;~ 						Else
;~ 							_GUICtrlListBox_SetSel($fenetre1, $i, 0)
;~ 						EndIf
;~ 						For $j = 0 To UBound($recette,1)-1
;~ 							ajouteIngredient($fenetre2, $recette[$j][0], $n * $recette[$j][1])
;~ 						Next
;~ 					EndIf
;~ 				EndIf
;~ 			Next
;~ 			_GUICtrlListBox_EndUpdate($fenetre1)
;~ 		ElseIf $msg = $bouton21 Then														; Bouton fenetre 1 <- fenetre 2
;~ 			_GUICtrlListBox_BeginUpdate($fenetre2)
;~ 			_GUICtrlListBox_BeginUpdate($fenetre1)
;~ 			$arrayCursor = GUIGetCursorInfo($GUI)
;~ 			If $arrayCursor[3] = 0 Then
;~ 				For $i = _GUICtrlListBox_GetCount($fenetre1)-1 To 0 Step -1
;~ 					_GUICtrlListBox_DeleteString($fenetre1, $i)
;~ 				Next
;~ 				ReDim $liste_retour[1][2]
;~ 				$liste_retour[0][0] = ""
;~ 				$liste_retour[0][1] = 0
;~ 				For $i = 0 To _GUICtrlListBox_GetCount($fenetre2)-1
;~ 					If _GUICtrlListBox_GetSel($fenetre2,$i) Then
;~ 						$valeur = _GUICtrlListBox_GetText($fenetre2, $i)
;~ 						$str = StringSplit($valeur, " x ", 1)
;~ 						If $str[0] = 2 Then
;~ 							$recette = getCraft($metiers_actifs[0], $str[2], Number($str[1]))
;~ 							$liste_retour = combinerCrafts($liste_retour, $recette)
;~ 						EndIf
;~ 					EndIf
;~ 				Next
;~ 				For $i = 0 To UBound($liste_retour,1)-1
;~ 					ajouteIngredient($fenetre1, $liste_retour[$i][0], $liste_retour[$i][1])
;~ 				Next
;~ 			Else
;~ 				For $i = _GUICtrlListBox_GetCount($fenetre1)-1 To 0 Step -1
;~ 					_GUICtrlListBox_DeleteString($fenetre1, $i)
;~ 				Next
;~ 				ReDim $liste_retour[1][2]
;~ 				$liste_retour[0][0] = ""
;~ 				$liste_retour[0][1] = 0
;~ 				For $i = 0 To _GUICtrlListBox_GetCount($fenetre2)-1
;~ 					If _GUICtrlListBox_GetSel($fenetre2,$i) Then
;~ 						$valeur = _GUICtrlListBox_GetText($fenetre2, $i)
;~ 						$str = StringSplit($valeur, " x ", 1)
;~ 						If $str[0] = 2 Then
;~ 							$recette = getCraft($metiers_actifs[0], $str[2], Number($str[1]))
;~ 							$j = 0
;~ 							If $recette[0][0]<>"" Then
;~ 								$choix = recette_choix($recette,1)
;~ 								ajouteIngredient($fenetre1, $choix[0], $choix[1])
;~ 							EndIf
;~ 						EndIf
;~ 					EndIf
;~ 				Next
;~ 			EndIf
;~ 			_GUICtrlListBox_EndUpdate($fenetre1)
;~ 			_GUICtrlListBox_EndUpdate($fenetre2)
;~ 		ElseIf $msg = $bouton23 Then														; Bouton fenetre 2 -> fenetre 3
;~ 			_GUICtrlListBox_BeginUpdate($fenetre2)
;~ 			_GUICtrlListBox_BeginUpdate($fenetre3)
;~ 			$arrayCursor = GUIGetCursorInfo($GUI)
;~ 			If $arrayCursor[3] = 1 Then
;~ 				For $i = _GUICtrlListBox_GetCount($fenetre3)-1 To 0 Step -1
;~ 					_GUICtrlListBox_DeleteString($fenetre3, $i)
;~ 				Next
;~ 			EndIf
;~ 			_GUICtrlListBox_EndUpdate($fenetre3)
;~ 			For $i = 0 To _GUICtrlListBox_GetCount($fenetre2)-1
;~ 				If _GUICtrlListBox_GetSel($fenetre2,$i) Then
;~ 					$valeur = _GUICtrlListBox_GetText($fenetre2, $i)
;~ 					$str = StringSplit($valeur, " x ", 1)
;~ 					If $str[0] = 2 Then
;~ 						$n = Number($str[1])
;~ 						$objet = $str[2]
;~ 						$recette = getRecette($metiers_actifs[1], $objet)
;~ 						If $recette[0][0] <> "" Then
;~ 							_GUICtrlListBox_SetSel($fenetre2, $i, 1)
;~ 						Else
;~ 							_GUICtrlListBox_SetSel($fenetre2, $i, 0)
;~ 						EndIf
;~ 						For $j = 0 To UBound($recette,1)-1
;~ 							ajouteIngredient($fenetre3, $recette[$j][0], $n * $recette[$j][1])
;~ 						Next
;~ 					EndIf
;~ 				EndIf
;~ 			Next
;~ 			_GUICtrlListBox_EndUpdate($fenetre2)
;~ 		ElseIf $msg = $bouton32 Then														; Bouton fenetre 2 <- fenetre 3
;~ 			_GUICtrlListBox_BeginUpdate($fenetre3)
;~ 			_GUICtrlListBox_BeginUpdate($fenetre2)
;~ 			$arrayCursor = GUIGetCursorInfo($GUI)
;~ 			If $arrayCursor[3] = 0 Then
;~ 				For $i = _GUICtrlListBox_GetCount($fenetre2)-1 To 0 Step -1
;~ 					_GUICtrlListBox_DeleteString($fenetre2, $i)
;~ 				Next
;~ 				ReDim $liste_retour[1][2]
;~ 				$liste_retour[0][0] = ""
;~ 				$liste_retour[0][1] = 0
;~ 				For $i = 0 To _GUICtrlListBox_GetCount($fenetre3)-1
;~ 					If _GUICtrlListBox_GetSel($fenetre3,$i) Then
;~ 						$valeur = _GUICtrlListBox_GetText($fenetre3, $i)
;~ 						$str = StringSplit($valeur, " x ", 1)
;~ 						If $str[0] = 2 Then
;~ 							$recette = getCraft($metiers_actifs[1], $str[2], Number($str[1]))
;~ 							$liste_retour = combinerCrafts($liste_retour, $recette)
;~ 						EndIf
;~ 					EndIf
;~ 				Next
;~ 				For $i = 0 To UBound($liste_retour,1)-1
;~ 					ajouteIngredient($fenetre2, $liste_retour[$i][0], $liste_retour[$i][1])
;~ 				Next
;~ 			Else
;~ 				For $i = _GUICtrlListBox_GetCount($fenetre2)-1 To 0 Step -1
;~ 					_GUICtrlListBox_DeleteString($fenetre2, $i)
;~ 				Next
;~ 				ReDim $liste_retour[1][2]
;~ 				$liste_retour[0][0] = ""
;~ 				$liste_retour[0][1] = 0
;~ 				For $i = 0 To _GUICtrlListBox_GetCount($fenetre3)-1
;~ 					If _GUICtrlListBox_GetSel($fenetre3,$i) Then
;~ 						$valeur = _GUICtrlListBox_GetText($fenetre3, $i)
;~ 						$str = StringSplit($valeur, " x ", 1)
;~ 						If $str[0] = 2 Then
;~ 							$recette = getCraft($metiers_actifs[1], $str[2], Number($str[1]))
;~ 							$j = 0
;~ 							If $recette[0][0]<>"" Then
;~ 								$choix = recette_choix($recette,1)
;~ 								ajouteIngredient($fenetre2, $choix[0], $choix[1])
;~ 							EndIf
;~ 						EndIf
;~ 					EndIf
;~ 				Next
;~ 			EndIf
;~ 			_GUICtrlListBox_EndUpdate($fenetre2)
;~ 			_GUICtrlListBox_EndUpdate($fenetre3)
;~ 		Else
;~ 			For $i = 0 To UBound($sousmenus_metier12)-1												; Choix metier 12
;~ 				If $msg = $sousmenus_metier12[$i][0] Then
;~ 					GUICtrlSetState($fenetre1, $GUI_ENABLE)
;~ 					GUICtrlSetState($fenetre_modifier1, $GUI_ENABLE)
;~ 					GUICtrlSetState($bouton12, $GUI_ENABLE)
;~ 					GUICtrlSetState($bouton21, $GUI_ENABLE)
;~ 					GUICtrlSetState($fenetre2, $GUI_ENABLE)
;~ 					GUICtrlSetState($fenetre_modifier2, $GUI_ENABLE)
;~ 					GUICtrlSetImage($metier12, $MODULE_DIR&"\Images\"&$sousmenus_metier12[$i][1]&".bmp")
;~ 					For $j = 0 To UBound($metiers,1)-1
;~ 						If $metiers[$j][0] = $sousmenus_metier12[$i][1] Then
;~ 							#Region Effacement menus
;~ 							If $metiers_actifs[0] <> "" Then GUICtrlDelete($menu_fenetre1)
;~ 							If $metiers_actifs[0] <> "" Or $metiers_actifs[1] <> "" Then
;~ 								; Fenetre 1
;~ 								GUICtrlDelete($menu1_fenetre1)
;~ 								GUICtrlDelete($menu2_fenetre1)
;~ 								GUICtrlDelete($menu3_fenetre1)
;~ 							EndIf
;~ 							$menu_fenetre1 = GUICtrlCreateContextMenu($fenetre1)
;~ 							If $metiers_actifs[1] <> "" Then
;~ 								; Fenetre 2
;~ 								GUICtrlDelete($menu2_fenetre2)
;~ 								GUICtrlDelete($menu3_fenetre2)
;~ 							Else
;~ 								$menu_fenetre2 = GUICtrlCreateContextMenu($fenetre2)
;~ 							EndIf
;~ 							#EndRegion
;~ 							#Region Menus fenetre 1
;~ 							; Crafts
;~ 							$menu1_fenetre1 = GUICtrlCreateMenu("Crafts", $menu_fenetre1,0)
;~ 							$liste_crafts = $metiers[$j][1]
;~ 							ReDim $liste1_fenetre1[UBound($liste_crafts)][2]
;~ 							For $k = 0 To UBound($liste_crafts)-1
;~ 								If $k > 0 Then
;~ 									If $liste_crafts[$k][1] <> $liste_crafts[$k-1][1] Then GUICtrlCreateMenuItem("", $menu1_fenetre1)
;~ 								EndIf
;~ 								$liste1_fenetre1[$k][0] = GUICtrlCreateMenuItem($liste_crafts[$k][0], $menu1_fenetre1)
;~ 								$liste1_fenetre1[$k][1] = $liste_crafts[$k][0]
;~ 							Next
;~ 							If UBound($liste_crafts) = 1 And $liste_crafts[0] = "" Then GUICtrlSetState($menu1_fenetre1, $GUI_DISABLE)
;~ 							; Ingrdients
;~ 							$menu2_fenetre1 = GUICtrlCreateMenu("Ingrdients", $menu_fenetre1,1)
;~ 							GUICtrlSetState($menu2_fenetre1, $GUI_DISABLE)
;~ 							; Matires premires
;~ 							$menu3_fenetre1 = GUICtrlCreateMenu("Matires premires", $menu_fenetre1,2)
;~ 							GUICtrlSetState($menu3_fenetre1, $GUI_DISABLE)
;~ 							#EndRegion
;~ 							#Region Menus fenetre 2
;~ 							If $metiers_actifs[1] = "" Then
;~ 								; Crafts
;~ 								$menu1_fenetre2 = GUICtrlCreateMenu("Crafts", $menu_fenetre2,0)
;~ 								GUICtrlSetState($menu1_fenetre2, $GUI_DISABLE)
;~ 							EndIf
;~ 							; Ingrdients
;~ 							$menu2_fenetre2 = GUICtrlCreateMenu("Ingrdients", $menu_fenetre2,1)
;~ 							$liste_ingredients = $metiers[$j][2]
;~ 							ReDim $liste2_fenetre2[UBound($liste_ingredients)][2]
;~ 							For $k = 0 To UBound($liste_ingredients)-1
;~ 								$liste2_fenetre2[$k][0] = GUICtrlCreateMenuItem($liste_ingredients[$k], $menu2_fenetre2)
;~ 								$liste2_fenetre2[$k][1] = $liste_ingredients[$k]
;~ 							Next
;~ 							If UBound($liste_ingredients) = 1 And $liste_ingredients[0] = "" Then GUICtrlSetState($menu2_fenetre2, $GUI_DISABLE)
;~ 							; Matires premires
;~ 							$menu3_fenetre2 = GUICtrlCreateMenu("Matires premires", $menu_fenetre2,2)
;~ 							$liste_matierespremieres = $metiers[$j][3]
;~ 							ReDim $liste3_fenetre2[UBound($liste_matierespremieres)][2]
;~ 							For $k = 0 To UBound($liste_matierespremieres)-1
;~ 								$liste3_fenetre2[$k][0] = GUICtrlCreateMenuItem($liste_matierespremieres[$k], $menu3_fenetre2)
;~ 								$liste3_fenetre2[$k][1] = $liste_matierespremieres[$k]
;~ 							Next
;~ 							If UBound($liste_matierespremieres) = 1 And $liste_matierespremieres[0] = "" Then GUICtrlSetState($menu3_fenetre2, $GUI_DISABLE)
;~ 							#EndRegion
;~ 							$metiers_actifs[0] = $metiers[$j][0]
;~ 							ExitLoop
;~ 						EndIf
;~ 					Next
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 			For $i = 0 To UBound($sousmenus_metier23)-1												; Choix metier 23
;~ 				If $msg = $sousmenus_metier23[$i][0] Then
;~ 					GUICtrlSetState($fenetre2, $GUI_ENABLE)
;~ 					GUICtrlSetState($fenetre_modifier2, $GUI_ENABLE)
;~ 					GUICtrlSetState($bouton23, $GUI_ENABLE)
;~ 					GUICtrlSetState($bouton32, $GUI_ENABLE)
;~ 					GUICtrlSetState($fenetre3, $GUI_ENABLE)
;~ 					GUICtrlSetState($fenetre_modifier3, $GUI_ENABLE)
;~ 					GUICtrlSetImage($metier23, $MODULE_DIR&"\Images\"&$sousmenus_metier23[$i][1]&".bmp")
;~ 					For $j = 0 To UBound($metiers,1)-1
;~ 						If $metiers[$j][0] = $sousmenus_metier23[$i][1] Then
;~ 							#Region Effacement menus
;~ 							If $metiers_actifs[1] <> "" Then GUICtrlDelete($menu_fenetre3)
;~ 							If $metiers_actifs[0] <> "" Or $metiers_actifs[1] <> "" Then
;~ 								; Fenetre 3
;~ 								GUICtrlDelete($menu1_fenetre3)
;~ 								GUICtrlDelete($menu2_fenetre3)
;~ 								GUICtrlDelete($menu3_fenetre3)
;~ 							EndIf
;~ 							$menu_fenetre3 = GUICtrlCreateContextMenu($fenetre3)
;~ 							If $metiers_actifs[0] <> "" Then
;~ 								; Fenetre 2
;~ 								GUICtrlDelete($menu1_fenetre2)
;~ 							Else
;~ 								$menu_fenetre2 = GUICtrlCreateContextMenu($fenetre2)
;~ 							EndIf
;~ 							#EndRegion
;~ 							#Region Menus fenetre 3
;~ 							; Crafts
;~ 							$menu1_fenetre3 = GUICtrlCreateMenu("Crafts", $menu_fenetre3,0)
;~ 							GUICtrlSetState($menu1_fenetre3, $GUI_DISABLE)
;~ 							; Ingrdients
;~ 							$menu2_fenetre3 = GUICtrlCreateMenu("Ingrdients", $menu_fenetre3,1)
;~ 							$liste_ingredients = $metiers[$j][2]
;~ 							ReDim $liste2_fenetre3[UBound($liste_ingredients)][2]
;~ 							For $k = 0 To UBound($liste_ingredients)-1
;~ 								$liste2_fenetre3[$k][0] = GUICtrlCreateMenuItem($liste_ingredients[$k], $menu2_fenetre3)
;~ 								$liste2_fenetre3[$k][1] = $liste_ingredients[$k]
;~ 							Next
;~ 							If UBound($liste_ingredients) = 1 And $liste_ingredients[0] = "" Then GUICtrlSetState($menu2_fenetre3, $GUI_DISABLE)
;~ 							; Matires premires
;~ 							$menu3_fenetre3 = GUICtrlCreateMenu("Matires premires", $menu_fenetre3,2)
;~ 							$liste_matierespremieres = $metiers[$j][3]
;~ 							ReDim $liste3_fenetre3[UBound($liste_matierespremieres)][2]
;~ 							For $k = 0 To UBound($liste_matierespremieres)-1
;~ 								$liste3_fenetre3[$k][0] = GUICtrlCreateMenuItem($liste_matierespremieres[$k], $menu3_fenetre3)
;~ 								$liste3_fenetre3[$k][1] = $liste_matierespremieres[$k]
;~ 							Next
;~ 							If UBound($liste_matierespremieres) = 1 And $liste_matierespremieres[0] = "" Then GUICtrlSetState($menu3_fenetre3, $GUI_DISABLE)
;~ 							#EndRegion
;~ 							#Region Menus fenetre 2
;~ 							; Crafts
;~ 							$menu1_fenetre2 = GUICtrlCreateMenu("Crafts", $menu_fenetre2,0)
;~ 							$liste_crafts = $metiers[$j][1]
;~ 							ReDim $liste1_fenetre2[UBound($liste_crafts,1)][2]
;~ 							For $k = 0 To UBound($liste_crafts)-1
;~ 								If $k > 0 Then
;~ 									If $liste_crafts[$k][1] <> $liste_crafts[$k-1][1] Then GUICtrlCreateMenuItem("", $menu1_fenetre2)
;~ 								EndIf
;~ 								$liste1_fenetre2[$k][0] = GUICtrlCreateMenuItem($liste_crafts[$k][0], $menu1_fenetre2)
;~ 								$liste1_fenetre2[$k][1] = $liste_crafts[$k][0]
;~ 							Next
;~ 							If UBound($liste_crafts,1) = 1 And $liste_crafts[0] = "" Then GUICtrlSetState($menu1_fenetre2, $GUI_DISABLE)
;~ 							If $metiers_actifs[0] = "" Then
;~ 								; Ingrdients
;~ 								$menu2_fenetre2 = GUICtrlCreateMenu("Ingrdients", $menu_fenetre2,1)
;~ 								GUICtrlSetState($menu2_fenetre2, $GUI_DISABLE)
;~ 								; Matires premires
;~ 								$menu3_fenetre2 = GUICtrlCreateMenu("Matires premires", $menu_fenetre2,2)
;~ 								GUICtrlSetState($menu3_fenetre2, $GUI_DISABLE)
;~ 							EndIf
;~ 							#EndRegion
;~ 							$metiers_actifs[1] = $metiers[$j][0]
;~ 							ExitLoop
;~ 						EndIf
;~ 					Next
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 			For $i = 0 To UBound($liste1_fenetre1,1)-1												; Choix crafts 1
;~ 				If $msg = $liste1_fenetre1[$i][0] Then
;~ 					$nombre = recette_nombre(1)
;~ 					If $nombre <> 0 Then
;~ 						_GUICtrlListBox_AddString($fenetre1, $nombre &" x "& $liste1_fenetre1[$i][1])
;~ 					EndIf
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 			For $i = 0 To UBound($liste1_fenetre2,1)-1												; Choix crafts 2
;~ 				If $msg = $liste1_fenetre2[$i][0] Then
;~ 					$nombre = recette_nombre(2)
;~ 					If $nombre <> 0 Then
;~ 						_GUICtrlListBox_AddString($fenetre2, $nombre &" x "& $liste1_fenetre2[$i][1])
;~ 					EndIf
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 			For $i = 0 To UBound($liste2_fenetre2,1)-1												; Choix ingrdients 2
;~ 				If $msg = $liste2_fenetre2[$i][0] Then
;~ 					$nombre = recette_nombre(2)
;~ 					If $nombre <> 0 Then
;~ 						_GUICtrlListBox_AddString($fenetre2, $nombre &" x "& $liste2_fenetre2[$i][1])
;~ 					EndIf
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 			For $i = 0 To UBound($liste3_fenetre2,1)-1												; Choix matires premires 2
;~ 				If $msg = $liste3_fenetre2[$i][0] Then
;~ 					$nombre = recette_nombre(2)
;~ 					If $nombre <> 0 Then
;~ 						_GUICtrlListBox_AddString($fenetre2, $nombre &" x "& $liste3_fenetre2[$i][1])
;~ 					EndIf
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 			For $i = 0 To UBound($liste2_fenetre3,1)-1												; Choix ingrdients 3
;~ 				If $msg = $liste2_fenetre3[$i][0] Then
;~ 					$nombre = recette_nombre(3)
;~ 					If $nombre <> 0 Then
;~ 						_GUICtrlListBox_AddString($fenetre3, $nombre &" x "& $liste2_fenetre3[$i][1])
;~ 					EndIf
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 			For $i = 0 To UBound($liste3_fenetre3,1)-1												; Choix matires premires 3
;~ 				If $msg = $liste3_fenetre3[$i][0] Then
;~ 					$nombre = recette_nombre(3)
;~ 					If $nombre <> 0 Then
;~ 						_GUICtrlListBox_AddString($fenetre3, $nombre &" x "& $liste3_fenetre3[$i][1])
;~ 					EndIf
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next

	; Traitement des mtiers possibles
;~ 	Local $XML_metiers = $XML.SelectNodes("/donnees/metier")
;~ 	For $XML_metier In $XML_metiers
;~ 		$valeur = $XML_metier.GetAttribute("nom")
;~ 		If $liste_metiers[0][0] = "" Then
;~ 			$liste_metiers[0][0] = $valeur
;~ 		ElseIf _ArraySearch($liste_metiers, $valeur) = -1 Then
;~ 			ReDim $liste_metiers[UBound($liste_metiers)+1][4]
;~ 			$liste_metiers[UBound($liste_metiers,1)-1][0] = $valeur
;~ 		EndIf
;~ 		; Traitement des matires premires possibles
;~ 		$XML_matieres_premieres = $XML_metier.SelectNodes("matieres_premieres/ingredient")
;~ 		ReDim $liste_matieres_premieres[1]
;~ 		$liste_matieres_premieres[0] = ""
;~ 		For $XML_matiere_premiere In $XML_matieres_premieres
;~ 			$valeur = $XML_matiere_premiere.GetAttribute("nom")
;~ 			If $liste_matieres_premieres[0] = "" Then
;~ 				$liste_matieres_premieres[0] = $valeur
;~ 			ElseIf _ArraySearch($liste_matieres_premieres, $valeur) = -1 Then
;~ 				ReDim $liste_matieres_premieres[UBound($liste_matieres_premieres)+1]
;~ 				$liste_matieres_premieres[UBound($liste_matieres_premieres)-1] = $valeur
;~ 			EndIf
;~ 		Next
;~ 		; Traitement des crafts possibles
;~ 		$XML_crafts = $XML_metier.SelectNodes("craft")
;~ 		ReDim $liste_crafts[1][2]
;~ 		$liste_crafts[0][0] = ""
;~ 		$liste_crafts[0][1] = 0
;~ 		ReDim $liste_ingredients[1]
;~ 		$liste_ingredients[0] = ""
;~ 		For $XML_craft In $XML_crafts
;~ 			$valeur = $XML_craft.GetAttribute("nom")
;~ 			If $liste_crafts[0][0] <> "" Then
;~ 				ReDim $liste_crafts[UBound($liste_crafts)+1][2]
;~ 			EndIf
;~ 			$liste_crafts[UBound($liste_crafts)-1][0] = $valeur
;~ 			; Traitement des ingrdients possibles
;~ 			$XML_ingredients = $XML_craft.SelectNodes("ingredient")
;~ 			$valeur_n = 0
;~ 			For $XML_ingredient In $XML_ingredients
;~ 				$valeur_n = $valeur_n + 1
;~ 				$valeur = $XML_ingredient.GetAttribute("nom")
;~ 				If $liste_ingredients[0] = "" Then
;~ 					$liste_ingredients[0] = $valeur
;~ 				ElseIf _ArraySearch($liste_ingredients, $valeur) = -1 And _ArraySearch($liste_matieres_premieres, $valeur) = -1 Then
;~ 					ReDim $liste_ingredients[UBound($liste_ingredients)+1]
;~ 					$liste_ingredients[UBound($liste_ingredients)-1] = $valeur
;~ 				EndIf
;~ 			Next
;~ 			$liste_crafts[UBound($liste_crafts)-1][1] = $valeur_n
;~ 		Next
;~  		$liste_metiers[UBound($liste_metiers,1)-1][1] = $liste_crafts
;~ 		$liste_metiers[UBound($liste_metiers,1)-1][2] = $liste_ingredients
;~  		$liste_metiers[UBound($liste_metiers,1)-1][3] = $liste_matieres_premieres
;~ 	Next

;~ Func combinerCrafts($liste1, $liste2)
;~ 	Local $retour[1][2] = [["",0]]
;~ 	Local $i,$j
;~ 	If $liste1[0][0] = "" Then Return $liste2
;~ 	For $i = 0 To UBound($liste1,1)-1
;~ 		If $liste1[$i][0] <> "" Then
;~ 			For $j = 0 To UBound($liste2,1)-1
;~ 				If $liste1[$i][0] = $liste2[$j][0] Then
;~ 					If $retour[0][0]="" Or $retour[0][1]=0 Then
;~ 						$retour[0][0] = $liste1[$i][0]
;~ 						$retour[0][1] = _Min(Number($liste1[$i][1]),Number($liste2[$j][1]))
;~ 					Else
;~ 						ReDim $retour[Ubound($retour,1)+1][2]
;~ 						$retour[UBound($retour,1)-1][0] = $liste1[$i][0]
;~ 						$retour[UBound($retour,1)-1][1] = _Min(Number($liste1[$i][1]),Number($liste2[$j][1]))
;~ 					EndIf
;~ 					ExitLoop
;~ 				EndIf
;~ 			Next
;~ 		EndIf
;~ 	Next
;~ 	Return $retour
;~ EndFunc
#EndRegion
