#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=..\Images\ZaDS-nAiO.ico
#AutoIt3Wrapper_outfile=ReliCalc.exe
#AutoIt3Wrapper_Res_FileVersion=1.1.0.1
#AutoIt3Wrapper_Res_Field=Nom (short)|ReliCalc
#AutoIt3Wrapper_Res_Field=Nom (long)|ReliCalc
#AutoIt3Wrapper_Res_Field=Version (short)|1.1a
#AutoIt3Wrapper_Res_Field=Version (long)|1.1.0.1
#AutoIt3Wrapper_Res_Field=Description|Module de calcul de reliquat
#AutoIt3Wrapper_Res_Field=Type|Module
#AutoIt3Wrapper_Res_Field=Auteur|Orphi [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Options AutoIt
AutoItSetOption("MustDeclareVars", 1)

; Entte du module
Global Const _
	$MODULE_NOM = "ReliCalc", $MODULE_AUTEUR = "Orphi", $MODULE_VERSION = "1.1a", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1), $CONNECT_MODE = ($cmdLine[0] >= 1 And $cmdLine[1] = "-connect")

#Region Librairies AutoIt
;~ #Include <EditConstants.au3>
Global Const $ES_CENTER = 1
Global Const $ES_RIGHT  = 2
Global Const $ES_NUMBER = 8192
;~ #Include <GUIConstantsEx.au3>
Global Const $GUI_EVENT_CLOSE = -3
#EndRegion

#cs *********** ToDo list ***********
#ce *********************************

#cs **** Historique des versions ****
08/04/2011 1.0.1.0 Nouveau poids des runes Do Pou (10->5), R Pou (10->2) et R Cri (10->2)
01/02/2011 1.0.0.0 Version initiale
#ce *********************************

#Region Dclaration des Constantes
Local Const $Chemin_icone = cond(@Compiled, @ScriptName, '..\Images\ZaDS-nAiO.ico')

Local Const $Nombre_bonus = 15
;Colonnes :                     Nom des bonus , Poids
Local $Liste_bonus[$Nombre_bonus][2] = [ _
	[                             'Initiative',  0.1], _
	[                        'Pods / Vitalit', 0.25], _
	['Force / Intelligence / Chance / Agilit',    1], _
	[ '%Dom / %Dom Piges / Rs Pou,Cri,Elem*',    2], _
	[                  'Sagesse / Prospection',    3], _
	[                          'Tacle / Fuite',    4], _
	[    'Arme de Chasse / Dom Pousse, Elem*',    5], _
	[                     '% Rsistance Elem*',    6], _
	[       'Retrait PA/PM / Rsistance PA/PM',    7], _
	[                    'Dommages aux Piges',   15], _
	[                       'Dommages / Soins',   20], _
	[     'Invoc / Coups Crit / Renvoi de Dom',   30], _
	[                                 'Porte',   51], _
	[                                     'PM',   90], _
	[                                     'PA',  100]  _
]

Local Const $Nombre_runes = 23
;Colonnes :                            Nom des runes , Poids
Local $Liste_runes[$Nombre_runes][2] = [ _
	[                                            'Vi', 0.75], _
	[                                 'Ini / Carac**',    1], _
	[  'Do Per / Pi Per / R Pou / R Cri / R Elem*',    2], _
	[                                   'Pod / Pa Vi',  2.5], _
	[             'Sa / Prospe / Pa Ini / Pa Carac**',    3], _
	[                                     'Tac / Fui',    4], _
	[                    'Chasse / Do Pou / Do Elem*',    5], _
	[          'R Per Elem* / Pa Do Per / Pa Pi Per',    6], _
	[                         'Pa R Pou / Pa R Cri',    6], _
	[             'Ret Pme / Ret Pa / R Pme / R Pa',    7], _
	[                                'Pa Pod / Ra Vi',  7.5], _
	[                             'Pa Sa / Pa Prospe',    9], _
	[                           'Ra Ini / Ra Carac**',   10], _
	[                               'Pa Tac / Pa Fui',   12], _
	[                  'Pi / Pa Do Pou / Pa Do Elem*',   15], _
	[               'Do / So / Ra Do Per / Ra Pi Per',   20], _
	[ 'Pa Ret Pme / Pa Ret Pa / Pa R Pme / Pa R Pa',   21], _
	[                                        'Ra Pod',   25], _
	[                   'Invo / Cri / Do Ren / Ra Sa',   30], _
	[                                         'Pa Pi',   45], _
	[                                            'Po',   51], _
	[                                        'Ga Pme',   90], _
	[                                         'Ga Pa',  100]  _
]

Local $Star_elem = "* Elem = Neutre / Terre / Feu / Eau / Air"
Local $Star_carac = "** Carac = Force / Intelligence / Chance / Agilit"

Local $Correspondance_bonus_runes[$Nombre_bonus][$Nombre_runes] = [ _
	[0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], _ ;  0.1
	[1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0], _ ;  0.25
	[0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], _ ;  1
	[0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0], _ ;  2
	[0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0], _ ;  3
	[0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0], _ ;  4
	[0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0], _ ;  5
	[0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], _ ;  6
	[0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0], _ ;  7
	[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0], _ ; 15
	[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0], _ ; 20
	[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0], _ ; 30
	[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0], _ ; 51
	[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0], _ ; 90
	[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1]  _ ;100
]
#EndRegion Dclaration des Constantes


#Region Dclaration et initialisation des Variables
Local $Hauteur_fenetre_initiale = 410, $Hauteur_fenetre = $Hauteur_fenetre_initiale
Local $Hauteur_popup_initiale = 520, $Hauteur_popup = $Hauteur_popup_initiale, $cond1, $cond2
Local $Decalage_x_fenetre = 50, $Decalage_y_fenetre = Default, $Decalage_fenetre[4] = [$Decalage_x_fenetre, $Decalage_y_fenetre, Default, Default]
Local $Decalage1 = 70, $Decalage2_initial = 375, $Decalage2 = $Decalage2_initial, $Hauteur_ligne = 20, $Decalage_ligne

Local $Form, $Msg, $Button_raz_valeurs, $Button_raz_reliquat, $Input_reliquat, $Label_reliquat
Local $Label_bonus_titre, $Label_bonus_poids_titre, $Label_input_titre
Local $Label_bonus[$Nombre_bonus], $Label_bonus_poids[$Nombre_bonus], $Input_bonus[$Nombre_bonus]
Local $Button_plus10[$Nombre_bonus], $Button_plus1[$Nombre_bonus], $Button_moins1[$Nombre_bonus], $Button_moins10[$Nombre_bonus], $Button_reduire[$Nombre_bonus]
Local $Affiche_bonus[$Nombre_bonus], $Affiche_bonus_initial
Local $Button_moins_reliquat, $Button_plus_reliquat
Local $Label_bonus_star, $Button_afficher_tout
Local $Valeur_reliquat = 0, $Valeur_bonus[$Nombre_bonus], $Valeur, $Valeur_initiale, $Bonus_positif, $Num_bonus_positif
Local $Num_bonus, $Num_bonus_mini, $Exit
Local $Retour_fonction_Affiche_gui[13][$Nombre_bonus]

Local $Popup, $Msg_pop
Local $Label_runes_titre, $Label_runes_poids_titre, $Button_runes[$Nombre_runes], $Label_poids[$Nombre_runes]
Local $Affiche_runes[$Nombre_runes]
Local $Label_runes_star, $Label_runes_star2, $Button_afficher_tout_runes, $Nb_runes_cachees
Local $Num_rune
Local $Retour_fonction_Affiche_popup[3][$Nombre_runes]

For $Num_bonus = 0 To $Nombre_bonus - 1
	$Affiche_bonus[$Num_bonus] = 1
	$Valeur_bonus[$Num_bonus] = 0
Next
#EndRegion Dclaration et initialisation des Variables


;Gnration et affichage de l'interface graphique principale
$Retour_fonction_Affiche_gui = Affiche_gui($Chemin_icone, $Star_elem, $Decalage_fenetre, $Hauteur_fenetre, $Decalage1, $Decalage2, _
    $Hauteur_ligne, $Nombre_bonus, $Valeur_reliquat, $Affiche_bonus, $Liste_bonus)
$Form                  = $Retour_fonction_Affiche_gui[ 0][0]
$Button_afficher_tout  = $Retour_fonction_Affiche_gui[ 1][0]
For $Num_bonus = 0 To $Nombre_bonus - 1
	$Button_plus10[$Num_bonus]  = $Retour_fonction_Affiche_gui[ 2][$Num_bonus]
	$Button_plus1[$Num_bonus]   = $Retour_fonction_Affiche_gui[ 3][$Num_bonus]
	$Input_bonus[$Num_bonus]    = $Retour_fonction_Affiche_gui[ 4][$Num_bonus]
	$Button_moins1[$Num_bonus]  = $Retour_fonction_Affiche_gui[ 5][$Num_bonus]
	$Button_moins10[$Num_bonus] = $Retour_fonction_Affiche_gui[ 6][$Num_bonus]
	$Button_reduire[$Num_bonus] = $Retour_fonction_Affiche_gui[ 7][$Num_bonus]
Next
$Button_plus_reliquat  = $Retour_fonction_Affiche_gui[ 8][0]
$Button_moins_reliquat = $Retour_fonction_Affiche_gui[ 9][0]
$Input_reliquat        = $Retour_fonction_Affiche_gui[10][0]
$Button_raz_reliquat   = $Retour_fonction_Affiche_gui[11][0]
$Button_raz_valeurs    = $Retour_fonction_Affiche_gui[12][0]


;Boucle principale
While 1
	Sleep(5) ;pour allger la charge CPU

	;Acquisition du message envoy par l'interface (ID du bouton sur lequel on a appuy)
    $Msg = GUIGetMsg()

	;Fermeture de la fentre
    If $Msg = $GUI_EVENT_CLOSE Then
		Exit
	EndIf


	;Gestion de l'appui sur un des boutons de modification de valeur d'un bonus (+10,+1,-1,-10) ou sur un bouton d'effaage de la ligne
	$Affiche_bonus_initial = 0
	For $Num_bonus = 0 To $Nombre_bonus - 1
		If $Affiche_bonus[$Num_bonus] = 1 Then
			If $Msg = $Button_plus10[$Num_bonus] Then
				$Valeur_bonus[$Num_bonus] = GUICtrlRead($Input_bonus[$Num_bonus]) + 10
				GUICtrlSetData($Input_bonus[$Num_bonus], $Valeur_bonus[$Num_bonus])
				ExitLoop
			EndIf
			If $Msg = $Button_plus1[$Num_bonus] Then
				$Valeur_bonus[$Num_bonus] = GUICtrlRead($Input_bonus[$Num_bonus]) + 1
				GUICtrlSetData($Input_bonus[$Num_bonus], $Valeur_bonus[$Num_bonus])
				ExitLoop
			EndIf
			If $Msg = $Button_moins1[$Num_bonus] Then
				$Valeur_bonus[$Num_bonus] = GUICtrlRead($Input_bonus[$Num_bonus]) - 1
				GUICtrlSetData($Input_bonus[$Num_bonus], $Valeur_bonus[$Num_bonus])
				ExitLoop
			EndIf
			If $Msg = $Button_moins10[$Num_bonus] Then
				$Valeur_bonus[$Num_bonus] = GUICtrlRead($Input_bonus[$Num_bonus]) - 10
				GUICtrlSetData($Input_bonus[$Num_bonus], $Valeur_bonus[$Num_bonus])
				ExitLoop
			EndIf
			If $Msg = $Button_reduire[$Num_bonus] Then
				$Valeur_bonus[$Num_bonus] = 0
				$Affiche_bonus[$Num_bonus] = 0
				$Affiche_bonus_initial = 1
				ExitLoop
			EndIf
		EndIf
	Next

	;Si on efface une ligne, on recre une fentre dont la hauteur est adapte
	For $Num_bonus = 0 To $Nombre_bonus - 1
		If $Affiche_bonus_initial = 1 And $Msg = $Button_reduire[$Num_bonus] Then
			$Valeur_reliquat = GUICtrlRead($Input_reliquat)
			$Decalage_fenetre = WinGetPos("[ACTIVE]")
			$Hauteur_fenetre = $Hauteur_fenetre - $Hauteur_ligne
			$Decalage2 = $Decalage2 - $Hauteur_ligne
			GUIDelete ($Form)

			;Affichage de la fentre principale
			$Retour_fonction_Affiche_gui = Affiche_gui($Chemin_icone, $Star_elem, $Decalage_fenetre, $Hauteur_fenetre, $Decalage1, $Decalage2, _
				$Hauteur_ligne, $Nombre_bonus, $Valeur_reliquat, $Affiche_bonus, $Liste_bonus)
			$Form                  = $Retour_fonction_Affiche_gui[ 0][0]
			$Button_afficher_tout  = $Retour_fonction_Affiche_gui[ 1][0]
			For $Num_bonus = 0 To $Nombre_bonus - 1
				$Button_plus10[$Num_bonus]  = $Retour_fonction_Affiche_gui[ 2][$Num_bonus]
				$Button_plus1[$Num_bonus]   = $Retour_fonction_Affiche_gui[ 3][$Num_bonus]
				$Input_bonus[$Num_bonus]    = $Retour_fonction_Affiche_gui[ 4][$Num_bonus]
				$Button_moins1[$Num_bonus]  = $Retour_fonction_Affiche_gui[ 5][$Num_bonus]
				$Button_moins10[$Num_bonus] = $Retour_fonction_Affiche_gui[ 6][$Num_bonus]
				$Button_reduire[$Num_bonus] = $Retour_fonction_Affiche_gui[ 7][$Num_bonus]
			Next
			$Button_plus_reliquat  = $Retour_fonction_Affiche_gui[ 8][0]
			$Button_moins_reliquat = $Retour_fonction_Affiche_gui[ 9][0]
			$Input_reliquat        = $Retour_fonction_Affiche_gui[10][0]
			$Button_raz_reliquat   = $Retour_fonction_Affiche_gui[11][0]
			$Button_raz_valeurs    = $Retour_fonction_Affiche_gui[12][0]

			ExitLoop
		EndIf
	Next


	;Gestion de l'appui sur un des boutons de validation du reliquat
    If $Msg = $Button_plus_reliquat Or $Msg = $Button_moins_reliquat Then

		;Initialisation des valeurs
		For $Num_rune = 0 To $Nombre_runes - 1
			$Affiche_runes[$Num_rune] = 0
		Next
		$Exit = 0
		$Valeur = GUICtrlRead($Input_reliquat)
		$Valeur_initiale = $Valeur

		;Calcul du nombre de bonus positifs
		$Bonus_positif = 0
		$Num_bonus_positif = 0
		For $Num_bonus = 0 To $Nombre_bonus - 1
			If $Affiche_bonus[$Num_bonus] = 1 Then
				If GUICtrlRead($Input_bonus[$Num_bonus]) > 0 Then
					$Bonus_positif = $Bonus_positif + 1
					$Num_bonus_positif = $Num_bonus
				EndIf
			EndIf
		Next

		;Message d'erreur si plusieurs bonus sont positifs
		If $Bonus_positif > 1 Then
			MsgBox( 16, 'Erreur', 'Il ne peut pas y avoir plusieurs bonus positifs en mme temps.')
			$Exit = 1
		EndIf

		;Calcul de la nouvelle valeur du reliquat
		For $Num_bonus = 0 To $Nombre_bonus - 1
			If $Affiche_bonus[$Num_bonus] = 1 Then
				$Valeur = $Valeur - GUICtrlRead($Input_bonus[$Num_bonus]) * $Liste_bonus[$Num_bonus][1]
			EndIf
		Next

		;S'il n'y a pas de bonus positif, on affiche un popup pour demander quelle rune a t tente
		If( $Exit = 0 And $Bonus_positif = 0 ) Then

			;Dtermination des runes  cacher en fonction des bonus cachs
			$Nb_runes_cachees = 0
			For $Num_bonus = 0 To $Nombre_bonus - 1
				If $Affiche_bonus[$Num_bonus] = 1 Then
					For $Num_rune = 0 To $Nombre_runes - 1
						$Affiche_runes[$Num_rune] = $Affiche_runes[$Num_rune] + $Correspondance_bonus_runes[$Num_bonus][$Num_rune]
					Next
				EndIf
			Next
			For $Num_rune = 0 To $Nombre_runes - 1
				$Nb_runes_cachees = $Nb_runes_cachees + ( 1 - Min(1, $Affiche_runes[$Num_rune]) )
			Next

			;Ajustement de la hauteur de la fentre popup
			$Hauteur_popup = $Hauteur_popup_initiale - $Hauteur_ligne * $Nb_runes_cachees

			$cond1 = ($Affiche_runes[2]=0 And $Affiche_runes[6]=0 And $Affiche_runes[7]=0 And $Affiche_runes[13]=0)
			$cond2 = ($Affiche_runes[1]=0 And $Affiche_runes[4]=0 And $Affiche_runes[11]=0)
			If $cond1 Then $Hauteur_popup = $Hauteur_popup - $Hauteur_ligne
			If $cond2 Then $Hauteur_popup = $Hauteur_popup - $Hauteur_ligne

			;Affichage de la fentre popup
			$Retour_fonction_Affiche_popup = Affiche_popup($Chemin_icone, $Star_elem, $Star_carac, _
					$Hauteur_popup, $Hauteur_ligne, $Nombre_runes, $Affiche_runes, $Liste_runes)
			$Popup                       = $Retour_fonction_Affiche_popup[0][0]
			For $Num_rune = 0 To $Nombre_runes - 1
				$Button_runes[$Num_rune] = $Retour_fonction_Affiche_popup[1][$Num_rune]
			Next
			$Button_afficher_tout_runes  = $Retour_fonction_Affiche_popup[2][0]

			;Boucle secondaire (pour le popup)
			While 1
				Sleep(10)

				If $Exit = 1 Then
					ExitLoop
				EndIf

				$Msg_pop = GUIGetMsg()

				If $Msg_pop = $GUI_EVENT_CLOSE Then
					GUIDelete ($Popup)
					$Exit = 1
					ExitLoop
				EndIf

				;Calcul de la nouvelle valeur du reliquat issue du popup
				For $Num_rune = 0 To $Nombre_runes - 1
					If $Affiche_runes[$Num_rune] > 0 And $Msg_pop = $Button_runes[$Num_rune] Then
						$Valeur = $Valeur - $Liste_runes[$Num_rune][1]
						GUIDelete ($Popup)
						ExitLoop 2
					EndIf
				Next

				;Gestion de l'appui sur le bouton pour afficher toutes les lignes
				If $Msg_pop = $Button_afficher_tout_runes Then
					For $Num_rune = 0 To $Nombre_runes - 1
						$Affiche_runes[$Num_rune] = 1
					Next
					$Hauteur_popup = $Hauteur_popup_initiale
					GUIDelete ($Popup)

					;Affichage de la fentre popup
					$Retour_fonction_Affiche_popup = Affiche_popup($Chemin_icone, $Star_elem, $Star_carac, _
							$Hauteur_popup, $Hauteur_ligne, $Nombre_runes, $Affiche_runes, $Liste_runes)
					$Popup                       = $Retour_fonction_Affiche_popup[0][0]
					For $Num_rune = 0 To $Nombre_runes - 1
						$Button_runes[$Num_rune] = $Retour_fonction_Affiche_popup[1][$Num_rune]
					Next
					$Button_afficher_tout_runes  = $Retour_fonction_Affiche_popup[2][0]
				EndIf
			WEnd ;fin de la boucle secondaire

		EndIf

		;Message d'erreur si l'on appuie sur "+ Reliquat" alors qu'il ne peut pas augmenter
		If $Msg = $Button_plus_reliquat And $Valeur < $Valeur_initiale Then
			MsgBox( 16, 'Erreur', 'Le reliquat ne peut pas augmenter avec les valeurs entres.')
			$Exit = 1
		EndIf

		;Message d'erreur si l'on appuie sur "- Reliquat" alors qu'il ne peut pas diminuer
		If $Msg = $Button_moins_reliquat And $Valeur > $Valeur_initiale Then
			MsgBox( 16, 'Erreur', 'Le reliquat ne peut pas diminuer avec les valeurs entres.')
			$Exit = 1
		EndIf

		;Mise  jour de la valeur du reliquat et RAZ pour la saisie de la prochaine rune
		If $Exit = 0 Then
			For $Num_bonus = 0 To $Nombre_bonus - 1
				If $Affiche_bonus[$Num_bonus] = 1 Then
					GUICtrlSetData($Input_bonus[$Num_bonus], '0')
				EndIf
				$Valeur_bonus[$Num_bonus] = 0
			Next

			If $Valeur < 0 Then
				MsgBox( 48, 'Attention', 'Les valeurs entres amnent  un reliquat ngatif.')
				$Valeur = 0
			EndIf

			GUICtrlSetData($Input_reliquat, $Valeur)
			$Valeur_reliquat = $Valeur
		EndIf
	EndIf

	;Gestion de l'appui sur le bouton de remise  zro du reliquat
    If $Affiche_bonus_initial = 0 And $Msg = $Button_raz_reliquat Then
		GUICtrlSetData($Input_reliquat, 0)
		$Valeur_reliquat = 0
	EndIf

	;Gestion de l'appui sur le bouton de remise  zro des valeurs des bonus
	If $Msg = $Button_raz_valeurs Then
		For $Num_bonus = 0 To $Nombre_bonus - 1
			If $Affiche_bonus[$Num_bonus] = 1 Then
				GUICtrlSetData($Input_bonus[$Num_bonus], 0)
			EndIf
			$Valeur_bonus[$Num_bonus] = 0
		Next
		$Valeur_reliquat = GUICtrlRead($Input_reliquat)
	EndIf

	;Gestion de l'appui sur le bouton pour afficher toutes les lignes
    If $Msg = $Button_afficher_tout Then
		$Valeur_reliquat = GUICtrlRead($Input_reliquat)
		For $Num_bonus = 0 To $Nombre_bonus - 1
			$Affiche_bonus[$Num_bonus] = 1
		Next
		$Decalage_fenetre = WinGetPos("[ACTIVE]")
		$Hauteur_fenetre = $Hauteur_fenetre_initiale
		$Decalage2 = $Decalage2_initial
		GUIDelete ($Form)

		;Affichage de la fentre principale
		$Retour_fonction_Affiche_gui = Affiche_gui($Chemin_icone, $Star_elem, $Decalage_fenetre, $Hauteur_fenetre, $Decalage1, $Decalage2, _
			    $Hauteur_ligne, $Nombre_bonus, $Valeur_reliquat, $Affiche_bonus, $Liste_bonus)
		$Form                  = $Retour_fonction_Affiche_gui[ 0][0]
		$Button_afficher_tout  = $Retour_fonction_Affiche_gui[ 1][0]
		For $Num_bonus = 0 To $Nombre_bonus - 1
			$Button_plus10[$Num_bonus]  = $Retour_fonction_Affiche_gui[ 2][$Num_bonus]
			$Button_plus1[$Num_bonus]   = $Retour_fonction_Affiche_gui[ 3][$Num_bonus]
			$Input_bonus[$Num_bonus]    = $Retour_fonction_Affiche_gui[ 4][$Num_bonus]
			$Button_moins1[$Num_bonus]  = $Retour_fonction_Affiche_gui[ 5][$Num_bonus]
			$Button_moins10[$Num_bonus] = $Retour_fonction_Affiche_gui[ 6][$Num_bonus]
			$Button_reduire[$Num_bonus] = $Retour_fonction_Affiche_gui[ 7][$Num_bonus]
		Next
		$Button_plus_reliquat  = $Retour_fonction_Affiche_gui[ 8][0]
		$Button_moins_reliquat = $Retour_fonction_Affiche_gui[ 9][0]
		$Input_reliquat        = $Retour_fonction_Affiche_gui[10][0]
		$Button_raz_reliquat   = $Retour_fonction_Affiche_gui[11][0]
		$Button_raz_valeurs    = $Retour_fonction_Affiche_gui[12][0]
	EndIf

WEnd ;fin de la boucle principale


;**********************************************************************************************************************
;***************************************************** Fonctions ******************************************************
;**********************************************************************************************************************

;********************************* Fonction pour calculer le minimum de deux nombres **********************************
Func Min($Nombre1, $Nombre2)
	If $Nombre1 < $Nombre2 Then Return $Nombre1
	Return $Nombre2
EndFunc ;**************************************************************************************************************

;****************************************** Fonction conditionnelle rapide ********************************************
Func cond($cond, $true, $false)
	If $cond Then Return $true
	Return $false
EndFunc ;**************************************************************************************************************


;**********************************************************************************************************************
;**************************** Fonction de gnration de l'interface graphique principale ******************************
Func Affiche_gui($Chemin_icone, $Star_elem, ByRef $Decalage_fenetre, $Hauteur_fenetre, $Decalage1, $Decalage2, _
	$Hauteur_ligne, $Nombre_bonus, $Valeur_reliquat,  ByRef $Affiche_bonus, ByRef $Liste_bonus)

	;Dclaration des variables locales
	Local $Decalage_x_fenetre, $Decalage_y_fenetre, $Decalage_ligne
	Local $Form, $Label_bonus_titre, $Label_bonus_poids_titre, $Label_input_titre, $Button_afficher_tout
	Local $Label_bonus[$Nombre_bonus], $Label_bonus_poids[$Nombre_bonus], $Button_plus10[$Nombre_bonus], $Button_plus1[$Nombre_bonus]
	Local $Input_bonus[$Nombre_bonus], $Button_moins1[$Nombre_bonus], $Button_moins10[$Nombre_bonus], $Button_reduire[$Nombre_bonus]
	Local $Label_bonus_star
	Local $Button_plus_reliquat, $Button_moins_reliquat, $Label_reliquat, $Input_reliquat, $Button_raz_reliquat, $Button_raz_valeurs
	Local $Retour_fonction_Affiche_gui[13][$Nombre_bonus], $Num_bonus


	;Cration de la fentre principale et dfinition de l'icone associe
	$Decalage_x_fenetre = $Decalage_fenetre[0]
	$Decalage_y_fenetre = $Decalage_fenetre[1]
	$Form = GUICreate("Calculateur de reliquat", 415, $Hauteur_fenetre, $Decalage_x_fenetre, $Decalage_y_fenetre)
	GUISetIcon($Chemin_icone)

	;Cration et mise en forme de la ligne de titres et du bouton pour afficher toutes les lignes de bonus
	$Label_bonus_titre       = GUICtrlCreateLabel('Bonus impact', 10, $Decalage1 - $Hauteur_ligne, 200)
	$Label_bonus_poids_titre = GUICtrlCreateLabel('Poids', 218, $Decalage1 - $Hauteur_ligne, 100)
	$Label_input_titre       = GUICtrlCreateLabel('Valeur', 302, $Decalage1 - $Hauteur_ligne, 100)
	$Button_afficher_tout    = GUICtrlCreateButton("+", 395, $Decalage1 - $Hauteur_ligne - 2, 16, 18)
	GUICtrlSetFont($Label_bonus_titre, Default , 800)
	GUICtrlSetFont($Label_bonus_poids_titre, Default , 800)
	GUICtrlSetFont($Label_input_titre, Default , 800)

	;Cration des lignes de bonus avec les boutons pour modifier les valeurs et le bouton pour cacher la ligne
	$Decalage_ligne = 0
	For $Num_bonus = 0 To $Nombre_bonus - 1
		If $Affiche_bonus[$Num_bonus] = 1 Then ;uniquement pour les lignes affiches
			$Label_bonus[$Num_bonus]       = GUICtrlCreateLabel($Liste_bonus[$Num_bonus][0], 10, $Hauteur_ligne * $Decalage_ligne + $Decalage1)
			$Label_bonus_poids[$Num_bonus] = GUICtrlCreateLabel($Liste_bonus[$Num_bonus][1], 220, $Hauteur_ligne * $Decalage_ligne + $Decalage1)
			$Button_plus10[$Num_bonus]     = GUICtrlCreateButton("+10", 250, $Hauteur_ligne * $Decalage_ligne + $Decalage1 - 3, 25, $Hauteur_ligne)
			$Button_plus1[$Num_bonus]      = GUICtrlCreateButton("+1", 280, $Hauteur_ligne * $Decalage_ligne + $Decalage1 - 3, 20, $Hauteur_ligne)
			$Input_bonus[$Num_bonus]       = GUICtrlCreateInput($Valeur_bonus[$Num_bonus], 305, $Hauteur_ligne * $Decalage_ligne + $Decalage1 - 3, 30, $Hauteur_ligne, $ES_NUMBER + $ES_RIGHT)
			$Button_moins1[$Num_bonus]     = GUICtrlCreateButton("-1", 340, $Hauteur_ligne * $Decalage_ligne + $Decalage1 - 3, 20, $Hauteur_ligne)
			$Button_moins10[$Num_bonus]    = GUICtrlCreateButton("-10", 365, $Hauteur_ligne * $Decalage_ligne + $Decalage1 - 3, 25, $Hauteur_ligne)
			$Button_reduire[$Num_bonus]    = GUICtrlCreateButton("-", 395, $Hauteur_ligne * $Decalage_ligne + $Decalage1 + 0, 16, 14)
			$Decalage_ligne = $Decalage_ligne + 1
		Else
			;Les ID des contrles des lignes caches sont mis  0
			$Label_bonus[$Num_bonus]       = 0
			$Label_bonus_poids[$Num_bonus] = 0
			$Button_plus10[$Num_bonus]     = 0
			$Button_plus1[$Num_bonus]      = 0
			$Input_bonus[$Num_bonus]       = 0
			$Button_moins1[$Num_bonus]     = 0
			$Button_moins10[$Num_bonus]    = 0
			$Button_reduire[$Num_bonus]    = 0
		EndIf
	Next

	;Cration de la ligne de l'astrisque
	If $Affiche_bonus[3] = 1 Or $Affiche_bonus[6] = 1 Or $Affiche_bonus[7] = 1 Then ;uniquement si les lignes contenant un * sont affiches
		$Label_bonus_star = GUICtrlCreateLabel($Star_elem, 10, $Hauteur_ligne * $Decalage_ligne + $Decalage1)
	EndIf

	;Cration des boutons pour valider la modification du reliquat
	$Button_plus_reliquat  = GUICtrlCreateButton("+ Reliquat", 250, $Decalage2, 65, 30)
	$Button_moins_reliquat = GUICtrlCreateButton("- Reliquat", 325, $Decalage2, 65, 30)

	;Cration et mise en forme de l'affichage du reliquat et des boutons de remise  zro
	; (mis  la fin pour viter d'avoir le focus sur la valeur du reliquat)
	$Label_reliquat      = GUICtrlCreateLabel('Reliquat :', 90, 13, 100, 30)
	$Input_reliquat      = GUICtrlCreateInput($Valeur_reliquat, 180, 10, 70, 30, $ES_CENTER)
	$Button_raz_reliquat = GUICtrlCreateButton("RAZ Reliquat", 335, 5, 76, 20)
	$Button_raz_valeurs  = GUICtrlCreateButton("RAZ Valeurs", 335, 25, 76, 20)
	GUICtrlSetFont($Label_reliquat, 14 , 800)
	GUICtrlSetFont($Input_reliquat, 14 , 800)

	;Affichage de la fentre
	GUISetState(@SW_SHOW)

	;Prparation du retour de la fonction
	$Retour_fonction_Affiche_gui[ 0][0] = $Form
	$Retour_fonction_Affiche_gui[ 1][0] = $Button_afficher_tout
	For $Num_bonus = 0 To $Nombre_bonus - 1
		$Retour_fonction_Affiche_gui[ 2][$Num_bonus] = $Button_plus10[$Num_bonus]
		$Retour_fonction_Affiche_gui[ 3][$Num_bonus] = $Button_plus1[$Num_bonus]
		$Retour_fonction_Affiche_gui[ 4][$Num_bonus] = $Input_bonus[$Num_bonus]
		$Retour_fonction_Affiche_gui[ 5][$Num_bonus] = $Button_moins1[$Num_bonus]
		$Retour_fonction_Affiche_gui[ 6][$Num_bonus] = $Button_moins10[$Num_bonus]
		$Retour_fonction_Affiche_gui[ 7][$Num_bonus] = $Button_reduire[$Num_bonus]
	Next
	$Retour_fonction_Affiche_gui[ 8][0] = $Button_plus_reliquat
	$Retour_fonction_Affiche_gui[ 9][0] = $Button_moins_reliquat
	$Retour_fonction_Affiche_gui[10][0] = $Input_reliquat
	$Retour_fonction_Affiche_gui[11][0] = $Button_raz_reliquat
	$Retour_fonction_Affiche_gui[12][0] = $Button_raz_valeurs
	Return $Retour_fonction_Affiche_gui

EndFunc ;Fonction de gnration de l'interface graphique principale ***************************************************


;**********************************************************************************************************************
;******************************* Fonction de gnration de l'interface graphique popup ********************************
Func Affiche_popup($Chemin_icone, $Star_elem, $Star_carac, _
	$Hauteur_popup, $Hauteur_ligne, $Nombre_runes, ByRef $Affiche_runes, ByRef $Liste_runes)

	;Dclaration des variables locales
	Local $Decalage_fenetre[4], $Decalage_y_fenetre, $Hauteur_fenetre, $Decalage_x_popup, $Decalage_y_popup, $Decalage_ligne
	Local $Popup, $Label_runes_titre, $Label_runes_poids_titre, $Button_runes[$Nombre_runes], $Label_poids[$Nombre_runes]
	Local $Label_runes_star, $Label_runes_star2, $Button_afficher_tout_runes
	Local $Retour_fonction_Affiche_popup[3][$Nombre_runes], $Num_rune
	Local $cond1, $cond2

	;Cration de la fentre popup et dfinition de l'icone associe
	$Decalage_fenetre   = WinGetPos("[ACTIVE]")
	$Decalage_x_popup   = $Decalage_fenetre[0] + 60
	$Decalage_y_fenetre = $Decalage_fenetre[1]
	$Hauteur_fenetre    = $Decalage_fenetre[3]
	$Decalage_y_popup   = $Decalage_y_fenetre + ($Hauteur_fenetre - $Hauteur_popup) / 2 - 15
	If $Decalage_y_popup < 0 Then
		$Decalage_y_popup = $Decalage_y_fenetre
	ElseIf $Decalage_y_popup + $Hauteur_popup > @DesktopHeight - 50 Then
		$Decalage_y_popup = $Decalage_y_fenetre + $Hauteur_fenetre - $Hauteur_popup - 30
	EndIf
	$Popup = GUICreate("Quelle tait la rune tente ?", 290, $Hauteur_popup, $Decalage_x_popup, $Decalage_y_popup)
	GUISetIcon($Chemin_icone)

	;Cration et mise en forme de la ligne de titres
	$Label_runes_titre       = GUICtrlCreateLabel('Rune', 110, 5, 100)
	$Label_runes_poids_titre = GUICtrlCreateLabel('Poids', 255, 5, 100)
	GUICtrlSetFont($Label_runes_titre, Default , 800)
	GUICtrlSetFont($Label_runes_poids_titre, Default , 800)

	;Cration des lignes de runes tentes
	$Decalage_ligne = 0
	For $Num_rune = 0 To $Nombre_runes - 1
		If $Affiche_runes[$Num_rune] > 0 Then
			$Button_runes[$Num_rune] = GUICtrlCreateButton($Liste_runes[$Num_rune][0], 1, $Hauteur_ligne * $Decalage_ligne + 20, 250, $Hauteur_ligne)
			$Label_poids[$Num_rune]  = GUICtrlCreateLabel($Liste_runes[$Num_rune][1], 260, $Hauteur_ligne * $Decalage_ligne + 23)
			$Decalage_ligne = $Decalage_ligne + 1
		Else
			$Button_runes[$Num_rune] = 0
			$Label_poids[$Num_rune]  = 0
		EndIf
	Next

	;Cration des lignes d'astrisques
	$cond1 = ($Affiche_runes[2] > 0 Or $Affiche_runes[6] > 0 Or $Affiche_runes[7] > 0 Or $Affiche_runes[13] > 0)
	$cond2 = ($Affiche_runes[1] > 0 Or $Affiche_runes[4] > 0 Or $Affiche_runes[11] > 0)
	If $cond1 And $cond2 Then
		$Label_runes_star  = GUICtrlCreateLabel($Star_elem, 5, $Hauteur_popup - 35)
		$Label_runes_star2 = GUICtrlCreateLabel($Star_carac, 5, $Hauteur_popup - 18)
	ElseIf $cond1 Then
		$Label_runes_star  = GUICtrlCreateLabel($Star_elem, 5, $Hauteur_popup - 18)
	ElseIf $cond2 Then
		$Label_runes_star2 = GUICtrlCreateLabel($Star_carac, 5, $Hauteur_popup - 18)
	EndIf

	;Cration du bouton pour afficher toutes les lignes de bonus
	$Button_afficher_tout_runes = -1
	For $Num_rune = 0 To $Nombre_runes - 1
		If $Affiche_runes[$Num_rune] > 0 Then
			ContinueLoop
		Else
			$Button_afficher_tout_runes = GUICtrlCreateButton("+", 235, 2, 16, 18)
			ExitLoop
		EndIf
	Next

	;Affichage de la fentre
	GUISetState(@SW_SHOW)

	;Prparation du retour de la fonction
	$Retour_fonction_Affiche_popup[0][0] = $Popup
	For $Num_rune = 0 To $Nombre_runes - 1
		$Retour_fonction_Affiche_popup[1][$Num_rune] = $Button_runes[$Num_rune]
	Next
	$Retour_fonction_Affiche_popup[2][0] = $Button_afficher_tout_runes
	Return $Retour_fonction_Affiche_popup

EndFunc ;Fonction de gnration de l'interface graphique popup ********************************************************