#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Tiny\Tiny.ico
#AutoIt3Wrapper_outfile=Tiny.exe
#AutoIt3Wrapper_Res_Fileversion=0.0.0.0
#AutoIt3Wrapper_Res_Field=Nom (short)|Tiny
#AutoIt3Wrapper_Res_Field=Nom (long)|Tiny
#AutoIt3Wrapper_Res_Field=Version (short)|Alpha
#AutoIt3Wrapper_Res_Field=Version (long)|0.0.0.0
#AutoIt3Wrapper_Res_Field=Description|Module de gestion de fentres et de miniatures
#AutoIt3Wrapper_Res_Field=Type|Module
#AutoIt3Wrapper_Res_Field=Auteur|ZDS [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Entte du module
Global Const _
	$MODULE_NOM = "Tiny", $MODULE_AUTEUR = "ZDS", $MODULE_VERSION = "Alpha", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1)

; Compilation
#Include ".\Tiny\Compilation.au3"

#Region Librairies AutoIt
#include <Array.au3>
#include <GUIConstantsEx.au3>
#include <GDIPlus.au3>
#include <ScreenCapture.au3>
#include <WindowsConstants.au3>
#include <WinAPI.au3>
#EndRegion

#Region Librairies nAiO
Func si($cond, $true, $false)
	If $cond Then Return $true
	Return $false
EndFunc
Func min($a, $b)
	Return si($a<$b,$a,$b)
EndFunc
Func max($a, $b)
	Return si($a>$b,$a,$b)
EndFunc
Func min_max($a, $b, $c)
	Return min(max($a,$b),$c)
EndFunc
Func state($control,$state)
	Return BitAND(GUICtrlGetState($control),$state) = $state
EndFunc
#EndRegion

; Initialisation
_GDIPlus_Startup()
; Constantes
Global Const $fichierCfg = $MODULE_DIR&"\"&$MODULE_NOM&".ini", $TINY_ICONES = TINY_ICONES()
Func TINY_ICONES()
	Local $classes = StringSplit("Cr;Ecaflip;Eniripsa;Enutrof;Fca;Iop;Osamodas;Pandawa;Roublard;Sacrieur;Sadida;Sram;Steamer;Xlor;Zobal",";")
	Local $resultat[$classes[0]+1][2] = [[$classes[0]]]
	For $i = 1 To $resultat[0][0]
		$resultat[$i][0] = $classes[$i]
		$resultat[$i][1] = _GDIPlus_ImageLoadFromFile($MODULE_DIR&"\Images\Classes\"&$classes[$i]&".png")
	Next
	Return $resultat
EndFunc
; Variables (valeurs par dfaut du module)
Global $TINY_PATTERN = "[REGEXPTITLE:^[^\(\)]*$; CLASS:ApolloRuntimeContentWindow]", $TINY_SIZE[4] = [5,150,120,1], $LOGO_SIZE[3] = [5,32,32], $TINY_LISTE[1][7] = [[0]], $TINY_RULES[1][3] = [[0]]

; Implmentation du fichier
If Not FileExists($fichierCfg) Then
	FileClose(FileOpen($fichierCfg,9))
	IniWrite($fichierCfg, "MAIN", "pattern", $TINY_PATTERN)
	IniWrite($fichierCfg, "Size", "border",  $TINY_SIZE[0])
	IniWrite($fichierCfg, "Size", "border",  $TINY_SIZE[0])
	IniWrite($fichierCfg, "Size", "width",   $TINY_SIZE[1])
	IniWrite($fichierCfg, "Size", "height",  $TINY_SIZE[2])
	IniWrite($fichierCfg, "Size", "column",  $TINY_SIZE[3])
	IniWrite($fichierCfg, "Logo", "border",  $LOGO_SIZE[0])
	IniWrite($fichierCfg, "Logo", "width",   $LOGO_SIZE[1])
	IniWrite($fichierCfg, "Logo", "height",  $LOGO_SIZE[2])
	IniWriteSection($fichierCfg, "Rules", "")
EndIf
updateValues()

; Cration de la fentre
Global $GUI = GUICreate($MODULE_NOM&" v"&$MODULE_VERSION, $TINY_SIZE[1]+$TINY_SIZE[0]*2, 25+25+$TINY_SIZE[0]*4, Default, Default, 0x80800000) ; $WS_POPUP = 0x80000000 , $WS_BORDER = 0x00800000
GUISetIcon($MODULE_DIR&"\"&$MODULE_NOM&".ico", Default, $GUI)
; Dclaration des lments graphiques
Local $GUI_TITRE = GUICtrlCreateLabel($MODULE_NOM, $TINY_SIZE[0],$TINY_SIZE[0]+1, $TINY_SIZE[1]-25*2,25, Default, 0x00100000) ; $GUI_WS_EX_PARENTDRAG = 0x00100000
GUICtrlSetBkColor($GUI_TITRE, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlSetFont($GUI_TITRE, 15, 800)
GUICtrlSetResizing($GUI_TITRE, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
Local $GUI_CONFIGURER = GUICtrlCreateButton("@", $TINY_SIZE[0]+$TINY_SIZE[1]-25-25*1, $TINY_SIZE[0], 25, 25)
GUICtrlSetFont($GUI_CONFIGURER, 14, 400, 1, "Webdings")
GUICtrlSetTip($GUI_CONFIGURER, "Configurer le module")
GUICtrlSetResizing($GUI_CONFIGURER, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
Local $GUI_QUITTER = GUICtrlCreateButton("", $TINY_SIZE[0]+$TINY_SIZE[1]-25-25*0, $TINY_SIZE[0], 25, 25)
GUICtrlSetFont($GUI_QUITTER, 18, 400, 1, "Wingdings")
GUICtrlSetTip($GUI_QUITTER, "Quitter le module")
GUICtrlSetResizing($GUI_QUITTER, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
Local $GUI_SEPARATEUR = GUICtrlCreateLabel("", $TINY_SIZE[0], 25+$TINY_SIZE[0]*2-1, $TINY_SIZE[1], 1)
GUICtrlSetBkColor($GUI_SEPARATEUR, 0x000000)
GUICtrlSetResizing($GUI_SEPARATEUR, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
Local $GUI_SLIDER = GUICtrlCreateSlider($TINY_SIZE[0], 25+$TINY_SIZE[0]*3, $TINY_SIZE[1]-25-$TINY_SIZE[0], 25)
GUICtrlSetLimit($GUI_SLIDER, 20, 1) ; x100ms
GUICtrlSetData($GUI_SLIDER, 2)
GUICtrlSetTip($GUI_SLIDER, "Ajuster le rafraichissement")
GUICtrlSetResizing($GUI_SLIDER, $GUI_DOCKLEFT+$GUI_DOCKBOTTOM+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
Local $GUI_RAFRAICHIR = GUICtrlCreateButton("q", $TINY_SIZE[0]+$TINY_SIZE[1]-25-25*0, 25+$TINY_SIZE[0]*3, 25, 25)
GUICtrlSetFont($GUI_RAFRAICHIR, 14, 400, 1, "Webdings")
GUICtrlSetTip($GUI_RAFRAICHIR, "Actualiser la liste")
GUICtrlSetResizing($GUI_RAFRAICHIR, $GUI_DOCKRIGHT+$GUI_DOCKBOTTOM+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
; Dmarrage de l'affichage
Global $GUI_GRAPHICS = _GDIPlus_GraphicsCreateFromHWND($GUI)
GuiSetState(@SW_SHOW, $GUI)
WinSetOnTop($GUI, "", True)
refresh($GUI)

; Traitement
Global $stop = False, $speed = 0, $pointer = 1, $timer = TimerInit()
While Not $stop
	Local $msg = GUIGetMsg()
	If $speed <> GUICtrlRead($GUI_SLIDER) Then $speed = GUICtrlRead($GUI_SLIDER)
	Switch $msg
	Case $GUI_EVENT_CLOSE, $GUI_QUITTER
		$stop = True
	Case $GUI_CONFIGURER
		GUISetState(@SW_HIDE, $GUI)
		; Cration de la fentre
		Local $GUICONFIG = GUICreate($MODULE_NOM&" v"&$MODULE_VERSION, 300, 250, Default, Default, 0x80800000) ; $WS_POPUP = 0x80000000 , $WS_BORDER = 0x00800000
		GUISetIcon($MODULE_DIR&"\"&$MODULE_NOM&".ico", Default, $GUICONFIG)
		; Dclaration des lments graphiques
		Local $GUICONFIG_TITRE = GUICtrlCreateLabel($MODULE_NOM&" : Configuration", 5, 5, 230, 25, Default, 0x00100000) ; $GUI_WS_EX_PARENTDRAG = 0x00100000
		GUICtrlSetBkColor($GUICONFIG_TITRE, $GUI_BKCOLOR_TRANSPARENT)
		GUICtrlSetFont($GUICONFIG_TITRE, 15, 800)
		GUICtrlSetResizing($GUICONFIG_TITRE, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
		Local $GUICONFIG_AIDE = GUICtrlCreateButton("?", 240, 5, 25, 25)
		GUICtrlSetTip($GUICONFIG_AIDE, "Afficher l'aide du module")
		GUICtrlSetResizing($GUICONFIG_AIDE, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
		Local $GUICONFIG_QUITTER = GUICtrlCreateButton("", 270, 5, 25, 25)
		GUICtrlSetFont($GUICONFIG_QUITTER, 18, 400, 1, "Wingdings")
		GUICtrlSetTip($GUICONFIG_QUITTER, "Quitter la configuration")
		GUICtrlSetResizing($GUICONFIG_QUITTER, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
		Local $GUICONFIG_SEPARATEUR = GUICtrlCreateLabel("", 5, 34, 290, 1)
		GUICtrlSetBkColor($GUICONFIG_SEPARATEUR, 0x000000)
		GUICtrlSetResizing($GUICONFIG_SEPARATEUR, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKRIGHT+$GUI_DOCKHEIGHT)
		Local $GUICONFIG_DONNEES = GUICtrlCreateEdit("", 5, 40, 290, 205)
		GUICtrlSetData($GUICONFIG_DONNEES, getDonnees())
		GUICtrlSetFont($GUICONFIG_DONNEES, Default, Default, Default, "Courier New")
		GUICtrlSetTip($GUICONFIG_DONNEES, "Donnes structures au format INI pour"&@CRLF&"la configuration du module '"&$MODULE_NOM&"'."&@CRLF&"(Attention : rserv aux connaisseurs)"&@CRLF&@CRLF&"[Rules] : Nom=ordre,icone", "Donnes de configuration")
		GUICtrlSetResizing($GUICONFIG_DONNEES, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKRIGHT+$GUI_DOCKBOTTOM)
		; Dmarrage de l'affichage
		GUISetState(@SW_SHOW, $GUICONFIG)
		; Traitement
		Local $config_stop = False
		While Not $config_stop
			Local $config_msg = GUIGetMsg()
			Switch $config_msg
			Case $GUI_EVENT_CLOSE, $GUICONFIG_QUITTER
				Local $flux = FileOpen($fichierCfg,10)
				If @error = 0 Then
					FileWrite($flux, GUICtrlRead($GUICONFIG_DONNEES))
					FileClose($flux)
					updateValues()
					$config_stop = True
				EndIf
			Case $GUICONFIG_AIDE
				GuiSetState(@SW_HIDE, $GUICONFIG)
				$GUIAIDE = GUICreate($MODULE_NOM&" v"&$MODULE_VERSION, 500, 400, Default, Default, $WS_POPUPWINDOW)
				; Icone de la fentre
				GUISetIcon($MODULE_DIR&"\"&$MODULE_NOM&".ico", Default, $GUIAIDE)
				Local $GUIAIDE_titre = GUICtrlCreateLabel($MODULE_NOM&" : Aide", 10, 5, 500-45, 25, Default, $GUI_WS_EX_PARENTDRAG)
				GUICtrlSetFont($GUIAIDE_titre, 14, 800)
				Local $GUIAIDE_quitter = GUICtrlCreateButton("X", 500-30, 5, 25, 25)
				GUICtrlSetTip($GUIAIDE_quitter, "Fermer")
				Local $label_separateur = GUICtrlCreateLabel("", 5, 35, 500-10, 1)
				GUICtrlSetBkColor($label_separateur, 0x000000)
				Local $GUIAIDE_tree = GUICtrlCreateTreeView(5,40,500-10, 400-45)
				Local $GUIAIDE_tree_values[2] = [ 1 _
					, "Gnral" _
						& @CRLF & "[ Manuel d'utilisation en cours de rdaction ]" _
				]
;~ 				Local $GUIAIDE_tree_values[7] = [ 6 _
;~ 					, "Gnral" _
;~ 						& @CRLF & "Glissez/dposez le titre pour dplacer la fentre"               _
;~ 						& @CRLF & "Cliquez sur le bouton '?' pour afficher cette bote de dialogue" _
;~ 						& @CRLF & "Cliquez sur le bouton 'X' pour quitter le module"                _
;~ 					, "Mtiers" _
;~ 						& @CRLF & "Cliquez sur le bouton '...' pour slectionner un mtier" _
;~ 							& "#" & "Cela ajoute un panneau  la fentre"                   _
;~ 						& @CRLF & "Cliquez sur le bouton 'Mtier' pour effacer un mtier"   _
;~ 							& "#" & "Ainsi que les mtiers qui le suivent dans la liste"    _
;~ 					, "Ingrdients" _
;~ 						& @CRLF & "Cliquez droit dans un panneau pour choisir/effacer un ingrdient" _
;~ 							& "#" & "Une fois choisi, cela affiche une boite de dialogue"            _
;~ 						& @CRLF & "Tapez la quantit d'ingrdients puis tapez [Entre]"              _
;~ 							& "#" & "Tapez [Echap] pour annuler l'ajout de l'ingrdient"             _
;~ 						& @CRLF & "Double-cliquez sur un ingrdient pour modifier sa quantit"       _
;~ 							& "#" & "Tapez [Echap] pour annuler la modification de l'ingrdient"     _
;~ 						& @CRLF & "Control-cliquez pour slectionner plusieurs ingrdients"          _
;~ 					, "Recettes" _
;~ 						& @CRLF & "Glissez/dposez des ingrdients pour faire une dcomposition ou un craft"   _
;~ 							& "#" & "Vers le panneau de gauche pour dcomposer chaque ingrdient slectionn"  _
;~ 							& "#" & "Vers le panneau de droite pour crafter avec les ingrdients slectionns" _
;~ 					, "Import/Export" _
;~ 						& @CRLF & "Fonctionnalit en cours de dveloppement" _
;~ 					, "[ A COMPLETER ]" _
;~ 						& @CRLF & "Manuel d'utilisation en cours de rdaction" _
;~ 				]
				For $i = 1 To $GUIAIDE_tree_values[0]
					Local $values = StringSplit($GUIAIDE_tree_values[$i], @CRLF, 1)
					If Not @error And $values[0] > 1 Then
						Local $menu = GUICtrlCreateTreeViewItem($values[1], $GUIAIDE_tree)
						GUICtrlSetColor($menu, 0x0000C0)
						For $j = 2 To $values[0]
							Local $subvalues = StringSplit($values[$j], "#", 1)
							Local $item = GUICtrlCreateTreeViewItem($subvalues[1], $menu)
							GUICtrlSetColor($item, 0x000000)
							If $subvalues[0] > 1 Then
								For $k = 2 To $subvalues[0]
									Local $child = GUICtrlCreateTreeViewItem($subvalues[$k], $item)
									GUICtrlSetColor($child, 0x808080)
								Next
								GUICtrlSetState($item, $GUI_EXPAND)
							EndIf
						Next
						GUICtrlSetState($menu, $GUI_DEFBUTTON)
					EndIf
				Next
				; Finalisation
				GuiSetState(@SW_SHOW, $GUIAIDE)
				; Boucle de traitement
				While $stop = False
					#Region Gestion des evenements de l'interface graphique
					Local $msg = GuiGetMsg()
					If $msg = $GUIAIDE_quitter Or $msg = -3 Then ; $GUI_EVENT_CLOSE = -3
						$stop = True
					EndIf
				WEnd
				GUISetState(@SW_HIDE, $GUIAIDE)
				GUIDelete($GUIAIDE)
				GUISetState(@SW_SHOW, $GUICONFIG)
				$stop = False
			Case Else
				; Rien
			EndSwitch
		WEnd
		GUISetState(@SW_HIDE, $GUICONFIG)
		GUIDelete($GUICONFIG)
		; Finalisation
		GUISetState(@SW_SHOW, $GUI)
		refresh($GUI)
	Case $GUI_RAFRAICHIR
		refresh($GUI)
	Case Else
		For $i = 1 To $TINY_LISTE[0][0]
			If $msg = $TINY_LISTE[$i][1] Then
				WinActivate($TINY_LISTE[$i][0])
				ExitLoop
			EndIf
		Next
		For $i = 1 To $TINY_LISTE[0][0]
			Local $menuItems = $TINY_LISTE[$i][4]
			For $j = 1 To $menuItems[0]
				If $msg = $menuItems[$j] Then
					$TINY_LISTE[$i][2] = $j
				EndIf
			Next
			If $msg = $TINY_LISTE[$i][5] Then
				$TINY_LISTE[$i][2] = 0
			EndIf
		Next
	EndSwitch
	If TimerDiff($timer) > $speed*100 Then
		$timer = TimerInit()
		For $i = 1 To $TINY_LISTE[0][0]
			Local $capture = getCapture($TINY_LISTE[$i][0])
			If @error = 0 Then
				Local $cropFrame = $capture[3], $grille[3] = [2,Mod($i-1,$TINY_SIZE[3])+1,Floor(($i-1)/$TINY_SIZE[3])+1]
				Local $image = _GDIPlus_BitmapCreateFromHBITMAP($capture[0]), $imageContext = _GDIPlus_ImageGetGraphicsContext($image)
				Local $thumbnail = _GDIPlus_BitmapCreateFromGraphics($TINY_SIZE[1],$TINY_SIZE[2],$imageContext), $thumbnailContext = _GDIPlus_ImageGetGraphicsContext($thumbnail)
				_GDIPlus_GraphicsDrawImageRectRect($thumbnailContext, $image, $cropFrame[0], $cropFrame[1], $cropFrame[2], $cropFrame[3], 0, 0, $TINY_SIZE[1], $TINY_SIZE[2])
				Local $icone = $TINY_ICONES[$TINY_LISTE[$i][2]][1]
				_GDIPlus_GraphicsDrawImageRectRect($thumbnailContext, $icone, 0, 0, _GDIPlus_ImageGetWidth($icone), _GDIPlus_ImageGetHeight($icone), $TINY_SIZE[1]-$LOGO_SIZE[1]-$LOGO_SIZE[0], $TINY_SIZE[2]-$LOGO_SIZE[2]-$LOGO_SIZE[0], $LOGO_SIZE[1], $LOGO_SIZE[2])
				_GDIPlus_GraphicsDrawImageRectRect($GUI_GRAPHICS, $thumbnail, 0, 0, $TINY_SIZE[1], $TINY_SIZE[2], $TINY_SIZE[0]+($TINY_SIZE[1]+$TINY_SIZE[0])*($grille[1]-1), 25+$TINY_SIZE[0]*($grille[2]+2)+$TINY_SIZE[2]*($grille[2]-1), $TINY_SIZE[1], $TINY_SIZE[2])
				_GDIPlus_GraphicsDispose($thumbnailContext)
				_GDIPlus_ImageDispose($thumbnail)
				_GDIPlus_GraphicsDispose($imageContext)
				_GDIPlus_ImageDispose($image)
				_WinAPI_DeleteObject($capture[0])
			EndIf
		Next
	EndIf
WEnd
; Finalisation
For $i = 1 To $TINY_ICONES[0][0]
	_GDIPlus_ImageDispose($TINY_ICONES[$i][1])
Next
_GDIPlus_GraphicsDispose($GUI_GRAPHICS)
_GDIPlus_Shutdown()

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Rcupration des donnes mises en forme du fichier de configuration
Func getDonnees()
	Local $resultat = "", $sections = IniReadSectionNames($fichierCfg)
	If Not @error And $sections[0] > 0 Then
		For $i = 1 To $sections[0]
			$resultat = $resultat & @CRLF & @CRLF & "["&$sections[$i]&"]"
			Local $values = IniReadSection($fichierCfg,$sections[$i])
			If Not @error And $values[0][0] > 0 Then
				For $j = 1 To $values[0][0]
					$resultat = $resultat & @CRLF & $values[$j][0]&"="&$values[$j][1]
				Next
			EndIf
		Next
	EndIf
	Return StringStripWS($resultat,3)
EndFunc

; Mise  jour des paramtres
Func updateValues()
	$TINY_PATTERN = IniRead($fichierCfg, "MAIN", "pattern", $TINY_PATTERN)
	$TINY_SIZE[0] = Number(IniRead($fichierCfg, "Size", "border", $TINY_SIZE[0]))
	$TINY_SIZE[1] = Number(IniRead($fichierCfg, "Size", "width",  $TINY_SIZE[1]))
	$TINY_SIZE[2] = Number(IniRead($fichierCfg, "Size", "height", $TINY_SIZE[2]))
	$TINY_SIZE[3] = Number(IniRead($fichierCfg, "Size", "column", $TINY_SIZE[3]))
	$LOGO_SIZE[0] = Number(IniRead($fichierCfg, "Logo", "border", $LOGO_SIZE[0]))
	$LOGO_SIZE[1] = Number(IniRead($fichierCfg, "Logo", "width",  $LOGO_SIZE[1]))
	$LOGO_SIZE[2] = Number(IniRead($fichierCfg, "Logo", "height", $LOGO_SIZE[2]))
	Local $rules[1][3] = [[0]], $rules_ini = IniReadSection($fichierCfg, "Rules")
	If Not @error Then
		ReDim $rules[$rules_ini[0][0]+1][UBound($rules,2)]
		$rules[0][0] = $rules_ini[0][0]
		For $i = 1 To $rules_ini[0][0]
			Local $val = StringSplit($rules_ini[$i][1],",")
			$rules[$i][0] = $rules_ini[$i][0]
			$rules[$i][1] = $val[1]
			$rules[$i][2] = $val[2]
		Next
	EndIf
	$TINY_RULES = $rules
EndFunc

; Mise  jour de la liste des fentres
Func refresh($window)
	For $i = 1 To $TINY_LISTE[0][0]
		GUICtrlDelete($TINY_LISTE[$i][6])
		GUICtrlDelete($TINY_LISTE[$i][5])
		Local $menuItems = $TINY_LISTE[$i][4]
		For $j = 1 To $menuItems[0]
			GUICtrlDelete($menuItems[$j])
		Next
		GUICtrlDelete($TINY_LISTE[$i][3])
		GUICtrlDelete($TINY_LISTE[$i][1])
	Next
	Local $winListe = WinList($TINY_PATTERN)
	WinMove($GUI, "", Default, Default, $TINY_SIZE[0]+($TINY_SIZE[1]+$TINY_SIZE[0])*$TINY_SIZE[3]+2, 25+25+$TINY_SIZE[0]*4+($TINY_SIZE[2]+$TINY_SIZE[0])*Ceiling($winListe[0][0]/$TINY_SIZE[3])+2)
	_GDIPlus_GraphicsDispose($GUI_GRAPHICS)
	$GUI_GRAPHICS = _GDIPlus_GraphicsCreateFromHWND($GUI)
	For $i = 1 To $winListe[0][0]
		Local $found = 0, $titre = $winListe[$i][0]
		For $j = 1 To $TINY_RULES[0][0]
			If $titre = $TINY_RULES[$j][0] Then $found = $j
		Next
		Local $length = 4, $prefix = StringRight(""&((10^$length)-1),$length)
		If $found > 0 And Number($TINY_RULES[$found][1]) > 0 Then $prefix = StringRight(""&(10^$length)&$TINY_RULES[$found][1], $length)
		$winListe[$i][0] = $prefix&"-"&$titre
	Next
	_ArraySort($winListe,0,1,0,0)
	ReDim $winListe[$winListe[0][0]+1][7]
	For $i = 1 To $winListe[0][0]
		Local $texte = WinGetTitle($winListe[$i][1]), $icone = -1, $grille[2] = [Mod($i-1,$TINY_SIZE[3]),Floor(($i-1)/$TINY_SIZE[3])]
		If $icone = -1 Then
			For $j = 1 To $TINY_RULES[0][0]
				If $TINY_RULES[$j][0] = $texte Then
					For $k = 1 To $TINY_ICONES[0][0]
						If $TINY_RULES[$j][2] = $TINY_ICONES[$k][0] Then $icone = $k
					Next
				EndIf
			Next
		EndIf
		If $icone = -1 Then
			For $j = 1 To $TINY_LISTE[0][0]
				If $TINY_LISTE[$j][0] = $winListe[$i][1] Then $icone = $TINY_LISTE[$j][2]
			Next
		EndIf
		If $icone = -1 Then $icone = 0
		$winListe[$i][0] = $winListe[$i][1]
		$winListe[$i][1] = GUICtrlCreateLabel($texte, $TINY_SIZE[0]+($TINY_SIZE[1]+$TINY_SIZE[0])*$grille[0], 25+$TINY_SIZE[0]*3+($TINY_SIZE[2]+$TINY_SIZE[0])*$grille[1], $TINY_SIZE[1], $TINY_SIZE[2])
		GUICtrlSetBkColor($winListe[$i][1], $GUI_BKCOLOR_TRANSPARENT)
		GUICtrlSetTip($winListe[$i][1], "Clic gauche pour activer la fentre"&@CRLF&"Clic droit pour choisir une icone", "Fentre n"&$i&" : "&$texte)
		$winListe[$i][2] = $icone
		$winListe[$i][3] = GUICtrlCreateContextMenu($winListe[$i][1])
		Local $menuItems[$TINY_ICONES[0][0]+1] = [$TINY_ICONES[0][0]]
		For $j = 1 To $TINY_ICONES[0][0]
			$menuItems[$j] = GUICtrlCreateMenuItem($TINY_ICONES[$j][0], $winListe[$i][3])
		Next
		$winListe[$i][4] = $menuItems
		$winListe[$i][5] = GUICtrlCreateMenuItem("", $winListe[$i][3])
		$winListe[$i][6] = GUICtrlCreateMenuItem("Aucun", $winListe[$i][3])
	Next
	$TINY_LISTE = $winListe
EndFunc

; Rcupration de la miniature de la fentre choisie
Func getCapture($window)
	Local $struct = DllStructCreate("int X;int Y")
	DllStructSetData($struct, "X", 0)
	DllStructSetData($struct, "Y", 0)
	Local $pointeur = DllStructGetPtr($struct)
	DllCall("user32.dll", "bool", "ClientToScreen", "hwnd", $window, "ptr", $pointeur)
	Local $windowpos = WinGetPos($window)
	If @error Then Return SetError(1)
	Local $clientsize = WinGetClientSize($window)
	If @error Then Return SetError(1)
	Local $frame[6] = [DllStructGetData($struct,"X")-$windowpos[0],DllStructGetData($struct,"Y")-$windowpos[1],DllStructGetData($struct,"X"),DllStructGetData($struct,"Y"),$clientsize[0],$clientsize[1]]
	If @error Then Return SetError(1)
	Local $cropFrame[4] = [0, 0, $frame[4], $frame[5]]
	If $frame[4]*$TINY_SIZE[2] > $TINY_SIZE[1]*$frame[5] Then ; plus large, bandes noires  gauche et droite
		$cropFrame[0] = ($frame[4] - $frame[5]*$TINY_SIZE[1]/$TINY_SIZE[2])/2
		$cropFrame[2] = ($frame[4] + $frame[5]*$TINY_SIZE[1]/$TINY_SIZE[2])/2
	ElseIf $frame[4]*$TINY_SIZE[2] < $TINY_SIZE[1]*$frame[5] Then ; plus haut, bandes noires en haut et en bas
		$cropFrame[1] = ($frame[5] - $frame[4]*$TINY_SIZE[2]/$TINY_SIZE[1])/2
		$cropFrame[3] = ($frame[5] + $frame[4]*$TINY_SIZE[2]/$TINY_SIZE[1])/2
	EndIf
	$cropFrame[0] = $cropFrame[0]+$frame[0]
	$cropFrame[1] = $cropFrame[1]+$frame[1]
	$cropFrame[2] = $cropFrame[2]-$cropFrame[0]+$frame[0]
	$cropFrame[3] = $cropFrame[3]-$cropFrame[1]+$frame[1]
	If @error Then Return SetError(1)
	Local $resultat[4] = [0, $windowpos[2], $windowpos[3], $cropFrame]
	Local $context = _WinAPI_GetDC($window), $compatible = _WinAPI_CreateCompatibleDC($context), $bitmap = _WinAPI_CreateCompatibleBitmap($context, $resultat[1], $resultat[2])
	_WinAPI_SelectObject($compatible, $bitmap)
	DllCall("User32.dll", "int", "PrintWindow", "hwnd", $window, "hwnd", $compatible, "int", 0)
	_WinAPI_ReleaseDC($window, $context)
	_WinAPI_DeleteDC($compatible)
	$resultat[0] = $bitmap
	Return $resultat
EndFunc

; Dclenchement de l'affichage d'un sousmenu
Func sousmenu($GUI, $target, $context)
	Local $menu = GUICtrlGetHandle($context), $position = ControlGetPos($GUI, "", $target), $coords = DllStructCreate("int;int")
	DllStructSetData($coords, 1, $position[0]+10)
	DllStructSetData($coords, 2, $position[1]+10)
	DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $GUI, "ptr", DllStructGetPtr($coords))
	DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $menu, "int", 0, "int", DllStructGetData($coords, 1), "int", DllStructGetData($coords, 2), "hwnd", $GUI, "ptr", 0)
EndFunc
