#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=ToDo\ToDo.ico
#AutoIt3Wrapper_outfile=ToDo.exe
#AutoIt3Wrapper_Res_FileVersion=1.1.0.1
#AutoIt3Wrapper_Res_Field=Nom (short)|ToDo
#AutoIt3Wrapper_Res_Field=Nom (long)|ToDo
#AutoIt3Wrapper_Res_Field=Version (short)|1.1a
#AutoIt3Wrapper_Res_Field=Version (long)|1.1.0.1
#AutoIt3Wrapper_Res_Field=Description|Module de bloc-notes
#AutoIt3Wrapper_Res_Field=Type|Module
#AutoIt3Wrapper_Res_Field=Auteur|ZDS [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#NoTrayIcon

; Entte du module
Global Const _
	$MODULE_NOM = "ToDo", $MODULE_AUTEUR = "ZDS", $MODULE_VERSION = "1.1a", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1), $CONNECT_MODE = ($cmdLine[0] >= 1 And $cmdLine[1] = "-connect")

; Compilation
#Include ".\ToDo\Compilation.au3"

#Region Librairies AutoIt
;~ #Include <Misc.au3>
Func mouseTrap($x1 = 0, $y1 = 0, $x2 = 0, $y2 = 0)
	Local $retour
	If @NumParams == 0 Then
		$retour = DllCall("user32.dll", "bool", "ClipCursor", "ptr", 0)
		If @error Or Not $retour[0] Then Return SetError(1, winAPI_GetLastError(), False)
	Else
		If @NumParams == 2 Then
			$x2 = $x1 + 1
			$y2 = $y1 + 1
		EndIf
		Local $rectangle = DllStructCreate("long Left;long Top;long Right;long Bottom")
		DllStructSetData($rectangle, "Left",   $x1)
		DllStructSetData($rectangle, "Top",    $y1)
		DllStructSetData($rectangle, "Right",  $x2)
		DllStructSetData($rectangle, "Bottom", $y2)
		$retour = DllCall("user32.dll", "bool", "ClipCursor", "ptr", DllStructGetPtr($rectangle))
		If @error Or Not $retour[0] Then Return SetError(2, winAPI_GetLastError(), False)
	EndIf
	Return True
EndFunc
Func winAPI_GetLastError($error=@error, $extended=@extended)
	Local $retour = DllCall("kernel32.dll", "dword", "GetLastError")
	Return SetError($error, $extended, $retour[0])
EndFunc
Func singleton($nom)
	Local $retour = DllCall("kernel32.dll", "handle", "CreateMutexW", "ptr", 0, "bool", 1, "wstr", $nom)
	If @error Then Return SetError(@error, @extended, 0)
	Local $error = DllCall("kernel32.dll", "dword", "GetLastError")
	If @error Then Return SetError(@error, @extended, 0)
	If $error[0] = 183 Then
		Return SetError($error[0], $error[0], 0)
	EndIf
	Return $retour[0]
EndFunc
Func isPressed($key, $dll = 'user32.dll')
	Local $retour = DllCall($dll, "short", "GetAsyncKeyState", "int", '0x' & $key)
	If @error Then Return SetError(@error, @extended, False)
	Return BitAND($retour[0], 0x8000) <> 0
EndFunc
;~ #Include <Array.au3>
Func arrayDelete(ByRef $avArray, $iElement)
	If Not IsArray($avArray) Then Return SetError(1, 0, 0)
	Local $iUBound = UBound($avArray, 1) - 1
	If Not $iUBound Then
		$avArray = ""
		Return 0
	EndIf
	; Bounds checking
	If $iElement < 0 Then $iElement = 0
	If $iElement > $iUBound Then $iElement = $iUBound
	; Move items after $iElement up by 1
	Switch UBound($avArray, 0)
		Case 1
			For $i = $iElement To $iUBound - 1
				$avArray[$i] = $avArray[$i + 1]
			Next
			ReDim $avArray[$iUBound]
		Case 2
			Local $iSubMax = UBound($avArray, 2) - 1
			For $i = $iElement To $iUBound - 1
				For $j = 0 To $iSubMax
					$avArray[$i][$j] = $avArray[$i + 1][$j]
				Next
			Next
			ReDim $avArray[$iUBound][$iSubMax + 1]
		Case Else
			Return SetError(3, 0, 0)
	EndSwitch
	Return $iUBound
EndFunc
;~ #Include <Constants.au3>
Global Const _
	$TRAY_ENABLE              =          64, _
	$TRAY_DISABLE             =         128, _
	$TRAY_DEFAULT             =         512, _
	$TRAY_EVENT_PRIMARYDOWN   =          -7, _
	$TRAY_EVENT_PRIMARYUP     =          -8, _
	$TRAY_EVENT_PRIMARYDOUBLE =         -13
;~ #Include <GUIConstants.au3>
Global Const _
	$GUI_FOCUS                =         256, _
	$GUI_WS_EX_PARENTDRAG     =     1048576, _
	$GUI_BKCOLOR_TRANSPARENT  =          -2, _
	$GUI_DOCKLEFT             =           2, _
	$GUI_DOCKRIGHT            =           4, _
	$GUI_DOCKTOP              =          32, _
	$GUI_DOCKBOTTOM           =          64, _
	$GUI_DOCKHEIGHT           =         512, _
	$GUI_DOCKSIZE             =         768
;~ #Include <WindowsConstants.au3>
Global Const _
	$WS_POPUP                 = -2147483648, _
	$WS_BORDER                =     8388608, _
	$WS_EX_TOOLWINDOW         =         128
#EndRegion

#Region Variables
; Smaphore pour viter les doubles-excutions du programme
Local $semaphore = singleton("nAiO-"&$MODULE_NOM&"-"&$MODULE_VERSION)
If $semaphore = 0 Then Exit 1
; Variables de base
Global Const $COLORS[10][2] = [[9,""],                                    _
	["Gris",   "E0E0E0"], ["Rouge",      "FFD0D0"], ["Vert",   "D0FFD0"], _
	["Violet", "D0D0FF"], ["Vert Fonc", "C0DFA0"], ["Bleu",   "D0FFFF"], _
	["Rose",   "FFD0FF"], ["Jaune",      "FFFFD0"], ["Orange", "FFD0A0"]  _
]
Global Const $FICHIER_INI = $MODULE_DIR & "\" & "ToDo.ini"
; Sortie manuelle
Global $STOP = False, $FORCE_STOP = False
HotKeySet("{F4}","stop")
HotKeySet("#{F4}","forceStop")
#EndRegion

; Lancement de la fonction principale
toDoGUI()

#Region Fonction principale
Func toDoGUI()
	Opt("TrayMenuMode",3)
	TraySetIcon(".\ToDo\ToDo.ico")
	Local $liste_todo_items = newListeTodos()
	load($FICHIER_INI, $liste_todo_items)
	If $liste_todo_items[0][0] = 0 Then
		TrayTip($MODULE_NOM&" v"&$MODULE_VERSION,      _
			"Aucune note n'est ouverte," & @CRLF &     _
			"Double-cliquez ici pour en ajouter une.", _
			30, 2 _
		)
	EndIf
	$tray_addNew   = TrayCreateItem("Ajouter")
	$tray_undelete = TrayCreateItem("Rtablir")
	$tray_display  = TrayCreateItem("Afficher")
	TrayCreateItem("")
	$tray_exit     = TrayCreateItem("Quitter")
	TrayItemSetState($tray_addNew,   $TRAY_DEFAULT)
	TrayItemSetState($tray_undelete, $TRAY_DISABLE)
	Local $lastDeletedNote[5] = ["","","","",""]
	While Not $FORCE_STOP
		Local $tray = TrayGetMsg()
		Switch $tray
		Case $TRAY_EVENT_PRIMARYDOWN, $TRAY_EVENT_PRIMARYUP
			; Rien
		Case $TRAY_EVENT_PRIMARYDOUBLE, $tray_addNew
			ajouterNote($liste_todo_items)
			While TrayGetMsg()
			WEnd
			afficherNote($liste_todo_items)
		Case $tray_undelete
			ajouterNote($liste_todo_items)
			Local $index = $liste_todo_items[0][0]
			$liste_todo_items[$index][7]  =  $lastDeletedNote[0]
			$liste_todo_items[$index][8]  =  $lastDeletedNote[1]
			$liste_todo_items[$index][9]  =  $lastDeletedNote[2]
			$liste_todo_items[$index][10] =  $lastDeletedNote[3]
			$liste_todo_items[$index][11] =  $lastDeletedNote[4]
			afficherNote($liste_todo_items)
			TrayItemSetState($tray_undelete, $TRAY_DISABLE)
		Case $tray_display
			For $i = 1 To $liste_todo_items[0][0]
				GUISetState(@SW_RESTORE, $liste_todo_items[$i][0])
			Next
		Case $tray_exit
			For $i = 1 To $liste_todo_items[0][0]
				GUISetState(@SW_DISABLE, $liste_todo_items[$i][0])
			Next
			Local $confirmation = MsgBox(48+3,$MODULE_NOM&" v"&$MODULE_VERSION, _
				"Souhaitez-vous sauvegarder l'tat actuel des notes?" & @CRLF & _
				"- Cliquez sur Oui pour sauvegarder et quitter"       & @CRLF & _
				"- Cliquez sur Non pour quitter sans sauvegarder"     & @CRLF & _
				"- Cliquez sur Annuler pour ne pas quitter", 30                 _
			)
			If $confirmation = 6 Or $confirmation = 7 Then
				$FORCE_STOP = True
				If $confirmation = 6 Then save($liste_todo_items, $FICHIER_INI)
				For $i = $liste_todo_items[0][0] To 1 Step -1
					effacerNote($liste_todo_items,$i,$tray_undelete)
				Next
				$FORCE_STOP = True
			Else
				For $i = 1 To $liste_todo_items[0][0]
					GUISetState(@SW_ENABLE, $liste_todo_items[$i][0])
				Next
			EndIf
		EndSwitch
		Local $msg = GUIGetMsg()
		For $i = $liste_todo_items[0][0] To 1 Step -1
			; Survol du bouton Check
			Local _
				$hoverCheck = isHoveringCtrl($liste_todo_items[$i][0],$liste_todo_items[$i][3]), _
				$stateCheck = (GUICtrlRead($liste_todo_items[$i][3])="")
			If $liste_todo_items[$i][10] Then
				If Not $stateCheck Then GUICtrlSetData($liste_todo_items[$i][3],"")
			Else
				If $hoverCheck And Not $stateCheck Then
					GUICtrlSetData($liste_todo_items[$i][3],"")
				ElseIf Not $hoverCheck And $stateCheck Then
					GUICtrlSetData($liste_todo_items[$i][3],"")
				EndIf
			EndIf
			; Survol du bouton Color
			Local _
				$hoverColor = isHoveringCtrl($liste_todo_items[$i][0],$liste_todo_items[$i][5]), _
				$stateColor = (GUICtrlRead($liste_todo_items[$i][5])="p")
			If $hoverColor And Not $stateColor Then
				GUICtrlSetData($liste_todo_items[$i][5],"p")
			ElseIf Not $hoverColor And $stateColor Then
				GUICtrlSetData($liste_todo_items[$i][5],"")
			EndIf
			; Survol du bouton Resize
			Local _
				$hoverResize = isHoveringCtrl($liste_todo_items[$i][0],$liste_todo_items[$i][6]), _
				$stateResize = (GUICtrlRead($liste_todo_items[$i][6])="")
			If $hoverResize And Not $stateResize Then
				GUICtrlSetData($liste_todo_items[$i][6],"")
			ElseIf Not $hoverResize And $stateResize Then
				GUICtrlSetData($liste_todo_items[$i][6],"")
			EndIf
			; Traitement des messages
			Switch $msg
			Case $liste_todo_items[$i][3] ; Check
				Local $pos = WinGetPos($liste_todo_items[$i][0])
				If Not @error Then
					Local $actual_pos = $pos[0]&";"&$pos[1]&";"&$pos[2]&";"&$pos[3]
					If $liste_todo_items[$i][7] = $actual_pos Then
						$liste_todo_items[$i][10] = Not $liste_todo_items[$i][10]
						GUICtrlSetColor($liste_todo_items[$i][3], cond($liste_todo_items[$i][10],0x000000,0xC0C0C0))
					Else
						$liste_todo_items[$i][7] = $actual_pos
					EndIf
				EndIf
			Case $liste_todo_items[$i][4] ; Fermer
				Local $pos = WinGetPos($liste_todo_items[$i][0])
				If Not @error Then
					Local $actual_pos = $pos[0]&";"&$pos[1]&";"&$pos[2]&";"&$pos[3]
					If $liste_todo_items[$i][7] = $actual_pos Then
						Local $retour = effacerNote($liste_todo_items, $i, $tray_undelete)
						If Not @error Then $lastDeletedNote = $retour
						If $liste_todo_items[0][0] = 0 Then
							TrayTip($MODULE_NOM&" v"&$MODULE_VERSION,      _
								"Aucune note n'est ouverte," & @CRLF &     _
								"Double-cliquez ici pour en ajouter une.", _
								30, 2 _
							)
						EndIf
					Else
						$liste_todo_items[$i][7] = $actual_pos
					EndIf
				EndIf
			Case $liste_todo_items[$i][5] ; Couleur
				Local $pos = WinGetPos($liste_todo_items[$i][0])
				If Not @error Then
					Local $actual_pos = $pos[0]&";"&$pos[1]&";"&$pos[2]&";"&$pos[3]
					If $liste_todo_items[$i][7] = $actual_pos Then
						GUICtrlSetData($liste_todo_items[$i][5],"")
						Local $color = guiColor($liste_todo_items[$i][0], Int(Number($liste_todo_items[$i][11])), $msg)
						If $color > 0 And $color <= $COLORS[0][0] Then
							$liste_todo_items[$i][11] = $color
							GUISetBkColor(Dec($COLORS[$color][1]), $liste_todo_items[$i][0])
						EndIf
					Else
						$liste_todo_items[$i][7] = $actual_pos
					EndIf
				EndIf
			Case $liste_todo_items[$i][6] ; Resize
				Local $dll = DllOpen("user32.dll"), $split = StringSplit($liste_todo_items[$i][7],";")
				Local $position[2] = [$split[1],$split[2]], $control = getControlCoords($liste_todo_items[$i][0],$msg,True)
				mouseTrap( _
					$position[0]+100-$control[2]/2, $position[1]+80-$control[3]/2, _
					@DesktopWidth-$control[2]/2,    @DesktopHeight-$control[3]/2   _
				)
				While isPressed("01", $dll)
					Local $mouse = MouseGetPos()
					If IsArray($control) Then
						Local $size[2] = [$mouse[0]-$position[0]+$control[2]/2,$mouse[1]-$position[1]+$control[3]/2]
						WinMove($liste_todo_items[$i][0],"", Default,Default, $size[0],$size[1])
					EndIf
				WEnd
				mouseTrap()
				DllClose($dll)
				Local $pos = WinGetPos($liste_todo_items[$i][0])
				If Not @error Then $liste_todo_items[$i][7] = $pos[0]&";"&$pos[1]&";"&$pos[2]&";"&$pos[3]
			Case $liste_todo_items[$i][1] ; Titre
				Local $pos = WinGetPos($liste_todo_items[$i][0])
				If Not @error Then
					Local $actual_pos = $pos[0]&";"&$pos[1]&";"&$pos[2]&";"&$pos[3]
					If $liste_todo_items[$i][7] = $actual_pos Then
						Local $titre = guiValeur($liste_todo_items[$i][0], $liste_todo_items[$i][8], "titre", $msg)
						If Not @error Then
							$liste_todo_items[$i][8] = $titre
							If $titre = "" Then $titre = "Aucun titre"
							GUICtrlSetData($liste_todo_items[$i][1], $titre)
						EndIf
					Else
						$liste_todo_items[$i][7] = $actual_pos
					EndIf
				EndIf
			Case $liste_todo_items[$i][2] ; Description
				Local $pos = WinGetPos($liste_todo_items[$i][0])
				If Not @error Then
					Local $actual_pos = $pos[0]&";"&$pos[1]&";"&$pos[2]&";"&$pos[3]
					If $liste_todo_items[$i][7] = $actual_pos Then
						Local $description = guiValeur($liste_todo_items[$i][0], $liste_todo_items[$i][9], "description", $msg)
						If Not @error Then
							$liste_todo_items[$i][9] = $description
							GUICtrlSetData($liste_todo_items[$i][2], $description)
						EndIf
					Else
						$liste_todo_items[$i][7] = $actual_pos
					EndIf
				EndIf
			EndSwitch
		Next
	WEnd
EndFunc
#EndRegion

#Region
Func guiColor($parent, $valeur, $itemToCatch)
	Local $retour = $valeur, $erreur = 0, $vide[4] = [0,0,20,20], $position = getControlCoords($parent, $itemToCatch)
	If @error Then $position = $vide
	; GUI
	Sleep(200)
	Local $child = GUICreate("", 60-2, 60-2, _
		cond($position[0]+$position[2]+20>@DesktopWidth, _
			@DesktopWidth-$position[2]-20, _
			cond($position[0]<20, _
				0, _
				$position[0]-18 _
			)-1 _
		), _
		cond($position[1]+$position[3]+20>@DesktopHeight, _
			@DesktopHeight-$position[3]-20, _
			cond($position[1]<20, _
				0, _
				$position[1]-18 _
			)+1 _
		), _
		$WS_POPUP, -1, _
		$parent _
	)
	GUISetBkColor(0x000000, $child)
	; Item
	Local $items[10] = [9,"","","","","","","","",""]
	For $i = -1 To 1
		For $j = -1 To 1
			Local $index = 3*$i+$j+5, $decalage = cond($index=$valeur,1,0)
			$items[$index] = GUICtrlCreateLabel("",         _
				19*$i+19+1+$decalage, 19*$j+19+1+$decalage, _
				20-2-2*$decalage,     20-2-2*$decalage      _
			)
			GUICtrlSetBkColor($items[$index], Dec($COLORS[$index][1]))
		Next
	Next
	GUICtrlSetState($items[$valeur],$GUI_FOCUS)
	; Traitement
	GUISetState(@SW_SHOW, $child)
	ControlFocus($child, "", $items[$valeur])
	Local $found = 0
	While WinActive($child) And $found = 0
		Local $msg = GUIGetMsg()
		For $i = 1 To $items[0]
			If $msg = $items[$i] Then $found = $i
		Next
	WEnd
	; Effacement
	GUIDelete($child)
	While GUIGetMsg()
	WEnd
	WinActivate($parent)
	Return $found
EndFunc
Func guiValeur($parent, $valeur, $type, $itemToCatch)
	Local _
		$retour = $valeur, $item = "", $erreur = 0, _
		$vide[4] = [0,0,100,50], $position = getControlCoords($parent, $itemToCatch)
	If @error Then $position = $vide
	; GUI
	Local $child = GUICreate("", $position[2], $position[3], _
		cond($position[0]+$position[2]>@DesktopWidth, _
			@DesktopWidth-$position[2], _
			cond($position[0]<0, _
				0, _
				$position[0] _
			) _
		), _
		cond($position[1]+$position[3]>@DesktopHeight, _
			@DesktopHeight-$position[3], _
			cond($position[1]<0, _
				0, _
				$position[1] _
			) _
		), _
		$WS_POPUP+$WS_BORDER, -1, _
		$parent _
	)
	; Item
	Switch StringLower($type)
	Case "titre"
		$item = GUICtrlCreateInput($retour,0,0,$position[2],$position[3])
	Case "description"
		$item = GUICtrlCreateEdit($retour,0,0,$position[2],$position[3])
	EndSwitch
	If $item = "" Then
		$erreur = 1
	Else
		; Traitement
		GUISetState(@SW_SHOW, $child)
		ControlFocus($child, "", $item)
		Local $dll = DllOpen("user32.dll"), $cancel = False
		While WinActive($child) And Not $cancel
			If isPressed("1B", $dll) Then $cancel = True
		WEnd
		DllClose($dll)
		$retour = GUICtrlRead($item)
		If $cancel Then $erreur = 2
	EndIf
	; Effacement
	GUIDelete($child)
	While GUIGetMsg()
	WEnd
	WinActivate($parent)
	If $erreur = 0 Then Return $retour
	SetError($erreur)
EndFunc
Func getControlCoords($handle="", $control="",$relative=False)
	Local $pos = ControlGetPos($handle, "", $control)
	If @error Then
		SetError(1)
		Return
	EndIf
	If $relative Then Return $pos
	Local $winpos = WinGetPos($handle)
	Local $resultat[4] = [$winpos[0]+$pos[0],$winpos[1]+$pos[1], $pos[2],$pos[3]]
	Return $resultat
EndFunc
Func isHoveringCtrl($window,$ctrl)
	Local $mouse = GUIGetCursorInfo($window)
	If @error Then Return False
	Return ($mouse[4] = $ctrl)
EndFunc
Func load($fichier, ByRef $liste)
	$liste = newListeTodos()
	Local $sections = IniReadSectionNames($fichier)
	If Not @error Then
		For $i = 1 To $sections[0]
			; Nouvel lment
			ajouterNote($liste)
			; Valeurs
			$liste[$i][7]  =  IniRead($fichier, $sections[$i], "PositionSize", "")
			$liste[$i][8]  =  IniRead($fichier, $sections[$i], "Titre",        "")
			$liste[$i][9]  =  StringReplace(IniRead($fichier, $sections[$i], "Description",  ""),"\n",@CRLF)
			$liste[$i][10] = (IniRead($fichier, $sections[$i], "Check",        "")="Y")
			$liste[$i][11] =  IniRead($fichier, $sections[$i], "Color",        "")
			; Traitement
			afficherNote($liste, $i)
		Next
	EndIf
EndFunc
Func ajouterNote(ByRef $liste)
	$liste[0][0] = $liste[0][0] + 1
	ReDim $liste[$liste[0][0]+1][12]
	; Valeurs
	$liste[$liste[0][0]][7]  = ""
	$liste[$liste[0][0]][8]  = ""
	$liste[$liste[0][0]][9]  = ""
	$liste[$liste[0][0]][10] = ""
	$liste[$liste[0][0]][11] = ""
EndFunc
Func afficherNotes(ByRef $liste)
	For $i = 1 To $liste[0][0]
		afficherNote($liste, $i)
	Next
EndFunc
Func afficherNote(ByRef $liste, $index = "")
	Local $i = cond(IsNumber($index) And $index>=1 And $index<=$liste[0][0], $index, $liste[0][0])
	Local $position = StringSplit($liste[$i][7],";"), $positionDefault[5] = [4,10+20*($i+1),10+20*($i+1),250,150]
	If Not StringRegExp($liste[$i][7],"^\d+;\d+;\d+;\d+$") Then $position = $positionDefault
	Local $titre = $liste[$i][8]
	If $titre = "" Then $titre = "Aucun titre"
	Local $description = $liste[$i][9]
	Local $color = Int(Number($liste[$i][11]))
	If $color < 1 Or $color > $COLORS[0][0] Then $color = 1
	; Elments
	$liste[$i][0]  = GUICreate($titre, _
		$position[3], $position[4], _
		$position[1], $position[2], _
		$WS_POPUP+$WS_BORDER, $WS_EX_TOOLWINDOW _
	)
	GUISetBkColor(Dec($COLORS[$color][1]), $liste[$i][0])
	GUISetIcon(".\ToDo\ToDo.ico")
	; Label du titre
	$liste[$i][1] = GUICtrlCreateLabel($titre, _
		20, 0, $position[3]-40, 20,            _
		Default, $GUI_WS_EX_PARENTDRAG         _
	)
	GUICtrlSetBkColor($liste[$i][1], $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetFont($liste[$i][1], 12, 800)
	; Label de la description
	$liste[$i][2] = GUICtrlCreateLabel($description, _
		10, 20, $position[3]-20, $position[4]-40,    _
		Default, $GUI_WS_EX_PARENTDRAG               _
	)
	GUICtrlSetBkColor($liste[$i][2], $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetFont($liste[$i][2], 9, 400)
	; Bouton Check
	$liste[$i][3] = GUICtrlCreateLabel("", 0,0, 20,20, Default, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetBkColor($liste[$i][3], $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetColor($liste[$i][3], cond($liste[$i][10],0x000000,0xC0C0C0))
	GUICtrlSetFont($liste[$i][3], 16, 800, 0, "Wingdings")
	; Bouton Quitter
	$liste[$i][4] = GUICtrlCreateLabel("", $position[3]-20,0, 20,20, Default, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetBkColor($liste[$i][4], $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetFont($liste[$i][4], 18, 400, 0, "Wingdings")
	; Bouton Couleur
	$liste[$i][5] = GUICtrlCreateLabel("", 0,$position[4]-20, 20,20, Default, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetBkColor($liste[$i][5], $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetFont($liste[$i][5], 16, 400, 0, "Wingdings")
	; Bouton Redimensionner
	$liste[$i][6] = GUICtrlCreateLabel("", $position[3]-20,$position[4]-20, 20,20)
	GUICtrlSetBkColor($liste[$i][6], $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetFont($liste[$i][6], 12, 400, 0, "Wingdings")
	; Mode de redimensionnement des controles
	GUICtrlSetResizing($liste[$i][1], $GUI_DOCKLEFT+$GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKHEIGHT)
	GUICtrlSetResizing($liste[$i][2], $GUI_DOCKLEFT+$GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKBOTTOM)
	GUICtrlSetResizing($liste[$i][3], $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKSIZE)
	GUICtrlSetResizing($liste[$i][4], $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKSIZE)
	GUICtrlSetResizing($liste[$i][5], $GUI_DOCKLEFT+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetResizing($liste[$i][6], $GUI_DOCKRIGHT+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	; Affichage
	GUISetState(@SW_SHOW,$liste[$i][0])
	WinSetTrans($liste[$i][0],"",230)
	$liste[$i][7] = $position[1]&";"&$position[2]&";"&$position[3]&";"&$position[4]
	WinMove($liste[$i][0], "", _
		Number($position[1]), Number($position[2]), _
		Number($position[3]), Number($position[4])  _
	)
EndFunc
Func effacerNote(ByRef $liste, $i, $tray_last)
	Local $last[5], $gui = $liste[$i][0]
	$last[0] = $liste[$i][7]
	$last[1] = $liste[$i][8]
	$last[2] = $liste[$i][9]
	$last[3] = $liste[$i][10]
	$last[4] = $liste[$i][11]
	arrayDelete($liste,$i)
	If Not @error Then
		$liste[0][0] = $liste[0][0] - 1
		GUIDelete($gui)
		TrayItemSetState($tray_last, $TRAY_ENABLE)
		Return $last
	EndIf
	SetError(1)
EndFunc
Func save($liste, $fichier)
	FileClose(FileOpen($fichier,10))
	For $i = 1 To $liste[0][0]
		Local $section = "Fenetre_"&$i
		IniWrite($fichier, $section, "PositionSize", $liste[$i][7])
		IniWrite($fichier, $section, "Titre",        $liste[$i][8])
		IniWrite($fichier, $section, "Description",  StringReplace($liste[$i][9],@CRLF,"\n"))
		IniWrite($fichier, $section, "Check",        cond($liste[$i][10],"Y","N"))
		IniWrite($fichier, $section, "Color",        $liste[$i][11])
	Next
EndFunc
Func newListeTodos()
	Local $liste[1][12] = [[0, _
		"idTitre", "idDescription", "idCheck", "idClose", "idColor", "idResize", _
		"PositionSize", "Titre", "Description", "Check", "Color"]]
	Return $liste
EndFunc
#EndRegion
#Region Manipulation systme et retour
Func cond($cond, $true, $false)
	If $cond Then Return $true
	Return $false
EndFunc
Func checkState($control,$state)
	Return (BitAND(GUICtrlGetState($control),$state) = $state)
EndFunc
Func max($a,$b)
	If Number($a) < Number($b) Then Return $b
	Return $a
EndFunc
Func stop()
	$STOP = True
EndFunc
Func forceStop()
	$FORCE_STOP = True
	$STOP = True
EndFunc
Func stopCode($retour, $code=0, $extended="")
	Local $titre = "Erreur"
	If $extended <> "" Then $titre = "Erreur : '"&$extended&"'"
	If Not $DEBUG_MODE Then
		; Ne rien faire
	ElseIf $code = 1 Then
		MsgBox(80, $titre, "Erreur systme")
	ElseIf $code = 2 Then
		MsgBox(80, $titre, "Connexion interrompue")
	ElseIf $code = 3 Then
		MsgBox(80, $titre, "Connexion echoue")
	ElseIf $code = 4 Then
		MsgBox(80, $titre, "Connexion errone")
	ElseIf $code = 5 Then
		MsgBox(80, $titre, "Connexion corrompue")
	ElseIf $code = 6 Then
		MsgBox(80, $titre, "Fichier introuvable")
	ElseIf $code = 7 Then
		MsgBox(80, $titre, "Fichier illisible")
	ElseIf $code = 8 Then
		MsgBox(80, $titre, "Information introuvable")
	ElseIf $code = 9 Then
		MsgBox(80, $titre, "Information ambigue")
	ElseIf $code <> 0 Then
		MsgBox(80, $titre, "Erreur inconnue")
	EndIf
	Return $retour
EndFunc
#EndRegion
