#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Images\ZaDS-nAiO.ico
#AutoIt3Wrapper_outfile=nAiO.exe
#AutoIt3Wrapper_Res_FileVersion=1.5.2.0
#AutoIt3Wrapper_Res_Field=Nom (short)|nAiO
#AutoIt3Wrapper_Res_Field=Nom (long)|nAiO
#AutoIt3Wrapper_Res_Field=Version (short)|1.5b
#AutoIt3Wrapper_Res_Field=Version (long)|1.5.2.0
#AutoIt3Wrapper_Res_Field=Description|nAiO, le Tout-En-Un du Dofusien !
#AutoIt3Wrapper_Res_Field=Type|nAiO
#AutoIt3Wrapper_Res_Field=Auteur|Za [Equipe nAiO],ZDS [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Rpertoires de base
Global Const _
	$nAiO_repertoire_audio    = @ScriptDir & "\" & "Audio"    & "\", _ ; Rpertoire des ressources audio du nAiO
	$nAiO_repertoire_captures = @ScriptDir & "\" & "Captures" & "\", _ ; Rpertoire des captures d'cran
	$nAiO_repertoire_data     = @ScriptDir & "\" & "Data"     & "\", _ ; Rpertoire des donnes de configuration du nAiO
	$nAiO_repertoire_images   = @ScriptDir & "\" & "Images"   & "\", _ ; Rpertoire des images du nAiO
	$nAiO_repertoire_include  = @ScriptDir & "\" & "Include"  & "\", _ ; Rpertoire des scripts internes du nAiO
	$nAiO_repertoire_language = @ScriptDir & "\" & "Language" & "\", _ ; Rpertoire des ressources de langue du nAiO
	$nAiO_repertoire_modules  = @ScriptDir & "\" & "Modules"  & "\"    ; Rpertoire des modules externes du nAiO

; Librairies AutoIt
#Include "Include\Librairies AutoIt.au3"

; Variables globales de base
Global $nAiO_title = "nAiO", $nAiO_title_long = "Za & ZDS - new All-in-One", $nAiO_version = "1.5b",            _
	$nAiO_alertes_to_display, $nAiO_alertes_to_check, $nAiO_etat_stop, $nAiO_etat_restart, $nAiO_etat_extended, _
	$nAiO_password, $nAiO_repertoire_data_profil = "", $nAiO_listeProfils, $nAiO_profil_password = "",          _
	$nAiO_languageResources = newArray(2), $snapshotCadre[2] = [20,20], $nAiO_trayIconForMessage = 0,           _
	$nAiO_fenetres_CLASS = "ApolloRuntimeContentWindow"

; Librairies personnelles
#Include "Include\Modelisation.au3"
#Include "Include\Interface Principale.au3"
#Include "Include\Interface Configuration.au3"
#Include "Include\Internationalisation.au3"
#Include "Include\Menus Graphiques.au3"
#Include "Include\Compilation.au3"
#Include "Include\Controle Souris.au3"
#Include "Include\Encryptage Decryptage.au3"
#Include "Include\Fonctions Avancees.au3"
#Include "Include\Gestion Alertes.au3"
#Include "Include\Gestion Historique.au3"
#Include "Include\Gestion Proprietes.au3"
#Include "Include\Execution Programmes.au3"
#Include "Include\Reorganisation Fenetres.au3"
#Include "Include\Choix Profil.au3"

; Variables de base
$nAiO_password           = $DEFAULT_Password
$nAiO_alertes_to_display = newListeAlertes()
$nAiO_alertes_to_check   = newListeAlertes()
$nAiO_etat_extended      = False
$nAiO_etat_stop          = False
$nAiO_etat_restart       = False
$nAiO_languageResources  = getInternationalisationFile()

; Smaphore pour viter les doubles-excutions du programme
If nAiO_isAlreadyLaunched() Then
	Local $reponse = MsgBox(48+4, $nAiO_title&" v"&$nAiO_version,                               _
		getInternationalisationText($nAiO_languageResources, "NAIO_double_execution_texte"), 30 _
	)
	If $reponse <> 6 Then exit_naio()
EndIf

; Traduction des noms des jours de la semaine et des dures
Global _
	$NAIO_Dates            = StringSplit(getInternationalisationText($nAiO_languageResources, "NAIO_date_days"),","),           _
	$NAIO_Delays_singulier = StringSplit(getInternationalisationText($nAiO_languageResources, "NAIO_date_delays"),","),         _
	$NAIO_Delays_pluriel   = StringSplit(getInternationalisationText($nAiO_languageResources, "NAIO_date_delays_pluriel"),","), _
	$NAIO_Delays = newArray(2)
For $i = 1 To _Min($NAIO_Delays_singulier[0], $NAIO_Delays_pluriel[0])
	addToArray($NAIO_Delays, $NAIO_Delays_singulier[$i], $NAIO_Delays_pluriel[$i])
Next

; Profil des donnes de configuration du nAiO
$nAiO_repertoire_data_profil = newProfil($DEFAULT_PROFIL, $nAiO_repertoire_data&$DEFAULT_PROFIL&"\")
convertStructureToListeProfils($nAiO_listeProfils)

; Demande du code d'entre au profil
Global $ok = True
If isProfilProtected() Then $ok = guiChoixProfil()

; Lancement de l'application
If $ok Then
	Global $last_time_Alertes_en_cours = getProfilDate(getProfilActuel())
	guiInterface()
	setLastUsedProfil()
EndIf

If $nAiO_etat_restart Then restart_naio()
exit_naio()