#Include-Once

Global _
	$GENERAL_aot_values[3]        = ["", "", ""],     $GENERAL_taskbar_values[2]    = ["", ""], _
    $GENERAL_fullscreen_values[3] = ["", "", ""],     $MULTIS_customized_values[2]  = ["", ""], _
    $GENERAL_colors_values[4]     = ["", "", "", ""], $ALERTES_audio_values[2]      = ["", ""]

Func guiConfiguration($tray = "")
	#Region Rcupration des donnes
	Local _
		$listeComptes    = newListeComptes(), _
		$listeMultis     = newListeMultis(),  _
		$listeAlertes    = newListeAlertes(), _
		$listeModules    = newListeModules(), _
		$listeLiens      = newListeLiens(),   _
		$listeActions    = newListeActions(), _
		$listeParametres = newListeParametres()
	Local $nAiO_fichiers_dates_before = FileGetTime(getProfilFichier("comptes"),0,1)&"/"&FileGetTime(getProfilFichier("multis"),0,1)&"/"&FileGetTime(getProfilFichier("alertes"),0,1)&"/"&FileGetTime(getProfilFichier("liens"),0,1)&"/"&FileGetTime(getProfilFichier("config"),0,1)
	convertFichierToListeComptes(    getProfilFichier("comptes"), $listeComptes,   $nAiO_profil_password)
	convertFichierToListeMultis(     getProfilFichier("multis"),  $listeMultis     )
	convertFichierToListeParametres( getProfilFichier("config"),  $listeParametres )
	convertFichierToListeAlertes(    getProfilFichier("alertes"), $listeAlertes    )
	convertFichierToListeModules(    getProfilFichier("modules"), $listeModules    )
	convertFichierToListeLiens(      getProfilFichier("liens"),   $listeLiens      )
	convertFichierToListeActions(    getProfilFichier("config"),  $listeActions    )
	Local $listeAlertesOriginales = $listeAlertes
	Local $nAiO_config_password = $nAiO_profil_password
	; Mise  jour des variables globales
	defineGlobalValues($GENERAL_aot_values,        "IC_constants_aot_value")
	defineGlobalValues($GENERAL_taskbar_values,    "IC_constants_taskbar_value")
	defineGlobalValues($GENERAL_fullscreen_values, "IC_constants_fullscreen_value")
	defineGlobalValues($GENERAL_colors_values,     "IC_constants_colors_value")
	defineGlobalValues($MULTIS_customized_values,  "IC_constants_customized_value")
	$ALERTES_audio_values[0] = getInternationalisationText($nAiO_languageResources, "IC_constants_alerte_audio_off")
	$ALERTES_audio_values[1] = getInternationalisationText($nAiO_languageResources, "IC_constants_alerte_audio_on")
	#EndRegion

	#Region Chargement de l'interface graphique
	Local $GUI_position[4] = [350, 400, 10], $GUI_unappliedModifications = False, $GUI_restartRequired = False
	Local $GUI = GUICreate($nAiO_title&" v"&$nAiO_version&" : "&getInternationalisationText($nAiO_languageResources, "IC_title"), _
		$GUI_position[0], $GUI_position[1], _
		Default, Default, _
		$WS_POPUP+$WS_BORDER, $WS_EX_ACCEPTFILES _
	)
	GUISetIcon($nAiO_repertoire_images&"ZaDS-nAiO.ico")
	#EndRegion

	#Region Items gnraux pour l'interface
	Local  $GUI_TITRE   = GUICtrlCreateLabel(WinGetTitle($GUI), 5, 8, $GUI_position[0]-145, 25, Default, $GUI_WS_EX_PARENTDRAG)
	Global $GUI_CLOCK   = GUICtrlCreateLabel("",   $GUI_position[0]-135, 8, 100, 25, 0x1)
	Local  $GUI_QUITTER = GUICtrlCreateButton("", $GUI_position[0]-30,  5,  25, 25)
	; Tooltips des items
	GUICtrlSetTip($GUI_QUITTER, getInternationalisationText($nAiO_languageResources, "IC_tip_quitter"))
	; Update d'items
	GUICtrlSetBkColor($GUI_TITRE,   $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GUI_CLOCK,   $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GUI_QUITTER, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetFont($GUI_TITRE,      15, 800)
	GUICtrlSetFont($GUI_CLOCK,      15, 800)
	GUICtrlSetFont($GUI_QUITTER,    18, 400, 0, "Wingdings")
	#EndRegion

	GUICtrlCreateTab(6,36,$GUI_position[0]-5-6,$GUI_position[1]-5-36, 0x00000100) ; $TCS_BUTTONS = 0x00000100
	; Onglet "Infos"
	GUICtrlCreateTabItem(getInternationalisationText($nAiO_languageResources, "IC_tab1"))
	#Region items pour les paramtres de base et les informations principales
	Local $IMPORTANT_cadre[4]      = [11,60,$GUI_position[0]-11-12,$GUI_position[1]-60-12]
	Local $IMPORTANT_group         = GUICtrlCreateGroup("",$IMPORTANT_cadre[0],$IMPORTANT_cadre[1],$IMPORTANT_cadre[2],$IMPORTANT_cadre[3])
	GUICtrlSetData($IMPORTANT_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_important")&" : ")
	Local $IMPORTANT_label         = GUICtrlCreateLabel("", _
		$IMPORTANT_cadre[0]+8,    $IMPORTANT_cadre[1]+18,   _
        5+$IMPORTANT_cadre[2]-21, $IMPORTANT_cadre[3]-78    _
	)
	Local $IMPORTANT_password_text = GUICtrlCreateButton("", _
		$IMPORTANT_cadre[0]+8,    $IMPORTANT_cadre[1]+$IMPORTANT_cadre[3]-53, _
        5+$IMPORTANT_cadre[2]-21,  20 _
	)
	Local $IMPORTANT_folder_text   = GUICtrlCreateButton("", _
		$IMPORTANT_cadre[0]+8,    $IMPORTANT_cadre[1]+$IMPORTANT_cadre[3]-28, _
        5+$IMPORTANT_cadre[2]-21,  20 _
	)
	; Contenu
	GUICtrlSetData($IMPORTANT_label, @CRLF & getInternationalisationText($nAiO_languageResources, "IC_important_label_avertissement"))
	GUICtrlSetBkColor($IMPORTANT_label, $GUI_BKCOLOR_TRANSPARENT)
	If $nAiO_config_password = "" Then
		GUICtrlSetData($IMPORTANT_password_text, getInternationalisationText($nAiO_languageResources, "IC_important_profil_protection_ko",getProfilNom(getProfilActuel())))
	Else
		GUICtrlSetData($IMPORTANT_password_text, getInternationalisationText($nAiO_languageResources, "IC_important_profil_protection_ok",getProfilNom(getProfilActuel())))
	EndIf
	GUICtrlSetData($IMPORTANT_folder_text, getInternationalisationText($nAiO_languageResources, "IC_important_profil_repertoire"))
	#EndRegion

	; Onglet "Gnral"
	GUICtrlCreateTabItem(getInternationalisationText($nAiO_languageResources, "IC_tab2"))
	#Region Items pour les paramtres gnraux
	Local $GENERAL_cadre[4] = [11,60,$GUI_position[0]-11-12,196]
	Local $GENERAL_group    = GUICtrlCreateGroup("",$GENERAL_cadre[0],$GENERAL_cadre[1],$GENERAL_cadre[2],$GENERAL_cadre[3])
	GUICtrlSetData($GENERAL_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_general")&" : ")
	; Champs pour le paramtrage
	Local $GENERAL_position_label        = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_general_position_label")&" :", _
											$GENERAL_cadre[0]+8,                                 $GENERAL_cadre[1]+0*25+21, _
											($GENERAL_cadre[2]-26)/3,                            20)
	Local $GENERAL_position_text         = GUICtrlCreateButton("", _
											$GENERAL_cadre[0]+8+1*(5+$GENERAL_cadre[2]-16)/3,    $GENERAL_cadre[1]+0*25+18, _
											5+2*($GENERAL_cadre[2]-26)/3,                        20)
	Local $GENERAL_aot_label             = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_general_aot_label")&" :", _
											$GENERAL_cadre[0]+8,                                 $GENERAL_cadre[1]+1*25+21, _
											($GENERAL_cadre[2]-26)/3,                            20)
	Local $GENERAL_aot_text              = GUICtrlCreateButton("", _
											$GENERAL_cadre[0]+8+1*(5+$GENERAL_cadre[2]-16)/3,    $GENERAL_cadre[1]+1*25+18, _
											5+2*($GENERAL_cadre[2]-26)/3,                        20)
	Local $GENERAL_taskbar_label         = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_general_taskbar_label")&" :", _
											$GENERAL_cadre[0]+8,                                 $GENERAL_cadre[1]+2*25+21, _
											($GENERAL_cadre[2]-26)/3,                            20)
	Local $GENERAL_taskbar_text          = GUICtrlCreateButton("", _
											$GENERAL_cadre[0]+8+1*(5+$GENERAL_cadre[2]-16)/3,    $GENERAL_cadre[1]+2*25+18, _
											5+2*($GENERAL_cadre[2]-26)/3,                        20)
	Local $GENERAL_timeout_label         = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_general_timeout_label")&" :", _
											$GENERAL_cadre[0]+8,                                 $GENERAL_cadre[1]+3*25+21, _
											($GENERAL_cadre[2]-26)/3,                            20)
	Local $GENERAL_timeout_text          = GUICtrlCreateCombo(getInternationalisationText($nAiO_languageResources, "IC_general_timeout_values_default"), _
											$GENERAL_cadre[0]+8+1*(5+$GENERAL_cadre[2]-16)/3,    $GENERAL_cadre[1]+3*25+18, _
											5+2*($GENERAL_cadre[2]-26)/3,                        20)
	Local $GENERAL_connexion_label       = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_general_connexion_label")&" :", _
											$GENERAL_cadre[0]+8,                                 $GENERAL_cadre[1]+4*25+21, _
											($GENERAL_cadre[2]-26)/3,                            20)
	Local $GENERAL_connexion_text        = GUICtrlCreateInput("", _
											$GENERAL_cadre[0]+8+1*(5+$GENERAL_cadre[2]-16)/3,    $GENERAL_cadre[1]+4*25+18, _
											5+2*($GENERAL_cadre[2]-26)/3-23,                     20)
	Local $GENERAL_connexion_box         = GUICtrlCreateButton("...", _
											$GENERAL_cadre[0]+8+3*(5+$GENERAL_cadre[2]-16)/3-25, $GENERAL_cadre[1]+4*25+18, _
											20,                                                  20)
	Local $GENERAL_fullscreen_label      = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_general_fullscreen_label")&" :", _
											$GENERAL_cadre[0]+8,                                 $GENERAL_cadre[1]+5*25+21, _
											($GENERAL_cadre[2]-26)/3,                            20)
	Local $GENERAL_fullscreen_text       = GUICtrlCreateButton("", _
											$GENERAL_cadre[0]+8+1*($GENERAL_cadre[2]-16)/3,      $GENERAL_cadre[1]+5*25+18, _
											1*($GENERAL_cadre[2]-26)/3,                          20)
	Local $GENERAL_fullscreen_multi_text = GUICtrlCreateButton("", _
											$GENERAL_cadre[0]+8+2*($GENERAL_cadre[2]-16)/3+4,    $GENERAL_cadre[1]+5*25+18, _
											1*($GENERAL_cadre[2]-26)/3,                          20)
	Local $GENERAL_colors_label          = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_general_colors_label")&" :", _
											$GENERAL_cadre[0]+8,                                 $GENERAL_cadre[1]+6*25+21, _
											($GENERAL_cadre[2]-26)/3,                            20)
	Local $GENERAL_colors_gui_text       = GUICtrlCreateButton("", _
											$GENERAL_cadre[0]+8+1*($GENERAL_cadre[2]-16)/3,      $GENERAL_cadre[1]+6*25+18, _
											1*($GENERAL_cadre[2]-26)/3,                          20)
	Local $GENERAL_colors_tray_text      = GUICtrlCreateButton("", _
											$GENERAL_cadre[0]+8+2*($GENERAL_cadre[2]-16)/3+4,    $GENERAL_cadre[1]+6*25+18, _
											1*($GENERAL_cadre[2]-26)/3,                          20)
	; Sousmenus
	Local $GENERAL_connexion_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $GENERAL_connexion_item_parcourir = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_general_connexion_parcourir"), $GENERAL_connexion_menu)
	Local $GENERAL_connexion_item_separator = GUICtrlCreateAdvancedMenuItem("", $GENERAL_connexion_menu)
	Local $GENERAL_connexion_items = newList()
	; Update des items
	GUICtrlSetData($GENERAL_timeout_text, getInternationalisationText($nAiO_languageResources, "IC_general_timeout_values_list"))
	parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
	GUICtrlSetBkColor($GENERAL_position_label,   $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GENERAL_aot_label,        $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GENERAL_taskbar_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GENERAL_timeout_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GENERAL_connexion_label,  $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GENERAL_fullscreen_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($GENERAL_colors_label,     $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetState($GENERAL_connexion_text,     $GUI_DROPACCEPTED)
	Local _
		$GENERAL_connexion_text_color = 0x000000
	GUICtrlSetColor($GENERAL_connexion_text,     $GENERAL_connexion_text_color)
	; Tooltips des items
	GUICtrlSetTip($GENERAL_position_text,                                                               _
		getInternationalisationText($nAiO_languageResources, "IC_general_position_tip_texte"),          _
		getInternationalisationText($nAiO_languageResources, "IC_general_position_tip_title")           _
	)
	GUICtrlSetTip($GENERAL_aot_text,                                                                    _
		getInternationalisationText($nAiO_languageResources, "IC_general_aot_tip_texte"),               _
		getInternationalisationText($nAiO_languageResources, "IC_general_aot_tip_title")                _
	)
	GUICtrlSetTip($GENERAL_taskbar_text,                                                                _
		getInternationalisationText($nAiO_languageResources, "IC_general_taskbar_tip_texte"),           _
		getInternationalisationText($nAiO_languageResources, "IC_general_taskbar_tip_title")            _
	)
	GUICtrlSetTip($GENERAL_timeout_text,                                                                _
		getInternationalisationText($nAiO_languageResources, "IC_general_timeout_tip_texte"),           _
		getInternationalisationText($nAiO_languageResources, "IC_general_timeout_tip_title")            _
	)
	GUICtrlSetTip($GENERAL_connexion_text,                                                              _
		getInternationalisationText($nAiO_languageResources, "IC_general_connexion_tip_texte"),         _
		getInternationalisationText($nAiO_languageResources, "IC_general_connexion_tip_title")          _
	)
	GUICtrlSetTip($GENERAL_connexion_box,                                                               _
		getInternationalisationText($nAiO_languageResources, "IC_general_connexion_box_tip_texte"),     _
		getInternationalisationText($nAiO_languageResources, "IC_general_connexion_box_tip_title")      _
	)
	GUICtrlSetTip($GENERAL_fullscreen_text,                                                             _
		getInternationalisationText($nAiO_languageResources, "IC_general_fullscreen_compte_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_general_fullscreen_compte_tip_title")  _
	)
	GUICtrlSetTip($GENERAL_fullscreen_multi_text,                                                       _
		getInternationalisationText($nAiO_languageResources, "IC_general_fullscreen_multi_tip_texte"),  _
		getInternationalisationText($nAiO_languageResources, "IC_general_fullscreen_multi_tip_title")   _
	)
	GUICtrlSetTip($GENERAL_colors_gui_text,                                                             _
		getInternationalisationText($nAiO_languageResources, "IC_general_colors_gui_tip_texte"),        _
		getInternationalisationText($nAiO_languageResources, "IC_general_colors_gui_tip_title")         _
	)
	GUICtrlSetTip($GENERAL_colors_tray_text,                                                            _
		getInternationalisationText($nAiO_languageResources, "IC_general_colors_tray_tip_texte"),       _
		getInternationalisationText($nAiO_languageResources, "IC_general_colors_tray_tip_title")        _
	)
	#EndRegion

	#Region Items pour les paramtres de captures d'cran
	Local $CAPTURE_cadre[4] = [11,$GUI_position[1]-46-12,$GUI_position[0]-11-12,46]
	Local $CAPTURE_group    = GUICtrlCreateGroup("",$CAPTURE_cadre[0],$CAPTURE_cadre[1],$CAPTURE_cadre[2],$CAPTURE_cadre[3])
	GUICtrlSetData($CAPTURE_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_capture")&" : ")
	; Champs pour le paramtrage
	Local $CAPTURE_modes_label = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_capture_modes_label")&" :", _
									$CAPTURE_cadre[0]+8,                                 $CAPTURE_cadre[1]+0*25+21, _
									($CAPTURE_cadre[2]-26)/3,                            20)
	Local $CAPTURE_modes_text  = GUICtrlCreateButton("", _
									$CAPTURE_cadre[0]+8+1*(5+$CAPTURE_cadre[2]-16)/3,    $CAPTURE_cadre[1]+0*25+18, _
									5+2*($CAPTURE_cadre[2]-26)/3,                        20)
	; Sousmenus
	Local $CAPTURE_modes_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $CAPTURE_modes_menus = newList( _
		GUICtrlCreateAdvancedMenu(getInternationalisationText($nAiO_languageResources, "IC_capture_format_label"), $CAPTURE_modes_menu), _
		GUICtrlCreateAdvancedMenu(getInternationalisationText($nAiO_languageResources, "IC_capture_crop_label"),   $CAPTURE_modes_menu), _
		GUICtrlCreateAdvancedMenu(getInternationalisationText($nAiO_languageResources, "IC_capture_mode_label"),   $CAPTURE_modes_menu)  _
	)
	Local $CAPTURE_modes_format_list = newList( _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_format_value0"), $CAPTURE_modes_menus[1]), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_format_value1"), $CAPTURE_modes_menus[1]), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_format_value2"), $CAPTURE_modes_menus[1])  _
	)
	Local $CAPTURE_modes_crop_list   = newList( _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_crop_value0"),   $CAPTURE_modes_menus[2]), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_crop_value1"),   $CAPTURE_modes_menus[2]), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_crop_value2"),   $CAPTURE_modes_menus[2]), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_crop_value3"),   $CAPTURE_modes_menus[2]), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_constants_capture_crop_value4"),   $CAPTURE_modes_menus[2])  _
	)
	Local $CAPTURE_modes_mode_list   = newList( _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_mode_value0"),   $CAPTURE_modes_menus[3]), _
		GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IP_constants_capture_mode_value1"),   $CAPTURE_modes_menus[3])  _
	)
	; Update des items
	capture_updateButtonAndContextMenu($listeParametres, $CAPTURE_modes_text, $CAPTURE_modes_menus, $CAPTURE_modes_format_list, $CAPTURE_modes_crop_list, $CAPTURE_modes_mode_list)
	GUICtrlSetBkColor($CAPTURE_modes_label,$GUI_BKCOLOR_TRANSPARENT)
	; Tooltips des items
	GUICtrlSetTip($CAPTURE_modes_text, getInternationalisationText($nAiO_languageResources, "IC_capture_modes_tip_texte"))
	#EndRegion

	; Onglet "Comptes"
	GUICtrlCreateTabItem(getInternationalisationText($nAiO_languageResources, "IC_tab3"))
	#Region Items pour l'dition de comptes
	Local $COMPTES_cadre[4]    = [11,60,$GUI_position[0]-11-12,$GUI_position[1]-60-12], $COMPTES_modeEdition = False
	Local $COMPTES_group       = GUICtrlCreateGroup("",$COMPTES_cadre[0],$COMPTES_cadre[1],$COMPTES_cadre[2],$COMPTES_cadre[3])
	GUICtrlSetData($COMPTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_comptes")&" : ")
	; ComboBox pour le listing
	Local $COMPTES_comboBox    = GUICtrlCreateCombo("", $COMPTES_cadre[0]+8, $COMPTES_cadre[1]+18, $COMPTES_cadre[2]-16, Default)
	; Boutons pour les actions choix>dition
	Local $COMPTES_add         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_comptes_label_add"), _
									$COMPTES_cadre[0]+8+0*(3+$COMPTES_cadre[2]-16)/4, $COMPTES_cadre[1]+43, ($COMPTES_cadre[2]-25)/4, 25)
	Local $COMPTES_get         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_comptes_label_get"), _
									$COMPTES_cadre[0]+8+1*(3+$COMPTES_cadre[2]-16)/4, $COMPTES_cadre[1]+43, ($COMPTES_cadre[2]-25)/4, 25)
	Local $COMPTES_del         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_comptes_label_del"), _
									$COMPTES_cadre[0]+8+2*(3+$COMPTES_cadre[2]-16)/4, $COMPTES_cadre[1]+43, ($COMPTES_cadre[2]-25)/4, 25)
	Local $COMPTES_mov         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_comptes_label_mov"), _
									$COMPTES_cadre[0]+8+3*(3+$COMPTES_cadre[2]-16)/4, $COMPTES_cadre[1]+43, ($COMPTES_cadre[2]-25)/4, 25)
	; Boutons pour les actions dition>choix
	Local $COMPTES_set         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_comptes_label_set"), _
									$COMPTES_cadre[0]+8+0*(3+$COMPTES_cadre[2]-16)/2, $COMPTES_cadre[1]+43, ($COMPTES_cadre[2]-19)/2, 25)
	Local $COMPTES_nok         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_comptes_label_nok"), _
									$COMPTES_cadre[0]+8+1*(3+$COMPTES_cadre[2]-16)/2, $COMPTES_cadre[1]+43, ($COMPTES_cadre[2]-19)/2, 25)
	; Champs pour l'dition
	Local $COMPTE_alias_label  = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_compte_alias_label")&" :", _
									$COMPTES_cadre[0]+8,                                 $COMPTES_cadre[1]+0*25+76, ($COMPTES_cadre[2]-26)/3,        20)
	Local $COMPTE_alias_text   = GUICtrlCreateInput("",           _
									$COMPTES_cadre[0]+8+1*(5+$COMPTES_cadre[2]-16)/3,    $COMPTES_cadre[1]+0*25+73, 5+2*($COMPTES_cadre[2]-26)/3,    20)
	Local $COMPTE_avatar_label = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_compte_avatar_label")&" :", _
									$COMPTES_cadre[0]+8,                                 $COMPTES_cadre[1]+1*25+76, ($COMPTES_cadre[2]-26)/3,        20)
	Local $COMPTE_avatar_text  = GUICtrlCreateInput("",           _
									$COMPTES_cadre[0]+8+1*(5+$COMPTES_cadre[2]-16)/3,    $COMPTES_cadre[1]+1*25+73, 5+2*($COMPTES_cadre[2]-26)/3-23, 20)
	Local $COMPTE_avatar_box   = GUICtrlCreateButton("...",       _
									$COMPTES_cadre[0]+8+3*(5+$COMPTES_cadre[2]-16)/3-25, $COMPTES_cadre[1]+1*25+73, 20,                              20)
	Local $COMPTE_login_label  = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_compte_login_label")&" :", _
									$COMPTES_cadre[0]+8,                                 $COMPTES_cadre[1]+2*25+76, ($COMPTES_cadre[2]-26)/3,        20)
	Local $COMPTE_login_text   = GUICtrlCreateInput("",           _
									$COMPTES_cadre[0]+8+1*(5+$COMPTES_cadre[2]-16)/3,    $COMPTES_cadre[1]+2*25+73, 5+2*($COMPTES_cadre[2]-26)/3,    20)
	Local $COMPTE_pass_label   = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_compte_pass_label")&" :", _
									$COMPTES_cadre[0]+8,                                 $COMPTES_cadre[1]+3*25+76, ($COMPTES_cadre[2]-26)/3,        20)
	Local $COMPTE_pass_text    = GUICtrlCreateInput("",           _
									$COMPTES_cadre[0]+8+1*(5+$COMPTES_cadre[2]-16)/3,    $COMPTES_cadre[1]+3*25+73, 5+2*($COMPTES_cadre[2]-26)/3,    20, 160) ; $ES_PASSWORD = 32  /  $ES_AUTOHSCROLL = 128
	Local $COMPTE_key_label    = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_compte_key_label")&" :", _
									$COMPTES_cadre[0]+8,                                 $COMPTES_cadre[1]+4*25+76, ($COMPTES_cadre[2]-26)/3,        20)
	Local $COMPTE_key_text     = GUICtrlCreateInput("",           _
									$COMPTES_cadre[0]+8+1*(5+$COMPTES_cadre[2]-16)/3,    $COMPTES_cadre[1]+4*25+73, 5+2*($COMPTES_cadre[2]-26)/3,    20, 160) ; $ES_PASSWORD = 32  /  $ES_AUTOHSCROLL = 128
	Dim $COMPTE_items_pour_modelisation[5] = [$COMPTE_alias_text, $COMPTE_avatar_text, $COMPTE_login_text, $COMPTE_pass_text, $COMPTE_key_text]
	; Sousmenus
	Dim $COMPTES_mov_liste[1] = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())]
	Local $COMPTES_del_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $COMPTES_del_confirm = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_del_confirm_texte", ""), $COMPTES_del_menu)
	; Update des items
	GUICtrlSetState($COMPTE_avatar_text, $GUI_DROPACCEPTED)
	compte_updateComboBoxAndContextMenu($listeComptes, $COMPTES_comboBox, $COMPTES_mov_liste)
	GUICtrlSetBkColor($COMPTE_alias_label,  $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($COMPTE_avatar_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($COMPTE_login_label,  $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($COMPTE_pass_label,   $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($COMPTE_key_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetLimit($COMPTE_alias_text,   32)
	GUICtrlSetLimit($COMPTE_avatar_text, 255)
	GUICtrlSetLimit($COMPTE_login_text,   32)
	GUICtrlSetLimit($COMPTE_pass_text,    64)
	GUICtrlSetLimit($COMPTE_key_text,      8)
	GUICtrlSetState($COMPTES_comboBox,        cond(getListeComptesLength($listeComptes) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($COMPTES_add, $GUI_SHOW + $GUI_ENABLE)
	GUICtrlSetState($COMPTES_get, $GUI_SHOW + cond(getListeComptesLength($listeComptes) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($COMPTES_del, $GUI_SHOW + cond(getListeComptesLength($listeComptes) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($COMPTES_mov, $GUI_SHOW + cond(getListeComptesLength($listeComptes) < 2, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($COMPTES_set, $GUI_HIDE + $GUI_DISABLE)
	GUICtrlSetState($COMPTES_nok, $GUI_HIDE + $GUI_DISABLE)
	For $item In $COMPTE_items_pour_modelisation
		GUICtrlSetState($item, $GUI_DISABLE)
	Next
	GUICtrlSetState($COMPTE_avatar_box, $GUI_DISABLE)
	Local $COMPTE_avatar_text_color = 0x000000
	GUICtrlSetColor($COMPTE_avatar_text, $COMPTE_avatar_text_color)
	; Tooltips des items
	GUICtrlSetTip($COMPTES_comboBox, _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_combobox_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_combobox_tip_title")  _
	)
	GUICtrlSetTip($COMPTES_add, _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_add_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_add_tip_title")  _
	)
	GUICtrlSetTip($COMPTES_get, _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_get_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_get_tip_title")  _
	)
	GUICtrlSetTip($COMPTES_del, _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_del_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_del_tip_title")  _
	)
	GUICtrlSetTip($COMPTES_mov, _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_mov_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_mov_tip_title")  _
	)
	GUICtrlSetTip($COMPTES_set, _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_set_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_set_tip_title")  _
	)
	GUICtrlSetTip($COMPTES_nok, _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_nok_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_comptes_nok_tip_title")  _
	)
	GUICtrlSetTip($COMPTE_alias_text, _
		getInternationalisationText($nAiO_languageResources, "IC_compte_alias_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_compte_alias_tip_title")  _
	)
	GUICtrlSetTip($COMPTE_avatar_text, _
		getInternationalisationText($nAiO_languageResources, "IC_compte_avatar_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_compte_avatar_tip_title")  _
	)
	GUICtrlSetTip($COMPTE_avatar_box, _
		getInternationalisationText($nAiO_languageResources, "IC_compte_avatar_box_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_compte_avatar_box_tip_title")  _
	)
	GUICtrlSetTip($COMPTE_login_text, _
		getInternationalisationText($nAiO_languageResources, "IC_compte_login_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_compte_login_tip_title")  _
	)
	GUICtrlSetTip($COMPTE_pass_text, _
		getInternationalisationText($nAiO_languageResources, "IC_compte_pass_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_compte_pass_tip_title")  _
	)
	GUICtrlSetTip($COMPTE_key_text, _
		getInternationalisationText($nAiO_languageResources, "IC_compte_key_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_compte_key_tip_title")  _
	)
	#EndRegion

	; Onglet "Multis"
	GUICtrlCreateTabItem(getInternationalisationText($nAiO_languageResources, "IC_tab4"))
	#Region Items pour la gestion des multis
	Local $MULTIS_cadre[4]           = [11,60,$GUI_position[0]-11-12,$GUI_position[1]-60-12], $MULTIS_modeEdition = False
	Local $MULTIS_group              = GUICtrlCreateGroup("",$MULTIS_cadre[0],$MULTIS_cadre[1],$MULTIS_cadre[2],$MULTIS_cadre[3])
	GUICtrlSetData($MULTIS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_multis")&" : ")
	; ComboBox pour le listing
	Local $MULTIS_comboBox           = GUICtrlCreateCombo("", $MULTIS_cadre[0]+8, $MULTIS_cadre[1]+18, $MULTIS_cadre[2]-16, Default)
	; Boutons pour les actions choix>dition
	Local $MULTIS_add                = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_multis_label_add"), _
										$MULTIS_cadre[0]+8+0*(3+$MULTIS_cadre[2]-16)/4, $MULTIS_cadre[1]+43, ($MULTIS_cadre[2]-25)/4, 25)
	Local $MULTIS_get                = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_multis_label_get"), _
										$MULTIS_cadre[0]+8+1*(3+$MULTIS_cadre[2]-16)/4, $MULTIS_cadre[1]+43, ($MULTIS_cadre[2]-25)/4, 25)
	Local $MULTIS_del                = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_multis_label_del"), _
									    $MULTIS_cadre[0]+8+2*(3+$MULTIS_cadre[2]-16)/4, $MULTIS_cadre[1]+43, ($MULTIS_cadre[2]-25)/4, 25)
	Local $MULTIS_mov                = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_multis_label_mov"), _
										$MULTIS_cadre[0]+8+3*(3+$MULTIS_cadre[2]-16)/4, $MULTIS_cadre[1]+43, ($MULTIS_cadre[2]-25)/4, 25)
	; Boutons pour les actions dition>choix
	Local $MULTIS_set                = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_multis_label_set"), _
									    $MULTIS_cadre[0]+8+0*(3+$MULTIS_cadre[2]-16)/2, $MULTIS_cadre[1]+43, ($MULTIS_cadre[2]-19)/2, 25)
	Local $MULTIS_nok                = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_multis_label_nok"), _
									    $MULTIS_cadre[0]+8+1*(3+$MULTIS_cadre[2]-16)/2, $MULTIS_cadre[1]+43, ($MULTIS_cadre[2]-19)/2, 25)
	; Champs pour l'dition
	Local $MULTI_alias_label         = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_multi_alias_label")&" :", _
										$MULTIS_cadre[0]+8,                                $MULTIS_cadre[1]+0*25+76,                                          ($MULTIS_cadre[2]-26)/3,        20)
	Local $MULTI_alias_text          = GUICtrlCreateInput("", _
										$MULTIS_cadre[0]+8+1*(5+$MULTIS_cadre[2]-16)/3,    $MULTIS_cadre[1]+0*25+73,                                          5+2*($MULTIS_cadre[2]-26)/3,    20)
	Local $MULTI_comptes_list        = GUICtrlCreateListView("-", _
										$MULTIS_cadre[0]+8,                                $MULTIS_cadre[1]+1*25+73,                                          5+3*($MULTIS_cadre[2]-20)/3-25, $MULTIS_cadre[3]-136, Default, 0x00000021) ; $LVS_EX_FULLROWSELECT = 0x00000020  /  $LVS_EX_GRIDLINES = 0x00000001
	Local $MULTI_comptes_list_MoveUp = GUICtrlCreateButton("5", _
										$MULTIS_cadre[0]+8+5+3*($MULTIS_cadre[2]-20)/3-20, $MULTIS_cadre[1]+1*25+73+0*($MULTIS_cadre[3]-136-20)/2,            20,                             20)
	Local $MULTI_comptes_list_Insert = GUICtrlCreateButton("+", _
										$MULTIS_cadre[0]+8+5+3*($MULTIS_cadre[2]-20)/3-20, $MULTIS_cadre[1]+1*25+73+1*($MULTIS_cadre[3]-136-20)/2-12,         20,                             20)
	Local $MULTI_comptes_list_Delete = GUICtrlCreateButton("X", _
										$MULTIS_cadre[0]+8+5+3*($MULTIS_cadre[2]-20)/3-20, $MULTIS_cadre[1]+1*25+73+1*($MULTIS_cadre[3]-136-20)/2+12,         20,                             20)
	Local $MULTI_comptes_list_MoveDn = GUICtrlCreateButton("6", _
										$MULTIS_cadre[0]+8+5+3*($MULTIS_cadre[2]-20)/3-20, $MULTIS_cadre[1]+1*25+73+2*($MULTIS_cadre[3]-136-20)/2,            20,                             20)
	Local $MULTI_custom_label        = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_multi_customized_mode_label")&" :", _
										$MULTIS_cadre[0]+8,                                $MULTIS_cadre[1]+$MULTIS_cadre[3]-25, ($MULTIS_cadre[2]-26)/3,     20)
	Local $MULTI_custom_text         = GUICtrlCreateButton("", _
										$MULTIS_cadre[0]+8+1*(5+$MULTIS_cadre[2]-16)/3,    $MULTIS_cadre[1]+$MULTIS_cadre[3]-28, 5+2*($MULTIS_cadre[2]-26)/3, 20)
	; ComboBox pour le listing
	Dim $MULTI_items_pour_modelisation[1] = [$MULTI_alias_text]
	Local $MULTI_comptes_listitems[1]     = [0]
	; Sousmenus
	Local _
		$MULTIS_mov_liste[1]    = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())], _
		$MULTI_comptes_items[1] = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())], _
		$MULTIS_del_menu        = GUICtrlCreateContextMenu(GUICtrlCreateDummy()),   _
		$MULTIS_del_confirm     = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_trt_multis_del_confirm_texte", ""), $MULTIS_del_menu)
	; Update des items
	multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $MULTIS_comboBox, $MULTI_custom_text, $MULTIS_mov_liste, $MULTI_comptes_list)
	GUICtrlSetBkColor($MULTI_alias_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($MULTI_comptes_list,   $GUI_BKCOLOR_LV_ALTERNATE)
	GUICtrlSetFont($MULTI_comptes_list_MoveUp, 11, 400, 0, "Webdings")
	GUICtrlSetFont($MULTI_comptes_list_MoveDn, 11, 400, 0, "Webdings")
	GUICtrlSetLimit($MULTI_alias_text, 32)
	GUICtrlSetState($MULTIS_comboBox,        cond(getListeMultisLength($listeMultis) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($MULTIS_add, $GUI_SHOW + $GUI_ENABLE)
	GUICtrlSetState($MULTIS_get, $GUI_SHOW + cond(getListeMultisLength($listeMultis) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($MULTIS_del, $GUI_SHOW + cond(getListeMultisLength($listeMultis) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($MULTIS_mov, $GUI_SHOW + cond(getListeMultisLength($listeMultis) < 2, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($MULTIS_set, $GUI_HIDE + $GUI_DISABLE)
	GUICtrlSetState($MULTIS_nok, $GUI_HIDE + $GUI_DISABLE)
	For $item In $MULTI_items_pour_modelisation
		GUICtrlSetState($item,   $GUI_DISABLE)
	Next
	GUICtrlSetState($MULTI_comptes_list,        $GUI_DISABLE)
	GUICtrlSetState($MULTI_comptes_list_MoveUp, $GUI_DISABLE)
	GUICtrlSetState($MULTI_comptes_list_Insert, $GUI_DISABLE)
	GUICtrlSetState($MULTI_comptes_list_Delete, $GUI_DISABLE)
	GUICtrlSetState($MULTI_comptes_list_MoveDn, $GUI_DISABLE)
	; Tooltips des items
	GUICtrlSetTip($MULTIS_comboBox, _
		getInternationalisationText($nAiO_languageResources, "IC_multis_combobox_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multis_combobox_tip_title")  _
	)
	GUICtrlSetTip($MULTIS_add, _
		getInternationalisationText($nAiO_languageResources, "IC_multis_add_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multis_add_tip_title")  _
	)
	GUICtrlSetTip($MULTIS_get, _
		getInternationalisationText($nAiO_languageResources, "IC_multis_get_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multis_get_tip_title")  _
	)
	GUICtrlSetTip($MULTIS_del, _
		getInternationalisationText($nAiO_languageResources, "IC_multis_del_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multis_del_tip_title")  _
	)
	GUICtrlSetTip($MULTIS_mov, _
		getInternationalisationText($nAiO_languageResources, "IC_multis_mov_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multis_mov_tip_title")  _
	)
	GUICtrlSetTip($MULTIS_set, _
		getInternationalisationText($nAiO_languageResources, "IC_multis_set_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multis_set_tip_title")  _
	)
	GUICtrlSetTip($MULTIS_nok, _
		getInternationalisationText($nAiO_languageResources, "IC_multis_nok_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multis_nok_tip_title")  _
	)
	GUICtrlSetTip($MULTI_alias_text, _
		getInternationalisationText($nAiO_languageResources, "IC_multi_alias_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multi_alias_tip_title")  _
	)
	GUICtrlSetTip($MULTI_comptes_list, _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_list_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_list_tip_title")  _
	)
	GUICtrlSetTip($MULTI_comptes_list_MoveUp, _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_list_moveup_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_list_moveup_tip_title")  _
	)
	GUICtrlSetTip($MULTI_comptes_list_Insert, _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_insert_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_insert_tip_title")  _
	)
	GUICtrlSetTip($MULTI_comptes_list_Delete, _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_delete_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_delete_tip_title")  _
	)
	GUICtrlSetTip($MULTI_comptes_list_MoveDn, _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_movedn_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_multi_comptes_movedn_tip_title")  _
	)
	#EndRegion

	; Onglet "Alertes"
	GUICtrlCreateTabItem(getInternationalisationText($nAiO_languageResources, "IC_tab5"))
	#Region Items pour l'dition d'alertes
	Local $ALERTES_cadre[4]      = [11,60,$GUI_position[0]-11-12,$GUI_position[1]-60-12], $ALERTES_modeEdition = False, $ALERTES_dateFormat = 0x1032, $ALERTES_dateStyle = "dd/MM/yyyy HH:mm"
	Local $ALERTES_group         = GUICtrlCreateGroup("",$ALERTES_cadre[0],$ALERTES_cadre[1],$ALERTES_cadre[2],$ALERTES_cadre[3])
	GUICtrlSetData($ALERTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_alertes")&" : ")
	; ComboBox pour le listing
	Local $ALERTES_comboBox      = GUICtrlCreateCombo("", $ALERTES_cadre[0]+8, $ALERTES_cadre[1]+18, $ALERTES_cadre[2]-16, Default)
	; Boutons pour les actions choix>dition
	Local $ALERTES_add           = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_alertes_label_add"), _
									$ALERTES_cadre[0]+8+0*(3+$ALERTES_cadre[2]-16)/4, $ALERTES_cadre[1]+43, ($ALERTES_cadre[2]-25)/4, 25)
	Local $ALERTES_get           = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_alertes_label_get"), _
									$ALERTES_cadre[0]+8+1*(3+$ALERTES_cadre[2]-16)/4, $ALERTES_cadre[1]+43, ($ALERTES_cadre[2]-25)/4, 25)
	Local $ALERTES_del           = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_alertes_label_del"), _
									$ALERTES_cadre[0]+8+2*(3+$ALERTES_cadre[2]-16)/4, $ALERTES_cadre[1]+43, ($ALERTES_cadre[2]-25)/4, 25)
	Local $ALERTES_mov           = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_alertes_label_mov"), _
									$ALERTES_cadre[0]+8+3*(3+$ALERTES_cadre[2]-16)/4, $ALERTES_cadre[1]+43, ($ALERTES_cadre[2]-25)/4, 25)
	; Boutons pour les actions dition>choix
	Local $ALERTES_set           = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_alertes_label_set"), _
									$ALERTES_cadre[0]+8+0*(3+$ALERTES_cadre[2]-16)/2, $ALERTES_cadre[1]+43, ($ALERTES_cadre[2]-19)/2, 25)
	Local $ALERTES_nok           = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_alertes_label_nok"), _
									$ALERTES_cadre[0]+8+1*(3+$ALERTES_cadre[2]-16)/2, $ALERTES_cadre[1]+43, ($ALERTES_cadre[2]-19)/2, 25)
	; Champs pour l'dition
	Local $ALERTE_dateA_label    = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_alerte_datea_label")&" :", _
									$ALERTES_cadre[0]+8,                              $ALERTES_cadre[1]+0*25+76,              ($ALERTES_cadre[2]-26)/3,     20)
	Local $ALERTE_dateA_text     = GUICtrlCreateDate("", _
									$ALERTES_cadre[0]+8+1*(5+$ALERTES_cadre[2]-16)/3, $ALERTES_cadre[1]+0*25+73,              5+2*($ALERTES_cadre[2]-26)/3, 20)
	Local $ALERTE_dateB_label    = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_alerte_dateb_label")&" :", _
									$ALERTES_cadre[0]+8,                              $ALERTES_cadre[1]+1*25+76,              ($ALERTES_cadre[2]-26)/3,     20)
	Local $ALERTE_dateB_text     = GUICtrlCreateDate("", _
									$ALERTES_cadre[0]+8+1*(5+$ALERTES_cadre[2]-16)/3, $ALERTES_cadre[1]+1*25+73,              5+2*($ALERTES_cadre[2]-26)/3, 20)
	Local $ALERTE_periodic_label = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_alerte_periodic_label")&" :", _
									$ALERTES_cadre[0]+8,                              $ALERTES_cadre[1]+2*25+76,              ($ALERTES_cadre[2]-26)/3,     20)
	Local $ALERTE_periodic_text  = GUICtrlCreateInput("", _
									$ALERTES_cadre[0]+8+1*(5+$ALERTES_cadre[2]-16)/3, $ALERTES_cadre[1]+2*25+73,              5+2*($ALERTES_cadre[2]-26)/3, 20)
	Local $ALERTE_title_label    = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_alerte_title_label")&" :", _
									$ALERTES_cadre[0]+8,                              $ALERTES_cadre[1]+3*25+76,              ($ALERTES_cadre[2]-26)/3,     20)
	Local $ALERTE_title_text     = GUICtrlCreateInput("", _
									$ALERTES_cadre[0]+8+1*(5+$ALERTES_cadre[2]-16)/3, $ALERTES_cadre[1]+3*25+73,              5+2*($ALERTES_cadre[2]-26)/3, 20)
	Local $ALERTE_descript_label = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_alerte_descript_label")&" :", _
									$ALERTES_cadre[0]+8,                              $ALERTES_cadre[1]+4*25+76,              2*($ALERTES_cadre[2]-26)/3,   20)
	Local $ALERTE_descript_text  = GUICtrlCreateEdit("", _
									$ALERTES_cadre[0]+8+0*(5+$ALERTES_cadre[2]-16)/3, $ALERTES_cadre[1]+193,                  5+3*($ALERTES_cadre[2]-20)/3, $ALERTES_cadre[3]-8-228)
	Local $ALERTE_audio_label    = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_alerte_audio_label")&" :", _
									$ALERTES_cadre[0]+8,                              $ALERTES_cadre[1]+$ALERTES_cadre[3]-25, ($ALERTES_cadre[2]-26)/3,     20)
	Local $ALERTE_audio_text     = GUICtrlCreateButton("", _
									$ALERTES_cadre[0]+8+1*(5+$ALERTES_cadre[2]-16)/3, $ALERTES_cadre[1]+$ALERTES_cadre[3]-28, 5+2*($ALERTES_cadre[2]-26)/3, 20)
	Dim $ALERTE_items_pour_modelisation[5] = [$ALERTE_dateA_text, $ALERTE_dateB_text, $ALERTE_periodic_text, $ALERTE_title_text, $ALERTE_descript_text]
	; Sousmenus
	Dim $ALERTES_mov_liste[1] = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())]
	Local $ALERTES_del_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $ALERTES_del_confirm = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_trt_alertes_del_confirm_texte", ""), $ALERTES_del_menu)
	; Update des items
	GUICtrlSendMsg($ALERTE_dateA_text, $ALERTES_dateFormat, 0, $ALERTES_dateStyle)
	GUICtrlSendMsg($ALERTE_dateB_text, $ALERTES_dateFormat, 0, $ALERTES_dateStyle)
	alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $ALERTES_comboBox, $ALERTE_audio_text, $ALERTES_mov_liste)
	GUICtrlSetBkColor($ALERTE_dateA_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ALERTE_dateB_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ALERTE_periodic_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ALERTE_title_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ALERTE_descript_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetLimit($ALERTE_dateA_text, 16)
	GUICtrlSetLimit($ALERTE_dateB_text, 16)
	GUICtrlSetLimit($ALERTE_periodic_text, 16)
	GUICtrlSetLimit($ALERTE_title_text, 64)
	GUICtrlSetLimit($ALERTE_descript_text, 255)
	GUICtrlSetState($ALERTES_comboBox, cond(getListeAlertesLength($listeAlertes) = 0,$GUI_DISABLE,$GUI_ENABLE))
	GUICtrlSetState($ALERTES_add, $GUI_SHOW+$GUI_ENABLE)
	GUICtrlSetState($ALERTES_get, $GUI_SHOW+cond(getListeAlertesLength($listeAlertes) = 0,$GUI_DISABLE,$GUI_ENABLE))
	GUICtrlSetState($ALERTES_del, $GUI_SHOW+cond(getListeAlertesLength($listeAlertes) = 0,$GUI_DISABLE,$GUI_ENABLE))
	GUICtrlSetState($ALERTES_mov, $GUI_SHOW+cond(getListeAlertesLength($listeAlertes) < 2,$GUI_DISABLE,$GUI_ENABLE))
	GUICtrlSetState($ALERTES_set, $GUI_HIDE+$GUI_DISABLE)
	GUICtrlSetState($ALERTES_nok, $GUI_HIDE+$GUI_DISABLE)
	For $item In $ALERTE_items_pour_modelisation
		GUICtrlSetState($item, $GUI_DISABLE)
	Next
	; Tooltips des items
	GUICtrlSetTip($ALERTES_comboBox, _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_combobox_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_combobox_tip_title")  _
	)
	GUICtrlSetTip($ALERTES_add, _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_add_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_add_tip_title")  _
	)
	GUICtrlSetTip($ALERTES_get, _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_get_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_get_tip_title")  _
	)
	GUICtrlSetTip($ALERTES_del, _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_del_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_del_tip_title")  _
	)
	GUICtrlSetTip($ALERTES_mov, _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_mov_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_mov_tip_title")  _
	)
	GUICtrlSetTip($ALERTES_set, _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_set_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_set_tip_title")  _
	)
	GUICtrlSetTip($ALERTES_nok, _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_nok_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alertes_nok_tip_title")  _
	)
	GUICtrlSetTip($ALERTE_dateA_text, _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_datea_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_datea_tip_title")  _
	)
	GUICtrlSetTip($ALERTE_dateB_text, _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_dateb_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_dateb_tip_title")  _
	)
	GUICtrlSetTip($ALERTE_periodic_text, _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_periodic_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_periodic_tip_title")  _
	)
	GUICtrlSetTip($ALERTE_title_text, _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_title_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_title_tip_title")  _
	)
	GUICtrlSetTip($ALERTE_descript_text, _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_descript_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_alerte_descript_tip_title")  _
	)
	#EndRegion

	; Onglet "Modules"
	GUICtrlCreateTabItem(getInternationalisationText($nAiO_languageResources, "IC_tab6"))
	#Region Items pour la gestion des modules
	Local $MODULES_cadre[4] = [11,60,$GUI_position[0]-11-12,$GUI_position[1]-60-12-129]
	Local $MODULES_group    = GUICtrlCreateGroup("",$MODULES_cadre[0],$MODULES_cadre[1],$MODULES_cadre[2],$MODULES_cadre[3])
	GUICtrlSetData($MODULES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_modules")&" : ")
	; ComboBox pour le listing
	Local $MODULES_WhiteTitle   = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_group_modules_actifs")   & " : ", $MODULES_cadre[0]+8,                             $MODULES_cadre[1]+18, ($MODULES_cadre[2]-16-30)/2, 20, 0x0100) ; $SS_NOTIFY = 0x0100 ; $SS_LEFT = 0x0
	Local $MODULES_BlackTitle   = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_group_modules_inactifs") & " : ", $MODULES_cadre[0]+8+($MODULES_cadre[2]-16+30)/2, $MODULES_cadre[1]+18, ($MODULES_cadre[2]-16-30)/2, 20, 0x0102) ; $SS_NOTIFY = 0x0100 ; $SS_RIGHT = 0x2
	Local $MODULES_listBoxWhite = GUICtrlCreateList("",    0, 0, Default, Default, 0x00A00103) ; $GUI_SS_DEFAULT_LIST = 0x00A00003 ; $LBS_NOINTEGRALHEIGHT = 0x0100
	Local $MODULES_listBoxBlack = GUICtrlCreateList("",    0, 0, Default, Default, 0x00A00103) ; $GUI_SS_DEFAULT_LIST = 0x00A00003 ; $LBS_NOINTEGRALHEIGHT = 0x0100
	Local $MODULES_allow        = GUICtrlCreateButton("<", 0, 0)
	Local $MODULES_deny         = GUICtrlCreateButton(">", 0, 0)
	Local $MODULES_positions[4][5] = [                                                                                                                                                         _
		[$MODULES_listBoxWhite, $MODULES_cadre[0]+8,                             $MODULES_cadre[1]+43,                            ($MODULES_cadre[2]-16-30)/2, $MODULES_cadre[3]-50         ], _
		[$MODULES_listBoxBlack, $MODULES_cadre[0]+8+($MODULES_cadre[2]-16+30)/2, $MODULES_cadre[1]+43,                            ($MODULES_cadre[2]-16-30)/2, $MODULES_cadre[3]-50         ], _
		[$MODULES_allow,        $MODULES_cadre[0]+8+($MODULES_cadre[2]-16-20)/2, $MODULES_cadre[1]+43+40,                         20,                          ($MODULES_cadre[3]-50-5)/2-40], _
		[$MODULES_deny,         $MODULES_cadre[0]+8+($MODULES_cadre[2]-16-20)/2, $MODULES_cadre[1]+43+($MODULES_cadre[3]-50+5)/2, 20,                          ($MODULES_cadre[3]-50-5)/2-40]  _
	]
	; Update des items
	GUICtrlSetBkColor($MODULES_listBoxWhite, $GUI_BKCOLOR_LV_ALTERNATE)
	GUICtrlSetBkColor($MODULES_listBoxBlack, $GUI_BKCOLOR_LV_ALTERNATE)
	module_updateItems($listeModules, $MODULES_positions)
	#EndRegion
	#Region Items pour l'dition de liens
	Local $LIENS_cadre[4]    = [11,$GUI_position[1]-124-12,$GUI_position[0]-11-12,124], $LIENS_modeEdition = False
	Local $LIENS_group       = GUICtrlCreateGroup("",$LIENS_cadre[0],$LIENS_cadre[1],$LIENS_cadre[2],$LIENS_cadre[3])
	GUICtrlSetData($LIENS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_liens")&" : ")
	; ComboBox pour le listing
	Local $LIENS_comboBox    = GUICtrlCreateCombo("", $LIENS_cadre[0]+8, $LIENS_cadre[1]+18, $LIENS_cadre[2]-16, Default)
	; Boutons pour les actions choix>dition
	Local $LIENS_add         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_liens_label_add"), _
									$LIENS_cadre[0]+8+0*(3+$LIENS_cadre[2]-16)/4, $LIENS_cadre[1]+43, ($LIENS_cadre[2]-25)/4, 25)
	Local $LIENS_get         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_liens_label_get"), _
									$LIENS_cadre[0]+8+1*(3+$LIENS_cadre[2]-16)/4, $LIENS_cadre[1]+43, ($LIENS_cadre[2]-25)/4, 25)
	Local $LIENS_del         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_liens_label_del"), _
									$LIENS_cadre[0]+8+2*(3+$LIENS_cadre[2]-16)/4, $LIENS_cadre[1]+43, ($LIENS_cadre[2]-25)/4, 25)
	Local $LIENS_mov         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_liens_label_mov"), _
									$LIENS_cadre[0]+8+3*(3+$LIENS_cadre[2]-16)/4, $LIENS_cadre[1]+43, ($LIENS_cadre[2]-25)/4, 25)
	; Boutons pour les actions dition>choix
	Local $LIENS_set         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_liens_label_set"), _
									$LIENS_cadre[0]+8+0*(3+$LIENS_cadre[2]-16)/2, $LIENS_cadre[1]+43, ($LIENS_cadre[2]-19)/2, 25)
	Local $LIENS_nok         = GUICtrlCreateButton(getInternationalisationText($nAiO_languageResources, "IC_liens_label_nok"), _
									$LIENS_cadre[0]+8+1*(3+$LIENS_cadre[2]-16)/2, $LIENS_cadre[1]+43, ($LIENS_cadre[2]-19)/2, 25)
	; Champs pour l'dition
	Local $LIEN_alias_label  = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_lien_alias_label")&" :", _
									$LIENS_cadre[0]+8,                               $LIENS_cadre[1]+0*25+76, ($LIENS_cadre[2]-26)/3,           20)
	Local $LIEN_alias_text   = GUICtrlCreateInput("",           _
									$LIENS_cadre[0]+8+1*(5+$LIENS_cadre[2]-16)/3,    $LIENS_cadre[1]+0*25+73, 5+2*($LIENS_cadre[2]-26)/3,       20)
	Local $LIEN_chemin_label = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_lien_chemin_label")&" :", _
									$LIENS_cadre[0]+8,                               $LIENS_cadre[1]+1*25+76, ($LIENS_cadre[2]-26)/3,           20)
	Local $LIEN_chemin_text  = GUICtrlCreateInput("",           _
									$LIENS_cadre[0]+8+1*(5+$LIENS_cadre[2]-16)/3,    $LIENS_cadre[1]+1*25+73, 5+2*($LIENS_cadre[2]-26)/3-23-25, 20)
	Local $LIEN_type_box     = GUICtrlCreateButton("",       _
									$LIENS_cadre[0]+8+3*(5+$LIENS_cadre[2]-16)/3-50, $LIENS_cadre[1]+1*25+73, 20,                               20)
	Local $LIEN_chemin_box   = GUICtrlCreateButton("...",       _
									$LIENS_cadre[0]+8+3*(5+$LIENS_cadre[2]-16)/3-25, $LIENS_cadre[1]+1*25+73, 20,                               20)
	Dim $LIEN_items_pour_modelisation[3] = [$LIEN_alias_text, $LIEN_chemin_text, $LIEN_type_box]
	; Sousmenus
	Dim $LIENS_mov_liste[1] = [GUICtrlCreateContextMenu(GUICtrlCreateDummy())]
	Local $LIENS_del_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $LIENS_del_confirm = GUICtrlCreateAdvancedMenuItem(getInternationalisationText($nAiO_languageResources, "IC_trt_liens_del_confirm_texte", ""), $LIENS_del_menu)
	; Update des items
	GUICtrlSetState($LIEN_chemin_text, $GUI_DROPACCEPTED)
	lien_updateComboBoxAndContextMenu($listeLiens, $LIENS_comboBox, $LIENS_mov_liste)
	GUICtrlSetBkColor($LIEN_alias_label,  $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($LIEN_chemin_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetLimit($LIEN_alias_text,   32)
	GUICtrlSetLimit($LIEN_chemin_text, 512)
	GUICtrlSetState($LIENS_comboBox,        cond(getListeLiensLength($listeLiens) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($LIENS_add, $GUI_SHOW + $GUI_ENABLE)
	GUICtrlSetState($LIENS_get, $GUI_SHOW + cond(getListeLiensLength($listeLiens) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($LIENS_del, $GUI_SHOW + cond(getListeLiensLength($listeLiens) = 0, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($LIENS_mov, $GUI_SHOW + cond(getListeLiensLength($listeLiens) < 2, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlSetState($LIENS_set, $GUI_HIDE + $GUI_DISABLE)
	GUICtrlSetState($LIENS_nok, $GUI_HIDE + $GUI_DISABLE)
	For $item In $LIEN_items_pour_modelisation
		GUICtrlSetState($item, $GUI_DISABLE)
	Next
	Local $LIEN_chemin_text_color = 0x000000
	GUICtrlSetColor($LIEN_chemin_text, $LIEN_chemin_text_color)
	; Tooltips des items
	GUICtrlSetTip($LIENS_comboBox, _
		getInternationalisationText($nAiO_languageResources, "IC_liens_combobox_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_liens_combobox_tip_title")  _
	)
	GUICtrlSetTip($LIENS_add, _
		getInternationalisationText($nAiO_languageResources, "IC_liens_add_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_liens_add_tip_title")  _
	)
	GUICtrlSetTip($LIENS_get, _
		getInternationalisationText($nAiO_languageResources, "IC_liens_get_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_liens_get_tip_title")  _
	)
	GUICtrlSetTip($LIENS_del, _
		getInternationalisationText($nAiO_languageResources, "IC_liens_del_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_liens_del_tip_title")  _
	)
	GUICtrlSetTip($LIENS_mov, _
		getInternationalisationText($nAiO_languageResources, "IC_liens_mov_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_liens_mov_tip_title")  _
	)
	GUICtrlSetTip($LIENS_set, _
		getInternationalisationText($nAiO_languageResources, "IC_liens_set_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_liens_set_tip_title")  _
	)
	GUICtrlSetTip($LIENS_nok, _
		getInternationalisationText($nAiO_languageResources, "IC_liens_nok_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_liens_nok_tip_title")  _
	)
	GUICtrlSetTip($LIEN_alias_text, _
		getInternationalisationText($nAiO_languageResources, "IC_lien_alias_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_lien_alias_tip_title")  _
	)
	GUICtrlSetTip($LIEN_chemin_text, _
		getInternationalisationText($nAiO_languageResources, "IC_lien_chemin_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_lien_chemin_tip_title")  _
	)
	GUICtrlSetTip($LIEN_type_box, _
		getInternationalisationText($nAiO_languageResources, "IC_lien_type_box_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_lien_type_box_tip_title")  _
	)
	GUICtrlSetTip($LIEN_chemin_box, _
		getInternationalisationText($nAiO_languageResources, "IC_lien_chemin_box_tip_texte"), _
		getInternationalisationText($nAiO_languageResources, "IC_lien_chemin_box_tip_title")  _
	)
	#EndRegion

	; Onglet "Actions"
	GUICtrlCreateTabItem(getInternationalisationText($nAiO_languageResources, "IC_tab7"))
	#Region Items pour les paramtres de l'action customisable n1
	Local $ACTION1_cadre[4] = [11,60,$GUI_position[0]-11-12,146], $ACTION1_actionPreview = ""
	Local $ACTION1_group    = GUICtrlCreateGroup("",$ACTION1_cadre[0],$ACTION1_cadre[1],$ACTION1_cadre[2],$ACTION1_cadre[3])
	GUICtrlSetData($ACTION1_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_actions", 1)&" : ")
	; Champs pour le paramtrage
	Local $ACTION1_bouton_label   = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_label")&" :", _
									$ACTION1_cadre[0]+8,                         $ACTION1_cadre[1]+21,   $ACTION1_cadre[2]/4-20,   20)
	Local $ACTION1_bouton_text1   = GUICtrlCreateInput("", _
									$ACTION1_cadre[0]+1*$ACTION1_cadre[2]/4-16,  $ACTION1_cadre[1]+18,   $ACTION1_cadre[2]/4-48,   20)
	Local $ACTION1_bouton_text2   = GUICtrlCreateInput("", _
									$ACTION1_cadre[0]+2*$ACTION1_cadre[2]/4-58,  $ACTION1_cadre[1]+18,   $ACTION1_cadre[2]/4-48,   20)
	Local $ACTION1_bouton_text3   = GUICtrlCreateCombo("", _
									$ACTION1_cadre[0]+3*$ACTION1_cadre[2]/4-100, $ACTION1_cadre[1]+18,   $ACTION1_cadre[2]/4-8+50, 20)
	Local $ACTION1_bouton_text4   = GUICtrlCreateCheckbox("", _
									$ACTION1_cadre[0]+4*$ACTION1_cadre[2]/4-52,  $ACTION1_cadre[1]+18,   20,                       20)
	Local $ACTION1_preview_button = GUICtrlCreateButton("", _
									$ACTION1_cadre[0]+4*$ACTION1_cadre[2]/4-32,  $ACTION1_cadre[1]+16,   24,                       24)
	Local $ACTION1_tooltip_label  = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_actions_tooltip_label")&" :", _
									$ACTION1_cadre[0]+8,                         $ACTION1_cadre[1]+46,   $ACTION1_cadre[2]/4-20,   20)
	Local $ACTION1_tooltip_text1  = GUICtrlCreateInput("", _
									$ACTION1_cadre[0]+1*$ACTION1_cadre[2]/4-16,  $ACTION1_cadre[1]+43,   3*$ACTION1_cadre[2]/4+9,  20)
	Local $ACTION1_tooltip_text2  = GUICtrlCreateEdit("", _
									$ACTION1_cadre[0]+8, $ACTION1_cadre[1]+64,   $ACTION1_cadre[2]-16,                             50)
	Local $ACTION1_action_label   = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_actions_action_label")&" :", _
									$ACTION1_cadre[0]+8, $ACTION1_cadre[1]+122,  $ACTION1_cadre[2]/4-20,                           20)
	Local $ACTION1_action_text1   = GUICtrlCreateCombo("", _
									$ACTION1_cadre[0]+1*$ACTION1_cadre[2]/4-16,  $ACTION1_cadre[1]+119,  3*$ACTION1_cadre[2]/8,    20)
	Local $ACTION1_action_text2   = GUICtrlCreateInput("", _
									$ACTION1_cadre[0]+5*$ACTION1_cadre[2]/8-7,   $ACTION1_cadre[1]+119,  3*$ACTION1_cadre[2]/8,    20)
	; Update des items
	action_updateItems($listeActions, 1, $ACTION1_bouton_text1, $ACTION1_bouton_text2, $ACTION1_bouton_text3, $ACTION1_bouton_text4, $ACTION1_tooltip_text1, $ACTION1_tooltip_text2, $ACTION1_action_text1, $ACTION1_action_text2, $ACTION1_preview_button)
	GUICtrlSetBkColor($ACTION1_bouton_label,  $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ACTION1_tooltip_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ACTION1_action_label,  $GUI_BKCOLOR_TRANSPARENT)
	; Tooltips des items
	GUICtrlSetTip($ACTION1_bouton_text1,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip1"))
	GUICtrlSetTip($ACTION1_bouton_text2,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip2"))
	GUICtrlSetTip($ACTION1_bouton_text3,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip3"))
	GUICtrlSetTip($ACTION1_bouton_text4,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip4"))
	GUICtrlSetTip($ACTION1_tooltip_text1, getInternationalisationText($nAiO_languageResources, "IC_actions_tooltip_tip1"))
	GUICtrlSetTip($ACTION1_tooltip_text2, getInternationalisationText($nAiO_languageResources, "IC_actions_tooltip_tip2"))
	GUICtrlSetTip($ACTION1_action_text1,  getInternationalisationText($nAiO_languageResources, "IC_actions_action_tip1"))
	GUICtrlSetTip($ACTION1_action_text2,  getInternationalisationText($nAiO_languageResources, "IC_actions_action_tip2"))
	#EndRegion
	#Region Items pour les paramtres de l'action customisable n2
	Local $ACTION2_cadre[4] = [11,$GUI_position[1]-146-12,$GUI_position[0]-11-12,146], $ACTION2_actionPreview = ""
	Local $ACTION2_group    = GUICtrlCreateGroup("",$ACTION2_cadre[0],$ACTION2_cadre[1],$ACTION2_cadre[2],$ACTION2_cadre[3])
	GUICtrlSetData($ACTION2_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_actions", 2)&" : ")
	; Champs pour le paramtrage
	Local $ACTION2_bouton_label   = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_label")&" :", _
									$ACTION2_cadre[0]+8,                         $ACTION2_cadre[1]+21,   $ACTION2_cadre[2]/4-20,   20)
	Local $ACTION2_bouton_text1   = GUICtrlCreateInput("", _
									$ACTION2_cadre[0]+1*$ACTION2_cadre[2]/4-16,  $ACTION2_cadre[1]+18,   $ACTION2_cadre[2]/4-48,   20)
	Local $ACTION2_bouton_text2   = GUICtrlCreateInput("", _
									$ACTION2_cadre[0]+2*$ACTION2_cadre[2]/4-58,  $ACTION2_cadre[1]+18,   $ACTION2_cadre[2]/4-48,   20)
	Local $ACTION2_bouton_text3   = GUICtrlCreateCombo("", _
									$ACTION2_cadre[0]+3*$ACTION2_cadre[2]/4-100, $ACTION2_cadre[1]+18,   $ACTION2_cadre[2]/4-8+50, 20)
	Local $ACTION2_bouton_text4   = GUICtrlCreateCheckbox("", _
									$ACTION2_cadre[0]+4*$ACTION2_cadre[2]/4-52,  $ACTION2_cadre[1]+18,   20,                       20)
	Local $ACTION2_preview_button = GUICtrlCreateButton("", _
									$ACTION2_cadre[0]+4*$ACTION2_cadre[2]/4-32,  $ACTION2_cadre[1]+16,   24,                       24)
	Local $ACTION2_tooltip_label  = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_actions_tooltip_label")&" :", _
									$ACTION2_cadre[0]+8,                         $ACTION2_cadre[1]+46,   $ACTION2_cadre[2]/4-20,   20)
	Local $ACTION2_tooltip_text1  = GUICtrlCreateInput("", _
									$ACTION2_cadre[0]+1*$ACTION2_cadre[2]/4-16,  $ACTION2_cadre[1]+43,   3*$ACTION2_cadre[2]/4+9,  20)
	Local $ACTION2_tooltip_text2  = GUICtrlCreateEdit("", _
									$ACTION2_cadre[0]+8, $ACTION2_cadre[1]+64,   $ACTION2_cadre[2]-16,                             50)
	Local $ACTION2_action_label   = GUICtrlCreateLabel(getInternationalisationText($nAiO_languageResources, "IC_actions_action_label")&" :", _
									$ACTION2_cadre[0]+8, $ACTION2_cadre[1]+122,  $ACTION2_cadre[2]/4-20,                           20)
	Local $ACTION2_action_text1   = GUICtrlCreateCombo("", _
									$ACTION2_cadre[0]+1*$ACTION2_cadre[2]/4-16,  $ACTION2_cadre[1]+119,  3*$ACTION2_cadre[2]/8,    20)
	Local $ACTION2_action_text2   = GUICtrlCreateInput("", _
									$ACTION2_cadre[0]+5*$ACTION2_cadre[2]/8-7,   $ACTION2_cadre[1]+119,  3*$ACTION2_cadre[2]/8,    20)
	; Update des items
	action_updateItems($listeActions, 2, $ACTION2_bouton_text1, $ACTION2_bouton_text2, $ACTION2_bouton_text3, $ACTION2_bouton_text4, $ACTION2_tooltip_text1, $ACTION2_tooltip_text2, $ACTION2_action_text1, $ACTION2_action_text2, $ACTION2_preview_button)
	GUICtrlSetBkColor($ACTION2_bouton_label,  $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ACTION2_tooltip_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ACTION2_action_label,  $GUI_BKCOLOR_TRANSPARENT)
	; Tooltips des items
	GUICtrlSetTip($ACTION2_bouton_text1,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip1"))
	GUICtrlSetTip($ACTION2_bouton_text2,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip2"))
	GUICtrlSetTip($ACTION2_bouton_text3,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip3"))
	GUICtrlSetTip($ACTION2_bouton_text4,  getInternationalisationText($nAiO_languageResources, "IC_actions_bouton_tip4"))
	GUICtrlSetTip($ACTION2_tooltip_text1, getInternationalisationText($nAiO_languageResources, "IC_actions_tooltip_tip1"))
	GUICtrlSetTip($ACTION2_tooltip_text2, getInternationalisationText($nAiO_languageResources, "IC_actions_tooltip_tip2"))
	GUICtrlSetTip($ACTION2_action_text1,  getInternationalisationText($nAiO_languageResources, "IC_actions_action_tip1"))
	GUICtrlSetTip($ACTION2_action_text2,  getInternationalisationText($nAiO_languageResources, "IC_actions_action_tip2"))
	#EndRegion

	; Cloture du Tab-Container
	GUICtrlCreateTabItem("")

	#Region Donnes initiales pour les mises  jour controles
	Local $ACTION1_preview = _
		GUICtrlRead($ACTION1_bouton_text1)  & GUICtrlRead($ACTION1_bouton_text2)  & GUICtrlRead($ACTION1_bouton_text3)  & GUICtrlRead($ACTION1_bouton_text4)  & _
		GUICtrlRead($ACTION1_tooltip_text1) & GUICtrlRead($ACTION1_tooltip_text2) & GUICtrlRead($ACTION1_action_text1)  & GUICtrlRead($ACTION1_action_text2)
	Local $ACTION2_preview = _
		GUICtrlRead($ACTION2_bouton_text1)  & GUICtrlRead($ACTION2_bouton_text2)  & GUICtrlRead($ACTION2_bouton_text3)  & GUICtrlRead($ACTION2_bouton_text4)  & _
		GUICtrlRead($ACTION2_tooltip_text1) & GUICtrlRead($ACTION2_tooltip_text2) & GUICtrlRead($ACTION2_action_text1)  & GUICtrlRead($ACTION2_action_text2)
	Local $GUI_unappliedModifications_valeur_previous = _
		GUICtrlRead($GENERAL_timeout_text)  & GUICtrlRead($GENERAL_connexion_text)
	#EndRegion

	GUISetState(@SW_SHOW, $GUI)
	While True
		; Traitement des messages
		Local $msgGUI = GUIGetMsg()
		#Region Traitement des messages GUI pour les commandes gnrales
		Switch $msgGUI
		Case $GUI_EVENT_CLOSE, $GUI_QUITTER
			If BitAND(GUICtrlGetState($GUI_QUITTER),$GUI_ENABLE) = $GUI_ENABLE Then
				$nAiO_etat_stop = True
			Else
				GUISetState(@SW_DISABLE, $GUI)
				Local $retour = MsgBox(256+48+4, WinGetTitle($GUI), _
					getInternationalisationText($nAiO_languageResources, "IC_trt_edition_message"), _
					20, $GUI _
				)
				If $retour = 6 Then
					$nAiO_etat_stop = True
				EndIf
				GUISetState(@SW_ENABLE, $GUI)
			EndIf
		Case $IMPORTANT_password_text
			GUISetState(@SW_DISABLE, $GUI)
			Local $essai = 0, $ok = False
			If $nAiO_config_password = "" Then
				$ok = True
			Else
				While $essai < 3 And Not $ok
					$essai = $essai + 1
					Local $clef = InputBox( _
						getInternationalisationText($nAiO_languageResources, "IC_trt_profil_title1",getProfilNom(getProfilActuel()),$essai), _
						getInternationalisationText($nAiO_languageResources, "IC_trt_profil_texte1"), "", "*M20", _
						250,120,Default,Default, 60 _
					)
					If @error Then
						$essai = 3
					Else
						$ok = ($clef=$nAiO_config_password)
					EndIf
				WEnd
			EndIf
			If $ok Then
				Local $clef_1 = InputBox( _
					getInternationalisationText($nAiO_languageResources, "IC_trt_profil_title2",getProfilNom(getProfilActuel())), _
					getInternationalisationText($nAiO_languageResources, "IC_trt_profil_texte2"), "", "*M20", _
					250,120,Default,Default, 60 _
				)
				If @error = 0 Then
					Local $clef_2 = InputBox( _
						getInternationalisationText($nAiO_languageResources, "IC_trt_profil_title3",getProfilNom(getProfilActuel())), _
						getInternationalisationText($nAiO_languageResources, "IC_trt_profil_texte3"), "", "*M20", _
						250,120,Default,Default, 60 _
					)
					If $clef_1 = $clef_2 Then
						$nAiO_config_password = $clef_1
						GUICtrlSetData($IMPORTANT_password_text, getInternationalisationText($nAiO_languageResources, "IC_important_profil_protection_ok_modif",getProfilNom(getProfilActuel())))
						$GUI_unappliedModifications = True
					Else
						; Mauvaise confirmation
					EndIf
				ElseIf @error = 1 And $nAiO_config_password <> "" Then
					Local $confirmation = MsgBox(4+32, _
						getInternationalisationText($nAiO_languageResources, "IC_trt_profil_title3",getProfilNom(getProfilActuel())), _
						getInternationalisationText($nAiO_languageResources, "IC_trt_profil_texte4"), 30 _
					)
					If $confirmation = 6 Then
						$nAiO_config_password = ""
						GUICtrlSetData($IMPORTANT_password_text, getInternationalisationText($nAiO_languageResources, "IC_important_profil_protection_ko_modif",getProfilNom(getProfilActuel())))
						$GUI_unappliedModifications = True
					EndIf
				EndIf
			Else
				; Mauvais mot de passe actuel
			EndIf
			GUISetState(@SW_ENABLE, $GUI)
		Case $IMPORTANT_folder_text
			Local $retour = MsgBox(308, $nAiO_title&" v"&$nAiO_version, _
				getInternationalisationText($nAiO_languageResources, "IC_trt_dossierprofils_paragraphe1",$nAiO_repertoire_data) & _
				@CRLF & @CRLF & _
				getInternationalisationText($nAiO_languageResources, "IC_trt_dossierprofils_paragraphe2",$nAiO_repertoire_data) & _
				@CRLF & @CRLF & _
				getInternationalisationText($nAiO_languageResources, "IC_trt_dossierprofils_paragraphe3",$nAiO_repertoire_data) & _
				@CRLF & @CRLF & _
				getInternationalisationText($nAiO_languageResources, "IC_trt_dossierprofils_paragraphe4",$nAiO_repertoire_data) & _
				"", 60 _
			)
			If $retour = 6 Then ShellExecute($nAiO_repertoire_data)
		Case $GUI_CLOCK
			Local $now = _NowCalc()
			If getListeAlertesLength($nAiO_alertes_to_display) = 0 Then
				Local $nextAlertes = getNextAlertesInListAt($listeAlertesOriginales, $now)
				Local $diffFromNow = @extended
				If getListeAlertesLength($nextAlertes) > 0 Then
					; Affiche
					Local _
						$trigger = _DateAdd("s", $diffFromNow, $now), _
						$errorTriggerDate   = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_date_format_error"), _
						$formatTriggerDate  = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_date_format"), _
						$errorTriggerDelay  = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_delay_format_error"), _
						$formatTriggerDelay = getInternationalisationText($nAiO_languageResources, "NAIO_trigger_delay_format")
					Local _
						$triggerAsDate  = getAlerteTriggerAsDate($trigger,$errorTriggerDate,$formatTriggerDate), _
						$triggerAsDelay = getAlerteTriggerAsDelay($diffFromNow,$errorTriggerDelay)
					If getListeAlertesLength($nextAlertes) > 1 Then
						Local $texte = ""
						For $i = 1 To getListeAlertesLength($nextAlertes)
							Local $alerte = getAlerteInListAt($nextAlertes,$i)
							$texte = $texte & cond($i>1,", ","") & "'" & getAlerteTitle($alerte) & "'"
						Next
						$texte = StringReplace($texte, ", ", " et ",-1)
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_title"), _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_submessage", $triggerAsDate, $triggerAsDelay) & @CRLF & @CRLF & _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_message_pluriel", $texte), _
							30,1 _
						)
					Else
						Local $alerte = getAlerteInListAt($nextAlertes,1)
						Local $texte = "'" & getAlerteTitle($alerte) & "'"
						TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_title"), _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_submessage", $triggerAsDate, $triggerAsDelay) & @CRLF & @CRLF & _
							getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_message", $texte), _
							30,1 _
						)
					EndIf
				Else
					; Aucun
					TrayAdvancedDisplayMessage($TRAY, $nAiO_title&" v"&$nAiO_version&" - "&getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_title"), _
						getInternationalisationText($nAiO_languageResources, "IP_principal_agenda_message_aucun"), _
						30,2 _
					)
				EndIf
			Else
				GUICtrlSetColor($GUI_CLOCK, 0x000000)
				If IsDeclared("Label_HHMM") Then GUICtrlSetColor($Label_HHMM, 0x000000)
				$last_time_Alertes_en_cours = @YEAR&@MON&@MDAY&@HOUR&@MIN&@SEC
				If @SEC > 0 Then deleteListeAlertes($nAiO_alertes_to_display)
			EndIf
		Case Else
			; Dsactivation en mode dition
			Local $state = cond(Not $COMPTES_modeEdition And Not $MULTIS_modeEdition And Not $ALERTES_modeEdition And Not $LIENS_modeEdition, $GUI_ENABLE, $GUI_DISABLE)
			If BitAND(GUICtrlGetState($GUI_QUITTER),$state) = 0 Then GUICtrlSetState($GUI_QUITTER,$state)
			; Affichage de l'horaire
			If Not IsDeclared("horaire") Then Local $horaire = -1
			If $horaire <> @HOUR&":"&@MIN&":"&@SEC Then ; Actualise toutes les demi-secondes
				$horaire = @HOUR&":"&@MIN&":"&@SEC
				GUICtrlSetData($GUI_CLOCK, @HOUR&":"&@MIN&":"&@SEC)
			EndIf
			If $nAiO_etat_stop Then
				$nAiO_etat_stop = False
				If $GUI_unappliedModifications Then
					GUISetState(@SW_DISABLE, $GUI)
					Local $retour = MsgBox(512+48+3, WinGetTitle($GUI), _
						getInternationalisationText($nAiO_languageResources, "IC_trt_sauvegarder_message"), _
						20, $GUI _
					)
					If $retour = 7 Then
						$GUI_restartRequired = False
						$GUI_unappliedModifications = False
					ElseIf $retour = 6 Then
 						saveData( _
							$nAiO_config_password, $nAiO_profil_password,  _
							$listeComptes, $listeMultis, $listeParametres, _
							$listeAlertes, $listeModules, $listeLiens,     _
							$listeActions, $GENERAL_timeout_text, $tray    _
						)
						$GUI_unappliedModifications = False
					EndIf
					GUISetState(@SW_ENABLE, $GUI)
				EndIf
				If Not $GUI_unappliedModifications Then ExitLoop
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour l'dition de comptes
		Switch $msgGUI
		Case $COMPTES_add	; Choix > Edition
			Local $check = "" ; Nombre maximum de comptes?
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_add_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($COMPTES_comboBox, $GUI_DISABLE)
				GUICtrlSetState($COMPTES_add, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_get, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_del, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_mov, $GUI_HIDE+$GUI_DISABLE)
				; Ajout item vierge dans $listeComptes
				addToListeComptes($listeComptes, newCompte(0,"# Compte #","","",""))
				; Mise  jour de la liste dans $COMPTES_comboBox
				compte_updateComboBoxAndContextMenu($listeComptes, $COMPTES_comboBox, $COMPTES_mov_liste)
				; Effacement des champs
				GUICtrlSetData($COMPTE_alias_text,  "")
				GUICtrlSetData($COMPTE_avatar_text, "")
				GUICtrlSetData($COMPTE_login_text,  "")
				GUICtrlSetData($COMPTE_pass_text,   "")
				GUICtrlSetData($COMPTE_key_text,    "")
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($COMPTES_set, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($COMPTES_nok, $GUI_SHOW+$GUI_ENABLE)
				For $item In $COMPTE_items_pour_modelisation
					GUICtrlSetState($item, $GUI_ENABLE)
				Next
				GUICtrlSetState($COMPTE_avatar_box, $GUI_ENABLE)
				$COMPTES_modeEdition = True
				GUICtrlSetData($COMPTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_comptes")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $COMPTES_get	; Choix > Edition
			Local $compte_toString = GUICtrlRead($COMPTES_comboBox)
			Local $check = compte_checkItemExistence($listeComptes, $compte_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_get_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE
				GUICtrlSetState($COMPTES_comboBox, $GUI_DISABLE)
				GUICtrlSetState($COMPTES_add, $GUI_DISABLE)
				GUICtrlSetState($COMPTES_get, $GUI_DISABLE)
				GUICtrlSetState($COMPTES_del, $GUI_DISABLE)
				GUICtrlSetState($COMPTES_mov, $GUI_DISABLE)
				; Edition item de $listeComptes
				Local $compte = getCompteInListFromToString($listeComptes, $compte_toString)
				Local $key = $DEFAULT_Key, $error = 0
				If isCompteLockedByKey($compte) Then
					$key = InputBox( _
						getInternationalisationText($nAiO_languageResources, "IC_trt_compte_msg_title", getCompteAlias($compte)), _
						getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_get_demande_clef_texte"), "", "*M8", _
						200, 120, Default, Default, 30 _
					)
					$error = @error
				EndIf
				If $error = 0 Then
					If Not checkCompteWithKey($compte,$key) Then $key = ""
					GUICtrlSetData($COMPTE_alias_text,  getCompteAlias($compte))
					GUICtrlSetData($COMPTE_avatar_text, getCompteAvatar($compte))
					If $key <> "" Then
						GUICtrlSetData($COMPTE_login_text,  getCompteLogin($compte,$key))
						GUICtrlSetData($COMPTE_pass_text,   getComptePass($compte,$key))
						GUICtrlSetData($COMPTE_key_text,    cond($key=$DEFAULT_Key,"",$key))
					EndIf
					; Switch choix>dition ENABLE/SHOW
					GUICtrlSetState($COMPTES_add, $GUI_HIDE)
					GUICtrlSetState($COMPTES_get, $GUI_HIDE)
					GUICtrlSetState($COMPTES_del, $GUI_HIDE)
					GUICtrlSetState($COMPTES_mov, $GUI_HIDE)
					GUICtrlSetState($COMPTES_set, $GUI_SHOW+cond($key<>"",$GUI_ENABLE,$GUI_DISABLE))
					GUICtrlSetState($COMPTES_nok, $GUI_SHOW+$GUI_ENABLE)
					For $item In $COMPTE_items_pour_modelisation
						GUICtrlSetState($item, cond($key<>"",$GUI_ENABLE,$GUI_DISABLE))
					Next
					GUICtrlSetState($COMPTE_avatar_box, cond($key<>"",$GUI_ENABLE,$GUI_DISABLE))
					$COMPTES_modeEdition = True
					GUICtrlSetData($COMPTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_comptes")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
				Else
					; Switch choix>choix ENABLE
					GUICtrlSetState($COMPTES_comboBox, $GUI_ENABLE)
					GUICtrlSetState($COMPTES_add, $GUI_ENABLE)
					GUICtrlSetState($COMPTES_get, $GUI_ENABLE)
					GUICtrlSetState($COMPTES_del, $GUI_ENABLE)
					GUICtrlSetState($COMPTES_mov, $GUI_ENABLE)
				EndIf
			EndIf
		Case $COMPTES_del	; Choix > Choix
			GUICtrlSetState($COMPTES_comboBox, $GUI_DISABLE)
			Local $valueToDelete = GUICtrlRead($COMPTES_comboBox)
			GUICtrlAdvancedMenuItemSetText($COMPTES_del_confirm, getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_del_confirm_texte", $valueToDelete))
			sousmenu($GUI, $COMPTES_del, $COMPTES_del_menu)
			GUICtrlSetState($COMPTES_comboBox, $GUI_ENABLE)
		Case $COMPTES_del_confirm
			Local $compte_toString = GUICtrlRead($COMPTES_comboBox)
			Local $check = compte_checkItemExistence($listeComptes, $compte_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_del_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($COMPTES_comboBox, $GUI_DISABLE)
				GUICtrlSetState($COMPTES_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_nok, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_add, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_get, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_del, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_mov, $GUI_SHOW+$GUI_DISABLE)
				For $item In $COMPTE_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
					GUICtrlSetData($item, "")
				Next
				GUICtrlSetState($COMPTE_avatar_box, $GUI_DISABLE)
				; Suppression item dans $listeComptes
				delInListeComptesFromToString($listeComptes, $compte_toString)
				; Mise  jour de la liste dans $COMPTES_comboBox
				compte_updateComboBoxAndContextMenu($listeComptes, $COMPTES_comboBox, $COMPTES_mov_liste)
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($COMPTES_comboBox, cond(getListeComptesLength($listeComptes) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($COMPTES_get, cond(getListeComptesLength($listeComptes) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($COMPTES_add, $GUI_ENABLE)
				GUICtrlSetState($COMPTES_del, cond(getListeComptesLength($listeComptes) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($COMPTES_mov, $GUI_SHOW+cond(getListeComptesLength($listeComptes) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$GUI_unappliedModifications = True
			EndIf
		Case $COMPTES_mov	; Choix > Choix
			GUICtrlSetState($COMPTES_comboBox, $GUI_DISABLE)
			Local $valueToCheck = GUICtrlRead($COMPTES_comboBox)
			For $i = 1 To UBound($COMPTES_mov_liste)-1
				GUICtrlSetState($COMPTES_mov_liste[$i], cond(GUICtrlAdvancedMenuItemGetText($COMPTES_mov_liste[$i])=$valueToCheck,$GUI_DISABLE,$GUI_ENABLE))
			Next
			sousmenu($GUI, $COMPTES_mov, $COMPTES_mov_liste[0])
			GUICtrlSetState($COMPTES_comboBox, $GUI_ENABLE)
		Case $COMPTES_set	; Edition > Choix
			Local $compte_toString = GUICtrlRead($COMPTES_comboBox)
			Local $check = compte_checkItemCoherency($COMPTE_alias_text,$COMPTE_avatar_text,$COMPTE_login_text,$COMPTE_pass_text,$COMPTE_key_text)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_set_error"), $check, 30, 3)
			Else
				; Switch dition>choix DISABLE/HIDE
				GUICtrlSetState($COMPTES_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($COMPTES_nok, $GUI_HIDE+$GUI_DISABLE)
				For $item In $COMPTE_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
				Next
				GUICtrlSetState($COMPTE_avatar_box, $GUI_DISABLE)
				; Modification item dans $listeComptes
				Local $key = GUICtrlRead($COMPTE_key_text)
				If $key = "" Then $key = $DEFAULT_Key
				setCompteInListFromToString($listeComptes, $compte_toString, GUICtrlRead($COMPTE_alias_text),GUICtrlRead($COMPTE_avatar_text),GUICtrlRead($COMPTE_login_text),GUICtrlRead($COMPTE_pass_text), $key)
				; Mise  jour de la liste dans $COMPTES_comboBox
				compte_updateComboBoxAndContextMenu($listeComptes, $COMPTES_comboBox, $COMPTES_mov_liste, True)
				; Switch dition>choix ENABLE/SHOW
				GUICtrlSetState($COMPTES_comboBox, $GUI_ENABLE)
				GUICtrlSetState($COMPTES_add, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($COMPTES_get, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($COMPTES_del, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($COMPTES_mov, $GUI_SHOW+cond(getListeComptesLength($listeComptes) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$compte_en_consultation_previous = ""
				$COMPTES_modeEdition = False
				GUICtrlSetData($COMPTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_comptes")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $COMPTES_nok	; Edition > Choix
			; Switch dition>choix DISABLE/HIDE
			GUICtrlSetState($COMPTES_set, $GUI_HIDE+$GUI_DISABLE)
			GUICtrlSetState($COMPTES_nok, $GUI_HIDE+$GUI_DISABLE)
			For $item In $COMPTE_items_pour_modelisation
				GUICtrlSetState($item, $GUI_DISABLE)
				GUICtrlSetData($item, "")
			Next
			GUICtrlSetState($COMPTE_avatar_box, $GUI_DISABLE)
			; Mise  jour de la liste dans $COMPTES_comboBox
			compte_updateComboBoxAndContextMenu($listeComptes, $COMPTES_comboBox, $COMPTES_mov_liste, True)
			; Switch dition>choix ENABLE/SHOW
			GUICtrlSetState($COMPTES_comboBox, $GUI_ENABLE)
			GUICtrlSetState($COMPTES_add, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($COMPTES_get, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($COMPTES_del, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($COMPTES_mov, $GUI_SHOW+cond(getListeComptesLength($listeComptes) < 2,$GUI_DISABLE,$GUI_ENABLE))
			$compte_en_consultation_previous = ""
			$COMPTES_modeEdition = False
			GUICtrlSetData($COMPTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_comptes")&" : ")
		Case $COMPTE_avatar_box ; Edition > Edition
			GUICtrlSetState($COMPTES_set, $GUI_DISABLE)
			GUICtrlSetState($COMPTES_nok, $GUI_DISABLE)
			For $item In $COMPTE_items_pour_modelisation
				GUICtrlSetState($item, $GUI_DISABLE)
			Next
			GUICtrlSetState($COMPTE_avatar_box, $GUI_DISABLE)
			Local $compte_toString = GUICtrlRead($COMPTES_comboBox)
			; "Smaphore" pour exclure les bidouillages pendant l'affichage de la seconde fentre
			GUISetState(@SW_DISABLE, $GUI)
			Local $result = FileOpenDialog( _
				getInternationalisationText($nAiO_languageResources, "IC_trt_compte_avatar_dialog_title", $compte_toString), _
				@ScriptDir, "JPEG (*.jpe?g)|Bitmap (*.bmp)|Icone (*.ico)", _
				1, "", $GUI _
			)
			If @error = 0 Then GUICtrlSetData($COMPTE_avatar_text, $result)
			GUISetState(@SW_ENABLE, $GUI)
			; "Smaphore" relach
			GUICtrlSetState($COMPTES_set, $GUI_ENABLE)
			GUICtrlSetState($COMPTES_nok, $GUI_ENABLE)
			For $item In $COMPTE_items_pour_modelisation
				GUICtrlSetState($item, $GUI_ENABLE)
			Next
			GUICtrlSetState($COMPTE_avatar_box, $GUI_ENABLE)
		Case Else
			For $i = 1 To UBound($COMPTES_mov_liste)-1
				If $msgGUI = $COMPTES_mov_liste[$i] And IsInt($COMPTES_mov_liste[$i]) Then
					Local $compte_toString = GUICtrlRead($COMPTES_comboBox)
					Local $check = compte_checkItemExistence($listeComptes, $compte_toString)
					If $check <> "" Then
						TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_comptes_mov_error"), $check, 30, 3)
						Sleep(1000)
					Else
						; Switch choix>dition DISABLE/HIDE
						GUICtrlSetState($COMPTES_comboBox, $GUI_DISABLE)
						GUICtrlSetState($COMPTES_set, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($COMPTES_nok, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($COMPTES_add, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($COMPTES_get, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($COMPTES_del, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($COMPTES_mov, $GUI_SHOW+$GUI_DISABLE)
						For $item In $COMPTE_items_pour_modelisation
							GUICtrlSetState($item, $GUI_DISABLE)
							GUICtrlSetData($item, "")
						Next
						GUICtrlSetState($COMPTE_avatar_box, $GUI_DISABLE)
						; Suppression item dans $listeComptes
						Local $compte_toString_fromContext = GUICtrlAdvancedMenuItemGetText($msgGUI)
						moveInListeComptesFromToString($listeComptes, $compte_toString, $compte_toString_fromContext)
						; Mise  jour de la liste dans $COMPTES_comboBox
						compte_updateComboBoxAndContextMenu($listeComptes, $COMPTES_comboBox, $COMPTES_mov_liste, True)
						; Switch choix>dition ENABLE/SHOW
						GUICtrlSetState($COMPTES_comboBox, cond(getListeComptesLength($listeComptes) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($COMPTES_get, cond(getListeComptesLength($listeComptes) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($COMPTES_add, $GUI_ENABLE)
						GUICtrlSetState($COMPTES_del, cond(getListeComptesLength($listeComptes) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($COMPTES_mov, $GUI_SHOW+cond(getListeComptesLength($listeComptes) < 2,$GUI_DISABLE,$GUI_ENABLE))
						$GUI_unappliedModifications = True
					EndIf
				EndIf
			Next
			; Mise  jour automatique du champ avatar
			Local $COMPTE_avatar_text_color_to_apply = 0x000000
			If BitAND(GUICtrlGetState($COMPTE_avatar_text),$GUI_ENABLE) = $GUI_ENABLE And GUICtrlGetHandle($COMPTE_avatar_text) <> ControlGetHandle($GUI,"",ControlGetFocus($GUI)) Then
				If FileExists(GUICtrlRead($COMPTE_avatar_text)) And StringRegExp(GUICtrlRead($COMPTE_avatar_text),"\.(?i)(jpe?g|ico|bmp)$") Then
					$COMPTE_avatar_text_color_to_apply = 0x009900
				Else
					$COMPTE_avatar_text_color_to_apply = 0xBB0000
				EndIf
			EndIf
			If $COMPTE_avatar_text_color <> $COMPTE_avatar_text_color_to_apply Then
				$COMPTE_avatar_text_color = $COMPTE_avatar_text_color_to_apply
				GUICtrlSetColor($COMPTE_avatar_text, $COMPTE_avatar_text_color)
			EndIf
			; Mise  jour pour consultation
			If Not $COMPTES_modeEdition Then
				Local $compte_en_consultation_previous, $compte_en_consultation = GUICtrlRead($COMPTES_comboBox)
				If Not IsDeclared("compte_en_consultation_previous") Or $compte_en_consultation <> $compte_en_consultation_previous Then
					$compte_en_consultation_previous = $compte_en_consultation
					Local $compte = getCompteInListFromToString($listeComptes, $compte_en_consultation)
					If isCompte($compte) Then
						Local $protected = isCompteLockedByKey($compte)
						GUICtrlSetData($COMPTE_alias_text,  getCompteAlias($compte))
						GUICtrlSetData($COMPTE_avatar_text, getCompteAvatar($compte))
						GUICtrlSetData($COMPTE_login_text,  getCompteLogin($compte))
						GUICtrlSetData($COMPTE_pass_text,   getComptePass($compte))
						GUICtrlSetData($COMPTE_key_text,    cond($protected,"",""))
					EndIf
				EndIf
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour l'dition de multis
		Switch $msgGUI
		Case $MULTIS_add				; Choix > Edition
			Local $check = "" ; Nombre maximum de multis?
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_multis_add_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($MULTIS_comboBox, $GUI_DISABLE)
				GUICtrlSetState($MULTIS_add, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_get, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_del, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_mov, $GUI_HIDE+$GUI_DISABLE)
				Local $newMulti = newMulti(0,"# Multi #","")
				; Ajout item vierge dans $listeMultis
				addToListeMultis($listeMultis, $newMulti)
				; Mise  jour de la liste dans $MULTIS_comboBox
				multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $MULTIS_comboBox, $MULTI_custom_text, $MULTIS_mov_liste, $MULTI_comptes_list)
				; Effacement des champs
				GUICtrlSetData($MULTI_alias_text,    "")
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($MULTIS_set, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($MULTIS_nok, $GUI_SHOW+$GUI_ENABLE)
				For $item In $MULTI_items_pour_modelisation
					GUICtrlSetState($item, $GUI_ENABLE)
				Next
				GUICtrlSetState($MULTI_comptes_list,        $GUI_ENABLE)
				GUICtrlSetState($MULTI_comptes_list_MoveUp, $GUI_ENABLE)
				GUICtrlSetState($MULTI_comptes_list_Insert, $GUI_ENABLE)
				GUICtrlSetState($MULTI_comptes_list_Delete, $GUI_ENABLE)
				GUICtrlSetState($MULTI_comptes_list_MoveDn, $GUI_ENABLE)
				multi_updateListViewForListing($newMulti, $MULTI_comptes_list, $MULTI_comptes_listitems, $MULTI_comptes_items, $listeComptes)
				$MULTIS_modeEdition = True
				GUICtrlSetData($MULTIS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_multis")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $MULTIS_get				; Choix > Edition
			Local $multi_toString = GUICtrlRead($MULTIS_comboBox)
			Local $check = multi_checkItemExistence($listeMultis, $multi_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_multis_get_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE
				GUICtrlSetState($MULTIS_comboBox, $GUI_DISABLE)
				GUICtrlSetState($MULTIS_add, $GUI_DISABLE)
				GUICtrlSetState($MULTIS_get, $GUI_DISABLE)
				GUICtrlSetState($MULTIS_del, $GUI_DISABLE)
				GUICtrlSetState($MULTIS_mov, $GUI_DISABLE)
				; Edition item de $listeMultis
				Local $multi = getMultiInListFromToString($listeMultis, $multi_toString)
				If isMulti($multi) Then
					Local $newListing = cleanMultiListingWithListeComptes(getMultiListing($multi), $listeComptes)
					If $newListing <> getMultiListing($multi) Then
						TrayAdvancedDisplayMessage($tray,  _
							getInternationalisationText($nAiO_languageResources, "IC_trt_multi_msg_title", $multi_toString), _
							getInternationalisationText($nAiO_languageResources, "IC_trt_multi_get_listing_warning"), _
							30, 2 _
						)
					EndIf
					setMultiListing($multi,$newListing)
					Local $size = getMultiListingSize($multi)
					GUICtrlSetData($MULTI_alias_text, getMultiAlias($multi))
					; Switch choix>dition ENABLE/SHOW
					GUICtrlSetState($MULTIS_add, $GUI_HIDE)
					GUICtrlSetState($MULTIS_get, $GUI_HIDE)
					GUICtrlSetState($MULTIS_del, $GUI_HIDE)
					GUICtrlSetState($MULTIS_mov, $GUI_HIDE)
					GUICtrlSetState($MULTIS_set, $GUI_SHOW+$GUI_ENABLE)
					GUICtrlSetState($MULTIS_nok, $GUI_SHOW+$GUI_ENABLE)
					For $item In $MULTI_items_pour_modelisation
						GUICtrlSetState($item, $GUI_ENABLE)
					Next
					GUICtrlSetState($MULTI_comptes_list,        $GUI_ENABLE)
					GUICtrlSetState($MULTI_comptes_list_MoveUp, $GUI_ENABLE)
					GUICtrlSetState($MULTI_comptes_list_Insert, $GUI_ENABLE)
					GUICtrlSetState($MULTI_comptes_list_Delete, $GUI_ENABLE)
					GUICtrlSetState($MULTI_comptes_list_MoveDn, $GUI_ENABLE)
					multi_updateListViewForListing($multi, $MULTI_comptes_list, $MULTI_comptes_listitems, $MULTI_comptes_items, $listeComptes)
					$MULTIS_modeEdition = True
					GUICtrlSetData($MULTIS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_multis")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
				Else
					; Switch choix>choix ENABLE
					GUICtrlSetState($MULTIS_comboBox, $GUI_ENABLE)
					GUICtrlSetState($MULTIS_add, $GUI_ENABLE)
					GUICtrlSetState($MULTIS_get, $GUI_ENABLE)
					GUICtrlSetState($MULTIS_del, $GUI_ENABLE)
					GUICtrlSetState($MULTIS_mov, $GUI_ENABLE)
				EndIf
			EndIf
		Case $MULTIS_del				; Choix > Choix
			GUICtrlSetState($MULTIS_comboBox, $GUI_DISABLE)
			Local $valueToDelete = GUICtrlRead($MULTIS_comboBox)
			GUICtrlAdvancedMenuItemSetText($MULTIS_del_confirm, getInternationalisationText($nAiO_languageResources, "IC_trt_multis_del_confirm_texte", $valueToDelete))
			sousmenu($GUI, $MULTIS_del, $MULTIS_del_menu)
			GUICtrlSetState($MULTIS_comboBox, $GUI_ENABLE)
		Case $MULTIS_del_confirm		; Choix > Choix
			Local $multi_toString = GUICtrlRead($MULTIS_comboBox)
			Local $check = multi_checkItemExistence($listeMultis, $multi_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_multis_del_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($MULTIS_comboBox, $GUI_DISABLE)
				GUICtrlSetState($MULTIS_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_nok, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_add, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_get, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_del, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_mov, $GUI_SHOW+$GUI_DISABLE)
				For $item In $MULTI_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
					GUICtrlSetData($item, "")
				Next
				GUICtrlSetState($MULTI_comptes_list,       $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_MoveUp, $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_Insert, $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_Delete, $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_MoveDn, $GUI_DISABLE)
				; Suppression item dans $listeMultis
				delInListeMultisFromToString($listeMultis, $multi_toString)
				; Mise  jour de la liste dans $MULTIS_comboBox
				multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $MULTIS_comboBox, $MULTI_custom_text, $MULTIS_mov_liste, $MULTI_comptes_list)
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($MULTIS_comboBox, cond(getListeMultisLength($listeMultis) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($MULTIS_get, cond(getListeMultisLength($listeMultis) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($MULTIS_add, $GUI_ENABLE)
				GUICtrlSetState($MULTIS_del, cond(getListeMultisLength($listeMultis) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($MULTIS_mov, $GUI_SHOW+cond(getListeMultisLength($listeMultis) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$GUI_unappliedModifications = True
			EndIf
		Case $MULTIS_mov				; Choix > Choix
			GUICtrlSetState($MULTIS_comboBox, $GUI_DISABLE)
			Local $valueToCheck = GUICtrlRead($MULTIS_comboBox)
			For $i = 1 To UBound($MULTIS_mov_liste)-1
				GUICtrlSetState($MULTIS_mov_liste[$i], cond(GUICtrlAdvancedMenuItemGetText($MULTIS_mov_liste[$i])=$valueToCheck,$GUI_DISABLE,$GUI_ENABLE))
			Next
			sousmenu($GUI, $MULTIS_mov, $MULTIS_mov_liste[0])
			GUICtrlSetState($MULTIS_comboBox, $GUI_ENABLE)
		Case $MULTIS_set				; Edition > Choix
			Local $multi_toString = GUICtrlRead($MULTIS_comboBox)
			Local $check = multi_checkItemCoherency($MULTI_alias_text,$MULTI_comptes_listitems,$listeComptes)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_multis_set_error"), $check, 30, 3)
			Else
				; Switch dition>choix DISABLE/HIDE
				GUICtrlSetState($MULTIS_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($MULTIS_nok, $GUI_HIDE+$GUI_DISABLE)
				For $item In $MULTI_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
				Next
				GUICtrlSetState($MULTI_comptes_list,       $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_MoveUp, $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_Insert, $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_Delete, $GUI_DISABLE)
				GUICtrlSetState($MULTI_comptes_list_MoveDn, $GUI_DISABLE)
				; Modification item dans $listeMultis
				Local $newMulti = getMultiInListFromToString($listeMultis, $multi_toString)
				setMultiListing($newMulti,"")
				For $i = 1 To $MULTI_comptes_listitems[0]
					Local $toString = StringTrimRight(GUICtrlRead($MULTI_comptes_listitems[$i]),1)
					Local $compte   = getCompteInListFromToString($listeComptes, $toString)
					If isCompte($compte) Then addCompteToMultiListing($newMulti, $compte)
				Next
				setMultiInListFromToString($listeMultis, $multi_toString, GUICtrlRead($MULTI_alias_text), getMultiListing($newMulti))
				; Mise  jour de la liste dans $MULTIS_comboBox
				multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $MULTIS_comboBox, $MULTI_custom_text, $MULTIS_mov_liste, $MULTI_comptes_list, True)
				; Switch dition>choix ENABLE/SHOW
				GUICtrlSetState($MULTIS_comboBox, $GUI_ENABLE)
				GUICtrlSetState($MULTIS_add, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($MULTIS_get, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($MULTIS_del, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($MULTIS_mov, $GUI_SHOW+cond(getListeMultisLength($listeMultis) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$multi_en_consultation_previous = ""
				$MULTIS_modeEdition = False
				GUICtrlSetData($MULTIS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_multis")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $MULTIS_nok				; Edition > Choix
			; Switch dition>choix DISABLE/HIDE
			GUICtrlSetState($MULTIS_set, $GUI_HIDE+$GUI_DISABLE)
			GUICtrlSetState($MULTIS_nok, $GUI_HIDE+$GUI_DISABLE)
			For $item In $MULTI_items_pour_modelisation
				GUICtrlSetState($item, $GUI_DISABLE)
				GUICtrlSetData($item, "")
			Next
			GUICtrlSetState($MULTI_comptes_list,       $GUI_DISABLE)
			GUICtrlSetState($MULTI_comptes_list_MoveUp, $GUI_DISABLE)
			GUICtrlSetState($MULTI_comptes_list_Insert, $GUI_DISABLE)
			GUICtrlSetState($MULTI_comptes_list_Delete, $GUI_DISABLE)
			GUICtrlSetState($MULTI_comptes_list_MoveDn, $GUI_DISABLE)
			; Mise  jour de la liste dans $MULTIS_comboBox
			multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $MULTIS_comboBox, $MULTI_custom_text, $MULTIS_mov_liste, $MULTI_comptes_list, True)
			; Switch dition>choix ENABLE/SHOW
			GUICtrlSetState($MULTIS_comboBox,        $GUI_ENABLE)
			GUICtrlSetState($MULTIS_add, $GUI_SHOW + $GUI_ENABLE)
			GUICtrlSetState($MULTIS_get, $GUI_SHOW + $GUI_ENABLE)
			GUICtrlSetState($MULTIS_del, $GUI_SHOW + $GUI_ENABLE)
			GUICtrlSetState($MULTIS_mov, $GUI_SHOW + cond(getListeMultisLength($listeMultis) < 2,$GUI_DISABLE,$GUI_ENABLE))
			$multi_en_consultation_previous = ""
			$MULTIS_modeEdition = False
			GUICtrlSetData($MULTIS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_multis")&" : ")
		Case $MULTI_comptes_list_Insert	; Edition > Edition
			sousmenu($GUI, $MULTI_comptes_list, $MULTI_comptes_items[0])
		Case $MULTI_comptes_list_Delete	; Edition > Edition
			For $i = 1 To $MULTI_comptes_listitems[0]
				If _GUICtrlListView_GetItemSelected($MULTI_comptes_list, $i-1) Then
					Local $compteFromContextLabel = getCompteInListFromToString($listeComptes, StringTrimRight(GUICtrlRead($MULTI_comptes_listitems[$i]),1))
					Local $multiToGet = getMultiInListFromToString($listeMultis,GUICtrlRead($MULTIS_comboBox))
					Local $multiToSet = copyMulti($multiToGet)
					If isMulti($multiToSet) And isCompte($compteFromContextLabel) Then
						setMultiListing($multiToSet,"")
						For $j = 1 To $MULTI_comptes_listitems[0]
							Local $texte = StringTrimRight(GUICtrlRead($MULTI_comptes_listitems[$j]),1)
							Local $compteFromListViewItem = getCompteInListFromToString($listeComptes, $texte)
							If isCompte($compteFromListViewItem) Then
								addCompteToMultiListing($multiToSet, $compteFromListViewItem)
							EndIf
						Next
						delCompteFromMultiListing($multiToSet, $compteFromContextLabel)
						multi_updateListViewForListing($multiToSet, $MULTI_comptes_list, $MULTI_comptes_listitems, $MULTI_comptes_items, $listeComptes)
					EndIf
					ExitLoop
				EndIf
			Next
		Case $MULTI_comptes_list_MoveDn, $MULTI_comptes_list_MoveUp
			Local $multiToSet = getMultiInListFromToString($listeMultis,GUICtrlRead($MULTIS_comboBox))
			If isMulti($multiToSet) Then
				Local $selected = ""
				For $i = 1 To $MULTI_comptes_listitems[0]
					If _GUICtrlListView_GetItemSelected($MULTI_comptes_list, $i-1) Then
						If $selected = "" Then
							$selected = StringTrimRight(GUICtrlRead($MULTI_comptes_listitems[$i]),1)
						Else
							$selected = ""
							ExitLoop
						EndIf
					EndIf
				Next
				If $selected = "" Then
					For $i = 1 To $MULTI_comptes_listitems[0]
						_GUICtrlListView_SetItemSelected($MULTI_comptes_list, $i-1, False)
					Next
				Else
					For $i = 1 To $MULTI_comptes_listitems[0]
						Local $texte = StringTrimRight(GUICtrlRead($MULTI_comptes_listitems[$i]),1)
						If _GUICtrlListView_GetItemSelected($MULTI_comptes_list, $i-1) Then
							Local $destination = $i
							If $msgGUI = $MULTI_comptes_list_MoveUp And $i > 1 Then
								$destination = $destination - 1
							ElseIf $msgGUI = $MULTI_comptes_list_MoveDn And $i < $MULTI_comptes_listitems[0] Then
								$destination = $destination + 1
							EndIf
							Local $texteDestination = StringTrimRight(GUICtrlRead($MULTI_comptes_listitems[$destination]),1)
							GUICtrlSetData($MULTI_comptes_listitems[$destination], $selected)
							GUICtrlSetData($MULTI_comptes_listitems[$i], $texteDestination)
							_GUICtrlListView_SetItemSelected($MULTI_comptes_list, $destination-1)
							ExitLoop
						EndIf
					Next
				EndIf
			EndIf
		Case $MULTI_custom_text
			setParametreValeurInListFromClef($listeParametres, "CustomMulti", cond(getParametreValeurInListFromClef($listeParametres, "CustomMulti")="Y","N","Y"))
			multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $MULTIS_comboBox, $MULTI_custom_text, $MULTIS_mov_liste, $MULTI_comptes_list, True)
			$GUI_unappliedModifications = True
		Case Else
			For $i = 1 To UBound($MULTIS_mov_liste)-1
				If $msgGUI = $MULTIS_mov_liste[$i] And IsInt($MULTIS_mov_liste[$i]) Then
					Local $multi_toString = GUICtrlRead($MULTIS_comboBox)
					Local $check = multi_checkItemExistence($listeMultis, $multi_toString)
					If $check <> "" Then
						TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_multis_mov_error"), $check, 30, 3)
					Else
						; Switch choix>dition DISABLE/HIDE
						GUICtrlSetState($MULTIS_comboBox, $GUI_DISABLE)
						GUICtrlSetState($MULTIS_set, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($MULTIS_nok, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($MULTIS_add, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($MULTIS_get, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($MULTIS_del, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($MULTIS_mov, $GUI_SHOW+$GUI_DISABLE)
						For $item In $MULTI_items_pour_modelisation
							GUICtrlSetState($item, $GUI_DISABLE)
							GUICtrlSetData($item, "")
						Next
						GUICtrlSetState($MULTI_comptes_list,       $GUI_DISABLE)
						GUICtrlSetState($MULTI_comptes_list_MoveUp, $GUI_DISABLE)
						GUICtrlSetState($MULTI_comptes_list_Insert, $GUI_DISABLE)
						GUICtrlSetState($MULTI_comptes_list_Delete, $GUI_DISABLE)
						GUICtrlSetState($MULTI_comptes_list_MoveDn, $GUI_DISABLE)
						; Suppression item dans $listeMultis
						Local $multi_toString_fromContext = GUICtrlAdvancedMenuItemGetText($msgGUI)
						moveInListeMultisFromToString($listeMultis, $multi_toString, $multi_toString_fromContext)
						; Mise  jour de la liste dans $MULTIS_comboBox
						multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $MULTIS_comboBox, $MULTI_custom_text, $MULTIS_mov_liste, $MULTI_comptes_list, True)
						; Switch choix>dition ENABLE/SHOW
						GUICtrlSetState($MULTIS_comboBox, cond(getListeMultisLength($listeMultis) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($MULTIS_get, cond(getListeMultisLength($listeMultis) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($MULTIS_add, $GUI_ENABLE)
						GUICtrlSetState($MULTIS_del, cond(getListeMultisLength($listeMultis) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($MULTIS_mov, $GUI_SHOW+cond(getListeMultisLength($listeMultis) < 2,$GUI_DISABLE,$GUI_ENABLE))
						$GUI_unappliedModifications = True
					EndIf
				EndIf
			Next
			For $i = 1 To UBound($MULTI_comptes_items)-1
				If $msgGUI = $MULTI_comptes_items[$i] And IsInt($MULTI_comptes_items[$i]) Then
					Local $compteFromContextLabel = getCompteInListFromToString($listeComptes,GUICtrlAdvancedMenuItemGetText($MULTI_comptes_items[$i]))
					Local $multiToGet = getMultiInListFromToString($listeMultis,GUICtrlRead($MULTIS_comboBox))
					Local $multiToSet = copyMulti($multiToGet)
					If isMulti($multiToSet) And isCompte($compteFromContextLabel) Then
						setMultiListing($multiToSet,"")
						For $j = 1 To $MULTI_comptes_listitems[0]
							Local $texte = StringTrimRight(GUICtrlRead($MULTI_comptes_listitems[$j]),1)
							Local $compteFromListViewItem = getCompteInListFromToString($listeComptes, $texte)
							If isCompte($compteFromListViewItem) Then
								addCompteToMultiListing($multiToSet, $compteFromListViewItem)
							Else
								$compteFromListViewItem = getCompteInListFromToString($listeComptes, $texte)
								If isCompte($compteFromListViewItem) Then
									addCompteToMultiListing($multiToSet, $compteFromListViewItem)
								EndIf
							EndIf
						Next
						If isCompteInMultiListing($multiToSet, $compteFromContextLabel) Then
							delCompteFromMultiListing($multiToSet, $compteFromContextLabel)
						Else
							addCompteToMultiListing($multiToSet, $compteFromContextLabel)
						EndIf
						multi_updateListViewForListing($multiToSet, $MULTI_comptes_list, $MULTI_comptes_listitems, $MULTI_comptes_items, $listeComptes)
					EndIf
					ExitLoop
				EndIf
			Next
			; Mise  jour pour consultation
			If Not $MULTIS_modeEdition Then
				Local $multi_en_consultation_previous, $multi_en_consultation = GUICtrlRead($MULTIS_comboBox)
				If Not IsDeclared("multi_en_consultation_previous") Or $multi_en_consultation <> $multi_en_consultation_previous Then
					$multi_en_consultation_previous = $multi_en_consultation
					Local $multi = getMultiInListFromToString($listeMultis, $multi_en_consultation)
					If isMulti($multi) Then
						GUICtrlSetData($MULTI_alias_text, getMultiAlias($multi))
						multi_updateListViewForListing($multi, $MULTI_comptes_list, $MULTI_comptes_listitems, $MULTI_comptes_items, $listeComptes)
					EndIf
				EndIf
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour l'dition d'alertes
		Switch $msgGUI
		Case $ALERTES_add	; Choix > Edition
			Local $check = "" ; Nombre maximum d'alertes?
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_alertes_add_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($ALERTES_comboBox, $GUI_DISABLE)
				GUICtrlSetState($ALERTES_add, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_get, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_del, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_mov, $GUI_HIDE+$GUI_DISABLE)
				; Ajout item vierge dans $listeAlertes
				addToListeAlertes($listeAlertes, newAlerte(0,"","","","# Alerte #", ""))
				; Mise  jour de la liste dans $ALERTES_comboBox
				alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $ALERTES_comboBox, $ALERTE_audio_text, $ALERTES_mov_liste)
				; Effacement des champs
				GUICtrlSetData($ALERTE_dateA_text,    "")
				GUICtrlSetData($ALERTE_dateB_text,    "")
				GUICtrlSetData($ALERTE_periodic_text, "")
				GUICtrlSetData($ALERTE_title_text,    "")
				GUICtrlSetData($ALERTE_descript_text, "")
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($ALERTES_set, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($ALERTES_nok, $GUI_SHOW+$GUI_ENABLE)
				For $item In $ALERTE_items_pour_modelisation
					GUICtrlSetState($item, $GUI_ENABLE)
				Next
				$ALERTES_modeEdition = True
				GUICtrlSetData($ALERTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_alertes")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $ALERTES_get	; Choix > Edition
			Local $alerte_toString = GUICtrlRead($ALERTES_comboBox)
			Local $check = alerte_checkItemExistence($listeAlertes, $ALERTE_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_alertes_get_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($ALERTES_comboBox, $GUI_DISABLE)
				GUICtrlSetState($ALERTES_add, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_get, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_del, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_mov, $GUI_HIDE+$GUI_DISABLE)
				; Edition item de $listeAlertes
				Local $alerte = getAlerteInListFromToString($listeAlertes, $alerte_toString), $date=""
				$date = StringSplit(getAlerteDateA($alerte),"/ :")
				If $date[0] = 5 Then GUICtrlSetData($ALERTE_dateA_text,  $date[3]&"/"&$date[2]&"/"&$date[1]&" "&$date[4]&":"&$date[5])
				$date = StringSplit(getAlerteDateB($alerte),"/ :")
				If $date[0] = 5 Then GUICtrlSetData($ALERTE_dateB_text,  $date[3]&"/"&$date[2]&"/"&$date[1]&" "&$date[4]&":"&$date[5])
				GUICtrlSetData($ALERTE_periodic_text, getAlertePeriodic($alerte))
				GUICtrlSetData($ALERTE_title_text,    getAlerteTitle($alerte))
				GUICtrlSetData($ALERTE_descript_text, getAlerteDescript($alerte))
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($ALERTES_set, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($ALERTES_nok, $GUI_SHOW+$GUI_ENABLE)
				For $item In $ALERTE_items_pour_modelisation
					GUICtrlSetState($item, $GUI_ENABLE)
				Next
				$ALERTES_modeEdition = True
				GUICtrlSetData($ALERTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_alertes")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
			EndIf
		Case $ALERTES_del	; Choix > Choix
			GUICtrlSetState($ALERTES_comboBox, $GUI_DISABLE)
			Local $valueToDelete = GUICtrlRead($ALERTES_comboBox)
			GUICtrlAdvancedMenuItemSetText($ALERTES_del_confirm, getInternationalisationText($nAiO_languageResources, "IC_trt_alertes_del_confirm_texte", $valueToDelete))
			sousmenu($GUI, $ALERTES_del, $ALERTES_del_menu)
			GUICtrlSetState($ALERTES_comboBox, $GUI_ENABLE)
		Case $ALERTES_del_confirm
			Local $alerte_toString = GUICtrlRead($ALERTES_comboBox)
			Local $check = alerte_checkItemExistence($listeAlertes, $alerte_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_alertes_del_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($ALERTES_comboBox, $GUI_DISABLE)
				GUICtrlSetState($ALERTES_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_nok, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_add, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_get, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_del, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_mov, $GUI_SHOW+$GUI_DISABLE)
				For $item In $ALERTE_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
					GUICtrlSetData($item, "")
				Next
				; Suppression item dans $listeAlertes
				delInListeAlertesFromToString($listeAlertes, $alerte_toString)
				; Mise  jour de la liste dans $ALERTES_comboBox
				alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $ALERTES_comboBox, $ALERTE_audio_text, $ALERTES_mov_liste)
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($ALERTES_comboBox, cond(getListeAlertesLength($listeAlertes) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($ALERTES_get, cond(getListeAlertesLength($listeAlertes) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($ALERTES_add, $GUI_ENABLE)
				GUICtrlSetState($ALERTES_del, cond(getListeAlertesLength($listeAlertes) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($ALERTES_mov, $GUI_SHOW+cond(getListeAlertesLength($listeAlertes) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$GUI_unappliedModifications = True
			EndIf
		Case $ALERTES_mov	; Choix > Choix
			GUICtrlSetState($ALERTES_comboBox, $GUI_DISABLE)
			Local $valueToCheck = GUICtrlRead($ALERTES_comboBox)
			For $i = 1 To UBound($ALERTES_mov_liste)-1
				GUICtrlSetState($ALERTES_mov_liste[$i], cond(GUICtrlAdvancedMenuItemGetText($ALERTES_mov_liste[$i])=$valueToCheck,$GUI_DISABLE,$GUI_ENABLE))
			Next
			sousmenu($GUI, $ALERTES_mov, $ALERTES_mov_liste[0])
			GUICtrlSetState($ALERTES_comboBox, $GUI_ENABLE)
		Case $ALERTES_set	; Edition > Choix
			Local $alerte_toString = GUICtrlRead($ALERTES_comboBox)
			Local $check = alerte_checkItemCoherency($ALERTE_dateA_text,$ALERTE_dateB_text,$ALERTE_periodic_text,$ALERTE_title_text,$ALERTE_descript_text)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_alertes_set_error"), $check, 30, 3)
			Else
				; Switch dition>choix DISABLE/HIDE
				GUICtrlSetState($ALERTES_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($ALERTES_nok, $GUI_HIDE+$GUI_DISABLE)
				For $item In $ALERTE_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
				Next
				; Modification item dans $listeAlertes
				setAlerteInListFromToString($listeAlertes, $alerte_toString, GUICtrlRead($ALERTE_dateA_text),GUICtrlRead($ALERTE_dateB_text),GUICtrlRead($ALERTE_periodic_text),GUICtrlRead($ALERTE_title_text),GUICtrlRead($ALERTE_descript_text))
				; Mise  jour de la liste dans $ALERTES_comboBox
				alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $ALERTES_comboBox, $ALERTE_audio_text, $ALERTES_mov_liste, True)
				; Switch dition>choix ENABLE/SHOW
				GUICtrlSetState($ALERTES_comboBox, $GUI_ENABLE)
				GUICtrlSetState($ALERTES_add, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($ALERTES_get, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($ALERTES_del, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($ALERTES_mov, $GUI_SHOW+cond(getListeAlertesLength($listeAlertes) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$alerte_en_consultation_previous = ""
				$ALERTES_modeEdition = False
				GUICtrlSetData($ALERTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_alertes")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $ALERTES_nok	; Edition > Choix
			; Switch dition>choix DISABLE/HIDE
			GUICtrlSetState($ALERTES_set, $GUI_HIDE+$GUI_DISABLE)
			GUICtrlSetState($ALERTES_nok, $GUI_HIDE+$GUI_DISABLE)
			For $item In $ALERTE_items_pour_modelisation
				GUICtrlSetState($item, $GUI_DISABLE)
				GUICtrlSetData($item, "")
			Next
			; Mise  jour de la liste dans $ALERTES_comboBox
			alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $ALERTES_comboBox, $ALERTE_audio_text, $ALERTES_mov_liste, True)
			; Switch dition>choix ENABLE/SHOW
			GUICtrlSetState($ALERTES_comboBox, $GUI_ENABLE)
			GUICtrlSetState($ALERTES_add, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($ALERTES_get, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($ALERTES_del, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($ALERTES_mov, $GUI_SHOW+cond(getListeAlertesLength($listeAlertes) < 2,$GUI_DISABLE,$GUI_ENABLE))
			$alerte_en_consultation_previous = ""
			$ALERTES_modeEdition = False
			GUICtrlSetData($ALERTES_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_alertes")&" : ")
		Case $ALERTE_audio_text
			setParametreValeurInListFromClef($listeParametres, "Audio", cond(getParametreValeurInListFromClef($listeParametres, "Audio")="Y","N","Y"))
			alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $ALERTES_comboBox, $ALERTE_audio_text, $ALERTES_mov_liste, True)
			$GUI_unappliedModifications = True
		Case Else
			For $i = 1 To UBound($ALERTES_mov_liste)-1
				If $msgGUI = $ALERTES_mov_liste[$i] And IsInt($ALERTES_mov_liste[$i]) Then
					Local $alerte_toString = GUICtrlRead($ALERTES_comboBox)
					Local $check = alerte_checkItemExistence($listeAlertes, $alerte_toString)
					If $check <> "" Then
						TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_alertes_mov_error"), $check, 30, 3)
					Else
						; Switch choix>dition DISABLE/HIDE
						GUICtrlSetState($ALERTES_comboBox, $GUI_DISABLE)
						GUICtrlSetState($ALERTES_set, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($ALERTES_nok, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($ALERTES_add, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($ALERTES_get, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($ALERTES_del, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($ALERTES_mov, $GUI_SHOW+$GUI_DISABLE)
						For $item In $ALERTE_items_pour_modelisation
							GUICtrlSetState($item, $GUI_DISABLE)
							GUICtrlSetData($item, "")
						Next
						; Suppression item dans $listeAlertes
						Local $alerte_toString_fromContext = GUICtrlAdvancedMenuItemGetText($msgGUI)
						moveInListeAlertesFromToString($listeAlertes, $alerte_toString, $alerte_toString_fromContext)
						; Mise  jour de la liste dans $ALERTES_comboBox
						alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $ALERTES_comboBox, $ALERTE_audio_text, $ALERTES_mov_liste, True)
						; Switch choix>dition ENABLE/SHOW
						GUICtrlSetState($ALERTES_comboBox, cond(getListeAlertesLength($listeAlertes)=0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($ALERTES_get, cond(getListeAlertesLength($listeAlertes)=0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($ALERTES_add, $GUI_ENABLE)
						GUICtrlSetState($ALERTES_del, cond(getListeAlertesLength($listeAlertes)=0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($ALERTES_mov, $GUI_SHOW+cond(getListeAlertesLength($listeAlertes)<2,$GUI_DISABLE,$GUI_ENABLE))
						$GUI_unappliedModifications = True
					EndIf
				EndIf
			Next
			; Mise  jour automatique des champs lis dateB et periodic
			If BitAND(GUICtrlGetState($ALERTE_periodic_text),$GUI_ENABLE) = $GUI_ENABLE Then
				If StringRegExp(GUICtrlRead($ALERTE_periodic_text),"^[1-9]\d* ((jour|heure|minute)s?|mois)$") = 0 Then
					If BitAND(GUICtrlGetState($ALERTE_dateB_text),$GUI_ENABLE) = $GUI_ENABLE Then
						GUICtrlSetState($ALERTE_dateB_text,$GUI_DISABLE)
					EndIf
				Else
					If BitAND(GUICtrlGetState($ALERTE_dateB_text),$GUI_ENABLE) <> $GUI_ENABLE Then
						GUICtrlSetState($ALERTE_dateB_text,$GUI_ENABLE)
					EndIf
				EndIf
			EndIf
			; Mise  jour pour consultation
			If Not $ALERTES_modeEdition Then
				Local $alerte_en_consultation_previous, $alerte_en_consultation = GUICtrlRead($ALERTES_comboBox)
				If Not IsDeclared("alerte_en_consultation_previous") Or $alerte_en_consultation <> $alerte_en_consultation_previous Then
					$alerte_en_consultation_previous = $alerte_en_consultation
					Local $alerte = getAlerteInListFromToString($listeAlertes, $alerte_en_consultation)
					If isAlerte($alerte) Then
						Local $date=""
						$date = StringSplit(getAlerteDateA($alerte),"/ :")
						If $date[0] = 5 Then GUICtrlSetData($ALERTE_dateA_text,  $date[3]&"/"&$date[2]&"/"&$date[1]&" "&$date[4]&":"&$date[5])
						$date = StringSplit(getAlerteDateB($alerte),"/ :")
						If $date[0] = 5 Then GUICtrlSetData($ALERTE_dateB_text,  $date[3]&"/"&$date[2]&"/"&$date[1]&" "&$date[4]&":"&$date[5])
						GUICtrlSetData($ALERTE_periodic_text,  getAlertePeriodic($alerte))
						GUICtrlSetData($ALERTE_title_text, getAlerteTitle($alerte))
						GUICtrlSetData($ALERTE_descript_text,  getAlerteDescript($alerte))
					EndIf
				EndIf
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour la gestion des modules
		Switch $msgGUI
		Case $MODULES_allow
			Local $module_to_allow = GUICtrlRead($MODULES_listBoxBlack)
			For $i = 1 To getListeModulesLength($listeModules)
				Local $module = getModuleInListAt($listeModules, $i)
				If toStringModule($module) = $module_to_allow Then
					setModuleEtatActif($module)
					setModuleInListAt($listeModules,$i,$module)
					$GUI_unappliedModifications = True
				EndIf
			Next
			module_updateItems($listeModules, $MODULES_positions)
		Case $MODULES_deny
			Local $module_to_deny = GUICtrlRead($MODULES_listBoxWhite)
			For $i = 1 To getListeModulesLength($listeModules)
				Local $module = getModuleInListAt($listeModules, $i)
				If toStringModule($module) = $module_to_deny Then
					setModuleEtatInactif($module)
					setModuleInListAt($listeModules,$i,$module)
					$GUI_unappliedModifications = True
				EndIf
			Next
			module_updateItems($listeModules, $MODULES_positions)
		Case Else
			; Rien
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour l'dition de liens
		Switch $msgGUI
		Case $LIENS_add	; Choix > Edition
			Local $check = "" ; Nombre maximum de liens?
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_liens_add_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($LIENS_comboBox, $GUI_DISABLE)
				GUICtrlSetState($LIENS_add, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($LIENS_get, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($LIENS_del, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($LIENS_mov, $GUI_HIDE+$GUI_DISABLE)
				; Ajout item vierge dans $listeLiens
				addToListeLiens($listeLiens, newLien(0,"# Lien #","",""))
				; Mise  jour de la liste dans $LIENS_comboBox
				lien_updateComboBoxAndContextMenu($listeLiens, $LIENS_comboBox, $LIENS_mov_liste)
				; Effacement des champs
				GUICtrlSetData($LIEN_alias_text,  "")
				GUICtrlSetData($LIEN_chemin_text, "")
				GUICtrlSetData($LIEN_type_box,    "D")
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($LIENS_set, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($LIENS_nok, $GUI_SHOW+$GUI_ENABLE)
				For $item In $LIEN_items_pour_modelisation
					GUICtrlSetState($item, $GUI_ENABLE)
				Next
				GUICtrlSetState($LIEN_chemin_box, $GUI_ENABLE)
				$LIENS_modeEdition = True
				GUICtrlSetData($LIENS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_liens")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $LIENS_get	; Choix > Edition
			Local $lien_toString = GUICtrlRead($LIENS_comboBox)
			Local $check = lien_checkItemExistence($listeLiens, $lien_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_liens_get_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE
				GUICtrlSetState($LIENS_comboBox, $GUI_DISABLE)
				GUICtrlSetState($LIENS_add, $GUI_DISABLE)
				GUICtrlSetState($LIENS_get, $GUI_DISABLE)
				GUICtrlSetState($LIENS_del, $GUI_DISABLE)
				GUICtrlSetState($LIENS_mov, $GUI_DISABLE)
				; Edition item de $listeLiens
				Local $lien = getLienInListFromToString($listeLiens, $lien_toString)
				Local $key = $DEFAULT_Key, $error = 0
				GUICtrlSetData($LIEN_alias_text,  getLienAlias($lien))
				GUICtrlSetData($LIEN_chemin_text, getLienChemin($lien))
				GUICtrlSetData($LIEN_type_box,    getLienType($lien))
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($LIENS_add, $GUI_HIDE)
				GUICtrlSetState($LIENS_get, $GUI_HIDE)
				GUICtrlSetState($LIENS_del, $GUI_HIDE)
				GUICtrlSetState($LIENS_mov, $GUI_HIDE)
				GUICtrlSetState($LIENS_set, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($LIENS_nok, $GUI_SHOW+$GUI_ENABLE)
				For $item In $LIEN_items_pour_modelisation
					GUICtrlSetState($item, $GUI_ENABLE)
				Next
				GUICtrlSetState($LIEN_chemin_box, $GUI_ENABLE)
				$LIENS_modeEdition = True
				GUICtrlSetData($LIENS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_liens")&" "&getInternationalisationText($nAiO_languageResources, "IC_group_edition_mode")&" : ")
			EndIf
		Case $LIENS_del	; Choix > Choix
			GUICtrlSetState($LIENS_comboBox, $GUI_DISABLE)
			Local $valueToDelete = GUICtrlRead($LIENS_comboBox)
			GUICtrlAdvancedMenuItemSetText($LIENS_del_confirm, getInternationalisationText($nAiO_languageResources, "IC_trt_liens_del_confirm_texte", $valueToDelete))
			sousmenu($GUI, $LIENS_del, $LIENS_del_menu)
			GUICtrlSetState($LIENS_comboBox, $GUI_ENABLE)
		Case $LIENS_del_confirm
			Local $lien_toString = GUICtrlRead($LIENS_comboBox)
			Local $check = lien_checkItemExistence($listeLiens, $lien_toString)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_liens_del_error"), $check, 30, 3)
			Else
				; Switch choix>dition DISABLE/HIDE
				GUICtrlSetState($LIENS_comboBox, $GUI_DISABLE)
				GUICtrlSetState($LIENS_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($LIENS_nok, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($LIENS_add, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($LIENS_get, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($LIENS_del, $GUI_SHOW+$GUI_DISABLE)
				GUICtrlSetState($LIENS_mov, $GUI_SHOW+$GUI_DISABLE)
				For $item In $LIEN_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
					GUICtrlSetData($item, "")
				Next
				GUICtrlSetState($LIEN_chemin_box, $GUI_DISABLE)
				; Suppression item dans $listeLiens
				delInListeLiensFromToString($listeLiens, $lien_toString)
				; Mise  jour de la liste dans $LIENS_comboBox
				lien_updateComboBoxAndContextMenu($listeLiens, $LIENS_comboBox, $LIENS_mov_liste)
				; Switch choix>dition ENABLE/SHOW
				GUICtrlSetState($LIENS_comboBox, cond(getListeLiensLength($listeLiens) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($LIENS_get, cond(getListeLiensLength($listeLiens) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($LIENS_add, $GUI_ENABLE)
				GUICtrlSetState($LIENS_del, cond(getListeLiensLength($listeLiens) = 0,$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($LIENS_mov, $GUI_SHOW+cond(getListeLiensLength($listeLiens) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$GUI_unappliedModifications = True
			EndIf
		Case $LIENS_mov	; Choix > Choix
			GUICtrlSetState($LIENS_comboBox, $GUI_DISABLE)
			Local $valueToCheck = GUICtrlRead($LIENS_comboBox)
			For $i = 1 To UBound($LIENS_mov_liste)-1
				GUICtrlSetState($LIENS_mov_liste[$i], cond(GUICtrlAdvancedMenuItemGetText($LIENS_mov_liste[$i])=$valueToCheck,$GUI_DISABLE,$GUI_ENABLE))
			Next
			sousmenu($GUI, $LIENS_mov, $LIENS_mov_liste[0])
			GUICtrlSetState($LIENS_comboBox, $GUI_ENABLE)
		Case $LIENS_set	; Edition > Choix
			Local $lien_toString = GUICtrlRead($LIENS_comboBox)
			Local $check = lien_checkItemCoherency($LIEN_alias_text,$LIEN_chemin_text)
			If $check <> "" Then
				TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_liens_set_error"), $check, 30, 3)
			Else
				; Switch dition>choix DISABLE/HIDE
				GUICtrlSetState($LIENS_set, $GUI_HIDE+$GUI_DISABLE)
				GUICtrlSetState($LIENS_nok, $GUI_HIDE+$GUI_DISABLE)
				For $item In $LIEN_items_pour_modelisation
					GUICtrlSetState($item, $GUI_DISABLE)
				Next
				GUICtrlSetState($LIEN_chemin_box, $GUI_DISABLE)
				; Modification item dans $listeLiens
				setLienInListFromToString($listeLiens, $lien_toString, GUICtrlRead($LIEN_alias_text),GUICtrlRead($LIEN_chemin_text),GUICtrlRead($LIEN_type_box))
				; Mise  jour de la liste dans $LIENS_comboBox
				lien_updateComboBoxAndContextMenu($listeLiens, $LIENS_comboBox, $LIENS_mov_liste, True)
				; Switch dition>choix ENABLE/SHOW
				GUICtrlSetState($LIENS_comboBox, $GUI_ENABLE)
				GUICtrlSetState($LIENS_add, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($LIENS_get, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($LIENS_del, $GUI_SHOW+$GUI_ENABLE)
				GUICtrlSetState($LIENS_mov, $GUI_SHOW+cond(getListeLiensLength($listeLiens) < 2,$GUI_DISABLE,$GUI_ENABLE))
				$lien_en_consultation_previous = ""
				$LIENS_modeEdition = False
				GUICtrlSetData($LIENS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_liens")&" : ")
				$GUI_unappliedModifications = True
			EndIf
		Case $LIENS_nok	; Edition > Choix
			; Switch dition>choix DISABLE/HIDE
			GUICtrlSetState($LIENS_set, $GUI_HIDE+$GUI_DISABLE)
			GUICtrlSetState($LIENS_nok, $GUI_HIDE+$GUI_DISABLE)
			For $item In $LIEN_items_pour_modelisation
				GUICtrlSetState($item, $GUI_DISABLE)
				GUICtrlSetData($item, "")
			Next
			GUICtrlSetState($LIEN_chemin_box, $GUI_DISABLE)
			; Mise  jour de la liste dans $LIENS_comboBox
			lien_updateComboBoxAndContextMenu($listeLiens, $LIENS_comboBox, $LIENS_mov_liste, True)
			; Switch dition>choix ENABLE/SHOW
			GUICtrlSetState($LIENS_comboBox, $GUI_ENABLE)
			GUICtrlSetState($LIENS_add, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($LIENS_get, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($LIENS_del, $GUI_SHOW+$GUI_ENABLE)
			GUICtrlSetState($LIENS_mov, $GUI_SHOW+cond(getListeLiensLength($listeLiens) < 2,$GUI_DISABLE,$GUI_ENABLE))
			$lien_en_consultation_previous = ""
			$LIENS_modeEdition = False
			GUICtrlSetData($LIENS_group," "&getInternationalisationText($nAiO_languageResources, "IC_group_liens")&" : ")
		Case $LIEN_chemin_box ; Edition > Edition
			GUICtrlSetState($LIENS_set, $GUI_DISABLE)
			GUICtrlSetState($LIENS_nok, $GUI_DISABLE)
			For $item In $LIEN_items_pour_modelisation
				GUICtrlSetState($item, $GUI_DISABLE)
			Next
			GUICtrlSetState($LIEN_chemin_box, $GUI_DISABLE)
			Local $lien_toString = GUICtrlRead($LIENS_comboBox)
			; "Smaphore" pour exclure les bidouillages pendant l'affichage de la seconde fentre
			GUISetState(@SW_DISABLE, $GUI)
			Local $result = ""
			Switch GUICtrlRead($LIEN_type_box)
			Case "D"
				$result = FileSelectFolder(getInternationalisationText($nAiO_languageResources, "IC_trt_lien_chemin_dialog_title_dossier"), "", 0, "", $GUI)
				If @error = 0 Then GUICtrlSetData($LIEN_chemin_text, $result)
			Case "F"
				$result = FileOpenDialog(getInternationalisationText($nAiO_languageResources, "IC_trt_lien_chemin_dialog_title_fichier"), "", _
					getInternationalisationText($nAiO_languageResources, "IC_trt_lien_chemin_dialog_filter_fichier"), 1, "", $GUI _
				)
				If @error = 0 Then GUICtrlSetData($LIEN_chemin_text, $result)
			Case "P"
				$result = FileOpenDialog(getInternationalisationText($nAiO_languageResources, "IC_trt_lien_chemin_dialog_title_programme"), "", _
					getInternationalisationText($nAiO_languageResources, "IC_trt_lien_chemin_dialog_filter_programme"), 1, "", $GUI _
				)
				If @error = 0 Then GUICtrlSetData($LIEN_chemin_text, $result)
			EndSwitch
			GUISetState(@SW_ENABLE, $GUI)
			; "Smaphore" relach
			GUICtrlSetState($LIENS_set, $GUI_ENABLE)
			GUICtrlSetState($LIENS_nok, $GUI_ENABLE)
			For $item In $LIEN_items_pour_modelisation
				GUICtrlSetState($item, $GUI_ENABLE)
			Next
			GUICtrlSetState($LIEN_chemin_box, $GUI_ENABLE)
		Case $LIEN_type_box ; Edition > Edition
			Local $type = GUICtrlRead($LIEN_type_box)
			If $type = "D" Then
				$type = "F"
			ElseIf $type = "F" Then
				$type = "P"
			Else
				$type = "D"
			EndIf
			GUICtrlSetData($LIEN_type_box, $type)
		Case Else
			For $i = 1 To UBound($LIENS_mov_liste)-1
				If $msgGUI = $LIENS_mov_liste[$i] And IsInt($LIENS_mov_liste[$i]) Then
					Local $lien_toString = GUICtrlRead($LIENS_comboBox)
					Local $check = lien_checkItemExistence($listeLiens, $lien_toString)
					If $check <> "" Then
						TrayAdvancedDisplayMessage($tray, getInternationalisationText($nAiO_languageResources, "IC_trt_liens_mov_error"), $check, 30, 3)
					Else
						; Switch choix>dition DISABLE/HIDE
						GUICtrlSetState($LIENS_comboBox, $GUI_DISABLE)
						GUICtrlSetState($LIENS_set, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($LIENS_nok, $GUI_HIDE+$GUI_DISABLE)
						GUICtrlSetState($LIENS_add, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($LIENS_get, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($LIENS_del, $GUI_SHOW+$GUI_DISABLE)
						GUICtrlSetState($LIENS_mov, $GUI_SHOW+$GUI_DISABLE)
						For $item In $LIEN_items_pour_modelisation
							GUICtrlSetState($item, $GUI_DISABLE)
							GUICtrlSetData($item, "")
						Next
						GUICtrlSetState($LIEN_chemin_box, $GUI_DISABLE)
						; Suppression item dans $listeLiens
						Local $lien_toString_fromContext = GUICtrlAdvancedMenuItemGetText($msgGUI)
						moveInListeLiensFromToString($listeLiens, $lien_toString, $lien_toString_fromContext)
						; Mise  jour de la liste dans $LIENS_comboBox
						lien_updateComboBoxAndContextMenu($listeLiens, $LIENS_comboBox, $LIENS_mov_liste, True)
						; Switch choix>dition ENABLE/SHOW
						GUICtrlSetState($LIENS_comboBox, cond(getListeLiensLength($listeLiens) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($LIENS_get, cond(getListeLiensLength($listeLiens) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($LIENS_add, $GUI_ENABLE)
						GUICtrlSetState($LIENS_del, cond(getListeLiensLength($listeLiens) = 0,$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($LIENS_mov, $GUI_SHOW+cond(getListeLiensLength($listeLiens) < 2,$GUI_DISABLE,$GUI_ENABLE))
						$GUI_unappliedModifications = True
					EndIf
				EndIf
			Next
			; Mise  jour automatique du champ chemin
			Local $LIEN_chemin_text_color_to_apply = 0x000000
			If BitAND(GUICtrlGetState($LIEN_chemin_text),$GUI_ENABLE) = $GUI_ENABLE And GUICtrlGetHandle($LIEN_chemin_text) <> ControlGetHandle($GUI,"",ControlGetFocus($GUI)) Then
				Local $fichier = GUICtrlRead($LIEN_chemin_text), $type = GUICtrlRead($LIEN_type_box)
				Local $test = FileExists($fichier), $attribs = FileGetAttrib($fichier)
				If Not $test Then
					$LIEN_chemin_text_color_to_apply = 0xBB0000
				ElseIf (StringInStr($attribs, "D", 0) <> 0) = ($type = "D") Then
					$LIEN_chemin_text_color_to_apply = 0x009900
				Else
					$LIEN_chemin_text_color_to_apply = 0xBB8800
				EndIf
			EndIf
			If $LIEN_chemin_text_color <> $LIEN_chemin_text_color_to_apply Then
				$LIEN_chemin_text_color = $LIEN_chemin_text_color_to_apply
				GUICtrlSetColor($LIEN_chemin_text, $LIEN_chemin_text_color)
			EndIf
			; Mise  jour pour consultation
			If Not $LIENS_modeEdition Then
				Local $lien_en_consultation_previous, $lien_en_consultation = GUICtrlRead($LIENS_comboBox)
				If Not IsDeclared("lien_en_consultation_previous") Or $lien_en_consultation <> $lien_en_consultation_previous Then
					$lien_en_consultation_previous = $lien_en_consultation
					Local $lien = getLienInListFromToString($listeLiens, $lien_en_consultation)
					If isLien($lien) Then
						GUICtrlSetData($LIEN_alias_text,  getLienAlias($lien))
						GUICtrlSetData($LIEN_chemin_text, getLienChemin($lien))
						GUICtrlSetData($LIEN_type_box,    getLienType($lien))
					EndIf
				EndIf
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour les paramtres gnraux
		Switch $msgGUI
		Case $GENERAL_position_text
			Local $param = positionner()
			If IsArray($param) And UBound($param) = 2 Then
				setParametreValeurInListFromClef($listeParametres, "PositionXY", $param[0]&";"&$param[1])
				parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
				$GUI_unappliedModifications = True
			EndIf
		Case $GENERAL_aot_text
			Local $param = getParametreValeurInListFromClef($listeParametres, "AOT")
			If $param = "Y" Then
				$param = "S"
			ElseIf $param = "S" Then
				$param = "N"
			Else
				$param = "Y"
			EndIf
			setParametreValeurInListFromClef($listeParametres, "AOT", $param)
			parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
			$GUI_unappliedModifications = True
		Case $GENERAL_taskbar_text
			Local $param = getParametreValeurInListFromClef($listeParametres, "Taskbar")
			If $param = "N" Then
				$param = "Y"
			Else
				$param = "N"
			EndIf
			setParametreValeurInListFromClef($listeParametres, "Taskbar", $param)
			parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
			$GUI_unappliedModifications = True
			$GUI_restartRequired = True
		Case $GENERAL_fullscreen_text
			Local $param = getParametreValeurInListFromClef($listeParametres, "Fullscreen")
			If $param = "1" Then
				$param = "2"
			ElseIf $param = "2" Then
				$param = "0"
			Else
				$param = "1"
			EndIf
			setParametreValeurInListFromClef($listeParametres, "Fullscreen", $param)
			parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
			$GUI_unappliedModifications = True
		Case $GENERAL_fullscreen_multi_text
			Local $param = getParametreValeurInListFromClef($listeParametres, "FullscreenMulti")
			If $param = "1" Then
				$param = "2"
			ElseIf $param = "2" Then
				$param = "0"
			Else
				$param = "1"
			EndIf
			setParametreValeurInListFromClef($listeParametres, "FullscreenMulti", $param)
			parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
			$GUI_unappliedModifications = True
		Case $GENERAL_colors_gui_text
			Local $param = getParametreValeurInListFromClef($listeParametres, "ColorGUI")
			If $param = "1" Then
				$param = "2"
			ElseIf $param = "2" Then
				$param = "3"
			ElseIf $param = "3" Then
				$param = "0"
			Else
				$param = "1"
			EndIf
			setParametreValeurInListFromClef($listeParametres, "ColorGUI", $param)
			parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
			$GUI_unappliedModifications = True
		Case $GENERAL_colors_tray_text
			Local $param = getParametreValeurInListFromClef($listeParametres, "ColorTRAY")
			If $param = "1" Then
				$param = "2"
			ElseIf $param = "2" Then
				$param = "3"
			ElseIf $param = "3" Then
				$param = "0"
			Else
				$param = "1"
			EndIf
			setParametreValeurInListFromClef($listeParametres, "ColorTRAY", $param)
			parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
			$GUI_unappliedModifications = True
		Case $GENERAL_connexion_box
			parametre_updateContextMenu($GENERAL_connexion_menu, $GENERAL_connexion_items, $listeModules)
			sousmenu($GUI, $GENERAL_connexion_box, $GENERAL_connexion_menu)
		Case $GENERAL_connexion_item_parcourir
			GUICtrlSetState($GENERAL_connexion_box, $GUI_DISABLE)
			; "Smaphore" pour exclure les bidouillages pendant l'affichage de la seconde fentre
			GUISetState(@SW_DISABLE, $GUI)
			Local $result = FileOpenDialog( _
				getInternationalisationText($nAiO_languageResources, "IC_trt_general_connexion_dialog_title"), _
				cond(FileExists(StringTrimRight($nAiO_repertoire_modules,1)),StringTrimRight($nAiO_repertoire_modules,1),@ScriptDir), _
				cond(@Compiled, _
					getInternationalisationText($nAiO_languageResources, "IC_trt_general_connexion_dialog_filter_EXE"), _
					getInternationalisationText($nAiO_languageResources, "IC_trt_general_connexion_dialog_filter_AU3")  _
				), 1, "", $GUI _
			)
			If @error = 0 Then
				setParametreValeurInListFromClef($listeParametres, "Connexion", $result)
				Local $module = getModuleInListFromChemin($listeModules, $result)
				If isModule($module) Then
					setParametreValeurInListFromClef($listeParametres, "Connexion", getModuleChemin($module))
					If Not isModuleEtatActif($module) Then
						setModuleEtatActif($module)
						setModuleInListFromNom($listeModules,getModuleNom($module),$module)
						module_updateItems($listeModules, $MODULES_positions)
					EndIf
				EndIf
				$GUI_unappliedModifications = True
			EndIf
			parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
			GUISetState(@SW_ENABLE, $GUI)
			; "Smaphore" relach
			GUICtrlSetState($GENERAL_connexion_box, $GUI_ENABLE)
		Case Else
			; Mise  jour automatique du champ timeout
			If Not IsDeclared("GENERAL_timeout_previous") Then $GENERAL_timeout_previous = ""
			If GUICtrlGetHandle($GENERAL_timeout_text) <> ControlGetHandle($GUI,"",ControlGetFocus($GUI)) Then
				If $GENERAL_timeout_previous <> GUICtrlRead($GENERAL_timeout_text) Then
					$GENERAL_timeout_previous = GUICtrlRead($GENERAL_timeout_text)
					setParametreValeurInListFromClef($listeParametres, "TimeOut", convertTimeOutToInt($GENERAL_timeout_previous))
				EndIf
			EndIf
			; Mise  jour automatique du champ connexion
			Local $GENERAL_connexion_text_color_to_apply = 0x000000
			If GUICtrlGetHandle($GENERAL_connexion_text) <> ControlGetHandle($GUI,"",ControlGetFocus($GUI)) Then
				If FileExists(GUICtrlRead($GENERAL_connexion_text)) Then
					$GENERAL_connexion_text_color_to_apply = 0x009900
					setParametreValeurInListFromClef($listeParametres, "Connexion", GUICtrlRead($GENERAL_connexion_text))
				Else
					$GENERAL_connexion_text_color_to_apply = 0xBB0000
				EndIf
			EndIf
			If $GENERAL_connexion_text_color <> $GENERAL_connexion_text_color_to_apply Then
				$GENERAL_connexion_text_color = $GENERAL_connexion_text_color_to_apply
				GUICtrlSetColor($GENERAL_connexion_text, $GENERAL_connexion_text_color)
			EndIf
			; Traitement des choix rapides pour le module de connexion
			For $i = 1 To $GENERAL_connexion_items[0]
				If $msgGUI = $GENERAL_connexion_items[$i] And IsInt($GENERAL_connexion_items[$i]) Then
					Local $moduleToString = GUICtrlAdvancedMenuItemGetText($GENERAL_connexion_items[$i])
					Local $module = getModuleInListFromToString($listeModules, $moduleToString)
					If isModule($module) Then
						setParametreValeurInListFromClef($listeParametres, "Connexion", getModuleChemin($module))
						If Not isModuleEtatActif($module) Then
							setModuleEtatActif($module)
							setModuleInListFromNom($listeModules,getModuleNom($module),$module)
							module_updateItems($listeModules, $MODULES_positions)
						EndIf
						$GUI_unappliedModifications = True
					EndIf
					parametre_updateItems($listeParametres, $GENERAL_position_text, $GENERAL_aot_text, $GENERAL_taskbar_text, $GENERAL_timeout_text, $GENERAL_connexion_text, $GENERAL_fullscreen_text, $GENERAL_fullscreen_multi_text, $GENERAL_colors_gui_text, $GENERAL_colors_tray_text)
				EndIf
			Next
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour la gestion des captures
		Switch $msgGUI
		Case $CAPTURE_modes_text
			sousmenu($GUI, $CAPTURE_modes_text, $CAPTURE_modes_menu)
		Case Else
			For $i = 1 To $CAPTURE_modes_format_list[0]
				If $msgGUI = $CAPTURE_modes_format_list[$i] And IsInt($CAPTURE_modes_format_list[$i]) Then
					Local $previousValue = getParametreValeurInListFromClef($listeParametres,"SnapshotFormat"), $liste = newList("BMP","JPG","PNG")
					setParametreValeurInListFromClef($listeParametres,"SnapshotFormat",$liste[$i])
					capture_updateButtonAndContextMenu($listeParametres, $CAPTURE_modes_text, $CAPTURE_modes_menus, $CAPTURE_modes_format_list, $CAPTURE_modes_crop_list, $CAPTURE_modes_mode_list)
					$GUI_unappliedModifications = $GUI_unappliedModifications Or ($previousValue = getParametreValeurInListFromClef($listeParametres,"SnapshotFormat"))
					sousmenu($GUI, $CAPTURE_modes_text, $CAPTURE_modes_menu)
				EndIf
			Next
			For $i = 1 To $CAPTURE_modes_crop_list[0]
				If $msgGUI = $CAPTURE_modes_crop_list[$i] And IsInt($CAPTURE_modes_crop_list[$i]) Then
					Local $previousValue = getParametreValeurInListFromClef($listeParametres,"SnapshotCrop"), $liste = newList("INTERNAL","WINDOW","DESKTOP","CAROTTE","MANUAL")
					setParametreValeurInListFromClef($listeParametres,"SnapshotCrop",$liste[$i])
					capture_updateButtonAndContextMenu($listeParametres, $CAPTURE_modes_text, $CAPTURE_modes_menus, $CAPTURE_modes_format_list, $CAPTURE_modes_crop_list, $CAPTURE_modes_mode_list)
					$GUI_unappliedModifications = $GUI_unappliedModifications Or ($previousValue = getParametreValeurInListFromClef($listeParametres,"SnapshotCrop"))
					sousmenu($GUI, $CAPTURE_modes_text, $CAPTURE_modes_menu)
				EndIf
			Next
			For $i = 1 To $CAPTURE_modes_mode_list[0]
				If $msgGUI = $CAPTURE_modes_mode_list[$i] And IsInt($CAPTURE_modes_mode_list[$i]) Then
					Local $previousValue = getParametreValeurInListFromClef($listeParametres,"SnapshotMode"), $liste = newList("GLOBAL","UNIQUE")
					setParametreValeurInListFromClef($listeParametres,"SnapshotMode",$liste[$i])
					capture_updateButtonAndContextMenu($listeParametres, $CAPTURE_modes_text, $CAPTURE_modes_menus, $CAPTURE_modes_format_list, $CAPTURE_modes_crop_list, $CAPTURE_modes_mode_list)
					$GUI_unappliedModifications = $GUI_unappliedModifications Or ($previousValue = getParametreValeurInListFromClef($listeParametres,"SnapshotMode"))
					sousmenu($GUI, $CAPTURE_modes_text, $CAPTURE_modes_menu)
				EndIf
			Next
		EndSwitch
		#EndRegion
		#Region Traitement des messages GUI pour la gestion des actions customisables
		Switch $msgGUI
		Case $ACTION1_bouton_text4, $ACTION2_bouton_text4
			; Aucun traitement pour le moment
		Case Else
			Local $ACTION1_actual_preview = _
				GUICtrlRead($ACTION1_bouton_text1)  & GUICtrlRead($ACTION1_bouton_text2)  & GUICtrlRead($ACTION1_bouton_text3)  & GUICtrlRead($ACTION1_bouton_text4)  & _
				GUICtrlRead($ACTION1_tooltip_text1) & GUICtrlRead($ACTION1_tooltip_text2) & GUICtrlRead($ACTION1_action_text1)  & GUICtrlRead($ACTION1_action_text2)
			If $ACTION1_actual_preview <> $ACTION1_preview Then
				$GUI_unappliedModifications = True
				$ACTION1_preview = $ACTION1_actual_preview
				Local $action = getActionInListAt($listeActions, 1)
				setActionTitle($action, GUICtrlRead($ACTION1_tooltip_text1))
				setActionDescription($action, GUICtrlRead($ACTION1_tooltip_text2))
				setActionLabel($action, GUICtrlRead($ACTION1_bouton_text1))
				setActionFont($action, GUICtrlRead($ACTION1_bouton_text3))
				setActionBold($action, cond(BitAND(GUICtrlRead($ACTION1_bouton_text4),$GUI_CHECKED)=$GUI_CHECKED,"Y","N"))
				setActionSize($action, GUICtrlRead($ACTION1_bouton_text2))
				setActionType($action, Number(StringLeft(GUICtrlRead($ACTION1_action_text1),1)))
				setActionParameter($action, GUICtrlRead($ACTION1_action_text2))
				action_updatePreview($action, $ACTION1_preview_button)
			EndIf
			Local $ACTION1_actual_actionPreview = GUICtrlRead($ACTION1_action_text1)
			If $ACTION1_actual_actionPreview <> $ACTION1_actionPreview Then
				$ACTION1_actionPreview = $ACTION1_actual_actionPreview
				action_updateParametreTooltip($ACTION1_action_text2, GUICtrlRead($ACTION1_action_text1))
			EndIf
			Local $ACTION2_preview, $ACTION2_actual_preview = _
				GUICtrlRead($ACTION2_bouton_text1)  & GUICtrlRead($ACTION2_bouton_text2)  & GUICtrlRead($ACTION2_bouton_text3)  & GUICtrlRead($ACTION2_bouton_text4)  & _
				GUICtrlRead($ACTION2_tooltip_text1) & GUICtrlRead($ACTION2_tooltip_text2) & GUICtrlRead($ACTION2_action_text1)  & GUICtrlRead($ACTION2_action_text2)
			If $ACTION2_actual_preview <> $ACTION2_preview Then
				$GUI_unappliedModifications = True
				$ACTION2_preview = $ACTION2_actual_preview
				Local $action = getActionInListAt($listeActions, 2)
				setActionTitle($action, GUICtrlRead($ACTION2_tooltip_text1))
				setActionDescription($action, GUICtrlRead($ACTION2_tooltip_text2))
				setActionLabel($action, GUICtrlRead($ACTION2_bouton_text1))
				setActionFont($action, GUICtrlRead($ACTION2_bouton_text3))
				setActionBold($action, cond(BitAND(GUICtrlRead($ACTION2_bouton_text4),$GUI_CHECKED)=$GUI_CHECKED,"Y","N"))
				setActionSize($action, GUICtrlRead($ACTION2_bouton_text2))
				setActionType($action, Number(StringLeft(GUICtrlRead($ACTION2_action_text1),1)))
				setActionParameter($action, GUICtrlRead($ACTION2_action_text2))
				action_updatePreview($action, $ACTION2_preview_button)
			EndIf
			Local $ACTION2_actual_actionPreview = GUICtrlRead($ACTION2_action_text1)
			If $ACTION2_actual_actionPreview <> $ACTION2_actionPreview Then
				$ACTION2_actionPreview = $ACTION2_actual_actionPreview
				action_updateParametreTooltip($ACTION2_action_text2, GUICtrlRead($ACTION2_action_text1))
			EndIf
		EndSwitch
		#EndRegion
		#Region Traitement des diffrences de textes pour la confirmation de sortie
		If Not $GUI_unappliedModifications Then
			Local $GUI_unappliedModifications_valeur = _
				GUICtrlRead($GENERAL_timeout_text) & GUICtrlRead($GENERAL_connexion_text)
			If $GUI_unappliedModifications_valeur_previous <> $GUI_unappliedModifications_valeur Then
				$GUI_unappliedModifications_valeur_previous = $GUI_unappliedModifications_valeur
				$GUI_unappliedModifications = True
			EndIf
		EndIf
		#EndRegion
	WEnd
	#Region Traitement des lments de retour de l'interface
	; On consomme les lments indsirables avant de quitter l'interface
	While GUIGetMsg()
		Sleep(1)
	WEnd
	GUIDelete($GUI)
	Local $nAiO_fichiers_dates_after = FileGetTime(getProfilFichier("comptes"),0,1)&"/"&FileGetTime(getProfilFichier("multi"),0,1)&"/"&FileGetTime(getProfilFichier("alertes"),0,1)&"/"&FileGetTime(getProfilFichier("liens"),0,1)&"/"&FileGetTime(getProfilFichier("config"),0,1)
	TrayAdvancedDisplayMessage($tray)
	#EndRegion
	Return $GUI_restartRequired
EndFunc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#Region Fonctions annexes pour le traitement des messages de l'interface
Func defineGlobalValues(ByRef $array, $root)
	Local $size = UBound($array)
	For $i = 0 To $size-1
		$array[$i] = getInternationalisationText($nAiO_languageResources, $root&$i)
	Next
EndFunc
Func saveData($config_pass, ByRef $profil_pass, $comptes, $multis,  $parametres, $alertes, $modules, $liens, $actions, $timeout, $tray)
	TrayAdvancedDisplayMessage($tray,  _
		getInternationalisationText($nAiO_languageResources, "IC_func_savedata_title"), _
		getInternationalisationText($nAiO_languageResources, "IC_func_savedata_texte_begin"), _
		30, 2 _
	)
	; Mise  jour Listview>Modules
	For $i = 1 To getListeModulesLength($modules)
		Local $module = getModuleInListAt($modules,$i)
		If Not isModuleEtatActif($module) Then setModuleEtatInactif($module)
	Next
	; Mise  jour ComboBox Timeout>Paramtres
	Local $valeurStr = StringSplit(GUICtrlRead($timeout)," "), $valeur = 0
	If $valeurStr[0] = 2 Then
		Local $valeur = Number($valeurStr[1]) * _
			cond(StringRegExp($valeurStr[2],"^mois$"),     60*24*31, _
			cond(StringRegExp($valeurStr[2],"^jours?$"),   60*24, _
			cond(StringRegExp($valeurStr[2],"^heures?$"),  60, _
			cond(StringRegExp($valeurStr[2],"^minutes?$"), 1, _
			0))))
	EndIf
	; Enregistrement nouveau mot de passe
	setParametreValeurInListFromClef($parametres,"Password",autoencryptage($config_pass))
	; Sauvegarde des donnes
	convertListeComptesToFichier(    $comptes,    getProfilFichier("comptes"), $config_pass)
	convertListeMultisToFichier(     $multis,     getProfilFichier("multis"))
	convertListeParametresToFichier( $parametres, getProfilFichier("config"))
	convertListeAlertesToFichier(    $alertes,    getProfilFichier("alertes"))
	convertListeModulesToFichier(    $modules,    getProfilFichier("modules"))
	convertListeLiensToFichier(      $liens,      getProfilFichier("liens"))
	convertListeActionsToFichier(    $actions,    getProfilFichier("config"))
	$profil_pass = $config_pass
	TrayAdvancedDisplayMessage($tray,  _
		getInternationalisationText($nAiO_languageResources, "IC_func_savedata_title"), _
		getInternationalisationText($nAiO_languageResources, "IC_func_savedata_texte_end"), _
		30, 1 _
	)
EndFunc
Func compte_updateComboBoxAndContextMenu($listeComptes, $comboBox, ByRef $liste, $keepDefault = False)
	Local $default = "", $found = False, $item = 0, $menu = $liste[0]
	If $keepDefault Then $default = GUICtrlRead($comboBox)
	Local $texte = getInternationalisationText($nAiO_languageResources, "IC_comptes_aucun_label")
	GUICtrlSetData($comboBox, "")
	For $i = 1 To UBound($liste)-1
		GUICtrlAdvancedDelete($liste[$i])
	Next
	$liste = newArray()
	If getListeComptesLength($listeComptes) = 0 Then
		GUICtrlSetData($comboBox, $texte,$texte)
	Else
		For $i = 1 To getListeComptesLength($listeComptes)
			$texte = toStringCompte(getCompteInListAt($listeComptes,$i))
			GUICtrlSetData($comboBox, $texte,$texte)
			If $keepDefault And $default = $texte Then $found = True
			$item = GUICtrlCreateAdvancedMenuItem($texte, $menu)
			addToArray($liste, $item)
		Next
		If $found Then GUICtrlSetData($comboBox, $default)
	EndIf
	$liste[0] = $menu
EndFunc
Func compte_checkItemCoherency($alias,$avatar,$login,$pass,$key)
	Local $message_erreur = ""
	; [TODO] Traitement par regexp
	If GUICtrlRead($alias) = "" Then $message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_compte_coherence_alias") & @CRLF
	If GUICtrlRead($login) = "" Then $message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_compte_coherence_login") & @CRLF
	If GUICtrlRead($pass)  = "" Then $message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_compte_coherence_pass")  & @CRLF
	Return StringStripWS($message_erreur,7)
EndFunc
Func compte_checkItemExistence($liste, $toString)
	Local $message_erreur = cond(isCompte(getCompteInListFromToString($liste, $toString)),"",getInternationalisationText($nAiO_languageResources, "IC_func_compte_existence", $toString))
	Return $message_erreur
EndFunc
Func multi_updateComboBoxAndContextMenu($listeMultis, $listeParametres, $comboBox, $customMulti, ByRef $liste, $listView, $keepDefault = False)
	Local $default = "", $found = False, $item = 0, $menu = $liste[0]
	If $keepDefault Then $default = GUICtrlRead($comboBox)
	Local $texte = getInternationalisationText($nAiO_languageResources, "IC_multis_aucun_label")
	GUICtrlSetData($comboBox, "")
	For $i = 1 To UBound($liste)-1
		GUICtrlAdvancedDelete($liste[$i])
	Next
	$liste = newArray()
	If getListeMultisLength($listeMultis) = 0 Then
		GUICtrlSetData($comboBox, $texte,$texte)
	Else
		For $i = 1 To getListeMultisLength($listeMultis)
			$texte = toStringMulti(getMultiInListAt($listeMultis,$i))
			GUICtrlSetData($comboBox, $texte,$texte)
			If $keepDefault And $default = $texte Then $found = True
			$item = GUICtrlCreateAdvancedMenuItem($texte, $menu)
			addToArray($liste, $item)
		Next
		If $found Then GUICtrlSetData($comboBox, $default)
	EndIf
	GUICtrlSetData($customMulti, _
		cond(getParametreValeurInListFromClef($listeParametres,"CustomMulti")="Y", _
			$MULTIS_customized_values[1], _
			$MULTIS_customized_values[0]  _
		) _
	)
	$liste[0] = $menu
EndFunc
Func multi_updateListViewForListing($multi, $listView, ByRef $listView_items, ByRef $contextMenu, $listeComptes)
	Local $texte = getInternationalisationText($nAiO_languageResources, "IC_comptes_aucun_label"), $texte_noCompteLeft = getInternationalisationText($nAiO_languageResources, "IC_multis_aucunrestant_label")
	For $i = 1 To UBound($contextMenu)-1
		GUICtrlAdvancedDelete($contextMenu[$i])
	Next
	For $i = 1 To $listView_items[0]
		GUICtrlDelete($listView_items[$i])
	Next
	ReDim $contextMenu[1]
	ReDim $listView_items[1]
	$listView_items[0] = 0
	If getListeComptesLength($listeComptes) = 0 Then
		ReDim $contextMenu[2]
		$contextMenu[1] = GUICtrlCreateAdvancedMenuItem($contextMenu[0], $texte)
		GUICtrlSetState($contextMenu[1], $GUI_DISABLE)
	Else
		; ContextMenu "ajout de compte au listing"
		For $i = 1 To getListeComptesLength($listeComptes)
			Local $compte = getCompteInListAt($listeComptes,$i)
			If Not isCompteInMultiListing(getMultiListing($multi), $compte) Then
				ReDim $contextMenu[UBound($contextMenu)+1]
				$contextMenu[UBound($contextMenu)-1] = GUICtrlCreateAdvancedMenuItem(toStringCompte($compte), $contextMenu[0])
			EndIf
		Next
		If UBound($contextMenu) < 2 Then
			ReDim $contextMenu[2]
			$contextMenu[1] = GUICtrlCreateAdvancedMenuItem($texte_noCompteLeft, $contextMenu[0])
			GUICtrlSetState($contextMenu[1], $GUI_DISABLE)
		EndIf
		; Listview_Items "compte dans le listing du multi"
		Local $liste = getMultiListingAsArray($multi)
		For $i = 1 To $liste[0]
			Local $compte = getCompteInListFromIndex($listeComptes,$liste[$i])
			If isCompte($compte) Then
				$listView_items[0] = $listView_items[0]+1
				ReDim $listView_items[$listView_items[0]+1]
				$listView_items[$listView_items[0]] = GUICtrlCreateListViewItem(toStringCompte($compte), $listView)
				GUICtrlSetBkColor($listView_items[$listView_items[0]],0xF7F7F7)
			EndIf
		Next
	EndIf
	GUICtrlSetData($listView, $listView_items[0]&" compte"&cond($listView_items[0]>1,"s",""))
	_GUICtrlListView_SetColumnWidth($listView,0,-2) ; $LVSCW_AUTOSIZE_USEHEADER = -2
EndFunc
Func multi_checkItemCoherency($alias,$listing,$listeComptes)
	Local $message_erreur = ""
	; [TODO] Traitement par regexp
	If GUICtrlRead($alias) = "" Then $message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_multi_coherence_alias")   & @CRLF
	If $listing[0] < 2          Then $message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_multi_coherence_listing") & @CRLF
	Return StringStripWS($message_erreur,7)
EndFunc
Func multi_checkItemExistence($liste, $toString)
	Local $message_erreur = cond(isMulti(getMultiInListFromToString($liste, $toString)),"",getInternationalisationText($nAiO_languageResources, "IC_func_multi_existence", $toString))
	Return $message_erreur
EndFunc
Func module_updateItems($listeModules, $positions)
	Local $contentListeWhite = "", $contentListeBlack = ""
	For $i = 1 To getListeModulesLength($listeModules)
		Local $module = getModuleInListAt($listeModules,$i)
		If isModuleEtatActif($module) Then
			$contentListeWhite &= "|" & toStringModule($module)
		Else
			$contentListeBlack &= "|" & toStringModule($module)
		EndIf
	Next
	GUICtrlSetData($positions[0][0], $contentListeWhite)
	GUICtrlSetData($positions[1][0], $contentListeBlack)
	GUICtrlSetState($positions[2][0], cond($contentListeBlack="",$GUI_DISABLE,$GUI_ENABLE))
	GUICtrlSetState($positions[3][0], cond($contentListeWhite="",$GUI_DISABLE,$GUI_ENABLE))
	local $decalage = 0
	If $contentListeBlack = "" Then $decalage = $decalage+$positions[0][3]/2
	If $contentListeWhite = "" Then $decalage = $decalage-$positions[0][3]/2
	GUICtrlSetPos($positions[0][0], $positions[0][1],           $positions[0][2], $positions[0][3]+$decalage, $positions[0][4])
	GUICtrlSetPos($positions[1][0], $positions[1][1]+$decalage, $positions[1][2], $positions[1][3]-$decalage, $positions[1][4])
	GUICtrlSetPos($positions[2][0], $positions[2][1]+$decalage, $positions[2][2], $positions[2][3],           $positions[2][4])
	GUICtrlSetPos($positions[3][0], $positions[3][1]+$decalage, $positions[3][2], $positions[3][3],           $positions[3][4])
EndFunc
Func lien_updateComboBoxAndContextMenu($listeLiens, $comboBox, ByRef $liste, $keepDefault = False)
	Local $default = "", $found = False, $item = 0, $menu = $liste[0]
	If $keepDefault Then $default = GUICtrlRead($comboBox)
	Local $texte = getInternationalisationText($nAiO_languageResources, "IC_liens_aucun_label")
	GUICtrlSetData($comboBox, "")
	For $i = 1 To UBound($liste)-1
		GUICtrlAdvancedDelete($liste[$i])
	Next
	$liste = newArray()
	If getListeLiensLength($listeLiens) = 0 Then
		GUICtrlSetData($comboBox, $texte,$texte)
	Else
		For $i = 1 To getListeLiensLength($listeLiens)
			$texte = toStringLien(getLienInListAt($listeLiens,$i))
			GUICtrlSetData($comboBox, $texte,$texte)
			If $keepDefault And $default = $texte Then $found = True
			$item = GUICtrlCreateAdvancedMenuItem($texte, $menu)
			addToArray($liste, $item)
		Next
		If $found Then GUICtrlSetData($comboBox, $default)
	EndIf
	$liste[0] = $menu
EndFunc
Func lien_checkItemCoherency($alias,$chemin)
	Local $message_erreur = ""
	; [TODO] Traitement par regexp
	If GUICtrlRead($alias) = "" Then $message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_lien_coherence_alias") & @CRLF
	If GUICtrlRead($chemin) = "" Then
		$message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_lien_coherence_chemin") & @CRLF
	ElseIf FileExists(GUICtrlRead($chemin)) = 0 Then
		$message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_lien_existence_chemin") & @CRLF
	EndIf
	Return StringStripWS($message_erreur,7)
EndFunc
Func lien_checkItemExistence($liste, $toString)
	Local $message_erreur = cond(isLien(getLienInListFromToString($liste, $toString)),"",getInternationalisationText($nAiO_languageResources, "IC_func_lien_existence", $toString))
	Return $message_erreur
EndFunc
Func alerte_updateComboBoxAndContextMenu($listeAlertes, $listeParametres, $comboBox, $audio, ByRef $liste, $keepDefault = False)
	Local $default = "", $found = False, $item = 0, $menu = $liste[0]
	If $keepDefault Then $default = GUICtrlRead($comboBox)
	Local $texte = getInternationalisationText($nAiO_languageResources, "IC_alertes_aucun_label")
	GUICtrlSetData($comboBox, "")
	For $i = 1 To UBound($liste)-1
		GUICtrlAdvancedDelete($liste[$i])
	Next
	$liste = newArray()
	If getListeAlertesLength($listeAlertes) = 0 Then
		GUICtrlSetData($comboBox, $texte,$texte)
	Else
		For $i = 1 To getListeAlertesLength($listeAlertes)
			$texte = toStringAlerte(getAlerteInListAt($listeAlertes,$i))
			GUICtrlSetData($comboBox, $texte,$texte)
			If $keepDefault And $default = $texte Then $found = True
			$item = GUICtrlCreateAdvancedMenuItem($texte, $menu)
			addToArray($liste, $item)
		Next
		If $found Then GUICtrlSetData($comboBox, $default)
	EndIf
	GUICtrlSetData($audio, _
		cond(getParametreValeurInListFromClef($listeParametres,"Audio")="Y", _
			$ALERTES_audio_values[1], _
			$ALERTES_audio_values[0] _
		) _
	)
	$liste[0] = $menu
EndFunc
Func alerte_checkItemCoherency($dateA,$dateB,$periodic,$title,$descript)
	Local $message_erreur = ""
	If StringRegExp(GUICtrlRead($periodic),"^([1-9]\d* ((jour|heure|minute)s?|mois))?$") = 0 Then
		$message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_alerte_coherence_periodic")&@CRLF
	ElseIf GUICtrlRead($periodic) <> "" Then
		Local $splitA = StringSplit(GUICtrlRead($dateA),"/ :")
		Local $splitB = StringSplit(GUICtrlRead($dateB),"/ :")
		If $splitA[0] <> 5 Then
			$message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_alerte_coherence_datea")&@CRLF
		ElseIf $splitB[0] <> 5 Then
			$message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_alerte_coherence_dateb")&@CRLF
		ElseIf Int($splitA[3]&$splitA[2]&$splitA[1]&$splitA[4]&$splitA[5])>Int($splitB[3]&$splitB[2]&$splitB[1]&$splitB[4]&$splitB[5]) Then
			$message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_alerte_coherence_dates")&@CRLF
		EndIf
	EndIf
	If GUICtrlRead($title) = ""  Then
		$message_erreur &= getInternationalisationText($nAiO_languageResources, "IC_func_alerte_coherence_titre")&@CRLF
	EndIf
	Return StringStripWS($message_erreur,7)
EndFunc
Func alerte_checkItemExistence($liste, $toString)
	Local $message_erreur = cond(isAlerte(getAlerteInListFromToString($liste, $toString)),"",getInternationalisationText($nAiO_languageResources, "IC_func_alerte_existence", $toString))
	Return $message_erreur
EndFunc
Func profil_updateItems($listeProfils, $comboBox, $inputBox, $keepDefault = False)
	Local $default = "", $found = False
	If $keepDefault Then $default = GUICtrlRead($comboBox)
	Local $texte = getInternationalisationText($nAiO_languageResources, "IC_profils_aucun_label")
	GUICtrlSetData($comboBox, "")
	GUICtrlSetData($inputBox, "")
	If getListeProfilsLength($listeProfils) = 0 Then
		GUICtrlSetState(GUICtrlSetData($comboBox, $texte,$texte), $GUI_DISABLE)
	Else
		For $i = 1 To getListeProfilsLength($listeProfils)
			$texte = toStringProfil(getProfilInListAt($listeProfils,$i))
			GUICtrlSetData($comboBox, $texte,$texte)
			If $keepDefault And $default = $texte Then $found = True
		Next
		If $found Then GUICtrlSetData($comboBox, $default)
	EndIf
EndFunc
Func parametre_updateContextMenu($menu, ByRef $items, $modules)
	Local $item = 0, $texte = getInternationalisationText($nAiO_languageResources, "IC_connexions_aucun_label")
	For $i = 1 To $items[0]
		GUICtrlAdvancedDelete($items[$i])
	Next
	$items = newArray()
	For $i = 1 To getListeModulesLength($modules)
		Local $module = getModuleInListAt($modules, $i)
		If isModuleTypeConnexion($module) Then
			$texte = toStringModule($module)
			$item = GUICtrlCreateAdvancedMenuItem($texte, $menu)
			addToArray($items, $item)
		EndIf
	Next
	If $items[0] = 0 Then
		$item = GUICtrlCreateAdvancedMenuItem($texte, $menu)
		GUICtrlSetState($item, $GUI_DISABLE)
		addToArray($items, $item)
	EndIf
EndFunc
Func parametre_updateItems($listeParametres, $position_text, $aot_text, $taskbar_text, $timeout_text, $connexion_text, $fullscreen_text, $fullscreen_multi_text, $colors_gui_text, $colors_tray_text)
	; Position
	Local $position = StringSplit(getParametreValeurInListFromClef($listeParametres,"PositionXY"),";")
	If @error Or Not IsArray($position) Or $position[0] < 2 Then $position = StringSplit("10;10",";")
	GUICtrlSetData($position_text, getInternationalisationText($nAiO_languageResources, "IC_general_position_value_texte", $position[1], $position[2]))
	; AOT
	GUICtrlSetData($aot_text, _
		cond( _
			getParametreValeurInListFromClef($listeParametres,"AOT")<>"S", _
			cond( _
				getParametreValeurInListFromClef($listeParametres,"AOT")<>"Y", _
				$GENERAL_aot_values[0], _
				$GENERAL_aot_values[1] _
			), _
			$GENERAL_aot_values[2] _
		) _
	)
	; Taskbar
	GUICtrlSetData($taskbar_text, _
		cond( _
			getParametreValeurInListFromClef($listeParametres,"Taskbar")<>"N", _
			$GENERAL_taskbar_values[0], _
			$GENERAL_taskbar_values[1] _
		) _
	)
	; Fullscreen
	GUICtrlSetData($fullscreen_text, _
		cond( _
			getParametreValeurInListFromClef($listeParametres,"Fullscreen")<>"2", _
			cond( _
				getParametreValeurInListFromClef($listeParametres,"Fullscreen")<>"1", _
				$GENERAL_fullscreen_values[0], _
				$GENERAL_fullscreen_values[1] _
			), _
			$GENERAL_fullscreen_values[2] _
		) _
	)
	GUICtrlSetData($fullscreen_multi_text, _
		cond( _
			getParametreValeurInListFromClef($listeParametres,"FullscreenMulti")<>"2", _
			cond( _
				getParametreValeurInListFromClef($listeParametres,"FullscreenMulti")<>"1", _
				$GENERAL_fullscreen_values[0], _
				$GENERAL_fullscreen_values[1] _
			), _
			$GENERAL_fullscreen_values[2] _
		) _
	)
	; Couleurs
	GUICtrlSetData($colors_gui_text, _
		cond( _
			getParametreValeurInListFromClef($listeParametres,"ColorGUI")<>"3", _
			cond( _
				getParametreValeurInListFromClef($listeParametres,"ColorGUI")<>"2", _
				cond( _
					getParametreValeurInListFromClef($listeParametres,"ColorGUI")<>"1", _
					$GENERAL_colors_values[0], _
					$GENERAL_colors_values[1]  _
				), _
				$GENERAL_colors_values[2] _
			), _
			$GENERAL_colors_values[3] _
		) _
	)
	GUICtrlSetData($colors_tray_text, _
		cond( _
			getParametreValeurInListFromClef($listeParametres,"ColorTRAY")<>"3", _
			cond( _
				getParametreValeurInListFromClef($listeParametres,"ColorTRAY")<>"2", _
				cond( _
					getParametreValeurInListFromClef($listeParametres,"ColorTRAY")<>"1", _
					$GENERAL_colors_values[0], _
					$GENERAL_colors_values[1]  _
				), _
				$GENERAL_colors_values[2] _
			), _
			$GENERAL_colors_values[3] _
		) _
	)
	; Timeout
	Local $valeurInt = Number(getParametreValeurInListFromClef($listeParametres,"TimeOut"))
	Local $valeur = convertIntToTimeOut($valeurInt)
	GUICtrlSetData($timeout_text, $valeur,$valeur)
	; Module de connexion
	Local $connexion = getParametreValeurInListFromClef($listeParametres,"Connexion")
	GUICtrlSetData($connexion_text,cond(FileExists($connexion), $connexion, ""))
EndFunc
Func capture_updateButtonAndContextMenu($listeParametres, $button, $menus, $format_items, $crop_items, $mode_items)
	Local $index  = 0, $texte          = ""                                                                                _
		, $format = 0, $disable_Format = False, $format_values = newList("BMP","JPG","PNG")                                _
		, $crop   = 0, $disable_Crop   = False, $crop_values   = newList("INTERNAL","WINDOW","DESKTOP","CAROTTE","MANUAL") _
		, $mode   = 0, $disable_Mode   = False, $mode_values   = newList("GLOBAL","UNIQUE")
	If $index = 3 Or $index = 5 Then $disable_Mode = True
	; Index des valeurs en cours
	$format = getIndexInList($format_values, getParametreValeurInListFromClef($listeParametres,"SnapshotFormat"))
	$crop   = getIndexInList($crop_values,   getParametreValeurInListFromClef($listeParametres,"SnapshotCrop"))
	$mode   = getIndexInList($mode_values,   getParametreValeurInListFromClef($listeParametres,"SnapshotMode"))
	; Index par dfaut
	If $format = 0 Then $format = 1
	If $crop   = 0 Then $crop   = 3
	If $mode   = 0 Then $mode   = 1
	; Activation des checkboxs
	For $i = 1 To $format_items[0]
		GUICtrlAdvancedSetState($format_items[$i], cond($i=$format,$GUI_CHECKED,$GUI_UNCHECKED))
	Next
	For $i = 1 To $crop_items[0]
		GUICtrlAdvancedSetState($crop_items[$i], cond($i=$crop,$GUI_CHECKED,$GUI_UNCHECKED))
	Next
	For $i = 1 To $mode_items[0]
		GUICtrlAdvancedSetState($mode_items[$i], cond($i=$mode,$GUI_CHECKED,$GUI_UNCHECKED))
	Next
	; Activation/dsactivation des menus "Format", "Crop" et "Mode"
	If $crop = 3 Or $crop = 5 Then $disable_Mode = True
	GUICtrlAdvancedSetState($menus[1], cond($disable_Format, $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlAdvancedSetState($menus[2], cond($disable_Crop,   $GUI_DISABLE, $GUI_ENABLE))
	GUICtrlAdvancedSetState($menus[3], cond($disable_Mode,   $GUI_DISABLE, $GUI_ENABLE))
	; Contenu du bouton
	$texte = ""
	If Not $disable_Format Then
		If $texte <> "" Then $texte &= ", "
;~ 		$texte &= getInternationalisationText($nAiO_languageResources, "IC_constants_capture_format_shortValue" & ($format-1))
		$texte &= getInternationalisationText($nAiO_languageResources, "IC_constants_capture_format_value" & ($format-1))
	EndIf
	If Not $disable_Crop   Then
		If $texte <> "" Then $texte &= ", "
;~ 		$texte &= getInternationalisationText($nAiO_languageResources, "IC_constants_capture_crop_shortValue"   & ($crop-1))
		$texte &= getInternationalisationText($nAiO_languageResources, "IC_constants_capture_crop_value"   & ($crop-1))
	EndIf
	If Not $disable_Mode   Then
		If $texte <> "" Then $texte &= ", "
;~ 		$texte &= getInternationalisationText($nAiO_languageResources, "IC_constants_capture_mode_shortValue"   & ($mode-1))
		$texte &= getInternationalisationText($nAiO_languageResources, "IC_constants_capture_mode_value"   & ($mode-1))
	EndIf
	GUICtrlSetData($button, $texte)
EndFunc
Func action_updateItems($liste, $index, $label, $size, $font, $bold, $tooltip_title, $tooltip_text, $action_type, $action_parameter, $button)
	Local $action = getActionInListAt($liste, $index)
	GUICtrlSetData($label, getActionLabel($action))
	GUICtrlSetData($size, getActionSize($action))
	Local $fonts = ""
	For $i = 1 To $ACTION_FONTS[0]
		$fonts = $fonts & "|" & $ACTION_FONTS[$i]
	Next
	GUICtrlSetData($font, $fonts, getActionFont($action))
	GUICtrlSetState($bold, cond(getActionBold($action)="Y",$GUI_CHECKED,$GUI_UNCHECKED))
	GUICtrlSetData($tooltip_title, getActionTitle($action))
	GUICtrlSetData($tooltip_text, getActionDescription($action))
	Local $types = "", $type = "0 - " & getActionTypeName(0)
	For $i = 0 To getActionTypeMax()
		$types = $types&"|"&$i&" - "&getActionTypeName($i)
		If $i = Number(getActionType($action)) Then $type = $i&" - "&getActionTypeName($i)
	Next
	GUICtrlSetData($action_type, $types, $type)
	GUICtrlSetData($action_parameter, getActionParameter($action))
	action_updatePreview($action, $button)
EndFunc
Func action_updatePreview($action, $button)
	GUICtrlSetData($button, getActionLabel($action))
	GUICtrlSetFont($button, Number(getActionSize($action)), cond(getActionBold($action)="Y",800,400), 0, getActionFont($action))
	GUICtrlSetTip($button, getActionDescription($action), getActionTitle($action))
EndFunc
Func action_updateParametreTooltip($controle, $titre)
	Switch $titre
	Case "0 - "&getActionTypeName(0)
		GUICtrlSetState($controle, $GUI_DISABLE)
		GUICtrlSetTip($controle, "")
	Case "1 - "&getActionTypeName(1)
		GUICtrlSetState($controle, $GUI_ENABLE)
		GUICtrlSetTip($controle, getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_type2"), getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_title", $titre))
	Case "2 - "&getActionTypeName(2)
		GUICtrlSetState($controle, $GUI_ENABLE)
		GUICtrlSetTip($controle, getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_type3"), getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_title", $titre))
	Case "3 - "&getActionTypeName(3)
		GUICtrlSetState($controle, $GUI_ENABLE)
		GUICtrlSetTip($controle, getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_type4"), getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_title", $titre))
	Case "4 - "&getActionTypeName(4)
		GUICtrlSetState($controle, $GUI_ENABLE)
		GUICtrlSetTip($controle, getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_type5"), getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_title", $titre))
	Case "5 - "&getActionTypeName(5)
		GUICtrlSetState($controle, $GUI_ENABLE)
		GUICtrlSetTip($controle, getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_type6"), getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_title", $titre))
	Case "6 - "&getActionTypeName(6)
		GUICtrlSetState($controle, $GUI_ENABLE)
		GUICtrlSetTip($controle, getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_type7"), getInternationalisationText($nAiO_languageResources, "IC_func_action_updatetooltip_title", $titre))
	Case Else
		GUICtrlSetState($controle, $GUI_DISABLE)
		GUICtrlSetTip($controle, "")
	EndSwitch
EndFunc
#EndRegion