#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=DamageCalc\DamageCalc.ico
#AutoIt3Wrapper_outfile=DamageCalc.exe
#AutoIt3Wrapper_Res_FileVersion=1.1.0.1
#AutoIt3Wrapper_Res_Field=Nom (short)|DamageCalc
#AutoIt3Wrapper_Res_Field=Nom (long)|DamageCalc
#AutoIt3Wrapper_Res_Field=Version (short)|1.1a
#AutoIt3Wrapper_Res_Field=Version (long)|1.1.0.1
#AutoIt3Wrapper_Res_Field=Description|Module de calcul de dgts
#AutoIt3Wrapper_Res_Field=Type|Module
#AutoIt3Wrapper_Res_Field=Auteur|ZDS [Equipe nAiO]
#AutoIt3Wrapper_Res_Field=Site|http://www.naio.fr
#AutoIt3Wrapper_Res_SaveSource=n
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; Entte du module
Global Const _
	$MODULE_NOM = "DamageCalc", $MODULE_AUTEUR = "ZDS", $MODULE_VERSION = "1.1a", $MODULE_DIR = @ScriptDir&"\"&StringRegExpReplace(@ScriptName, "\.[^\.]+$","")
Global Const _
	$DEBUG_MODE = (FileExists("debug.txt")=1), $CONNECT_MODE = ($cmdLine[0] >= 1 And $cmdLine[1] = "-connect")

; Compilation
#Include ".\DamageCalc\Compilation.au3"

#Region Librairies AutoIt
;~ #Include <GDIPlus.au3>
Global $giGDIPRef = 0, $ghGDIPDll = 0, $giGDIPToken = 0
Func GDIPlus_Startup()
	$giGDIPRef += 1
	If $giGDIPRef > 1 Then Return True
	$ghGDIPDll = DllOpen("GDIPlus.dll")
	If $ghGDIPDll = -1 Then Return SetError(1, 2, False)
	Local $tInput = DllStructCreate("uint Version;ptr Callback;bool NoThread;bool NoCodecs")
	Local $pInput = DllStructGetPtr($tInput)
	Local $tToken = DllStructCreate("ulong_ptr Data")
	Local $pToken = DllStructGetPtr($tToken)
	DllStructSetData($tInput, "Version", 1)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdiplusStartup", "ptr", $pToken, "ptr", $pInput, "ptr", 0)
	If @error Then Return SetError(@error, @extended, False)
	$giGDIPToken = DllStructGetData($tToken, "Data")
	Return $aResult[0] = 0
EndFunc
Func GDIPlus_Shutdown()
	If $ghGDIPDll = 0 Then Return SetError(-1, -1, False)
	$giGDIPRef -= 1
	If $giGDIPRef = 0 Then
		DllCall($ghGDIPDll, "none", "GdiplusShutdown", "ptr", $giGDIPToken)
		DllClose($ghGDIPDll)
		$ghGDIPDll = 0
	EndIf
	Return True
EndFunc
Func GDIPlus_ImageLoadFromFile($sFileName)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipLoadImageFromFile", "wstr", $sFileName, "ptr*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aResult[0], $aResult[2])
EndFunc
Func GDIPlus_ImageGetWidth($hImage)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipGetImageWidth", "handle", $hImage, "uint*", -1)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aResult[0], $aResult[2])
EndFunc
Func GDIPlus_ImageGetHeight($hImage)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipGetImageHeight", "handle", $hImage, "uint*", 0)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aResult[0], $aResult[2])
EndFunc
Func GDIPlus_ImageDispose($hImage)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipDisposeImage", "handle", $hImage)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0] = 0
EndFunc
;~ #Include <Array.au3>
Func ArrayAdd(ByRef $avArray, $vValue)
	If Not IsArray($avArray) Then Return SetError(1, 0, -1)
	If UBound($avArray, 0) <> 1 Then Return SetError(2, 0, -1)
	Local $iUBound = UBound($avArray)
	ReDim $avArray[$iUBound + 1]
	$avArray[$iUBound] = $vValue
	Return $iUBound
EndFunc
Func ArrayInsert(ByRef $avArray, $iElement, $vValue = "")
	If Not IsArray($avArray) Then Return SetError(1, 0, 0)
	If UBound($avArray, 0) <> 1 Then Return SetError(2, 0, 0)
	Local $iUBound = UBound($avArray) + 1
	ReDim $avArray[$iUBound]
	For $i = $iUBound - 1 To $iElement + 1 Step -1
		$avArray[$i] = $avArray[$i - 1]
	Next
	$avArray[$iElement] = $vValue
	Return $iUBound
EndFunc
;~ #Include <File.au3>

Func FileListToArray($sPath, $sFilter = "*", $iFlag = 0)
	Local $hSearch, $sFile, $sFileList, $sDelim = "|"
	$sPath = StringRegExpReplace($sPath, "[\\/]+\z", "") & "\" ; ensure single trailing backslash
	If Not FileExists($sPath) Then Return SetError(1, 1, "")
	If StringRegExp($sFilter, "[\\/:><\|]|(?s)\A\s*\z") Then Return SetError(2, 2, "")
	If Not ($iFlag = 0 Or $iFlag = 1 Or $iFlag = 2) Then Return SetError(3, 3, "")
	$hSearch = FileFindFirstFile($sPath & $sFilter)
	If @error Then Return SetError(4, 4, "")
	While 1
		$sFile = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		If ($iFlag + @extended = 2) Then ContinueLoop
		If $iFlag < 2 Or StringRegExp($sFile,"^[^\.]") Then $sFileList &= $sDelim & $sFile
	WEnd
	FileClose($hSearch)
	If Not $sFileList Then Return SetError(4, 4, "")
	Return StringSplit(StringTrimLeft($sFileList, 1), "|")
EndFunc
;~ #Include <GUIConstantsEx.au3>
Global Const $GUI_CHECKED = 1
Global Const $GUI_UNCHECKED = 4
Global Const $GUI_SHOW = 16
Global Const $GUI_HIDE = 32
Global Const $GUI_ENABLE = 64
Global Const $GUI_DISABLE = 128
Global Const $GUI_DEFBUTTON = 512
Global Const $GUI_BKCOLOR_TRANSPARENT = -2
Global Const $GUI_WS_EX_PARENTDRAG = 0x00100000
;~ #Include <Math.au3>
Func Max($nNum1, $nNum2)
	If Not IsNumber($nNum1) Then
		Return SetError(1, 0, 0)
	ElseIf Not IsNumber($nNum2) Then
		Return SetError(2, 0, 0)
	ElseIf $nNum1 > $nNum2 Then
		Return $nNum1
	Else
		Return $nNum2
	EndIf
EndFunc
Func Min($nNum1, $nNum2)
	If Not IsNumber($nNum1) Then
		Return SetError(1, 0, 0)
	ElseIf Not IsNumber($nNum2) Then
		Return SetError(2, 0, 0)
	ElseIf $nNum1 > $nNum2 Then
		Return $nNum2
	Else
		Return $nNum1
	EndIf
EndFunc
;~ #Include <Misc.au3>
Func IsPressed($touche, $dll = 'user32.dll')
	Local $resultat = DllCall($dll, "short", "GetAsyncKeyState", "int", '0x' & $touche)
	If @error Then Return SetError(@error, @extended, False)
	Return BitAND($resultat[0], 0x8000) <> 0
EndFunc
;~ #Include <StaticConstants.au3>
Global Const $SS_CENTER = 0x1
Global Const $SS_RIGHT = 0x2
;~ #Include <String.au3>
Func StringBetween($s_String, $s_Start, $s_End, $v_Case = -1)
	; Set case type
	Local $s_case = ""
	If $v_Case = Default Or $v_Case = -1 Then $s_case = "(?i)"
	; Escape characters
	Local $s_pattern_escape = "(\.|\||\*|\?|\+|\(|\)|\{|\}|\[|\]|\^|\$|\\)"
	$s_Start = StringRegExpReplace($s_Start, $s_pattern_escape, "\\$1")
	$s_End = StringRegExpReplace($s_End, $s_pattern_escape, "\\$1")
	; If you want data from beginning then replace blank start with beginning of string
	If $s_Start = "" Then $s_Start = "\A"
	; If you want data from a start to an end then replace blank with end of string
	If $s_End = "" Then $s_End = "\z"
	Local $a_ret = StringRegExp($s_String, "(?s)" & $s_case & $s_Start & "(.*?)" & $s_End, 3)
	If @error Then Return SetError(1, 0, 0)
	Return $a_ret
EndFunc
;~ #Include <UpdownConstants.au3>
Global Const $UDS_ARROWKEYS = 0x0020
;~ #Include <WindowsConstants.au3>
Global Const $WS_POPUP      = 0x80000000
Global Const $WS_BORDER     = 0x00800000
Global Const $WS_EX_ACCEPTFILES = 0x00000010
Global Const $WS_EX_LAYERED = 0x00080000
Global Const $WS_EX_TOPMOST = 0x00000008
Global Const $DS_MODALFRAME = 0x00000080
Global Const $WM_MOUSEMOVE = 0x0200
Global Const $WM_LBUTTONDOWN = 0x0201
Global Const $WM_LBUTTONUP = 0x0202
Global Const $WM_LBUTTONDBLCLK = 0x0203
Global Const $WM_RBUTTONDOWN = 0x0204
Global Const $WM_RBUTTONUP = 0x0205
#EndRegion

#Region Librairies nAiO
;~ #Include "..\Include\Fonctions Avancees.au3"
Func cond($cond, $true, $false)
	If $cond Then Return $true
	Return $false
EndFunc
Func sousmenu($gui, $target, $context)
	Local $menu = GUICtrlGetHandle($context), $position = ControlGetPos($gui, "", $target), $coords = DllStructCreate("int;int")
	DllStructSetData($coords, 1, $position[0]+10)
	DllStructSetData($coords, 2, $position[1]+10)
	DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $gui, "ptr", DllStructGetPtr($coords))
	DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $menu, "int", 0, "int", DllStructGetData($coords, 1), "int", DllStructGetData($coords, 2), "hwnd", $gui, "ptr", 0)
EndFunc
Func getControlCoords($handle="", $control="",$relative=False)
	Local $pos = ControlGetPos($handle, "", $control)
	If @error Then
		SetError(1)
		Return
	EndIf
	If $relative Then Return $pos
	Local $winpos = WinGetPos($handle)
	Local $resultat[4] = [$winpos[0]+$pos[0],$winpos[1]+$pos[1], $pos[2],$pos[3]]
	Return $resultat
EndFunc
#Include "..\Include\Menus Graphiques.au3"
#EndRegion

Global Const $DAMAGECALC_FONT = "Segoe UI"
Global $damageCalc_repertoire_data   = $MODULE_DIR & "\" & "Data"   & "\"         ; Rpertoire des donnes de configuration du DamageCalc
Global $damageCalc_repertoire_skins  = $MODULE_DIR & "\" & "Images" & "\"         ; Rpertoire des skins du DamageCalc
Global $damageCalc_programme_icone   = $MODULE_DIR & "\" & "DamageCalc.ico"       ; Icone du DamageCalc
Global $damageCalc_programme_donnees = $MODULE_DIR & "\" & "DamageCalc.xml"       ; Donnes du DamageCalc
Global $damageCalc_repertoire_images = listingSkins($damageCalc_repertoire_skins) ; Rpertoire des images du DamageCalc

TraySetIcon($damageCalc_programme_icone)

If $damageCalc_repertoire_images <> "" Then damageCalcInterface()

Func damageCalcInterface()

	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Activation du mode ModernMenu")
	GUICtrlAdvancedSetColors()

	#Region Rcupration des donnes
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Rcupration des donnes"&@CRLF&"(pour la page principale)")
	Local $damageCalc_etat_stop = False
	; Rpertoires de base
	Local $damageCalc_background = $damageCalc_repertoire_images & "Interface\Background.bmp"
	Local $page = 1
	; Caractristiques  charger
	Local $ligne_vide = "<type></type><element></element><min></min><max></max><fmelement></fmelement><fmvaleur></fmvaleur>"
	Local _
		$perso_classe     = "Inconnu", 	$perso_sexe       = "M", 	$perso_nom     = "Anonyme", 	$perso_niveau  = "1", _
		$perso_arme       = "Autre",    $perso_sort       = "",     $perso_sortXML = ""
	Local _
		$carac_vit        = "0", 		$carac_sag        = "0", 	$carac_for     = "0", 			$carac_int     = "0", _
		$carac_cha        = "0", 		$carac_agi        = "0", 	$carac_pa      = "0", 			$carac_pm      = "0"
	Local _
		$retrait_pa       = "0", 		$esquive_pa       = "0", 	$retrait_pm    = "0", 			$esquive_pm    = "0", _
		$carac_cc         = "0", 		$carac_ec         = "0", 	$carac_soins   = "0", 			$carac_tacle   = "0", _
		$carac_fuite      = "0"
	Local _
		$dom_fixe         = "0", 		$dom_pour         = "0", 	$dom_neutre    = "0", 			$dom_for       = "0", _
		$dom_int          = "0", 		$dom_cha          = "0", 	$dom_agi       = "0", 			$dom_pouss     = "0", _
		$renvoi           = "0", 		$piege_fixe       = "0",	$piege_pour    = "0"
	Local _
		$resE_neutre_fixe = "0", 		$resE_neutre_pour = "0", 	$resE_for_fixe = "0", 			$resE_for_pour = "0", _
		$resE_int_fixe    = "0", 		$resE_int_pour    = "0", 	$resE_cha_fixe = "0", 			$resE_cha_pour = "0", _
		$resE_agi_fixe    = "0", 		$resE_agi_pour    = "0", 	$resE_cri_fixe = "0", 			$resE_pou_fixe = "0"
	Local _
		$resP_neutre_fixe = "0", 		$resP_neutre_pour = "0", 	$resP_for_fixe = "0", 			$resP_for_pour = "0", _
		$resP_int_fixe    = "0", 		$resP_int_pour    = "0", 	$resP_cha_fixe = "0",	 		$resP_cha_pour = "0", _
		$resP_agi_fixe    = "0", 		$resP_agi_pour    = "0"
	Local _
		$arme_pa          = "0",        $arme_cc          = "0",    $arme_tcc      = "0",           $arme_tec      = "0", _
		$arme_lignes[7] = [0, $ligne_vide,$ligne_vide,$ligne_vide,$ligne_vide,$ligne_vide,$ligne_vide]

	; Caractristiques par page
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Rcupration des donnes"&@CRLF&"(pour les pages auxiliaires)")
		; Constitution
		Local $AUX_perso_classe[1]     = [0], $AUX_perso_sexe[1]       = [0], $AUX_perso_nom[1]        = [0], $AUX_perso_niveau[1]     = [0]
		Local $AUX_perso_arme[1]       = [0], $AUX_perso_sort[1]       = [0], $AUX_perso_sortXML[1]    = [0]
		; Page 1/5
		Local $AUX_carac_vit[1]        = [0], $AUX_carac_sag[1]        = [0], $AUX_carac_for[1]        = [0], $AUX_carac_int[1]        = [0]
		Local $AUX_carac_cha[1]        = [0], $AUX_carac_agi[1]        = [0], $AUX_carac_pa[1]         = [0], $AUX_carac_pm[1]         = [0]
		; Page 2/5
		Local $AUX_retrait_pa[1]       = [0], $AUX_esquive_pa[1]       = [0], $AUX_retrait_pm[1]       = [0], $AUX_esquive_pm[1]       = [0]
		Local $AUX_carac_cc[1]         = [0], $AUX_carac_ec[1]         = [0], $AUX_carac_soins[1]      = [0], $AUX_carac_tacle[1]      = [0]
		Local $AUX_carac_fuite[1]      = [0]
		; Page 3/5
		Local $AUX_dom_fixe[1]         = [0], $AUX_dom_pour[1]         = [0], $AUX_dom_neutre[1]       = [0], $AUX_dom_for[1]          = [0]
		Local $AUX_dom_int[1]          = [0], $AUX_dom_cha[1]          = [0], $AUX_dom_agi[1]          = [0], $AUX_dom_pouss[1]        = [0]
		Local $AUX_renvoi[1]           = [0], $AUX_piege_fixe[1]       = [0], $AUX_piege_pour[1]       = [0]
		; Page 4/5
		Local $AUX_resE_neutre_fixe[1] = [0], $AUX_resE_neutre_pour[1] = [0], $AUX_resE_for_fixe[1]    = [0], $AUX_resE_for_pour[1]    = [0]
		Local $AUX_resE_int_fixe[1]    = [0], $AUX_resE_int_pour[1]    = [0], $AUX_resE_cha_fixe[1]    = [0], $AUX_resE_cha_pour[1]    = [0]
		Local $AUX_resE_agi_fixe[1]    = [0], $AUX_resE_agi_pour[1]    = [0], $AUX_resE_cri_fixe[1]    = [0], $AUX_resE_pou_fixe[1]    = [0]
		; Page 5/5
		Local $AUX_resP_neutre_fixe[1] = [0], $AUX_resP_neutre_pour[1] = [0], $AUX_resP_for_fixe[1]    = [0], $AUX_resP_for_pour[1]    = [0]
		Local $AUX_resP_int_fixe[1]    = [0], $AUX_resP_int_pour[1]    = [0], $AUX_resP_cha_fixe[1]    = [0], $AUX_resP_cha_pour[1]    = [0]
		Local $AUX_resP_agi_fixe[1]    = [0], $AUX_resP_agi_pour[1]    = [0]
		; Configuration de l'arme
		Local $AUX_arme_lignes[1]      = [0], $AUX_attaque_pa[1]       = [0], $AUX_attaque_cc[1]       = [0], $AUX_attaque_tcc[1]      = [0]
		Local $AUX_attaque_tec[1]      = [0]
		; Constitution
		Local $AUX_constitution[1]     = [0]
		; Comparaison
		Local $comparaison_couple[2]   = [0,0]
	#EndRegion

	#Region Rcupration de la taille du fond
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Rcupration de la taille du fond")
	GDIPlus_Startup()
	Local $image = GDIPlus_ImageLoadFromFile($damageCalc_background)
	Local $GUI_position[3] = [GDIPlus_ImageGetWidth($image),GDIPlus_ImageGetHeight($image),10]
	GDIPlus_ImageDispose($image)
	GDIPlus_ShutDown()
	#EndRegion

	#Region Chargement de l'interface graphique
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Chargement de l'interface graphique")
	Local $GUI = GUICreate($MODULE_NOM&" v"&$MODULE_VERSION, _
		$GUI_position[0], $GUI_position[1], _
		Default, Default, _
		BitOR($WS_POPUP,$WS_BORDER) _
	)
	GUISetIcon($damageCalc_programme_icone)
	#EndRegion

	#Region Fond d'cran
	GUICtrlCreatePic($damageCalc_background, 0,0, $GUI_position[0],$GUI_position[1])
	GUICtrlSetState(-1, $GUI_DISABLE)
	#EndRegion

	#Region Elements gnraux
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Elements gnraux")
	Local $Bouton_Configurer = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface"&"\"&"Configurer.bmp", 258,3, 21,21)
	Local $Bouton_Deplacer   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface"&"\"&"Deplacer.bmp",   283,3, 21,21, Default, $GUI_WS_EX_PARENTDRAG)
	Local $Bouton_Quitter    = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface"&"\"&"Quitter.bmp",    308,3, 21,21)
	GUICtrlSetTip($Bouton_Configurer, "Cliquez pour sauvegarder les informations"&@CRLF&"ou restaurer une sauvegarde prcdente", "Configurer le DamageCalc")
	GUICtrlSetTip($Bouton_Deplacer,   "Glissez/dposez la bouton pour"&@CRLF&"dplacer la fentre principale", "Dplacer le DamageCalc")
	GUICtrlSetTip($Bouton_Quitter,    "Cliquez pour quitter le DamageCalc"&@CRLF&"Attention: pas de confirmation", "Quitter le DamageCalc", 2)
	Local $configurer_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	; Menu Rcupration
	Local $configurer_menu_charge = GUICtrlCreateAdvancedMenu("Rcupration",  $configurer_menu)
	Local $configurer_menu_charge_item_pageweb = GUICtrlCreateAdvancedMenuItem("depuis la page web perso", $configurer_menu_charge)
	GUICtrlCreateAdvancedMenuItem("", $configurer_menu_charge)
	; Menu Sauvegarde
	Local $configurer_menu_sauve = GUICtrlCreateAdvancedMenu("Sauvegarde", $configurer_menu)
	; Sous-menus
	Local $configurer_menu_sauve_item_fichier[21] = [20], $configurer_menu_charge_item_fichier[21] = [20]
	For $i = 1 To Min($configurer_menu_charge_item_fichier[0],$configurer_menu_sauve_item_fichier[0])
		Local $fichier = $damageCalc_repertoire_data&"Config_"&StringFormat("%02s",$i)&".ini"
		Local $check = FileExists($fichier), $titre = IniRead($fichier, "Titre", "titre", "")
		$configurer_menu_charge_item_fichier[$i] = GUICtrlCreateAdvancedMenuItem(cond($check, StringFormat("%02s",$i)&" : "&cond($titre="","Titre vide",'"'&$titre&'"'), _
			"Emplacement n"&StringFormat("%02s",$i)&" vide"), $configurer_menu_charge)
		$configurer_menu_sauve_item_fichier[$i]  = GUICtrlCreateAdvancedMenuItem(cond($check, StringFormat("%02s",$i)&" : "&cond($titre="","Titre vide",'"'&$titre&'"'), _
			"Emplacement n"&StringFormat("%02s",$i)&" vide"), $configurer_menu_sauve)
		If $check = 0 Then GUICtrlSetState($configurer_menu_charge_item_fichier[$i],$GUI_DISABLE)
	Next
	#EndRegion

	#Region Caractristiques primordiales
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques primordiales")
	Local $classe_bouton = GUICtrlCreatePic(cond( _
		FileExists($damageCalc_repertoire_images&"Classes"&"\"&$perso_classe&"\"&$perso_classe&" "&$perso_sexe&".bmp"), _
		$damageCalc_repertoire_images&"Classes"&"\"&$perso_classe&"\"&$perso_classe&" "&$perso_sexe&".bmp", _
		$damageCalc_repertoire_images&"Classes"&"\"&"Inconnu.bmp" _
	), 10,12, 74,74)
	GUICtrlSetTip($classe_bouton, "Cliquez pour changer la classe"&@CRLF&"ou le sexe du personnage", "Classe/sexe du personnage")
	Local $nom_label     = GUICtrlCreateLabel($perso_nom,90,15,190,30)
	GUICtrlSetTip($nom_label, "Cliquez pour changer le nom du personnage"&@CRLF&"(pour la rcupration depuis le site officiel)", "Nom du personnage")
	Local $classe_label  = GUICtrlCreateLabel($perso_classe&", Niveau "&$perso_niveau,90,55,240,25)
	GUICtrlSetTip($classe_label, "Cliquez pour changer le niveau du personnage"&@CRLF&"(pour la rcupration depuis le site officiel)", "Classe/niveau du personnage")
	GUICtrlSetFont(   $nom_label,    16, 400, Default, $DAMAGECALC_FONT)
	GUICtrlSetFont(   $classe_label, 12, 400, Default, $DAMAGECALC_FONT)
	GUICtrlSetColor(  $nom_label,    0xFFFFFF)
	GUICtrlSetColor(  $classe_label, 0xFFFFFF)
	GUICtrlSetBkColor($nom_label,    $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($classe_label, $GUI_BKCOLOR_TRANSPARENT)
	Local $classe_menu   = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $classe_menu_item_inconnu = GUICtrlCreateAdvancedMenuItem("Inconnu", $classe_menu)
	GUICtrlAdvancedMenuItemSetIcon($classe_menu_item_inconnu, $damageCalc_repertoire_images&"Classes"&"\"&"Inconnu.bmp")
	Local $liste_classes = FileListToArray($damageCalc_repertoire_images&"Classes","*",2)
	If @error Then
		Local $array[1] = [0]
		$liste_classes = $array
	EndIf
	Local $classe_menu_items[$liste_classes[0]+1] = [$liste_classes[0]]
	For $i = 1 To $liste_classes[0]
		$classe_menu_items[$i] = GUICtrlCreateAdvancedMenuItem($liste_classes[$i], $classe_menu)
		GUICtrlAdvancedMenuItemSetIcon($classe_menu_items[$i], $damageCalc_repertoire_images&"Classes"&"\"&$liste_classes[$i]&"\"&$liste_classes[$i]&" "&cond($perso_sexe="M","M","F")&".bmp")
	Next
	GUICtrlCreateAdvancedMenuItem("", $classe_menu)
	Local           $classe_menu_item_F = GUICtrlCreateAdvancedMenuItem("Femelle", $classe_menu)
	Local           $classe_menu_item_M = GUICtrlCreateAdvancedMenuItem("Mle",    $classe_menu)
	GUICtrlSetState($classe_menu_item_F,cond(FileExists($damageCalc_repertoire_images&"Classes"&"\"&$perso_classe),$GUI_ENABLE,$GUI_DISABLE)+cond($perso_sexe="F",$GUI_CHECKED,$GUI_UNCHECKED))
	GUICtrlSetState($classe_menu_item_M,cond(FileExists($damageCalc_repertoire_images&"Classes"&"\"&$perso_classe),$GUI_ENABLE,$GUI_DISABLE)+cond($perso_sexe="M",$GUI_CHECKED,$GUI_UNCHECKED))
	#EndRegion

	#Region Caractristiques du personnage : entte
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques du personnage : entte")
	Local $pages_titles[6]  = [5, "Caractristiques principales", "Caractristiques secondaires", "Bonus aux dommages", "Rsistances de base", "Rsistances PVP"]
	Local             $caracs_titre_label = GUICtrlCreateLabel("",40,109,285,20)
	GUICtrlSetData(   $caracs_titre_label, $pages_titles[1])
	GUICtrlSetFont(   $caracs_titre_label, 12, 400, Default, $DAMAGECALC_FONT)
	GUICtrlSetColor(  $caracs_titre_label, 0xFFFFFF)
	GUICtrlSetBkColor($caracs_titre_label, $GUI_BKCOLOR_TRANSPARENT)
	Local $matrice_items[6] = [5, "", "", "", "", ""]
	#EndRegion

	#Region Caractristiques du personnage : page 1/5
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques du personnage : page 1/5")
	Local $carac_vit_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Soin.bmp",              14,  0*25+137,    20, 20)
	Local $carac_sag_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\XP.bmp",                14,  1*25+137,    20, 20)
	Local $carac_for_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Terre.bmp",             14,  2*25+137,    20, 20)
	Local $carac_int_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Feu.bmp",               14,  3*25+137,    20, 20)
	Local $carac_cha_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Eau.bmp",               14,  4*25+137,    20, 20)
	Local $carac_agi_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Air.bmp",               14,  5*25+137,    20, 20)
	Local $carac_pa_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\PA.bmp",                14,  6*25+137,    20, 20)
	Local $carac_pm_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\PM.bmp",                14,  7*25+137,    20, 20)
	Local $carac_vit_label  = GUICtrlCreateLabel("Vitalit",                                                   45,  0*25+137,   160, 20)
	Local $carac_sag_label  = GUICtrlCreateLabel("Sagesse",                                                    45,  1*25+137,   160, 20)
	Local $carac_for_label  = GUICtrlCreateLabel("Force",                                                      45,  2*25+137,   160, 20)
	Local $carac_int_label  = GUICtrlCreateLabel("Intelligence",                                               45,  3*25+137,   160, 20)
	Local $carac_cha_label  = GUICtrlCreateLabel("Chance",                                                     45,  4*25+137,   160, 20)
	Local $carac_agi_label  = GUICtrlCreateLabel("Agilit",                                                    45,  5*25+137,   160, 20)
	Local $carac_pa_label   = GUICtrlCreateLabel("PA (Action)",                                                45,  6*25+137,   160, 20)
	Local $carac_pm_label   = GUICtrlCreateLabel("PM (Mouvement)",                                             45,  7*25+137,   160, 20)
	Local $carac_vit_valeur = GUICtrlCreateLabel("0",                                                         209,  0*25+137,    45, 20, $SS_CENTER)
	Local $carac_sag_valeur = GUICtrlCreateLabel("0",                                                         209,  1*25+137,    45, 20, $SS_CENTER)
	Local $carac_for_valeur = GUICtrlCreateLabel("0",                                                         209,  2*25+137,    45, 20, $SS_CENTER)
	Local $carac_int_valeur = GUICtrlCreateLabel("0",                                                         209,  3*25+137,    45, 20, $SS_CENTER)
	Local $carac_cha_valeur = GUICtrlCreateLabel("0",                                                         209,  4*25+137,    45, 20, $SS_CENTER)
	Local $carac_agi_valeur = GUICtrlCreateLabel("0",                                                         209,  5*25+137,    45, 20, $SS_CENTER)
	Local $carac_pa_valeur  = GUICtrlCreateLabel("0",                                                         209,  6*25+137,    45, 20, $SS_CENTER)
	Local $carac_pm_valeur  = GUICtrlCreateLabel("0",                                                         209,  7*25+137,    45, 20, $SS_CENTER)
	Local $carac_vit_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  0*25+138,    17, 17)
	Local $carac_sag_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  1*25+138,    17, 17)
	Local $carac_for_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  2*25+138,    17, 17)
	Local $carac_int_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  3*25+138,    17, 17)
	Local $carac_cha_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  4*25+138,    17, 17)
	Local $carac_agi_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  5*25+138,    17, 17)
	Local $carac_pa_modif   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  6*25+138,    17, 17)
	Local $carac_pm_modif   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",        270,  7*25+138,    17, 17)
	Local $items_racine[9]  = [8, "carac_vit", "carac_sag", "carac_for", "carac_int", "carac_cha", "carac_agi", "carac_pa", "carac_pm"]
	For $i = 1 To $items_racine[0]
		Local $label = Eval($items_racine[$i]&"_label")
		If Not @error Then
			GUICtrlSetFont($label,     11, 400, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($label,    0xFFFFFF)
			GUICtrlSetBkColor($label,  $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $valeur = Eval($items_racine[$i]&"_valeur")
		If Not @error Then
			GUICtrlSetFont($valeur,    11, 600, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($valeur,   0xFFFFFF)
			GUICtrlSetBkColor($valeur, $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $modif = Eval($items_racine[$i]&"_modif")
		If Not @error Then
			GUICtrlSetTip($modif, "Cliquez pour modifier la"&@CRLF&"valeur de "&'"'&GUICtrlRead($label)&'"')
		EndIf
	Next
	$matrice_items[1] = $items_racine
	#EndRegion

	#Region Caractristiques du personnage : page 2/5
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques du personnage : page 2/5")
	Local $retrait_pa_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\PA.bmp",              14,  0*25+137,    20, 20)
	Local $esquive_pa_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\PA.bmp",              14,  1*25+137,    20, 20)
	Local $retrait_pm_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\PM.bmp",              14,  2*25+137,    20, 20)
	Local $esquive_pm_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\PM.bmp",              14,  3*25+137,    20, 20)
	Local $carac_soins_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Soin.bmp",            14,  6*25+137,    20, 20)
	Local $retrait_pa_label   = GUICtrlCreateLabel("Retrait (PA)",                                             45,  0*25+137,   160, 20)
	Local $esquive_pa_label   = GUICtrlCreateLabel("Esquive (PA)",                                             45,  1*25+137,   160, 20)
	Local $retrait_pm_label   = GUICtrlCreateLabel("Retrait (PM)",                                             45,  2*25+137,   160, 20)
	Local $esquive_pm_label   = GUICtrlCreateLabel("Esquive (PM)",                                             45,  3*25+137,   160, 20)
	Local $carac_cc_label     = GUICtrlCreateLabel("Coups critiques",                                          45,  4*25+137,   160, 20)
	Local $carac_ec_label     = GUICtrlCreateLabel("Echecs critiques",                                         45,  5*25+137,   160, 20)
	Local $carac_soins_label  = GUICtrlCreateLabel("Bonus soins",                                              45,  6*25+137,   160, 20)
	Local $carac_tacle_label  = GUICtrlCreateLabel("Taux de tacle",                                            45,  7*25+137,   160, 20)
	Local $carac_fuite_label  = GUICtrlCreateLabel("Taux de fuite",                                            45,  8*25+137,   160, 20)
	Local $retrait_pa_valeur  = GUICtrlCreateLabel("0",                                                       209,  0*25+137,    45, 20, $SS_CENTER)
	Local $esquive_pa_valeur  = GUICtrlCreateLabel("0",                                                       209,  1*25+137,    45, 20, $SS_CENTER)
	Local $retrait_pm_valeur  = GUICtrlCreateLabel("0",                                                       209,  2*25+137,    45, 20, $SS_CENTER)
	Local $esquive_pm_valeur  = GUICtrlCreateLabel("0",                                                       209,  3*25+137,    45, 20, $SS_CENTER)
	Local $carac_cc_valeur    = GUICtrlCreateLabel("0",                                                       209,  4*25+137,    45, 20, $SS_CENTER)
	Local $carac_ec_valeur    = GUICtrlCreateLabel("0",                                                       209,  5*25+137,    45, 20, $SS_CENTER)
	Local $carac_soins_valeur = GUICtrlCreateLabel("0",                                                       209,  6*25+137,    45, 20, $SS_CENTER)
	Local $carac_tacle_valeur = GUICtrlCreateLabel("0",                                                       209,  7*25+137,    45, 20, $SS_CENTER)
	Local $carac_fuite_valeur = GUICtrlCreateLabel("0",                                                       209,  8*25+137,    45, 20, $SS_CENTER)
	Local $retrait_pa_modif   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  0*25+138,    17, 17)
	Local $esquive_pa_modif   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  1*25+138,    17, 17)
	Local $retrait_pm_modif   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  2*25+138,    17, 17)
	Local $esquive_pm_modif   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  3*25+138,    17, 17)
	Local $carac_cc_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  4*25+138,    17, 17)
	Local $carac_ec_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  5*25+138,    17, 17)
	Local $carac_soins_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  6*25+138,    17, 17)
	Local $carac_tacle_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  7*25+138,    17, 17)
	Local $carac_fuite_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",      270,  8*25+138,    17, 17)
	Local $items_racine[10]   = [9, "retrait_pa", "esquive_pa", "retrait_pm", "esquive_pm", "carac_cc", "carac_ec", "carac_soins", "carac_tacle", "carac_fuite"]
	For $i = 1 To $items_racine[0]
		Local $label = Eval($items_racine[$i]&"_label")
		If Not @error Then
			GUICtrlSetFont($label,     11, 400, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($label,    0xFFFFFF)
			GUICtrlSetBkColor($label,  $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $valeur = Eval($items_racine[$i]&"_valeur")
		If Not @error Then
			GUICtrlSetFont($valeur,    11, 600, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($valeur,   0xFFFFFF)
			GUICtrlSetBkColor($valeur, $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $modif = Eval($items_racine[$i]&"_modif")
		If Not @error Then
			GUICtrlSetTip($modif, "Cliquez pour modifier la"&@CRLF&"valeur de "&'"'&GUICtrlRead($label)&'"')
		EndIf
	Next
	$matrice_items[2] = $items_racine
	#EndRegion

	#Region Caractristiques du personnage : page 3/5
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques du personnage : page 3/5")
	Local $dom_neutre_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Neutre.bmp",           14,  2*25+137,    20, 20)
	Local $dom_for_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Terre.bmp",            14,  3*25+137,    20, 20)
	Local $dom_int_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Feu.bmp",              14,  4*25+137,    20, 20)
	Local $dom_cha_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Eau.bmp",              14,  5*25+137,    20, 20)
	Local $dom_agi_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Air.bmp",              14,  6*25+137,    20, 20)
	Local $dom_fixe_label    = GUICtrlCreateLabel("Dommages",                                                  45,  0*25+137,   160, 20)
	Local $dom_pour_label    = GUICtrlCreateLabel("Dommages (%)",                                              45,  1*25+137,   160, 20)
	Local $dom_neutre_label  = GUICtrlCreateLabel("Neutre (fixe)",                                             45,  2*25+137,   160, 20)
	Local $dom_for_label     = GUICtrlCreateLabel("Terre (fixe)",                                              45,  3*25+137,   160, 20)
	Local $dom_int_label     = GUICtrlCreateLabel("Feu (fixe)",                                                45,  4*25+137,   160, 20)
	Local $dom_cha_label     = GUICtrlCreateLabel("Eau (fixe)",                                                45,  5*25+137,   160, 20)
	Local $dom_agi_label     = GUICtrlCreateLabel("Air (fixe)",                                                45,  6*25+137,   160, 20)
	Local $dom_pouss_label   = GUICtrlCreateLabel("Pousse",                                                   45,  7*25+137,   160, 20)
	Local $renvoi_label      = GUICtrlCreateLabel("Renvoi",                                                    45,  8*25+137,   160, 20)
	Local $piege_fixe_label  = GUICtrlCreateLabel("Piges (fixe)",                                             45,  9*25+137,   160, 20)
	Local $piege_pour_label  = GUICtrlCreateLabel("Piges (%)",                                                45, 10*25+137,   160, 20)
	Local $dom_fixe_valeur   = GUICtrlCreateLabel("0",                                                        209,  0*25+137,    45, 20, $SS_CENTER)
	Local $dom_pour_valeur   = GUICtrlCreateLabel("0",                                                        209,  1*25+137,    45, 20, $SS_CENTER)
	Local $dom_neutre_valeur = GUICtrlCreateLabel("0",                                                        209,  2*25+137,    45, 20, $SS_CENTER)
	Local $dom_for_valeur    = GUICtrlCreateLabel("0",                                                        209,  3*25+137,    45, 20, $SS_CENTER)
	Local $dom_int_valeur    = GUICtrlCreateLabel("0",                                                        209,  4*25+137,    45, 20, $SS_CENTER)
	Local $dom_cha_valeur    = GUICtrlCreateLabel("0",                                                        209,  5*25+137,    45, 20, $SS_CENTER)
	Local $dom_agi_valeur    = GUICtrlCreateLabel("0",                                                        209,  6*25+137,    45, 20, $SS_CENTER)
	Local $dom_pouss_valeur  = GUICtrlCreateLabel("0",                                                        209,  7*25+137,    45, 20, $SS_CENTER)
	Local $renvoi_valeur     = GUICtrlCreateLabel("0",                                                        209,  8*25+137,    45, 20, $SS_CENTER)
	Local $piege_fixe_valeur = GUICtrlCreateLabel("0",                                                        209,  9*25+137,    45, 20, $SS_CENTER)
	Local $piege_pour_valeur = GUICtrlCreateLabel("0",                                                        209, 10*25+137,    45, 20, $SS_CENTER)
	Local $dom_fixe_modif    = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  0*25+138,    17, 17)
	Local $dom_pour_modif    = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  1*25+138,    17, 17)
	Local $dom_neutre_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  2*25+138,    17, 17)
	Local $dom_for_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  3*25+138,    17, 17)
	Local $dom_int_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  4*25+138,    17, 17)
	Local $dom_cha_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  5*25+138,    17, 17)
	Local $dom_agi_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  6*25+138,    17, 17)
	Local $dom_pouss_modif   = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  7*25+138,    17, 17)
	Local $renvoi_modif      = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  8*25+138,    17, 17)
	Local $piege_fixe_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270,  9*25+138,    17, 17)
	Local $piege_pour_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp",       270, 10*25+138,    17, 17)
	Local $items_racine[12]  = [11, "dom_fixe", "dom_pour", "dom_neutre", "dom_for", "dom_int", "dom_cha", "dom_agi", "dom_pouss", "renvoi", "piege_fixe", "piege_pour"]
	For $i = 1 To $items_racine[0]
		Local $label = Eval($items_racine[$i]&"_label")
		If Not @error Then
			GUICtrlSetFont($label,     11, 400, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($label,    0xFFFFFF)
			GUICtrlSetBkColor($label,  $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $valeur = Eval($items_racine[$i]&"_valeur")
		If Not @error Then
			GUICtrlSetFont($valeur,    11, 600, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($valeur,   0xFFFFFF)
			GUICtrlSetBkColor($valeur, $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $modif = Eval($items_racine[$i]&"_modif")
		If Not @error Then
			GUICtrlSetTip($modif, "Cliquez pour modifier la"&@CRLF&"valeur de "&'"'&GUICtrlRead($label)&'"')
		EndIf
	Next
	$matrice_items[3] = $items_racine
	#EndRegion

	#Region Caractristiques du personnage : page 4/5
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques du personnage : page 4/5")
	Local $resE_neutre_fixe_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Neutre.bmp",     14,  0*25+137,    20, 20)
	Local $resE_neutre_pour_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Neutre.bmp",     14,  1*25+137,    20, 20)
	Local $resE_for_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Terre.bmp",      14,  2*25+137,    20, 20)
	Local $resE_for_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Terre.bmp",      14,  3*25+137,    20, 20)
	Local $resE_int_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Feu.bmp",        14,  4*25+137,    20, 20)
	Local $resE_int_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Feu.bmp",        14,  5*25+137,    20, 20)
	Local $resE_cha_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Eau.bmp",        14,  6*25+137,    20, 20)
	Local $resE_cha_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Eau.bmp",        14,  7*25+137,    20, 20)
	Local $resE_agi_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Air.bmp",        14,  8*25+137,    20, 20)
	Local $resE_agi_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Air.bmp",        14,  9*25+137,    20, 20)
	Local $resE_neutre_fixe_label  = GUICtrlCreateLabel("Neutre (fixe)",                                       45,  0*25+137,   160, 20)
	Local $resE_neutre_pour_label  = GUICtrlCreateLabel("Neutre (%)",                                          45,  1*25+137,   160, 20)
	Local $resE_for_fixe_label     = GUICtrlCreateLabel("Terre (fixe)",                                        45,  2*25+137,   160, 20)
	Local $resE_for_pour_label     = GUICtrlCreateLabel("Terre (%)",                                           45,  3*25+137,   160, 20)
	Local $resE_int_fixe_label     = GUICtrlCreateLabel("Feu (fixe)",                                          45,  4*25+137,   160, 20)
	Local $resE_int_pour_label     = GUICtrlCreateLabel("Feu (%)",                                             45,  5*25+137,   160, 20)
	Local $resE_cha_fixe_label     = GUICtrlCreateLabel("Eau (fixe)",                                          45,  6*25+137,   160, 20)
	Local $resE_cha_pour_label     = GUICtrlCreateLabel("Eau (%)",                                             45,  7*25+137,   160, 20)
	Local $resE_agi_fixe_label     = GUICtrlCreateLabel("Air (fixe)",                                          45,  8*25+137,   160, 20)
	Local $resE_agi_pour_label     = GUICtrlCreateLabel("Air (%)",                                             45,  9*25+137,   160, 20)
	Local $resE_cri_fixe_label     = GUICtrlCreateLabel("Coup critique (fixe)",                                45, 10*25+137,   160, 20)
	Local $resE_pou_fixe_label     = GUICtrlCreateLabel("Pousse (fixe)",                                      45, 11*25+137,   160, 20)
	Local $resE_neutre_fixe_valeur = GUICtrlCreateLabel("0",                                                  209,  0*25+137,    45, 20, $SS_CENTER)
	Local $resE_neutre_pour_valeur = GUICtrlCreateLabel("0",                                                  209,  1*25+137,    45, 20, $SS_CENTER)
	Local $resE_for_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  2*25+137,    45, 20, $SS_CENTER)
	Local $resE_for_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  3*25+137,    45, 20, $SS_CENTER)
	Local $resE_int_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  4*25+137,    45, 20, $SS_CENTER)
	Local $resE_int_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  5*25+137,    45, 20, $SS_CENTER)
	Local $resE_cha_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  6*25+137,    45, 20, $SS_CENTER)
	Local $resE_cha_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  7*25+137,    45, 20, $SS_CENTER)
	Local $resE_agi_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  8*25+137,    45, 20, $SS_CENTER)
	Local $resE_agi_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  9*25+137,    45, 20, $SS_CENTER)
	Local $resE_cri_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209, 10*25+137,    45, 20, $SS_CENTER)
	Local $resE_pou_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209, 11*25+137,    45, 20, $SS_CENTER)
	Local $resE_neutre_fixe_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  0*25+138,    17, 17)
	Local $resE_neutre_pour_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  1*25+138,    17, 17)
	Local $resE_for_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  2*25+138,    17, 17)
	Local $resE_for_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  3*25+138,    17, 17)
	Local $resE_int_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  4*25+138,    17, 17)
	Local $resE_int_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  5*25+138,    17, 17)
	Local $resE_cha_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  6*25+138,    17, 17)
	Local $resE_cha_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  7*25+138,    17, 17)
	Local $resE_agi_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  8*25+138,    17, 17)
	Local $resE_agi_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  9*25+138,    17, 17)
	Local $resE_cri_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270, 10*25+138,    17, 17)
	Local $resE_pou_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270, 11*25+138,    17, 17)
	Local $items_racine[13]        = [12, "resE_neutre_fixe", "resE_neutre_pour", "resE_for_fixe", "resE_for_pour", "resE_int_fixe", "resE_int_pour", _
										  "resE_cha_fixe", "resE_cha_pour", "resE_agi_fixe", "resE_agi_pour", "resE_cri_fixe", "resE_pou_fixe"]
	For $i = 1 To $items_racine[0]
		Local $label = Eval($items_racine[$i]&"_label")
		If Not @error Then
			GUICtrlSetFont($label,     11, 400, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($label,    0xFFFFFF)
			GUICtrlSetBkColor($label,  $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $valeur = Eval($items_racine[$i]&"_valeur")
		If Not @error Then
			GUICtrlSetFont($valeur,    11, 600, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($valeur,   0xFFFFFF)
			GUICtrlSetBkColor($valeur, $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $modif = Eval($items_racine[$i]&"_modif")
		If Not @error Then
			GUICtrlSetTip($modif, "Cliquez pour modifier la"&@CRLF&"valeur de "&'"'&GUICtrlRead($label)&'"')
		EndIf
	Next
	$matrice_items[4] = $items_racine
	#EndRegion

	#Region Caractristiques du personnage : page 5/5
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques du personnage : page 5/5")
	Local $resP_neutre_fixe_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Neutre.bmp",     14,  0*25+137,    20, 20)
	Local $resP_neutre_pour_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Neutre.bmp",     14,  1*25+137,    20, 20)
	Local $resP_for_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Terre.bmp",      14,  2*25+137,    20, 20)
	Local $resP_for_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Terre.bmp",      14,  3*25+137,    20, 20)
	Local $resP_int_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Feu.bmp",        14,  4*25+137,    20, 20)
	Local $resP_int_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Feu.bmp",        14,  5*25+137,    20, 20)
	Local $resP_cha_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Eau.bmp",        14,  6*25+137,    20, 20)
	Local $resP_cha_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Eau.bmp",        14,  7*25+137,    20, 20)
	Local $resP_agi_fixe_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Air.bmp",        14,  8*25+137,    20, 20)
	Local $resP_agi_pour_pic       = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments\Air.bmp",        14,  9*25+137,    20, 20)
	Local $resP_neutre_fixe_label  = GUICtrlCreateLabel("Neutre (fixe)",                                       45,  0*25+137,   160, 20)
	Local $resP_neutre_pour_label  = GUICtrlCreateLabel("Neutre (%)",                                          45,  1*25+137,   160, 20)
	Local $resP_for_fixe_label     = GUICtrlCreateLabel("Terre (fixe)",                                        45,  2*25+137,   160, 20)
	Local $resP_for_pour_label     = GUICtrlCreateLabel("Terre (%)",                                           45,  3*25+137,   160, 20)
	Local $resP_int_fixe_label     = GUICtrlCreateLabel("Feu (fixe)",                                          45,  4*25+137,   160, 20)
	Local $resP_int_pour_label     = GUICtrlCreateLabel("Feu (%)",                                             45,  5*25+137,   160, 20)
	Local $resP_cha_fixe_label     = GUICtrlCreateLabel("Eau (fixe)",                                          45,  6*25+137,   160, 20)
	Local $resP_cha_pour_label     = GUICtrlCreateLabel("Eau (%)",                                             45,  7*25+137,   160, 20)
	Local $resP_agi_fixe_label     = GUICtrlCreateLabel("Air (fixe)",                                          45,  8*25+137,   160, 20)
	Local $resP_agi_pour_label     = GUICtrlCreateLabel("Air (%)",                                             45,  9*25+137,   160, 20)
	Local $resP_neutre_fixe_valeur = GUICtrlCreateLabel("0",                                                  209,  0*25+137,    45, 20, $SS_CENTER)
	Local $resP_neutre_pour_valeur = GUICtrlCreateLabel("0",                                                  209,  1*25+137,    45, 20, $SS_CENTER)
	Local $resP_for_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  2*25+137,    45, 20, $SS_CENTER)
	Local $resP_for_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  3*25+137,    45, 20, $SS_CENTER)
	Local $resP_int_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  4*25+137,    45, 20, $SS_CENTER)
	Local $resP_int_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  5*25+137,    45, 20, $SS_CENTER)
	Local $resP_cha_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  6*25+137,    45, 20, $SS_CENTER)
	Local $resP_cha_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  7*25+137,    45, 20, $SS_CENTER)
	Local $resP_agi_fixe_valeur    = GUICtrlCreateLabel("0",                                                  209,  8*25+137,    45, 20, $SS_CENTER)
	Local $resP_agi_pour_valeur    = GUICtrlCreateLabel("0",                                                  209,  9*25+137,    45, 20, $SS_CENTER)
	Local $resP_neutre_fixe_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  0*25+138,    17, 17)
	Local $resP_neutre_pour_modif  = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  1*25+138,    17, 17)
	Local $resP_for_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  2*25+138,    17, 17)
	Local $resP_for_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  3*25+138,    17, 17)
	Local $resP_int_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  4*25+138,    17, 17)
	Local $resP_int_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  5*25+138,    17, 17)
	Local $resP_cha_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  6*25+138,    17, 17)
	Local $resP_cha_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  7*25+138,    17, 17)
	Local $resP_agi_fixe_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  8*25+138,    17, 17)
	Local $resP_agi_pour_modif     = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Modifier.bmp", 270,  9*25+138,    17, 17)
	Local $items_racine[11]        = [10, "resP_neutre_fixe", "resP_neutre_pour", "resP_for_fixe", "resP_for_pour", "resP_int_fixe", "resP_int_pour", _
	                                      "resP_cha_fixe", "resP_cha_pour", "resP_agi_fixe", "resP_agi_pour"]
	For $i = 1 To $items_racine[0]
		Local $label = Eval($items_racine[$i]&"_label")
		If Not @error Then
			GUICtrlSetFont($label,     11, 400, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($label,    0xFFFFFF)
			GUICtrlSetBkColor($label,  $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $valeur = Eval($items_racine[$i]&"_valeur")
		If Not @error Then
			GUICtrlSetFont($valeur,    11, 600, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($valeur,   0xFFFFFF)
			GUICtrlSetBkColor($valeur, $GUI_BKCOLOR_TRANSPARENT)
		EndIf
		Local $modif = Eval($items_racine[$i]&"_modif")
		If Not @error Then
			GUICtrlSetTip($modif, "Cliquez pour modifier la"&@CRLF&"valeur de "&'"'&GUICtrlRead($label)&'"')
		EndIf
	Next
	$matrice_items[5] = $items_racine
	#EndRegion

	#Region Elments des pages
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Elments des pages")
	Local $Bouton_pages[$matrice_items[0]+1] = [$matrice_items[0]]
	Local _
		$Bouton_page_up   = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface\Haut" & cond($page>1,                "", "_inactif") & ".bmp", 307,135, 15,9), _
		$Bouton_page_down = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface\Bas"  & cond($page<$Bouton_pages[0], "", "_inactif") & ".bmp", 307,450, 15,9)
	GUICtrlSetTip($Bouton_page_up, "Cliquez pour aller  la page prcdente", "Page prcdente")
	GUICtrlSetTip($Bouton_page_down, "Cliquez pour aller  la page suivante", "Page suivante")
	GUICtrlSetState($Bouton_page_up,   cond($page>1,                $GUI_ENABLE, $GUI_DISABLE))
	GUICtrlSetState($Bouton_page_down, cond($page<$Bouton_pages[0], $GUI_ENABLE, $GUI_DISABLE))
	For $i = 1 To $Bouton_pages[0]
		$Bouton_pages[$i] = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface\Deroulement" & cond($page=$i, "", "_vide") & ".bmp", 307,145+61*($i-1), 15,60)
		GUICtrlSetTip($Bouton_pages[$i], "Cliquez pour aller directement"&@CRLF&" la page selectionne", "Page '"&$pages_titles[$i]&"' ("&$i&"/"&$Bouton_pages[0]&")")
		Local $state = cond($page = $i,$GUI_SHOW,$GUI_HIDE)
		Local $items_racine = $matrice_items[$i]
		For $j = 1 To $items_racine[0]
			Local $pic = Eval($items_racine[$j]&"_pic")
			If Not @error Then GUICtrlSetState($pic,$state)
			Local $label = Eval($items_racine[$j]&"_label")
			If Not @error Then GUICtrlSetState($label,$state)
			Local $valeur = Eval($items_racine[$j]&"_valeur")
			If Not @error Then GUICtrlSetState($valeur,$state)
			Local $modif = Eval($items_racine[$j]&"_modif")
			If Not @error Then GUICtrlSetState($modif,$state)
		Next
	Next
	; Menu Remise  zro
	Local $reinitialiser = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Reinitialiser.bmp", 209,13*25+139,  45,16)
	GUICtrlSetTip($reinitialiser, "Cliquez pour rinitialiser la page en cours"&@CRLF&"ou toutes les pages de caractristiques", "Rinitialisation des valeurs")
	Local $reinitialiser_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $reinitialiser_item_pageX = GUICtrlCreateAdvancedMenuItem("Remise  zro de la page actuelle", $reinitialiser_menu)
	Local $reinitialiser_item_pages = GUICtrlCreateAdvancedMenuItem("Remise  zro de toutes les pages", $reinitialiser_menu)
	#EndRegion

	#Region Barre de progression
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Barre de progression")
	Local $progression = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Progression\0.bmp", ($GUI_position[0]-215)/2,485,  215,16)
	#EndRegion

	#Region Caractristiques de l'arme
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Caractristiques de l'arme")
	Local $arme_titre_label = GUICtrlCreateLabel(" Caractristiques de l'arme",40,506,285,20)
	GUICtrlSetFont(   $arme_titre_label, 12, 400, Default, $DAMAGECALC_FONT)
	GUICtrlSetColor(  $arme_titre_label, 0xFFFFFF)
	GUICtrlSetBkColor($arme_titre_label, $GUI_BKCOLOR_TRANSPARENT)
	Local $arme_bouton = GUICtrlCreatePic(cond( _
		FileExists($damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp"), _
		$damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp", _
		$damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp" _
	), 20,530, 74,74)
	GUICtrlSetTip($arme_bouton, "Cliquez pour changer l'attaque"&@CRLF&"du personnage (sort ou arme)", "Arme/sort du personnage")
	Local $arme_label = GUICtrlCreateLabel($perso_arme, 95,535, 232,30)
	Local $ppr_label  = GUICtrlCreateLabel("PPR : 0 ",   95,541, 232,30, $SS_RIGHT)
	GUICtrlSetTip($ppr_label, "Rsultat de la formule de PPR"&@CRLF&"(version utilise : 1.0.1)", "PPR de l'arme slectionne")
	GUICtrlSetFont(   $arme_label, 16, 400, Default, $DAMAGECALC_FONT)
	GUICtrlSetFont(   $ppr_label,  13, 400, 2,       $DAMAGECALC_FONT)
	GUICtrlSetColor(  $arme_label, 0xFFFFFF)
	GUICtrlSetColor(  $ppr_label,  0xFFFFFF)
	GUICtrlSetBkColor($arme_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetBkColor($ppr_label,  $GUI_BKCOLOR_TRANSPARENT)
	Local $arme_menu   = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $arme_menu_item_inconnu = GUICtrlCreateAdvancedMenuItem("Autre", $arme_menu)
	GUICtrlAdvancedMenuItemSetIcon($arme_menu_item_inconnu, $damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp")
	Local $liste_armes = FileListToArray($damageCalc_repertoire_images&"Armes","*",2)
	Local $liste_sorts[1][2] = [[0,""]]
	If @error Then
		Local $array[1] = [0]
		$liste_armes = $array
	EndIf
	Local $arme_menu_items[$liste_armes[0]+1] = [$liste_armes[0]]
	For $i = 1 To $liste_armes[0]
		$arme_menu_items[$i] = GUICtrlCreateAdvancedMenuItem($liste_armes[$i], $arme_menu)
		GUICtrlAdvancedMenuItemSetIcon($arme_menu_items[$i], $damageCalc_repertoire_images&"Armes"&"\"&$liste_armes[$i]&"\"&$liste_armes[$i]&".bmp")
	Next
	#EndRegion

	#Region Configuration de l'arme
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Configuration de l'arme")
	Local $arme_config_bouton = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Large.bmp", 100,575, 85,27)
	Local $arme_config_label  = GUICtrlCreateLabel("Modifier", 100,580, 85,25, $SS_CENTER)
	GUICtrlSetTip($arme_config_label, "Cliquez pour modifier les paramtres de l'arme"&@CRLF&"ou pour choisir un sort de classe", "Configuration de l'attaque slectionne")
	GUICtrlSetFont(   $arme_config_label, 11, 600, Default, "Segoe Media Center Semibold")
	GUICtrlSetColor(  $arme_config_label, 0x28221F)
	GUICtrlSetBkColor($arme_config_label, $GUI_BKCOLOR_TRANSPARENT)
	; Menu en cas de choix d'une arme
	Local $arme_config_menu   = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $arme_config_menu_items_lignes[7] = [6,"","","","",""]
	Local $icone = cond(FileExists($damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp"), _
		$damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp", _
		$damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp")
	For $i = 1 To $arme_config_menu_items_lignes[0]
		$arme_config_menu_items_lignes[$i] = GUICtrlCreateAdvancedMenuItem(ligne_arme_tostring($arme_lignes[$i]), $arme_config_menu)
		GUICtrlAdvancedMenuItemSetIcon($arme_config_menu_items_lignes[$i], $icone)
		GUICtrlSetState($arme_config_menu_items_lignes[$i],0)
		If $i = $arme_lignes[0]+1 Then
			GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$i],"Ajouter nouvelle ligne")
			GUICtrlSetState($arme_config_menu_items_lignes[$i],$GUI_DEFBUTTON)
		ElseIf $i > $arme_lignes[0]+1 Then
			GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$i],"-")
			GUICtrlSetState($arme_config_menu_items_lignes[$i],$GUI_DISABLE)
		EndIf
	Next
	GUICtrlCreateAdvancedMenuItem("", $arme_config_menu)
	Local $arme_config_menu_items_pa  = GUICtrlCreateAdvancedMenuItem("Nombre de PA : " & cond(Number($arme_pa)  > 0,        Number($arme_pa),  "Aucun"),           $arme_config_menu)
	Local $arme_config_menu_items_cc  = GUICtrlCreateAdvancedMenuItem("Bonus CC : " &     cond(Number($arme_cc)  > 0, "+" &  Number($arme_cc),  "Aucun"),           $arme_config_menu)
	Local $arme_config_menu_items_tcc = GUICtrlCreateAdvancedMenuItem("Taux CC : " &      cond(Number($arme_tcc) > 1, "1/" & Number($arme_tcc), "Pas de critique"), $arme_config_menu)
	Local $arme_config_menu_items_tec = GUICtrlCreateAdvancedMenuItem("Taux EC : " &      cond(Number($arme_tec) > 1, "1/" & Number($arme_tec), "Pas d'echec"),     $arme_config_menu)
	; Menu en cas de choix de sort
	Local $sort_config_menu   = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $sort_config_menu_items[1] = [0]
	updateSortMenu($sort_config_menu_items, $liste_sorts, $sort_config_menu)
	#EndRegion

	#Region Lancement des fentres auxiliaires
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Lancement des fentres auxiliaires")
	Local $effet_lance_bouton = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Large.bmp", 195,575, 85,27)
	Local $effet_lance_label  = GUICtrlCreateLabel("Afficher", 195,580, 85,25, $SS_CENTER)
	GUICtrlSetTip($effet_lance_label, "Cliquez pour afficher le rsultat du calcul"&@CRLF&"de dgts dans une fentre auxiliaire", "Affichage des effets de l'attaque")
	GUICtrlSetFont(   $effet_lance_label, 11, 600, Default, "Segoe Media Center Semibold")
	GUICtrlSetColor(  $effet_lance_label, 0x28221F)
	GUICtrlSetBkColor($effet_lance_label, $GUI_BKCOLOR_TRANSPARENT)
	Local $effet_efface_bouton = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Normal_inactif.bmp", 290,575, 28,27)
	Local $effet_efface_label  = GUICtrlCreateLabel("X", 290,580, 28,25, $SS_CENTER)
	GUICtrlSetTip($effet_efface_label, "Cliquez pour effacer les fentres auxiliaires", "Rinitialisation")
	GUICtrlSetFont(   $effet_efface_label, 11, 600, Default, "Segoe Media Center Semibold")
	GUICtrlSetColor(  $effet_efface_label, 0x28221F)
	GUICtrlSetBkColor($effet_efface_label, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetState($effet_efface_bouton, $GUI_DISABLE)
	GUICtrlSetState($effet_efface_label,  $GUI_DISABLE)
	#EndRegion

	#Region Remplissage des caractristiques
	displayTip($MODULE_NOM&" v"&$MODULE_VERSION,"Remplissage des caractristiques")
	For $i = 1 To $matrice_items[0]
		Local $racines = $matrice_items[$i]
		For $j = 1 To $racines[0]
			GUICtrlSetData(Eval($racines[$j]&"_valeur"),Number(Eval($racines[$j])))
		Next
	Next
	#EndRegion

	#Region Variables d'tat de l'interface
;~ 	Local $damageCalc_etat_move = False
	#EndRegion

	displayTip()
	GUISetState(@SW_SHOW,$GUI)
	Local $AUX_GUI[1] = [0]
	Local $dll = DllOpen("user32.dll")
	While True
		; Traitement des messages
		Local $msgGUI = GUIGetMsg(1), $msgTray = TrayGetMsg()
		If WinActive($GUI) Then                                                                                                                      ; Raccourci de changement de page
			If $page > 1 And IsPressed("21", $dll) Then
				$msgGUI[1] = $GUI
				$msgGUI[0] = $Bouton_pages[$page-1]
			ElseIf $page < $Bouton_pages[0] And IsPressed("22", $dll) Then
				$msgGUI[1] = $GUI
				$msgGUI[0] = $Bouton_pages[$page+1]
			EndIf
		EndIf
		Switch $msgGUI[1]
		Case $GUI ; Fentre principale
			#Region Traitement des commandes gnrales
			Switch $msgGUI[0]
			Case $Bouton_Quitter                                                                                                                     ; Bouton Quitter
				ExitLoop
			Case $Bouton_Configurer                                                                                                                  ; Bouton Configurer
				sousmenu($GUI, $Bouton_Configurer, $configurer_menu)
			Case $configurer_menu_charge_item_pageweb                                                                                                ; Bouton Rcupration depuis le site web
				displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "La rcupration des caractristiques d'un personnage"&@CRLF&"depuis la page perso du site officiel Ankama Dofus"&@CRLF& _
					"n'est pas implmente pour le moment."&@CRLF&"(Un peu de patience ^^)")
			Case Else
				For $i = 1 To $configurer_menu_sauve_item_fichier[0]                                                                                 ; Choix de la sauvegarde dans le menu
					If $msgGUI[0] = $configurer_menu_sauve_item_fichier[$i] Then
						Local $fichier = $damageCalc_repertoire_data&"Config_"&StringFormat("%02s",$i)&".ini", $ok = True
						displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le libell de la sauvegarde n"&StringFormat("%02s",$i)&@CRLF&"(chaine de 3  50 caractres)")
						Local $titre = guiValeur($GUI, IniRead($fichier,"Titre","titre",""), "STRING", 3, 50, $Bouton_Configurer)
						$ok = (@error = 0)
						displayTip()
						If $ok Then
							FileClose(FileOpen($fichier,10))
							IniWrite($fichier, "Titre", "titre", $titre)
							; Caractristiques de base
							IniWrite($fichier, "Caractristiques", "perso_classe", $perso_classe)
							IniWrite($fichier, "Caractristiques", "perso_sexe",   $perso_sexe)
							IniWrite($fichier, "Caractristiques", "perso_nom",    $perso_nom)
							IniWrite($fichier, "Caractristiques", "perso_niveau", $perso_niveau)
							; Caractristiques par page
							For $j = 1 To $matrice_items[0]
								Local $racines = $matrice_items[$j]
								For $k = 1 To $racines[0]
									setProgression($progression,(100/$matrice_items[0])*($j-1)+(100/$matrice_items[0])*($k/$racines[0]))
									IniWrite($fichier, "Caractristiques", $racines[$k], Eval($racines[$k]))
								Next
							Next
							; Caractristiques de l'arme
							IniWrite($fichier, "Caractristiques", "perso_arme",  $perso_arme)
							IniWrite($fichier, "Caractristiques", "perso_sort",  $perso_sort)
							IniWrite($fichier, "Caractristiques", "arme_ligne0", $arme_lignes[0])
							IniWrite($fichier, "Caractristiques", "arme_ligne1", $arme_lignes[1])
							IniWrite($fichier, "Caractristiques", "arme_ligne2", $arme_lignes[2])
							IniWrite($fichier, "Caractristiques", "arme_ligne3", $arme_lignes[3])
							IniWrite($fichier, "Caractristiques", "arme_ligne4", $arme_lignes[4])
							IniWrite($fichier, "Caractristiques", "arme_ligne5", $arme_lignes[5])
							IniWrite($fichier, "Caractristiques", "arme_ligne6", $arme_lignes[6])
							IniWrite($fichier, "Caractristiques", "arme_pa",     $arme_pa)
							IniWrite($fichier, "Caractristiques", "arme_cc",     $arme_cc)
							IniWrite($fichier, "Caractristiques", "arme_tcc",    $arme_tcc)
							IniWrite($fichier, "Caractristiques", "arme_tec",    $arme_tec)
							; Mise  jour des menus
							GUICtrlAdvancedMenuItemSetText($configurer_menu_charge_item_fichier[$i], StringFormat("%02s",$i)&" : "&cond($titre="","Titre vide",'"'&$titre&'"'))
							GUICtrlAdvancedMenuItemSetText($configurer_menu_sauve_item_fichier[$i],  StringFormat("%02s",$i)&" : "&cond($titre="","Titre vide",'"'&$titre&'"'))
							GUICtrlSetState($configurer_menu_charge_item_fichier[$i],$GUI_ENABLE)
						EndIf
						setProgression($progression)
					EndIf
				Next
				For $i = 1 To $configurer_menu_charge_item_fichier[0]                                                                                ; Choix de la rcupration dans le menu
					If $msgGUI[0] = $configurer_menu_charge_item_fichier[$i] Then
						Local $fichier = $damageCalc_repertoire_data&"Config_"&StringFormat("%02s",$i)&".ini", $ok = True
						If $ok Then
							; Base
							$perso_classe = IniRead($fichier, "Caractristiques", "perso_classe", "Inconnu")
							$perso_sexe   = IniRead($fichier, "Caractristiques", "perso_sexe", "M")
							$perso_nom    = IniRead($fichier, "Caractristiques", "perso_nom", "Tapez le nom ici")
							$perso_niveau = IniRead($fichier, "Caractristiques", "perso_niveau", "1")
							; Caractristiques par page
							For $j = 1 To $matrice_items[0]
								Local $racines = $matrice_items[$j]
								For $k = 1 To $racines[0]
									setProgression($progression,(50/$matrice_items[0])*($j-1)+(50/$matrice_items[0])*($k/$racines[0]))
									Assign($racines[$k], Number(IniRead($fichier, "Caractristiques", $racines[$k], "0")))
								Next
							Next
							For $j = 1 To $matrice_items[0]
								Local $racines = $matrice_items[$j]
								For $k = 1 To $racines[0]
									setProgression($progression,50+(50/$matrice_items[0])*($j-1)+(50/$matrice_items[0])*($k/$racines[0]))
									Assign($racines[$k], Number(IniRead($fichier, "Caractristiques", $racines[$k], "0")))
									GUICtrlSetColor(Eval($racines[$k]&"_label"),  0xFFFFFF)
									GUICtrlSetColor(Eval($racines[$k]&"_valeur"), 0xFFFFFF)
									GUICtrlSetData( Eval($racines[$k]&"_valeur"), Eval($racines[$k]))
								Next
							Next
							; Mise  jour de l'affichage de la classe
							GUICtrlSetData($nom_label, $perso_nom)
							GUICtrlSetData($classe_label, $perso_classe&", Niveau "&$perso_niveau)
							GUICtrlSetImage($classe_bouton, _
								cond( _
									FileExists($damageCalc_repertoire_images&"Classes"&"\"&$perso_classe&"\"&$perso_classe&" "&$perso_sexe&".bmp"), _
									$damageCalc_repertoire_images&"Classes"&"\"&$perso_classe&"\"&$perso_classe&" "&$perso_sexe&".bmp", _
									$damageCalc_repertoire_images&"Classes"&"\"&"Inconnu.bmp" _
								) _
							)
							If $perso_classe = "Inconnu" Then
								GUICtrlSetImage($classe_bouton, $damageCalc_repertoire_images&"Classes"&"\"&"Inconnu.bmp")
								GUICtrlSetState($classe_menu_item_F,$GUI_DISABLE)
								GUICtrlSetState($classe_menu_item_M,$GUI_DISABLE)
							Else
								For $j = 1 To $classe_menu_items[0]
									If $perso_classe = $liste_classes[$j] Then
										GUICtrlSetImage($classe_bouton, $damageCalc_repertoire_images&"Classes"&"\"&$perso_classe&"\"&$perso_classe&" "&$perso_sexe&".bmp")
										GUICtrlSetState($classe_menu_item_F,$GUI_ENABLE)
										GUICtrlSetState($classe_menu_item_M,$GUI_ENABLE)
										GUICtrlSetData($classe_label, $perso_classe&", Niveau "&$perso_niveau)
									EndIf
									GUICtrlAdvancedMenuItemSetIcon($classe_menu_items[$j], $damageCalc_repertoire_images&"Classes"&"\"&$liste_classes[$j]&"\"& _
										$liste_classes[$j]&" "&cond($perso_sexe="M","M","F")&".bmp")
								Next
								GUICtrlSetState($classe_menu_item_F, cond($perso_sexe="F",$GUI_CHECKED,$GUI_UNCHECKED))
								GUICtrlSetState($classe_menu_item_M, cond($perso_sexe="M",$GUI_CHECKED,$GUI_UNCHECKED))
							EndIf
							; Caractristiques de l'arme
							$perso_arme     = IniRead($fichier, "Caractristiques", "perso_arme",  "Autre")
							$perso_sort     = IniRead($fichier, "Caractristiques", "perso_sort",  "")
							$perso_sortXML = ""
							$arme_lignes[0] = Number(IniRead($fichier, "Caractristiques", "arme_ligne0", 0))
							$arme_lignes[1] = IniRead($fichier, "Caractristiques", "arme_ligne1", "")
							$arme_lignes[2] = IniRead($fichier, "Caractristiques", "arme_ligne2", "")
							$arme_lignes[3] = IniRead($fichier, "Caractristiques", "arme_ligne3", "")
							$arme_lignes[4] = IniRead($fichier, "Caractristiques", "arme_ligne4", "")
							$arme_lignes[5] = IniRead($fichier, "Caractristiques", "arme_ligne5", "")
							$arme_lignes[6] = IniRead($fichier, "Caractristiques", "arme_ligne6", "")
							$arme_pa        = IniRead($fichier, "Caractristiques", "arme_pa",     "0")
							$arme_cc        = IniRead($fichier, "Caractristiques", "arme_cc",     "0")
							$arme_tcc       = IniRead($fichier, "Caractristiques", "arme_tcc",    "0")
							$arme_tec       = IniRead($fichier, "Caractristiques", "arme_tec",    "0")
							; Mise  jour de l'affichage de l'arme
							If $perso_arme = "Autre" Then
								GUICtrlSetImage($arme_bouton, $damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp")
							Else
								For $j = 1 To $arme_menu_items[0]
									If $perso_arme = $liste_armes[$j] Then
										GUICtrlSetImage($arme_bouton, $damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp")
										GUICtrlSetData($arme_label, $perso_arme)
										If $perso_arme <> "Sort" Then
											$perso_sort = ""
											$perso_sortXML = ""
										EndIf
										For $k = 1 To $arme_config_menu_items_lignes[0]
											GUICtrlAdvancedMenuItemSetIcon($arme_config_menu_items_lignes[$k], $damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp")
										Next
									EndIf
								Next
							EndIf
							Local $icone = cond(FileExists($damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp"), _
								$damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp", _
								$damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp")
							If $perso_arme = "Sort" Then
								updateSortMenu($sort_config_menu_items, $liste_sorts, $sort_config_menu, $perso_classe, $perso_sort)
							Else
								For $j = 1 To $arme_config_menu_items_lignes[0]
									GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j], ligne_arme_tostring($arme_lignes[$j]))
									GUICtrlAdvancedMenuItemSetIcon($arme_config_menu_items_lignes[$j], $icone)
									GUICtrlSetState($arme_config_menu_items_lignes[$j],0)
									If $j = $arme_lignes[0]+1 Then
										GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j],"Ajouter nouvelle ligne")
										GUICtrlSetState($arme_config_menu_items_lignes[$j],$GUI_DEFBUTTON)
									ElseIf $j > $arme_lignes[0]+1 Then
										GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j],"-")
										GUICtrlSetState($arme_config_menu_items_lignes[$j],$GUI_DISABLE)
									EndIf
								Next
								GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_pa,  "Nombre de PA : " & cond(Number($arme_pa)  > 0,        Number($arme_pa),  "Aucun"))
								GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_cc,  "Bonus CC : " &     cond(Number($arme_cc)  > 0, "+" &  Number($arme_cc),  "Aucun"))
								GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_tcc, "Taux CC : " &      cond(Number($arme_tcc) > 1, "1/" & Number($arme_tcc), "Pas de critique"))
								GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_tec, "Taux EC : " &      cond(Number($arme_tec) > 1, "1/" & Number($arme_tec), "Pas d'echec"))
							EndIf
						EndIf
						If $perso_arme<>"Sort" Then
							Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
							GUICtrlSetData($ppr_label, "PPR : "&$ppr&" ")
						ElseIf $perso_sort<>"" Then
							Local $found = False
							For $j = 1 To $liste_sorts[0][0]
								If Not $found And $perso_sort = $liste_sorts[$j][0] And IsObj($liste_sorts[$j][1]) Then
									$found = True
									Local $image = $damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&$perso_classe&"\"&$liste_sorts[$j][1].GetAttribute("id")&".bmp"
									GUICtrlSetImage($arme_bouton, cond(FileExists($image),$image,$damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&"Sort.bmp"))
									$perso_sortXML = $liste_sorts[$j][1]
									GUICtrlSetData($ppr_label, $perso_sort&" ")
								EndIf
							Next
							If Not $found Then
								$perso_sort = ""
								$perso_sortXML = ""
								GUICtrlSetImage($arme_bouton, cond(FileExists($image),$image,$damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&"Sort.bmp"))
								GUICtrlSetData($ppr_label, "Aucun sort slectionn"&" ")
							EndIf
						Else
							$perso_sortXML = ""
							GUICtrlSetData($ppr_label, "Aucun sort slectionn"&" ")
						EndIf
						setProgression($progression)
					EndIf
				Next
			EndSwitch
			#EndRegion
			#Region Traitement de la classe
			Switch $msgGUI[0]
			Case $nom_label                                                                                                                          ; Label du nom du personnage
				displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le nom du personnage"&@CRLF&"(chaine de 16 caractres maximum)")
				Local $retour = guiValeur($GUI,$perso_nom,"STRING",1,16,$nom_label)
				If Not @error Then
					$perso_nom = $retour
					GUICtrlSetData($nom_label, $perso_nom)
				EndIf
				displayTip()
			Case $classe_label                                                                                                                       ; Label de la classe et du niveau
				displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le niveau du personnage"&@CRLF&"(valeur entire entre 1 et 200)")
				Local $retour = guiValeur($GUI,$perso_niveau,"INT",1,200,$classe_label)
				If Not @error Then
					$perso_niveau = Number($retour)
					GUICtrlSetData($classe_label, $perso_classe&", Niveau "&$perso_niveau)
				EndIf
				displayTip()
			Case $classe_bouton                                                                                                                      ; Image de la classe du personnage
				sousmenu($GUI, $classe_bouton, $classe_menu)
			Case $classe_menu_item_inconnu                                                                                                           ; Choix de la classe inconnue dans le menu
				$perso_classe = "Inconnu"
				$perso_sort = ""
				$perso_sortXML = ""
				GUICtrlSetImage($classe_bouton, $damageCalc_repertoire_images&"Classes"&"\"&"Inconnu.bmp")
				GUICtrlSetState($classe_menu_item_F,$GUI_DISABLE)
				GUICtrlSetState($classe_menu_item_M,$GUI_DISABLE)
				GUICtrlSetData($classe_label, $perso_classe&", Niveau "&$perso_niveau)
				updateSortMenu($sort_config_menu_items, $liste_sorts, $sort_config_menu)
				Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
				GUICtrlSetData($ppr_label, cond($perso_arme="Sort","Aucun sort slectionn","PPR : "&$ppr)&" ")
				GUICtrlSetImage($arme_bouton, $damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp")
				; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
				GUICtrlSetImage($effet_lance_bouton, $damageCalc_repertoire_images&"Interface\Large"&cond($perso_arme="Sort","_inactif","")&".bmp")
				GUICtrlSetState($effet_lance_bouton, cond($perso_arme="Sort",$GUI_DISABLE,$GUI_ENABLE))
				GUICtrlSetState($effet_lance_label,  cond($perso_arme="Sort",$GUI_DISABLE,$GUI_ENABLE))
			Case $classe_menu_item_F,$classe_menu_item_M                                                                                             ; Choix du sexe F et M dans le menu
				$perso_sexe = cond($msgGUI[0]=$classe_menu_item_F,"F","M")
				GUICtrlSetState($classe_menu_item_F, cond($msgGUI[0]=$classe_menu_item_F,$GUI_CHECKED,$GUI_UNCHECKED))
				GUICtrlSetState($classe_menu_item_M, cond($msgGUI[0]=$classe_menu_item_M,$GUI_CHECKED,$GUI_UNCHECKED))
				GUICtrlSetImage($classe_bouton, $damageCalc_repertoire_images&"Classes"&"\"&$perso_classe&"\"&$perso_classe&" "&$perso_sexe&".bmp")
				For $i = 1 To $liste_classes[0]
					GUICtrlAdvancedMenuItemSetIcon($classe_menu_items[$i], $damageCalc_repertoire_images&"Classes"&"\"&$liste_classes[$i]&"\"& _
						$liste_classes[$i]&" "&cond($perso_sexe="M","M","F")&".bmp")
				Next
			Case Else
				For $i = 1 To $classe_menu_items[0]                                                                                                  ; Choix de la classe dans le menu
					If $msgGUI[0] = $classe_menu_items[$i] Then
						$perso_classe = $liste_classes[$i]
						$perso_sort = ""
						$perso_sortXML = ""
						GUICtrlSetImage($classe_bouton, $damageCalc_repertoire_images&"Classes"&"\"&$perso_classe&"\"&$perso_classe&" "&$perso_sexe&".bmp")
						GUICtrlSetState($classe_menu_item_F,$GUI_ENABLE)
						GUICtrlSetState($classe_menu_item_M,$GUI_ENABLE)
						GUICtrlSetData($classe_label, $perso_classe&", Niveau "&$perso_niveau)
						GUICtrlSetImage($arme_bouton, $damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp")
						updateSortMenu($sort_config_menu_items, $liste_sorts, $sort_config_menu, $perso_classe, $perso_sort)
						Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
						GUICtrlSetData($ppr_label, cond($perso_arme="Sort","Aucun sort slectionn","PPR : "&$ppr)&" ")
						; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
						GUICtrlSetImage($effet_lance_bouton, $damageCalc_repertoire_images&"Interface\Large"&cond($perso_arme="Sort","_inactif","")&".bmp")
						GUICtrlSetState($effet_lance_bouton, cond($perso_arme="Sort",$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($effet_lance_label,  cond($perso_arme="Sort",$GUI_DISABLE,$GUI_ENABLE))
					EndIf
				Next
			EndSwitch
			#EndRegion
			#Region Traitement de l'arme
			Switch $msgGUI[0]
			Case $arme_bouton                                                                                                                        ; Image de l'arme
				sousmenu($GUI, $arme_bouton, $arme_menu)
			Case $arme_menu_item_inconnu                                                                                                             ; Choix de l'arme "Autre" dans le menu
				$perso_arme = "Autre"
				GUICtrlSetImage($arme_bouton, $damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp")
				GUICtrlSetData($arme_label, $perso_arme)
				For $i = 1 To $arme_config_menu_items_lignes[0]
					GUICtrlAdvancedMenuItemSetIcon($arme_config_menu_items_lignes[$i], $damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp")
				Next
				Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
				GUICtrlSetData($ppr_label, "PPR : "&$ppr&" ")
				; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
				GUICtrlSetImage($effet_lance_bouton, $damageCalc_repertoire_images&"Interface\Large.bmp")
				GUICtrlSetState($effet_lance_bouton, $GUI_ENABLE)
				GUICtrlSetState($effet_lance_label,  $GUI_ENABLE)
			Case $arme_config_bouton,$arme_config_label                                                                                              ; Bouton modifier
				If $perso_arme = "Sort" Then
					sousmenu($GUI, $arme_config_bouton, $sort_config_menu)
				Else
					sousmenu($GUI, $arme_config_bouton, $arme_config_menu)
				EndIf
			Case $arme_config_menu_items_pa                                                                                                          ; Nombre de PA de l'arme
				displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le nombre de PA de l'arme"&@CRLF&"(valeur entire entre 0 et 10)")
				Local $retour = guiValeur($GUI,$arme_pa,"INT",0,10,$arme_config_label)
				If Not @error Then
					$arme_pa = Number($retour)
					GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_pa, "Nombre de PA : "&cond(Number($arme_pa)>0,Number($arme_pa),"Aucun"))
				EndIf
				Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
				GUICtrlSetData($ppr_label, "PPR : "&$ppr&" ")
				displayTip()
			Case $arme_config_menu_items_cc                                                                                                          ; Bonus au coup critique de l'arme
				displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le bonus d'attaque au coup critique de l'arme"&@CRLF&"(valeur entire entre 0 et 999)")
				Local $retour = guiValeur($GUI,$arme_cc,"INT",0,999,$arme_config_label)
				If Not @error Then
					$arme_cc = Number($retour)
					GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_cc, "Bonus CC : "&cond(Number($arme_cc)>0,"+"&Number($arme_cc),"Aucun"))
				EndIf
				Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
				GUICtrlSetData($ppr_label, "PPR : "&$ppr&" ")
				displayTip()
			Case $arme_config_menu_items_tcc                                                                                                         ; Taux de coup critique de l'arme
				displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le taux 1/X de coup critique de l'arme"&@CRLF&"(X valeur entire entre 0 et 999)")
				Local $retour = guiValeur($GUI,$arme_tcc,"INT",0,999,$arme_config_label)
				If Not @error Then
					$arme_tcc = Number($retour)
					GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_tcc, "Taux CC : "&cond(Number($arme_tcc)>1,"1/"&Number($arme_tcc),"Pas de critique"))
				EndIf
				Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
				GUICtrlSetData($ppr_label, "PPR : "&$ppr&" ")
				displayTip()
			Case $arme_config_menu_items_tec                                                                                                         ; Taux d'echec critique de l'arme
				displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le taux 1/X d'chec critique de l'arme"&@CRLF&"(X valeur entire entre 0 et 999)")
				Local $retour = guiValeur($GUI,$arme_tec,"INT",0,999,$arme_config_label)
				If Not @error Then
					$arme_tec = Number($retour)
					GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_tec, "Taux EC : "&cond(Number($arme_tec)>1,"1/"&Number($arme_tec),"Pas d'chec"))
				EndIf
				Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
				GUICtrlSetData($ppr_label, "PPR : "&$ppr&" ")
				displayTip()
			Case Else
				For $i = 1 To $sort_config_menu_items[0]                                                                                             ; Choix du sort dans le menu
					If $msgGUI[0] = $sort_config_menu_items[$i] Then
						$perso_sort = $liste_sorts[$i][0]
						GUICtrlSetData($ppr_label, cond($perso_sort="","Aucun sort slectionn",$perso_sort)&" ")
						If $perso_arme="Sort" And $perso_sort<>"" Then
							updateSortMenu($sort_config_menu_items, $liste_sorts, $sort_config_menu, $perso_classe, $perso_sort)
							Local $found = False
							For $j = 1 To $liste_sorts[0][0]
								If Not $found And $perso_sort = $liste_sorts[$j][0] And IsObj($liste_sorts[$j][1]) Then
									$found = True
									Local $image = $damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&$perso_classe&"\"&$liste_sorts[$j][1].GetAttribute("id")&".bmp"
									GUICtrlSetImage($arme_bouton, cond(FileExists($image),$image,$damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&"Sort.bmp"))
									$perso_sortXML = $liste_sorts[$j][1]
								EndIf
							Next
							If Not $found Then GUICtrlSetImage($arme_bouton, cond(FileExists($image),$image,$damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&"Sort.bmp"))
						EndIf
						; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
						GUICtrlSetImage($effet_lance_bouton, $damageCalc_repertoire_images&"Interface\Large.bmp")
						GUICtrlSetState($effet_lance_bouton, $GUI_ENABLE)
						GUICtrlSetState($effet_lance_label,  $GUI_ENABLE)
					EndIf
				Next
				For $i = 1 To $arme_menu_items[0]                                                                                                    ; Choix de l'arme dans le menu
					If $msgGUI[0] = $arme_menu_items[$i] Then
						$perso_arme = $liste_armes[$i]
						GUICtrlSetImage($arme_bouton, $damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp")
						GUICtrlSetData($arme_label, $perso_arme)
						If $perso_arme <> "Sort" Then $perso_sort = ""
						For $j = 1 To $arme_config_menu_items_lignes[0]
							GUICtrlAdvancedMenuItemSetIcon($arme_config_menu_items_lignes[$j], $damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp")
						Next
						Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
						GUICtrlSetData($ppr_label, cond($perso_arme="Sort",cond($perso_sort="","Aucun sort slectionn",$perso_sort),"PPR : "&$ppr)&" ")
						If $perso_arme="Sort" And $perso_sort<>"" Then
							updateSortMenu($sort_config_menu_items, $liste_sorts, $sort_config_menu, $perso_classe, $perso_sort)
							Local $found = False
							For $j = 1 To $liste_sorts[0][0]
								If Not $found And $perso_sort = $liste_sorts[$j][0] And IsObj($liste_sorts[$j][1]) Then
									$found = True
									Local $image = $damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&$perso_classe&"\"&$liste_sorts[$j][1].GetAttribute("id")&".bmp"
									GUICtrlSetImage($arme_bouton, cond(FileExists($image),$image,$damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&"Sort.bmp"))
									$perso_sortXML = $liste_sorts[$j][1]
								EndIf
							Next
							If Not $found Then GUICtrlSetImage($arme_bouton, cond(FileExists($image),$image,$damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&"Sort.bmp"))
						EndIf
						If $perso_arme = "Sort" Then updateSortMenu($sort_config_menu_items, $liste_sorts, $sort_config_menu, $perso_classe, $perso_sort)
						; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
						GUICtrlSetImage($effet_lance_bouton, $damageCalc_repertoire_images&"Interface\Large"&cond($perso_arme="Sort" And $perso_sort="","_inactif","")&".bmp")
						GUICtrlSetState($effet_lance_bouton, cond($perso_arme="Sort" And $perso_sort="",$GUI_DISABLE,$GUI_ENABLE))
						GUICtrlSetState($effet_lance_label,  cond($perso_arme="Sort" And $perso_sort="",$GUI_DISABLE,$GUI_ENABLE))
					EndIf
				Next
				For $i = 1 To $arme_config_menu_items_lignes[0]                                                                                      ; Choix de la ligne de dgts dans le menu
					If $msgGUI[0] = $arme_config_menu_items_lignes[$i] Then
						Local $retour = guiLigne($GUI, _
							cond($arme_lignes[0]<$i,"",$arme_lignes[$i]), _
							"Ligne de dgts"&cond($arme_lignes[0]<$i,""," n"&$i))
						If @error = 0 Then ; Valider la ligne de dgts
							If check_ligne_arme($retour) Then
								GUICtrlSetState($arme_config_menu_items_lignes[$arme_config_menu_items_lignes[0]],$GUI_DEFBUTTON)
								GUICtrlSetState($arme_config_menu_items_lignes[1],$GUI_DEFBUTTON)
								$arme_lignes[$i] = $retour
								$arme_lignes[0]  = Max($arme_lignes[0],$i)
								For $j = 1 To $arme_config_menu_items_lignes[0]
									GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j], ligne_arme_tostring($arme_lignes[$j]))
									GUICtrlSetState($arme_config_menu_items_lignes[$j],0)
									If $j = $arme_lignes[0]+1 Then
										GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j],"Ajouter nouvelle ligne")
										GUICtrlSetState($arme_config_menu_items_lignes[$j],$GUI_DEFBUTTON)
									ElseIf $j > $arme_lignes[0]+1 Then
										GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j],"-")
										GUICtrlSetState($arme_config_menu_items_lignes[$j],$GUI_DISABLE)
									EndIf
								Next
							EndIf
						ElseIf @error = 1 Then ; Supprimer la ligne de dgts
							If $i <= $arme_lignes[0] Then
								$arme_lignes[0] = $arme_lignes[0]-1
								For $j = $i To $arme_lignes[0]
									$arme_lignes[$j] = $arme_lignes[$j+1]
								Next
								$arme_lignes[$arme_lignes[0]+1] = "<type></type><element></element><min></min><max></max><fmelement></fmelement><fmvaleur></fmvaleur>"
								For $j = 1 To $arme_config_menu_items_lignes[0]
									GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j], ligne_arme_tostring($arme_lignes[$j]))
									GUICtrlSetState($arme_config_menu_items_lignes[$j],0)
									If $j = $arme_lignes[0]+1 Then
										GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j],"Ajouter nouvelle ligne")
										GUICtrlSetState($arme_config_menu_items_lignes[$j],$GUI_DEFBUTTON)
									ElseIf $j > $arme_lignes[0]+1 Then
										GUICtrlAdvancedMenuItemSetText($arme_config_menu_items_lignes[$j],"-")
										GUICtrlSetState($arme_config_menu_items_lignes[$j],$GUI_DISABLE)
									EndIf
								Next
							EndIf
						ElseIf @error = 2 Then ; Annuler la modif
							; Ne rien faire
						EndIf
						Local $ppr = calcul_de_ppr(convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes))
						GUICtrlSetData($ppr_label, "PPR : "&$ppr&" ")
					EndIf
				Next
			EndSwitch
			#EndRegion
			#Region Traitement des items de chaque page
			Switch $msgGUI[0]
			Case $reinitialiser                                                                                                                      ; Bouton rinitialiser
				sousmenu($GUI, $reinitialiser, $reinitialiser_menu)
			Case $reinitialiser_item_pages, $reinitialiser_item_pageX                                                                                ; Rinitialiser une ou toutes les pages
				For $i = 1 To $matrice_items[0]
					setProgression($progression,(100/$matrice_items[0])*($i-1))
					If $i = $page Or $msgGUI[0] = $reinitialiser_item_pages Then
						Local $racines = $matrice_items[$i]
						For $j = 1 To $racines[0]
							setProgression($progression,(100/$matrice_items[0])*($i-1)+(100/$matrice_items[0])*($j/$racines[0]))
							Assign($racines[$j],0)
							GUICtrlSetColor(Eval($racines[$j]&"_label"),0xFFFFFF)
							GUICtrlSetColor(Eval($racines[$j]&"_valeur"),0xFFFFFF)
							GUICtrlSetData(Eval($racines[$j]&"_valeur"),0)
						Next
					EndIf
				Next
				setProgression($progression)
			Case Else
				If $page > 1 And $msgGUI[0] = $Bouton_page_up Then                                                                                   ; Bouton de passage  la page prcdente
					$msgGUI[0] = $Bouton_pages[$page-1]
				ElseIf $page < $Bouton_pages[0] And $msgGUI[0] = $Bouton_page_down Then                                                              ; Bouton de passage  la page suivante
					$msgGUI[0] = $Bouton_pages[$page+1]
				EndIf
				For $i = 1 To $Bouton_pages[0]                                                                                                       ; Changement de page
					If $msgGUI[0] = $Bouton_pages[$i] Then
						If $page <> $i Then
							GUICtrlSetData($caracs_titre_label, " Chargement de la page ...")
							GUICtrlSetImage($Bouton_pages[$page],$damageCalc_repertoire_images&"Interface\Deroulement_vide.bmp")
							Local $items_racine = $matrice_items[$page]
							setProgression($progression)
							For $j = 1 To $items_racine[0]
								setProgression($progression,(50/$items_racine[0])*($j-1))
								Local $pic = Eval($items_racine[$j]&"_pic")
								If Not @error Then GUICtrlSetState($pic,$GUI_HIDE)
								Local $label = Eval($items_racine[$j]&"_label")
								If Not @error Then GUICtrlSetState($label,$GUI_HIDE)
								Local $valeur = Eval($items_racine[$j]&"_valeur")
								If Not @error Then GUICtrlSetState($valeur,$GUI_HIDE)
								Local $modif = Eval($items_racine[$j]&"_modif")
								If Not @error Then GUICtrlSetState($modif,$GUI_HIDE)
							Next
							$page = $i
							GUICtrlSetImage($Bouton_pages[$page],$damageCalc_repertoire_images&"Interface\Deroulement.bmp")
							Local $items_racine = $matrice_items[$page]
							setProgression($progression,50)
							For $j = 1 To $items_racine[0]
								setProgression($progression,50+(50/$items_racine[0])*($j-1))
								Local $pic = Eval($items_racine[$j]&"_pic")
								If Not @error Then GUICtrlSetState($pic,$GUI_SHOW)
								Local $label = Eval($items_racine[$j]&"_label")
								If Not @error Then GUICtrlSetState($label,$GUI_SHOW)
								Local $valeur = Eval($items_racine[$j]&"_valeur")
								If Not @error Then GUICtrlSetState($valeur,$GUI_SHOW)
								Local $modif = Eval($items_racine[$j]&"_modif")
								If Not @error Then GUICtrlSetState($modif,$GUI_SHOW)
							Next
							GUICtrlSetImage($Bouton_page_up,   $damageCalc_repertoire_images & "Interface\Haut" & cond($page=1, "_inactif","") & ".bmp")
							GUICtrlSetImage($Bouton_page_down, $damageCalc_repertoire_images & "Interface\Bas"  & cond($page=5, "_inactif","") & ".bmp")
							GUICtrlSetState($Bouton_page_up,   cond($page=1,$GUI_DISABLE, $GUI_ENABLE))
							GUICtrlSetState($Bouton_page_down, cond($page=5,$GUI_DISABLE, $GUI_ENABLE))
							GUICtrlSetData($caracs_titre_label, " "&$pages_titles[$i])
							setProgression($progression)
						EndIf
					EndIf
				Next
				Local $racines = $matrice_items[$page]
				For $i = 1 To $racines[0]                                                                                                            ; Modification de valeur
					If $msgGUI[0] = Eval($racines[$i]&"_modif") Then
						displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner la caractristique '"&GUICtrlRead(Eval($racines[$i]&"_label"))&"'"&@CRLF& _
							"(valeur positive/ngative entre -9999 et 9999)")
						Local $retour = guiValeur($GUI,Eval($racines[$i]),"INT",-9999,9999,Eval($racines[$i]&"_modif"))
						If Not @error Then
							Assign($racines[$i],Number($retour))
							GUICtrlSetColor(Eval($racines[$i]&"_label"),  0x44CC44)
							GUICtrlSetColor(Eval($racines[$i]&"_valeur"), 0x44CC44)
							GUICtrlSetData( Eval($racines [$i]&"_valeur"), Number($retour))
						EndIf
						displayTip()
					EndIf
				Next
			EndSwitch
			#EndRegion
			#Region Traitement des liens vers les fentres auxiliaires
			Switch $msgGUI[0]
			Case $effet_efface_bouton, $effet_efface_label                                                                                           ; Effacement des fentres auxiliaires en cours
				$comparaison_couple[0] = 0
				$comparaison_couple[1] = 0
				For $index = 1 To $AUX_GUI[0] ; Pour chaque fentre
					GUIDelete($AUX_GUI[$index])
				Next
				; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
				GUICtrlSetImage($effet_efface_bouton, $damageCalc_repertoire_images&"Interface\Normal_inactif.bmp")
				GUICtrlSetState($effet_efface_bouton, $GUI_DISABLE)
				GUICtrlSetState($effet_efface_label,  $GUI_DISABLE)
			Case $effet_lance_bouton, $effet_lance_label                                                                                             ; Cration d'une fenetre auxiliaire
				If $perso_arme = "Sort" And $perso_sort = "" Then
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION, "Veuillez renseigner le type de sort")
				Else
					#Region Chargement de l'interface graphique
					setProgression($progression)
					$AUX_GUI[0] = $AUX_GUI[0]+1
					ReDim $AUX_GUI[$AUX_GUI[0]+1]
					Local $index = $AUX_GUI[0]
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Chargement de l'interface graphique")
					$AUX_GUI[$index] = GUICreate($MODULE_NOM&" v"&$MODULE_VERSION, _
						438, 442, _
						Default, Default, _
						BitOR($WS_POPUP,$WS_BORDER), -1, _
						$GUI _
					)
					#EndRegion

					#Region Prparation des variables  sauver
					#Region Constitution
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(caractristiques primordiales)")
					setProgression($progression,5)
					; Classe
					$AUX_perso_classe[0] = $index
					ReDim $AUX_perso_classe[$index+1]
					$AUX_perso_classe[$index] = $perso_classe
					; Sexe
					$AUX_perso_sexe[0] = $index
					ReDim $AUX_perso_sexe[$index+1]
					$AUX_perso_sexe[$index] = $perso_sexe
					; Nom
					$AUX_perso_nom[0] = $index
					ReDim $AUX_perso_nom[$index+1]
					$AUX_perso_nom[$index] = $perso_nom
					; Niveau
					$AUX_perso_niveau[0] = $index
					ReDim $AUX_perso_niveau[$index+1]
					$AUX_perso_niveau[$index] = $perso_niveau
					; Arme
					$AUX_perso_arme[0] = $index
					ReDim $AUX_perso_arme[$index+1]
					$AUX_perso_arme[$index] = $perso_arme
					; Sort
					$AUX_perso_sort[0] = $index
					ReDim $AUX_perso_sort[$index+1]
					$AUX_perso_sort[$index] = $perso_sort
					; Sort en XML
					$AUX_perso_sortXML[0] = $index
					ReDim $AUX_perso_sortXML[$index+1]
					$AUX_perso_sortXML[$index] = $perso_sortXML
					#EndRegion
					#Region Page 1/5
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(constitution - page 1/5)")
					setProgression($progression,10)
					; Vitalit
					$AUX_carac_vit[0] = $index
					ReDim $AUX_carac_vit[$index+1]
					$AUX_carac_vit[$index] = $carac_vit
					; Sagesse
					$AUX_carac_sag[0] = $index
					ReDim $AUX_carac_sag[$index+1]
					$AUX_carac_sag[$index] = $carac_sag
					; Force
					$AUX_carac_for[0] = $index
					ReDim $AUX_carac_for[$index+1]
					$AUX_carac_for[$index] = $carac_for
					; Intelligence
					$AUX_carac_int[0] = $index
					ReDim $AUX_carac_int[$index+1]
					$AUX_carac_int[$index] = $carac_int
					; Chance
					$AUX_carac_cha[0] = $index
					ReDim $AUX_carac_cha[$index+1]
					$AUX_carac_cha[$index] = $carac_cha
					; Agilit
					$AUX_carac_agi[0] = $index
					ReDim $AUX_carac_agi[$index+1]
					$AUX_carac_agi[$index] = $carac_agi
					; PA
					$AUX_carac_pa[0] = $index
					ReDim $AUX_carac_pa[$index+1]
					$AUX_carac_pa[$index] = $carac_pa
					; PM
					$AUX_carac_pm[0] = $index
					ReDim $AUX_carac_pm[$index+1]
					$AUX_carac_pm[$index] = $carac_pm
					#EndRegion
					#Region Page 2/5
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(constitution - page 2/5)")
					setProgression($progression,15)
					; Retrait PA
					$AUX_retrait_pa[0] = $index
					ReDim $AUX_retrait_pa[$index+1]
					$AUX_retrait_pa[$index] = $retrait_pa
					; Esquive PA
					$AUX_esquive_pa[0] = $index
					ReDim $AUX_esquive_pa[$index+1]
					$AUX_esquive_pa[$index] = $esquive_pa
					; Retrait PM
					$AUX_retrait_pm[0] = $index
					ReDim $AUX_retrait_pm[$index+1]
					$AUX_retrait_pm[$index] = $retrait_pm
					; Esquive PM
					$AUX_esquive_pm[0] = $index
					ReDim $AUX_esquive_pm[$index+1]
					$AUX_esquive_pm[$index] = $esquive_pm
					; Coups critiques
					$AUX_carac_cc[0] = $index
					ReDim $AUX_carac_cc[$index+1]
					$AUX_carac_cc[$index] = $carac_cc
					; Echecs critiques
					$AUX_carac_ec[0] = $index
					ReDim $AUX_carac_ec[$index+1]
					$AUX_carac_ec[$index] = $carac_ec
					; Soins
					$AUX_carac_soins[0] = $index
					ReDim $AUX_carac_soins[$index+1]
					$AUX_carac_soins[$index] = $carac_soins
					; Tacle
					$AUX_carac_tacle[0] = $index
					ReDim $AUX_carac_tacle[$index+1]
					$AUX_carac_tacle[$index] = $carac_tacle
					; Fuite
					$AUX_carac_fuite[0] = $index
					ReDim $AUX_carac_fuite[$index+1]
					$AUX_carac_fuite[$index] = $carac_fuite
					#EndRegion
					#Region Page 3/5
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(constitution - page 3/5)")
					setProgression($progression,20)
					; Dommages fixes
					$AUX_dom_fixe[0] = $index
					ReDim $AUX_dom_fixe[$index+1]
					$AUX_dom_fixe[$index] = $dom_fixe
					; Dommages en pourcentage
					$AUX_dom_pour[0] = $index
					ReDim $AUX_dom_pour[$index+1]
					$AUX_dom_pour[$index] = $dom_pour
					; Dommages fixes neutre
					$AUX_dom_neutre[0] = $index
					ReDim $AUX_dom_neutre[$index+1]
					$AUX_dom_neutre[$index] = $dom_neutre
					; Dommages fixes terre
					$AUX_dom_for[0] = $index
					ReDim $AUX_dom_for[$index+1]
					$AUX_dom_for[$index] = $dom_for
					; Dommages fixes feu
					$AUX_dom_int[0] = $index
					ReDim $AUX_dom_int[$index+1]
					$AUX_dom_int[$index] = $dom_int
					; Dommages fixes eau
					$AUX_dom_cha[0] = $index
					ReDim $AUX_dom_cha[$index+1]
					$AUX_dom_cha[$index] = $dom_cha
					; Dommages fixes air
					$AUX_dom_agi[0] = $index
					ReDim $AUX_dom_agi[$index+1]
					$AUX_dom_agi[$index] = $dom_agi
					; Dommages fixes pousse
					$AUX_dom_pouss[0] = $index
					ReDim $AUX_dom_pouss[$index+1]
					$AUX_dom_pouss[$index] = $dom_pouss
					; Renvoi de dommages
					$AUX_renvoi[0] = $index
					ReDim $AUX_renvoi[$index+1]
					$AUX_renvoi[$index] = $renvoi
					; Piges fixes
					$AUX_piege_fixe[0] = $index
					ReDim $AUX_piege_fixe[$index+1]
					$AUX_piege_fixe[$index] = $piege_fixe
					; Piges en pourcentage
					$AUX_piege_pour[0] = $index
					ReDim $AUX_piege_pour[$index+1]
					$AUX_piege_pour[$index] = $piege_pour
					#EndRegion
					#Region Page 4/5
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(constitution - page 4/5)")
					setProgression($progression,25)
					; Rsistances PVE fixes neutre
					$AUX_resE_neutre_fixe[0] = $index
					ReDim $AUX_resE_neutre_fixe[$index+1]
					$AUX_resE_neutre_fixe[$index] = $resE_neutre_fixe
					; Rsistances PVE en pourcentage neutre
					$AUX_resE_neutre_pour[0] = $index
					ReDim $AUX_resE_neutre_pour[$index+1]
					$AUX_resE_neutre_pour[$index] = $resE_neutre_pour
					; Rsistances PVE fixes terre
					$AUX_resE_for_fixe[0] = $index
					ReDim $AUX_resE_for_fixe[$index+1]
					$AUX_resE_for_fixe[$index] = $resE_for_fixe
					; Rsistances PVE en pourcentage terre
					$AUX_resE_for_pour[0] = $index
					ReDim $AUX_resE_for_pour[$index+1]
					$AUX_resE_for_pour[$index] = $resE_for_pour
					; Rsistances PVE fixes feu
					$AUX_resE_int_fixe[0] = $index
					ReDim $AUX_resE_int_fixe[$index+1]
					$AUX_resE_int_fixe[$index] = $resE_int_fixe
					; Rsistances PVE en pourcentage feu
					$AUX_resE_int_pour[0] = $index
					ReDim $AUX_resE_int_pour[$index+1]
					$AUX_resE_int_pour[$index] = $resE_int_pour
					; Rsistances PVE fixes eau
					$AUX_resE_cha_fixe[0] = $index
					ReDim $AUX_resE_cha_fixe[$index+1]
					$AUX_resE_cha_fixe[$index] = $resE_cha_fixe
					; Rsistances PVE en pourcentage eau
					$AUX_resE_cha_pour[0] = $index
					ReDim $AUX_resE_cha_pour[$index+1]
					$AUX_resE_cha_pour[$index] = $resE_cha_pour
					; Rsistances PVE fixes air
					$AUX_resE_agi_fixe[0] = $index
					ReDim $AUX_resE_agi_fixe[$index+1]
					$AUX_resE_agi_fixe[$index] = $resE_agi_fixe
					; Rsistances PVE en pourcentage air
					$AUX_resE_agi_pour[0] = $index
					ReDim $AUX_resE_agi_pour[$index+1]
					$AUX_resE_agi_pour[$index] = $resE_agi_pour
					; Rsistances PVE fixes critique
					$AUX_resE_cri_fixe[0] = $index
					ReDim $AUX_resE_cri_fixe[$index+1]
					$AUX_resE_cri_fixe[$index] = $resE_cri_fixe
					; Rsistances PVE fixes pousse
					$AUX_resE_pou_fixe[0] = $index
					ReDim $AUX_resE_pou_fixe[$index+1]
					$AUX_resE_pou_fixe[$index] = $resE_pou_fixe
					#EndRegion
					#Region Page 5/5
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(constitution - page 5/5)")
					setProgression($progression,30)
					; Rsistances PVP fixes neutre
					$AUX_resP_neutre_fixe[0] = $index
					ReDim $AUX_resP_neutre_fixe[$index+1]
					$AUX_resP_neutre_fixe[$index] = $resP_neutre_fixe
					; Rsistances PVP en pourcentage neutre
					$AUX_resP_neutre_pour[0] = $index
					ReDim $AUX_resP_neutre_pour[$index+1]
					$AUX_resP_neutre_pour[$index] = $resP_neutre_pour
					; Rsistances PVP fixes terre
					$AUX_resP_for_fixe[0] = $index
					ReDim $AUX_resP_for_fixe[$index+1]
					$AUX_resP_for_fixe[$index] = $resP_for_fixe
					; Rsistances PVP en pourcentage terre
					$AUX_resP_for_pour[0] = $index
					ReDim $AUX_resP_for_pour[$index+1]
					$AUX_resP_for_pour[$index] = $resP_for_pour
					; Rsistances PVP fixes feu
					$AUX_resP_int_fixe[0] = $index
					ReDim $AUX_resP_int_fixe[$index+1]
					$AUX_resP_int_fixe[$index] = $resP_int_fixe
					; Rsistances PVP en pourcentage feu
					$AUX_resP_int_pour[0] = $index
					ReDim $AUX_resP_int_pour[$index+1]
					$AUX_resP_int_pour[$index] = $resP_int_pour
					; Rsistances PVP fixes eau
					$AUX_resP_cha_fixe[0] = $index
					ReDim $AUX_resP_cha_fixe[$index+1]
					$AUX_resP_cha_fixe[$index] = $resP_cha_fixe
					; Rsistances PVP en pourcentage eau
					$AUX_resP_cha_pour[0] = $index
					ReDim $AUX_resP_cha_pour[$index+1]
					$AUX_resP_cha_pour[$index] = $resP_cha_pour
					; Rsistances PVP fixes air
					$AUX_resP_agi_fixe[0] = $index
					ReDim $AUX_resP_agi_fixe[$index+1]
					$AUX_resP_agi_fixe[$index] = $resP_agi_fixe
					; Rsistances PVP en pourcentage air
					$AUX_resP_agi_pour[0] = $index
					ReDim $AUX_resP_agi_pour[$index+1]
					$AUX_resP_agi_pour[$index] = $resP_agi_pour
					#EndRegion
					#Region Configuration de l'arme
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(configuration de l'arme)")
					setProgression($progression,35)
					; Lignes de dgts de l'arme
					$AUX_arme_lignes[0] = $index
					ReDim $AUX_arme_lignes[$index+1]
					$AUX_arme_lignes[$index] = $arme_lignes
					; Nombre de PA de l'arme
					$AUX_attaque_pa[0] = $index
					ReDim $AUX_attaque_pa[$index+1]
					$AUX_attaque_pa[$index] = $arme_pa
					; Bonus de l'arme en coup critique
					$AUX_attaque_cc[0] = $index
					ReDim $AUX_attaque_cc[$index+1]
					$AUX_attaque_cc[$index] = $arme_cc
					; Taux d'chec critique de l'arme
					$AUX_attaque_tcc[0] = $index
					ReDim $AUX_attaque_tcc[$index+1]
					$AUX_attaque_tcc[$index] = $arme_tcc
					; Taux d'chec critique de l'arme
					$AUX_attaque_tec[0] = $index
					ReDim $AUX_attaque_tec[$index+1]
					$AUX_attaque_tec[$index] = $arme_tec
					#EndRegion
					#Region Constitution
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Prparation des variables  sauver"&@CRLF&"(synthse des donnes en XML")
					setProgression($progression,40)
					$AUX_constitution[0] = $index
					ReDim $AUX_constitution[$index+1]
					$AUX_constitution[$index] = convertToXML( _
						$perso_classe, $perso_sexe, $perso_nom, $perso_niveau, $perso_arme, $perso_sort, $perso_sortXML, _
						$carac_vit, $carac_sag, $carac_for, $carac_int, $carac_cha, $carac_agi, $carac_pa, $carac_pm, _
						$retrait_pa, $esquive_pa, $retrait_pm, $esquive_pm, $carac_cc, $carac_ec, $carac_soins, $carac_tacle, $carac_fuite, _
						$dom_fixe, $dom_pour, $dom_neutre, $dom_for, $dom_int, $dom_cha, $dom_agi, $dom_pouss, $renvoi, $piege_fixe, $piege_pour, _
						$resE_neutre_fixe, $resE_neutre_pour, $resE_for_fixe, $resE_for_pour, $resE_int_fixe, $resE_int_pour, _
						$resE_cha_fixe, $resE_cha_pour, $resE_agi_fixe, $resE_agi_pour, $resE_cri_fixe, $resE_pou_fixe, _
						$resP_neutre_fixe, $resP_neutre_pour, $resP_for_fixe, $resP_for_pour, $resP_int_fixe, $resP_int_pour, $resP_cha_fixe, $resP_cha_pour, $resP_agi_fixe, $resP_agi_pour, _
						$arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes _
					)
					#EndRegion
					#EndRegion

					setProgression($progression,50)

					#Region Fond d'cran
					GUICtrlCreatePic($damageCalc_repertoire_images&"Interface"&"\"&"Background_affichage.bmp", 0,0, 438,442)
					GUICtrlSetState(-1, $GUI_DISABLE)
					#EndRegion

					#Region Boutons principaux
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Cration des boutons principaux")
					setProgression($progression,55)
					If Not IsDeclared("AUX_Bouton_Quitter") Then Local $AUX_Bouton_Quitter[1] = [0]
					$AUX_Bouton_Quitter[0] = $index
					ReDim $AUX_Bouton_Quitter[$index+1]
					$AUX_Bouton_Quitter[$index] = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface"&"\"&"Quitter.bmp",           408,3, 21,21)
					GUICtrlSetTip($AUX_Bouton_Quitter[$index], "Cliquez pour fermer la fentre auxiliaire"&@CRLF&"Attention: pas de confirmation", "Fermer la fentre", 2)
					If Not IsDeclared("AUX_Bouton_Deplacer") Then Local $AUX_Bouton_Deplacer[1] = [0]
					$AUX_Bouton_Deplacer[0] = $index
					ReDim $AUX_Bouton_Deplacer[$index+1]
					$AUX_Bouton_Deplacer[$index] = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface"&"\"&"Deplacer.bmp",         383,3, 21,21, Default, $GUI_WS_EX_PARENTDRAG)
					GUICtrlSetTip($AUX_Bouton_Deplacer[$index], "Glissez/dposez la bouton pour"&@CRLF&"dplacer la fentre auxiliaire", "Dplacer la fentre")
					If Not IsDeclared("AUX_Bouton_Epingler") Then Local $AUX_Bouton_Epingler[1] = [0]
					$AUX_Bouton_Epingler[0] = $index
					ReDim $AUX_Bouton_Epingler[$index+1]
					$AUX_Bouton_Epingler[$index] = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface"&"\"&"Epingler_inactif.bmp", 358,3, 21,21)
					GUICtrlSetTip($AUX_Bouton_Epingler[$index], "Cliquez pour pingler la fentre pour comparer"&@CRLF&"les rsultats (deux pingles maximum)", "Epingler la fentre")
					#EndRegion

					#Region Image de l'arme
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Cration de l'image de l'arme")
					setProgression($progression,60)
					If Not IsDeclared("AUX_rwc_label") Then Local $AUX_rwc_label[1] = [0]
					$AUX_rwc_label[0] = $index
					ReDim $AUX_rwc_label[$index+1]
					If Not IsDeclared("AUX_rwc_valeur") Then Local $AUX_rwc_valeur[1] = [0]
					$AUX_rwc_valeur[0] = $index
					ReDim $AUX_rwc_valeur[$index+1]
					If Not IsDeclared("AUX_ppr_label") Then Local $AUX_ppr_label[1] = [0]
					$AUX_ppr_label[0] = $index
					ReDim $AUX_ppr_label[$index+1]
					If Not IsDeclared("AUX_ppr_valeur") Then Local $AUX_ppr_valeur[1] = [0]
					$AUX_ppr_valeur[0] = $index
					ReDim $AUX_ppr_valeur[$index+1]
					If Not IsDeclared("AUX_total_label") Then Local $AUX_total_label[1] = [0]
					$AUX_total_label[0] = $index
					ReDim $AUX_total_label[$index+1]
					If Not IsDeclared("AUX_total_valeur") Then Local $AUX_total_valeur[1] = [0]
					$AUX_total_valeur[0] = $index
					ReDim $AUX_total_valeur[$index+1]
					If Not IsDeclared("AUX_lvl_label") Then Local $AUX_lvl_label[1] = [0]
					$AUX_lvl_label[0] = $index
					ReDim $AUX_lvl_label[$index+1]
					If Not IsDeclared("AUX_lvl_valeur") Then Local $AUX_lvl_valeur[1] = [0]
					$AUX_lvl_valeur[0] = $index
					ReDim $AUX_lvl_valeur[$index+1]
					If Not IsDeclared("AUX_lvl_menu") Then Local $AUX_lvl_menu[1] = [0]
					$AUX_lvl_menu[0] = $index
					ReDim $AUX_lvl_menu[$index+1]
					If Not IsDeclared("AUX_lvl_menuitems") Then Local $AUX_lvl_menuitems[1] = [0]
					$AUX_lvl_menuitems[0] = $index
					ReDim $AUX_lvl_menuitems[$index+1]
					Local $picture = GUICtrlCreatePic("", 10,12, 74,74)
					Local $chemin = ""
					If $perso_arme <> "Sort" Then
						$chemin = $damageCalc_repertoire_images&"Armes"&"\"&$perso_arme&"\"&$perso_arme&".bmp"
					Else
						If $perso_sort <> "" Then
							Local $liste = listing_XML($damageCalc_programme_donnees, $perso_classe), $found = ""
							For $i = 1 To $liste[0][0]
								If $found = "" And $liste[$i][0] = $perso_sort Then $found = $liste[$i][1]
							Next
							If $found <> "" Then $chemin = $damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&$perso_classe&"\"&($found.GetAttribute("id"))&".bmp"
						EndIf
						If Not FileExists($chemin) Then $chemin = $damageCalc_repertoire_images&"Armes"&"\"&"Sort"&"\"&"Sort.bmp"
					EndIf
					If Not FileExists($chemin) Then $chemin = $damageCalc_repertoire_images&"Armes"&"\"&"Autre.bmp"
					GUICtrlSetImage($picture,$chemin)
					Local $ppr = 0
					If $perso_arme<>"Sort" Then $ppr = calcul_de_ppr($AUX_constitution[$index])
					setProgression($progression,65)
					$AUX_ppr_valeur[$index]   = $ppr
					$AUX_rwc_valeur[$index]   = 0
					$AUX_total_valeur[$index] = 0
					$AUX_lvl_valeur[$index]   = cond($perso_arme="Sort",1,0)
					Local $AUX_label          = GUICtrlCreateLabel($perso_arme,90,15,150,30)
					$AUX_ppr_label[$index]    = GUICtrlCreateLabel(cond($perso_arme="Sort",cond($perso_sort="","Aucun sort slectionn",$perso_sort),"PPR : "&$ppr)&" ",140,18,200,30,$SS_RIGHT)
					$AUX_rwc_label[$index]    = GUICtrlCreateLabel("Ratio",90,55,140,30)
					GUICtrlSetTip($AUX_rwc_label[$index], "Valeur du RWC - ratio de dgts moyens par PA"&@CRLF&"(dpend de l'attaquant et de la cible)")
					$AUX_total_label[$index]  = GUICtrlCreateLabel("Total de dgts", 20,287, 400,20, $SS_CENTER)
					GUICtrlSetTip($AUX_total_label[$index], "Cliquez pour changer le mode d'affichage"&@CRLF&"(total de dgts, ou moyenne de dgts)", "Mode d'affichage du rsum")
					$AUX_lvl_label[$index]    = GUICtrlCreateLabel("",270,55,150,30,$SS_RIGHT)
					If $perso_arme = "Sort" Then
						GUICtrlSetTip($AUX_lvl_label[$index], "Cliquez pour slectionner le niveau du sort", "Niveau du sort '"&$perso_sort&"'")
						GUICtrlSetData($AUX_lvl_label[$index],"Niveau 1")
					Else
						GUICtrlSetTip($AUX_ppr_label[$index], "Rsultat de la formule de PPR"&@CRLF&"(version utilise : 1.0.1)", "PPR de l'arme slectionne")
						If $perso_arme = "Autre" Then
							GUICtrlSetData($AUX_lvl_label[$index],"")
							GUICtrlSetState($AUX_lvl_label[$index],$GUI_DISABLE)
						Else
							GUICtrlSetTip($AUX_lvl_label[$index], "Cliquez pour slectionner le niveau de la matrise d'arme", "Niveau de la matrise '"&$perso_arme&"'")
							GUICtrlSetData($AUX_lvl_label[$index],"Aucune matrise")
						EndIf
					EndIf
					$AUX_lvl_menu[$index] = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
					Local $liste[7] = [6,"Niveau 1","Niveau 2","Niveau 3","Niveau 4","Niveau 5","Niveau 6"]
					If $perso_arme <> "Sort" Then
						ArrayInsert($liste,1,"Aucune matrise")
						ArrayAdd($liste,"Niveau 6 (cc)")
						$liste[0] = 8
					EndIf
					For $i = 1 To $liste[0]
						$liste[$i] = GUICtrlCreateAdvancedMenuItem($liste[$i], $AUX_lvl_menu[$index])
					Next
					GUICtrlSetState($liste[1],$GUI_DISABLE+$GUI_DEFBUTTON)
					$AUX_lvl_menuitems[$index] = $liste
					GUICtrlSetFont(   $AUX_label,               16, 400, Default, $DAMAGECALC_FONT)
					GUICtrlSetFont(   $AUX_ppr_label[$index],   14, 400, 2,       $DAMAGECALC_FONT)
					GUICtrlSetFont(   $AUX_rwc_label[$index],   12, 400, Default, $DAMAGECALC_FONT)
					GUICtrlSetFont(   $AUX_total_label[$index], 12, 400, Default, $DAMAGECALC_FONT)
					GUICtrlSetFont(   $AUX_lvl_label[$index],   12, 400, Default, $DAMAGECALC_FONT)
					GUICtrlSetColor(  $AUX_label,               0xFFFFFF)
					GUICtrlSetColor(  $AUX_ppr_label[$index],   0xFFFFFF)
					GUICtrlSetColor(  $AUX_rwc_label[$index],   0xFFFFFF)
					GUICtrlSetColor(  $AUX_total_label[$index], 0xFFFFFF)
					GUICtrlSetColor(  $AUX_lvl_label[$index],   0xFFFFFF)
					GUICtrlSetBkColor($AUX_label,               $GUI_BKCOLOR_TRANSPARENT)
					GUICtrlSetBkColor($AUX_ppr_label[$index],   $GUI_BKCOLOR_TRANSPARENT)
					GUICtrlSetBkColor($AUX_rwc_label[$index],   $GUI_BKCOLOR_TRANSPARENT)
					GUICtrlSetBkColor($AUX_total_label[$index], $GUI_BKCOLOR_TRANSPARENT)
					GUICtrlSetBkColor($AUX_lvl_label[$index],   $GUI_BKCOLOR_TRANSPARENT)
					#EndRegion

					#Region Caractristiques des dgts : entte
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Caractristiques des dgts : entte")
					setProgression($progression,70)
					; Mise  jour des caractristiques des variables
					If $perso_arme = "Sort" Then
						$AUX_attaque_pa[$index]  = Number(getDommageBalise(getDommageBalise(getDommageBalise($AUX_constitution[$index],"perso_sort"),"niveau_1"),"pa"))
						$AUX_attaque_tcc[$index] = Number(getDommageBalise(getDommageBalise(getDommageBalise($AUX_constitution[$index],"perso_sort"),"niveau_1"),"tcc"))
					EndIf
					; Dclaration des contenus du tableau des effets
					If Not IsDeclared("AUX_cc_effectif") Then Local $AUX_cc_effectif[1] = [0]
					$AUX_cc_effectif[0] = $index
					ReDim $AUX_cc_effectif[$index+1]
					$AUX_cc_effectif[$index] = 0
					If Not IsDeclared("AUX_cn_label") Then Local $AUX_cn_label[1] = [0]
					$AUX_cn_label[0] = $index
					ReDim $AUX_cn_label[$index+1]
					$AUX_cn_label[$index] = GUICtrlCreateLabel("Coup normal"&cond($AUX_attaque_pa[$index]>0," : "&$AUX_attaque_pa[$index]&"PA",""),    17,109, 200,20, $SS_CENTER)
					GUICtrlSetFont(   $AUX_cn_label[$index], 12, 400, Default, $DAMAGECALC_FONT)
					GUICtrlSetColor(  $AUX_cn_label[$index], 0xFFFFFF)
					GUICtrlSetBkColor($AUX_cn_label[$index], $GUI_BKCOLOR_TRANSPARENT)
					If Not IsDeclared("AUX_cc_label") Then Local $AUX_cc_label[1] = [0]
					$AUX_cc_label[0] = $index
					ReDim $AUX_cc_label[$index+1]
					$AUX_cc_label[$index] = GUICtrlCreateLabel("", 222,109, 200,20, $SS_CENTER)
					GUICtrlSetFont(   $AUX_cc_label[$index], 12, 400, Default, $DAMAGECALC_FONT)
					GUICtrlSetColor(  $AUX_cc_label[$index], 0xFFFFFF)
					GUICtrlSetBkColor($AUX_cc_label[$index], $GUI_BKCOLOR_TRANSPARENT)
					$AUX_cc_effectif[$index] = calcul_de_cc($AUX_attaque_tcc[$index], $AUX_carac_cc[$index], $AUX_carac_agi[$index])
					GUICtrlSetData($AUX_cc_label[$index], cond(Number($AUX_cc_effectif[$index]) > 1, "Coup critique : 1/" & Number($AUX_cc_effectif[$index]), "Coup critique : Aucun"))
					#EndRegion

					#Region Caractristiques de dgts
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Caractristiques de dgts"&@CRLF&"(cration des images des lments)")
					setProgression($progression,75)
					Local $liste = $AUX_arme_lignes[$index]
					Local $caracs_sort = getDommageBalise($AUX_constitution[$index],"perso_sort"), $lvl_sort = "1"
					; Dclaration des contenus du tableau des effets
					If Not IsDeclared("AUX_attaque_lignes_normal_pic") Then Local $AUX_attaque_lignes_normal_pic[1] = [0]
					$AUX_attaque_lignes_normal_pic[0] = $index
					ReDim $AUX_attaque_lignes_normal_pic[$index+1]
					Local $liste_normal_pic[7]   = [6,"","","","","",""]
					If Not IsDeclared("AUX_attaque_lignes_normal_label") Then Local $AUX_attaque_lignes_normal_label[1] = [0]
					$AUX_attaque_lignes_normal_label[0] = $index
					ReDim $AUX_attaque_lignes_normal_label[$index+1]
					Local $liste_normal_label[7] = [6,"","","","","",""]
					If Not IsDeclared("AUX_attaque_lignes_critique_pic") Then Local $AUX_attaque_lignes_critique_pic[1] = [0]
					$AUX_attaque_lignes_critique_pic[0] = $index
					ReDim $AUX_attaque_lignes_critique_pic[$index+1]
					Local $liste_critique_pic[7]   = [6,"","","","","",""]
					If Not IsDeclared("AUX_attaque_lignes_critique_label") Then Local $AUX_attaque_lignes_critique_label[1] = [0]
					$AUX_attaque_lignes_critique_label[0] = $index
					ReDim $AUX_attaque_lignes_critique_label[$index+1]
					Local $liste_critique_label[7] = [6,"","","","","",""]
					; Sauvegarde des donnes de base des dgats
					If Not IsDeclared("AUX_attaque_lignes_degats_matrice") Then Local $AUX_attaque_lignes_degats_matrice[1] = [0]
					$AUX_attaque_lignes_degats_matrice[0] = $index
					ReDim $AUX_attaque_lignes_degats_matrice[$index+1]
					; Cration des items du tableau des effets
					Local $matrice[7][2] = [[6,""],["",""],["",""],["",""],["",""],["",""],["",""]]
					For $i = 1 To 6
						displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Caractristiques de dgts"&@CRLF&"(ligne de dgts n"&$i&")")
						setProgression($progression,80+($i-1))
						; Effet normal
						$liste_normal_pic[$i]   = GUICtrlCreatePic("",   17, $i*25+112,  20, 20)
						$liste_normal_label[$i] = GUICtrlCreateLabel("", 42, $i*25+112, 175, 20)
						GUICtrlSetFont($liste_normal_label[$i],    9, 400, Default, $DAMAGECALC_FONT)
						GUICtrlSetColor($liste_normal_label[$i],   0xFFFFFF)
						GUICtrlSetBkColor($liste_normal_label[$i], $GUI_BKCOLOR_TRANSPARENT)
						; Effet critique
						$liste_critique_pic[$i]   = GUICtrlCreatePic("",   222, $i*25+112,  20, 20)
						$liste_critique_label[$i] = GUICtrlCreateLabel("", 247, $i*25+112, 175, 20)
						GUICtrlSetFont($liste_critique_label[$i],    9, 400, Default, $DAMAGECALC_FONT)
						GUICtrlSetColor($liste_critique_label[$i],   0xFFFFFF)
						GUICtrlSetBkColor($liste_critique_label[$i], $GUI_BKCOLOR_TRANSPARENT)
						If $perso_arme = "Sort" Then
							; Effet normal
							Local $effet = ""
							If check_ligne_sort(getDommageBalise(getDommageBalise($caracs_sort,"niveau_"&$lvl_sort),"normal_ligne_"&$i)) Then
								$effet = sort_calcul_de_degats($AUX_constitution[$index],$lvl_sort,$i)
							EndIf
							$matrice[$i][0] = $effet
							; Effet critique
							Local $effet = ""
							If check_ligne_sort(getDommageBalise(getDommageBalise($caracs_sort,"niveau_"&$lvl_sort),"critique_ligne_"&$i)) Then
								$effet = sort_calcul_de_degats($AUX_constitution[$index],$lvl_sort,$i,True)
							EndIf
							$matrice[$i][1] = $effet
						Else
							; Effet normal
							Local $effet = ""
							If check_ligne_arme($liste[$i]) Then $effet = arme_calcul_de_degats($AUX_constitution[$index],0,$i)
							$matrice[$i][0] = $effet
							; Effet critique
							Local $effet = ""
							If check_ligne_arme($liste[$i]) Then $effet = arme_calcul_de_degats($AUX_constitution[$index],0,$i,True)
							$matrice[$i][1] = $effet
						EndIf
					Next
					$AUX_attaque_lignes_normal_pic[$index]     = $liste_normal_pic     ; Liste des ctrlHandles des images lies aux dgts normaux
					$AUX_attaque_lignes_normal_label[$index]   = $liste_normal_label   ; Liste des ctrlHandles des items lis aux dgts normaux
					$AUX_attaque_lignes_critique_pic[$index]   = $liste_critique_pic   ; Liste des ctrlHandles des images lies aux dgts critiques
					$AUX_attaque_lignes_critique_label[$index] = $liste_critique_label ; Liste des ctrlHandles des items lis aux dgts critiques
					$AUX_attaque_lignes_degats_matrice[$index] = $matrice              ; Matrice des effets de l'arme / du sort
					#EndRegion

					#Region Caractristiques de l'adversaire
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Caractristiques de l'adversaire")
					setProgression($progression,90)
					$AUX_adversaire_titre_label = GUICtrlCreateLabel(" Caractristiques de l'adversaire",40,331,358,20)
					GUICtrlSetFont(   $AUX_adversaire_titre_label, 12, 400, Default, $DAMAGECALC_FONT)
					GUICtrlSetColor(  $AUX_adversaire_titre_label, 0xFFFFFF)
					GUICtrlSetBkColor($AUX_adversaire_titre_label, $GUI_BKCOLOR_TRANSPARENT)
					; Elements graphiques
					If Not IsDeclared("AUX_adversaire_resistance_pics") Then Local $AUX_adversaire_resistance_pics[1] = [0]
					$AUX_adversaire_resistance_pics[0] = $index
					ReDim $AUX_adversaire_resistance_pics[$index+1]
					If Not IsDeclared("AUX_adversaire_resistance_labels") Then Local $AUX_adversaire_resistance_labels[1] = [0]
					$AUX_adversaire_resistance_labels[0] = $index
					ReDim $AUX_adversaire_resistance_labels[$index+1]
					setProgression($progression,95)
					Local $array[10] = [9, _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"PA.bmp",         21+0*81, 359, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"PM.bmp",         21+1*81, 359, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"PA_inactif.bmp", 21+3*81, 359, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"PM_inactif.bmp", 21+4*81, 359, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Neutre.bmp",     21+0*81, 384, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Terre.bmp",      21+1*81, 384, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Feu.bmp",        21+2*81, 384, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Eau.bmp",        21+3*81, 384, 20, 20), _
						GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Air.bmp",        21+4*81, 384, 20, 20)  _
					]
					GUICtrlSetTip($array[1], "Nombre de PA de l'adversaire")
					GUICtrlSetTip($array[2], "Nombre de PM de l'adversaire")
					GUICtrlSetTip($array[3], "Esquive PA de l'adversaire")
					GUICtrlSetTip($array[4], "Esquive PM de l'adversaire")
					GUICtrlSetTip($array[5], "Rsistance neutre de l'adversaire")
					GUICtrlSetTip($array[6], "Rsistance terre de l'adversaire")
					GUICtrlSetTip($array[7], "Rsistance feu de l'adversaire")
					GUICtrlSetTip($array[8], "Rsistance eau de l'adversaire")
					GUICtrlSetTip($array[9], "Rsistance air de l'adversaire")
					$AUX_adversaire_resistance_pics[$index] = $array ; Liste des ctrlHandles des images lies aux caractristiques de l'adversaire
					Local $array[10] = [9, _
						GUICtrlCreateInput(0, 45+0*81, 359, 46, 20), _
						GUICtrlCreateInput(0, 45+1*81, 359, 46, 20), _
						GUICtrlCreateInput(0, 45+3*81, 359, 46, 20), _
						GUICtrlCreateInput(0, 45+4*81, 359, 46, 20), _
						GUICtrlCreateInput(0, 45+0*81, 384, 46, 20), _
						GUICtrlCreateInput(0, 45+1*81, 384, 46, 20), _
						GUICtrlCreateInput(0, 45+2*81, 384, 46, 20), _
						GUICtrlCreateInput(0, 45+3*81, 384, 46, 20), _
						GUICtrlCreateInput(0, 45+4*81, 384, 46, 20)  _
					]
					GUICtrlSetTip($array[1], "Nombre de PA de l'adversaire")
					GUICtrlSetTip($array[2], "Nombre de PM de l'adversaire")
					GUICtrlSetTip($array[3], "Esquive PA de l'adversaire")
					GUICtrlSetTip($array[4], "Esquive PM de l'adversaire")
					GUICtrlSetTip($array[5], "Rsistance neutre de l'adversaire")
					GUICtrlSetTip($array[6], "Rsistance terre de l'adversaire")
					GUICtrlSetTip($array[7], "Rsistance feu de l'adversaire")
					GUICtrlSetTip($array[8], "Rsistance eau de l'adversaire")
					GUICtrlSetTip($array[9], "Rsistance air de l'adversaire")
					For $i = 1 To $array[0]
						GUICtrlCreateUpdown($array[$i], $UDS_ARROWKEYS)
						GUICtrlSetColor($array[$i],     0xFFFFFF)
						GUICtrlSetBkColor($array[$i],   0x564F4C)
					Next
					$AUX_adversaire_resistance_labels[$index] = $array ; Liste des ctrlHandles des items lis aux caractristiques de l'adversaire
					If Not IsDeclared("AUX_adversaire_resistances_previous") Then Local $AUX_adversaire_resistances_previous[1] = [0]
					$AUX_adversaire_resistances_previous[0] = $index
					ReDim $AUX_adversaire_resistances_previous[$index+1]
					$AUX_adversaire_resistances_previous[$index] = ""
					If Not IsDeclared("AUX_adversaire_resistances") Then Local $AUX_adversaire_resistances[1] = [0]
					$AUX_adversaire_resistances[0] = $index
					ReDim $AUX_adversaire_resistances[$index+1]
					$AUX_adversaire_resistances[$index] = ""
					; Systme de rcupration des rsistances
					If Not IsDeclared("AUX_damageCalc_copier_bouton") Then Local $AUX_damageCalc_copier_bouton[1] = [0]
					$AUX_damageCalc_copier_bouton[0] = $index
					ReDim $AUX_damageCalc_copier_bouton[$index+1]
					$AUX_damageCalc_copier_bouton[$index] = GUICtrlCreatePic($damageCalc_repertoire_images&"Interface\Copier.bmp", 45+3*81, 385+25,  45,16)
					GUICtrlSetTip($AUX_damageCalc_copier_bouton[$index], "Cliquez pour copier les caractritiques de l'adversaire"&@CRLF& _
						"vers toutes les fentres auxiliaires affiches", "Copie des caractritiques de l'adversaire")
					#EndRegion

					#Region Systme d'tats
					displayTip($MODULE_NOM&" v"&$MODULE_VERSION&" [AUX:"&$index&"]","Systme d'tats de la fentre")
					setProgression($progression,100)
					; Mode d'affichage
					If Not IsDeclared("AUX_damageCalc_etat_meandisplay") Then Local $AUX_damageCalc_etat_meandisplay[1] = [0]
					$AUX_damageCalc_etat_meandisplay[0] = $index
					ReDim $AUX_damageCalc_etat_meandisplay[$index+1]
					$AUX_damageCalc_etat_meandisplay[$index] = False
					; Mode de dplacement
					If Not IsDeclared("AUX_damageCalc_etat_move") Then Local $AUX_damageCalc_etat_move[1] = [0]
					$AUX_damageCalc_etat_move[0] = $index
					ReDim $AUX_damageCalc_etat_move[$index+1]
					$AUX_damageCalc_etat_move[$index] = True
					; Mode "NotifyObserver"
					If Not IsDeclared("AUX_force_update") Then Local $AUX_force_update[1] = [0]
					$AUX_force_update[0] = $index
					ReDim $AUX_force_update[$index+1]
					$AUX_force_update[$index] = False
					#endregion

					displayTip()
					GUISetState(@SW_SHOW,$AUX_GUI[$index])

					; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
					GUICtrlSetImage($effet_efface_bouton, $damageCalc_repertoire_images&"Interface\Normal.bmp")
					GUICtrlSetState($effet_efface_bouton, $GUI_ENABLE)
					GUICtrlSetState($effet_efface_label,  $GUI_ENABLE)
					setProgression($progression)
				EndIf
			EndSwitch
			#EndRegion
		Case Else
			For $index = 1 To $AUX_GUI[0]
				If $msgGUI[1] = $AUX_GUI[$index] Or $AUX_force_update[$index] Then                                                                   ; Fentre auxiliaire n$index
					Switch $msgGUI[0]
					Case $AUX_Bouton_Quitter[$index]                                                                                                 ; Bouton Quitter
						GUIDelete($AUX_GUI[$index])
						; Changement des pages  comparer
						If $index = $comparaison_couple[0] Then
							$comparaison_couple[0] = $comparaison_couple[1]
							$comparaison_couple[1] = 0
						ElseIf $index = $comparaison_couple[1] Then
							$comparaison_couple[1] = 0
						EndIf
						; Dsactivation des fentres prcdentes
						If $comparaison_couple[0] = 0 Or $comparaison_couple[1] = 0 Then
							GUICtrlSetColor($AUX_ppr_label[$comparaison_couple[0]],   0xFFFFFF)
							GUICtrlSetColor($AUX_rwc_label[$comparaison_couple[0]],   0xFFFFFF)
							GUICtrlSetColor($AUX_total_label[$comparaison_couple[0]], 0xFFFFFF)
							GUICtrlSetColor($AUX_ppr_label[$comparaison_couple[1]],   0xFFFFFF)
							GUICtrlSetColor($AUX_rwc_label[$comparaison_couple[1]],   0xFFFFFF)
							GUICtrlSetColor($AUX_total_label[$comparaison_couple[1]], 0xFFFFFF)
						EndIf
						Local $found = False
						For $j = 1 To $AUX_GUI[0]
							$found = $found Or IsArray(GUIGetStyle($AUX_GUI[$j]))
						Next
						; Mise  jour des boutons "Modifier"/"Afficher"/"Effacer"
						GUICtrlSetImage($effet_efface_bouton, $damageCalc_repertoire_images&"Interface\Normal"&cond($found,"","_inactif")&".bmp")
						GUICtrlSetState($effet_efface_bouton, cond($found,$GUI_ENABLE,$GUI_DISABLE))
						GUICtrlSetState($effet_efface_label,  cond($found,$GUI_ENABLE,$GUI_DISABLE))
					Case $AUX_Bouton_Deplacer[$index]                                                                                                ; Bouton Dplacer
						$AUX_damageCalc_etat_move[$index] = False
					Case $AUX_damageCalc_copier_bouton[$index]                                                                                       ; Bouton Copier
						Local $valeurOriginal = $AUX_adversaire_resistance_labels[$index]
						For $i = 1 To $AUX_GUI[0]
							$AUX_force_update[$i] = True
							If $i <> $index And WinExists($AUX_GUI[$i]) Then
								Local $valeur = $AUX_adversaire_resistance_labels[$i]
								For $j = 1 To $valeur[0]
									GUICtrlSetData($valeur[$j],GUICtrlRead($valeurOriginal[$j]))
								Next
							EndIf
						Next
					Case $AUX_total_label[$index]                                                                                                    ; Label total/moyenne de dgats
						$AUX_damageCalc_etat_meandisplay[$index] = Not $AUX_damageCalc_etat_meandisplay[$index]
						$AUX_force_update[$index] = True
					Case $AUX_Bouton_Epingler[$index]                                                                                                ; Bouton Epingler
						; Dsactivation des fentres prcdentes
						If $comparaison_couple[0] <> 0 Then
							GUICtrlSetImage($AUX_Bouton_Epingler[$comparaison_couple[0]], $damageCalc_repertoire_images&"Interface"&"\"&"Epingler_inactif.bmp")
							GUICtrlSetColor($AUX_ppr_label[$comparaison_couple[0]],   0xFFFFFF)
							GUICtrlSetColor($AUX_rwc_label[$comparaison_couple[0]],   0xFFFFFF)
							GUICtrlSetColor($AUX_total_label[$comparaison_couple[0]], 0xFFFFFF)
						EndIf
						If $comparaison_couple[1] <> 0 Then
							GUICtrlSetImage($AUX_Bouton_Epingler[$comparaison_couple[1]], $damageCalc_repertoire_images&"Interface"&"\"&"Epingler_inactif.bmp")
							GUICtrlSetColor($AUX_ppr_label[$comparaison_couple[1]],   0xFFFFFF)
							GUICtrlSetColor($AUX_rwc_label[$comparaison_couple[1]],   0xFFFFFF)
							GUICtrlSetColor($AUX_total_label[$comparaison_couple[1]], 0xFFFFFF)
						EndIf
						; Changement des pages  comparer
						If $index = $comparaison_couple[0] Then
							$comparaison_couple[0] = $comparaison_couple[1]
							$comparaison_couple[1] = 0
						ElseIf $index = $comparaison_couple[1] Then
							$comparaison_couple[1] = 0
						Else
							$comparaison_couple[1] = $comparaison_couple[0]
							$comparaison_couple[0] = $index
						EndIf
						If $comparaison_couple[0] <> 0 Then GUICtrlSetImage($AUX_Bouton_Epingler[$comparaison_couple[0]], $damageCalc_repertoire_images&"Interface"&"\"&"Epingler.bmp")
						If $comparaison_couple[1] <> 0 Then GUICtrlSetImage($AUX_Bouton_Epingler[$comparaison_couple[1]], $damageCalc_repertoire_images&"Interface"&"\"&"Epingler.bmp")
						If $comparaison_couple[0] <> 0 And $comparaison_couple[1] <> 0 Then
							$AUX_force_update[$comparaison_couple[0]] = True
							$AUX_force_update[$comparaison_couple[1]] = True
						EndIf
					Case $AUX_lvl_label[$index]                                                                                                      ; Bouton du choix du niveau de sort/matrise
						sousmenu($AUX_GUI[$index], $AUX_lvl_label[$index], $AUX_lvl_menu[$index])
					Case Else
						If $AUX_damageCalc_etat_move[$index] Then                                                                                    ; Activation du mode de dplacement
							Local $mouse = MouseGetPos(), $control = getControlCoords($AUX_GUI[$index],$AUX_Bouton_Deplacer[$index],True)
							If IsArray($control) Then WinMove($AUX_GUI[$index],"", $mouse[0]-$control[0]-$control[2]/2, $mouse[1]-$control[1]-$control[3]/2)
						EndIf
						Local $liste_menuitems = $AUX_lvl_menuitems[$index]
						For $lvl = 1 To $liste_menuitems[0]                                                                                          ; Changement de niveau de matrise ou de sort
							If $msgGUI[0] = $liste_menuitems[$lvl] Then
								For $i = 1 To $liste_menuitems[0]
									GUICtrlSetState($liste_menuitems[$i],$GUI_ENABLE)
								Next
								GUICtrlSetState($liste_menuitems[$lvl],$GUI_DISABLE+$GUI_DEFBUTTON)
								If $AUX_perso_arme[$index] = "Sort" Then
									#Region Sort
									Local $caracs_sort = getDommageBalise($AUX_constitution[$index],"perso_sort")
									; Entte de colonnes
									$AUX_lvl_valeur[$index]  = Number($lvl)
									$AUX_attaque_pa[$index]  = Number(getDommageBalise(getDommageBalise($caracs_sort,"niveau_"&$lvl),"pa"))
									$AUX_attaque_tcc[$index] = Number(getDommageBalise(getDommageBalise($caracs_sort,"niveau_"&$lvl),"tcc"))
									$AUX_cc_effectif[$index] = calcul_de_cc($AUX_attaque_tcc[$index], $AUX_carac_cc[$index], $AUX_carac_agi[$index])
									GUICtrlSetData($AUX_cn_label[$index], "Coup normal"&cond($AUX_attaque_pa[$index]>0," : "&$AUX_attaque_pa[$index]&"PA",""))
									GUICtrlSetData($AUX_cc_label[$index], cond(Number($AUX_cc_effectif[$index]) > 1, "Coup critique : 1/" & Number($AUX_cc_effectif[$index]), "Coup critique : Aucun"))
									; Modification des miniatures prcdentes des lignes de sorts
									Local $liste_normal_pic = $AUX_attaque_lignes_normal_pic[$index], $liste_critique_pic = $AUX_attaque_lignes_critique_pic[$index]
									Local $matrice[7][2] = [[6,""],["",""],["",""],["",""],["",""],["",""],["",""]]
									For $i = 1 To 6
										GUICtrlSetImage($liste_normal_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										GUICtrlSetImage($liste_critique_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_normal_pic[$i])
										If Not @error Then GUICtrlSetPos($liste_normal_pic[$i], $pos[0],$pos[1], 20,20)
										Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_critique_pic[$i])
										If Not @error Then GUICtrlSetPos($liste_critique_pic[$i], $pos[0],$pos[1], 20,20)
										; Effet normal
										Local $effet = ""
										If check_ligne_sort(getDommageBalise(getDommageBalise($caracs_sort,"niveau_"&$lvl),"normal_ligne_"&$i)) Then
											$effet = sort_calcul_de_degats($AUX_constitution[$index],$lvl,$i)
										EndIf
										$matrice[$i][0] = $effet
										; Effet critique
										Local $effet = ""
										If check_ligne_sort(getDommageBalise(getDommageBalise($caracs_sort,"niveau_"&$lvl),"critique_ligne_"&$i)) Then
											$effet = sort_calcul_de_degats($AUX_constitution[$index],$lvl,$i,True)
										EndIf
										$matrice[$i][1] = $effet
									Next
									$AUX_attaque_lignes_degats_matrice[$index] = $matrice
									; Label niveau de sort
									GUICtrlSetData($AUX_lvl_label[$index],"Niveau "&$AUX_lvl_valeur[$index])
									#EndRegion
								Else
									#Region Arme
									; Entte de colonnes
									$AUX_lvl_valeur[$index]  = Number($lvl)-1
									$AUX_cc_effectif[$index] = calcul_de_cc($AUX_attaque_tcc[$index], $AUX_carac_cc[$index], $AUX_carac_agi[$index])
									GUICtrlSetData($AUX_cn_label[$index], "Coup normal"&cond($AUX_attaque_pa[$index]>0," : "&$AUX_attaque_pa[$index]&"PA",""))
									GUICtrlSetData($AUX_cc_label[$index], cond(Number($AUX_cc_effectif[$index]) > 1, "Coup critique : 1/" & Number($AUX_cc_effectif[$index]), "Coup critique : Aucun"))
									; Modification des miniatures prcdentes des lignes de sorts
									Local $liste_normal_pic = $AUX_attaque_lignes_normal_pic[$index], $liste_critique_pic = $AUX_attaque_lignes_critique_pic[$index]
									Local $matrice[7][2] = [[6,""],["",""],["",""],["",""],["",""],["",""],["",""]], $liste = $AUX_arme_lignes[$index]
									For $i = 1 To 6
										GUICtrlSetImage($liste_normal_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										GUICtrlSetImage($liste_critique_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_normal_pic[$i])
										If Not @error Then GUICtrlSetPos($liste_normal_pic[$i], $pos[0],$pos[1], 20,20)
										Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_critique_pic[$i])
										If Not @error Then GUICtrlSetPos($liste_critique_pic[$i], $pos[0],$pos[1], 20,20)
										; Effet normal
										Local $effet = ""
										If check_ligne_arme($liste[$i]) Then $effet = arme_calcul_de_degats($AUX_constitution[$index],$lvl,$i)
										$matrice[$i][0] = $effet
										; Effet critique
										Local $effet = ""
										If check_ligne_arme($liste[$i]) Then $effet = arme_calcul_de_degats($AUX_constitution[$index],$lvl,$i,True)
										$matrice[$i][1] = $effet
									Next
									$AUX_attaque_lignes_degats_matrice[$index] = $matrice
									; Label niveau de sort
									GUICtrlSetData($AUX_lvl_label[$index], _
										cond($AUX_lvl_valeur[$index]=0, _
											"Aucune matrise", _
											cond($AUX_lvl_valeur[$index]=7, _
												"Niveau 6 (cc)", _
												"Niveau "&$AUX_lvl_valeur[$index] _
											) _
										) _
									)
									#EndRegion
								EndIf
								$AUX_force_update[$index] = True
							EndIf
						Next
						Local $liste_res = $AUX_adversaire_resistance_labels[$index]
						$AUX_adversaire_resistances[$index] = "" & _
							"<nombre_pa>"  & cleanNumber(GUICtrlRead($liste_res[1])) & "</nombre_pa>"  & _
							"<nombre_pm>"  & cleanNumber(GUICtrlRead($liste_res[2])) & "</nombre_pm>"  & _
							"<esquive_pa>" & cleanNumber(GUICtrlRead($liste_res[3])) & "</esquive_pa>" & _
							"<esquive_pm>" & cleanNumber(GUICtrlRead($liste_res[4])) & "</esquive_pm>" & _
							"<neutre>"     & cleanNumber(GUICtrlRead($liste_res[5])) & "</neutre>"     & _
							"<for>"        & cleanNumber(GUICtrlRead($liste_res[6])) & "</for>"        & _
							"<int>"        & cleanNumber(GUICtrlRead($liste_res[7])) & "</int>"        & _
							"<cha>"        & cleanNumber(GUICtrlRead($liste_res[8])) & "</cha>"        & _
							"<agi>"        & cleanNumber(GUICtrlRead($liste_res[9])) & "</agi>"
						If $AUX_adversaire_resistances_previous[$index] <> $AUX_adversaire_resistances[$index] Or $AUX_force_update[$index] Then     ; Modification des rsistances de l'adversaire
							$AUX_force_update[$index] = False
							$AUX_adversaire_resistances_previous[$index] = $AUX_adversaire_resistances[$index]
							$liste_normal_pic     = $AUX_attaque_lignes_normal_pic[$index]
							$liste_normal_label   = $AUX_attaque_lignes_normal_label[$index]
							$liste_critique_pic   = $AUX_attaque_lignes_critique_pic[$index]
							$liste_critique_label = $AUX_attaque_lignes_critique_label[$index]
							$matrice              = $AUX_attaque_lignes_degats_matrice[$index]
							Local $ratioCN = 0, $ratioCC = 0, $totalCN = 0, $totalCNmin = 0, $totalCNmax = 0, $totalCC = 0, $totalCCmin = 0, $totalCCmax = 0
							For $i = 1 To 6
								If $AUX_perso_arme[$index] = "Sort" Then
									; Sort : Effet normal
									If check_ligne_sort($matrice[$i][0]) Then
										GUICtrlSetImage($liste_normal_pic[$i],  $damageCalc_repertoire_images&"Elments\"& _
											cond( _
												getDommageElement($matrice[$i][0])<>"Neutre", _
												getDommageElement($matrice[$i][0]), _
												cond( _
													Number(getDommageForgemagieValeur($matrice[$i][0]))<>0 And StringInStr(";Terre;Feu;Eau;Air;",";"&getDommageForgemagieElement($matrice[$i][0])&";"), _
													getDommageForgemagieElement($matrice[$i][0]), _
													"Neutre" _
												) _
											)&".bmp" _
										)
										#Region Calcul de l'effet
										Local $valeur = appliquer_resistances($matrice[$i][0],$AUX_adversaire_resistances[$index],$AUX_constitution[$index])
										If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&getDommageElement($matrice[$i][0])&";") Then
											Local $coef = getCoefFromType(getDommageType($valeur))
											$ratioCN    = $ratioCN + $coef*(Number(getDommageMin($valeur))+Number(getDommageMax($valeur)))/2
											$totalCN    = $totalCN + (Number(getDommageMin($valeur))+Number(getDommageMax($valeur)))/2
											$totalCNmin = $totalCNmin + Number(getDommageMin($valeur))
											$totalCNmax = $totalCNmax + Number(getDommageMax($valeur))
										EndIf
										#EndRegion
										GUICtrlSetData($liste_normal_label[$i], effet_tostring($valeur))
									Else
										GUICtrlSetImage($liste_normal_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										GUICtrlSetData($liste_normal_label[$i], cond($i=1,"N'a aucun effet",""))
									EndIf
									Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_normal_pic[$i])
									If Not @error Then GUICtrlSetPos($liste_normal_pic[$i], $pos[0],$pos[1], 20,20)
									; Sort : Effet critique
									If check_ligne_sort($matrice[$i][1]) Then
										GUICtrlSetImage($liste_critique_pic[$i],  $damageCalc_repertoire_images&"Elments\"& _
											cond( _
												getDommageElement($matrice[$i][1])<>"Neutre", _
												getDommageElement($matrice[$i][1]), _
												cond( _
													Number(getDommageForgemagieValeur($matrice[$i][1]))<>0 And StringInStr(";Terre;Feu;Eau;Air;",";"&getDommageForgemagieElement($matrice[$i][1])&";"), _
													getDommageForgemagieElement($matrice[$i][1]), _
													"Neutre" _
												) _
											)&".bmp" _
										)
										#Region Calcul de l'effet
										Local $valeur = appliquer_resistances($matrice[$i][1],$AUX_adversaire_resistances[$index],$AUX_constitution[$index])
										If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&getDommageElement($matrice[$i][1])&";") Then
											Local $type = getDommageType($valeur)
											Local $coef = cond($type="Inflige",1,cond($type="Vole",1.5,cond($type="Soigne",-1,0)))/2
											$ratioCC = $ratioCC + $coef*(Number(getDommageMin($valeur))+Number(getDommageMax($valeur)))
											$totalCC = $totalCC + (Number(getDommageMin($valeur))+Number(getDommageMax($valeur)))/2
											$totalCCmin = $totalCCmin + Number(getDommageMin($valeur))
											$totalCCmax = $totalCCmax + Number(getDommageMax($valeur))
										EndIf
										#EndRegion
										GUICtrlSetData($liste_critique_label[$i], effet_tostring($valeur))
									Else
										GUICtrlSetImage($liste_critique_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										GUICtrlSetData($liste_critique_label[$i], cond($i=1,"N'a aucun effet",""))
									EndIf
									Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_critique_pic[$i])
									If Not @error Then GUICtrlSetPos($liste_critique_pic[$i], $pos[0],$pos[1], 20,20)
								Else
									; Arme : Effet normal
									If check_ligne_arme($matrice[$i][0]) Then
										GUICtrlSetImage($liste_normal_pic[$i],  $damageCalc_repertoire_images&"Elments\"& _
											cond( _
												getDommageElement($matrice[$i][0])<>"Neutre", _
												getDommageElement($matrice[$i][0]), _
												cond( _
													Number(getDommageForgemagieValeur($matrice[$i][0]))<>0 And StringInStr(";Terre;Feu;Eau;Air;",";"&getDommageForgemagieElement($matrice[$i][0])&";"), _
													getDommageForgemagieElement($matrice[$i][0]), _
													"Neutre" _
												) _
											)&".bmp" _
										)
										#Region Calcul de l'effet
										Local $valeur = appliquer_resistances($matrice[$i][0],$AUX_adversaire_resistances[$index],$AUX_constitution[$index])
										If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&getDommageElement($matrice[$i][0])&";") Then
											Local $type = getDommageType($valeur)
											Local $coef = cond($type="Inflige",1,cond($type="Vole",1.5,cond($type="Soigne",-1,0)))/2
											$ratioCN = $ratioCN + $coef*(getDommageMin($valeur)+getDommageMax($valeur))
											$totalCN = $totalCN + (getDommageMin($valeur)+getDommageMax($valeur))/2
											$totalCNmin = $totalCNmin + getDommageMin($valeur)
											$totalCNmax = $totalCNmax + getDommageMax($valeur)
										EndIf
										#EndRegion
										GUICtrlSetData($liste_normal_label[$i], effet_tostring($valeur))
									Else
										GUICtrlSetImage($liste_normal_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										GUICtrlSetData($liste_normal_label[$i], cond($i=1,"N'a aucun effet",""))
									EndIf
									Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_normal_pic[$i])
									If Not @error Then GUICtrlSetPos($liste_normal_pic[$i], $pos[0],$pos[1], 20,20)
									; Arme : Effet critique
									If check_ligne_arme($matrice[$i][1]) Then
										GUICtrlSetImage($liste_critique_pic[$i],  $damageCalc_repertoire_images&"Elments\"& _
											cond( _
												getDommageElement($matrice[$i][1])<>"Neutre", _
												getDommageElement($matrice[$i][1]), _
												cond( _
													Number(getDommageForgemagieValeur($matrice[$i][1]))<>0 And StringInStr(";Terre;Feu;Eau;Air;",";"&getDommageForgemagieElement($matrice[$i][1])&";"), _
													getDommageForgemagieElement($matrice[$i][1]), _
													"Neutre" _
												) _
											)&".bmp" _
										)
										#Region Calcul de l'effet
										Local $valeur = appliquer_resistances($matrice[$i][1],$AUX_adversaire_resistances[$index],$AUX_constitution[$index])
										If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&getDommageElement($matrice[$i][0])&";") Then
											Local $type = getDommageType($valeur)
											Local $coef = cond($type="Inflige",1,cond($type="Vole",1.5,cond($type="Soigne",-1,0)))/2
											If $AUX_cc_effectif[$index]>=2 Then
												$ratioCC = $ratioCC + $coef*(getDommageMin($valeur)+getDommageMax($valeur))
												$totalCC = $totalCC + (getDommageMin($valeur)+getDommageMax($valeur))/2
												$totalCCmin = $totalCCmin + getDommageMin($valeur)
												$totalCCmax = $totalCCmax + getDommageMax($valeur)
											EndIf
										EndIf
										#EndRegion
										GUICtrlSetData($liste_critique_label[$i], effet_tostring($valeur))
									Else
										GUICtrlSetImage($liste_critique_pic[$i], $damageCalc_repertoire_images&"Elments\Aucun_"&Mod($i,2)&".bmp")
										GUICtrlSetData($liste_critique_label[$i], cond($i=1,"N'a aucun effet",""))
									EndIf
									Local $pos = ControlGetPos($AUX_GUI[$index], "", $liste_critique_pic[$i])
									If Not @error Then GUICtrlSetPos($liste_critique_pic[$i], $pos[0],$pos[1], 20,20)
								EndIf
							Next
							Local $ratio = $ratioCN, $total = $totalCN
							If $AUX_cc_effectif[$index]>=2 Then
								$ratio = Round((($AUX_cc_effectif[$index]-1)*$ratioCN + $ratioCC)/$AUX_cc_effectif[$index],2)
								$total = Round((($AUX_cc_effectif[$index]-1)*$totalCN + $totalCC)/$AUX_cc_effectif[$index],2)
							EndIf
							$AUX_rwc_valeur[$index]   = cond(Number($AUX_attaque_pa[$index])>0,Round($ratio/Max(Number($AUX_attaque_pa[$index]),1),2),"Aucun")
							$AUX_total_valeur[$index] = $total
							GUICtrlSetData($AUX_rwc_label[$index],"Ratio : "&$AUX_rwc_valeur[$index])
							If $AUX_damageCalc_etat_meandisplay[$index] Then
								GUICtrlSetData($AUX_total_label[$index], "Moyenne : " & $total)
							Else
								GUICtrlSetData($AUX_total_label[$index], _
									"Total : " & $totalCNmin & cond($totalCNmin=$totalCNmax, "", "  "&$totalCNmax) & _
									cond($AUX_cc_effectif[$index]>=2, _
										" / " & $totalCCmin&cond($totalCCmin=$totalCCmax, "", "  "&$totalCCmax) & " en cc", _
										"" _
									) _
								)
							EndIf
							; Mise en place des comparaisons
							If $comparaison_couple[0] <> 0 And $comparaison_couple[1] <> 0 Then
								Local $delta_ppr   = Number($AUX_ppr_valeur[$comparaison_couple[1]])   - Number($AUX_ppr_valeur[$comparaison_couple[0]])
								Local $delta_rwc   = Number($AUX_rwc_valeur[$comparaison_couple[1]])   - Number($AUX_rwc_valeur[$comparaison_couple[0]])
								Local $delta_total = Number($AUX_total_valeur[$comparaison_couple[1]]) - Number($AUX_total_valeur[$comparaison_couple[0]])
								Local $delta_tcc   = Number($AUX_cc_effectif[$comparaison_couple[1]])  - Number($AUX_cc_effectif[$comparaison_couple[0]])
								If Number($AUX_ppr_valeur[$comparaison_couple[0]]) > 0 And Number($AUX_ppr_valeur[$comparaison_couple[1]]) > 0 Then
									GUICtrlSetColor($AUX_ppr_label[$comparaison_couple[0]], cond($delta_ppr<=0,0x44CC44,0xFFFFFF))
									GUICtrlSetColor($AUX_ppr_label[$comparaison_couple[1]], cond($delta_ppr>=0,0x44CC44,0xFFFFFF))
								EndIf
								GUICtrlSetColor($AUX_rwc_label[$comparaison_couple[0]], cond($delta_rwc<=0,0x44CC44,0xFFFFFF))
								GUICtrlSetColor($AUX_rwc_label[$comparaison_couple[1]], cond($delta_rwc>=0,0x44CC44,0xFFFFFF))
								GUICtrlSetColor($AUX_total_label[$comparaison_couple[0]], cond($delta_total<=0,0x119911,0xFFFFFF))
								GUICtrlSetColor($AUX_total_label[$comparaison_couple[1]], cond($delta_total>=0,0x119911,0xFFFFFF))
								If $AUX_cc_effectif[$comparaison_couple[0]]*$AUX_cc_effectif[$comparaison_couple[1]] <> 0 Then
									GUICtrlSetColor($AUX_cc_label[$comparaison_couple[0]], cond($delta_tcc>=0,0x119911,0xFFFFFF)) ; Invers
									GUICtrlSetColor($AUX_cc_label[$comparaison_couple[1]], cond($delta_tcc<=0,0x119911,0xFFFFFF)) ; Invers
								EndIf
							EndIf
						EndIf
					EndSwitch
				EndIf
			Next
		EndSwitch
	WEnd
	DllClose($dll)
	GUIDelete($GUI)
EndFunc

Func listingSkins($dossier)
	Local $valeur = IniRead($dossier&"Skin.ini","Skin","Dossier",""), $liste = FileListToArray(StringTrimRight($dossier,1),"*",2)
	If $valeur = "" Or Not FileExists($dossier&$valeur) Or Not IsArray($liste) Then
		$valeur = ""
		If IsArray($liste) Then $valeur = $liste[Min(1,$liste[0])]
		FileClose(FileOpen($dossier&"Skin.ini",10))
		IniWrite($dossier&"Skin.ini","Skin","Dossier",$valeur)
		Return ""
	EndIf
	Return $dossier&$valeur&"\"
EndFunc

Func updateSortMenu(ByRef $menu, ByRef $liste, $ctx, $classe = "", $sort = "")
	Local $resultat = False
	For $i = 1 To $menu[0]
		GUICtrlAdvancedDelete($menu[$i])
	Next
	If $classe <> "" Then
		$liste = listing_XML($damageCalc_programme_donnees, $classe)
		If $liste[0][0] = 0 Then
			ReDim $menu[2], $liste[2][2]
			$menu[0] = 1
			$menu[1] = GUICtrlCreateAdvancedMenuItem("Aucun sort", $ctx)
			$liste[0][0] = 0
			$liste[0][1] = ""
			$liste[1][0] = ""
			$liste[1][1] = ""
			GUICtrlSetState($menu[1], $GUI_DISABLE)
		Else
			$menu[0] = $liste[0][0]
			ReDim $menu[$menu[0]+1]
			For $i = 1 To $menu[0]
				$menu[$i] = GUICtrlCreateAdvancedMenuItem($liste[$i][0], $ctx)
				If $liste[$i][0]=$sort Then $resultat = True
			Next
		EndIf
	Else
		ReDim $menu[2], $liste[2][2]
		$menu[0] = 1
		$menu[1] = GUICtrlCreateAdvancedMenuItem("Aucun sort", $ctx)
		$liste[0][0] = 0
		$liste[0][1] = ""
		$liste[1][0] = ""
		$liste[1][1] = ""
		GUICtrlSetState($menu[1], $GUI_DISABLE)
	EndIf
	Return $resultat
EndFunc

Func setProgression($item,$pourcent=0)
	GUICtrlSetImage($item, $damageCalc_repertoire_images&"Interface\Progression\"&Floor($pourcent*33/100)&".bmp")
	Sleep(10)
EndFunc

Func guiValeur($parent,$valeur,$type,$min="",$max="", $itemToCatch = "MOUSE")
	Local $retour = 0, $erreur = 0, $vide[2] = [0,0], $ok = False
	If $itemToCatch = "MOUSE" Then
		Local $position = MouseGetPos()
	Else
		Local $position = getControlCoords($parent, $itemToCatch)
		If @error Then
			$position = $vide
		Else
			$position[0] = $position[0] + $position[2]/4
			$position[1] = $position[1] + $position[3]/4
		EndIf
	EndIf
	; GUI
	Local $child_background = $damageCalc_repertoire_images & "Interface\Background_modif.bmp", $dimension[2] = [112,30]
	Local $child = GUICreate("", $dimension[0], $dimension[1], _
		cond($position[0]+$dimension[0]>@DesktopWidth,  @DesktopWidth-$dimension[0],  cond($position[0]<0, @DesktopWidth  - $dimension[0]/2, $position[0])), _
		cond($position[1]+$dimension[1]>@DesktopHeight, @DesktopHeight-$dimension[1], cond($position[1]<0, @DesktopHeight - $dimension[1]/2, $position[1])), _
		BitOR($WS_POPUP,$WS_BORDER), -1, _
		$parent _
	)
	GUICtrlCreatePic($child_background, 0,0, $dimension[0],$dimension[1])
	GUICtrlSetState(-1, $GUI_DISABLE)
	; Item
	Local $item = "", $updown = ""
	Switch $type
	Case "INT"
		$item   = GUICtrlCreateInput($valeur,4,4,83,21)
		$updown = GUICtrlCreateUpdown($item,$UDS_ARROWKEYS)
	Case "STRING"
		$item = GUICtrlCreateInput($valeur,4,4,83,21)
	EndSwitch
	If $item = "" Then
		$erreur = 1
	Else
		GUICtrlSetColor($item,0xFFFFFF)
		GUICtrlSetBkColor($item,0x564F4C)
		Local $valider = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface\Valider.bmp", 89,6, 18,18)
		; Traitement
		GUISetState(@SW_SHOW, $child)
		ControlFocus($child, "", $item)
		ControlSend($child, "", $item, "{UP}{DOWN}{HOME}+{END}")
		Local $dll = DllOpen("user32.dll")
		While WinActive($child) And Not IsPressed("1B", $dll) And Not $ok
			Local $msgChild = GUIGetMsg()
			If $msgChild = $valider Or IsPressed("0D", $dll) Then $ok = True
		WEnd
		DllClose($dll)
		If $ok Then
			Switch $type
			Case "INT"
				$retour = cleanNumber(GUICtrlRead($item))
				If $min<>"" And Number($retour)<$min Then
					$ok = False
				ElseIf $max<>"" And $max<Number($retour) Then
					$ok = False
				EndIf
			Case "STRING"
				$retour = GUICtrlRead($item)
				If $min<>"" And StringLen($retour)<$min Then
					$ok = False
				ElseIf $max<>"" And $max<StringLen($retour) Then
					$ok = False
				EndIf
			EndSwitch
		EndIf
	EndIf
	If $erreur = 0 And Not $ok Then $erreur = 2
	; Effacement
	GUIDelete($child)
	WinActivate($parent)
	If $erreur = 0 Then Return $retour
	SetError($erreur)
EndFunc

Func guiLigne($parent, $valeur = "", $titre = "Ligne de dgts", $itemToCatch = "MOUSE")
	Local $retour = $valeur, $erreur = 0, $vide[2] = [0,0], $ok = False, $stop = False
	Local _
		$type    = getDommageType($retour), _
		$element = getDommageElement($retour), _
		$min     = getDommageMin($retour), _
		$max     = getDommageMax($retour), _
		$fmelem  = getDommageForgemagieElement($retour), _
		$fmval   = getDommageForgemagieValeur($retour), _
		$page_wizard = 1, $pages_wizard[5][2] = [[4,""],["Type",""],["Elment",""],["Valeurs min/max",""],["Forgemagie",""]]

	#Region Positionnement de l'interface
	If $itemToCatch = "MOUSE" Then
		Local $position = MouseGetPos()
	Else
		Local $position = getControlCoords($parent, $itemToCatch)
		If @error Then
			$position = $vide
		Else
			$position[0] = $position[0] + $position[2]/2
			$position[1] = $position[1] + $position[3]/2
		EndIf
	EndIf
	#EndRegion

	#Region Cration de l'interface
	Local $child_background = $damageCalc_repertoire_images & "Interface"&"\"&"Background_ligne.bmp", $dimension[2] = [245,109]
	Local $child = GUICreate("", $dimension[0], $dimension[1], _
		cond($position[0]+$dimension[0]>@DesktopWidth,  @DesktopWidth-$dimension[0],  cond($position[0]<0, @DesktopWidth  - $dimension[0]/2, $position[0])), _
		cond($position[1]+$dimension[1]>@DesktopHeight, @DesktopHeight-$dimension[1], cond($position[1]<0, @DesktopHeight - $dimension[1]/2, $position[1])), _
		BitOR($WS_POPUP,$WS_BORDER), -1, _
		$parent _
	)
	#EndRegion

	#Region Contenu de l'interface
	GUICtrlCreatePic($child_background, 0,0, $dimension[0],$dimension[1])
	GUICtrlSetState(-1, $GUI_DISABLE)
	Local $supprimer   = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Quitter.bmp",       9,  3,  21, 21)
	Local $enregistrer = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Enregistrer.bmp", 215,  3,  21, 21)
	Local $titre_label = GUICtrlCreateLabel($titre, 35, 13, 176, 20, $SS_CENTER)
	GUICtrlSetFont($titre_label,     10,  800, Default, $DAMAGECALC_FONT)
	GUICtrlSetColor($titre_label,    0xFFFFFF)
	GUICtrlSetBkColor($titre_label,  $GUI_BKCOLOR_TRANSPARENT)
	Local $page_label = GUICtrlCreateLabel("", 20, 34, 205, 20, $SS_CENTER)
	GUICtrlSetFont($page_label,      10,  400, Default, $DAMAGECALC_FONT)
	GUICtrlSetColor($page_label,     0xFFFFFF)
	GUICtrlSetBkColor($page_label,   $GUI_BKCOLOR_TRANSPARENT)
	Local $ligne_label = GUICtrlCreateLabel("", 0, 77, 248, 18, $SS_CENTER)
	GUICtrlSetFont($ligne_label,     9.5, 400, Default, $DAMAGECALC_FONT)
	GUICtrlSetColor($ligne_label,    0xFFFFFF)
	GUICtrlSetBkColor($ligne_label,  $GUI_BKCOLOR_TRANSPARENT)
	Local $boutons_wizard[2] = [ _
		GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Gauche.bmp",  10, 46, 10, 17), _
		GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Droite.bmp", 225, 46, 10, 17)  _
	]
	Local $cancel_menu = GUICtrlCreateContextMenu(GUICtrlCreateDummy())
	Local $cancel_menu_item_annuler   = GUICtrlCreateAdvancedMenuItem("Annuler la modification", $cancel_menu)
	Local $cancel_menu_item_supprimer = GUICtrlCreateAdvancedMenuItem("Supprimer la "&StringLower($titre), $cancel_menu)
	#EndRegion

	#Region Page 1 : Type d'action
	If Not StringInStr(";inflige;vole;soigne;",";"&$type&";") Then $type = "Inflige"
	Local _
		$boutons_type_inflige_pic   = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Large.bmp",       28, 55, 60, 20), _
		$boutons_type_vole_pic      = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Large.bmp",       93, 55, 60, 20), _
		$boutons_type_soigne_pic    = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Large.bmp",      158, 55, 60, 20)
	Local _
		$boutons_type_inflige_label = GUICtrlCreateLabel("Inflige",  28, 55, 60, 20, $SS_CENTER), _
		$boutons_type_vole_label    = GUICtrlCreateLabel("Vole",     93, 55, 60, 20, $SS_CENTER), _
		$boutons_type_soigne_label  = GUICtrlCreateLabel("Soigne",  158, 55, 60, 20, $SS_CENTER)
	Local $array[7] = [6,$boutons_type_inflige_pic,$boutons_type_vole_pic,$boutons_type_soigne_pic,$boutons_type_inflige_label,$boutons_type_vole_label,$boutons_type_soigne_label]
	For $i = 1 To $array[0]
		GUICtrlSetState($array[$i],       $GUI_HIDE)
		If $i <= $array[0]/2 Then
			GUICtrlSetState($array[$i],   $GUI_DISABLE)
		Else
			GUICtrlSetFont($array[$i],    10, 400, Default, $DAMAGECALC_FONT)
			GUICtrlSetColor($array[$i],   0x28221F)
			GUICtrlSetBkColor($array[$i], $GUI_BKCOLOR_TRANSPARENT)
		EndIf
	Next
	$pages_wizard[1][1] = $array
	#EndRegion

	#Region Page 2 : Elment de l'action
	If Not StringInStr(";Neutre;Terre;Feu;Eau;Air;PA;PM;",";"&$element&";") Then $element = "Neutre"
	Local _
		$boutons_element_neutre_pic = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Neutre"&cond($type="Soigne" Or $element="Neutre", "_inactif","")&".bmp",  30, 54, 22, 20), _
		$boutons_element_terre_pic  = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Terre" &cond($type="Soigne" Or $element="Terre",  "_inactif","")&".bmp",  55, 54, 22, 20), _
		$boutons_element_feu_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Feu"   &cond($type="Soigne" Or $element="Feu",    "_inactif","")&".bmp",  80, 54, 22, 20), _
		$boutons_element_eau_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Eau"   &cond($type="Soigne" Or $element="Eau",    "_inactif","")&".bmp", 105, 54, 22, 20), _
		$boutons_element_air_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Air"   &cond($type="Soigne" Or $element="Air",    "_inactif","")&".bmp", 130, 54, 22, 20), _
		$boutons_element_pa_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"PA"    &cond($type="Soigne" Or $element="PA",     "_inactif","")&".bmp", 168, 54, 22, 20), _
		$boutons_element_pm_pic     = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"PM"    &cond($type="Soigne" Or $element="PM",     "_inactif","")&".bmp", 193, 54, 22, 20)
	Local $array[8] = [7, $boutons_element_neutre_pic, $boutons_element_terre_pic, $boutons_element_feu_pic, $boutons_element_eau_pic, $boutons_element_air_pic, $boutons_element_pa_pic, $boutons_element_pm_pic]
	For $i = 1 To $array[0]
		GUICtrlSetState($array[$i], $GUI_HIDE)
	Next
	$pages_wizard[2][1] = $array
	#EndRegion

	#Region Page 3 : Valeurs min/max
	If Not Number($min) Then $min = "0"
	If Not Number($max) Then $max = "0"
	Local _
		$boutons_valeur_min_input = GUICtrlCreateInput($min,  70, 54, 50, 20), _
		$boutons_valeur_max_input = GUICtrlCreateInput($max, 125, 54, 50, 20), _
		$boutons_valeur_min_updown = GUICtrlCreateUpdown($boutons_valeur_min_input,$UDS_ARROWKEYS), _
		$boutons_valeur_max_updown = GUICtrlCreateUpdown($boutons_valeur_max_input,$UDS_ARROWKEYS)
	Local $array[5] = [4,$boutons_valeur_min_input,$boutons_valeur_max_input,$boutons_valeur_min_updown,$boutons_valeur_max_updown]
	For $i = 1 To $array[0]
		GUICtrlSetColor($array[$i],   0xFFFFFF)
		GUICtrlSetBkColor($array[$i], 0x564F4C)
		GUICtrlSetState($array[$i],   $GUI_HIDE)
	Next
	$pages_wizard[3][1] = $array
	#EndRegion

	#Region Page 4 : Forgemagie
	If $fmval<>"50" And $fmval<>"67" And $fmval<>"85" Then $fmval = "0"
	If Not StringInStr(";Terre;Feu;Eau;Air;",";"&$fmelem&";") Then $fmelem = ""
	Local _
		$boutons_fmval_pic   = GUICtrlCreatePic($damageCalc_repertoire_images & "Interface"&"\"&"Large.bmp", 43, 55, 50, 20), _
		$boutons_fmval_label = GUICtrlCreateLabel(cond($fmval="0","Aucun",$fmval&" %"),                      43, 55, 50, 20, $SS_CENTER)
	Local _
		$boutons_fmelem_terre_pic  = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Terre" &cond($fmval="0" Or $fmelem="Terre",  "_inactif","")&".bmp", 103, 54, 22, 20), _
		$boutons_fmelem_feu_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Feu"   &cond($fmval="0" Or $fmelem="Feu",    "_inactif","")&".bmp", 128, 54, 22, 20), _
		$boutons_fmelem_eau_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Eau"   &cond($fmval="0" Or $fmelem="Eau",    "_inactif","")&".bmp", 153, 54, 22, 20), _
		$boutons_fmelem_air_pic    = GUICtrlCreatePic($damageCalc_repertoire_images&"Elments"&"\"&"Air"   &cond($fmval="0" Or $fmelem="Air",    "_inactif","")&".bmp", 178, 54, 22, 20)
	Local $array[7] = [6, $boutons_fmval_pic, $boutons_fmval_label, $boutons_fmelem_terre_pic, $boutons_fmelem_feu_pic, $boutons_fmelem_eau_pic, $boutons_fmelem_air_pic]
	GUICtrlSetState($boutons_fmval_pic,     $GUI_DISABLE)
	GUICtrlSetFont($boutons_fmval_label,    10, 400, Default, $DAMAGECALC_FONT)
	GUICtrlSetColor($boutons_fmval_label,   0x28221F)
	GUICtrlSetBkColor($boutons_fmval_label, $GUI_BKCOLOR_TRANSPARENT)
	For $i = 1 To $array[0]
		GUICtrlSetState($array[$i], $GUI_HIDE)
	Next
	$pages_wizard[4][1] = $array
	#EndRegion

	Local $liste = $pages_wizard[$page_wizard][1]
	For $i = 1 To $liste[0]
		GUICtrlSetState($liste[$i], $GUI_SHOW)
	Next
	; Traitement
	GUISetState(@SW_SHOW, $child)
	Local $dll = DllOpen("user32.dll"), $retour_previous = "UNDEFINED"
	While WinActive($child) And Not IsPressed("1B", $dll) And Not $stop
		Local $msgChild = GUIGetMsg()
		If IsPressed("21", $dll) Then
			While IsPressed("21", $dll)
				Sleep(50)
			WEnd
			$msgChild = $boutons_wizard[0]
		ElseIf IsPressed("22", $dll) Then
			While IsPressed("22", $dll)
				Sleep(50)
			WEnd
			$msgChild = $boutons_wizard[1]
		EndIf
		Switch $msgChild
		Case $enregistrer
			$stop = True
			$ok   = True
		Case $supprimer
			sousmenu($child, $supprimer, $cancel_menu)
			WinActivate($child)
		Case $cancel_menu_item_annuler
			WinActivate($parent) ; (annuler l'action en perdant le focus)
		Case $cancel_menu_item_supprimer
			$stop = True
			$ok   = False
		Case $boutons_wizard[0], $boutons_wizard[1]
			Local $liste = $pages_wizard[$page_wizard][1]
			For $i = 1 To $liste[0]
				GUICtrlSetState($liste[$i], $GUI_HIDE)
			Next
			If $msgChild=$boutons_wizard[0] Then
				$page_wizard = $page_wizard-1
				If $page_wizard < 1 Then $page_wizard = $pages_wizard[0][0]
				If $page_wizard = 4 And Not (($type = "Inflige" Or $type = "Vole") And $element = "Neutre") Then $page_wizard = 3
			ElseIf $msgChild=$boutons_wizard[1] Then
				$page_wizard = $page_wizard+1
				If $page_wizard > $pages_wizard[0][0] Then $page_wizard = 1
				If $page_wizard = 4 And Not (($type = "Inflige" Or $type = "Vole") And $element = "Neutre") Then $page_wizard = 1
			EndIf
			Local $liste = $pages_wizard[$page_wizard][1]
			For $i = 1 To $liste[0]
				GUICtrlSetState($liste[$i], $GUI_SHOW)
			Next
			If $page_wizard = 1 Then
				GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : "&$type)
			ElseIf $page_wizard = 2 Then
				GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : "&$element)
			ElseIf $page_wizard = 3 Then
				GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : de "&$min&"  "&$max)
			ElseIf $page_wizard = 4 Then
				GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : "&cond($fmelem="" Or $fmval="0","Aucune",$fmelem&"  "&$fmval&"%"))
			EndIf
		Case $boutons_type_inflige_label, $boutons_type_vole_label, $boutons_type_soigne_label
			If $msgChild = $boutons_type_inflige_label Then
				$type = "Inflige"
			ElseIf $msgChild = $boutons_type_vole_label Then
				$type = "Vole"
			ElseIf $msgChild = $boutons_type_soigne_label Then
				$type = "Soigne"
				$element = "Feu"
			EndIf
			GUICtrlSetImage($boutons_element_neutre_pic, $damageCalc_repertoire_images&"Elments"&"\"&"Neutre"&cond($type="Soigne" Or $element="Neutre", "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_element_terre_pic,  $damageCalc_repertoire_images&"Elments"&"\"&"Terre" &cond($type="Soigne" Or $element="Terre",  "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_element_feu_pic,    $damageCalc_repertoire_images&"Elments"&"\"&"Feu"   &cond($type="Soigne" Or $element="Feu",    "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_element_eau_pic,    $damageCalc_repertoire_images&"Elments"&"\"&"Eau"   &cond($type="Soigne" Or $element="Eau",    "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_element_air_pic,    $damageCalc_repertoire_images&"Elments"&"\"&"Air"   &cond($type="Soigne" Or $element="Air",    "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_element_pa_pic,     $damageCalc_repertoire_images&"Elments"&"\"&"PA"    &cond($type="Soigne" Or $element="PA",     "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_element_pm_pic,     $damageCalc_repertoire_images&"Elments"&"\"&"PM"    &cond($type="Soigne" Or $element="PM",     "_inactif","")&".bmp")
			$retour = "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max><fmelement>"&$fmelem&"</fmelement><fmvaleur>"&$fmval&"</fmvaleur>"
		Case $boutons_element_neutre_pic, $boutons_element_terre_pic, $boutons_element_feu_pic, $boutons_element_eau_pic, $boutons_element_air_pic, $boutons_element_pa_pic, $boutons_element_pm_pic
			If $type = "Inflige" Or $type = "Vole" Then
				If $msgChild = $boutons_element_neutre_pic Then
					$element = "Neutre"
				ElseIf $msgChild = $boutons_element_terre_pic Then
					$element = "Terre"
				ElseIf $msgChild = $boutons_element_feu_pic Then
					$element = "Feu"
				ElseIf $msgChild = $boutons_element_eau_pic Then
					$element = "Eau"
				ElseIf $msgChild = $boutons_element_air_pic Then
					$element = "Air"
				ElseIf $msgChild = $boutons_element_pa_pic Then
					$element = "PA"
				ElseIf $msgChild = $boutons_element_pm_pic Then
					$element = "PM"
				EndIf
				GUICtrlSetImage($boutons_element_neutre_pic, $damageCalc_repertoire_images&"Elments"&"\"&"Neutre"&cond($element="Neutre", "_inactif","")&".bmp")
				GUICtrlSetImage($boutons_element_terre_pic,  $damageCalc_repertoire_images&"Elments"&"\"&"Terre" &cond($element="Terre",  "_inactif","")&".bmp")
				GUICtrlSetImage($boutons_element_feu_pic,    $damageCalc_repertoire_images&"Elments"&"\"&"Feu"   &cond($element="Feu",    "_inactif","")&".bmp")
				GUICtrlSetImage($boutons_element_eau_pic,    $damageCalc_repertoire_images&"Elments"&"\"&"Eau"   &cond($element="Eau",    "_inactif","")&".bmp")
				GUICtrlSetImage($boutons_element_air_pic,    $damageCalc_repertoire_images&"Elments"&"\"&"Air"   &cond($element="Air",    "_inactif","")&".bmp")
				GUICtrlSetImage($boutons_element_pa_pic,     $damageCalc_repertoire_images&"Elments"&"\"&"PA"    &cond($element="PA",     "_inactif","")&".bmp")
				GUICtrlSetImage($boutons_element_pm_pic,     $damageCalc_repertoire_images&"Elments"&"\"&"PM"    &cond($element="PM",     "_inactif","")&".bmp")
				$retour = "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max><fmelement>"&$fmelem&"</fmelement><fmvaleur>"&$fmval&"</fmvaleur>"
			EndIf
		Case $boutons_fmval_label, $boutons_fmelem_terre_pic, $boutons_fmelem_feu_pic, $boutons_fmelem_eau_pic, $boutons_fmelem_air_pic
			If $msgChild = $boutons_fmval_label Then
				If $fmval = "0" Then
					$fmval = "50"
					$fmelem = ""
				ElseIf $fmval = "50" Then
					$fmval = "67"
				ElseIf $fmval = "67" Then
					$fmval = "85"
				Else
					$fmval = "0"
				EndIf
			ElseIf $msgChild = $boutons_fmelem_terre_pic Then
				$fmelem = "Terre"
			ElseIf $msgChild = $boutons_fmelem_feu_pic Then
				$fmelem = "Feu"
			ElseIf $msgChild = $boutons_fmelem_eau_pic Then
				$fmelem = "Eau"
			ElseIf $msgChild = $boutons_fmelem_air_pic Then
				$fmelem = "Air"
			EndIf
			GUICtrlSetData($boutons_fmval_label,       cond($fmval="0","Aucun",$fmval&" %"))
			GUICtrlSetImage($boutons_fmelem_terre_pic, $damageCalc_repertoire_images&"Elments"&"\"&"Terre" &cond($fmval = "0" Or $fmelem="Terre", "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_fmelem_feu_pic,   $damageCalc_repertoire_images&"Elments"&"\"&"Feu"   &cond($fmval = "0" Or $fmelem="Feu",   "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_fmelem_eau_pic,   $damageCalc_repertoire_images&"Elments"&"\"&"Eau"   &cond($fmval = "0" Or $fmelem="Eau",   "_inactif","")&".bmp")
			GUICtrlSetImage($boutons_fmelem_air_pic,   $damageCalc_repertoire_images&"Elments"&"\"&"Air"   &cond($fmval = "0" Or $fmelem="Air",   "_inactif","")&".bmp")
			$retour = "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max><fmelement>"&$fmelem&"</fmelement><fmvaleur>"&$fmval&"</fmvaleur>"
		Case Else
			If $page_wizard = 3 Then
				Local $min_input = GUICtrlRead($boutons_valeur_min_input), $max_input = GUICtrlRead($boutons_valeur_max_input)
				If ($min <> $min_input Or $max <> $max_input) Then
					GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : de "&$min&"  "&$max)
					$min = $min_input
					$max = $max_input
					$retour = "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max><fmelement>"&$fmelem&"</fmelement><fmvaleur>"&$fmval&"</fmvaleur>"
				EndIf
			EndIf
			If $page_wizard = 4 Then
				Local $min_input = GUICtrlRead($boutons_valeur_min_input), $max_input = GUICtrlRead($boutons_valeur_max_input)
				If ($min <> $min_input Or $max <> $max_input) Then
					GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : de "&$min &"  "&$max)
					$min = $min_input
					$max = $max_input
					$retour = "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max><fmelement>"&$fmelem&"</fmelement><fmvaleur>"&$fmval&"</fmvaleur>"
				EndIf
			EndIf
			If IsPressed("0D", $dll) Then
				$stop = True
				$ok   = False
			ElseIf $retour <> $retour_previous Then
				$retour_previous = $retour
				If $page_wizard = 1 Then
					GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : "&$type)
				ElseIf $page_wizard = 2 Then
					GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : "&$element)
				ElseIf $page_wizard = 3 Then
					GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : "&$min&" / "&$max)
				ElseIf $page_wizard = 4 Then
					GUICtrlSetData($page_label,$pages_wizard[$page_wizard][0]&" : "&cond($fmelem="" Or $fmval="0","Aucune",$fmelem&"  "&$fmval&"%"))
				EndIf
				GUICtrlSetData($ligne_label, ligne_arme_tostring($retour))
			EndIf
		EndSwitch
	WEnd
	DllClose($dll)
	$focus = (WinActive($parent) <> 0)
	If $stop = False Then ; Annuler
		$erreur = 2
	ElseIf $ok = False Then ; Supprimer
		$erreur = 1
	EndIf
	; Effacement
	GUIDelete($child)
	If $focus Then WinActivate($parent)
	If $erreur = 0 Then Return $retour
	SetError($erreur)
EndFunc

Func appliquer_resistances($effet, $resistances, $constitution)
	Local _
		$type    = getDommageType($effet), _
		$element = getDommageElement($effet), _
		$min     = Number(getDommageMin($effet)), _
		$max     = Number(getDommageMax($effet))
	If StringInStr(";Neutre;Terre;Feu;Eau;Air;Aucun;",";"&$element&";") Then
		Switch $type
		Case "Inflige", "Vole"
			Local $val = 0
			Switch $element
			Case "Neutre"
				$val = Number(getDommageBalise($resistances,"neutre"))
			Case "Terre"
				$val = Number(getDommageBalise($resistances,"for"))
			Case "Feu"
				$val = Number(getDommageBalise($resistances,"int"))
			Case "Eau"
				$val = Number(getDommageBalise($resistances,"cha"))
			Case "Air"
				$val = Number(getDommageBalise($resistances,"agi"))
			EndSwitch
			Return "<type>"&$type&"</type><element>"&$element&"</element><min>"&Max(0,Floor($min*(100-$val)/100))&"</min><max>"&Max(0,Floor($max*(100-$val)/100))&"</max>"
		Case "Soigne"
			Return $effet
		Case "Rduit"
			Return $effet
		Case "Renvoie"
			Return $effet
		Case "Dsenvoute"
			Return $effet
		Case "Pousse"
			Return $effet
		EndSwitch
	ElseIf StringInStr(";PA;PM;",";"&$element&";") Then
		$val = calcul_de_retrait($min, $max, getDommageBalise($constitution,"retrait_"&StringLower($element)), _
			getDommageBalise($resistances,"esquive_"&StringLower($element)), getDommageBalise($resistances,"nombre_"&StringLower($element)))
		Return "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max><moy>"&$val&"</moy>"
	EndIf
	Return $effet
EndFunc

Func check_ligne_arme($xml)
	; Rcupration
	Local _
		$type    = getDommageType($xml), _
		$element = getDommageElement($xml), _
		$min     = Number(getDommageMin($xml)), _
		$max     = Number(getDommageMax($xml))
	If $min<=$max And $max>0 Then
		; Vrification
		Switch $type
		Case "Inflige"
			Return StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Or StringInStr(";PA;PM;",";"&$element&";")
		Case "Vole"
			Return StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Or StringInStr(";PA;PM;",";"&$element&";")
		Case "Soigne"
			Return True
		EndSwitch
	EndIf
	Return False
EndFunc

Func ligne_arme_tostring($xml)
	Local $retour_vide = "N'a aucun effet"
	; Rcupration
	Local _
		$type    = getDommageType($xml), _
		$element = getDommageElement($xml), _
		$min     = Number(getDommageMin($xml)), _
		$max     = Number(getDommageMax($xml)), _
		$fmelem  = getDommageForgemagieElement($xml), _
		$fmval   = Number(getDommageForgemagieValeur($xml))
	Local _
		$minFM   = Max(cond($min>0,1,0),Floor(($min-1)*$fmval/100)+1), _
		$maxFM   = Max(cond($max>0,1,0),Floor(($min-1)*$fmval/100)+Floor(($max-$min+1)*$fmval/100))

	If $min<=$max And $max>0 Then
		; Vrification
		Switch $type
		Case "Inflige"
			If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
				If $min = $max Then
					Return "Dommages : " & cond($element="Neutre" And StringInStr(";Terre;Feu;Eau;Air;",";"&$fmelem&";") And $fmval>0, _
						$minFM&" ("&$fmelem&" "&$fmval&"%)", _
						$min&" ("&$element&")")
				Else
					Return "Dommages : " & cond($element="Neutre" And StringInStr(";Terre;Feu;Eau;Air;",";"&$fmelem&";") And $fmval>0, _
						$minFM&"  "&$maxFM&" ("&$fmelem&" "&$fmval&"%)", _
						$min&"  "&$max&" ("&$element&")")
				EndIf
			ElseIf StringInStr(";PA;PM;",";"&$element&";") Then
				If $min = $max Then Return StringUpper($element)&" perdus  la cible : "&$min
				Return StringUpper($element)&" perdus  la cible : "&$min&"  "&$max
			EndIf
		Case "Vole"
			If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
				If $min = $max Then
					Return "Vole " & cond($element="Neutre" And StringInStr(";Terre;Feu;Eau;Air;",";"&$fmelem&";") And $fmval>0, _
						$minFM&" PDV ("&$fmelem&" "&$fmval&"%)", _
						$min&" PDV ("&$element&")")
				Else
					Return "Vole " & cond($element="Neutre" And StringInStr(";Terre;Feu;Eau;Air;",";"&$fmelem&";") And $fmval>0, _
						$minFM&"  "&$maxFM&" PDV ("&$fmelem&" "&$fmval&"%)", _
						$min&"  "&$max&" PDV ("&$element&")")
				EndIf
			ElseIf StringInStr(";PA;PM;",";"&$element&";") Then
				If $min = $max Then Return "Vole "&$min&" "&StringUpper($element)&"  la cible"
				Return "Vole "&$min&"  "&$max&" "&StringUpper($element)&"  la cible"
			EndIf
		Case "Soigne"
			If $min = $max Then Return "PDV rendus : "&$min
			Return "PDV rendus : "&$min&"  "&$max
		EndSwitch
	EndIf
	SetError(1)
	Return $retour_vide
EndFunc

Func check_ligne_sort($xml)
	; Rcupration
	Local _
		$type    = getDommageType($xml), _
		$element = getDommageElement($xml), _
		$min     = Number(getDommageMin($xml)), _
		$max     = Number(getDommageMax($xml))
	; Vrification
	Switch $type
	Case "Inflige", "Inflige%", "InfligeP", "Vole", "Vole+"
		Return ($min<=$max And $max>0) And StringInStr(";Neutre;Terre;Feu;Eau;Air;PA;PM;PO;",";"&$element&";")
	Case "Soigne", "Rduit", "Pousse"
		Return ($min<=$max And $max>0)
	Case "Dsenvoute"
		Return True
	EndSwitch
	Return False
EndFunc

Func effet_tostring($xml)
	Local $retour = "", $retour_vide = "N'a aucun effet"
	; Rcupration
	Local _
		$type    = getDommageType($xml), _
		$element = getDommageElement($xml), _
		$min     = Number(getDommageMin($xml)), _
		$max     = Number(getDommageMax($xml)), _
		$moy     = Number(getDommageMoy($xml))
	; Vrification
	Switch $type
	Case "Inflige"
		If $min<=$max And $max>0 Then
			If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
				If $min = $max Then Return "Inflige "&$min&" ("&$element&")"
				Return "Inflige de "&$min&"  "&$max&" ("&$element&")"
			ElseIf StringInStr(";PA;PM;",";"&$element&";") Then
				Return "Retire "&Round($moy,2)&" "&StringUpper($element)&" en moyenne"
			ElseIf $element="PO" Then
				If $min = $max Then Return "Retire "&$min&" PO"
				Return "Retire entre "&$min&" et "&$max&" PO"
			EndIf
		EndIf
	Case "Vole"
		If $min<=$max And $max>0 Then
			If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
				If $min = $max Then Return "Vole "&$min&" ("&$element&")"
				Return "Vole de "&$min&"  "&$max&" ("&$element&")"
			ElseIf StringInStr(";PA;PM;",";"&$element&";") Then
				Return "Vole "&Round($moy,2)&" "&StringUpper($element)&" en moyenne"
			ElseIf $element="PO" Then
				If $min = $max Then Return "Vole "&$min&" PO"
				Return "Vole entre "&$min&" et "&$max&" PO"
			EndIf
		EndIf
	Case "Soigne"
		If $min<=$max And $max>0 Then
			If $min = $max Then Return "Soigne "&$min&" PDV"
			Return "Soigne de "&$min&"  "&$max&" PDV"
		EndIf
	Case "Rduit"
		If $min<=$max And $max>0 Then
			If $min = $max Then Return "Rduit de "&$min&" ("&$element&")"
			Return "Rduit de "&$min&"  "&$max&" ("&$element&")"
		EndIf
	Case "Renvoie"
		If $min<=$max And $max>0 Then
			If $min = $max Then Return "Renvoie "&$min&" de dgts"
			Return "Rduit entre "&$min&" et "&$max&" de dgts"
		EndIf
	Case "Dsenvoute"
		Return "Dsenvoute la cible"
	Case "Pousse"
		If $min<=$max And $max>0 Then
			If $min = $max Then Return "Pousse de "&$min&" case"&cond($min>1,"s","")&" [non calcul]"
			Return "Pousse de "&$min&"  "&$max&" case"&cond($max>1,"s","")&" [non calcul]"
		EndIf
	EndSwitch
	SetError(1)
	Return $retour_vide
EndFunc

Func displayTip($titre="",$texte="")
	TrayTip($titre,$texte,30,16)
EndFunc

#Region Modelisation
Func getDommageBalise($dommage,$balise)
	Local $retour = StringBetween($dommage,"<"&$balise&">","</"&$balise&">")
	If @error Then Return ""
	Return $retour[0]
EndFunc
Func getDommageType($dommage)
	Local $retour = getDommageBalise($dommage,"type")
	SetError(@error)
	Return $retour
EndFunc
Func getDommageElement($dommage)
	Local $retour = getDommageBalise($dommage,"element")
	SetError(@error)
	Return $retour
EndFunc
Func getDommageMin($dommage)
	Local $retour = getDommageBalise($dommage,"min")
	SetError(@error)
	Return $retour
EndFunc
Func getDommageMax($dommage)
	Local $retour = getDommageBalise($dommage,"max")
	SetError(@error)
	Return $retour
EndFunc
Func getDommageMoy($dommage)
	Local $retour = getDommageBalise($dommage,"moy")
	SetError(@error)
	Return $retour
EndFunc
Func getDommageForgemagieElement($dommage)
	Local $retour = getDommageBalise($dommage,"fmelement")
	SetError(@error)
	Return $retour
EndFunc
Func getDommageForgemagieValeur($dommage)
	Local $retour = getDommageBalise($dommage,"fmvaleur")
	SetError(@error)
	Return $retour
EndFunc
Func convertToXML($perso_classe, $perso_sexe, $perso_nom, $perso_niveau, $perso_arme, $perso_sort, $perso_sortXML, $carac_vit, $carac_sag, $carac_for, $carac_int, $carac_cha, $carac_agi, $carac_pa, $carac_pm, $retrait_pa, $esquive_pa, $retrait_pm, $esquive_pm, $carac_cc, $carac_ec, $carac_soins, $carac_tacle, $carac_fuite, $dom_fixe, $dom_pour, $dom_neutre, $dom_for, $dom_int, $dom_cha, $dom_agi, $dom_pouss, $renvoi, $piege_fixe, $piege_pour, $resE_neutre_fixe, $resE_neutre_pour, $resE_for_fixe, $resE_for_pour, $resE_int_fixe, $resE_int_pour, $resE_cha_fixe, $resE_cha_pour, $resE_agi_fixe, $resE_agi_pour, $resE_cri_fixe, $resE_pou_fixe, $resP_neutre_fixe, $resP_neutre_pour, $resP_for_fixe, $resP_for_pour, $resP_int_fixe, $resP_int_pour, $resP_cha_fixe, $resP_cha_pour, $resP_agi_fixe, $resP_agi_pour, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes)
	Local $retour = "" & _
		"<perso_classe>"     & $perso_classe     & "</perso_classe>"     & "<perso_sexe>"       & $perso_sexe       & "</perso_sexe>"       & _
		"<perso_nom>"        & $perso_nom        & "</perso_nom>"        & "<perso_niveau>"     & $perso_niveau     & "</perso_niveau>"     & _
		"<carac_vit>"        & $carac_vit        & "</carac_vit>"        & "<carac_sag>"        & $carac_sag        & "</carac_sag>"        & _
		"<carac_for>"        & $carac_for        & "</carac_for>"        & "<carac_int>"        & $carac_int        & "</carac_int>"        & _
		"<carac_cha>"        & $carac_cha        & "</carac_cha>"        & "<carac_agi>"        & $carac_agi        & "</carac_agi>"        & _
		"<carac_pa>"         & $carac_pa         & "</carac_pa>"         & "<carac_pm>"         & $carac_pm         & "</carac_pm>"         & _
		"<retrait_pa>"       & $retrait_pa       & "</retrait_pa>"       & "<esquive_pa>"       & $esquive_pa       & "</esquive_pa>"       & _
		"<retrait_pm>"       & $retrait_pm       & "</retrait_pm>"       & "<esquive_pm>"       & $esquive_pm       & "</esquive_pm>"       & _
		"<carac_cc>"         & $carac_cc         & "</carac_cc>"         & "<carac_ec>"         & $carac_ec         & "</carac_ec>"         & _
		"<carac_soins>"      & $carac_soins      & "</carac_soins>"                                                                         & _
		"<carac_tacle>"      & $carac_tacle      & "</carac_tacle>"      & "<carac_fuite>"      & $carac_fuite      & "</carac_fuite>"      & _
		"<dom_fixe>"         & $dom_fixe         & "</dom_fixe>"         & "<dom_pour>"         & $dom_pour         & "</dom_pour>"         & _
		"<dom_neutre>"       & $dom_neutre       & "</dom_neutre>"                                                                          & _
		"<dom_for>"          & $dom_for          & "</dom_for>"          & "<dom_int>"          & $dom_int          & "</dom_int>"          & _
		"<dom_cha>"          & $dom_cha          & "</dom_cha>"          & "<dom_agi>"          & $dom_agi          & "</dom_agi>"          & _
		"<dom_pouss>"        & $dom_pouss        & "</dom_pouss>"        & "<renvoi>"           & $renvoi           & "</renvoi>"           & _
		"<piege_fixe>"       & $piege_fixe       & "</piege_fixe>"       & "<piege_pour>"       & $piege_pour       & "</piege_pour>"       & _
		"<resE_neutre_fixe>" & $resE_neutre_fixe & "</resE_neutre_fixe>" & "<resE_neutre_pour>" & $resE_neutre_pour & "</resE_neutre_pour>" & _
		"<resE_for_fixe>"    & $resE_for_fixe    & "</resE_for_fixe>"    & "<resE_for_pour>"    & $resE_for_pour    & "</resE_for_pour>"    & _
		"<resE_int_fixe>"    & $resE_int_fixe    & "</resE_int_fixe>"    & "<resE_int_pour>"    & $resE_int_pour    & "</resE_int_pour>"    & _
		"<resE_cha_fixe>"    & $resE_cha_fixe    & "</resE_cha_fixe>"    & "<resE_cha_pour>"    & $resE_cha_pour    & "</resE_cha_pour>"    & _
		"<resE_agi_fixe>"    & $resE_agi_fixe    & "</resE_agi_fixe>"    & "<resE_agi_pour>"    & $resE_agi_pour    & "</resE_agi_pour>"    & _
		"<resE_cri_fixe>"    & $resE_cri_fixe    & "</resE_cri_fixe>"    & "<resE_pou_fixe>"    & $resE_pou_fixe    & "</resE_pou_fixe>"    & _
		"<resP_neutre_fixe>" & $resP_neutre_fixe & "</resP_neutre_fixe>" & "<resP_neutre_pour>" & $resP_neutre_pour & "</resP_neutre_pour>" & _
		"<resP_for_fixe>"    & $resP_for_fixe    & "</resP_for_fixe>"    & "<resP_for_pour>"    & $resP_for_pour    & "</resP_for_pour>"    & _
		"<resP_int_fixe>"    & $resP_int_fixe    & "</resP_int_fixe>"    & "<resP_int_pour>"    & $resP_int_pour    & "</resP_int_pour>"    & _
		"<resP_cha_fixe>"    & $resP_cha_fixe    & "</resP_cha_fixe>"    & "<resP_cha_pour>"    & $resP_cha_pour    & "</resP_cha_pour>"    & _
		"<resP_agi_fixe>"    & $resP_agi_fixe    & "</resP_agi_fixe>"    & "<resP_agi_pour>"    & $resP_agi_pour    & "</resP_agi_pour>"    & _
	""
	If $perso_arme = "Sort" And $perso_sort <> "" Then
		$retour = $retour & convertSortToXML($perso_sortXML)
	ElseIf $perso_arme <> "Sort" Then
		$retour = $retour & convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes)
	EndIf
	Return $retour
EndFunc
Func convertArmeToXML($perso_arme, $perso_sort, $arme_pa, $arme_cc, $arme_tcc, $arme_tec, $arme_lignes, $lvl=0)
	Local $retour = "<perso_arme>" & $perso_arme & "</perso_arme>" & "<arme_pa>" & $arme_pa & "</arme_pa>" & "<arme_cc>" & $arme_cc & "</arme_cc>" & "<arme_tcc>" & $arme_tcc & "</arme_tcc>" & "<arme_tec>" & $arme_tec & "</arme_tec>"
	Local $retour_arme = "<arme_nombre>"&$arme_lignes[0]&"</arme_nombre>"
	$retour_arme = $retour_arme & "<arme_lignes>"
	For $j = 1 To 6
		$retour_arme = $retour_arme & "<arme_ligne_"&$j&">"&$arme_lignes[$j]&"</arme_ligne_"&$j&">"
	Next
	$retour_arme = $retour_arme & "</arme_lignes>"
	$retour = $retour & $retour_arme
	Return $retour
EndFunc
Func convertSortToXML($sort)
	If Not IsObj($sort) Then Return ""
	Local $retour = "", $niveaux = $sort.SelectNodes("niveau"), $lvl_max = 0
	For $niveau In $niveaux
		$lvl_max = Max($lvl_max,Number($niveau.GetAttribute("nom")))
		$retour = $retour & "<niveau_"&$niveau.GetAttribute("nom")&">"
		$retour = $retour & _
			"<pa>"    & $niveau.GetAttribute("pa")    & "</pa>"    & _
			"<tcc>"   & $niveau.GetAttribute("cc")    & "</tcc>"   & _
			"<tec>"   & $niveau.GetAttribute("ec")    & "</tec>"   & _
			"<pomin>" & $niveau.GetAttribute("pomin") & "</pomin>" & _
			"<pomax>" & $niveau.GetAttribute("pomax") & "</pomax>" & _
			"<zone>"  & $niveau.GetAttribute("zone")  & "</zone>"  & _
		""
		; Dgats normaux
		$normaux = $niveau.SelectNodes("normal")
		$i = 0
		$retour = $retour & "<normal_lignes>"
		For $normal In $normaux
			$i = $i+1
			$ligne  = _
				"<type>"    & $normal.GetAttribute("type")    & "</type>"    & _
				"<element>" & $normal.GetAttribute("element") & "</element>" & _
				"<min>"     & $normal.GetAttribute("min")     & "</min>"     & _
				"<max>"     & $normal.GetAttribute("max")     & "</max>"     & _
				"<delai>"   & $normal.GetAttribute("delai")   & "</delai>"   & _
				"<target>"  & $normal.GetAttribute("target")  & "</target>"  & _
				"<param>"   & $normal.GetAttribute("param")   & "</param>"   & _
				"<boost>"   & $normal.GetAttribute("boost")   & "</boost>"   & _
				"<coef>"    & $normal.GetAttribute("coef")    & "</coef>"    & _
			""
			$retour = $retour & "<normal_ligne_"&$i&">"&$ligne&"</normal_ligne_"&$i&">"
		Next
		$retour = $retour & "</normal_lignes>"
		; Dgats critiques
		$critiques = $niveau.SelectNodes("critique")
		$i = 0
		$retour = $retour & "<critique_lignes>"
		For $critique In $critiques
			$i = $i+1
			$ligne  = _
				"<type>"    & $critique.GetAttribute("type")    & "</type>"    & _
				"<element>" & $critique.GetAttribute("element") & "</element>" & _
				"<min>"     & $critique.GetAttribute("min")     & "</min>"     & _
				"<max>"     & $critique.GetAttribute("max")     & "</max>"     & _
				"<delai>"   & $critique.GetAttribute("delai")   & "</delai>"   & _
				"<target>"  & $critique.GetAttribute("target")  & "</target>"  & _
				"<param>"   & $critique.GetAttribute("param")   & "</param>"   & _
				"<boost>"   & $critique.GetAttribute("boost")   & "</boost>"   & _
				"<coef>"    & $critique.GetAttribute("coef")    & "</coef>"    & _
			""
			$retour = $retour & "<critique_ligne_"&$i&">"&$ligne&"</critique_ligne_"&$i&">"
		Next
		$retour = $retour & "</critique_lignes>"
		$retour = $retour & "</niveau_"&$niveau.GetAttribute("nom")&">"
	Next
	Return "<perso_arme>Sort</perso_arme><perso_sort><nom>" & $sort.GetAttribute("nom") & "</nom>" & "<niveau_max>" & $lvl_max & "</niveau_max>" & $retour & "</perso_sort>"
EndFunc
#EndRegion

#Region Calcul de dgts
	#Region Fonctions mathmatiques
	Func cleanNumber($valeur)
		Local $retour = ""
		For $i = StringLen($valeur) To 1 Step -1
			Local $char = StringLeft(StringTrimLeft($valeur,$i-1),1)
			If $char = "-" Or StringIsDigit($char) Then $retour = $char&$retour
		Next
		Return Number($retour)
	EndFunc
	#EndRegion
	#Region Listing des sorts de classe
	Func listing_XML($fichier, $classeToGet="", $sortToGet="", $niveauToGet="")
		Local $liste[1][2] = [[0,""]], $xml_present = True, $XML = ObjCreate("Microsoft.XMLDOM")
		If Not (IsObj($XML) And FileExists($fichier)) Then $xml_present = False
		If $xml_present Then
			$XML.Load($fichier)
			Local $classes = $XML.SelectNodes("/donnees/classe")
			For $classe In $classes
				If $classeToGet = "" Then
					$liste[0][0] = $liste[0][0] + 1
					ReDim $liste[$liste[0][0]+1][2]
					$liste[$liste[0][0]][0] = $classe.GetAttribute("nom")
					$liste[$liste[0][0]][1] = $classe
				ElseIf $classeToGet = $classe.GetAttribute("nom") Then
					Local $sorts = $classe.SelectNodes("sort")
					For $sort In $sorts
						If $sortToGet = "" Then
							$liste[0][0] = $liste[0][0] + 1
							ReDim $liste[$liste[0][0]+1][2]
							$liste[$liste[0][0]][0] = $sort.GetAttribute("nom")
							$liste[$liste[0][0]][1] = $sort
						ElseIf $sortToGet = $sort.GetAttribute("nom") Then
							Local $niveaux = $sort.SelectNodes("niveau")
							For $niveau In $niveaux
								If $niveauToGet = "" Then
									$liste[0][0] = $liste[0][0] + 1
									ReDim $liste[$liste[0][0]+1][2]
									$liste[$liste[0][0]][0] = $niveau.GetAttribute("nom")
									$liste[$liste[0][0]][1] = $niveau
								ElseIf $niveauToGet = $niveau.GetAttribute("nom") Then
									;
								EndIf
							Next
						EndIf
					Next
				EndIf
			Next
		EndIf
		Return $liste
	EndFunc
	#EndRegion
	#Region Calcul de dgts effectifs
	Func arme_calcul_de_degats($constitution,$maitrise=0,$index=1,$critique=False)
		Local $retour_vide = ""
		Local $ligne       = getDommageBalise(getDommageBalise($constitution,"arme_lignes"),"arme_ligne_"&$index)
		Local $bonus_cc    = cond($critique And Not StringInStr(";PA;PM;",";"&getDommageElement($ligne)&";"),Number(getDommageBalise($constitution,"arme_cc")),0)
		If Not @error Then
			Local _
				$type    = getDommageType($ligne), _
				$element = getDommageElement($ligne), _
				$min     = Number(getDommageMin($ligne)), _
				$max     = Number(getDommageMax($ligne)), _
				$fmelem  = getDommageForgemagieElement($ligne), _
				$fmval   = Number(getDommageForgemagieValeur($ligne))
			Local $moy = Floor(($min+$max)/2)
			If $min<=$max And $max>0 Then
				Local $minOriginal = $min, $maxOriginal = $max, $taux_maitrise = cond($maitrise=0,100,105+$maitrise*5)/100
				If $element="Neutre" And StringInStr(";Terre;Feu;Eau;Air;",";"&$fmelem&";") And $fmval>0 Then
					$element = $fmelem
				Else
					$fmelem = "Aucun"
					$fmval  = 100
				EndIf
				If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
					$min = $bonus_cc + Max(cond($minOriginal>0,1,0),Floor((Floor(($minOriginal-1)*$fmval/100)+1)*$taux_maitrise))
					$max = $bonus_cc + Max(cond($maxOriginal>0,1,0),Floor((Floor(($minOriginal-1)*$fmval/100))*$taux_maitrise)+Floor((Floor(($maxOriginal-$minOriginal+1)*$fmval/100))*$taux_maitrise))
				EndIf
				; Vrification
				Switch $type
				Case "Inflige","Vole"
					If StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
						Switch $element
						Case "Neutre","Terre"
							Local $element_racine = "for"
						Case "Feu"
							Local $element_racine = "int"
						Case "Eau"
							Local $element_racine = "cha"
						Case "Air"
							Local $element_racine = "agi"
						EndSwitch
						$min = cond($min>0,Floor($min*(100+getDommageBalise($constitution,"carac_"&$element_racine)+getDommageBalise($constitution,"dom_pour"))/100)+getDommageBalise($constitution,"dom_"&$element_racine)+getDommageBalise($constitution,"dom_fixe"),0)
						$max = cond($max>0,Floor($max*(100+getDommageBalise($constitution,"carac_"&$element_racine)+getDommageBalise($constitution,"dom_pour"))/100)+getDommageBalise($constitution,"dom_"&$element_racine)+getDommageBalise($constitution,"dom_fixe"),0)
						Return "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max>"
					ElseIf StringInStr(";PA;PM;",";"&$element&";") Then
						Return "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max>"
					EndIf
				Case "Soigne"
					$min = cond($minOriginal>0,Floor($minOriginal*(100+getDommageBalise($constitution,"carac_int"))/100)+getDommageBalise($constitution,"carac_soins"),0)
					$max = cond($maxOriginal>0,Floor($maxOriginal*(100+getDommageBalise($constitution,"carac_int"))/100)+getDommageBalise($constitution,"carac_soins"),0)
					Return "<type>"&$type&"</type><element>Feu</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndSwitch
			EndIf
		EndIf
		SetError(1)
		Return $retour_vide
	EndFunc
	Func sort_calcul_de_degats($constitution,$lvl=1,$index=1,$critique=False)
		Local $retour_vide = ""
		Local $ligne       = getDommageBalise(getDommageBalise(getDommageBalise($constitution,"perso_sort"),"niveau_"&$lvl),cond($critique,"critique","normal")&"_ligne_"&$index)
		If Not @error Then
			Local _
				$type    = getDommageType($ligne), _
				$element = getDommageElement($ligne), _
				$min     = Number(getDommageMin($ligne)), _
				$max     = Number(getDommageMax($ligne))
			Local $moy = Floor(($min+$max)/2)
			; Vrification
			Switch $type
			Case "Inflige","Vole"
				If $min<=$max And $max>0 And StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
					Switch $element
					Case "Neutre","Terre"
						Local $element_racine = "for"
					Case "Feu"
						Local $element_racine = "int"
					Case "Eau"
						Local $element_racine = "cha"
					Case "Air"
						Local $element_racine = "agi"
					EndSwitch
					$min = cond($min>0,Floor($min*(100+getDommageBalise($constitution,"carac_"&$element_racine)+getDommageBalise($constitution,"dom_pour"))/100)+getDommageBalise($constitution,"dom_"&$element_racine)+getDommageBalise($constitution,"dom_fixe"),0)
					$max = cond($max>0,Floor($max*(100+getDommageBalise($constitution,"carac_"&$element_racine)+getDommageBalise($constitution,"dom_pour"))/100)+getDommageBalise($constitution,"dom_"&$element_racine)+getDommageBalise($constitution,"dom_fixe"),0)
					Return "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max>"
				ElseIf $min<=$max And $max>0 And StringInStr(";PO;PA;PM;",";"&$element&";") Then
					Return "<type>"&$type&"</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndIf
			Case "Inflige%"
				If $min<=$max And $max>0 And StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
					$min = cond($min>0,Floor($min*(Number(getDommageBalise($constitution,"carac_vit"))/100)),0)
					$max = cond($max>0,Floor($max*(Number(getDommageBalise($constitution,"carac_vit"))/100)),0)
					Return "<type>Inflige</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndIf
			Case "Vole+"
				If $min<=$max And $max>0 And StringInStr(";Neutre;Terre;Feu;Eau;Air;",";"&$element&";") Then
					Return "<type>Vole</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndIf
			Case "Soigne"
				If $min<=$max And $max>0 Then
					$min = cond($min>0,Floor($min*(100+getDommageBalise($constitution,"carac_int")+getDommageBalise($constitution,"dom_pour"))/100)+getDommageBalise($constitution,"carac_soins"),0)
					$max = cond($max>0,Floor($max*(100+getDommageBalise($constitution,"carac_int")+getDommageBalise($constitution,"dom_pour"))/100)+getDommageBalise($constitution,"carac_soins"),0)
					Return "<type>Soigne</type><element>Feu</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndIf
			Case "Soigne+"
				If $min<=$max And $max>0 Then
					$min = cond($min>0,$min+getDommageBalise($constitution,"carac_soins"),0)
					$max = cond($max>0,$max+getDommageBalise($constitution,"carac_soins"),0)
					Return "<type>Soigne</type><element>Feu</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndIf
			Case "Rduit"
				If $min<=$max And $max>0 Then
					Switch $element
					Case "Neutre","Terre"
						Local $element_racine = "for"
					Case "Feu"
						Local $element_racine = "int"
					Case "Eau"
						Local $element_racine = "cha"
					Case "Air"
						Local $element_racine = "agi"
					EndSwitch
					Local $coef = (100+Max(Number(getDommageBalise($constitution,"carac_"&$element_racine)),Number(getDommageBalise($constitution,"carac_int"))/2+Number(getDommageBalise($constitution,"carac_"&$element_racine))/2))/100
					$min = cond($min>0,Floor($min*$coef),0)
					$max = cond($min>0,Floor($max*$coef),0)
					Return "<type>Rduit</type><element>"&$element&"</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndIf
			Case "Pousse"
				If $min<=$max And $max>0 Then
					Return "<type>Pousse</type><element>Aucun</element><min>"&$min&"</min><max>"&$max&"</max>"
				EndIf
			Case "Dsenvoute"
				Return "<type>Dsenvoute</type><element></element><min></min><max></max>"
;~ 			Case "Subit","Donne","Perd","Subit%","InfligeP","Renvoie"
;~ 				Return ""
			Case "Aucun"
				Return "<type></type><element></element><min></min><max></max>"
			EndSwitch
		EndIf
		SetError(1)
		Return $retour_vide
	EndFunc
	Func getCoefFromType($type)
		Switch $type
		Case "Inflige","InfligeP","Inflige%"
			Return 1
		Case "Vole","VoleP","Vole+"
			Return 1.5
		Case "Soigne","Soigne+"
			Return -1
		EndSwitch
		Return 0
	EndFunc
	Func calcul_de_ppr($arme)
		Local _
			$nom = getDommageBalise($arme,"perso_arme"), _
			$lignes = getDommageBalise($arme,"arme_lignes"), _
			$pa = Number(getDommageBalise($arme,"arme_pa")), _
			$cc = Number(getDommageBalise($arme,"arme_cc")), _
			$tcc = Number(getDommageBalise($arme,"arme_tcc")), _
			$tec = Number(getDommageBalise($arme,"arme_tec")), _
			$nb = Number(getDommageBalise($arme,"arme_nombre"))
		Local $coef_arme = _
			cond($nom="Bton", 1.3, _
			cond($nom="Marteau", 1.25, _
			cond($nom="Baguette", 1.1, _
			cond($nom="Arc", 1.1, _
			cond($nom="Epe", 1, _
			cond($nom="Dagues", 1, _
			cond($nom="Hache", 1, _
			cond($nom="Pelle", 1, 0.75))))))))
		Local $DPAscore = 0, $DPAr = 0, $DPAbrut = 0, $DPAvdv = 0, $SPAr = 0, $elements[6] = [0,0,0,0,0,0], $pa_mode = False
		If $pa > 0 Then
			For $i = 1 To $nb
				Local $ligne = getDommageBalise($lignes,"arme_ligne_"&$i)
				If getDommageType($ligne) = "Inflige" Then
					Local $ok = True
					Switch getDommageElement($ligne)
					Case "Neutre"
						$elements[1] = $elements[1] + 1
					Case "Terre"
						$elements[2] = $elements[2] + 1
					Case "Feu"
						$elements[3] = $elements[3] + 1
					Case "Eau"
						$elements[4] = $elements[4] + 1
					Case "Air"
						$elements[5] = $elements[5] + 1
					Case "PA"
						$ok = False
						$pa_mode = True
					Case Else
						$ok = False
					EndSwitch
					If $ok Then
						$elements[0] = $elements[0] + 1
						$DPAbrut = $DPAbrut + (getDommageMin($ligne)+getDommageMax($ligne)+$cc)/(2*$pa)
					EndIf
				ElseIf getDommageType($ligne) = "Vole" Then
					Local $ok = True
					Switch getDommageElement($ligne)
					Case "Neutre"
						$elements[1] = $elements[1] + 1
					Case "Terre"
						$elements[2] = $elements[2] + 1
					Case "Feu"
						$elements[3] = $elements[3] + 1
					Case "Eau"
						$elements[4] = $elements[4] + 1
					Case "Air"
						$elements[5] = $elements[5] + 1
					Case Else
						$ok = False
					EndSwitch
					If $ok Then
						$elements[0] = $elements[0] + 1
						$DPAvdv = $DPAvdv + (getDommageMin($ligne)+getDommageMax($ligne)+$cc)/(2*$pa)
					EndIf
				ElseIf getDommageType($ligne) = "Soigne" Then
					$SPAr = $SPAr + (getDommageMin($ligne)+getDommageMax($ligne)+$cc)/(2*$pa)
				EndIf
			Next
			$DPAr = $DPAbrut + $DPAvdv * 1.2
			; Calcul du coef d'lement
			Local $coef = 0
			If $elements[0] > 0 Then
				Local $val = Max(Max(Max(Max($elements[5],$elements[4]),$elements[3]),$elements[2]),$elements[1])/$elements[0], $valNT = ($elements[1]+$elements[2])/$elements[0]
				If $val = 1 Then
					$coef = 1.4
				ElseIf $val > 0.66 Then
					$coef = 1.3
				ElseIf $val >= 0.5 Then
					$coef = 1
				ElseIf $valNT > 0.66 Then
					$coef = 1.2
				ElseIf $valNT >= 0.5 Then
					$coef = 1.1
				Else
					$coef = 1
				EndIf
				$DPAr = $coef * $DPAr
				; Calcul du coef de soins
				Local $coef = 1, $val = $elements[3]/$elements[0]
				Select
				Case $val = 1
					$coef = 8
				Case $val >= 0.66
					$coef = 6
				Case $val >= 0.5
					$coef = 4
				Case $val >= 0.33
					$coef = 2
				EndSelect
				$SPAr = $SPAr * $coef
				; Calcul du DPAscore initial
				$DPAscore = 50 * ($DPAr - $SPAr)
				; Bonus/Malus  appliquer
				$DPAscore = $DPAscore + _
					cond($tcc<=30, 30, _
					cond($tcc<=50, 20, _
					cond($tcc<=60, 5, 0)))
				$DPAscore = $DPAscore + _
					cond($pa=1, 50, _
					cond($pa=2, 40, _
					cond($pa=3, 30, _
					cond($pa=4, 20, _
					cond($pa>5, -30, 0)))))
				$DPAscore = $DPAscore + _
					cond($elements[0]=1, 25, _
					cond($elements[0]=2, 0, _
					cond($elements[0]=3, 25, 35)))
				$DPAscore = $DPAscore + _
					cond($tec=2, -500, _
					cond($tec<25, -100, _
					cond($tec<45, -50, _
					cond($tec<60, 0, _
					cond($tec<100, 20, 50)))))
				$DPAscore = $DPAscore + _
					cond(Not $pa_mode, 0, _
						cond($coef_arme = 1.25, 20, _
						cond($coef_arme = 1.3, 10, 0)) _
						+ _
						cond($pa=2,50, _
						cond($pa=3,40, _
						cond($pa=4,30, _
						cond($pa=5,20, _
						cond($pa>6,10, 0))))) _
					)
				Local $retour = Ceiling($DPAscore*$coef_arme)
				Return $retour
			EndIf
		EndIf
		Return 0
	EndFunc
	#EndRegion
	#Region Calcul de taux de coup critique
	Func calcul_de_cc($cc_initial, $bonus_cc, $agilite)
		If $cc_initial < 2 Then
			Return $cc_initial
		Else
			If $agilite < 9 Then
				$cc_final = Max(Floor($cc_initial-$bonus_cc),2)
			Else
				$cc_final = Max(Floor(($cc_initial-$bonus_cc) * 2.9901 / Log($agilite +12)),2)
			EndIf
			Return $cc_final
		EndIf
	EndFunc
	#EndRegion
	#Region Calcul de retrait de PA/PM
	Func calcul_de_retrait($min, $max, $esquive_lanceur, $esquive_cible, $PA_cible)
		If $min<0 Or $max<=0 Or $max<$min Then
			Local $probas[1] = [1]
			Return 0
		EndIf

		Local $tab[$max][2]
		For $i = 0 To $max-1
			$PA_restant = Max($PA_cible - $i,0)
			If $PA_cible <= 0 Or $PA_restant <= 0 Then
				$proba = 0
			ElseIf $esquive_cible = 0 Then
				If $esquive_lanceur < 0 Then
					$proba = 10
				ElseIf $esquive_lanceur > 0 Then
					$proba = 90
				Else
					$proba = 50
				EndIf
			Else
				$proba = Max(10,Min(90, Floor(($esquive_lanceur/$esquive_cible) * 50*($PA_restant/$PA_cible))))
			EndIf
			$tab[$i][0] = $PA_restant
			$tab[$i][1] = $proba/100
		Next
		Local $abr = determiner_abr(1,$tab,0,$max)
		Local $probas[$max+1]
		For $i = 0 To $max
			$probas[$i] = 0
		Next

		calculer_abr($abr,0,$probas)
		$taux_final = 0
		For $i=$min to $max
			$taux_final = $taux_final + $probas[$i]
		Next

		Return $taux_final/($max-$min+1)
	EndFunc
	Func determiner_abr($noeud,$proba,$x,$reste)
		If $reste <= 0 Then
			Local $array[2] = [$noeud,$x]
		Else
			Local $array[4] = [$noeud*(1-$proba[$x][1]),$noeud,$x,$noeud*$proba[$x][1]]
			$array[0] = determiner_abr($array[0],$proba,$x,$reste-1)
			$array[3] = determiner_abr($array[3],$proba,$x+1,$reste-1)
		EndIf
		Return $array
	EndFunc
	Func calculer_abr($abr,$x,ByRef $array)
		If Ubound($abr)=4 Then
			$array[$x] = $array[$x] + $abr[1] * $abr[2]
			calculer_abr($abr[0],$x+1,$array)
			calculer_abr($abr[3],$x+1,$array)
		Else
			$array[$x] = $array[$x] + $abr[0] * $abr[1]
		EndIf
	EndFunc
	#EndRegion
#EndRegion
